#ifndef _TBC_ID_MENUS_H_
#define _TBC_ID_MENUS_H_

	/**
	 * Menu States - These are distinct, displayable menu screens
	 */
	// Roster
	#define MENU_SCREEN_START 									MENU_FLAG_SCREEN
	#define MENU_SCREEN_FP_MAIN									MENU_SCREEN_START
	#define MENU_SCREEN_EXERCISE_UI								MENU_SCREEN_FP_MAIN +1
	#define MENU_SCREEN_TEST_IMAGE	 							MENU_SCREEN_EXERCISE_UI + 1
	#define MENU_SCREEN_TEST_TEXT								MENU_SCREEN_TEST_IMAGE + 1
	#define MENU_SCREEN_TEST_PROGRESS							MENU_SCREEN_TEST_TEXT + 1
	#define MENU_SCREEN_TEST_UNSUPPORTED_1						MENU_SCREEN_TEST_PROGRESS + 1
	#define MENU_SCREEN_TEST_UNSUPPORTED_2						MENU_SCREEN_TEST_UNSUPPORTED_1 + 1
	#define MENU_SCREEN_NETWORK_WAIT							MENU_SCREEN_TEST_UNSUPPORTED_2 + 1
	#define MENU_SCREEN_NETWORK_ERROR							MENU_SCREEN_NETWORK_WAIT + 1
	#define MENU_SCREEN_HELP									MENU_SCREEN_NETWORK_ERROR + 1
	#define MENU_SCREEN_HELP_1									MENU_SCREEN_HELP + 1
	#define MENU_SCREEN_HELP_2									MENU_SCREEN_HELP_1 + 1
	#define MENU_SCREEN_HELP_3									MENU_SCREEN_HELP_2 + 1
	#define MENU_SCREEN_OUT_OF_SEEDS 							MENU_SCREEN_HELP_3+1
	#define MENU_SCREEN_GAME_RESULTS 							MENU_SCREEN_OUT_OF_SEEDS+1
	#define MENU_SCREEN_CLIENT									MENU_SCREEN_GAME_RESULTS + 1
	#define MENU_SCREEN_END										MENU_SCREEN_CLIENT + 1
	#define MENU_SCREEN_NUM 									MENU_SCREEN_END - MENU_SCREEN_START
	
	/**
	 * Menu Actions - These are Commands, when processed, return MenuStates based on field settings
	 */
	// Roster
	#define MENU_ACTION_RESUME_GAME								MENU_ACTION_MODULE_START
	#define MENU_ACTION_END										MENU_ACTION_RESUME_GAME + 1
	#define MENU_ACTION_NUM										MENU_ACTION_END - MENU_ACTION_START
	
	/**
	 * Menu Image Elements
	 */
	// Roster
	#define MENU_ELEMENT_IMAGE_START							MENU_FLAG_ELEMENT_IMAGE
	#define MENU_ELEMENT_IMAGE_END								MENU_ELEMENT_IMAGE_START
	#define MENU_ELEMENT_IMAGE_NUM								MENU_ELEMENT_IMAGE_END - MENU_ELEMENT_IMAGE_START
	
	/**
	 * Menu ProgressBar
	 */
	// Configuration
	#define MENU_ELEMENT_PROGRESSBAR_INITIAL_STATE				0
	// Roster
	#define MENU_ELEMENT_PROGRESSBAR_START						MENU_FLAG_ELEMENT_PROGRESSBAR
	#define MENU_ELEMENT_PROGRESSBAR_END						MENU_ELEMENT_PROGRESSBAR_START
	#define MENU_ELEMENT_PROGRESSBAR_NUM						MENU_ELEMENT_PROGRESSBAR_END - MENU_ELEMENT_PROGRESSBAR_START
	
	/**
	 * Menu Switch Elements
	 */
	// Configuration
	#define MENU_ELEMENT_SWITCH_OFF 							0
	#define MENU_ELEMENT_SWITCH_ON 								1
	#define MENU_ELEMENT_SWITCH_INITIAL_STATE					MENU_ELEMENT_SWITCH_OFF
	// Roster
	#define MENU_ELEMENT_SWITCH_START							MENU_FLAG_ELEMENT_SWITCH
	#define MENU_ELEMENT_SWITCH_END								MENU_ELEMENT_SWITCH_START
	#define MENU_ELEMENT_SWITCH_NUM								MENU_ELEMENT_SWITCH_END - MENU_ELEMENT_SWITCH_START
	
	/**
	 * Menu Text Box Elements
	 */
	// Roster
	#define MENU_ELEMENT_TEXTBOX_START							MENU_FLAG_ELEMENT_TEXTBOX
	#define MENU_ELEMENT_TEXTBOX_END							MENU_ELEMENT_TEXTBOX_START
	#define MENU_ELEMENT_TEXTBOX_NUM							MENU_ELEMENT_TEXTBOX_END - MENU_ELEMENT_TEXTBOX_START
	
	/**
	 * Menu Text Input Elements
	 */
	// Configuration
	#define MENU_ELEMENT_TEXTINPUT_EMPTY_CHAR					0
	// Roster
	#define MENU_ELEMENT_TEXTINPUT_START						MENU_FLAG_ELEMENT_TEXTINPUT
	#define MENU_ELEMENT_TEXTINPUT_END							MENU_ELEMENT_TEXTINPUT_START
	#define MENU_ELEMENT_TEXTINPUT_NUM							MENU_ELEMENT_TEXTINPUT_END - MENU_ELEMENT_TEXTINPUT_START


#endif _TBC_ID_MENUS_H_
