#ifndef _TB_STRING_FACTORY_H_
#define _TB_STRING_FACTORY_H_

#include "..\Core\ITBStringFactory.h"
#include "TBCidMenus.h"
#include "TBCidStrings.h"

/**
 * This Class is the String Localization Support for the For Prize Module.
 * 
 * It is Intentionally Package Scoped, we do not want to open this interface
 * to the public (We want control over the content of the menus).
 *
 * The Current Implementation is pretty innefficiant, but there is plenty of 
 * room to turn it into a better data-driven model
 *
 * @author Twistbox Games
 */
class TBStringFactory:
	public ITBStringFactory
{
public:
	TBStringFactory(byte language){
		// Ignoring language right now because this iteration of string factory doesn't support it
	};
	/* (non-Javadoc)
	 * @see com.twistbox.forprizes.IFPStringFactory#getString(int)
	 */
	String getString(int stringIndex) {
	
		switch (stringIndex) {
			
			// JAD PARAMETERS
//			case FP_STR_CONST_ID_PARAM_URL_TEST_IMAGE: return owner.getAppProperty("ForPrize-Test-Image-URL"); 
//			case FP_STR_CONST_ID_PARAM_URL_TEST_TEXT: return owner.getAppProperty("ForPrize-Test-Text-URL");
			
			// STRINGS
			case FP_STR_CONST_ID_SELECT:	return "Select";
			case FP_STR_CONST_ID_BACK: return "Back";
			case FP_STR_CONST_ID_YES: return "Yes";
			case FP_STR_CONST_ID_NO: return "No";
			case FP_STR_CONST_ID_ON: return "ON";
			case FP_STR_CONST_ID_OFF: return "OFF";
			case FP_STR_CONST_ID_TOGGLE: return "Turn ";
			case FP_STR_CONST_ID_TITLE: return "FP UI Testbed";
			case FP_STR_CONST_ID_TITLE_MENU_START: return "Start Game";
			case FP_STR_CONST_ID_TITLE_MENU_EXERCISE: return "Test UI";
			case FP_STR_CONST_ID_TEST_IMAGE: return "IMAGE Test";
			case FP_STR_CONST_ID_TEST_IMAGE_ANIMATION: return "Animation ";
			case FP_STR_CONST_ID_TEST_IMAGE_ANIMATION_QUESTION: return "Show Animation?";
			case FP_STR_CONST_ID_TEST_TEXT: return "TEXT Test";
			case FP_STR_CONST_ID_TEST_TEXT_DYNAMIC_1: return "This is a Dynamically";
			case FP_STR_CONST_ID_TEST_TEXT_DYNAMIC_2: return "Updating Single Line";
			case FP_STR_CONST_ID_TEST_TEXT_INPUT_TITLE: return "Input Text:";
			case FP_STR_CONST_ID_TEST_TEXT_INPUT_DEFAULT: return "abcdefghijklmno";
			case FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE: return " Characters"; 
			case FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE_QUESTION: return "Input Field Size:";
			case FP_STR_CONST_ID_TEST_TEXT_INPUT_CLEAR: return "Clear";
			case FP_STR_CONST_ID_TEST_TEXT_OUTPUT: return "The FP Module contains a fairly complex ui menu system along with the network interface.  The layout of this UI is dynamic and explicitly controlled by the  FPModule.  Rather than build a redundant menu system, however, the FPModule  instead provides this interface for feeding menu configurations into an existing client menu architecture.  The Client is responsible for taking the information provided by the following event handlers, then building and rendering it using the existing menu control infrastructure.";
			case FP_STR_CONST_ID_TEST_PROGRESS: return "PROGRESS Test";
			case FP_STR_CONST_ID_TEST_PROGRESS_STATE: return "Progress: ";
			case FP_STR_CONST_ID_TEST_PROGRESS_READY: return "Ready";
			case FP_STR_CONST_ID_TEST_PROGRESS_PAUSED: return "Paused";
			case FP_STR_CONST_ID_TEST_PROGRESS_RUNNING: return "Running";
			case FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RUN: return "Run";
			case FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_PAUSE: return "Pause";
			case FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RESET: return "Reset";
			case FP_STR_CONST_ID_TEST_PROGRESS_COMPLETE: return "Complete";
			case FP_STR_CONST_ID_TEST_PROGRESS_RUN_QUESTION: return "Run Time:";
			case FP_STR_CONST_ID_TEST_PROGRESS_RUN: return " Seconds";
			case FP_STR_CONST_ID_TEST_UNSUPPORTED: return "UNSUPPORTED Test";
			case FP_STR_CONST_ID_TEST_UNSUPPORTED_TEXT: return "This Test sends an undefined menu entry type to confirm that A: False will be correctly returned, and B: The Client can successfully handle a replacement menu definition correctly.  If this is displayed correctly and no exception was thrown, the test was successful";
			case FP_STR_CONST_ID_SCREEN_CLIENT: return "ClientScreen";
			case FP_STR_CONST_ID_SCREEN_HELP: return "Help Screen";
			case FP_STR_CONST_ID_SCREEN_HELP_1: return "Topic 1";
			case FP_STR_CONST_ID_SCREEN_HELP_2: return "Topic 2";
			case FP_STR_CONST_ID_SCREEN_HELP_3: return "Topic 3";
			case FP_STR_CONST_ID_SCREEN_SEEDS: return "OutOfSeedsScreen";
			case FP_STR_CONST_ID_SCREEN_RESULTS: return "ResultsScreen";
			case FP_STR_CONST_ID_REPLAY: return "Replay";
			case FP_STR_CONST_ID_END_GAME: return "End Game";
			case FP_STR_CONST_ID_OUT_OF_SEEDS: return "The For Prize Module is out of seeds.  The number of seeds available for any given tournament depends on the desires of the thirdparty client product team.  The For Prize Compliance Module Only contains two seeds (both cases of alternationg # and *s).";
			case FP_STR_CONST_ID_END_GAME_TEXT: return "This is the Score that will be reported to the server.  Notice that this post-game screen is controlled by the FP module and not the Client.";
			case FP_STR_CONST_ID_END_GAME_SCORE: return "Game Score: ";
			case FP_STR_CONST_ID_END_GAME_PLAYTIME: return "Game Play Time"; 
			case FP_STR_CONST_ID_CONNECTING: return "Connecting to Server:";
			case FP_STR_CONST_ID_DOWNLOADING_FILE: return "Downloading: ";
			case FP_STR_CONST_ID_CANCEL: return "Cancel";
			
			default: return "UNKNOWN STRING:";// + stringIndex;			
		}
		
	}
	
};

#endif _TB_STRING_FACTORY_H_
