#ifndef _ITB_SEED_GENERATOR_H_
#define _ITB_SEED_GENERATOR_H_


#include "..\..\src\BrewVector.h"


/**
 * 
 * This interface should be used as a mechanism to generate and test seed generation for FP 
 * Games.
 * 
 * The class that implements should _NOT_ necessarily be a built in portion of the client, Nor is
 * it necessary that this class be delivered to Twistbox for Specific Carrier Module integration.
 * 
 * As mentioned in other classes, seed encoding/decoding is entirely the responsibility of the 
 * client.
 * 
 * @author E Scott Cragg. Twistbox Client Core Engineering.
 *
 * and Tiago Teixeira. Twistbox Client Core Engineering.
 *
 */
class ITBSeedGenerator {
	
	/**
	 * Get a seed encoded for this particular client.  Return null to simulate an 'out of seed' condition
	 * if your game requires custom (not-randomly-generated) seeds.
	 * 
	 * @return The seed, or null
	 */
public:
	virtual Bbyte getSeed() = 0;
	
};

#endif //_ITB_SEED_GENERATOR_H_
