/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPEVENTS_H
#define AMTPEVENTS_H

#include "AEE.h"

//-----------------------------------------------------------------------------
//	Event codes used by the AMTP client framework
//-----------------------------------------------------------------------------

#define EVT_AMTP_RESERVED					EVT_USER + 2000

#define EVT_AMTP_EXIT						EVT_AMTP_RESERVED
#define EVT_AMTP_ERROR						EVT_AMTP_RESERVED + 1			// (wParam:errorID as listed in AMTPErrors.h)
#define EVT_AMTP_ERROR_REPORT				EVT_AMTP_RESERVED + 2

#define EVT_AMTP_WEB_RESPONSE				EVT_AMTP_RESERVED + 100
#define EVT_AMTP_WEB_PROGRESS				EVT_AMTP_RESERVED + 101
#define EVT_AMTP_REGISTER_RESPONSE			EVT_AMTP_RESERVED + 102
#define EVT_AMTP_GET_TOURNAMENTS_RESPONSE	EVT_AMTP_RESERVED + 103
#define EVT_AMTP_ENTER_TOURNAMENT_RESPONSE	EVT_AMTP_RESERVED + 104
#define EVT_AMTP_REPORT_SCORE_RESPONSE		EVT_AMTP_RESERVED + 105
#define EVT_AMTP_REPORT_FORFEIT_RESPONSE	EVT_AMTP_RESERVED + 106
#define EVT_AMTP_GET_SCORES_RESPONSE		EVT_AMTP_RESERVED + 107
#define EVT_AMTP_SET_OPTIONS_RESPONSE		EVT_AMTP_RESERVED + 108
#define EVT_AMTP_GET_PROMOTION_RESPONSE		EVT_AMTP_RESERVED + 109

#define EVT_AMTP_VIEW						EVT_AMTP_RESERVED + 200		// (wParam:viewID as listed in AMTPViews.h)
#define EVT_AMTP_SAVE_PREFS					EVT_AMTP_RESERVED + 201
#define EVT_AMTP_SOUND_TOGGLE				EVT_AMTP_RESERVED + 202
#define EVT_AMTP_MUSIC_TOGGLE				EVT_AMTP_RESERVED + 203
#define EVT_AMTP_SMS_TOGGLE					EVT_AMTP_RESERVED + 204
#define EVT_AMTP_FIRST_TIME_HELP			EVT_AMTP_RESERVED + 205
#define EVT_AMTP_TILT_TOGGLE				EVT_AMTP_RESERVED + 206
#define EVT_AMTP_LANGUAGE_TOGGLE			EVT_AMTP_RESERVED + 207

#define EVT_AMTP_SOUND_DONE					EVT_AMTP_RESERVED + 300

#endif // AMTPEVENTS_H