/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPFRAMEWORK_H
#define AMTPFRAMEWORK_H

#undef DEBUG_HEAP

#ifdef DEBUG_HEAP
#include "AEEHeap.h"
#endif

#include "AEE.h"
#include "AEEAppGen.h"
#include "AEEGraphics.h"
#include "AEEStdLib.h"

#include "../../Std/DbgLog.h"
#include "../../Std/Debug.h"
#include "../../Std/Memory.h"
#include "../../Std/PlatformBREW.h"

//#include "AMTP.h"
//#include "AMTPApplet.h"
//#include "AMTPGraphics.h"
//#include "AMTPSoundPlayer.h"
#include "../../Std/AMTPUtil.h"

#include "AMTPErrors.h"
#include "AMTPEvents.h"

#ifndef GETSHELL
#define GETSHELL()		((AEEApplet*)GETAPPINSTANCE())->m_pIShell
#endif

#ifndef GETCLASSID
#define GETCLASSID()	((AEEApplet*)GETAPPINSTANCE())->clsID
#endif

#ifndef GETDISPLAY
#define GETDISPLAY()	((AEEApplet*)GETAPPINSTANCE())->m_pIDisplay
#endif

#ifndef GETCLIENT
#define GETCLIENT()		((AMTPApplet*)GETAPPINSTANCE())->_pClient
#endif

#if defined(DEBUG_HEAP) && !defined(DBGHEAP)
#define DBGHEAP(expr)	DEBUG(("%s Memory: %d of %d", #expr, IHEAP_GetMemStats(((AMTPApplet*)GETAPPINSTANCE())->_heap), ((AMTPApplet*)GETAPPINSTANCE())->_totalRam));
#else
#define DBGHEAP(expr)
#endif

#endif // AMTPFRAMEWORK_H