#include "CarrierAdapter.h"
#include "..\..\..\src\aMain.h"
//#include "..\..\Std\Connector.h"


CarrierAdapter::CarrierAdapter()
{
	
	if(!_pMsg){
		_pMsg = new TBMessages();
		_pMsg->Start();
	}
	if (!_sendBuf.Start(PARAM_SEND_BUFFER_SIZE)) {
		_sendBuf.Stop();
	}
	
	if (!_recvBuf.Start(PARAM_RECEIVE_BUFFER_SIZE)) {
		_recvBuf.Stop();
	}

	_pWeb = NULL;
	if (!_pWeb) {
		NEW(); _pWeb = new Web(
							CONNECT_TIMEOUT_DEFAULT,
							IDLE_TIMEOUT_DEFAULT,
							LINGER_TIMEOUT_DEFAULT);
		if (!_pWeb || !_pWeb->Start(GETSHELL(), &_recvBuf, (PFNNOTIFY)HandleResponse, (void*)this)) {
			
			//Stop();
			return;
		}
	}
	_pWeb->SetProgressHandler((Web::ProgressFnPtr)HandleProgress, (void*)this);

	_requestTimeoutMillis = REQUEST_TIMEOUT_DEFAULT;
	
	_hasPromo = false;
	//_promoStr = NULL;
	//_promoNext = 1;
	_pczRedirectRootURL = NULL;
	gameHandleEvent = &ForPrizeTestbed::ForPrizeTestbed_HandleEvent;
	
	_isRunning = true;
	_hasScoreResults = false;
	fullUrl = NULL;
}

void CarrierAdapter::Release()
{
	_isRunning = false;
	if (fullUrl != NULL)
	{
		fullUrl->destruct();
		delete fullUrl;
	}

	for (int idx=0; idx < NUM_TOURNAMENT_TYPES; idx++) {
		_nextTournament[idx].Reset();
	}
	_enteredTournament.Reset();
	_lastGame.Reset();

	if (_pWeb) {
		_pWeb->Stop();
	}

	if (_pMsg) {
		delete _pMsg;
		_pMsg = NULL;
	}

	if (_pWeb) {
		delete _pWeb;
		_pWeb = NULL;
	}

	_sendBuf.Stop();

	DBGHEAP(" AMTPClient-x10");

	_recvBuf.Stop();

}



//-----------------------------------------------------------------------------
//	static
//
//	This handler and the receive buffer are registered with the Web object
//	in a call to pWeb->Start() in AMTPClient::Start()
//
//	Post the event because response processing might trigger the watchdog.
//-----------------------------------------------------------------------------
void CarrierAdapter::HandleResponse(CarrierAdapter* pClient)
{
	//post event so watchdog timer doesn't trigger
	ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_WEB_RESPONSE, 0, 0);
}

//-----------------------------------------------------------------------------
//	static
//
//	This handler and the receive buffer are registered with the Web object
//-----------------------------------------------------------------------------
void CarrierAdapter::HandleProgress(CarrierAdapter* pClient, int percentTimeout, int bytesRead)
{
	//if (!pClient->_isGameRunning)
	{
		if (!bytesRead)
		{
			DEBUG(( "PROGRESS: time %d%%", percentTimeout ));

			pClient->_nBytesInResponse = 0;
			//pClient->_pViewMgr->HandleEvent(EVT_AMTP_WEB_PROGRESS, (uint16)percentTimeout, 0);
			pClient->gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_WEB_PROGRESS, percentTimeout, 0);
		}
		else if (pClient->_nBytesInResponse)
		{
			int percent = bytesRead * 100 / pClient->_nBytesInResponse;
			DEBUG(( "PROGRESS: %d%%, time %d%%, %d bytes", percent, percentTimeout, bytesRead ));

			//pClient->_pViewMgr->HandleEvent(EVT_AMTP_WEB_PROGRESS, (uint16)percent, 0);
			pClient->gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_WEB_PROGRESS, (uint16)percent, 0);
		}
		else
		{
			pClient->_nBytesInResponse = pClient->_pMsg->GetResponseSize(pClient->_recvBuf);
			DEBUG(( "PROGRESS: response has %d bytes",pClient->_nBytesInResponse ));
		}
	}
	//DEBUGIF(pClient->_isGameRunning) DEBUG(( "GAME IN PROGRESS: time %d%%, %d bytes", percentTimeout, bytesRead ));

	/*
	if (pClient->_nBytesInResponse)
	{
		gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
		fpprogress(
	}
	else
		pClient->_nBytesInResponse = pClient->_pMsg->GetResponseSize(pClient->_recvBuf);
		*/
}

CarrierAdapter::CarrierAdapter(ITBStringFactory* _strings){
	
	strings = NULL;
	
	this->strings = _strings;
	
}

String CarrierAdapter::toMIN(String phoneNumber) {
	String result = "";
	result += getCarrierIDString();
	result += "001";
	result += phoneNumber;
	return result;
}

bool CarrierAdapter::isPhoneNeededForRegistration() {
	return false;
}


String CarrierAdapter::getCarrierIDString() {
	String result = "";
	char str[10];
	int id = getCarrierID();
	if(id >= 0 && id <= 9) {
		result += "0";
	}
	result += _itoa(id,str,10);
	return result;
}

bool CarrierAdapter::getTournaments(){
	TRACE(( "" ));
	TRACE(( "AMTPClient::GetTournaments()" ));

	if (!_isResponsePending) {
		if (!_adapter->_hasNextTournaments || _adapter->_outOfSeeds ) {
			return SendGetTournamentsRequest(0);  // Get all tournaments
		}
		else {
			DEBUG(( "AMTPClient::GetTournaments REJECTED: Next tournaments available" ));
			return true;
		}
	}
	else {
		return true;
	}
	return false;
}

bool CarrierAdapter::enterTournament(byte tournamentType){
	
	_adapter->_currentTournamentType = tournamentType;

	if (_adapter->_hasNextTournaments) {
		_enteredTournament = _nextTournament[tournamentType-1];
		 if (SendEnterTournamentRequest(_enteredTournament)) {
		 	_adapter->_hasNextTournaments = false;
		 	return true;
		 }
		 else {
		 	return false;
		 }
	}
	else {
		DEBUG(( "AMTPClient::EnterTournament REJECTED: Next tournaments not available" ));
		return false;
	}
}

//-----------------------------------------------------------------------------
bool CarrierAdapter::SendGetTournamentsRequest(int32 tournamentType)
{

	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendGetTournamentsRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSTR.\n" ));
	DBGLOGFLUSH;

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;			// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)2;						// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_REQ_GETTOURNEYS;	// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)7;						// msgID, MIN, tournamentType, productID, typeGame, verGame, assetClass

	_pMsg->WriteMessageID(_sendBuf);
	//_pMsg->WriteMIN(_sendBuf, _pczMobileID);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	_pMsg->WriteMIN(_sendBuf, _mobilID);

	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNTYPE, (int32)ALL_TOURNAMENTS);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PRODID, _adapter->_productID);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMETYPE, (int16)_adapter->_gameType);
	int32 version = TBUTIL_CreateVersionNumber((char*)_adapter->_gameVersion.toCharArray());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMEVERS, version);

	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_ASSET_CLASS,  (int32)_adapter->_assetClass);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	DEBUG(( "end of SendGetTournamentsRequest(), len=%d", _sendBuf.GetLength() ));
	TRACE(( " " ));

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;	

	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}

	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}

bool CarrierAdapter::SendEnterTournamentRequest(const AMTPTournament& tour)
{
	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendEnterTournamentRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSETR.\n" ));
	DBGLOGFLUSH;

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;			// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)2;						// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_REQ_ENTERTOURNEY;	// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)8;						// msgID, MIN, idTourn, tournamentType, idProd, typeGame, verGame, assetClass

	_pMsg->WriteMessageID(_sendBuf);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	_pMsg->WriteMIN(_sendBuf, _mobilID);
	//_pMsg->WriteMIN(_sendBuf, _pczMobileID);

	AtomText text(tour.GetID());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNID, text);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNTYPE, (int32)ALL_TOURNAMENTS);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PRODID, _adapter->_productID);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMETYPE, (int16)_adapter->_gameType);
	int32 version = TBUTIL_CreateVersionNumber((char*)_adapter->_gameVersion.toCharArray());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMEVERS, version);

	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_ASSET_CLASS,  (int32)_adapter->_assetClass);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	DEBUG(( "end of SendEnterTournamentRequest(), len=%d", _sendBuf.GetLength() ));
	TRACE(( " " ));

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;
	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}

	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}

bool CarrierAdapter::getScores(byte tournamentType, int scoreType){

	_scoreTournamentType = tournamentType;
	_scoreType = scoreType;

	_adapter->_isGettingScore = true;

	return getScores();
	
}

bool CarrierAdapter::getScores()
{
	if (!_isResponsePending) {
		if (!_adapter->ValidateTournament()) {
			return getTournaments();
		}
		else {
			return SendGetScoresRequest(_scoreTournamentType,_scoreType);
		}
	}
	else {
		return true;
	}
}

bool CarrierAdapter::SendGetScoresRequest(int32 tournamentType, int32 scoreType)
{
	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendGetScoresRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSGSR.\n" ));
	DBGLOGFLUSH;

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;					// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;		// atom type
	_sendBuf <<   (byte)0;					// retry count
	_sendBuf <<   (byte)0;					// padding
	_sendBuf << (uint16)2;					// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;					// dummy length
	_sendBuf << (uint32)TYPE_REQ_GETSCORES;	// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)7;					// msgID, MIN, ttype, pid, gtype, gver, styp

	_pMsg->WriteMessageID(_sendBuf);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	
	_pMsg->WriteMIN(_sendBuf, _mobilID);

	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNTYPE, tournamentType);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PRODID, _adapter->_productID);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMETYPE, (int16)_adapter->_gameType);
	int32 version = TBUTIL_CreateVersionNumber((char*)_adapter->_gameVersion.toCharArray());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMEVERS, version);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_SCORETYPE, scoreType);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	DEBUG(( "end of SendGetScoresRequest(), len=%d", _sendBuf.GetLength() ));
	TRACE(( " " ));

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;

	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}

	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}


int CarrierAdapter::registerPlayer(String pin, String phoneType, long timeLeft, bool optIn){
	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendRegisterRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSRR.\n" ));
	DBGLOGFLUSH;

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;					// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;		// atom type
	_sendBuf <<   (byte)0;					// retry count
	_sendBuf <<   (byte)0;					// padding
	_sendBuf << (uint16)2;					// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;					// dummy length
	_sendBuf << (uint32)TYPE_REQ_REGISTER;	// atom type
	_sendBuf <<   (byte)0;					// padding
	_sendBuf <<   (byte)0;					// padding
	_sendBuf << (uint16)8;					// messageID, MIN, userName, phoneType, userPrefs, productID, typeGame, verGame
	
	_pMsg->WriteMessageID(_sendBuf);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	
	_pMsg->WriteMIN(_sendBuf, _mobilID);

	int usernameLen = _adapter->_userName.length();
	char* pczUsername = (char*)MEMALLOC(usernameLen+1);
	//WSTRTOSTR(_userName.GetBuf(), pczUsername, usernameLen+1);
	{
		AtomText user((char*)_adapter->_userName.toCharArray());
		_pMsg->WriteNamedAtom(_sendBuf, TBMessages::IDX_NAMED_USERNAME, user);
	}

	{
		AtomText phone(Platform_GetPhoneName((char*)_adapter->_phoneType.toCharArray()));
		_pMsg->WriteNamedAtom(_sendBuf, TBMessages::IDX_NAMED_PHONETYPE, phone);
	}
	_pMsg->WritePrefsAtom(_sendBuf, _adapter->_isSMSOptIn);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PRODID, _adapter->_productID);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMETYPE, (int16)_adapter->_gameType);
	int32 version = TBUTIL_CreateVersionNumber((char*)_adapter->_gameVersion.toCharArray());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMEVERS, version);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	DEBUG(( "end of SendRegisterRequest(), len=%d", _sendBuf.GetLength() ));
	TRACE(( " " ));

	_isResponsePending = true;
	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}

	bool result = _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);

	if (pczUsername) {
		MEMFREE(pczUsername);
	}
	//_adapter->requestResponse = EVT_AMTP_WAIT;
	return result;
}

int CarrierAdapter::sendGetPromoRequest( int tournType, int promoID)
{
	_sendBuf.Reset();

	//package header
	_sendBuf <<	(uint32)0;						// dummy length
	_sendBuf <<	(uint32)TYPE_PACKAGE;			// atom type
	_sendBuf <<	(byte)0;						// retry count
	_sendBuf <<	(byte)0;						// padding
	_sendBuf <<	(uint16)2;						// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf <<	(uint32)0;						// dummy length
	_sendBuf <<	(uint32)TYPE_REQ_GETPROMOTION;	// atom type
	_sendBuf <<	(byte)0;						// retry count
	_sendBuf <<	(byte)0;						// padding
	_sendBuf <<	(uint16)8;						// msgID, MIN, tournamentType, promoID, productID, typeGame, verGame, assetClass

	_pMsg->WriteMessageID(_sendBuf);
	// TODO: Use MIN from CFG

	char* _mobilID = (char*)_adapter->min.toCharArray();
	_pMsg->WriteMIN(_sendBuf, _mobilID);

//	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNTYPE, (int32)ALL_TOURNAMENTS);
	// TODO: READ FROM CFG: 0 - both, 1- head to head , 2- progressive
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNTYPE, (int32) 0);	//(int32) tournamentType);		// HACK,  1 == HEAD TO HEAD ONLY  -JGP
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PROMOTION_ID, (int32) promoID);			
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PRODID, (int32)_adapter->_productID);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMETYPE,  (int16) _adapter->_gameType);
	int32 version = TBUTIL_CreateVersionNumber((char*)_adapter->_gameVersion.toCharArray());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_GAMEVERS, version);


	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_ASSET_CLASS, (int32)_adapter->_assetClass);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}


//	uint32 len = _sendBuf.GetLength();
	//_sendBuf.Seek(0);
//	_sendBuf << len;
	SetSendBufferLength();
	

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;

	//_adapter->requestResponse = EVT_AMTP_WAIT;
	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}

void CarrierAdapter::ReportGameScore(
	uint32 score,
	const void* pGameResults,
	unsigned lenGameResults)
{
	if (_adapter->getCurrentTournamentType() != PARAM_TOURNAMENT_TYPE_PRACTICE) {
		_lastGame.Reset();
		_lastGame.CopyData((const byte*)pGameResults, lenGameResults);
		_lastGame.SetScore(score);
		_lastGame.SetEndTime(ISHELL_GetUpTimeMS(GETSHELL()));

		_hasScoreResults = false;
		
		reportScore();
	}
}

bool CarrierAdapter::reportScore(){
	_isReportingScore = true;

	if (!_isResponsePending) {
		// Make sure a user has successfully entered the tournament before reporting
		// a score. A successful EnterTournamentResponse will cause HasNextTournaments()
		// to return true. If it's false, an EnterTournamentResponse must be sent before
		// the ReportScoreRequest.
		//...........................................................................
		if (!_adapter->_hasNextTournaments) {
			// We want the server to see the request as a continuation of the previous
			// attempt. To do this, we use the same send buffer we used before and increment
			// the retry count.
			//..............................................................................
			_isResponsePending = true;
			_requestRetries = REQUEST_RETRY_COUNT;

			const uint8 *sendBuffer = _sendBuf.GetBuf();
			((PackageHeader *)sendBuffer)->retryCount++;
	
			return _pWeb->SendRequest(fullUrl->toCharArray(), sendBuffer, _sendBuf.GetLength(), _requestTimeoutMillis);
		}
		else {
			if (!_hasScoreResults) {
				return SendReportScoreRequest(_enteredTournament, _lastGame);
			}
			else {
				DEBUG(( "AMTPClient::ReportScore REJECTED: Score results already available" ));
				return false;
			}
		}
	}
	else {
		DEBUG(( "AMTPClient::ReportScore QUEUED: Score report or other request in progress" ));
		return true;
	}
}

//-----------------------------------------------------------------------------
bool CarrierAdapter::SendReportForfeitRequest(const AMTPTournament& tour)
{
	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendReportForfeitRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSRFR.\n" ));
	DBGLOGFLUSH;

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;			// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)2;						// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_REQ_REPORTFORFEIT;	// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)3;						// msgID, MIN, idTourn

	_pMsg->WriteMessageID(_sendBuf);
//	_pMsg->WriteMIN(_sendBuf, _pczMobileID);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	_pMsg->WriteMIN(_sendBuf, _mobilID);

	AtomText text(tour.GetID());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNID, text);

	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	DEBUG(( "end of SendReportForfeitRequest(), len=%d", _sendBuf.GetLength() ));
	TRACE(( " " ));

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;

	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}
	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}


//-----------------------------------------------------------------------------
bool CarrierAdapter::SendReportScoreRequest(const AMTPTournament& tour, const AMTPGameResult& result)
{
	TRACE(( "" ));
	TRACE(( "AMTPRequests::SendReportScoreRequest()" ));
	ASSERT(_pMsg);
	DBGLOG(( "ClientSRSR.\n" ));
	DBGLOGFLUSH;
	DBGSTK_CHECK_LIGHT;

	if (result.GetForfeit()) {
		return SendReportForfeitRequest(tour);
	}

	_sendBuf.Reset();

	//package header
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_PACKAGE;			// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)2;						// CRC, request packet

	//CRC
	_pMsg->WriteAtom(_sendBuf, (int32)0xcdcdcdcd);

	//packet header
	uint32 mark = _sendBuf.Mark();
	_sendBuf << (uint32)0;						// dummy length
	_sendBuf << (uint32)TYPE_REQ_REPORTSCORE;	// atom type
	_sendBuf <<   (byte)0;						// retry count
	_sendBuf <<   (byte)0;						// padding
	_sendBuf << (uint16)10;						// msgID, MIN, idTourn, score, start, end, elapsed, dataGame

	_pMsg->WriteMessageID(_sendBuf);
	//_pMsg->WriteMIN(_sendBuf, _pczMobileID);
	char* _mobilID = (char*)_adapter->min.toCharArray();
	_pMsg->WriteMIN(_sendBuf, _mobilID);


	AtomText text(tour.GetID());
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TOURNID, text);

  	 int64 score,msStart64,msEnd64 = 0;
 int32 msStart32,msEnd32 = 0;

   score  = (int64)result.GetScore();
 msStart32 = result.GetStartTime();
 msEnd32 = result.GetEndTime();
 msStart64 = (int64)msStart32;
 msEnd64 = (int64)msEnd32;

 DEBUG(("score=%d,\nmsStart32=%d,\nmsEnd32=%d,\nmsStart64=%d,msEnd64=%d",score,msStart32,msEnd32,msStart64,msEnd64));

	int64 msElapsed;
	
	if (msEnd32 < msStart32) {
		// Local clock mus6t have wrapped around so adjust
		// accordingly.
		msElapsed = ((uint32)0xFFFFFFFF - msStart32) + msEnd32;
	}
	else {
		msElapsed = msEnd32 - msStart32;
	}

	int32 lenData;
	const byte* dataGame = result.GetData(lenData);

	char  myk[HASH_SIZE];
	char p1[KSIZE];
	char p2[KSIZE];
	 for (int i = 0; i < KSIZE; i++) {
	  p1[i] = 0;
	  p2[i] = 0;
	 }
	md5_byte_t out1[HASH_SIZE];
	md5_byte_t out2[HASH_SIZE];
	
	int32 len;
	byte* seed = _enteredTournament.GetSeed(&len);

	// convert score to byte array
	p1[7] = (byte)((score >> 56) & 0xFF);
	p1[6] = (byte)((score >> 48) & 0xFF);
	p1[5] = (byte)((score >> 40) & 0xFF);
	p1[4] = (byte)((score >> 32) & 0xFF);
	p1[3] = (byte)((score >> 24) & 0xFF);
	p1[2] = (byte)((score >> 16) & 0xFF);
	p1[1] = (byte)((score >> 8) & 0xFF);
	p1[0] = (byte)(score & 0xFF);

	// convert productID to byte array
	p1[11] = (byte)((_adapter->_productID >> 24) & 0xFF);
	p1[10] = (byte)((_adapter->_productID >> 16) & 0xFF);
	p1[9] = (byte)((_adapter->_productID >> 8) & 0xFF);
	p1[8] = (byte)(_adapter->_productID & 0xFF);


	//int usernameLen = _adapter->_userName.length();
	//char* pczUsername = (char*)MEMALLOC(usernameLen+1);
	//WSTRTOSTR(_userName.GetBuf(), pczUsername, usernameLen+1);
	//{
	//	AtomText user((char*)_adapter->_userName.toCharArray());
	//	_pMsg->WriteNamedAtom(_sendBuf, TBMessages::IDX_NAMED_USERNAME, user);
	//}

	// NAME
	//int usernameLen = _adapter->_userName.length();
	//char* pczUsername = (char*)MEMALLOC(usernameLen+1);
	//WSTRTOSTR(_username.GetBuf(), pczUsername, usernameLen+1);

	// fill rest with username
	int c = 0;
	int i;

	for (i=0; i < 8; i++)
	{
		p1[12+i] = seed[i];
	}

	for (i=20; i < KSIZE; i++)
	{	// fill rest with 0s
		p1[i] = 0;
	}

	// now construct p2
	// tourn ID
	const char* tid = tour.GetID();
	for (i=0; i < 32; i++)
	{
		p2[i] = tid[i];
	}
	TRACE(( "AMTPClient::GetResponse()" ));
	// convert seed to array
	
	for (i=0; i < 8; i++)
	{
		p2[32+i] = seed[i];
	}

	char finalhash[20];
	char hexval[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
	

	// md5 set up
	md5_state_t state;

	int a = sizeof(p1);
	// md5 p1
	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)p1, sizeof(p1));
	md5_finish(&state, out1);

	// md5 p2
	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)p2, sizeof(p2));
	md5_finish(&state, out2);

	//dmitri says lock outsize at 32 - ESC
	int outsize=32;
	 char output[33];
	// Clear the output buffer - ESC
	for (int i=0; i < outsize; i++) { output[i] = 0; }

	


	// XOR p1 and p2
	for (i=0; i < HASH_SIZE; i++)
	{
		myk[i] = (byte)(out1[i] ^ out2[i]);
	}

	// md5 
	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)myk, sizeof(myk));
	md5_finish(&state, out1);


	for(int j = 0; j < HASH_SIZE; j++)
	{
		output[j*2] = hexval[((out1[j] >> 4) & 0xF)];
		output[(j*2) + 1] = hexval[(out1[j]) & 0x0F];
	}
	output[HASH_SIZE*2] = '\0';
	//DEBUG(("hashtotal %s", output));

	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_SCORE, score);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_STARTTIME, msStart64);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_ENDTIME, msEnd64);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_ELAPSED, msElapsed);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_PLAYDATA, dataGame, lenData);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_TBDATA, output, outsize);
	_pMsg->WriteNamedAtom(_sendBuf, _pMsg->IDX_NAMED_SEED, seed, 8);
	//close packet
	_sendBuf.WriteUint32AtMark(mark, _sendBuf.MarkLength(mark));

	SetSendBufferLength();

	_isResponsePending = true;
	_requestRetries = REQUEST_RETRY_COUNT;

//	if (pczUsername) {
//		MEMFREE(pczUsername);
//	}

	if (fullUrl == NULL)
	{
		char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), _mobilID, _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
		fullUrl = new String(url);
		MEMFREE(url);
	}

	return _pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis);
}

int32 CarrierAdapter::SetSendBufferLength() {
	uint32 len = _sendBuf.GetLength();
	_sendBuf.Seek(0);
	_sendBuf << len;
	return len;
}


void CarrierAdapter::GetResponse()
{
	TRACE(( "" ));
	TRACE(( "AMTPClient::GetResponse()" ));

	// Short circuit for request cancelled
	if (!_isResponsePending) {
		DEBUG(("FP_GetResponse(): Request Cancelled"));
		return;
	}

	_nBytesInResponse = 0;

	char errorStr[NUM_ERROR_BUF_CHARS];

	// Abort if error message from Web transport
	if (_pWeb->GetErrorMessage(_adapter->_errorNum, errorStr, NUM_ERROR_BUF_CHARS))
	{
		STRTOWSTR(errorStr, _pErrorBuf, ERROR_BUFFER_SIZE);
		_isResponsePending = false;
						
		switch (_adapter->_errorNum) {

			case WEBCODE_MOVEDPERMANENTLY:
			case WEBCODE_FOUND:
			case WEBCODE_TEMPORARYREDIRECT:
				{
				DEBUG(( "AMTPClient::GetResponse(): Received redirect directive from web transport: %s", _pWeb->GetRedirectRootURL() ));
				DBGLOG(( "ClientGR: Redirect: %s\n", errorStr ));
				DBGLOGFLUSH;
				
				//_adapter->_serverURL  = _pWeb->GetRedirectRootURL();
				{
				if (fullUrl != NULL)
				{
					fullUrl->destruct();
					delete fullUrl;
				}
				char* url = CreateServerURL((char*)getRequestURL( ).toCharArray(), (char*)_adapter->min.toCharArray(), _adapter->_productID, _adapter->_gameType, (char*)_adapter->_gameVersion.toCharArray());
				fullUrl = new String(url);
				MEMFREE(url);
				
				}

	
				//_adapter->requestResponse = EVT_AMTP_WAIT;
				if (_pWeb->SendRequest(fullUrl->toCharArray(), _sendBuf.GetBuf(), _sendBuf.GetLength(), _requestTimeoutMillis)) {
					_isResponsePending = true;				
				}
				else {
					DEBUG(( "AMTPClient::GetResponse(): Failed to send redirect request" ));
					gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
				// TODO: DO WE NEED TO PASS ERROR EVENT?
				//	if (_pfnGameEventHandler) {
				//		ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR, (uint16)_nErrorNum, (uint32)errorStr);
				//	}
				}
				}
				return;

			case WEB_ERROR_PROTOCOL:
			case WEB_ERROR_BADURL:
			case WEB_ERROR_BADHOSTNAME:
			case WEB_ERROR_BADPORT:
			case WEB_ERROR_UNSUPSCHEME:
			case WEB_ERROR_DNSCONFIG:
			case WEB_ERROR_ADDRUNKNOWN:
			case WEB_ERROR_PROXYSPEC:
				gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
				//ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
				return;

			default:
				// WEB_ERROR_DNSTIMEOUT
				// WEB_ERROR_CONNECT
				// WEB_ERROR_SEND
				// WEB_ERROR_RECV
				// WEB_ERROR_BADRESPONSE
				// WEB_ERROR_BODYLENGTH


				if (_requestRetries == 0) {
					gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
				//	ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
				}
				else {
					_requestRetries--;

					DEBUG(( "AMTPClient::GetResponse(): Retrying timeout request (attempt %d of %d)", (REQUEST_RETRY_COUNT - _requestRetries), REQUEST_RETRY_COUNT ));
					DBGLOG(( "ClientGR: Retry: %s\n", errorStr ));
					DBGLOGFLUSH;

					const uint8 *sendBuffer = _sendBuf.GetBuf();
					((PackageHeader *)sendBuffer)->retryCount++;
					//_adapter->requestResponse = EVT_AMTP_WAIT;
					if (_pWeb->SendRequest(fullUrl->toCharArray(), sendBuffer, _sendBuf.GetLength(), _requestTimeoutMillis)) {
						_isResponsePending = true;
						gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR_REPORT, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
					//	ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR_REPORT, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
					}
					else {
						DEBUG(( "AMTPClient::GetResponse(): Failed to send retry request" ));
						_requestRetries = 0;
						gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)_pErrorBuf);
						// TODO: DO WE NEED TO PASS ERROR EVENT?
					//	if (_pfnGameEventHandler) {
					//		ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR, (uint16)_nErrorNum, (uint32)_pErrorBuf);
					//	}
					}
				}
				return;
		}
	}
	else
	{
		DEBUG(( "AMTPClient::GetResponse looking good so far..." ));
	}

	_isResponsePending = false;
	_requestRetries = 0;

	bool ok = _pMsg->ParseResponse(_recvBuf);

	// Look for any request timeout adjustments fron server.
	GetRequestTimeout();

	// Abort if error message from server.
	if (_pMsg->GetErrorMessage(_adapter->_errorNum, errorStr, ERROR_BUFFER_SIZE))
	{
		if (_adapter->_errorNum == ERR_AMTP_TOURNAMENT_NO_MORE_SEEDS) {
			if (errorStr != NULL) {
				STRTOWSTR(errorStr, _outOfSeedsErrorBuf, ERROR_BUFFER_SIZE);
			}
		}
		else {
			int len;
			char* pSuggestedName = (char *)_pMsg->GetResponseData(TBMessages::IDX_RESP_SUGGESTED_NAME, len);
			if (pSuggestedName) {
					if (STRTOWSTR(pSuggestedName, _pDisplayMessageBuf, DISPLAY_BUFFER_SIZE)) {
						if(_adapter->_userName.length() > 0)
							_adapter->setUsername(pSuggestedName);
						else
							_adapter->setUsername("");
				}
			}

			//if (_nErrorNum == ERR_AMTP_ACCOUNT_NOT_FOUND) {
			//	_isRegistered = false;
			//	SavePreferences();
			//}

			if (errorStr != NULL) {
				STRTOWSTR(errorStr, _pErrorBuf, ERROR_BUFFER_SIZE);
			}

			_adapter->_errorStr = errorStr;
		//	ISHELL_PostEvent(GETSHELL(), GETCLASSID(), EVT_AMTP_ERROR, (uint16)_nErrorNum, (uint32)errorStr);
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ERROR, (uint16)_adapter->_errorNum, (uint32)errorStr);		
			return;
		}
	}

	// Quiet status warning if error while parsing.
	if (!ok) {
		_nErrorCount++;
		_adapter->_errorNum = (uint32)-1;
		STRTOWSTR("Unrecognized response was ignored.", _pErrorBuf, ERROR_BUFFER_SIZE);
	}

	CheckRedirect(_pMsg);

	// TODO: if amtpurl is null, set the msg to it.
	// else just proceed as normal

	switch (_pMsg->GetResponseType()) {

		case TYPE_RESP_REGISTER:
		{
			DEBUG(( "RegResp recv'd" ));
			ARMDEBUG(( "RegResp recv'd" ));


			//tell game that we're registered
			//TODO: HOW TO SEND RESPONSE?
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_REGISTER_RESPONSE, 0, 0);
			//_adapter->requestResponse = EVT_AMTP_REGISTER_RESPONSE;
 			break;
		}
		
		case TYPE_RESP_GETTOURNEYS:
		{
			DEBUG(( "GetTournsResp recv'd" ));
			ARMDEBUG(( "GetTournsResp recv'd" ));

			SetOutOfSeeds(_adapter->_errorNum == ERR_AMTP_TOURNAMENT_NO_MORE_SEEDS);

			GetWinnerItems();
			GetNewsItems();

			// Save the latest tournaments if they were sent in this response
			int type = PARAM_TOURNAMENT_TYPE_H2H;

			bool hasH2HTournament = _pMsg->GetTournament(type, _nextTournament[type-1]);

			type = PARAM_TOURNAMENT_TYPE_PROGRESSIVE;
			bool hasProgressiveTournament = _pMsg->GetTournament(type, _nextTournament[type-1]);

			_adapter->_hasNextTournaments = (hasH2HTournament || hasProgressiveTournament);

//			CalculateLocalToServerTimeOffset();

 			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_GET_TOURNAMENTS_RESPONSE, 0, 0);
  
			// If we're in the process of getting scores, a successful GetTournamentsResponse
			// needs to be followed by a GetScoresRequest.
			if (_adapter->_isGettingScore) {
				getScores();
			}
			break;
		}
		
		case TYPE_RESP_ENTERTOURNEY:
		{
			DEBUG(( "EnterTournResp recv'd" ));
			ARMDEBUG(( "EnterTournResp recv'd" ));

			SetOutOfSeeds(_adapter->_errorNum == ERR_AMTP_TOURNAMENT_NO_MORE_SEEDS);

			GetWinnerItems();
			GetNewsItems();

			//Save the latest tournaments if they were sent in this response
			int type = PARAM_TOURNAMENT_TYPE_H2H;
			bool hasH2HTournament = _pMsg->GetTournament(type, _nextTournament[type-1]);

			type = PARAM_TOURNAMENT_TYPE_PROGRESSIVE;
			bool hasProgressiveTournament = _pMsg->GetTournament(type, _nextTournament[type-1]);

			_adapter->_hasNextTournaments = (hasH2HTournament || hasProgressiveTournament);

		//	SetHasNextTournaments(hasH2HTournament || hasProgressiveTournament);

			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_ENTER_TOURNAMENT_RESPONSE, 0, 0);

 			//_pfnGameEventHandler(GETAPPINSTANCE(), EVT_AMTP_ENTER_TOURNAMENT_RESPONSE, 0, 0);
  
			// If we're in the process of reporting a score, a successful EnterTournamentResponse
			// needs to be followed by a ReportScoreRequest.
			if (_isReportingScore) {
				reportScore();
			}
			break;
		}
		
		case TYPE_RESP_REPORTSCORE:
		{
			DEBUG(( "ReportScoreResp recv'd" ));
			ARMDEBUG(( "ReportScoreResp recv'd" ));

			_isReportingScore = false;
			_hasScoreResults = true;

			// Let Game know, in case it's waiting for it
 			//_pfnGameEventHandler(GETAPPINSTANCE(), EVT_AMTP_REPORT_SCORE_RESPONSE, 0, 0);
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_REPORT_SCORE_RESPONSE, 0, 0);
			break;
		}
		
		case TYPE_RESP_REPORTFORFEIT:
		{
			DEBUG(( "ReportForfeit recv'd" ));
			ARMDEBUG(( "ReportForfeit recv'd" ));

			_isReportingScore = false;

			// Let Game know, in case it's waiting for it
 			//_pfnGameEventHandler(GETAPPINSTANCE(), EVT_AMTP_REPORT_FORFEIT_RESPONSE, 0, 0);
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_REPORT_FORFEIT_RESPONSE, 0, 0);
			break;
		}
		
		case TYPE_RESP_GETSCORES:
		{
			DEBUG(( "GetScoresResp recv'd" ));
			ARMDEBUG(( "GetScoresResp recv'd" ));

			_adapter->_isGettingScore = false;

			// Let Game know, in case it's waiting for it
 			//_pfnGameEventHandler(GETAPPINSTANCE(), EVT_AMTP_GET_SCORES_RESPONSE, 0, 0);
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_GET_SCORES_RESPONSE, 0, 0);
			break;
		}
		
		case TYPE_RESP_SETOPTIONS:
		{
			DEBUG(( "SetOptionsResp recv'd" ));
			ARMDEBUG(( "SetOptionsResp recv'd" ));

			// Let Game know, in case it's waiting for it
 			//_pfnGameEventHandler(GETAPPINSTANCE(), EVT_AMTP_SET_OPTIONS_RESPONSE, 0, 0);
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_SET_OPTIONS_RESPONSE, 0, 0);
			break;
		}
		
		case TYPE_RESP_GETPROMOTION:
		{
			DEBUG(( "PromotionResp recv'd" ));
			ARMDEBUG(( "PromotionResp recv'd" ));
		
			GetPromoItems();

			//_adapter->requestResponse = EVT_AMTP_GET_PROMOTION_RESPONSE;
			gameHandleEvent(GETAPPINSTANCE(), EVT_AMTP_GET_PROMOTION_RESPONSE, 0, 0);
			
 			break;
		}
		default:
			DEBUG(( "UNKNOWN Resp recv'd" ));
			ARMDEBUG(( "UNKNOWN Resp recv'd" ));
			break;
	}
}

String CarrierAdapter::getRequestURL() {
	return _adapter->_serverURL;
}

char* CarrierAdapter::CreateServerURL(char *rootURL, char *mobileID, int productID, short gameType, char *gameVersion)
{
	int len = 	STRLEN(rootURL) +
				STRLEN("?MIN=")   + STRLEN(mobileID) +
				STRLEN("&pid=")   + 12 +
				STRLEN("&gtype=") + 6 +
				STRLEN("&gver=")  + STRLEN(gameVersion);

	char* pURL = NULL;

	if (NULL != (pURL = (char*)MEMALLOC(len+1))) {
		SPRINTF(pURL,"%s?min=%s&pid=%d&gtype=%d&gver=%s", rootURL, mobileID, productID, gameType, gameVersion);
	}

	return pURL;
}	

/**
 * Get request timeout modification (if any) from the current response.
 */
void CarrierAdapter::GetRequestTimeout()
{
	int32 requestTimeoutMillis;
	if (_pMsg->GetInt32(TBMessages::IDX_RESP_REQUEST_TIMEOUT, requestTimeoutMillis)) {
		if (requestTimeoutMillis == 0) {
			_requestTimeoutMillis = REQUEST_TIMEOUT_DEFAULT;
		}
		else if (requestTimeoutMillis < REQUEST_TIMEOUT_MINIMUM) {
			_requestTimeoutMillis = REQUEST_TIMEOUT_MINIMUM;
		}
		else {
			_requestTimeoutMillis = requestTimeoutMillis;
		}
	}
}

/**
 * Get news string and image (if any) from the current response.
 */
void CarrierAdapter::GetNewsItems()
{
	bool newNews = false;

	AECHAR * newsStr = GetResponseStr(TBMessages::IDX_RESP_NEWS_STR);
	if (newsStr != NULL) {
	//	if (_newsStr) {
	//		FREE(_newsStr);
	//		_newsStr = NULL;
	//	}
		int len = WSTRLEN(newsStr);
		if (len > 0) {
			//_newsStr = (AECHAR *)MEMALLOC((len + 1) * sizeof(AECHAR));
			//WSTRCPY(_newsStr, newsStr);
			_adapter->_newsText = newsStr;
			newNews = true;
		}
	}

	int len;
	bool wasSet;
	void * newsImg = _pMsg->GetResponseData(TBMessages::IDX_RESP_NEWS_IMG, len, wasSet);
	if (wasSet || newsImg != NULL) {
		TBUTIL_ReleaseBitmap(&_adapter->_newsImage);
		if (len > 0) {
			TBUTIL_CreateBitmap(&_adapter->_newsImage, newsImg, len);
			newNews = true;
		}
	}

	if (!_adapter->_hasNews) {
		_adapter->_hasNews = newNews;
	}
}

///////////////////////////////////////////////////////////////////////////////

/**
 * Get winner string and image (if any) from the current response.
 */
void CarrierAdapter::GetWinnerItems() 
{
	AECHAR * winnerStr = GetResponseStr(TBMessages::IDX_RESP_WINNER_STR);
	if (winnerStr != NULL) {
	//	if (_winnerStr) {
	//		FREE(_winnerStr);
	//		_winnerStr = NULL;
	//	}
		int len = WSTRLEN(winnerStr);
		if (len > 0) {
			//_winnerStr = (AECHAR *)MEMALLOC((len + 1) * sizeof(AECHAR));
		//	WSTRCPY(_winnerStr, winnerStr);
			_adapter->_winnerText = winnerStr;
		}
	}

	int len;
	bool wasSet;
	void * winnerImg = _pMsg->GetResponseData(TBMessages::IDX_RESP_WINNER_IMG, len, wasSet);
	if (wasSet || winnerImg != NULL) {
		TBUTIL_ReleaseBitmap(&_adapter->_winnerImage);
		if (len > 0) {
			TBUTIL_CreateBitmap(&_adapter->_winnerImage, winnerImg, len);
		}
	}
}

/**
 * Get news string and image (if any) from the current response.
 */
void CarrierAdapter::GetPromoItems()
{
	bool	newPromo = false;
	int		len;
	bool	wasSet;

	AECHAR*	promoStr = GetResponseStr(TBMessages::IDX_RESP_PROMO_STR);
	DEBUG(("PROMO %s", promoStr));
	if(promoStr != NULL) 
	{
	//	if(_promoStr) 
	//	{
	//		FREE(_promoStr);
	//		_promoStr = NULL;
	//	}
		len = WSTRLEN(promoStr);
		if(len > 0) 
		{
			//_promoStr = (AECHAR*) MALLOC((len + 1) * sizeof(AECHAR));
			//WSTRCPY(_promoStr, promoStr);
			_adapter->_promoText = promoStr;
			DEBUG(("PROMO2 %s", _adapter->_promoText.toCharArray()));
			newPromo = true;
		}
	}

	void* promoImg = _pMsg->GetResponseData(TBMessages::IDX_RESP_PROMO_IMG, len, wasSet);
	if(		wasSet 
		||	promoImg != NULL) 
	{
		TBUTIL_ReleaseBitmap(&_adapter->_promoImage);
		if(len > 0) 
		{
			TBUTIL_CreateBitmap(&_adapter->_promoImage, promoImg, len);
			newPromo = true;
		}
	}

	if(!_pMsg->GetInt32(TBMessages::IDX_RESP_PROMO_NEXT, _adapter->_promoID)) 
	{
		_adapter->_promoID = -1;
	}

	if(!_hasPromo) 
	{
		_hasPromo = newPromo;
	}

	_pMsg->FreeResponseData(TBMessages::IDX_RESP_PROMO_STR);
	_pMsg->FreeResponseData(TBMessages::IDX_RESP_PROMO_IMG);
}

AECHAR * CarrierAdapter::GetOutOfSeedsErrorStr() 
{
	return _outOfSeedsErrorBuf;
}



//-----------------------------------------------------------------------------
void CarrierAdapter::CheckRedirect(TBMessages* pMsg)
{
	char *redirectURL = pMsg->GetRedirectURL();

	if (redirectURL != NULL) {
		if (_pczRedirectRootURL != NULL) {
			MEMFREE(_pczRedirectRootURL);
			_pczRedirectRootURL = NULL;
		}
		_pczRedirectRootURL = (char *)STRDUP(redirectURL);

		if (_adapter->_serverURL.length( ) > 0) {
			//MEMFREE(_adapter->_serverURL);
			_adapter->_serverURL = "";
		}
		_adapter->_serverURL = _pczRedirectRootURL;
	}
}

void CarrierAdapter::SetOutOfSeeds(bool outOfSeeds)
{
	_adapter->_outOfSeeds = outOfSeeds;
}

AECHAR * CarrierAdapter::GetResponseStr(int type)
{
	int len;
	char * pMsg = (char *)_pMsg->GetResponseData(type, len);
	if(pMsg)
	DEBUG(("GET %d %s", len, pMsg));
	if (!pMsg) {
		return NULL;
	}

	if (!TBUTIL_StrToWstr(pMsg, _pDisplayMessageBuf, DISPLAY_BUFFER_SIZE)) {
		return NULL;
	}

	return _pDisplayMessageBuf;
}