#ifndef _FPC_MENUS_TESTBED_H_
#define _FPC_MENUS_TESTBED_H_

//#include "..\..\Core\TBC.h"
	
	/**
	 * Menu States - These are distinct, displayable menu screens
	 */
	// Roster
	#define MENU_SCREEN_START 									  MENU_FLAG_SCREEN 
	
	//ADI p4p library menu screens
	#define MENU_ERROR_GENERAL   MENU_SCREEN_START+1 
	#define MENU_NETWORK_N0T_AVAILABLE   MENU_ERROR_GENERAL+1 
	#define MENU_WELCOME   MENU_NETWORK_N0T_AVAILABLE+1 
	#define MENU_PROMO   MENU_WELCOME+1 
	#define MENU_ENTER_PIN   MENU_PROMO+1 
	#define MENU_VERIFY_PHONE   MENU_ENTER_PIN+1 
	#define MENU_SMS_OPTION   MENU_VERIFY_PHONE+1 
	#define MENU_ENTER_USER_NAME   MENU_SMS_OPTION+1
	#define MENU_EXISTING_USER_NAME   MENU_ENTER_USER_NAME+1 
	#define MENU_MISMATCH_USER_NAME   MENU_EXISTING_USER_NAME+1 
	#define MENU_INVALID_USER_NAME   MENU_MISMATCH_USER_NAME+1 
	#define MENU_INVALID_PIN   MENU_INVALID_USER_NAME+1 
	#define MENU_ENTER_PHONE   MENU_INVALID_PIN+1 
	#define MENU_REGISTRATION   MENU_ENTER_PHONE+1 
	#define MENU_RANK_SUMMARY   MENU_REGISTRATION+1 
	#define MENU_PRIZES   MENU_RANK_SUMMARY+1 
	#define MENU_NEWS   MENU_PRIZES+1 
	#define MENU_WINNER   MENU_NEWS+1 
	#define MENU_HELP_HOW_TO_PLAY   MENU_WINNER+1 
	#define MENU_HELP_SCORING   MENU_HELP_HOW_TO_PLAY+1 
	#define MENU_HELP_TIPS_AND_TRICKS   MENU_HELP_SCORING+1 
	#define MENU_HELP_TOURNAMENTS   MENU_HELP_TIPS_AND_TRICKS+1 
	#define MENU_HELP_LEGAL   MENU_HELP_TOURNAMENTS+1 
	#define MENU_HELP   MENU_HELP_LEGAL+1 
	#define MENU_SCORES_DISPLAY   MENU_HELP+1 
	#define MENU_SCORES_MY_TOURNAMENTS   MENU_SCORES_DISPLAY+1 
	#define MENU_SCORES_H2H   MENU_SCORES_MY_TOURNAMENTS+1 
	#define MENU_SCORES_PROGRESSIVE   MENU_SCORES_H2H+1 
	#define MENU_SCORES   MENU_SCORES_PROGRESSIVE+1 
	#define MENU_TOURNAMENT   MENU_SCORES+1 
	#define MENU_SUBSCRIPTION_THANKS   MENU_TOURNAMENT+1 
	#define MENU_SUBSCRIPTION_CONFIRM   MENU_SUBSCRIPTION_THANKS+1 
	#define MENU_SUBSCRIPTION   MENU_SUBSCRIPTION_CONFIRM+1 
	
	#define MENU_MATCH_RESULTS   MENU_SUBSCRIPTION+1 
	
	#define MENU_REGISTRATION_TEXT_MESSAGE   MENU_MATCH_RESULTS+1 
	
	#define MENU_SCREEN_FP_MAIN								  MENU_REGISTRATION_TEXT_MESSAGE+1 
	#define MENU_SCREEN_EXERCISE_UI							  MENU_SCREEN_FP_MAIN +1 
	#define MENU_SCREEN_TEST_IMAGE	 							  MENU_SCREEN_EXERCISE_UI+1 
	#define MENU_SCREEN_TEST_TEXT								  MENU_SCREEN_TEST_IMAGE+1 
	#define MENU_SCREEN_TEST_PROGRESS							  MENU_SCREEN_TEST_TEXT+1 
	#define MENU_SCREEN_TEST_NETWORK							  MENU_SCREEN_TEST_PROGRESS+1 
	#define MENU_SCREEN_NETWORK_WAIT							  MENU_SCREEN_TEST_NETWORK+1 
	#define MENU_LOADING 										  MENU_SCREEN_NETWORK_WAIT 
	#define MENU_SCREEN_NETWORK_ERROR							  MENU_SCREEN_NETWORK_WAIT+1 
	#define MENU_SCREEN_HELP									  MENU_SCREEN_NETWORK_ERROR+1 
	#define MENU_SCREEN_OUT_OF_SEEDS 							  MENU_SCREEN_HELP+1 
	#define MENU_SCREEN_GAME_RESULTS 							  MENU_SCREEN_OUT_OF_SEEDS+1 
	#define MENU_SCREEN_CLIENT									  MENU_SCREEN_GAME_RESULTS+1 
	
	
	
	
	
	//ACE screens
	#define  MENU_SCREEN_ACE_STATE_ACTIVATE    MENU_SCREEN_CLIENT+1 
	#define  MENU_SCREEN_ACE_STATE_INFO 		   MENU_SCREEN_ACE_STATE_ACTIVATE+1 
	#define  MENU_SCREEN_ACE_STATE_PACKAGE 	   MENU_SCREEN_ACE_STATE_INFO+1 
	#define  MENU_SCREEN_ACE_STATE_EXECUTE 	   MENU_SCREEN_ACE_STATE_PACKAGE+1 
	#define  MENU_SCREEN_ACE_STATE_TERMS 		   MENU_SCREEN_ACE_STATE_EXECUTE+1 
	#define  MENU_SCREEN_ACE_STATE_CAPTURE 	   MENU_SCREEN_ACE_STATE_TERMS+1 
	#define  MENU_SCREEN_ACE_STATE_SUCCESS 	   MENU_SCREEN_ACE_STATE_CAPTURE+1 
	#define  MENU_SCREEN_ACE_STATE_FAILURE 	   MENU_SCREEN_ACE_STATE_SUCCESS+1 
	#define  MENU_SCREEN_ACE_STATE_EXIT 		   MENU_SCREEN_ACE_STATE_FAILURE+1 
	#define  MENU_SCREEN_ACE_STATE_DEMO 		   MENU_SCREEN_ACE_STATE_EXIT+1 
	#define  MENU_SCREEN_PRINT_SCREEN 			   MENU_SCREEN_ACE_STATE_DEMO+1 
	
	
	
	
	
	
	#define MENU_SCREEN_END									  MENU_SCREEN_PRINT_SCREEN+1 
	#define MENU_SCREEN_NUM 									  MENU_SCREEN_END - MENU_SCREEN_START 
	
	/**
	 * Menu Actions - These are Commands, when processed, return MenuStates based on field settings
	 */
	//ADI p4p actions 
	#define MENU_ACTION_START_H2H_GAME   MENU_ACTION_MODULE_START 
	#define MENU_ACTION_START_PROGRESSIVE_GAME   MENU_ACTION_START_H2H_GAME+1 
	#define MENU_ACTION_VIEW_PROMO   MENU_ACTION_START_PROGRESSIVE_GAME+1 
	#define PARAM_MENU_ACTION_SWITCH_TO_GAME   MENU_ACTION_VIEW_PROMO+1 
	#define MENU_ACTION_GET_SCORES_H2H_CURRENT_RANK   PARAM_MENU_ACTION_SWITCH_TO_GAME+1 
	#define MENU_ACTION_GET_SCORES_PROGRESSIVE_CURRENT_RANK   MENU_ACTION_GET_SCORES_H2H_CURRENT_RANK+1 
	#define MENU_ACTION_GET_SCORES_H2H_RECENT_MATCHES   MENU_ACTION_GET_SCORES_PROGRESSIVE_CURRENT_RANK+1 
	#define MENU_ACTION_GET_SCORES_H2H_MY_TOURNAMENTS   MENU_ACTION_GET_SCORES_H2H_RECENT_MATCHES+1 
	#define MENU_ACTION_GET_SCORES_PROGRESSIVE_MY_TOURNAMENTS   MENU_ACTION_GET_SCORES_H2H_MY_TOURNAMENTS+1 
	#define MENU_ACTION_GET_SCORES_H2H_GLOBAL_RANKS   MENU_ACTION_GET_SCORES_PROGRESSIVE_MY_TOURNAMENTS+1 
	#define MENU_ACTION_GET_SCORES_PROGRESSIVE_ALL_TIME_BEST   MENU_ACTION_GET_SCORES_H2H_GLOBAL_RANKS+1 
	#define MENU_ACTION_CHECK_REGISTRATION   MENU_ACTION_GET_SCORES_PROGRESSIVE_ALL_TIME_BEST+1 
	#define MENU_ACTION_REGISTER   MENU_ACTION_CHECK_REGISTRATION+1 
	#define MENU_ACTION_DETERMINE_REGISTRATION_SCREEN   MENU_ACTION_REGISTER+1 
	#define MENU_ACTION_GET_TOURNAMENTS_H2H   MENU_ACTION_DETERMINE_REGISTRATION_SCREEN+1 
	#define MENU_ACTION_GET_TOURNAMENTS_PROGRESSIVE   MENU_ACTION_GET_TOURNAMENTS_H2H+1 
	#define MENU_ACTION_GOTO_TOURNAMENT   MENU_ACTION_GET_TOURNAMENTS_PROGRESSIVE+1 
	#define MENU_ACTION_CHECK_SUBSCRIPTION   MENU_ACTION_GOTO_TOURNAMENT+1 
	#define MENU_ACTION_CONFIRM_SUBSCRIPTION   MENU_ACTION_CHECK_SUBSCRIPTION+1 
	#define MENU_ACTION_SHOW_MAIN_MENU   MENU_ACTION_CONFIRM_SUBSCRIPTION+1 
	#define MENU_ACTION_SHOW_SCORES   MENU_ACTION_SHOW_MAIN_MENU+1 
	#define MENU_ACTION_SHOW_SCORES_H2H   MENU_ACTION_SHOW_SCORES+1 
	#define MENU_ACTION_SHOW_SCORES_PROGRESSIVE   MENU_ACTION_SHOW_SCORES_H2H+1 
	#define MENU_ACTION_SHOW_TOURNAMENT_0   MENU_ACTION_SHOW_SCORES_PROGRESSIVE+1 
	#define MENU_ACTION_SHOW_TOURNAMENT_1   MENU_ACTION_SHOW_TOURNAMENT_0+1 
	#define MENU_ACTION_SHOW_TOURNAMENT_2   MENU_ACTION_SHOW_TOURNAMENT_1+1 
	#define MENU_ACTION_ADVANCE   MENU_ACTION_SHOW_TOURNAMENT_2+1 
	#define MENU_ACTION_RESUME   MENU_ACTION_ADVANCE+1 
	#define MENU_ACTION_QUIT_GAME   MENU_ACTION_RESUME+1
	#define MENU_ACTION_FP_REGISTER MENU_ACTTION_QUIT_GAME+1
	#define MENU_ACTION_MAKE_SCROLL_BOX_HELP_HOW_TO_PLAY   MENU_LOADING+1 
	#define MENU_ACTION_MAKE_SCROLL_BOX_HELP_SCORING   MENU_ACTION_MAKE_SCROLL_BOX_HELP_HOW_TO_PLAY +1 
	#define MENU_ACTION_MAKE_SCROLL_BOX_HELP_TIPS_AND_TRICKS   MENU_ACTION_MAKE_SCROLL_BOX_HELP_SCORING+1 
	#define MENU_ACTION_MAKE_SCROLL_BOX_HELP_TOURNAMENTS   MENU_ACTION_MAKE_SCROLL_BOX_HELP_TIPS_AND_TRICKS+1 
	#define MENU_ACTION_MAKE_SCROLL_BOX_HELP_LEGAL   MENU_ACTION_MAKE_SCROLL_BOX_HELP_TOURNAMENTS+1 
	#define MENU_ACTION_RESUME_GAME							  MENU_ACTION_MAKE_SCROLL_BOX_HELP_LEGAL+1 
	#define MENU_ACTION_RETRY_NETWORK 							  MENU_ACTION_RESUME_GAME+1 
	#define MENU_ACTION_PAUSE_GAME								  MENU_ACTION_RETRY_NETWORK+1 
	#define MENU_ACTION_CANCEL_GAME							  MENU_ACTION_PAUSE_GAME+1 
#ifndef MENU_ACTION_END_GAME
	#define MENU_ACTION_END_GAME								  MENU_ACTION_CANCEL_GAME+1 
#endif
	
	//ACE_Actions
	#define MENU_ACTION_ACE_STATE_ACTIVATE								  MENU_ACTION_END_GAME+1 
	
	
	#define MENU_ACTION_END									  (MENU_ACTION_ACE_STATE_ACTIVATE+1) 
	#define MENU_ACTION_NUM									  MENU_ACTION_END - MENU_ACTION_START 
	
	/**
	 * Menu Image Elements
	 */
	// Roster
	#define MENU_ELEMENT_IMAGE_START							  MENU_FLAG_ELEMENT_IMAGE 
	#define MENU_ELEMENT_IMAGE_END								  MENU_ELEMENT_IMAGE_START 
	#define MENU_ELEMENT_IMAGE_NUM								  MENU_ELEMENT_IMAGE_END - MENU_ELEMENT_IMAGE_START 
	
	/**
	 * Menu ProgressBar
	 */
	// Configuration
	#define MENU_ELEMENT_PROGRESSBAR_INITIAL_STATE				  0 
	// Roster
	#define MENU_ELEMENT_PROGRESSBAR_START						  MENU_FLAG_ELEMENT_PROGRESSBAR 
	#define MENU_ELEMENT_PROGRESSBAR_END						  MENU_ELEMENT_PROGRESSBAR_START 
	#define MENU_ELEMENT_PROGRESSBAR_NUM						  MENU_ELEMENT_PROGRESSBAR_END - MENU_ELEMENT_PROGRESSBAR_START 
	
	/**
	 * Menu Switch Elements
	 */
	// Configuration
	#define MENU_ELEMENT_SWITCH_OFF 							  0 
	#define MENU_ELEMENT_SWITCH_ON 							  1 
	#define MENU_ELEMENT_SWITCH_INITIAL_STATE					  MENU_ELEMENT_SWITCH_OFF 
	// Roster
	#define MENU_ELEMENT_SWITCH_START							  MENU_FLAG_ELEMENT_SWITCH 
	#define MENU_ELEMENT_SWITCH_END							  MENU_ELEMENT_SWITCH_START 
	#define MENU_ELEMENT_SWITCH_NUM							  MENU_ELEMENT_SWITCH_END - MENU_ELEMENT_SWITCH_START 
	
	/**
	 * Menu Text Box Elements
	 */
	// Roster
	#define MENU_ELEMENT_TEXTBOX_START							  MENU_FLAG_ELEMENT_TEXTBOX 
	#define MENU_ELEMENT_TEXTBOX_END							  MENU_ELEMENT_TEXTBOX_START 
	#define MENU_ELEMENT_TEXTBOX_NUM							  MENU_ELEMENT_TEXTBOX_END - MENU_ELEMENT_TEXTBOX_START 
	
	/**
	 * Menu Text Input Elements
	 */
	// Configuration
	#define MENU_ELEMENT_TEXTINPUT_EMPTY_CHAR					  (char)0 
	// Roster
	#define MENU_ELEMENT_TEXTINPUT_START						  MENU_FLAG_ELEMENT_TEXTINPUT 
	#define MENU_ELEMENT_TEXTINPUT_END							  MENU_ELEMENT_TEXTINPUT_START 
	#define MENU_ELEMENT_TEXTINPUT_NUM							  MENU_ELEMENT_TEXTINPUT_END - MENU_ELEMENT_TEXTINPUT_START 

#endif _FPC_MENUS_TESTBED_H_