/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef MEMORY_H
#define MEMORY_H

#include "Debug.h"

//-----------------------------------------------------------------------------
//	NEW, MEMALLOC, MEMFREE
//-----------------------------------------------------------------------------
#if defined(_DEBUG) && 0

#ifdef __cplusplus
extern "C"
{
#endif

#define NEW() DEBUG(( "%s(%d) : **NEW**", __FILE__, __LINE__ ))

void* MemAlloc(size_t size, char* szFile, int iLine);
void MemFree(void* ptr, char* szFile, int iLine);

//#define MEMALLOC(expr) MemAlloc(expr, __FILE__, __LINE__)
#define MEMFREE(expr) MemFree(expr, __FILE__, __LINE__)

#ifdef __cplusplus
}
#endif

#else //defined(_DEBUG)

#define NEW()
#define MEMALLOC(expr) MALLOC(expr)
#define MEMFREE(expr) FREE(expr)

#endif //defined(_DEBUG)


#endif //MEMORY_H
