/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#include "TBMessages.h"

//#include "AMTPClient.h"
#include "../ForPrizes/Core/AMTPTournament.h"
//#include "Date.h"
#include "IOStreamBuf.h"

#if 1
#define DEBUGREADTEXT(expr) DEBUG(expr)
#else
#define DEBUGREADTEXT(expr)
#endif

#if 0
#define DEBUGWRITETEXT(expr) DEBUG(expr)
#else
#define DEBUGWRITETEXT(expr)
#endif

#if 0
#define DEBUGWRITE(expr) DEBUG(expr)
#else
#define DEBUGWRITE(expr)
#endif

#if 1
#define DEBUGREAD(expr) DEBUG(expr)
#else
#define DEBUGREAD(expr)
#endif

#if 0
#define DEBUGGET(expr) DEBUG(expr)
#else
#define DEBUGGET(expr)
#endif

#if 0
#define DEBUGSET(expr) DEBUG(expr)
#else
#define DEBUGSET(expr)
#endif

#if 0
#define DEBUGLEN(expr) DEBUG(expr)
#else
#define DEBUGLEN(expr)
#endif

#if 0
#define DEBUGI64(expr) DEBUG(expr)
#else
#define DEBUGI64(expr)
#endif

#if 0
#define DEBUGSTACK() GETCLIENT()->DebugStack();
#else
#define DEBUGSTACK()
#endif

#if defined(_DEBUG) && 0
#define DEBUGTYPE(expr) DebugPrintType(expr)
#else
#define DEBUGTYPE(expr)
#endif

#if defined(_DEBUG) && 0
#define PRINTTYPE(expr) DebugPrintType(expr)
#else
#define PRINTTYPE(expr)
#endif

#if defined(_ARMDEBUG) && 0
#define PRINTSHORTTEXT(expr) DebugText(expr)
#else
#define PRINTSHORTTEXT(expr)
#endif


#if defined(_DEBUG)
#define DEBUGPUSH() DebugIndent(1)
#define DEBUGPOP() DebugIndent(-1)
#else
#define DEBUGPUSH()
#define DEBUGPOP()
#endif

//-----------------------------------------------------------------------------
#ifdef _DEBUG
void TBMessages::DebugPrintType(uint32 type)
{
	char cType[4];
	cType[3] = (char)((uint32)type>>24 & 0xff);
	cType[2] = (char)((uint32)type>>16 & 0xff);
	cType[1] = (char)((uint32)type>>8 & 0xff);
	cType[0] = (char)((uint32)type & 0xff);

	DEBUG(( "%stype = 0x%lx = '%c%c%c%c'", _in, type, cType[3], cType[2], cType[1], cType[0] ));
	//ARMDEBUG(( "type='%c%c%c%c'", cType[3], cType[2], cType[1], cType[0] ));
}
void TBMessages::DebugIndent(int inc)
{
	_dbgIn += inc;
	switch (_dbgIn)
	{
		case 0: _in = ""; break;
		case 1: _in = "   "; break;
		case 2: _in = "      "; break;
		case 3: _in = "         "; break;
		case 4: _in = "            "; break;
	}
}
#endif
#ifdef _ARMDEBUG
void TBMessages::DebugText(const char* pChars)
{
	if (pChars)
	{
		if (STRLEN(pChars) > 24)
		{
			char shortstr[25];
			STRNCPY(shortstr, pChars, 24);
			shortstr[24] = '\0';
			ARMDEBUG(( "text=\"%s\"", shortstr ));
		}
		else
		{
			ARMDEBUG(( "text=\"%s\"", pChars ));
		}
	}
	else
		ARMDEBUG(( "text=\"\"" ));
}
#endif

//-----------------------------------------------------------------------------
TBMessages::TBMessages()
	: _nMessageID(0)
	, _pNameBuf(NULL)
	, _pStringBuf(NULL)
	, _pCertificateBuf(NULL)
	, _lenCertificateBuf(0)
	, _lenCertificate(0)
	, _lenMaxAtom(LEN_MAXATOMLENGTH)
{
	TRACE(( "TBMessages()" ));

	int idx = 0;
	idx = 0;
	_pcNames[idx++] = "!!";				// IDX_NAMED_MSGID,
	_pcNames[idx++] = "$min";			// IDX_NAMED_MIN,
	_pcNames[idx++] = "$user";			// IDX_NAMED_USERNAME,
	_pcNames[idx++] = "$ptyp";			// IDX_NAMED_PHONETYPE,
	_pcNames[idx++] = "%pref";			// IDX_NAMED_PREFS,
	_pcNames[idx++] = "&smsOptIn";		// IDX_NAMED_OPTIN,
	_pcNames[idx++] = "%gameID";		// IDX_NAMED_GAMEID,
	_pcNames[idx++] = "#pid";			// IDX_NAMED_PRODID,
	_pcNames[idx++] = "#gtype";			// IDX_NAMED_GAMETYPE,
	_pcNames[idx++] = "#gvers";			// IDX_NAMED_GAMEVERS,
	_pcNames[idx++] = "#ttyp";			// IDX_NAMED_TOURNTYPE,
	_pcNames[idx++] = "$tour";			// IDX_NAMED_TOURNID,
	_pcNames[idx++] = "%play";			// IDX_NAMED_GAMEPLAY,
	_pcNames[idx++] = "#score";			// IDX_NAMED_SCORE,
	_pcNames[idx++] = "#styp";			// IDX_NAMED_SCORETYPE,
	_pcNames[idx++] = "*start";			// IDX_NAMED_STARTTIME,
	_pcNames[idx++] = "*end";			// IDX_NAMED_ENDTIME,
	_pcNames[idx++] = "*elapsed";		// IDX_NAMED_ELAPSED,
	_pcNames[idx++] = "^data";			// IDX_NAMED_PLAYDATA,
	_pcNames[idx++] = "#acls";			// IDX_NAMED_ASSET_CLASS,
	_pcNames[idx++] = "$priz";			// IDX_NAMED_PRIZE_STR,
	_pcNames[idx++] = "^priz";			// IDX_NAMED_PRIZE_IMG,
	_pcNames[idx++] = "$news";			// IDX_NAMED_NEWS_STR
	_pcNames[idx++] = "^news";			// IDX_NAMED_NEWS_IMG
	_pcNames[idx++] = "$winr";			// IDX_NAMED_WINNER_STR
	_pcNames[idx++] = "^winr";			// IDX_NAMED_WINNER_IMG
	_pcNames[idx++] = "#reqt";			// IDX_NAMED_REQUEST_TIMEOUT
	_pcNames[idx++] = "#promoid";		// IDX_NAMED_PROMOTION_ID,
	_pcNames[idx++] = "^tbdata";			// IDX_NAMED_TBDATA
	_pcNames[idx++] = "^seed";			// IDX_NAMED_SEED

	_pcNames[idx++] = NULL;				// NUM_NAMES
	_numNames = idx-1;

	ASSERT(_numNames <= NUM_NAMES);

	idx = 0;
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "!!";
	_pResponseTypes[idx] = RESP_TYPE_INT32 ;	_pcResponseNames[idx++] = "#err";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$err";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$cert";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$rdir";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$sugg_name";
	_pResponseTypes[idx] = RESP_TYPE_INT64;		_pcResponseNames[idx++] = "*server";

	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$msum";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$tsum";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$sum";

	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$tour";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$descr";
	_pResponseTypes[idx] = RESP_TYPE_COMPOUND;	_pcResponseNames[idx++] = "[tours";
	_pResponseTypes[idx] = RESP_TYPE_HISTORY;	_pcResponseNames[idx++] = "[tlist";
	_pResponseTypes[idx] = RESP_TYPE_BINARY;	_pcResponseNames[idx++] = "^seed";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$param";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$news";
	_pResponseTypes[idx] = RESP_TYPE_BINARY;	_pcResponseNames[idx++] = "^news";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$winr";
	_pResponseTypes[idx] = RESP_TYPE_BINARY;	_pcResponseNames[idx++] = "^winr";
	_pResponseTypes[idx] = RESP_TYPE_INT32 ;	_pcResponseNames[idx++] = "#reqt";
	_pResponseTypes[idx] = RESP_TYPE_STRING;	_pcResponseNames[idx++] = "$promo";
	_pResponseTypes[idx] = RESP_TYPE_BINARY;	_pcResponseNames[idx++] = "^promo";
	_pResponseTypes[idx] = RESP_TYPE_INT32 ;	_pcResponseNames[idx++] = "#promonext";

	_pResponseTypes[idx] = RESP_TYPE_NONE  ;	_pcResponseNames[idx++] = NULL; //terminate
	_numResponses = idx-1;

	ASSERT(_numResponses <= NUM_RESPONSEITEMS);

	idx = 0;
	_pCompoundTypes[idx] = RESP_TYPE_INT32 ;	_pcCompoundNames[idx++] = "#ttyp";
	_pCompoundTypes[idx] = RESP_TYPE_STRING;	_pcCompoundNames[idx++] = "$tour";
	_pCompoundTypes[idx] = RESP_TYPE_STRING ;	_pcCompoundNames[idx++] = "$descr";
	_pCompoundTypes[idx] = RESP_TYPE_INT32 ;	_pcCompoundNames[idx++] = "#pid";
	_pCompoundTypes[idx] = RESP_TYPE_INT16 ;	_pcCompoundNames[idx++] = "#gtype";
	_pCompoundTypes[idx] = RESP_TYPE_INT32 ;	_pcCompoundNames[idx++] = "#gvers";
	_pCompoundTypes[idx] = RESP_TYPE_INT64 ;	_pcCompoundNames[idx++] = "*start";
	_pCompoundTypes[idx] = RESP_TYPE_INT64 ;	_pcCompoundNames[idx++] = "*end";
	_pCompoundTypes[idx] = RESP_TYPE_BINARY;	_pcCompoundNames[idx++] = "^seed";
	_pCompoundTypes[idx] = RESP_TYPE_STRING;	_pcCompoundNames[idx++] = "$param";
	_pCompoundTypes[idx] = RESP_TYPE_STRING;	_pcCompoundNames[idx++] = "$priz";
	_pCompoundTypes[idx] = RESP_TYPE_BINARY;	_pcCompoundNames[idx++] = "^priz";
	_pCompoundTypes[idx] = RESP_TYPE_STRING;	_pcCompoundNames[idx++] = "$tstat";
	_pCompoundTypes[idx] = RESP_TYPE_NONE  ;	_pcCompoundNames[idx++] = NULL; //terminate
	_numCompounds = idx-1;

	ASSERT(_numCompounds <= NUM_COMPOUNDITEMS);

	idx = 0;
	_pHistoryTypes[idx] = RESP_TYPE_STRING ;	_pcHistoryNames[idx++] = "$thdr";
	_pHistoryTypes[idx] = RESP_TYPE_STRING;		_pcHistoryNames[idx++] = "$tsum";
	_pHistoryTypes[idx] = RESP_TYPE_NONE  ;		_pcHistoryNames[idx++] = NULL; //terminate
	_numDetails = idx-1;

	ASSERT(_numDetails <= NUM_DETAILITEMS);

	for (idx=0; idx<NUM_RESPONSEITEMS; idx++)
	{
		_responseItem[idx].isSet = false;
		_responseItem[idx].i64 = 0;
		_responseItem[idx].data = NULL;
	}

	for (idx=0; idx<NUM_COMPOUNDS; idx++)
	{
		for (int jdx=0; jdx<NUM_COMPOUNDITEMS; jdx++)
		{
			_compoundItems[idx][jdx].isSet = false;
			_compoundItems[idx][jdx].i64 = 0;
			_compoundItems[idx][jdx].data = NULL;
		}
	}
	_isInCompound = false;
	_idxCompoundAtom = 0;

	ResetHistoryList();
	_isInHistory = false;
	_idxHistoryAtom = 0;

#ifdef _DEBUG
	_dbgIn = 0;
	_in = "";
#endif
}
//-----------------------------------------------------------------------------
TBMessages::~TBMessages()
{
	TRACE(( "~TBMessages" ));
	Stop();
}
//-----------------------------------------------------------------------------
bool TBMessages::Start()
{
	TRACE(( "TBMessages::Start()" ));

	if (_numNames > NUM_NAMES) return false;
	if (_numResponses > NUM_RESPONSEITEMS) return false;
	if (_numCompounds > NUM_COMPOUNDITEMS) return false;
	if (_numDetails > NUM_DETAILITEMS) return false;

	if (_pNameBuf) MEMFREE(_pNameBuf);
	if (_pStringBuf) MEMFREE(_pStringBuf);

	_pNameBuf = (char*)MEMALLOC(LEN_NAMEBUF);
	_pStringBuf = (char*)MEMALLOC(LEN_STRINGBUF);

	if (!_pNameBuf || !_pStringBuf)
	{
		DEBUG(( "TBMessages.Start(), ERROR: Failed to allocate buffers." ));
		Stop();
		return false;
	}
	return true;
}
//-----------------------------------------------------------------------------
void TBMessages::Stop()
{
	TRACE(( "TBMessages::Stop()" ));

	FreeMemory();

	MEMFREE(_pNameBuf);
	_pNameBuf = NULL;

	MEMFREE(_pStringBuf);
	_pStringBuf = NULL;
}


void TBMessages::FreeMemory()
{
	int idx, jdx;

	for (idx=0; idx<NUM_RESPONSEITEMS; idx++) {
		_responseItem[idx].isSet = false;
		_responseItem[idx].i64 = 0;
		if (_responseItem[idx].data) {
			MEMFREE(_responseItem[idx].data);
			_responseItem[idx].data = NULL;
		}
	}

	for (idx=0; idx<NUM_COMPOUNDS; idx++) {
		for (jdx=0; jdx<NUM_COMPOUNDITEMS; jdx++) {
			_compoundItems[idx][jdx].isSet = false;
			_compoundItems[idx][jdx].i64 = 0;
			if (_compoundItems[idx][jdx].data) {
				MEMFREE(_compoundItems[idx][jdx].data);
				_compoundItems[idx][jdx].data = NULL;
			}
		}
	}

	for (idx=0; idx<NUM_HISTORIES; idx++) {
		for (jdx=0; jdx<NUM_DETAILITEMS; jdx++) {
			_historyItems[idx][jdx].isSet = false;
			_historyItems[idx][jdx].i64 = 0;
			if (_historyItems[idx][jdx].data) {
				MEMFREE(_historyItems[idx][jdx].data);
				_historyItems[idx][jdx].data = NULL;
			}
		}
	}
}

//=============================================================================
//	ATOM COMPONENTS
//=============================================================================
//-----------------------------------------------------------------------------
uint32 TBMessages::WriteAtomHeader(IOStreamBuf& buf, int32 len, int32 type)
{
	uint32 mark = buf.Mark();

	DBGSTK_CHECK_LIGHT;

	buf << len;
	buf << type;

	return mark;
}
//-----------------------------------------------------------------------------
uint32 TBMessages::WriteNamedAtomHeader(IOStreamBuf& buf, int idxName)
{
	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_NAMED);

	DBGSTK_CHECK_LIGHT;

	ASSERT(idxName >= 0 && idxName < _numNames);
	if ((idxName >= 0) && (idxName < _numNames))
	{
		AtomText name(_pcNames[idxName]);
		buf << name;

		PRINTSHORTTEXT(_pcNames[idxName]);
	}
	return mark;
}
//=============================================================================
//	BASE ATOMS
//=============================================================================
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, AtomText& text)
{
	DEBUGWRITETEXT(( "TBMessages::WriteAtom(AtomText=\"%s\")", (text._pWriteChars?text._pWriteChars:"") ));
	PRINTSHORTTEXT(text._pWriteChars);
	DBGSTK_CHECK_LIGHT;

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_STRING);
	buf << text;

	DEBUGLEN(( "end of WriteAtom(AtomText), len=%d", buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, bool data)
{
	DEBUGWRITE(( "TBMessages::WriteAtom(bool = %d)",data ));
	ARMDEBUG(( "bool=%d",data ));
	DBGSTK_CHECK_LIGHT;

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_BOOL);
	buf << data;

	DEBUGLEN(( "end of WriteAtom(bool), len=%d", buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, int16 data)
{
	DEBUGWRITE(( "TBMessages::WriteAtom(int16 = 0x%04x = %d)",data,data ));
	ARMDEBUG(( "int16=%d",data ));
	DBGSTK_CHECK_LIGHT;

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_INT16);

	buf << data;
	//buf << HTOLES( data );

	DEBUGLEN(( "end of WriteAtom(int16), len=%d", buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, int32 data)
{
	DEBUGWRITE(( "TBMessages::WriteAtom(int32 = 0x%08x = %d)",data,data ));
	ARMDEBUG(( "int32=%d",data ));
	DBGSTK_CHECK_LIGHT;

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_INT32);

	buf << data;
	//buf << HTOLEL( data );

	DEBUGLEN(( "end of WriteAtom(int32), len=%d", buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, int64& data)
{
#if defined(_DEBUG)
	{
		int32* pLo = (int32*)&data;
		int32* pHi = pLo + 1;
		DEBUGWRITE(( "TBMessages::WriteAtom(int64 = 0x%08lx%08lx)",*pHi,*pLo ));
	}
#endif
	ARMDEBUG(( "int64=0x%016llx",data ));

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_INT64);

	#if defined(FEATURE_BIG_ENDIAN)
		if ( GETAEEVERSION( NULL, 0, 0 ) == 0x01020401 )
		{
			int32* pLoOrd = (int32*)&data;
			int32* pHiOrd = pLoOrd + 1;

			// Compensate for a bug in big endian runtime for
			// GETAEEVERSION 0x01020401.
			buf << *pLoOrd;
			buf << *pHiOrd;

			// This HTOLEL stuff might seem correct but I think we just have
			// to compensate for a bug in the brew 1.1 runtime libraries.
			// buf << HTOLEL( *pLoOrd );
			// buf << HTOLEL( *pHiOrd );

			DEBUG(( "TBMessages::WriteAtom int64 patch applied.\n" ));
		}else{
			buf << data;
		}
	#else
	    // Little endian including GETAEEVERSION 0x02010014
		buf << data;
	#endif

	DEBUGLEN(( "end of WriteAtom(int64), len=%d", buf.MarkLength(mark) ));
//	DEBUG(( "GETAEEVERSION returns 0x%x.\n", GETAEEVERSION( NULL, 0, 0 ) ));
	DBGLOGFLUSH;

	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteAtom(IOStreamBuf& buf, const void* data, int32 len)
{
	DEBUGWRITE(( "TBMessages::WriteAtom(binary)" ));
	DBGSTK_CHECK_LIGHT;

	uint32 mark = WriteAtomHeader(buf, LEN_DUMMY, TYPE_BINARY);
	buf.WriteBytes((const byte*)data, len);

	DEBUGLEN(( "end of WriteAtom(binary), len=%d", buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}


//=============================================================================
//	NAMED ATOMS
//=============================================================================
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, AtomText& text)
{
	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", AtomText)", _pcNames[idxName] ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, text);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", AtomText), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, bool data)
{
	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", bool)", _pcNames[idxName] ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, data);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", bool), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, int16 data)
{
	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", int16 = 0x%04x = %d)", _pcNames[idxName], data,data ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, data);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", int16), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, int32 data)
{
	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", int32 = 0x%08x = %ld)", _pcNames[idxName], data,data ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, data);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", int32), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, int64& data)
{
	DEBUG(("TBMessages::WriteNamedAtom(int64"));
	DEBUG(("%s,",_pcNames[idxName]));
	DEBUG(("%D)",data));

	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", int64)", _pcNames[idxName] ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, data);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", int64), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}
//-----------------------------------------------------------------------------
void TBMessages::WriteNamedAtom(IOStreamBuf& buf, int idxName, const void* data, int32 len)
{
	DEBUG(("TBMessages::WriteNamedAtom(int32,"));
	DEBUG(("%s,",_pcNames[idxName]));
	DEBUG(("%D)",data));

	ASSERT(idxName >= 0 && idxName < _numNames);
	DEBUGWRITE(( "TBMessages::WriteNamedAtom(\"%s\", void*)", _pcNames[idxName] ));

	uint32 mark = WriteNamedAtomHeader(buf, idxName);
	WriteAtom(buf, data, len);

	DEBUGLEN(( "end of WriteNamedAtom(\"%s\", void*), len=%d", _pcNames[idxName], buf.MarkLength(mark) ));
	buf.WriteUint32AtMark(mark, buf.MarkLength(mark));
}


//=============================================================================
//	SPECIFIC NAMED ATOMS
//=============================================================================
//-----------------------------------------------------------------------------
void TBMessages::WriteMessageID(IOStreamBuf& buf, int nMsgID)
{
	DEBUGWRITE(( " " ));
	DEBUGWRITE(( "TBMessages::WriteMessageID(ID=%d)",nMsgID ));

	//Create messageID
	SPRINTF(_pczMessageID, "%d", nMsgID);
	AtomText text(_pczMessageID); //AtomText_Init(text, _pczMessageID);

	WriteNamedAtom(buf, IDX_NAMED_MSGID, text);
}
//-----------------------------------------------------------------------------
void TBMessages::WriteMessageID(IOStreamBuf& buf)
{
	DEBUGWRITE(( " " ));
	DEBUGWRITE(( "TBMessages::WriteMessageID()" ));

	//Create messageID
	WriteMessageID(buf, ++_nMessageID);
}
//-----------------------------------------------------------------------------
void TBMessages::WriteMIN(IOStreamBuf& buf, const char* pcMIN)
{
	DEBUGWRITE(( " " ));
	DEBUGWRITE(( "TBMessages::WriteMIN()" ));

	AtomText text(pcMIN);

	WriteNamedAtom(buf, IDX_NAMED_MIN, text);
}


//=============================================================================
//	SPECIFIC PACKETS
//=============================================================================
//-----------------------------------------------------------------------------
void TBMessages::WritePrefsAtom(IOStreamBuf& buf, bool isOptIn)
{
	DEBUGWRITE(( " " ));
	DEBUGWRITE(( "TBMessages::WritePrefs()" ));
	//preferences
	//named atom
	uint32 markName = WriteNamedAtomHeader(buf, IDX_NAMED_PREFS);

	//nested packet
	uint32 markPacket = WriteAtomHeader(buf, LEN_DUMMY, TYPE_PREF);
	buf << (uint32)1;	//smsOptIn

	WriteNamedAtom(buf, IDX_NAMED_OPTIN, isOptIn);

	DEBUGLEN(( "end of WritePrefs(), len=%d", buf.MarkLength(markPacket) ));
	buf.WriteUint32AtMark(markPacket, buf.MarkLength(markPacket));

	DEBUGLEN(( "end of WritePrefs(), len=%d", buf.MarkLength(markName) ));
	buf.WriteUint32AtMark(markName, buf.MarkLength(markName));
}

//=============================================================================
//	REQUESTS
//=============================================================================

//-----------------------------------------------------------------------------
void * TBMessages::GetResponseData(int idxString, int& lenBuf)
{
	bool wasSet;
	return GetResponseData(idxString, lenBuf, wasSet);
}

//-----------------------------------------------------------------------------
void * TBMessages::GetResponseData(int idxString, int& lenBuf, bool& wasSet)
{
	wasSet = _responseItem[idxString].isSet;
	DEBUG(("idxString = %d, isSet = %d",idxString,wasSet));
	if (_responseItem[idxString].isSet)
	{
		_responseItem[idxString].isSet = false;
		lenBuf = _responseItem[idxString].i32;
		if (_responseItem[idxString].data == NULL) {
			DEBUG(( "ResponseItem[%d] was set but value was NULL!", idxString));
			return NULL;
		}
		else {
			return (void *)_responseItem[idxString].data;
		}
	}
	return NULL;
}

//-----------------------------------------------------------------------------
void TBMessages::FreeResponseData(int idxString)
{
	if(idxString < NUM_RESPONSEITEMS) 
	{
		_responseItem[idxString].isSet = false;
		_responseItem[idxString].i64 = 0;
		if (_responseItem[idxString].data) 
		{
			FREE(_responseItem[idxString].data);
			_responseItem[idxString].data = NULL;
		}
	}
}

//-----------------------------------------------------------------------------
bool TBMessages::GetErrorMessage(uint32 &nError, char* pErrorMessage, int lenBuf)
{
	bool found = false;

	if (_responseItem[IDX_RESP_ERRNUM].isSet)
	{
		_responseItem[IDX_RESP_ERRNUM].isSet = false;
		nError = _responseItem[IDX_RESP_ERRNUM].i32;
		found = true;

	}
	if (_responseItem[IDX_RESP_ERRMSG].isSet)
	{
		char* pMsg;
		int len;

		pMsg = (char *)GetResponseData(IDX_RESP_ERRMSG, len);

		if (len < lenBuf)
		{
			STRCPY(pErrorMessage, pMsg);
		}
		else
		{
			STRNCPY(pErrorMessage, pMsg, lenBuf);
			pErrorMessage[lenBuf-1] = '\0';
		}
		found = true;
	}

	DEBUGIF(nError) DEBUG(( "ERR %d = \"%s\"", nError, pErrorMessage ));

	return found;
}
//-----------------------------------------------------------------------------
int32 TBMessages::GetResponseType()
{
	return _responseType;
}
//-----------------------------------------------------------------------------
bool TBMessages::GetMsgID(uint32 &idMsg)
{
	if ((!_responseItem[IDX_RESP_MSGID].isSet) ||
		(_responseItem[IDX_RESP_MSGID].i32 > 32))
	{
		ARMDEBUG(( "ERROR: NO MSGID" ));
		idMsg = 0;
		return false;
	}

	idMsg = ATOI((char *)_responseItem[IDX_RESP_MSGID].data);
	ARMDEBUG(( "MSGID=%d",idMsg ));
	return true;
}
//-----------------------------------------------------------------------------
bool TBMessages::GetInt32(int idxItem, int32& i)
{
	if (_responseItem[idxItem].isSet) {
		i = _responseItem[idxItem].i32;
		return true;
	}
	else {
		i = 0;
		return false;
	}
}
//-----------------------------------------------------------------------------
char* TBMessages::GetRedirectURL()
{
	int len;
	
	char* redirectURL = (char *)GetResponseData(IDX_RESP_REDIRECT, len);

	if (redirectURL != NULL) {
		DEBUG(( "RedirectURL: %s", redirectURL ));
	}

	return redirectURL;
}
//-----------------------------------------------------------------------------
int64 TBMessages::GetServerTime()
{
	if (_responseItem[IDX_RESP_SERVER_TIME].isSet) {
		DEBUG(( "Server time=%Ld", _responseItem[IDX_RESP_SERVER_TIME].i64 ));
		return _responseItem[IDX_RESP_SERVER_TIME].i64;
	}
	else {
		DEBUG(( "Server time was not provided" ));
		return 0;
	}
}
//-----------------------------------------------------------------------------
bool TBMessages::GetTournament(int typeTournament, AMTPTournament& tour)
{
	DEBUGGET(( "TBMessages::GetTournament(): type=%d", typeTournament ));

	int len;
	for (int idx=0; idx<NUM_COMPOUNDS; idx++)
	{
		if ((!_compoundItems[idx][IDX_COMPOUND_TTYP].isSet) ||
			(_compoundItems[idx][IDX_COMPOUND_TTYP].i32 != typeTournament))
			continue;

		_compoundItems[idx][IDX_COMPOUND_TTYP].isSet = false;

		//ID
		if (_compoundItems[idx][IDX_COMPOUND_TOUR].isSet &&
			_compoundItems[idx][IDX_COMPOUND_TOUR].i32>0)
		{
			_compoundItems[idx][IDX_COMPOUND_TOUR].isSet = false;

			tour.CopyID((char *)_compoundItems[idx][IDX_COMPOUND_TOUR].data);
		}
		else
		{
			tour.CopyID(NULL);
		}

		// Description
		if (_compoundItems[idx][IDX_COMPOUND_DESCR].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_DESCR].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_DESCR].i32;
			tour.CopyDescription((char *)_compoundItems[idx][IDX_COMPOUND_DESCR].data, len);
		}
		else
		{
			tour.CopyDescription(NULL, 0);
		}

		// Prize string
		if (_compoundItems[idx][IDX_COMPOUND_PRIZE_STR].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_PRIZE_STR].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_PRIZE_STR].i32;
			tour.CopyPrizeStr((char *)_compoundItems[idx][IDX_COMPOUND_PRIZE_STR].data, len);
		}
		// If prize string is not set, use existing one (if any)

		// Prize image
		if (_compoundItems[idx][IDX_COMPOUND_PRIZE_IMG].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_PRIZE_IMG].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_PRIZE_IMG].i32;
			tour.CreatePrizeImg((byte *)_compoundItems[idx][IDX_COMPOUND_PRIZE_IMG].data, len);
		}
		// If prize image is not set, use existing one (if any)

		// Tournament status string
		if (_compoundItems[idx][IDX_COMPOUND_TOURNAMENT_STATUS_STR].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_TOURNAMENT_STATUS_STR].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_TOURNAMENT_STATUS_STR].i32;
			tour.CopyStatusStr((char *)_compoundItems[idx][IDX_COMPOUND_TOURNAMENT_STATUS_STR].data, len);
		}
		else
		{
			tour.CopyStatusStr(NULL, 0);
		}

		//Seed
		if (_compoundItems[idx][IDX_COMPOUND_SEED].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_SEED].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_SEED].i32;
			tour.CopySeed((byte*)_compoundItems[idx][IDX_COMPOUND_SEED].data, len);
		}
		else
		{
			tour.CopySeed((byte*)NULL, 0);
		}

		//Param
		if (_compoundItems[idx][IDX_COMPOUND_PARAM].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_PARAM].isSet = false;

			len = _compoundItems[idx][IDX_COMPOUND_PARAM].i32;
			tour.CopyParam((char*)_compoundItems[idx][IDX_COMPOUND_PARAM].data, len);
		}
		else
		{
			tour.CopyParam((char*)NULL, 0);
		}

		//StartDate
		if (_compoundItems[idx][IDX_COMPOUND_GAMESTART].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_GAMESTART].isSet = false;

			tour.SetStartDate(_compoundItems[idx][IDX_COMPOUND_GAMESTART].i64);
		}
		else
		{
			tour.SetStartDate(0);
		}

		//EndDate
		if (_compoundItems[idx][IDX_COMPOUND_GAMEEND].isSet)
		{
			_compoundItems[idx][IDX_COMPOUND_GAMEEND].isSet = false;

			tour.SetEndDate(_compoundItems[idx][IDX_COMPOUND_GAMEEND].i64);
		}
		else
		{
			tour.SetEndDate(0);
		}

		DEBUGGET(( "TBMessages::GetTournament(): Found ID=\"%s\"", tour.GetID() ));
		return true;
	}

	DEBUG(( "TBMessages::GetTournament() WARNING: ttyp=%d was not received in last response", typeTournament ));
	return false;
}
//-----------------------------------------------------------------------------
void TBMessages::ResetHistoryList()
{
	for (int idx=0; idx<NUM_HISTORIES; idx++)
	{
		for (int jdx=0; jdx<NUM_DETAILITEMS; jdx++)
		{
			_historyItems[idx][jdx].isSet = false;
			_historyItems[idx][jdx].i64 = 0;
			if (_historyItems[idx][jdx].data)
			{
				MEMFREE(_historyItems[idx][jdx].data);
				_historyItems[idx][jdx].data = NULL;
			}
		}
	}
}
//-----------------------------------------------------------------------------
char* TBMessages::GetHistoryHeader(int idx)
{
	DEBUGGET(( "TBMessages::GetHistoryHeader(): idx=%d", idx ));

	if ((!_historyItems[idx][IDX_HISTORY_HEADER].isSet)) {
		DEBUG(( "TBMessages::GetHistoryHeader() WARNING: header for idx=%d was not received in last response", idx ));
		return NULL;
	}

	//Header
	if (_historyItems[idx][IDX_HISTORY_HEADER].isSet &&
			_historyItems[idx][IDX_HISTORY_HEADER].i32>0)
	{
		return (char *)_historyItems[idx][IDX_HISTORY_HEADER].data;
	}
	else
	{
		return NULL;
	}
}
//-----------------------------------------------------------------------------
char* TBMessages::GetHistorySummary(int idx)
{
	DEBUGGET(( "TBMessages::GetHistorySummary(): idx=%d", idx ));

	if ((!_historyItems[idx][IDX_HISTORY_SUMMARY].isSet)) {
		DEBUG(( "TBMessages::GetHistorySummary() WARNING: summary for idx=%d was not received in last response", idx ));
		return NULL;
	}

	//Header
	if (_historyItems[idx][IDX_HISTORY_SUMMARY].isSet &&
			_historyItems[idx][IDX_HISTORY_SUMMARY].i32>0)
	{
		return (char *)_historyItems[idx][IDX_HISTORY_SUMMARY].data;
	}
	else
	{
		return NULL;
	}
}

//=============================================================================
//	PARSING
//=============================================================================
//-----------------------------------------------------------------------------
int32 TBMessages::GetResponseSize(IOStreamBuf& buf)
{
	int32 lenSoFar = buf.GetLength();
	if (lenSoFar < 4)
	{
		return 0;
	}

	//grab first long word in buffer and restore the buffer position
	int32 lenResp;
	buf.Seek(0);
	buf >> lenResp;
	buf.SeekEnd();

	return lenResp;
}
//-----------------------------------------------------------------------------
bool TBMessages::ParseResponse(IOStreamBuf& buf)
{
	DEBUG(( "TBMessages::ParseResponse(): len=%lu", buf.GetLength() ));
//	DEBUGSTACK();

	//clear the old message id
	_responseItem[IDX_RESP_MSGID].isSet = false;

	//read the response (should be in a single atom package)
	if (!ReadAtom(buf))
	{
		ARMDEBUG(( "PARSE ERROR" ));
		DEBUG(( "TBMessages::ParseResponse(): ERROR READING RESPONSE" ));

		uint32 offset = buf.Mark();
		uint32 length = buf.GetLength();
		int32 remainder = length - offset;
		DEBUG(( "Response buffer has %ld bytes remaining unread", remainder ));

		return false;
	}

	//the response should be completely consumed
	if (!buf.IsEmpty())
	{
		ASSERT(!("PARSE WARNING"));
		ARMDEBUG(( "PARSE IGNORE REMAINDER" ));
		DEBUGREAD(( "TBMessages::ParseResponse(): IGNORING REMAINDER IN BUFFER" ));

		return true;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadAtomHeader(IOStreamBuf& buf, int32& len, int32& type)
{
	DEBUG(("READ ATOM HEADER"));
	buf >> len;
	buf >> type;
	DEBUGREAD(( "%slen = %ld", _in, len ));
	DEBUGTYPE(type);

	//len is basically ignored throughout the parsing process
	ASSERT(len >= 8);
	ASSERT(len <= _lenMaxAtom);
	if (len > _lenMaxAtom) return false; //very rudimentary sanity check

	if(!buf.IsEmpty()) return true;
	return false;
}
//-----------------------------------------------------------------------------
int16 TBMessages::ReadAtomText(IOStreamBuf& buf, const int32 lenBuf, char* pcBuf)
{
	DEBUG(("READ ATOM TEXT"));
	uint8 encoding;
	int16 nChars;

	buf >> encoding;
	buf >> nChars;
	//ASSERT(lenAtom-11 == nChars);

	//read in the text
	int32 lenToRead = (nChars<lenBuf) ? nChars : lenBuf-1;
	DEBUG(("READ THE TEXT %d %d %d",  lenToRead, nChars, lenBuf));
	buf.ReadBytes((byte*)pcBuf, lenToRead);
	DEBUG(("aaaaa"));
	pcBuf[lenToRead] = '\0';
DEBUG(("READ THE TEXT2 %s", pcBuf));
	//DEBUGREAD(( "%sTBMessages::ReadAtomText(): text=\"%s\"", _in, pcBuf ));
	//DEBUGREADTEXT(( "%sencoding = 0x%x, nchars = %d, text = \"%s\"", _in, encoding, nChars, pcBuf ));
	DEBUGREADTEXT(( "%s\"%s\"", _in, pcBuf ));

#ifdef _ARMDEBUG
	if (STRLEN(pcBuf) > 24)
	{
		char ch = pcBuf[24];
		pcBuf[24] = '\0';
		ARMDEBUG(( "text=\"%s\"", pcBuf ));
		pcBuf[24] = ch;
	}
	else
	{
		ARMDEBUG(( "text=\"%s\"", pcBuf ));
	}
#endif

	//TODO: FIX THIS
	//for now, throw away the remainder
	if (lenToRead < nChars)
	{
		int8 ch;
		lenToRead = nChars - lenToRead;
		while (lenToRead-- > 0)
		{
			DEBUG(("READINT8"));
			buf.ReadInt8(ch);
		}
	}
	return nChars;
}

//-----------------------------------------------------------------------------
bool TBMessages::ReadAtom(IOStreamBuf& buf)
{
	DEBUGREAD(( "%sTBMessages::ReadAtom()", _in ));

	int32 lenAtom, typeAtom;
	ReadAtomHeader(buf, lenAtom, typeAtom);

	//for now, hardcode this stuff in a switch statement
	DEBUG(("READ ATOM SWITCH"));
	switch (typeAtom)
	{
		case TYPE_NAMED:
		{
			DEBUG(( "(named) " ));
			return ReadNamedBody(buf);
		}
		case TYPE_STRING:
		{
			DEBUG(( "(str) " ));

			int16 lenText = ReadAtomText(buf, LEN_STRINGBUF, _pStringBuf);

			DEBUG(( "%sIGNORED string \"%s\"", _in,_pStringBuf ));
			if (lenText < 0) return false;
			break;
		}
		case TYPE_BINARY:
		{
			DEBUG(( "(bin) " ));
			ASSERT(lenAtom > 8);

			buf.ReadBytes((byte*)_pStringBuf, lenAtom-8);

			DEBUG(( "%sIGNORED binary", _in ));
			//DBGLOG( "\n" );
			break;
		}
		case TYPE_BOOL:
		{
			bool bData;
			buf >> bData;
			DEBUG(( "%sIGNORED bool = %s", _in,(bData?"true":"false") ));
			DEBUG(( "\n" ));
			break;
		}
		case TYPE_INT8:
		{
			int8 data;
			buf >> data;
			DEBUG(( "%sIGNORED int8 = %c", _in, data ));
			//DBGLOG( "\n" );
			break;
		}
		case TYPE_INT16:
		{
			int16 data;
			buf >> data;
			DEBUG(( "%sIGNORED int16 = %d", _in, data ));
			//DBGLOG( "\n" );
			break;
		}
		case TYPE_INT32:
		{
			int32 data;
			buf >> data;
			DEBUG(( "%sIGNORED int32 = %ld", _in, data ));
			//DBGLOG( "\n" );
			break;
		}
		case TYPE_DATE:
		case TYPE_INT64:
		{
			int64 data;
			buf >> data;

#if defined(_DEBUG)
			{
				int32* pLo = (int32*)(&data);
				int32* pHi = pLo + 1; //little-endian means hi-order is higher

				DEBUG(( "%sIGNORED int64 = 0x%08lx%08lx", _in, *pHi, *pLo ));
			//	DEBUG(( "%sIGNORED int64 = 0x%016I64x", _in, data ));
			}
#endif
			//DBGLOG( "\n" );
			break;
		}
		case TYPE_LIST:
		{
			DEBUGPUSH();

			int idx;
			bool ok = ReadListBody(buf, idx);

			DEBUGPOP();
			//DBGLOG( "\n" );
			return ok;
		}
		case TYPE_RESP_REGISTER:
		case TYPE_RESP_AUTHENTICATE:
		case TYPE_RESP_ENTERTOURNEY:
		case TYPE_RESP_GETOPTIONS:
		case TYPE_RESP_GETSCORES:
		case TYPE_RESP_GETTOURNEYS:
		case TYPE_RESP_SETOPTIONS:
		case TYPE_RESP_GETPROMOTION:
		{
			_responseType = typeAtom;
		}
		// Fall through to code below...

		case TYPE_SEED:
//		case TYPE_PROMO:
		case TYPE_NEWS:
		case TYPE_RANK:
		case TYPE_TOURN:
		case TYPE_TOURNAMENT_DETAIL:
		{
			PRINTTYPE(typeAtom);
			DEBUGPUSH();

			int idx;
			bool ok = ReadMapBody(buf, idx);

			DEBUGPOP();
			//DBGLOG( "(misc-1)" );
			return ok;
		}
		case TYPE_RESP_REPORTSCORE:
		case TYPE_RESP_REPORTFORFEIT:
		{
			_responseType = typeAtom;

			PRINTTYPE(typeAtom);
			DEBUGPUSH();

			//Clear the summaries in case previous one was not yet used
			//i.e. don't want an old summary associated with this new response
			_responseItem[IDX_RESP_MATCHSUM].isSet = false;
			_responseItem[IDX_RESP_RANKSUM].isSet = false;

			int idx;
			bool ok = ReadMapBody(buf, idx);

			DEBUGPOP();
			//DBGLOG( "(report)\n" );
			return ok;
		}

		case TYPE_PACKAGE:
		{
			DEBUG(("PACKAGE"));
			DEBUG(("%d", typeAtom));
			int32 count;
			buf >> count;
			ASSERT(count<20);
			DEBUGIF(!count) DEBUG(( "%sCOUNT = 0", _in ));

			if (!buf.IsEmpty() && count--)
			{
				//this is the CRC atom
				if (!ReadAtom(buf))	return false;
				DEBUGREAD(( "%s   That was the CRC.", _in ));
			}
			int num = count;
			while (!buf.IsEmpty() && num--)
			{
				DEBUGREAD(( "%sPACK: %d of %d", _in, count-num, count ));
				if (!ReadAtom(buf)) return false;
			}
			//DBGLOG( "(package)\n" );
			break;
		}
		default:
			DEBUG(( "%sWARNING - IGNORING UNKNOWN TYPE = 0x%lx", _in,typeAtom ));
			ASSERT(lenAtom > 8);
			buf.ReadBytes((byte*)_pStringBuf, lenAtom-8);
			//DBGLOG( "(unrecognized type)\n" );
			break;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadNamedAtom(IOStreamBuf& buf)
{
	DEBUGREAD(( "TBMessages::ReadNamedAtom()" ));

	int32 len, type;
	ReadAtomHeader(buf, len, type);

	if (type != TYPE_NAMED)
	{
		//ARMDEBUG(( "NOT NAMED" ));
		DEBUG(( "TBMessages::ReadNamedAtom(): ERROR - NOT NAMED ATOM - TYPE = 0x%08lx", type ));
		return false;
	}

	return ReadNamedBody(buf);
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadNamedBody(IOStreamBuf& buf)
{
	//DEBUGREAD(( "TBMessages::ReadNamedBody()" ));

	int16 lenName = ReadAtomText(buf, LEN_NAMEBUF, _pNameBuf);

	return ReadNamedAtomData(buf);
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadNamedAtomData(IOStreamBuf& buf)
{
	if (!_pNameBuf || !*_pNameBuf)
	{
		DEBUG(( "TBMessages::ReadNamedAtomData(): ERROR - EMPTY NAME" ));
		return false;
	}

	DEBUGREAD(( "%sReadNamedAtomData(): NAME = \"%s\"", _in, _pNameBuf ));

	int idx=0, idxName=-1, nMax, nRank;
	int* pType;
	const char** ppName;
	ResponseItem* pItem;

	//setup for nested/non-nested lookup
	if (_isInCompound)
	{
		//DEBUGSET(( "TBMessages::ReadNamedAtomData(): inside compound atom" ));
		ppName = _pcCompoundNames;
		pType = _pCompoundTypes;
		nMax = _numCompounds;
		pItem = &_compoundItems[_idxCompoundAtom][0];
		nRank = _idxCompoundAtom;
	}
	else if (_isInHistory)
	{
		//DEBUGSET(( "TBMessages::ReadNamedAtomData(): inside history atom" ));
		ppName = _pcHistoryNames;
		pType = _pHistoryTypes;
		nMax = _numDetails;
		pItem = &_historyItems[_idxHistoryAtom][0];
		nRank = _idxHistoryAtom;
	}
	else
	{
		pItem = &_responseItem[0];
		ppName = _pcResponseNames;
		pType = _pResponseTypes;
		nMax = _numResponses;
		nRank = 0;
	}

	//find index of name in lookup table
	for (idx=0; idx<nMax; idx++)
	{
		//DEBUGSET(( "pList[%d]=0x%lx", idx, ppName[idx] ));

		if (ppName[idx])
		{
			//DEBUGSET(( "%s",ppName[idx] ));

			if (!STRCMP(ppName[idx], _pNameBuf))
			{
				idxName = idx;
				break;
			}
		}
	}
	if ((idxName < 0) || (idxName > nMax))
	{
		ARMDEBUG(( "%s IS UNKNOWN",_pNameBuf ));
		DEBUG(( "TBMessages::ReadNamedAtomData(): WARNING - UNKNOWN NAME %s", _pNameBuf ));

		DEBUGIF(pType == _pResponseTypes) DEBUG(( "WARNING reading regular response names list" ));
		DEBUGIF(pType == _pCompoundTypes) DEBUG(( "WARNING reading tournaments list" ));
		DEBUGIF(pType == _pHistoryTypes) DEBUG(( "WARNING reading history list" ));

		//name was not recognized -- try to skip it by reading the enclosed atom
		return ReadAtom(buf);
	}

	int32 lenAtom, typeAtom;
	ReadAtomHeader(buf, lenAtom, typeAtom);

	//DBGLOG( "(" );
	//DBGLOG( ppName[idxName] );
	//DBGLOG( " data) " );

	//lookup the type of atom data to read
	switch (pType[idxName])
	{
//TODO need error checking here
		case RESP_TYPE_BINARY:
		{
			ASSERT(typeAtom == TYPE_BINARY);
			PRINTTYPE(typeAtom);
			DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(%s): BINARY", _in,_pNameBuf ));
			//DBGLOG( "(bin type) " );

			ASSERT(lenAtom > 8);

			buf.ReadBytes((byte*)_pStringBuf, lenAtom-8);

			//kill old data
			if (pItem[idxName].data)
			{
				MEMFREE(pItem[idxName].data);
			}
			//save new data
			byte* temp = (byte*)MEMALLOC(lenAtom-8);
			if (temp)
			{
				MEMCPY(temp, _pStringBuf, lenAtom-8);
			}
			pItem[idxName].isSet = TRUE;
			pItem[idxName].i32 = lenAtom-8;
			pItem[idxName].data = (void*)temp;
			DEBUGSET(( "%s   %d-%d) %s: len=%d, binary",_in,nRank,idxName,_pNameBuf,lenAtom-8 ));
			break;
		}
		case RESP_TYPE_STRING:
		{
			ASSERT(typeAtom == TYPE_STRING);
			PRINTTYPE(typeAtom);
			DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(%s): STRING", _in,_pNameBuf ));
			//DBGLOG( "(str type) " );

			int16 lenText = ReadAtomText(buf, LEN_STRINGBUF, _pStringBuf);

			//kill old string
			if (pItem[idxName].data)
			{
				MEMFREE(pItem[idxName].data);
			}
			//save new string
			char* temp = (char*)MEMALLOC(lenText+1);
			if (temp)
			{
				STRNCPY(temp, _pStringBuf, lenText);
				temp[lenText] = '\0';
			}
			pItem[idxName].isSet = TRUE;
			pItem[idxName].i32 = lenText;
			pItem[idxName].data = (void*)temp;
			DEBUGSET(( "%s   %d-%d) %s: len=%d, \"%s\"",_in,nRank,idxName,_pNameBuf,lenText,temp ));
			break;
		}
		case RESP_TYPE_INT16:
		{
			ASSERT(typeAtom == TYPE_INT16);
			PRINTTYPE(typeAtom);
			int16 data;
			buf >> data;
			DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(%s): INT16 = 0x%04x = %d", _in,_pNameBuf,data,data ));
			//DBGLOG( "(int16 type) " );

			pItem[idxName].isSet = TRUE;
			pItem[idxName].i16 = data;
			pItem[idxName].data = (void*)NULL;
			DEBUGSET(( "%s   %d-%d) %s: int16=%d",_in,nRank,idxName,_pNameBuf,data ));
			break;
		}
		case RESP_TYPE_INT32:
		{
			ASSERT(typeAtom == TYPE_INT32);
			PRINTTYPE(typeAtom);
			int32 data;
			buf >> data;
			DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(%s): INT32 = 0x%08lx = %d", _in,_pNameBuf, data,data ));
			//DBGLOG( "(int32 type) " );

			pItem[idxName].isSet = TRUE;
			pItem[idxName].i32 = data;
			pItem[idxName].data = (void*)NULL;
			DEBUGSET(( "%s   %d-%d) %s: int32=%d",_in,nRank,idxName,_pNameBuf,data ));
			break;
		}
		case RESP_TYPE_INT64:
		{
			PRINTTYPE(typeAtom);
			int64 data;
			buf.ReadInt64(data); //buf >> data;

#if defined(_DEBUG) || defined (_ARMDEBUG)
			{
				int32* pLo = (int32*)(&data);
				int32* pHi = pLo + 1; //little-endian means hi-order is higher

				ARMDEBUG(( "%s=0x%016llx",_pNameBuf,data ));
				DEBUGI64(( "%s=0x%08lx%08lx",_pNameBuf,*pHi,*pLo ));

				if (typeAtom == TYPE_DATE)
				{
/*
					char strDate[64];
					Date::getJulianDate(data, strDate);
					ARMDEBUG(( "date=%s",strDate ));
					DEBUGSET(( "%s   %d-%d) %s: int64=0x%08lx%08lx (%s)",_in,nRank,idxName,_pNameBuf,*pHi,*pLo,strDate ));
*/
				}
				else if (!*pHi)
				{
					DEBUGSET(( "%s   %d-%d) %s: int64=0x%08lx%08lx (%ld)",_in,nRank,idxName,_pNameBuf,*pHi,*pLo,*pLo ));
				}
				else
				{
					DEBUGSET(( "%s   %d-%d) %s: int64=0x%08lx%08lx",_in,nRank,idxName,_pNameBuf,*pHi,*pLo ));
				}
			}
			//DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(): INT64 = 0x%016I64x", _in, data ));
#endif
			//DBGLOG( "(int64 type) " );

			pItem[idxName].isSet = TRUE;
			pItem[idxName].i64 = data;
			pItem[idxName].data = (void*)NULL;
			break;
		}
		case RESP_TYPE_ATOM:
		{
			PRINTTYPE(typeAtom);
			DEBUGREAD(( "%sTBMessages::ReadNamedAtomData(): ATOM", _in ));
			//DBGLOG( "(atom type) " );
			return ReadAtom(buf);
		}
		case RESP_TYPE_PACKET:
		{
			PRINTTYPE(typeAtom);
			int32 count;
			buf >> count;
			ASSERT(count<20);
			DEBUGIF(!count) DEBUG(( "%sCOUNT = 0", _in ));
			//DBGLOG( "(pk type) " );

			int num = count;
			while (!buf.IsEmpty() && num--)
			{
				DEBUGREAD(( "%sPACKET: %d of %d", _in, count-num, count ));
				ARMDEBUG(( "PACKET: %d of %d", count-num, count ));

				if (!ReadAtom(buf)) return false;
			}
			break;
		}

		case RESP_TYPE_COMPOUND:
		{
			//DBGLOG( "(compound type) " );
			PRINTTYPE(typeAtom);
			DEBUGPUSH();
			_isInCompound = true;

			bool ok = ReadListBody(buf, _idxCompoundAtom);

			_isInCompound = false;
			DEBUGPOP();
			return ok;
		}
		case RESP_TYPE_HISTORY:
		{
			//DBGLOG( "(hist type) " );
			PRINTTYPE(typeAtom);
			DEBUGPUSH();

			ResetHistoryList();

			_isInHistory = true;
			bool ok = ReadListBody(buf, _idxHistoryAtom);
			_isInHistory = false;
			DEBUGPOP();
			return ok;
		}
		default:
			DEBUG(( "%sWARNING - IGNORING UNKNOWN NAMED TYPE = 0x%lx", _in,typeAtom ));
			//DBGLOG( "(unknown type) " );
			ASSERT(lenAtom > 8);
			buf.ReadBytes((byte*)_pStringBuf, lenAtom-8);
			break;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadListBody(IOStreamBuf& buf, int& idx)
{
	DEBUGREAD(( "%sTBMessages::ReadListBody()",_in ));

	int32 count, num;
	buf >> count;
	ASSERT(count<20);
	DEBUGIF(!count) DEBUG(( "%sCOUNT = 0", _in ));

	idx = 0;
	num = count;
	while (!buf.IsEmpty() && num--)
	{
		DEBUGREAD(( "%sLIST: %d of %d", _in,count-num,count ));
		ARMDEBUG(( "LIST: %d of %d",count-num,count ));

		if (!ReadAtom(buf)) return false;

		idx++;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool TBMessages::ReadMapBody(IOStreamBuf& buf, int& idx)
{
	DEBUGREAD(( "%sTBMessages::ReadMapBody()",_in ));

	int32 count, num;
	buf >> count;
	ASSERT(count<20);
	DEBUGIF(!count) DEBUG(( "%sCOUNT = 0", _in ));

	idx = 0;
	num = count;
	while (!buf.IsEmpty() && num--)
	{
		DEBUGREAD(( "%sMAP: %d of %d", _in,count-num,count ));
		ARMDEBUG(( "MAP: %d of %d", count-num,count ));

		if (!ReadNamedAtom(buf)) return false;

		idx++;
	}
	return true;
}

