#ifndef _TB_COMPLIANCE_H_
#define _TB_COMPLIANCE_H_

#include "..\Core\ITBMenuControls.h"
#include "..\Core\ITBMenuEventListener.h"
#include "..\Core\ITBClientControls.h"
#include "..\Core\ITBClientEventListener.h"
#include "..\Core\TBC.h"
#include "..\..\src\BrewString.h"
#include "..\..\src\BrewVector.h"
#include "..\..\src\aImage.h"
#include "TBStringFactory.h"
#include "AEEAppGen.h"

// Other Definitions
#define ANIMATION_TICKS_PER_SECOND 5
#define ANIMATION_TEXT_CYCLE_TIME 2 // seconds
#define HEAP_FILL_SIZE 15000 // 15 kb ceiling

class TBCompliance:
	public ITBMenuControls,
	public ITBClientControls
{
	AEEApplet* myMain;
	TBStringFactory* strings;
	ITBClientEventListener* clientTrigger;
	ITBMenuEventListener* menuTrigger;
	
	int moduleState;
	int menuState;
	bool isGameRunning;
	bool isRunning;
	
	// Heap Test array
	Bbyte heapFill;
	
	// IMAGE TEST controls
	int animationState;

	Image* animationImages[8];
	Image* titleImage;

	// TEXT TEST controls
	String inputText;
	int dynamicTextCounter;
	UINT dynamicTextIndex;
	Bint dynamicTextOptions;
	Bint sizeOptions;
	int sizeOptionIndexSelected;
	
	// PROGRESS TEST controlls
	int progressState;
	Bint progressRateOptions;
	int progressRateIndexSelected;
	
	// Client controls
	int curScore;
	byte fpClientControlLock;

public:
	TBCompliance(AEEApplet* app,byte localizationCode);
	void Release();

	bool notifyModule(int code, int data);

	bool menuCommand(int menuCommandData);

	bool menuInput(int menuId, int menuEntryIndex, int menuEntryType, int entryData, String entryText);

	String getScreenName(int screenState);

	bool setMenu(int newScreenState);

	void update(int menuState);

	void setRun(bool state);

	static void run(TBCompliance* pTBC);

	void menuTick (){};

};


#endif _TB_COMPLIANCE_H_
