/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#include "AMTPGameResult.h"

//-----------------------------------------------------------------------------
//	dtor, ctor, copy ctor, operator=
//-----------------------------------------------------------------------------
AMTPGameResult::~AMTPGameResult()
{
	Reset();
}
//-----------------------------------------------------------------------------
void AMTPGameResult::Reset()
{
	SetForfeit(false);

	if (_pData)
	{
		MEMFREE(_pData);
		_pData = NULL;
		_lenData = 0;
	}
}
//-----------------------------------------------------------------------------
AMTPGameResult::AMTPGameResult()
	: _pData(NULL)
	, _lenData(0)
	, _score(0)
	, _timeStart(0)
	, _timeEnd(0)
	, _isForfeit(false)
{
}
//-----------------------------------------------------------------------------
AMTPGameResult::AMTPGameResult(const AMTPGameResult& copy)
{
	CopyData(copy._pData, copy._lenData);
	_score = copy._score;
	_timeEnd = copy._timeEnd;
	_timeStart = copy._timeStart;
	_isForfeit = copy._isForfeit;
}
//-----------------------------------------------------------------------------
AMTPGameResult& AMTPGameResult::operator=(const AMTPGameResult& copy)
{
	CopyData(copy._pData, copy._lenData);
	_score = copy._score;
	_timeEnd = copy._timeEnd;
	_timeStart = copy._timeStart;
	_isForfeit = copy._isForfeit;
	return *this;
}

//-----------------------------------------------------------------------------
void AMTPGameResult::CopyData(const byte* pData, int32 lenData)
{
	MEMFREE(_pData);
	_pData = NULL;
	_lenData = 0;

	if (lenData > 0)
	{
		_pData = (byte*)MEMALLOC(lenData);
		if (_pData)
		{
			MEMCPY(_pData, pData, lenData);
			_lenData = lenData;
		}
	}
}

//-----------------------------------------------------------------------------
#ifdef _DEBUG
void AMTPGameResult::Debug(const char* prefix) const
{
	//int32* pLo = (int32*)&_seed;
	//int32* pHi = pLo + 1; //little-endian means hi-order is higher

	//DEBUG(( "%s: %s, seed=0x%08lx%08lx", prefix,_id,*pHi,*pLo ));
	DEBUG(( "%s: %ld", prefix, _score ));
}
#endif
