/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPTOURNAMENT_H
#define AMTPTOURNAMENT_H

#include "AMTPFramework.h"


class AMTPTournament
{
public:
	enum { LEN_ID = 32 };

	~AMTPTournament();
	AMTPTournament();
	AMTPTournament(const AMTPTournament& copy);
	AMTPTournament& operator=(const AMTPTournament& copy);

	void Reset();

	//mutators
	void CopyID(const char* pID);
	void SetEndDate(const int64& date) { _dateEnd = date; }
	void SetStartDate(const int64& date) { _dateStart = date; }

	//accessors
	const char* GetID() const { return &_id[0]; }
	const int64& GetEndDate() const { return _dateEnd; }
	const int64& GetStartDate() const { return _dateStart; }

protected:
	int64 _dateStart;
	int64 _dateEnd;
	int _lenParam;
	char _id[LEN_ID];

public:
	char * _descriptionStr;
	void CopyDescription(const char* descriptionStr, int32 len);
	char * GetDescription();

	char * _prizeStr;
	void CopyPrizeStr(const char* prizeStr, int32 len);
	char * GetPrizeStr();

	ConvertedBitmapInfo _prizeBitmapInfo;
	void CreatePrizeImg(byte* rawImgData, int32 rawImgSize);
	ConvertedBitmapInfo * GetPrizeImg();

	char * _statusStr;
	void CopyStatusStr(const char* statusStr, int32 len);
	char * GetStatusStr();

	byte * _pSeed;
	int _lenSeed;
	void CopySeed(const byte* pSeed, int32 lenSeed);
	byte * GetSeed(int32* lenSeed);


public:
#ifdef PARAM_IS_BINARY

	byte* _pParam;
	void CopyParam(const byte* pParam, int32 lenParam);
	const byte* GetParam(int32* lenParam) const { *lenParam = _lenParam; return _pParam; }

#else

	char* _pParam;
	void CopyParam(const char* pParam, int32 lenParam);
	const char* GetParam() const { return _pParam; }

#endif
};


#endif //AMTPTOURNAMENT_H
