/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef CFGFILE_H
#define CFGFILE_H

#include "AMTPFramework.h"
#include "FileReader.h"

class CfgFile
{
protected:
	FileReader* _pFileReader;

public:
	CfgFile();
	~CfgFile() { Stop(); }

	bool Start(const char* pczFilename, bool isWritable=false);
	bool Restart(const char* pczFilename, bool isWritable=false);
	void Stop();
	void Rewind();

	char* GetString(const char* pczName, char* pcBuf=NULL, int lenBuf=0);
	bool GetBool(const char* pczName, bool& value);
	bool SetBool(const char* pczName, bool value);
	bool SetByte(const char* pczName, byte value);

	bool FindToken(const char* pczName);
};

#endif //CFGFILE_H
