#ifndef _FOR_PRIZE_TESTBED_H_
#define _FOR_PRIZE_TESTBED_H_

#include "AEEAppGen.h"
#include "AEE.h"

#include "..\..\Core\ITBMenuControls.h"
#include "..\..\Core\ITBClientControls.h"
#include "..\..\Core\ITBClientEventListener.h"
#include "..\..\Core\ITBMenuEventListener.h"
#include "..\..\..\src\BrewString.h"
#include "..\..\..\src\BrewVector.h"
#include "..\..\Std\Helpers.h"
#include "FPCStringsTestbed.h"
#include "FPCMenusTestbed.h"
#include "ForPrizesAdapterConstantDefinitions.h"
#include "CarrierAdapter.h"
#include "ForPrizesAdapter.h"
#include "..\..\..\src\aImage.h"
#include "..\..\Core\ITBStringFactory.h"

class ForPrizeTestbed:
	public ITBMenuControls,
	public ITBClientControls
{
	
	static bool fwcanceledLoading;
public:
	static int FORPRIZE_NAME_FIELD_MAX_SIZE; // 10;
	// The Parameters for the ForPrizesModule are stored as these JAD keys
	static String* FORPRIZE_PARAM_CARRIER; // "ForPrize-Carrier";
	static String* FORPRIZE_PARAM_GAME_ID; // "ForPrize-Game-Id";
	static String* FORPRIZE_PARAM_GAME_VERSION; // "ForPrize-Game-Version";
	static String* FORPRIZE_PARAM_SERVER; // "ForPrize-Server";
	static String* FORPRIZE_PARAM_ASSET_CLASS; // "ForPrize-Asset-Class";
	static String* FORPRIZE_PARAM_MIN; // "ForPrize-Min-Num";
	static String* FORPRIZE_PARAM_COUNTRYCODE; // "ForPrize-Country-Code";
	static String* FORPRIZE_PARAM_SUB_PRICE; // "ForPrize-Sub-Price";
	static String* FORPRIZE_PARAM_SUB_LENGTH; // "ForPrize-Sub-Length";
	static String* FORPRIZE_PARAM_SUB_REQ_URL; // "Forprize-Sub-ReqUrl";
	static String* FORPRIZE_PARAM_RECORD_STORE_ACCOUNT; // "ForPrize-Store-Account";
	static String* FORPRIZE_PARAM_RECORD_STORE_BILLING; // "ForPrize-Store-Billing";
	static String* FORPRIZE_PARAM_ISREGISTERED;
	static String* FORPRIZE_PARAM_ISSMSOPTIN;
	static class ForPrizeTestbed* self;
	bool requestCancelled;
	bool reloadTournaments;
private:
	ITBStringFactory* strings;
	class CarrierAdapter* carrierAdapter;
	ITBClientEventListener* clientTrigger;
	ITBMenuEventListener* menuTrigger;
	
	int moduleState;
	int menuState;
	bool isReplay;
	bool isGameRunning;
	
	// Client controls
	int curScore;
	
	// Adapter Controls
	class ForPrizesAdapter* fpa;
	int postRegistrationAdvanceGameState;
	int actionID;
	String fpHeaderString;
	
	int fpTypeScore;
	byte fpTypeTournament;
	bool alreadyEntered;
	
	//Adi selected turnament in history
	int fpTurnamentHistoryIndex;
	bool fpTournAvailFlag;
	
	
	//Adi score text
	String textScore;
	
	// Error Screen controls
	int errorBackState;
	int errorForeState;
	String errorTitleString;
	String errorContentsString;
	int lastNetworkAction;
	String fpTournamentParameters;
	bool menuTickOn;
	int menuStateAfterTick;
	bool fromMenuTick;
	bool promoInReplay;
	bool promoInWelcome;
	
	VoidVector eventList;

public:
	ForPrizeTestbed();
	ForPrizeTestbed(AEEApplet* main);
	void release();

	bool notifyModule(int code, int data);

	bool menuCommand(int menuCommandData);

	bool menuInput(int menuId, int menuEntryIndex, int menuEntryType, int entryData, String entryText);

	String getScreenName(int screenState);

	bool setMenu(int newScreenState);

	bool setDynamicMenu(int newScreenState,ConvertedBitmapInfo* dynamicMenuImage, String dynamicMenuString);

	/**
	 * General Handler Replaced with setErrorMenu() calls - ESC
	void handleGeneralError();
	*/

	void setErrorMenu(int errorTitle, int errorContents, int backState, int foreState);

	bool doNetworkTransaction( int actionID );
	

	// AW: Replaces ForPrizeNetworkAction
	void handleNetworAction();

	static boolean ForPrizeTestbed_HandleEvent(void *pApp, AEEEvent eCode, uint16 wParam, uint32 dwParam);
private:
	class ForPrizeNetworkAction {
	public:
		ForPrizeNetworkAction(int newActionID) { 
			ForPrizeTestbed::self->actionID = newActionID; 
		}
		static bool run;

		static void stop();

		static void _run(ForPrizeTestbed * pUser);
	};
public:
	void fpProgress( int percentComplete );

	void getScoresRegistrationCheck();

	void notifyClient(int code, Bbyte data);

	void menuTick();

	bool menuCommandActionFore();

	bool menuCommandActionBack();

};

#endif