#ifndef _FOR_PRIZES_ADAPTER_CONSTANT_DEFINITIONS_H_
#define _FOR_PRIZES_ADAPTER_CONSTANT_DEFINITIONS_H_

	// Network Action IDS
	#define LOAD_ACTION_FP_GET_TOURNAMENTS 	 -100 
	#define LOAD_ACTION_FP_REGISTER 			 -101 
	#define LOAD_ACTION_FP_ENTER_TOURNAMENT	 -102 
	#define LOAD_ACTION_FP_REPORT_GAME_SCORE  -103 
	#define LOAD_ACTION_FP_GET_SCORES 		 -104 
	#define LOAD_ACTION_FP_GET_PROMO		  -105 
	#define LOAD_ACTION_FP_GET_TERMSANDCONDITION	- 106
	
	//	 Parameters
	// Asset classes
	#define PARAM_ASSET_CLASS_TEXT_ONLY   0  
	#define PARAM_ASSET_CLASS_LARGE   2  
	#define PARAM_ASSET_CLASS_SMALL   4  
	
	// Basic Error Codes
	#define PARAM_ERR_NONE   0  
	#define PARAM_ERR_TIMEOUT   1  
	#define PARAM_ERR_CLIENT_BUSY   2  
	#define PARAM_ERR_REQUEST_ABORTED   3  
	
	// Base system errors
	#define PARAM_ERR_T4P_SYSTEM_UNAVAILABLE   10000  
	#define PARAM_ERR_T4P_ILLEGAL_OPERATION   10001  
	#define PARAM_ERR_T4P_DATABASE_ERROR   10002  
	#define PARAM_ERR_T4P_INVALID_MIN   10003  
	#define PARAM_ERR_T4P_SECURITY_ERROR   10004  
	#define PARAM_ERR_T4P_PRICEPLAN_ERROR   10005  
	
	// Carrier IDs 
	#define PARAM_CARRIER_ID_SPRINT   1  
	#define PARAM_CARRIER_ID_CINGULAR   3  
	#define PARAM_CARRIER_ID_VODAFONE_DE   4  
	#define PARAM_CARRIER_ID_T_MOBILE   5  

	#define PARAM_CARRIER_ID_VIRGIN   7  

	
	// Client software errors
	#define PARAM_ERR_T4P_UNKNOWN_CLIENT_SOFTWARE   11000  
	#define PARAM_ERR_T4P_OBSOLETE_CLIENT_SOFTWARE   11001  
	#define PARAM_ERR_T4P_OBSOLETE_GAME   11002  
	
	// Registration errors
	#define PARAM_ERR_T4P_ACCOUNT_ALREADY_EXISTS   12000  
	#define PARAM_ERR_T4P_ACCOUNT_NOT_FOUND   12001  
	#define PARAM_ERR_T4P_ACCOUNT_USER_NAME_MISMATCH   12002  
	#define PARAM_ERR_T4P_INVALID_USER_NAME   12003  
	#define PARAM_ERR_T4P_EXISTING_USER_NAME   12004  
	#define PARAM_ERR_T4P_ACCOUNT_CREATION_REQUIRED   12005  
	#define PARAM_ERR_T4P_ACCOUNT_PIN_REQUIRED   12010  
	#define PARAM_ERR_T4P_ACCOUNT_PIN_INVALID   12011  
	#define PARAM_ERR_T4P_ACCOUNT_PASSWORD_INVALID   12012  
	#define PARAM_ERR_T4P_PHONE_NOT_SUPPORTED   12013  
	#define PARAM_ERR_T4P_SUBSCRIPTION_EXPIRED   12014  
	#define PARAM_ERR_UNKNOWN_CARRIER   12015  
	    
	// Subscription errors
	#define PARAM_ERR_SUBSCRIPTION_CHECK    13000  
	#define PARAM_ERR_SUBSCRIPTION_CONFIRM    13001  
	
	// Tournament errors
	#define PARAM_ERR_T4P_TOURNAMENT_ENTER_REJECTED   12006  
	#define PARAM_ERR_T4P_TOURNAMENT_SCORE_REJECTED   12007  
	
	// Game IDs
	#define PARAM_GAME_PRIZE21   1  
	#define PARAM_GAME_SOLITAIRE   2  
	#define PARAM_GAME_GOLF_SOLITAIRE   3  
	#define PARAM_GAME_SWITCHIX   4  
	#define PARAM_GAME_TETRIS   5  
	#define PARAM_GAME_HEMPOKER   6  
	#define PARAM_GAME_QBZ   7  
	#define PARAM_GAME_WOF   8  
	#define PARAM_GAME_BDTFP   9  
	#define PARAM_GAME_MSPAC   10  
	#define PARAM_GAME_WHOOSH   11  
	#define PARAM_GAME_AMF   12  
	#define PARAM_GAME_TRICKSHOT_POOL   14  
	#define PARAM_GAME_PUB_POOL3   15  	
	#define PARAM_GAME_FROGGER   20  
	
	// Game IDs
	#define PARAM_GAME_TEST   9999  

	// Number of times to try sending data. in the run() method
	#define PARAM_MAX_RETRY_COUNT   3  

	// Size of the buffer that sends data to the server
	#define PARAM_SEND_BUFFER_SIZE   1024  

	// Quark Responses 
	#define PARAM_QUARK_RESPONSE_REGISTER   1001  
	#define PARAM_QUARK_RESPONSE_GET_TOURNAMENTS   1003  
	#define PARAM_QUARK_RESPONSE_ENTER_TOURNAMENT   1005  
	#define PARAM_QUARK_RESPONSE_REPORT_SCORE   1007  
	#define PARAM_QUARK_RESPONSE_GET_SCORES   1009  
	#define PARAM_QUARK_RESPONSE_SET_OPTIONS   1011  
	#define PARAM_QUARK_RESPONSE_SUBSCRIPTION_CHECK   1013  
	#define PARAM_QUARK_RESPONSE_RESUBSCRIBE_CONFIRM   1015  
	
	#define PARAM_QUARK_RESPONSE_GET_PROMO	  1019 
	    
	// only used by vodafone registration
	#define PARAM_QUARK_RESPONSE_RESUBSCRIBE_REQUEST1   -1  
	#define PARAM_QUARK_RESPONSE_RESUBSCRIBE_COMPLETE   -3  	    
	    
	// Quark Requests
	#define PARAM_QUARK_REQUEST_REGISTER   1000  
	#define PARAM_QUARK_REQUEST_GET_TOURNAMENTS   1002  
	#define PARAM_QUARK_REQUEST_ENTER_TOURNAMENT   1004  
	#define PARAM_QUARK_REQUEST_REPORT_SCORE   1006  
	#define PARAM_QUARK_REQUEST_GET_SCORES   1008  
	#define PARAM_QUARK_REQUEST_SET_OPTIONS   1010  
	#define PARAM_QUARK_REQUEST_SUBSCRIPTION_CHECK   1012  
	#define PARAM_QUARK_REQUEST_RESUBSCRIBE_CONFIRM   1014  
	#define PARAM_QUARK_REQUEST_PROMO				  1018 
	
	
	// Added dummy request for the billing module.  This to utilize the run()
	// loop for all HTTP network connection related transactions including non
	// quark ones.  Its a hack but not much time for Vodafone DE.
	#define PARAM_QUARK_REQUEST_RESUBSCRIBE_REQUEST1   -2  
	#define PARAM_QUARK_REQUEST_RESUBSCRIBE_REQUEST2   -4  
	
	// Quark Types
	#define PARAM_QUARK_ENCRYPTION_TAG   -55 
	#define PARAM_QUARK_EOR   -1  
	#define PARAM_QUARK_EOT   -2  
	#define PARAM_QUARK_ERROR   2  
	#define PARAM_QUARK_REQUEST_TIMEOUT   3  
	#define PARAM_QUARK_ASSET_CLASS   10  
	#define PARAM_QUARK_PREFS_SMS_OPT_IN   11  
	#define PARAM_QUARK_SUGGESTED_NAME   12  
	#define PARAM_QUARK_SUGGESTED_MIN   13  
	#define PARAM_QUARK_SUGGESTED_CERT   14  
	#define PARAM_QUARK_WINNER_IMAGE   20  
	#define PARAM_QUARK_WINNER_TEXT   21  
	#define PARAM_QUARK_NEWS_IMAGE   22  
	#define PARAM_QUARK_NEWS_TEXT   23  
	#define PARAM_QUARK_TOURNAMENT_H2H   30  
	#define PARAM_QUARK_TOURNAMENT_PROGRESSIVE   31  
	#define PARAM_QUARK_TOURNAMENT_PRIZE_TEXT   32  
	#define PARAM_QUARK_TOURNAMENT_PRIZE_IMAGE   33  
	#define PARAM_QUARK_TOURNAMENT_SEED   34  
	#define PARAM_QUARK_TOURNAMENT_PARAMS   35  
	#define PARAM_QUARK_MATCH_SUMMARY   40  
	#define PARAM_QUARK_RANK_SUMMARY   41  
	#define PARAM_QUARK_SCORE_SUMMARY   42  
	#define PARAM_QUARK_TOURNAMENT_HISTORY_LIST   43  
	#define PARAM_QUARK_SUBSCRIPTION_ITEM   50  
	
	#define PARAM_QUARK_PROMO_TEXT   54 
	#define PARAM_QUARK_PROMO_IMAGE   55 
	#define PARAM_QUARK_PROMO_NEXTID   56 
	
	

	// normal size of the buffer that receives data from the server
	#define PARAM_RECEIVE_BUFFER_SIZE   28576  
	//#define PARAM_RECEIVE_BLOCK_SIZE   1024  

	// Request timeout (milliseconds)
	#define PARAM_REQUEST_TIMEOUT_DEFAULT   60000         
		
	// Registration States  
	#define PARAM_REGISTER_PHONE_NEEDED   0  
	#define PARAM_REGISTER_PIN_NEEDED   1  
	#define PARAM_REGISTER_PIN_VALIDATED   2  
	#define PARAM_REGISTER_DONE   3      
	
	// Response ID fields (_ID)
	#define PARAM_TOURNAMENT_ID_IDX   0  
	#define PARAM_TOURNAMENT_SEQUENCE_IDX   1  
	
	// Response text fields (_text[])
	#define PARAM_TOURNAMENT_NAME_IDX   0  
	#define PARAM_TOURNAMENT_DESCRIPTION_IDX   1  
	#define PARAM_TOURNAMENT_STATUS_IDX   2  
	
	// Response Time fields (_time)
	#define PARAM_TOURNAMENT_START_TIME_IDX   0  
	#define PARAM_TOURNAMENT_END_TIME_IDX   1  
		
	// Servers
	#define PARAM_SERVER_QA1   0  
	#define PARAM_SERVER_QA2   1  
	#define PARAM_SERVER_ENG2   2  
	#define PARAM_SERVER_ENG3   3    
	
		
	// Scores Pages Types 
	#define PARAM_SCORES_TYPE_MY_CURRENT_RANK   1  
	#define PARAM_SCORES_TYPE_MY_RECENT_MATCHES   2  
	#define PARAM_SCORES_TYPE_MY_TOURNAMENTS   3  
	#define PARAM_SCORES_TYPE_GLOBAL_RANKS   4    
	
		
	// Subscription  
	#define PARAM_SUBSCRIPTION_EXPIRED   0  
	#define PARAM_SUBSCRIPTION_NEED_CONFIRM   1  
	#define PARAM_SUBSCRIPTION_OK   2  
	// Default subscription info
	#define PARAM_DEFAULT_SUBSCRIPTION_LENGTH   864000000  
	
	// Game Types
	#define PARAM_TOURNAMENT_TYPE_PRACTICE   0  
	#define PARAM_TOURNAMENT_TYPE_H2H   1  
	#define PARAM_TOURNAMENT_TYPE_PROGRESSIVE   2  
	
	// The number of possible tournament types
	#define PARAM_TOURNAMENT_TYPE_COUNT   2  
	
	// The number of tournaments possible to hold in the client
	#define PARAM_TOURNAMENT_CACHE_SIZE   2  
	
	// Head to Head and Progressive
	#define PARAM_TYPES_OF_TOURNAMENTS   2  
	
	// The number of tournaments possible to hold in the client
	#define PARAM_MAX_TOURNAMENT_COUNT   2  

#endif //_FOR_PRIZES_ADAPTER_CONSTANT_DEFINITIONS_H_