#include "VerizonAdapter.h"
#include "..\..\Std\Helpers.h"

VerizonAdapter::VerizonAdapter(AEEApplet *_main, ITBStringFactory* _strings){
	myMain = _main;
	CINGULAR_QUARKTYPE = 0x2 | 1 << 31;
	VERIFYTYPE_SMS = 0;
	VERIFYTYPE_MIN_HASH = 1;
	STR_CINGULAR_SUBSCRIBER_ID = "CarrierDeviceId";
	STR_DEFAULT_SUBSCRIBER_ID = "abc123@cingular.com";
	strings = _strings;
	TBEvents::registerCarrierAdapter((CarrierAdapter*)this);
	TEXT_CONST_te0=strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_MIN);
	TEXT_CONST_te7=strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_SECURITY);
	TEXT_CONST_te5=strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK);
}

void VerizonAdapter::Release(){
	TEXT_CONST_te0.destruct();
	TEXT_CONST_te7.destruct();
	TEXT_CONST_te5.destruct();
	STR_CINGULAR_SUBSCRIBER_ID.destruct();
	STR_DEFAULT_SUBSCRIBER_ID.destruct();
	((CarrierAdapter*)this)->Release();
}

void VerizonAdapter::prepareRequest(int requestType) {
	
}

String VerizonAdapter::getCingularSubscriberID() {
	if( getAppProperty( myMain, &STR_CINGULAR_SUBSCRIBER_ID ).length() == 0 ) {
		//debug("Cingular Subscriber ID NULL--Using default (abc123@cingular.com)");
		return STR_DEFAULT_SUBSCRIBER_ID;
	}
	return getAppProperty(myMain,  &STR_CINGULAR_SUBSCRIBER_ID );
}

void VerizonAdapter::prepareCarrierHttpRequest() {
	
}

int VerizonAdapter::sendSubscriptionRequest(String _subscriptionRequestURL) {
	// Not required for Cingular
	return PARAM_ERR_NONE;
}
