#include "Helpers.h"
#include "AEEStdlib.h"
#include "AEETapi.h"

#ifdef COMPLIANCE
int _nextInt()
 {
	byte _bRand[4];
	int _iRand;
	GETRAND(_bRand, 4);
	_iRand = _bRand[0]<<12;
	_iRand += _bRand[1]<<8;
	_iRand += _bRand[2]<<4;
	_iRand += _bRand[3];
	return _iRand;
 }
#endif

int _min(int a, int b){
	if(a<b)
		return a;
	return b;
}

int shiftn(int v, int a){
	int x = v & 0x40000000;
	v <<= 1;
	v >>= 1;
	v >>= a;
	return (v+x);
}

char* fgetline ( IFile* _fp, char* buffer, char end )
{
	String _copy;
	char _tmp[2];
	_tmp[0] = '\0';
	_tmp[1] = '\0';
	char* buffer_alt = buffer = NULL;
	int ret=0;
	while(ret=IFILE_Read(_fp,_tmp,1)>0)
	{
		if(_tmp[0] != 13 && _tmp[0] != end)
			_copy += _tmp;
		if(_tmp[0]==end )
			break;
	}
	if(_copy.length() > 0) {
		buffer = (char*)MALLOC( _copy.length()+1);
		STRCPY(buffer,_copy.toCharArray());
	}
	return buffer;
}

String getAppProperty(AEEApplet* _main, String* a){
	String ret;
	String str;
	String key;
	char* buf = NULL;
	IFileMgr* iFileMgr = NULL;
	IFile* file = NULL;
	ISHELL_CreateInstance(_main->m_pIShell, AEECLSID_FILEMGR, (void* *)&iFileMgr);
	if(iFileMgr != NULL){
		file = IFILEMGR_OpenFile(iFileMgr,"http.cfg", _OFM_READWRITE);
	}
	if(file != NULL){
		buf = fgetline(file,buf);
		while(buf != NULL){
			str = buf;
			key = str.substring(0,str.indexOf("="));
			if(key.equals(*a))
				break;
			FREE(buf);
			buf = fgetline(file,buf);
		}
		if(key.equals(*a))
			ret = str.substring(str.indexOf("=")+1, str.length());
		IFILE_Release(file);
		file = NULL;
	}

	if (buf != NULL)
		FREE(buf);
	if(iFileMgr != NULL)
		IFILEMGR_Release(iFileMgr);
	return ret;
}

char* ReadLine(IFile* _pIFile,  char* _pReadBuffer ,char* _pReturnBuffer, int& _idxFilePos, int & _idxReadBufPos, int &_nReadBufLen)
{
	return ReadWord(_pIFile, NULL,_pReadBuffer, _pReturnBuffer,  _idxFilePos, _idxReadBufPos, _nReadBufLen);
}

char* ReadWord(IFile* _pIFile, const char* pDelimiters, char* _pReadBuffer, char* _pReturnBuffer, int& _idxFilePos, int & _idxReadBufPos, int &_nReadBufLen)
{
	//scan file for delimiters
	char ch;
	boolean isFound = false;
	int idx, idxWrite = 0;
	int nDelimiters = 0;
	if (pDelimiters)
		nDelimiters = STRLEN(pDelimiters);

	//int _idxReadBufPos = 0;
	//int _nReadBufLen = 0;
//	int _idxFilePos = 0;
	//char* _pReturnBuffer = (char *)MEMALLOC(256);
	do
	{
		//Fill the read buf if it is empty or consumed
		if ((!_nReadBufLen) || (_nReadBufLen <= _idxReadBufPos))
		{
			_idxReadBufPos = 0;
			_nReadBufLen = IFILE_Read(_pIFile, _pReadBuffer, 50);
		}
		if (!_nReadBufLen) //didn't read anything on this pass?
			break;

		ch = _pReadBuffer[_idxReadBufPos++];
		_idxFilePos++;

#if FILEREADER_DEBUG
		DEBUG(( "ch = 0x%x, %c, %i", ch,ch,ch ));
#endif
		if (ch == '\r') continue;	//skip carriage returns
		if (ch == '\n') break;		//stop at newline

		//Check ch against delimiters
		for (idx=nDelimiters-1; idx >= 0; idx--)
		{
			if (ch == pDelimiters[idx])
			{
				isFound = true;
				break;
			}
		}
		if (isFound) break; //don't return the delimiter

		_pReturnBuffer[idxWrite++] = ch;

		//This class won't handle lines longer than the ReturnBuffer. Truncate.
		if (idxWrite >= 256-1)
		{
			break;
		}
	}
	while (true);

//DEBUG(( "found ch %c at %d", ch, _idxFilePos-1 ));

	_pReturnBuffer[idxWrite++] = '\0';
	if ((_pReturnBuffer[0] == '\0') && !_nReadBufLen)
	{
		return NULL;	//EndOfFile (as opposed to an empty line)
	}
	return _pReturnBuffer;
}

void setAppPropertyBool(AEEApplet* _main, String* pczName, bool value)
{
	IFileMgr* iFileMgr = NULL;
	IFile* file = NULL;
	ISHELL_CreateInstance(_main->m_pIShell, AEECLSID_FILEMGR, (void* *)&iFileMgr);
	if(iFileMgr != NULL){
		file = IFILEMGR_OpenFile(iFileMgr,"http.cfg", _OFM_READWRITE);
	}
	if(file != NULL){

		char *pczToken;
		bool found = false;
		int _idxFilePos = 0;
		int _idxReadBufPos = 0;
		int _nReadBufLen = 0;
		char* _pReadBuffer = (char *)MEMALLOC(50);
		char* _pReturnBuffer = (char *)MEMALLOC(256);
		do
		{
			pczToken = ReadWord(file, "=",  _pReadBuffer,_pReturnBuffer, _idxFilePos, _idxReadBufPos, _nReadBufLen);
			if (!pczToken)
				break;

			if (STRCMP(pczToken, pczName->toCharArray()))	//not found
			{
				MEMFREE(pczToken); pczToken = NULL;
				pczToken = ReadLine(file,   _pReadBuffer, _pReturnBuffer, _idxFilePos, _idxReadBufPos, _nReadBufLen);//go to next line
			}
			else
			{
				MEMFREE(pczToken); pczToken = NULL;
				found = true;
				break;
			}
		}
		while (pczToken);
	
		if (found)
		{
			char ch;
			if (value)
				ch = 'Y';
			else
				ch = 'N';

			uint32 nBytes;

			//If the current position is in the middle of the read buffer,
			//we need to rewind the file pointer to the current position.

			nBytes = IFILE_Seek(file, _SEEK_START, _idxFilePos);
			if (nBytes == EFAILED)
			{
			//	DEBUG(( "FileReader::WriteChar() ERROR IFILE_Seek() failed pos=%d.", _idxFilePos ));
				return;
			}
			nBytes = IFILE_Write(file, &ch, (uint32)1);
		}
	
		MEMFREE(_pReadBuffer); _pReadBuffer = NULL;
		MEMFREE(_pReturnBuffer); _pReturnBuffer = NULL;

		IFILE_Release(file);
		file = NULL;
	}
	if(iFileMgr != NULL)
		IFILEMGR_Release(iFileMgr);
	return;
}

