#include "InputStream.h"

InputStream::InputStream(){
	_buf = NULL;
	_length = 0;
	_pos = 0;
}

InputStream::InputStream(byte& buffer, int len){
	_buf = NULL;
	_length = 0;
	_pos = 0;
	this->setBuffer(buffer,len);
}

InputStream::~InputStream(){
	if(_buf){
		FREE(_buf);
		_buf = NULL;
	}
	_length = 0;
	_pos = 0;
}

int InputStream::setBuffer(byte& buffer, int len){
	_buf = &buffer;
	_length = len;
	return _length;
}

byte InputStream::readByte(){
	byte ret = 0;
	if(_pos+1 < _length){
		ret = _buf[_pos];
		_pos++;
	} else 
		_pos++;	
	return ret;
}

short InputStream::readShort(){
	short ret;
	ret = (readByte() << 8);
	ret += readByte();
	return ret;
}

int InputStream::readInt(){
	int ret;
	ret = (readByte() << 24);
	ret += (readByte() << 16);
	ret += (readByte() << 8);
	ret += readByte();
	if(_pos > _length)
		return -1;
	return ret;
}

long InputStream::readLong(){
	long ret;
	ret = (readByte() << 24);
	ret += (readByte() << 16);
	ret += (readByte() << 8);
	ret += readByte();	
	return ret;
} 

bool InputStream::readBoolean(){
	return (readByte() != FALSE);
}

WString InputStream::readUTF(){
	AECHAR	c[2] = {'\0','\0'};
	byte	b;
	short	length;

	WString pStrReturn = "";

	length = readShort();
	if(length == 0)
	{
		return(pStrReturn);
	}

	// Decode "java" UTF-8
	while(length > 0)
	{
		b = readByte();
		length--;
		
		if((b & 0xF0) == 0xE0)		// A 3-jbyte char
		{
			c[0] = b & 0x0F;
			c[0] <<= 6;
			
			b = readByte();
//			IM_ASSERT((b & 0xC0) == 0x80);
			length--;
			c[0] |= (b & 0x3F);
			c[0] <<= 6;

			b = readByte();
//			IM_ASSERT((b & 0xC0) == 0x80);
			length--;
			c[0] |= (b & 0x3F);
		}
		else if((b & 0xE0) == 0xC0)	// A 2-jbyte char
		{
			c[0] = (b & 0x1F);
			c[0] <<= 6;

			b = readByte();
//			IM_ASSERT((b & 0xC0) == 0x80);
			length--;
			c[0] |= (b & 0x3F);
		}
		else if((b & 0x80) == 0x00)	// A 1-jbyte char
		{
			c[0] = (b & 0x7F);
		}
		else
		{
//			IM_ASSERT(0);
		}

		pStrReturn += c;
	}
//	IM_ASSERT(length == 0);

	return(pStrReturn);
}

void InputStream::readFully(byte b[], int off, int len){
	if(len == -1)
		len = _length;
	for(int i = 0; i < len && i+off < _length; i++)
		b[i] = _buf[i+off];
}