/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

//#include "AMTPFramework.h"
#include "Memory.h"
#if 1
#define DEBUGMEM(expr) DEBUG(expr)
#else
#define DEBUGMEM(expr)
#endif
/*
//-----------------------------------------------------------------------------
//	global new/delete
//-----------------------------------------------------------------------------
void* operator new(size_t size)
{
	return MEMALLOC(size);
}
//-----------------------------------------------------------------------------
void operator delete(void* ptr)
{
	MEMFREE(ptr);
}
//-----------------------------------------------------------------------------
void* operator new[](size_t size)
{
	return operator new(size);
}
//-----------------------------------------------------------------------------
void operator delete[](void* ptr)
{
	operator delete(ptr);
}
//-----------------------------------------------------------------------------
*/
#ifdef __cplusplus
extern "C"
{
#endif

void* MemAlloc(size_t size, char* szFile, int iLine)
{
	void* ptr = MALLOC(size);
	DEBUGMEM(( "%s(%d) : MALLOC(%d) = 0x%x", szFile, iLine, size, ptr ));
	return ptr;
}

void MemFree(void* ptr, char* szFile, int iLine)
{
	DEBUGMEM(( "%s(%d) : FREE = 0x%x", szFile, iLine, ptr ));
	FREE(ptr);
}

#ifdef __cplusplus
}
#endif

