#include "TBBaseEvents.h"

TBBaseEvents* TBBaseEvents::bus = NULL;
VoidVector* TBBaseEvents::fpStringFactories = NULL;
VoidVector* TBBaseEvents::fpClientControls = NULL;
VoidVector* TBBaseEvents::tbClientEventListener = NULL;
VoidVector* TBBaseEvents::tbMenuControls = NULL;
VoidVector* TBBaseEvents::tbMenuEventListener = NULL;
ITBSeedGenerator* TBBaseEvents::seedGenerator = NULL;

String TBBaseEvents::getString(int stringIndex) {
	VoidVector tmp;
	tmp = *(bus->fpStringFactories);
	for(UINT i = 0; i < bus->fpStringFactories->size(); i++) {
		String toReturn = ((ITBStringFactory*)tmp[i])->getString(stringIndex);
		if(toReturn.length() != 0) return toReturn;
	}
	return "";
}

bool TBBaseEvents::notifyModule(int code, int data){
	VoidVector tmp;
	tmp = *(bus->fpClientControls);
	for(UINT i = 0; i < bus->fpClientControls->size(); i++){
		if(((ITBClientControls*)tmp[i])->notifyModule(code,data))
			return true;
	}
	return false;
}

bool TBBaseEvents::notifyClient(int code, Bbyte data){
	VoidVector tmp;
	tmp = *(bus->tbClientEventListener);
	for(UINT i = 0; i < tbClientEventListener->size(); i++){
		if(((ITBClientEventListener*)tmp[i])->notifyClient(code,data))
			return true;
	}
	return false;
}

bool TBBaseEvents::menuCommand(int menuCommandData) {
	VoidVector tmp;
	tmp = *(bus->tbMenuControls);
	for(UINT i = 0; i < bus->tbMenuControls->size(); i++) {
		if(((ITBMenuControls*)tmp[i])->menuCommand(menuCommandData))
			return true;
	}
	return false;
}

bool TBBaseEvents::menuInput(int menuId, int menuEntryIndex, int menuEntryType, int entryData, String entryText) {
	VoidVector tmp;
	tmp = *(bus->tbMenuControls);
	for(UINT i = 0; i < bus->tbMenuControls->size(); i++) {
		if(((ITBMenuControls*)tmp[i])->menuInput(menuId,menuEntryIndex,menuEntryType,entryData,entryText)) 
			return true;
	}
	return false;
}

bool TBBaseEvents::setMenu(int menuId, int menuIndexSelected, int menuSize, String menuName) {
	VoidVector tmp;
	tmp = *(bus->tbMenuEventListener);
	for(UINT i = 0; i < bus->tbMenuEventListener->size(); i++) {
		if(((ITBMenuEventListener*)tmp[i])->setMenu(menuId,menuIndexSelected,menuSize,menuName)) 
			return true;
	}
	return false;
}

bool TBBaseEvents::setMenuEntry(int menuId, int menuIndex, int entryType, String entryName, int entryData, String entryText, ConvertedBitmapInfo* entryImage) {
	VoidVector tmp;
	tmp = *(bus->tbMenuEventListener);
	for(UINT i = 0; i < bus->tbMenuEventListener->size(); i++) {
		if(((ITBMenuEventListener*)tmp[i])->setMenuEntry(menuId,menuIndex,entryType,entryName,entryData,entryText,entryImage)) 
			return true;
	}
	return false;
}

bool TBBaseEvents::endSetMenu(int menuId) {
	VoidVector tmp;
	tmp = *(bus->tbMenuEventListener);
	for(UINT i = 0; i < bus->tbMenuEventListener->size(); i++) {
		if(((ITBMenuEventListener*)tmp[i])->endSetMenu(menuId)) 
			return true;
	}
	return false;
}

Bbyte TBBaseEvents::getSeed() {
	if (seedGenerator == NULL) {
		Bbyte tmp;
		DEBUG(("FP:getSeed(): No Generator Registered"));
		return tmp;
	} 

	return seedGenerator->getSeed();
}

void TBBaseEvents::Release(){

	VoidVector tmp;
	tmp = *(bus->fpStringFactories);
	
	for(UINT i = 0; i < bus->fpStringFactories->size(); i++) 
		delete ((ITBStringFactory*)tmp[i]);
	fpStringFactories->_delete();
	delete(fpStringFactories);
	
	fpClientControls->_delete();
	delete(fpClientControls);
	
	tbClientEventListener->_delete();
	delete(tbClientEventListener);
	tbMenuControls->_delete();
	delete(tbMenuControls);
	tbMenuEventListener->_delete();
	delete(tbMenuEventListener);
	delete(seedGenerator);
	
}