/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPERRORS_H
#define AMTPERRORS_H

//-----------------------------------------------------------------------------
//	Error codes used by the AMTP client framework
//-----------------------------------------------------------------------------

#define ERR_NONE							0

#define ERR_TIMEOUT							1

// Base system errors
#define ERR_AMTP_SYSTEM_UNAVAILABLE			10000
#define ERR_AMTP_ILLEGAL_OPERATION			10001
#define ERR_AMTP_DATABASE_ERROR				10002
#define ERR_AMTP_INVALID_MIN				10003

// Client software errors
#define ERR_AMTP_UNKNOWN_CLIENT_SOFTWARE	11000
#define ERR_AMTP_OBSOLETE_CLIENT_SOFTWARE	11001
#define ERR_AMTP_OBSOLETE_GAME				11002

// Registration errors
#define ERR_AMTP_ACCOUNT_ALREADY_EXISTS		12000
#define ERR_AMTP_ACCOUNT_NOT_FOUND          12001
#define ERR_AMTP_ACCOUNT_USERNAME_MISMATCH  12002
#define ERR_AMTP_INVALID_USERNAME			12003
#define ERR_AMTP_EXISTING_USERNAME			12004
#define ERR_AMTP_ACCOUNT_CREATION_REQUIRED	12005

// Tournament errors
#define ERR_AMTP_TOURNAMENT_ENTER_REJECTED	12006
#define ERR_AMTP_TOURNAMENT_SCORE_REJECTED	12007
#define ERR_AMTP_TOURNAMENT_NO_MORE_SEEDS	13000

#endif // AMTPERRORS_H