/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPGAMERESULT_H
#define AMTPGAMERESULT_H

#include "AMTPFramework.h"

class AMTPGameResult
{
public:
	~AMTPGameResult();
	AMTPGameResult();
	AMTPGameResult(const AMTPGameResult& copy);
	AMTPGameResult& operator=(const AMTPGameResult& copy);

	//mutators
	void Reset();
	void CopyData(const byte* pData, int32 lenData);
	void SetScore(int32 score) { _score = score; }
	void SetEndTime(int32 timeEnd) { _timeEnd = timeEnd; }
	void SetStartTime(int32 timeStart) { _timeStart = timeStart; }
	void SetForfeit(bool isForfeit) { _isForfeit = isForfeit; }

	//accessors
	int32 GetScore() const { return _score; }
	int32 GetEndTime() const { return _timeEnd; }
	int32 GetStartTime() const { return _timeStart; }
	const byte* GetData(int32& lenData) const { lenData = _lenData; return _pData; }
	bool GetForfeit() const { return _isForfeit; }

#ifdef _DEBUG
	void Debug(const char* prefix) const;
#endif

protected:
	int32 _score;
	int32 _timeStart;
	int32 _timeEnd;
	byte* _pData;
	int _lenData;
	bool _isForfeit;
};


#endif //AMTPGAMERESULT_H
