#ifndef _FPC_STRINGS_TESTBED_H_
#define _FPC_STRINGS_TESTBED_H_

#include "..\..\Core\TBC.h"

	/**
	 * BitFlags for String IDS
	 */
	#define FP_STR_CONST_FLAG_MIDLET_PARAMETER   0x80000000 
	#define FP_STR_CONST_FLAG_DYNAMIC   0x40000000 

	/**
	 * String Language ID (For Localization Support) 
	 */
	#define FP_STR_LANG_EN_US   1 

	/**
	 * Constant String IDs
	 */
	#define STRING_NULL   0 

	// Tournament options
	#define CLIENT_STR_CONST_ID_GAME_NAME   0 
	#define FP_STR_CONST_ID_ITEM_LABEL_PLAY   CLIENT_STR_CONST_ID_GAME_NAME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENT   FP_STR_CONST_ID_ITEM_LABEL_PLAY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_H2H   FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENT + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE   FP_STR_CONST_ID_ITEM_LABEL_H2H + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_PRACTICE   FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_PROMO   FP_STR_CONST_ID_ITEM_LABEL_PRACTICE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SCORES   FP_STR_CONST_ID_ITEM_LABEL_PROMO + 1 

	// Scoring Strings
	#define FP_STR_CONST_ID_ITEM_LABEL_CURRENT_RANK   FP_STR_CONST_ID_ITEM_LABEL_SCORES + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RECENT_MATCHES   FP_STR_CONST_ID_ITEM_LABEL_CURRENT_RANK + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_MY_TOURNAMENTS   FP_STR_CONST_ID_ITEM_LABEL_RECENT_MATCHES + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_GLOBAL_RANKS   FP_STR_CONST_ID_ITEM_LABEL_MY_TOURNAMENTS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ALL_TIME_BEST   FP_STR_CONST_ID_ITEM_LABEL_GLOBAL_RANKS + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_SMS_NOTIFY   FP_STR_CONST_ID_ITEM_LABEL_ALL_TIME_BEST + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_HOW_TO_PLAY   FP_STR_CONST_ID_ITEM_LABEL_SMS_NOTIFY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SCORING   FP_STR_CONST_ID_ITEM_LABEL_HOW_TO_PLAY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_TIPS_AND_TRICKS   FP_STR_CONST_ID_ITEM_LABEL_SCORING + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENTS   FP_STR_CONST_ID_ITEM_LABEL_TIPS_AND_TRICKS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_LEGAL   FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENTS + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_SUPPORT   FP_STR_CONST_ID_ITEM_LABEL_LEGAL + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_CANCEL   FP_STR_CONST_ID_ITEM_LABEL_SUPPORT + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_NEXT   FP_STR_CONST_ID_ITEM_LABEL_CANCEL + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REPLAY   FP_STR_CONST_ID_ITEM_LABEL_NEXT + 1 

	// Reggistration String
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION   FP_STR_CONST_ID_ITEM_LABEL_REPLAY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_REQUEST   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_PHONE   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_REQUEST + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_10_DIGIT_PHONE   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_EXISTING_USERNAME   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_10_DIGIT_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_NAME   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_EXISTING_USERNAME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_PIN   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_NAME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_3_CHAR_MIN   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_PIN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_VERIFY_PHONE   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_3_CHAR_MIN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_TEXT_MESSAGE   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_VERIFY_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_4_DIGIT_PIN   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_TEXT_MESSAGE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_CONFIRM_PHONE   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_4_DIGIT_PIN + 1 

	// Tournament Screens
	#define FP_STR_CONST_ID_ITEM_LABEL_PRIZES   FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_CONFIRM_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_WINNER   FP_STR_CONST_ID_ITEM_LABEL_PRIZES + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_NEWS   FP_STR_CONST_ID_ITEM_LABEL_WINNER + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_MATCH_RESULTS   FP_STR_CONST_ID_ITEM_LABEL_NEWS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RANK_SUMMARY   FP_STR_CONST_ID_ITEM_LABEL_MATCH_RESULTS + 1 

	// Progress Screens
	#define FP_STR_CONST_ID_ITEM_LABEL_SLOGAN   FP_STR_CONST_ID_ITEM_LABEL_RANK_SUMMARY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_PROGRESS   FP_STR_CONST_ID_ITEM_LABEL_SLOGAN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RETRY   FP_STR_CONST_ID_ITEM_LABEL_PROGRESS + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_EXIT   FP_STR_CONST_ID_ITEM_LABEL_RETRY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUME   FP_STR_CONST_ID_ITEM_LABEL_EXIT + 1 
 
	// About Text
	#define FP_STR_CONST_ID_ITEM_LABEL_ABOUT1   FP_STR_CONST_ID_ITEM_LABEL_RESUME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ABOUT2   FP_STR_CONST_ID_ITEM_LABEL_ABOUT1 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ABOUT3   FP_STR_CONST_ID_ITEM_LABEL_ABOUT2 + 1 

	// Help Text
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP_TOURNAMENTS   FP_STR_CONST_ID_ITEM_LABEL_ABOUT3 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP_LEGAL   FP_STR_CONST_ID_ITEM_LABEL_HELP_TOURNAMENTS + 1 


	// Resubscription Text
	#define FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION_THANKS   FP_STR_CONST_ID_ITEM_LABEL_HELP_LEGAL + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION_EXPIRED   FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION_THANKS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION   FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION_EXPIRED + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_PURCHASE   FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION1   FP_STR_CONST_ID_ITEM_LABEL_PURCHASE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION2   FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION1 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION3   FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION2 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION4   FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION3 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION5   FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION4 + 1 
	//Default subscription info
	#define FP_STR_CONST_ID_ITEM_LABEL_DEFAULT_SUBSCRIPTION_PRICE   FP_STR_CONST_ID_ITEM_LABEL_RESUBSCRIPTION5 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_DEFAULT_SUBSCRIPTION_URL   FP_STR_CONST_ID_ITEM_LABEL_DEFAULT_SUBSCRIPTION_PRICE + 1 


	// Welcome text
	#define FP_STR_CONST_ID_ITEM_LABEL_WELCOME   FP_STR_CONST_ID_ITEM_LABEL_DEFAULT_SUBSCRIPTION_URL + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_WELCOME1   FP_STR_CONST_ID_ITEM_LABEL_WELCOME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_WELCOME2   FP_STR_CONST_ID_ITEM_LABEL_WELCOME1 + 1 


	// Error Strings
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR   FP_STR_CONST_ID_ITEM_LABEL_WELCOME2 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION FP_STR_CONST_ID_ITEM_LABEL_ERROR + 1
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_MIN   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_PIN   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_MIN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_USER_NAME   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_PIN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_EXISTS   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_USER_NAME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_MISMATCH   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_EXISTS + 1 


	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_UNSUPPORTED_PHONE   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_MISMATCH + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_UNSUPPORTED_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_NOT_AVAILABLE   FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_SECURITY   FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_NOT_AVAILABLE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_REQUEST_ABORTED   FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_SECURITY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ERROR_TIMEOUT   FP_STR_CONST_ID_ITEM_LABEL_ERROR_REQUEST_ABORTED + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_NO_ERROR   FP_STR_CONST_ID_ITEM_LABEL_ERROR_TIMEOUT + 1 


	//ADI missing stuff
	#define FP_STR_CONST_ID_ITEM_LABEL_NETWORK_ERROR   FP_STR_CONST_ID_ITEM_LABEL_NO_ERROR + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ENTER_PIN   FP_STR_CONST_ID_ITEM_LABEL_NETWORK_ERROR + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_VERIFY_PHONE   FP_STR_CONST_ID_ITEM_LABEL_ENTER_PIN + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ENTER_NAME   FP_STR_CONST_ID_ITEM_LABEL_VERIFY_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_ENTER_PHONE   FP_STR_CONST_ID_ITEM_LABEL_ENTER_NAME + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP_HOW_TO_PLAY   FP_STR_CONST_ID_ITEM_LABEL_ENTER_PHONE + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP_SCORING   FP_STR_CONST_ID_ITEM_LABEL_HELP_HOW_TO_PLAY + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP_TIPS_AND_TRICKS   FP_STR_CONST_ID_ITEM_LABEL_HELP_SCORING + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_HELP   FP_STR_CONST_ID_ITEM_LABEL_HELP_TIPS_AND_TRICKS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SCORES_MY_TOURNAMENTS   FP_STR_CONST_ID_ITEM_LABEL_HELP + 1 

	// Server Strings
	#define FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_QA1   FP_STR_CONST_ID_ITEM_LABEL_SCORES_MY_TOURNAMENTS + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_QA2   FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_QA1 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_ENG2   FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_QA2 + 1 
	#define FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_ENG3   FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_ENG2 + 1 

	#define FP_STR_CONST_ID_ITEM_LABEL_VERSION   FP_STR_CONST_ID_ITEM_LABEL_SERVER_URL_ENG3 + 1 
	
	#define FP_STR_CONST_ID_SELECT   FP_STR_CONST_ID_ITEM_LABEL_VERSION + 1 
	#define FP_STR_CONST_ID_P4P_MENU	FP_STR_CONST_ID_SELECT+1
	#define FP_STR_CONST_ID_BACK  FP_STR_CONST_ID_P4P_MENU +1 
	#define FP_STR_CONST_ID_TITLE   FP_STR_CONST_ID_BACK+1 
	#define FP_STR_CONST_ID_YES   FP_STR_CONST_ID_TITLE+1 
	#define FP_STR_CONST_ID_NO   FP_STR_CONST_ID_YES+1 
	#define FP_STR_CONST_ID_ON   FP_STR_CONST_ID_NO+1 
	#define FP_STR_CONST_ID_OFF   FP_STR_CONST_ID_ON+1 
	#define FP_STR_CONST_ID_TEST_IMAGE   FP_STR_CONST_ID_OFF+1 
	#define FP_STR_CONST_ID_TEST_IMAGE_ANIMATION   FP_STR_CONST_ID_TEST_IMAGE+1 
	#define FP_STR_CONST_ID_TEST_IMAGE_ANIMATION_QUESTION   FP_STR_CONST_ID_TEST_IMAGE_ANIMATION+1 
	#define FP_STR_CONST_ID_TEST_TEXT   FP_STR_CONST_ID_TEST_IMAGE_ANIMATION_QUESTION+1 
	#define FP_STR_CONST_ID_TEST_TEXT_INPUT_TITLE   FP_STR_CONST_ID_TEST_TEXT+1 
	#define FP_STR_CONST_ID_TEST_TEXT_INPUT_DEFAULT   FP_STR_CONST_ID_TEST_TEXT_INPUT_TITLE+1 
	#define FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE   FP_STR_CONST_ID_TEST_TEXT_INPUT_DEFAULT +1 
	#define FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE_QUESTION   FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE +1 
	#define FP_STR_CONST_ID_TEST_TEXT_INPUT_CLEAR   FP_STR_CONST_ID_TEST_TEXT_INPUT_SIZE_QUESTION +1 
	#define FP_STR_CONST_ID_TEST_TEXT_OUTPUT   FP_STR_CONST_ID_TEST_TEXT_INPUT_CLEAR+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS   FP_STR_CONST_ID_TEST_TEXT_OUTPUT+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_STATE   FP_STR_CONST_ID_TEST_PROGRESS+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_READY   FP_STR_CONST_ID_TEST_PROGRESS_STATE+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_PAUSED   FP_STR_CONST_ID_TEST_PROGRESS_READY+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_RUNNING   FP_STR_CONST_ID_TEST_PROGRESS_PAUSED+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_COMPLETE   FP_STR_CONST_ID_TEST_PROGRESS_RUNNING+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RUN   FP_STR_CONST_ID_TEST_PROGRESS_COMPLETE+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_PAUSE   FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RUN+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RESET  FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_PAUSE+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_RUN_QUESTION   FP_STR_CONST_ID_TEST_PROGRESS_COMMAND_RESET+1 
	#define FP_STR_CONST_ID_TEST_PROGRESS_RUN   FP_STR_CONST_ID_TEST_PROGRESS_RUN_QUESTION+1 
	#define FP_STR_CONST_ID_TEST_NETWORK   FP_STR_CONST_ID_TEST_PROGRESS_RUN+1 
	#define FP_STR_CONST_ID_SCREEN_HELP   FP_STR_CONST_ID_TEST_NETWORK +1 
	#define FP_STR_CONST_ID_SCREEN_SEEDS   FP_STR_CONST_ID_SCREEN_HELP+1 
	#define FP_STR_CONST_ID_SCREEN_RESULTS   FP_STR_CONST_ID_SCREEN_SEEDS+1 
	#define FP_STR_CONST_ID_SCREEN_CLIENT   FP_STR_CONST_ID_SCREEN_RESULTS+1 
	#define FP_STR_CONST_ID_TOGGLE   FP_STR_CONST_ID_SCREEN_CLIENT+1 
	#define FP_STR_CONST_ID_TITLE_MENU_START   FP_STR_CONST_ID_TOGGLE+1 
	#define FP_STR_CONST_ID_TITLE_MENU_EXERCISE   FP_STR_CONST_ID_TITLE_MENU_START+1 
	#define FP_STR_CONST_ID_OUT_OF_SEEDS   FP_STR_CONST_ID_TITLE_MENU_EXERCISE+1 
	#define FP_STR_CONST_ID_REPLAY   FP_STR_CONST_ID_OUT_OF_SEEDS+1 
	#define FP_STR_CONST_ID_END_GAME   FP_STR_CONST_ID_REPLAY + 1 
	#define FP_STR_CONST_ID_END_GAME_SCORE   FP_STR_CONST_ID_END_GAME+1 
	#define FP_STR_CONST_ID_END_GAME_SEND_SCORE_QUESTION   FP_STR_CONST_ID_END_GAME_SCORE+1 
	#define FP_STR_CONST_ID_CONNECTING   FP_STR_CONST_ID_END_GAME_SEND_SCORE_QUESTION+1 
	#define FP_STR_CONST_ID_CANCEL   FP_STR_CONST_ID_CONNECTING+1 
	#define FP_STR_CONST_ID_DOWNLOADING_FILE   FP_STR_CONST_ID_CANCEL+1 
	
	//ADI new stuff	
	#define FP_STR_CONST_ID_BOOL_OPTION_ON	  FP_STR_CONST_ID_DOWNLOADING_FILE + 1 	
	#define FP_STR_CONST_ID_BOOL_OPTION_OFF   FP_STR_CONST_ID_BOOL_OPTION_ON + 1 		
	#define FP_STR_CONST_ID_FORE   FP_STR_CONST_ID_BOOL_OPTION_OFF + 1 	
	//todo set correct string	
	#define FP_STR_CONST_ID_ITEM_LABEL_SMS_OPTION   FP_STR_CONST_ID_FORE + 1 		
	
	
		
	#define FP_STR_CONST_ID_PARAM_START   FP_STR_CONST_FLAG_MIDLET_PARAMETER 
	#define FP_STR_CONST_ID_PARAM_URL_TEST_IMAGE   FP_STR_CONST_ID_PARAM_START 
	#define FP_STR_CONST_ID_PARAM_URL_TEST_TEXT   FP_STR_CONST_ID_PARAM_URL_TEST_IMAGE+1 

#endif//  _FPC_STRINGS_TESTBED_H_