/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef FILEREADER_H
#define FILEREADER_H

#include "AMTPFramework.h"

#include "AEEFile.h"

class FileReader
{
public:
	//This class won't handle lines longer than the ReturnBuffer.
	//static const int LEN_OF_RETURN_BUFFER = 256;
	//static const int LEN_OF_READ_BUFFER = 32;
	enum { LEN_OF_RETURN_BUFFER = 256 };
	enum { LEN_OF_READ_BUFFER = 32 };

protected:
	IFileMgr* _pIFileMgr;
	IFile* _pIFile;

//	boolean _isInitialized;
//	boolean _isFileOpen;
	char* _pReturnBuffer;
	char* _pReadBuffer;
	int _idxFilePos;	//current position in file
	int _idxReadBufPos;	//current position in buf
	int _nReadBufLen;	//number of chars in buf

public:
	FileReader();
	~FileReader() { Stop(); }

	// Start & Stop must be used in place of the ctor/dtor. They eliminate
	// the need for a copy contructor and assignment operator.
	bool Start(int lenReturnBuffer = LEN_OF_RETURN_BUFFER);
	void Stop();

	// Only one file can be open at a time
	bool Open(const char* pszFilename, OpenFileMode ofm=_OFM_READ);
	void Close();
	void Rewind();

	char* ReadLine();
	char* ReadWord(const char* pszDelimiters);
	bool WriteChar(const char ch);

	boolean isFileOpen() { return _pIFile != NULL; }
	boolean isRunning() { return _pIFileMgr != NULL; }
};

#endif //FILEREADER_H
