#include "ForPrizeTestbed.h"
#include "..\..\..\src\aMain.h"
#include "..\..\Core\TBC.h"

//bool ForPrizeTestbed::fwcanceledLoading;
int ForPrizeTestbed::FORPRIZE_NAME_FIELD_MAX_SIZE;
String* ForPrizeTestbed::FORPRIZE_PARAM_CARRIER = NULL; // "ForPrize-Carrier";
String* ForPrizeTestbed::FORPRIZE_PARAM_GAME_ID = NULL; // "ForPrize-Game-Id";
String* ForPrizeTestbed::FORPRIZE_PARAM_GAME_VERSION = NULL; // "ForPrize-Game-Version";
String* ForPrizeTestbed::FORPRIZE_PARAM_SERVER = NULL; // "ForPrize-Server";
String* ForPrizeTestbed::FORPRIZE_PARAM_ASSET_CLASS = NULL; // "ForPrize-Asset-Class";
String* ForPrizeTestbed::FORPRIZE_PARAM_MIN = NULL; // "ForPrize-Min-Num";
String* ForPrizeTestbed::FORPRIZE_PARAM_COUNTRYCODE = NULL; // "ForPrize-Country-Code";
String* ForPrizeTestbed::FORPRIZE_PARAM_SUB_PRICE = NULL; // "ForPrize-Sub-Price";
String* ForPrizeTestbed::FORPRIZE_PARAM_SUB_LENGTH = NULL; // "ForPrize-Sub-Length";
String* ForPrizeTestbed::FORPRIZE_PARAM_SUB_REQ_URL = NULL; // "Forprize-Sub-ReqUrl";
String* ForPrizeTestbed::FORPRIZE_PARAM_RECORD_STORE_ACCOUNT = NULL; // "ForPrize-Store-Account";
String* ForPrizeTestbed::FORPRIZE_PARAM_RECORD_STORE_BILLING = NULL; // "ForPrize-Store-Billing";
String* ForPrizeTestbed::FORPRIZE_PARAM_ISREGISTERED = NULL; // "ForPrize-Store-Account";
String* ForPrizeTestbed::FORPRIZE_PARAM_ISSMSOPTIN = NULL; // "ForPrize-Store-Billing";
bool ForPrizeTestbed::fwcanceledLoading;
class ForPrizeTestbed* ForPrizeTestbed::self;
bool ForPrizeTestbed::ForPrizeNetworkAction::run = false;

ForPrizeTestbed::ForPrizeTestbed(){
	FORPRIZE_NAME_FIELD_MAX_SIZE = 10;
	// The Parameters for the ForPrizesModule are stored as these JAD keys
	FORPRIZE_PARAM_CARRIER = new String("ForPrize-Carrier");
	FORPRIZE_PARAM_GAME_ID = new String("ForPrize-Game-Id");
	FORPRIZE_PARAM_GAME_VERSION = new String("ForPrize-Game-Version");
	FORPRIZE_PARAM_SERVER = new String("ForPrize-Server");
	FORPRIZE_PARAM_ASSET_CLASS = new String("ForPrize-Asset-Class");
	FORPRIZE_PARAM_MIN = new String("ForPrize-Min-Num");
	FORPRIZE_PARAM_COUNTRYCODE = new String("ForPrize-Country-Code");
	FORPRIZE_PARAM_SUB_PRICE = new String("ForPrize-Sub-Price");
	FORPRIZE_PARAM_SUB_LENGTH = new String("ForPrize-Sub-Length");
	FORPRIZE_PARAM_SUB_REQ_URL = new String("Forprize-Sub-ReqUrl");
	FORPRIZE_PARAM_RECORD_STORE_ACCOUNT = new String("ForPrize-Store-Account");
	FORPRIZE_PARAM_RECORD_STORE_BILLING = new String("ForPrize-Store-Billing");
	FORPRIZE_PARAM_ISREGISTERED = new String("ForPrize-IsRegistered");
	FORPRIZE_PARAM_ISSMSOPTIN = new String("ForPrize-IsSMSOptIn");

	moduleState = MODULE_STATE_OFF;
	menuState = MENU_OFF;
	reloadTournaments = false;
	isGameRunning = false;
	isReplay = false;
	int errorBackState = MENU_OFF;
	int errorForeState = MENU_OFF;	
	strings = NULL;
	carrierAdapter = NULL;
	clientTrigger = NULL;
	menuTrigger = NULL;
	fpa = NULL;
}

ForPrizeTestbed::ForPrizeTestbed(AEEApplet *main){

	AEEApplet* owner = main;
	
	FORPRIZE_NAME_FIELD_MAX_SIZE = 10;
	// The Parameters for the ForPrizesModule are stored as these JAD keys
	FORPRIZE_PARAM_CARRIER = new String("ForPrize-Carrier");
	FORPRIZE_PARAM_GAME_ID = new String("ForPrize-Game-Id");
	FORPRIZE_PARAM_GAME_VERSION = new String("ForPrize-Game-Version");
	FORPRIZE_PARAM_SERVER = new String("ForPrize-Server");
	FORPRIZE_PARAM_ASSET_CLASS = new String("ForPrize-Asset-Class");
	FORPRIZE_PARAM_MIN = new String("ForPrize-Min-Num");
	FORPRIZE_PARAM_COUNTRYCODE = new String("ForPrize-Country-Code");
	FORPRIZE_PARAM_SUB_PRICE = new String("ForPrize-Sub-Price");
	FORPRIZE_PARAM_SUB_LENGTH = new String("ForPrize-Sub-Length");
	FORPRIZE_PARAM_SUB_REQ_URL = new String("Forprize-Sub-ReqUrl");
	FORPRIZE_PARAM_RECORD_STORE_ACCOUNT = new String("ForPrize-Store-Account");
	FORPRIZE_PARAM_RECORD_STORE_BILLING = new String("ForPrize-Store-Billing");
	FORPRIZE_PARAM_ISREGISTERED = new String("ForPrize-IsRegistered");
	FORPRIZE_PARAM_ISSMSOPTIN = new String("ForPrize-IsSMSOptIn");
	
//#ifdef DEBUG_ON
	DEBUG(("ForPrizeCompliance(): Initializing"));
//#endif
	moduleState = MODULE_STATE_OFF;
	menuState = MENU_OFF;
	isGameRunning = false;
	isReplay = false;
	int errorBackState = MENU_OFF;
	int errorForeState = MENU_OFF;	
	strings = NULL;
	carrierAdapter = NULL;
	clientTrigger = NULL;
	menuTrigger = NULL;
	fpa = NULL;
	
//	eventList = new Vector(5, 1);
	
	self = this;
	
	TBModuleEvents::registerEventHandler((ITBClientControls*)this);
	TBModuleEvents::registerEventHandler((ITBMenuControls*)this);
	
	strings = TBModuleEvents::getStringFactory();
	clientTrigger = TBModuleEvents::getClientEventListener();
	menuTrigger = TBModuleEvents::getMenuEventListener();
	carrierAdapter = TBModuleEvents::getCarrierAdapter();
	carrierAdapter->setOwner(this);
	
	
	// Load For Prize Parameters From Jad
	
	String badParams = "";
	
	String fpCarrier = getAppProperty(owner, FORPRIZE_PARAM_CARRIER);
	if (fpCarrier == ""){
		badParams += *FORPRIZE_PARAM_CARRIER;
		badParams += ", ";
	}
	
	String fpProductID = getAppProperty(owner, FORPRIZE_PARAM_GAME_ID);
	if (fpProductID == ""){
		badParams += *FORPRIZE_PARAM_GAME_ID;
		badParams += ", ";
	}

	String fpProductVersion = getAppProperty(owner, FORPRIZE_PARAM_GAME_VERSION);
	if (fpProductVersion == ""){
		badParams += *FORPRIZE_PARAM_GAME_VERSION;
		badParams += ", ";
	}
	
	String fpServerURL = getAppProperty(owner, FORPRIZE_PARAM_SERVER);
	if (fpServerURL == "") {
		badParams += *FORPRIZE_PARAM_SERVER;
		badParams += ", ";
	}
	
	String fpAssetClass = getAppProperty(owner, FORPRIZE_PARAM_ASSET_CLASS);
	if (fpAssetClass == ""){
		badParams += *FORPRIZE_PARAM_ASSET_CLASS;
		badParams += ", ";
	}
	
	String fpCountryCode = getAppProperty(owner, FORPRIZE_PARAM_COUNTRYCODE);
	if (fpCountryCode == ""){
		badParams += *FORPRIZE_PARAM_COUNTRYCODE;
		badParams += ", ";
	}
	
	String fpAccountRecordName = getAppProperty(owner, FORPRIZE_PARAM_RECORD_STORE_ACCOUNT);
	if (fpAccountRecordName == ""){
		badParams += *FORPRIZE_PARAM_RECORD_STORE_ACCOUNT;
		badParams += ", ";
	}
	
	String fpBillingRecordName = getAppProperty(owner, FORPRIZE_PARAM_RECORD_STORE_BILLING);
	if (fpBillingRecordName == "") {
		badParams += *FORPRIZE_PARAM_RECORD_STORE_BILLING;
		badParams += ", ";
	}
	
	String fpSubPrice = getAppProperty(owner, FORPRIZE_PARAM_SUB_PRICE);
	if (fpSubPrice == ""){ 
		badParams += *FORPRIZE_PARAM_SUB_PRICE;
		badParams += ", ";
	}
	
	String fpSubRequestURL = getAppProperty(owner, FORPRIZE_PARAM_SUB_REQ_URL);
	if (fpSubRequestURL == "") {
		badParams += *FORPRIZE_PARAM_SUB_REQ_URL;
		badParams += ", ";
	}
	
	String fpMin = getAppProperty(owner, FORPRIZE_PARAM_MIN);
	if (fpMin == "") {
		badParams += *FORPRIZE_PARAM_MIN;
		badParams += ", ";
	}

	String fpRegister = getAppProperty(owner, FORPRIZE_PARAM_ISREGISTERED);
	if (fpRegister == "") {
		badParams += *FORPRIZE_PARAM_ISREGISTERED;
		badParams += ", ";
	}
	String fpSms = getAppProperty(owner, FORPRIZE_PARAM_ISSMSOPTIN);
	if (fpSms == "") {
		badParams += *FORPRIZE_PARAM_ISSMSOPTIN;
		badParams += ", ";
	}
	
	// If we're missing any Jad Parameters, Fail Gracefully
//		if (badParams.length() != 0) throw new IllegalArgumentException("Missing ForPrizesModule Jad Parameters: " + badParams.toString());


	fpa = new ForPrizesAdapter(this,strings,owner,fpCarrier,fpProductID,fpProductVersion,fpServerURL,fpAssetClass,fpMin,fpCountryCode,fpSubPrice,fpSubRequestURL,fpAccountRecordName, fpBillingRecordName, fpRegister, fpSms);
	
	if(fpa->_userName.length() == 0) fpa->_userName = "";
	
}

void ForPrizeTestbed::release() {
	
	if (fpa != NULL)
	{
		fpa->release();
		delete fpa;
		fpa = NULL;
	}

	FORPRIZE_PARAM_CARRIER->destruct();
	FORPRIZE_PARAM_GAME_ID->destruct();
	FORPRIZE_PARAM_GAME_VERSION->destruct();
	FORPRIZE_PARAM_SERVER->destruct();
	FORPRIZE_PARAM_ASSET_CLASS->destruct();
	FORPRIZE_PARAM_MIN->destruct();
	FORPRIZE_PARAM_COUNTRYCODE->destruct();
	FORPRIZE_PARAM_SUB_PRICE->destruct();
	FORPRIZE_PARAM_SUB_LENGTH->destruct();
	FORPRIZE_PARAM_SUB_REQ_URL->destruct();
	FORPRIZE_PARAM_RECORD_STORE_ACCOUNT->destruct();
	FORPRIZE_PARAM_RECORD_STORE_BILLING->destruct();
	FORPRIZE_PARAM_ISREGISTERED->destruct();
	FORPRIZE_PARAM_ISSMSOPTIN->destruct();

	delete FORPRIZE_PARAM_CARRIER;
	delete FORPRIZE_PARAM_GAME_ID;
	delete FORPRIZE_PARAM_GAME_VERSION;
	delete FORPRIZE_PARAM_SERVER;
	delete FORPRIZE_PARAM_ASSET_CLASS;
	delete FORPRIZE_PARAM_MIN;
	delete FORPRIZE_PARAM_COUNTRYCODE;
	delete FORPRIZE_PARAM_SUB_PRICE;
	delete FORPRIZE_PARAM_SUB_LENGTH;
	delete FORPRIZE_PARAM_SUB_REQ_URL;
	delete FORPRIZE_PARAM_RECORD_STORE_ACCOUNT;
	delete FORPRIZE_PARAM_RECORD_STORE_BILLING;
	delete FORPRIZE_PARAM_ISREGISTERED;
	delete FORPRIZE_PARAM_ISSMSOPTIN;

	fpHeaderString.destruct();
	textScore.destruct();
	errorTitleString.destruct();
	errorContentsString.destruct();
	fpTournamentParameters.destruct();
}


bool ForPrizeTestbed::notifyModule(int code, int data) {

//#ifdef DEBUG_ON
	DEBUG(("ForPrizeCompliance:notifyModule(%d): Processing",moduleState));
//#endif
	
	if (code == MODULE_NOTIFY_DESTROYED) return fpa->savePreferences();
	
	int oldModuleState = moduleState;
	
	if (code >= 0) {
		moduleState |= code;
			
	} else {
		moduleState &= code;
	}
	
	if (moduleState == oldModuleState) return false;
	
	if ((moduleState & MODULE_STATE_FLAG_GAME_ON) != 0) {
		if (!isGameRunning) {
			isGameRunning = true;
			moduleState &= ~MODULE_STATE_FLAG_MENU_ON;
		}
	} else {
		if (isGameRunning) {
			isGameRunning = false;
			curScore = data;
			moduleState |= MODULE_STATE_FLAG_MENU_ON;
			//menuState = MENU_SCREEN_GAME_RESULTS;
			/*clientTrigger.*/notifyClient(CLIENT_START_MENU,NULL);
			setMenu(MENU_SCREEN_GAME_RESULTS);
			//System.out.println("-----------------------------------------------------> MENU_SCREEN_GAME_RESULTS");
			return true;
		}
	}
	
	if ((moduleState & MODULE_STATE_FLAG_MENU_ON) != 0) {

		if (menuState == MENU_OFF) {
			/*clientTrigger.*/notifyClient(CLIENT_START_MENU,NULL);
			if ((moduleState & MODULE_STATE_FLAG_HELP_ONLY) != 0) {
				setMenu(MENU_SCREEN_HELP);
			} else {
				setMenu(MENU_TOURNAMENT);
			}	
		} else {
			setMenu(menuState);
		}
		
	} else {
		if (menuState != MENU_OFF) {
			menuState = MENU_OFF;
			moduleState &= ~MODULE_STATE_FLAG_HELP_ONLY;
			/*clientTrigger.*/notifyClient(CLIENT_END_MENU,NULL);
		}
	}
	
	return true;
}

bool ForPrizeTestbed::menuCommand(int menuCommandData) {	

//#ifdef DEBUG_ON
	if ((menuCommandData | MENU_FLAG_ACTION)  != 0) {
		DEBUG(("ForPrize:menuCommand(%d) in menu: %s",(menuCommandData & MENU_MASK_FLAGS), getScreenName(menuState).toCharArray()));
	} 
//#endif
	
	switch(menuCommandData) {
		
		case MENU_ACTION_FORE:
			return menuCommandActionFore();
		case MENU_ACTION_BACK: 
			return menuCommandActionBack();
		
		case MENU_ACTION_RETRY_NETWORK: 
			doNetworkTransaction(MENU_ACTION_RETRY_NETWORK);
		return true;
  
		case MENU_ACTION_GET_SCORES_H2H_CURRENT_RANK : {
			fpTypeTournament = PARAM_TOURNAMENT_TYPE_H2H;
			fpTypeScore = PARAM_SCORES_TYPE_MY_CURRENT_RANK;
			postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_H2H_CURRENT_RANK;  
			getScoresRegistrationCheck();  
		} return true;  
		
		case MENU_ACTION_GET_SCORES_H2H_RECENT_MATCHES : {
			fpTypeTournament = PARAM_TOURNAMENT_TYPE_H2H;
			fpTypeScore = PARAM_SCORES_TYPE_MY_RECENT_MATCHES;
	     	postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_H2H_RECENT_MATCHES;  
	     	getScoresRegistrationCheck();   
	    } return true;
      
        case MENU_ACTION_GET_SCORES_H2H_GLOBAL_RANKS : {
			 fpTypeTournament = PARAM_TOURNAMENT_TYPE_H2H;
			 fpTypeScore = PARAM_SCORES_TYPE_GLOBAL_RANKS;
			 postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_H2H_GLOBAL_RANKS;  
			 getScoresRegistrationCheck();  
        } return true;

        case MENU_ACTION_GET_SCORES_H2H_MY_TOURNAMENTS : {
			 fpTypeTournament = PARAM_TOURNAMENT_TYPE_H2H;
			 fpTypeScore = PARAM_SCORES_TYPE_MY_TOURNAMENTS;
			 postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_H2H_MY_TOURNAMENTS;  
			 getScoresRegistrationCheck();   
        } return true;
      
        //Adi progressive screens
        case MENU_ACTION_GET_SCORES_PROGRESSIVE_CURRENT_RANK : {
			 fpTypeTournament = PARAM_TOURNAMENT_TYPE_PROGRESSIVE;
			 fpTypeScore = PARAM_SCORES_TYPE_MY_CURRENT_RANK;
			 postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_PROGRESSIVE_CURRENT_RANK;  
			 getScoresRegistrationCheck();  
        } return true;
      
        case MENU_ACTION_GET_SCORES_PROGRESSIVE_MY_TOURNAMENTS : {
			fpTypeTournament = PARAM_TOURNAMENT_TYPE_PROGRESSIVE;
			fpTypeScore = PARAM_SCORES_TYPE_MY_TOURNAMENTS;
			postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_PROGRESSIVE_MY_TOURNAMENTS;  
			getScoresRegistrationCheck();  
        } return true;
      
        case MENU_ACTION_GET_SCORES_PROGRESSIVE_ALL_TIME_BEST : {
			fpTypeTournament = PARAM_TOURNAMENT_TYPE_PROGRESSIVE;
			fpTypeScore = PARAM_SCORES_TYPE_GLOBAL_RANKS;
			postRegistrationAdvanceGameState = MENU_ACTION_GET_SCORES_PROGRESSIVE_ALL_TIME_BEST;  
			getScoresRegistrationCheck(); 
        } return true;
            
        case PARAM_MENU_ACTION_SWITCH_TO_GAME : { 
     	   // If tournament game
     	   if ( fpa->getCurrentTournamentType() != PARAM_TOURNAMENT_TYPE_PRACTICE && !alreadyEntered) {
     		   doNetworkTransaction( LOAD_ACTION_FP_ENTER_TOURNAMENT ); 
     		   //fpa->gameStarted();
     	   } 
        } return true;
        
		case MENU_ACTION_GET_TOURNAMENTS_H2H: {

			postRegistrationAdvanceGameState = MENU_ACTION_GET_TOURNAMENTS_H2H;
			//System.out.println("GameCanvasMenu.menuAction()--MENU_ACTION_GET_TOURNAMENTS_H2H"); 
			fpa->setCurrentTournamentType((byte)PARAM_TOURNAMENT_TYPE_H2H);  
			fpHeaderString = strings->getString(FP_STR_CONST_ID_ITEM_LABEL_H2H);
			
			if( fpa->getRegistrationState() != 0 ) { 
				
				if (fpa->_outOfSeeds || !fpa->ValidateTournament() )//|| reloadTournaments)
				{	// do GetTournamentRequest
					reloadTournaments = false;
					doNetworkTransaction( LOAD_ACTION_FP_GET_TOURNAMENTS ); 
				}
				else
				{	// winner, news, prize view
					if (fpa->DisplayWinner())
						ForPrizeTestbed::self->setMenu(MENU_WINNER);
					else if (fpa->DisplayNews(false)) 
						ForPrizeTestbed::self->setMenu(MENU_NEWS);
					else
						ForPrizeTestbed::self->setMenu(MENU_PRIZES);
				}
				/*
				if (GETCLIENT()->OutOfSeeds() || !GETCLIENT()->ValidateTournament(dwParam)) {
				return ViewManager::SetCurrentView(new GetTournamentsProgressView(dwParam));
			}
			else {
				if (GETCLIENT()->DisplayWinner()) {
					return ViewManager::SetCurrentView(new WinnerView(dwParam));
				}
				else if (GETCLIENT()->DisplayNews(false)) {
					return ViewManager::SetCurrentView(new PromoView(dwParam));
				}
				else {
					return ViewManager::SetCurrentView(new PrizeView(dwParam));
				}
				
			}
*/
		 	} else {
				// AW: even if not registered, we TRY just to get the default name
				doNetworkTransaction( LOAD_ACTION_FP_REGISTER ); 
			// 	return menuCommand( MENU_ACTION_CHECK_REGISTRATION );
		 	}
			          	 
		} return true;
        
		case MENU_ACTION_GET_TOURNAMENTS_PROGRESSIVE: {
           	 postRegistrationAdvanceGameState = MENU_ACTION_GET_TOURNAMENTS_PROGRESSIVE;
           	 fpa->setCurrentTournamentType((byte)PARAM_TOURNAMENT_TYPE_PROGRESSIVE);            	 
           	 fpHeaderString = strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE);
       		 if( fpa->getRegistrationState() != 0 ) { 
				DEBUG(("reloadTournaments=%b",reloadTournaments));
				if (fpa->_outOfSeeds || !fpa->ValidateTournament() )//|| reloadTournaments )
				{	// do GetTournamentRequest
					reloadTournaments = false;
					doNetworkTransaction( LOAD_ACTION_FP_GET_TOURNAMENTS ); 
				}
				else
				{	// winner, news, prize view
					if (fpa->DisplayWinner())
						ForPrizeTestbed::self->setMenu(MENU_WINNER);
					else if (fpa->DisplayNews(false)) 
						ForPrizeTestbed::self->setMenu(MENU_NEWS);
					else
						ForPrizeTestbed::self->setMenu(MENU_PRIZES);
				}
				/*
				if (GETCLIENT()->OutOfSeeds() || !GETCLIENT()->ValidateTournament(dwParam)) {
				return ViewManager::SetCurrentView(new GetTournamentsProgressView(dwParam));
			}
			else {
				if (GETCLIENT()->DisplayWinner()) {
					return ViewManager::SetCurrentView(new WinnerView(dwParam));
				}
				else if (GETCLIENT()->DisplayNews(false)) {
					return ViewManager::SetCurrentView(new PromoView(dwParam));
				}
				else {
					return ViewManager::SetCurrentView(new PrizeView(dwParam));
				}
				
			}
*/
		 	} else {
				// AW: even if not registered, we TRY just to get the default name
				doNetworkTransaction( LOAD_ACTION_FP_REGISTER ); 
			// 	return menuCommand( MENU_ACTION_CHECK_REGISTRATION );
		 	}
           	          	  	 
       } return true;

		case MENU_ACTION_CHECK_REGISTRATION: {
            int register_state = fpa->getRegistrationState();
            //System.out.println("GCMFP.menuAction()--registration_state=" + register_state);
            switch(register_state) {
            	case PARAM_REGISTER_PHONE_NEEDED:
            		setMenu(MENU_REGISTRATION);	                		                		
            		break;
            	case PARAM_REGISTER_PIN_NEEDED:
            		setMenu(MENU_ENTER_PIN);
            		break;
            	case PARAM_REGISTER_PIN_VALIDATED:
            		setMenu(MENU_ENTER_USER_NAME);
            		break;

            		
            		
            	case PARAM_REGISTER_DONE:
            		setMenu(MENU_TOURNAMENT);
            		break;
            }
            
  		} return true;
		
		case MENU_ACTION_DETERMINE_REGISTRATION_SCREEN: {
			// Short Circuit, if the carrier adapter want to display something for registration
			setMenu( TBModuleEvents::getCarrierAdapter()->carrierRegistration() );
		} return true;
		
		case MENU_ACTION_REGISTER: {
           	 doNetworkTransaction( LOAD_ACTION_FP_REGISTER ); 
		} return true;
			
		case MENU_ACTION_VIEW_PROMO:
		{	// off menu we always set promoID to 1
			fpa->setPromoID(1);
			postRegistrationAdvanceGameState = MENU_TOURNAMENT;
			doNetworkTransaction ( LOAD_ACTION_FP_GET_PROMO );
		} return true;
		
		/*
		 * If we're not dealing with an action, then assume its just a setMenu call
		 */
		default: {
			// If this is a Carrier Registration Screen Forward
			if (carrierAdapter->menuCommand(menuCommandData)) return true;
			
			// Otherwise treat as simply a menu screen
			return setMenu(menuCommandData);
		}
		
	}

}

bool ForPrizeTestbed::menuInput(int menuId, int menuEntryIndex, int menuEntryType, int entryData, String entryText) {
		
//#ifdef DEBUG_ON
	DEBUG(("FP:menuInput(%s,%d,%d,%d,%s)",getScreenName(menuId).toCharArray(),menuEntryIndex, menuEntryType,entryData,entryText.toCharArray()));
//#endif
			
	switch (menuId) {
		
		case MENU_SCORES_MY_TOURNAMENTS:{
				fpTurnamentHistoryIndex = entryData;
		}	return true;
		
		case MENU_EXISTING_USER_NAME:
		case MENU_ENTER_USER_NAME:
			fpa->setUsername(entryText);
			return true;
			
		case MENU_SMS_OPTION:
			fpa->setSMSOptIn(entryData == MENU_ELEMENT_SWITCH_ON);
			return true;
			
		default: {
//#ifdef DEBUG_ON
			DEBUG(("menuInput(%d, %d, %d, %d, %d): Unknown Input Field",menuId,menuEntryIndex,menuEntryType,entryData,entryText.toCharArray()));
//#endif
		} return false;
	}
	
}

String ForPrizeTestbed::getScreenName(int screenState) {
	switch (screenState) {
		// TODO We can put debug names for the various screens here if it makes life easier 
		case MENU_LOADING: return "Loading Screen";
		case MENU_WINNER: return "Winner Dynamic Screen";
		case MENU_NEWS: return "News Dynamic Screen";
		case MENU_PRIZES: return "Prizes Dynamic Screen";
		default: return "Unknown State";
	}
}

bool ForPrizeTestbed::setMenu(int newScreenState) {
//#ifdef DEBUG_ON
	DEBUG(("%s --> %s",getScreenName(menuState).toCharArray(), getScreenName(newScreenState).toCharArray()));
//#endif
	
	if ((newScreenState & MENU_FLAG_SCREEN) == MENU_NULL ) {
//#ifdef DEBUG_ON
		DEBUG(("setScreen(%d,%s): INVALID Menu Screen State", (newScreenState & MENU_MASK_FLAGS), getScreenName(newScreenState).toCharArray()));
//#endif
		return false;
	}
	
	if (menuTickOn && !fromMenuTick) {
		menuStateAfterTick = newScreenState;
		return true;
	}
	
	bool toReturn = true;
	
	int oldScreenState = this->menuState;
	this->menuState = newScreenState;
	String tmp;
	char str[10];
	switch (newScreenState) {
		
		//ADI new screens for p4p module
		/*
		 *
		 * For Errors, set errorForeState, errorTitleString and errorContents string.
		 * 
		 * errorBackState can also be set if you want to offer a retry option.
		 * 
		 * -ESC
		 */
		 
		 
		 
		case MENU_SCREEN_HELP: {
			menuTrigger->setMenu(newScreenState,0,2,strings->getString(FP_STR_CONST_ID_SCREEN_HELP));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENTS),
					MENU_HELP_TOURNAMENTS,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_LEGAL),
					MENU_HELP_LEGAL,
					"",NULL);
			menuTrigger->endSetMenu(newScreenState);
		} break;
		
		case MENU_HELP_TOURNAMENTS: {
			menuTrigger->setMenu(newScreenState,1,1,strings->getString(FP_STR_CONST_ID_SCREEN_HELP));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_STATIC_TEXT,
					"",0,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_TOURNAMENTS),
					NULL);	
			menuTrigger->endSetMenu(newScreenState);
		} break;
		
		case MENU_HELP_LEGAL: {
			menuTrigger->setMenu(newScreenState,1,1,strings->getString(FP_STR_CONST_ID_SCREEN_HELP));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_STATIC_TEXT,
					"",0,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_LEGAL),
					NULL);	
			menuTrigger->endSetMenu(newScreenState);
		} break;
		
		/*
		This is now handled by a dynamic server-fed screen -ESC
		case MENU_WELCOME: {
			menuTrigger->setMenu(newScreenState,0,1,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_WELCOME));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_FORE),
					-1,
					"",NULL);
			tmp = strings->getString(FP_STR_CONST_ID_ITEM_LABEL_WELCOME1);
			tmp += strings->getString(CLIENT_STR_CONST_ID_GAME_NAME);
			tmp += strings->getString(FP_STR_CONST_ID_ITEM_LABEL_WELCOME2);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_STATIC_TEXT,
					"",-1,
					tmp,NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		*/
		
		case MENU_PROMO:
			return setDynamicMenu(newScreenState,fpa->getPromoImage(),fpa->getPromoText());

		case MENU_SCREEN_GAME_RESULTS: {
			menuTrigger->setMenu(newScreenState,1,2,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_MATCH_RESULTS));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_P4P_MENU),
					-1,"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_YES),
					-1,"",NULL);
			tmp = strings->getString(FP_STR_CONST_ID_END_GAME_SCORE);
			tmp += _itoa(curScore,str,10);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_DYNAMIC_TEXT,
					"",0,
					 tmp,
					NULL);	
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_STATIC_TEXT,
					"",0,
					strings->getString(FP_STR_CONST_ID_END_GAME_SEND_SCORE_QUESTION),
					NULL);	
			menuTrigger->endSetMenu(newScreenState);
		} break;

		case MENU_INVALID_USER_NAME: {
			setErrorMenu(FP_STR_CONST_ID_ITEM_LABEL_ERROR,FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_USER_NAME,MENU_ENTER_USER_NAME,MENU_NULL);
		} return true;
		
		case MENU_NETWORK_N0T_AVAILABLE: 
		case MENU_ERROR_GENERAL: {

			// NOTE: The construction of these global strings should only be done in setErrorMenu (Ideally, this
			// Code could probably move there too) - Scott

			menuTrigger->setMenu(newScreenState,0,2,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR));
			
			if (errorForeState != MENU_OFF) {	
				if (errorForeState == MENU_ENTER_USER_NAME) {
					menuTrigger->setMenuEntry(newScreenState,-1,
						MENUENTRY_COMMAND_FORE,
						strings->getString(FP_STR_CONST_ID_FORE),
						-1,"",NULL);
				} else {
					menuTrigger->setMenuEntry(newScreenState,-1,
						MENUENTRY_COMMAND_FORE,
						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_RETRY),
						-1,"",NULL);
				}
			} 
				
			if (errorBackState != MENU_OFF) {
				menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,"",NULL);
			} 

			// Display Error Information
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_STATIC_TEXT,
					errorTitleString,-1,
					errorContentsString,
					NULL);

			menuTrigger->endSetMenu(newScreenState);

		}	break;

		
		case MENU_SMS_OPTION: {
			String options = strings->getString(FP_STR_CONST_ID_BOOL_OPTION_ON);
			options += ",";
			options += strings->getString(FP_STR_CONST_ID_BOOL_OPTION_OFF);
			menuTrigger->setMenu(newScreenState,1,2,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_FORE),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_STATIC_TEXT,
					"",
					-1,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SMS_NOTIFY),
					NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_INPUT_SWITCH,
					"",
					0,
					options,
					NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_LOADING: {
			menuTrigger->setMenu(newScreenState,0,2,strings->getString(FP_STR_CONST_ID_CONNECTING));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_CANCEL),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_DYNAMIC_TEXT,
					"",-1,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SLOGAN),
					NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_DYNAMIC_PROGRESS,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESS),
					0, 
					fpa->_userName,
					NULL);
			menuTrigger->endSetMenu(newScreenState);
		} return true;
		
		case MENU_EXISTING_USER_NAME:
		case MENU_ENTER_USER_NAME: {
			if(newScreenState == MENU_EXISTING_USER_NAME)
				menuTrigger->setMenu(newScreenState,0,3,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION));
			else
				menuTrigger->setMenu(newScreenState,2,3,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_FORE),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_DYNAMIC_TEXT,
					"",-1,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION),
					NULL);
			if (newScreenState == MENU_EXISTING_USER_NAME) {
				menuTrigger->setMenuEntry(newScreenState,1,
						MENUENTRY_STATIC_TEXT,
						"",	-1, 
						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_EXISTING_USERNAME),
						NULL);

			} else {
				menuTrigger->setMenuEntry(newScreenState,1,
						MENUENTRY_STATIC_TEXT,
						"",	-1, 
						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_ENTER_NAME),
						NULL);
			}
			menuTrigger->setMenuEntry(newScreenState,2,
					MENUENTRY_INPUT_TEXT,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_3_CHAR_MIN),
					FORPRIZE_NAME_FIELD_MAX_SIZE, 
					fpa->_userName,
					NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_REGISTRATION: {
			menuTrigger->setMenu(newScreenState,0,2,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_FORE),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_DYNAMIC_TEXT,
					"",-1,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION),
					NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_STATIC_TEXT,
					"",-1,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION_REQUEST)
					,NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_WINNER: return setDynamicMenu(newScreenState,fpa->getWinnerImage(),fpa->getWinnerText());
		case MENU_NEWS: return setDynamicMenu(newScreenState,fpa->getNewsImage(),fpa->getNewsText());
		case MENU_PRIZES: return setDynamicMenu(newScreenState,fpa->getPrizeImage(fpa->getCurrentTournamentType()),fpa->getPrizeText(fpa->getCurrentTournamentType()));
		case MENU_MATCH_RESULTS: return setDynamicMenu(newScreenState,NULL,fpa->getMatchSummary());
		case MENU_RANK_SUMMARY: return setDynamicMenu(newScreenState,NULL,fpa->getRankSummary());
		
//			case MENU_HELP_HOW_TO_PLAY: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_HOW_TO_PLAY));
//				menuTrigger->setMenuEntry(newScreenState,-1,
//						MENUENTRY_COMMAND_BACK,
//						strings->getString(FP_STR_CONST_ID_BACK),
//						-1,
//						NULL,NULL);
////				TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
//			
//			case MENU_HELP_SCORING: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_SCORING));
//				menuTrigger->setMenuEntry(newScreenState,-1,
//						MENUENTRY_COMMAND_BACK,
//						strings->getString(FP_STR_CONST_ID_BACK),
//						-1,
//						NULL,NULL);
////				TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
//			
//			case MENU_HELP_TIPS_AND_TRICKS: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_TIPS_AND_TRICKS));
//				menuTrigger->setMenuEntry(newScreenState,-1,
//						MENUENTRY_COMMAND_BACK,
//						strings->getString(FP_STR_CONST_ID_BACK),
//						-1,
//						NULL,NULL);
////				TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
		
		
//			case MENU_HELP: {
//				menuTrigger->setMenu(newScreenState,0,5,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP));
//				menuTrigger->setMenuEntry(newScreenState,-1,
//						MENUENTRY_COMMAND_BACK,
//						strings->getString(FP_STR_CONST_ID_BACK),
//						-1,
//						NULL,NULL);
//				menuTrigger->setMenuEntry(newScreenState,0,
//						MENUENTRY_COMMAND,
//						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_HOW_TO_PLAY),
//						MENU_ACTION_MAKE_SCROLL_BOX_HELP_HOW_TO_PLAY,
//						NULL,NULL);
//				menuTrigger->setMenuEntry(newScreenState,1,
//						MENUENTRY_COMMAND,
//						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_SCORING),
//						MENU_ACTION_MAKE_SCROLL_BOX_HELP_SCORING,
//						NULL,NULL);
//				menuTrigger->setMenuEntry(newScreenState,2,
//						MENUENTRY_COMMAND,
//						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_TIPS_AND_TRICKS),
//						MENU_ACTION_MAKE_SCROLL_BOX_HELP_TIPS_AND_TRICKS,
//						NULL,NULL);
//				menuTrigger->setMenuEntry(newScreenState,3,
//						MENUENTRY_COMMAND,
//						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_TOURNAMENTS),
//						MENU_ACTION_MAKE_SCROLL_BOX_HELP_TOURNAMENTS,
//						NULL,NULL);
//				menuTrigger->setMenuEntry(newScreenState,4,
//						MENUENTRY_COMMAND,
//						strings->getString(FP_STR_CONST_ID_ITEM_LABEL_HELP_LEGAL),
//						MENU_ACTION_MAKE_SCROLL_BOX_HELP_LEGAL,
//						NULL,NULL);
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;

		case MENU_SCORES_DISPLAY: {
			menuTrigger->setMenu(newScreenState,0,1,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SCORES));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			switch( fpTypeScore ) {
	    					 case PARAM_SCORES_TYPE_MY_CURRENT_RANK:		    						 
	    					 case PARAM_SCORES_TYPE_MY_RECENT_MATCHES:
	    					 case PARAM_SCORES_TYPE_GLOBAL_RANKS:
	    					 case PARAM_SCORES_TYPE_MY_TOURNAMENTS:{
								 menuTrigger->setMenuEntry(newScreenState,0,
											MENUENTRY_STATIC_TEXT,
											"",-1,
											textScore,
											NULL);
								} break;
			}



//				TODO
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_SCORES_MY_TOURNAMENTS: {
			//int size = fpa->getTournamentHistoryHeaders().size();
			// AW : Hardcode size max 10
			int size = 10;
			menuTrigger->setMenu(newScreenState,0,1,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENTS));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_FORE),
					-1,
					"",NULL);
					
			/*
			String options = "";		
		  for(int i = 0; i < size; i++ ) {
		  	options += *((String*)fpa->getTournamentHistoryHeaders()[i]);
		  	if (i != size - 1) options += ",";
			}
*/

			String options = "";	
			String temp = fpa->getTournamentHistoryHeader(0);
		  for(int i = 1; i < size; i++ ) 
		  {
			  options += temp;
			  
			  temp = fpa->getTournamentHistoryHeader(i);
			  if (temp.length() == 0)
				  break;	// no more
			  else
				  options += ",";
		   	  
		  
		  }
			//fpa->getTournamentHistoryHeaders(i)
			menuTrigger->setMenuEntry(newScreenState,0,
							MENUENTRY_INPUT_SWITCH,
							strings->getString(FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENTS),
							0,
							options,NULL);
					
					
					
//				TODO
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_SCORES_H2H: {
			menuTrigger->setMenu(newScreenState,0,4,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_H2H));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_CURRENT_RANK),
					MENU_ACTION_GET_SCORES_H2H_CURRENT_RANK,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_RECENT_MATCHES),
					MENU_ACTION_GET_SCORES_H2H_RECENT_MATCHES,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,2,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_MY_TOURNAMENTS),
					MENU_ACTION_GET_SCORES_H2H_MY_TOURNAMENTS,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,3,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_GLOBAL_RANKS),
					MENU_ACTION_GET_SCORES_H2H_GLOBAL_RANKS,
					"",NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_SCORES_PROGRESSIVE: {
			menuTrigger->setMenu(newScreenState,0,3,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_CURRENT_RANK),
					MENU_ACTION_GET_SCORES_PROGRESSIVE_CURRENT_RANK,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_MY_TOURNAMENTS),
					MENU_ACTION_GET_SCORES_PROGRESSIVE_MY_TOURNAMENTS,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,2,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ALL_TIME_BEST),
					MENU_ACTION_GET_SCORES_PROGRESSIVE_ALL_TIME_BEST,
					"",NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_SCORES: {
			menuTrigger->setMenu(newScreenState,0,2,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SCORES));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_H2H),
					MENU_SCORES_H2H,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE),
					MENU_SCORES_PROGRESSIVE,
					"",NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
		case MENU_TOURNAMENT: {
			isReplay = false;
			menuTrigger->setMenu(newScreenState,0,4,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_TOURNAMENT));
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_BACK,
					strings->getString(FP_STR_CONST_ID_BACK),
					-1,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,0,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_H2H),
					MENU_ACTION_GET_TOURNAMENTS_H2H,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,1,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESSIVE),
					MENU_ACTION_GET_TOURNAMENTS_PROGRESSIVE,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,2,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROMO),
					MENU_ACTION_VIEW_PROMO,
					"",NULL);
			menuTrigger->setMenuEntry(newScreenState,3,
					MENUENTRY_COMMAND,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SCORES),
					MENU_SCORES,
					"",NULL);
			menuTrigger->endSetMenu(newScreenState);
		}	break;
		
//			case MENU_SUBSCRIPTION_THANKS: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION));
//				//TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
//			
//			case MENU_SUBSCRIPTION_CONFIRM: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION));
//				//TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
//			
//			case MENU_SUBSCRIPTION: {
//				menuTrigger->setMenu(newScreenState,0,0,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_SUBSCRIPTION));
//				//TODO
//				menuTrigger->endSetMenu(newScreenState);
//			}	break;
		
		default: {
			
			// See if this is a carrier Registration screen
			if (carrierAdapter->setMenu(newScreenState)) {
//#ifdef DEBUG_ON
				DEBUG(("ForPrizeTestbed.setMenu(): Deferring to Carrier Adapter Interface"));
//#endif
				return true;
			}
			
			// Otherwise this is an unsupported menu state
//#ifdef DEBUG_ON
			DEBUG(("setScreen(%d): UNKNOWN Menu Screen State, reverting too: %s",(newScreenState & MENU_MASK_FLAGS), getScreenName(oldScreenState).toCharArray()));
//#endif
			this->menuState = oldScreenState;
		}	return false;
		
	}
	
	return toReturn;
}

bool ForPrizeTestbed::setDynamicMenu(int newScreenState,ConvertedBitmapInfo* dynamicMenuImage, String dynamicMenuString) {
//#ifdef DEBUG_ON
	if (dynamicMenuString == "") dynamicMenuString = "UNKNOWN OR UNLOADED DYNAMIC MENU STRING!";
//#endif
	int menuSize = 2;
	if (dynamicMenuImage == NULL) menuSize = 1;
	menuTrigger->setMenu(newScreenState,0,menuSize,strings->getString(FP_STR_CONST_ID_ITEM_LABEL_NEWS));
	if(newScreenState == MENU_MATCH_RESULTS || newScreenState == MENU_PRIZES){
		menuTrigger->setMenuEntry(newScreenState,-1,
			MENUENTRY_COMMAND_BACK,
			strings->getString(FP_STR_CONST_ID_P4P_MENU),
			-1,
			"",NULL);
	} else { 
		menuTrigger->setMenuEntry(newScreenState,-1,
				MENUENTRY_COMMAND_BACK,
				strings->getString(FP_STR_CONST_ID_BACK),
				-1,
				"",NULL);
	}
	if (newScreenState == MENU_PRIZES) {
		
		// MENU_TOURNAMENT resets isReplay to false.  -ESC
		if (!isReplay) {
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PLAY),
					-1,
					"",NULL);
			isReplay=true;
		} else {
			menuTrigger->setMenuEntry(newScreenState,-1,
					MENUENTRY_COMMAND_FORE,
					strings->getString(FP_STR_CONST_ID_REPLAY),
					-1,
					"",NULL);
		}

	} else {
		menuTrigger->setMenuEntry(newScreenState,-1,
				MENUENTRY_COMMAND_FORE,
				strings->getString(FP_STR_CONST_ID_FORE),
				-1,
				"",NULL);
	}
	if (dynamicMenuImage != NULL) {
		menuTrigger->setMenuEntry(newScreenState,0,
				MENUENTRY_DYNAMIC_IMAGE,
				"",-1,"",
				dynamicMenuImage);
	}
	menuTrigger->setMenuEntry(newScreenState,menuSize-1,
			MENUENTRY_STATIC_TEXT,
			dynamicMenuString,
			-1,
			"",NULL);
	menuTrigger->endSetMenu(newScreenState);
//#ifdef DEBUG_ON
	
//#endif
	return true;
}
/**

The General Handler has been replaced by specific setErrorMenu calls

void ForPrizeTestbed::handleGeneralError() {
//#ifdef DEBUG_ON
	char str[10];
	DEBUG(("_errorNum=%d", fpa->getErrorNum()));
 	DEBUG(("_errorStr=%s", fpa->getErrorStr().toCharArray()));
	errorTitleString=strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR);
	errorContentsString = _itoa(fpa->getErrorNum(),str,10);
	errorContentsString += ": ";
	errorContentsString += fpa->getErrorStr();
//#else
	errorTitleString=strings->getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR);
	errorContentsString = fpa->getErrorStr();
	//errorTitleString = strings.getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK);
	//errorContentsString = strings.getString(FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_NOT_AVAILABLE);
//#endif
	errorForeState = MENU_TOURNAMENT;
	if (fpa->getErrorNum() == PARAM_ERR_T4P_SYSTEM_UNAVAILABLE) errorBackState = MENU_ACTION_RETRY_NETWORK;
	setMenu( MENU_ERROR_GENERAL );
}

*/

void ForPrizeTestbed::setErrorMenu(int errorTitle, int errorContents, int backState, int foreState) {
	errorTitleString = strings->getString(errorTitle);
	errorContentsString = strings->getString(errorContents);

	DEBUG(("\nForPrizeTestbed::setErrorMenu("));
	DEBUG(("\n%s,",errorTitleString.toCharArray()));
	DEBUG(("\n%s,",errorContentsString.toCharArray()));
	DEBUG(("\n%d,",backState));
	DEBUG(("\n%d,",foreState));
	
	if (backState == MENU_NULL) backState = foreState;
	
	errorForeState = foreState;
	errorBackState = backState;	
	
	setMenu(MENU_ERROR_GENERAL);
}

bool ForPrizeTestbed::doNetworkTransaction( int actionID ) {
	if (actionID == MENU_ACTION_RETRY_NETWORK) {
		actionID = lastNetworkAction;
		ForPrizeTestbed::self->fpa->_hasNextTournaments = fpTournAvailFlag;
	} else {
		lastNetworkAction = actionID;
		fpTournAvailFlag = ForPrizeTestbed::self->fpa->_hasNextTournaments;
	}
	ForPrizeTestbed::ForPrizeNetworkAction::run = true;
	
	/* - Caneled requests handled below -ESC
	 //don't allow to have working multiple network threads	
//	 while (requestCancelled == true) Thread.yield();
	if(requestCancelled == true)
		ForPrizeTestbed::ForPrizeNetworkAction::run = false;
*/
	// TODO: Add all server request calls here so it is outside run loop. 
	if (actionID == LOAD_ACTION_FP_GET_PROMO)
	{
		ForPrizeTestbed::self->fpa->sendGetPromoRequest( 0, ForPrizeTestbed::self->fpa->getCurrentPromoID() );
	}
	else if (actionID == LOAD_ACTION_FP_REGISTER)
	{
		ForPrizeTestbed::self->fpa->registerPlayer();
	}
	else if (actionID == LOAD_ACTION_FP_GET_TERMSANDCONDITION)
	{
		ForPrizeTestbed::self->fpa->sendGetPromoRequest( 0, 5001 );
	}
	else if (actionID == LOAD_ACTION_FP_GET_TOURNAMENTS)
	{
		ForPrizeTestbed::self->fpa->getTournaments();
	}
	else if (actionID == LOAD_ACTION_FP_ENTER_TOURNAMENT)
	{
		ForPrizeTestbed::self->fpa->enterTournament(ForPrizeTestbed::self->fpa->getCurrentTournamentType());
	}
	else if (actionID == LOAD_ACTION_FP_GET_SCORES)
	{
		ForPrizeTestbed::self->fpa->getScores((byte)ForPrizeTestbed::self->fpTypeTournament, ForPrizeTestbed::self->fpTypeScore);
	}
	else if (actionID == LOAD_ACTION_FP_REPORT_GAME_SCORE)
	{
		ForPrizeTestbed::self->fpa->reportGameScore(ForPrizeTestbed::self->curScore, NULL);
	}

	 if( !fwcanceledLoading ) {
	//	 ForPrizeTestbed::ForPrizeNetworkAction(actionID)._run(this);
		 //ForPrizeTestbed::ForPrizeNetworkAction
		 setMenu(MENU_LOADING);
		 return true;
	 }
	 return false;
}

boolean ForPrizeTestbed::ForPrizeTestbed_HandleEvent(void *pApp, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
	//return ((slyderApp*)pApp)->pGame->handleEvent(eCode, wParam, dwParam);
	// if( ForPrizeTestbed::self->fpa->requestResponse == EVT_AMTP_GET_PROMOTION_RESPONSE ) 

	 switch (eCode)
	 {
		 case EVT_AMTP_GET_PROMOTION_RESPONSE:
			ForPrizeTestbed::self->setMenu(MENU_PROMO);	// PROMO MENU
			break;

		 case EVT_AMTP_REGISTER_RESPONSE:
		    // set registered flag. Show TC message
			ForPrizeTestbed::self->fpa->setRegisterState(PARAM_REGISTER_DONE);
			ForPrizeTestbed::self->doNetworkTransaction( LOAD_ACTION_FP_GET_TERMSANDCONDITION );
			break;

		 case EVT_AMTP_GET_SCORES_RESPONSE:
			 switch( ForPrizeTestbed::self->fpTypeScore ) 
			 {
    					 case PARAM_SCORES_TYPE_MY_CURRENT_RANK:		    						 
    					 case PARAM_SCORES_TYPE_MY_RECENT_MATCHES:
    					 case PARAM_SCORES_TYPE_GLOBAL_RANKS:
    						 ForPrizeTestbed::self->textScore = ForPrizeTestbed::self->fpa->getScoreSummary();
    						 ForPrizeTestbed::self->setMenu( MENU_SCORES_DISPLAY );
    						 break;
    						 
    					 case PARAM_SCORES_TYPE_MY_TOURNAMENTS:

    						 //System.out.println("GCMFP.load()--About to getTournamentHistoryHeaders");
							// if( ForPrizeTestbed::self->fpa->getTournamentHistoryHeaders().size() == 0 ) {
    						//	 //System.out.println("GCMFP.load()--PARAM_SCORES_TYPE_MY_TOURNAMENTS--Tournamnet history headers NULL");	
	    					//	 ForPrizeTestbed::self->textScore = ForPrizeTestbed::self->fpa->getScoreSummary();
    						//	 ForPrizeTestbed::self->setMenu( MENU_SCORES_DISPLAY );
    						//	 break;
    						// }
    						// else {
    							 //System.out.println("GCMFP.load()--PARAM_SCORES_TYPE_MY_TOURNAMENTS--fpa.getTournamentHistoryHeaders().size()=" + fpa.getTournamentHistoryHeaders().size() );		    							 
    							ForPrizeTestbed::self->setMenu( MENU_SCORES_MY_TOURNAMENTS );
    							break;
    						// }
    						 
    					 default:
    						 //System.out.println("GameCanvasMenu.update()--Unknown Score Type");
							 break;
			 }
			 break;

		 case EVT_AMTP_ENTER_TOURNAMENT_RESPONSE:
			 {
			 ForPrizeTestbed::self->notifyModule(MODULE_NOTIFY_START_GAME,0);

			 byte *pSeed;
			 int32 seedLen;
			 char *params;
			 int32 paramsLen;
			 ForPrizeTestbed::self->fpa->getGameSeed((const byte **)&pSeed, &seedLen, (const char **)&params, &paramsLen);
             if (pSeed == NULL)
				return false;

			Bbyte temp;
			//short _temp[] = { - 1,4, 48, 51, 52, 100, -1, 40, -1, 90,- 1};
			temp.removeAll();
			for(int i=0; i < seedLen; i++)
			{
				temp.append(pSeed[i]);
			}
			ForPrizeTestbed::self->notifyClient(CLIENT_GAME_START,temp);
			// ForPrizeTestbed::self->notifyClient(CLIENT_GAME_START,ForPrizeTestbed::self->fpa->getGameSeed(ForPrizeTestbed::self->fpTournamentParameters));
			 ForPrizeTestbed::self->fpa->gameStarted();
			
			 }	 

			 break;

		 case EVT_AMTP_GET_TOURNAMENTS_RESPONSE:

		    if (ForPrizeTestbed::self->fpa->_isGettingScore)
				return true;

			/* Error handling is at a lower level
			if (ForPrizeTestbed::self->fpa->_outOfSeeds)
			{	// TODO: show out of seeds error screeen
				ForPrizeTestbed::self->handleGeneralError(); 
			}
			else
			{
			*/
				if (ForPrizeTestbed::self->fpa->DisplayWinner())
						ForPrizeTestbed::self->setMenu(MENU_WINNER);
				else if (ForPrizeTestbed::self->fpa->DisplayNews(false)) 
					ForPrizeTestbed::self->setMenu(MENU_NEWS);
				else
					ForPrizeTestbed::self->setMenu(MENU_PRIZES);
			//}
			break;

		 case EVT_AMTP_WEB_PROGRESS:
			 if (!ForPrizeTestbed::self->isGameRunning)
				 ForPrizeTestbed::self->fpProgress(wParam);
			 break;

		 case EVT_AMTP_REPORT_SCORE_RESPONSE:
			 ForPrizeTestbed::self->reloadTournaments = true;
			 ForPrizeTestbed::self->alreadyEntered = false;
				 
			 switch( ForPrizeTestbed::self->fpa->getCurrentTournamentType() ) {
				 case PARAM_TOURNAMENT_TYPE_H2H :
					 ForPrizeTestbed::self->setMenu(MENU_MATCH_RESULTS);
					 break;
					 
				 case PARAM_TOURNAMENT_TYPE_PROGRESSIVE : 
					 ForPrizeTestbed::self->setMenu(MENU_RANK_SUMMARY);
					 break;    	 		
			 }   
			
			 break;


		 case EVT_AMTP_SET_OPTIONS_RESPONSE:
			// TODO: AW THIS MIGHT NOT BE NEEDED
			 break;

		 case EVT_AMTP_ERROR:

			 // This is the default Network error screen
			 int errorTitleString = FP_STR_CONST_ID_ITEM_LABEL_ERROR;
			 int errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_NOT_AVAILABLE;
			 int foreState = MENU_NULL;
			 int backState = MENUENTRY_COMMAND_BACK;

			 switch (wParam) {

				// Base system errors
				default:
				case ERR_AMTP_TOURNAMENT_ENTER_REJECTED:
				case ERR_AMTP_TOURNAMENT_SCORE_REJECTED: 
				case ERR_AMTP_SYSTEM_UNAVAILABLE:
				case ERR_AMTP_ILLEGAL_OPERATION:
				case ERR_AMTP_DATABASE_ERROR: {
					errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK_NOT_AVAILABLE;
					foreState = MENU_ACTION_RETRY_NETWORK;
					backState = MENU_TOURNAMENT;
				} break;

				case ERR_AMTP_INVALID_MIN: {
					errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_MIN;
					backState = MENU_TOURNAMENT;
				} break;

				// Client software errors
				case ERR_AMTP_UNKNOWN_CLIENT_SOFTWARE:
				case ERR_AMTP_OBSOLETE_CLIENT_SOFTWARE:
				case ERR_AMTP_OBSOLETE_GAME: {
					errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_UNSUPPORTED_PHONE;
					backState = MENU_TOURNAMENT;
				} break;

				case ERR_AMTP_ACCOUNT_USERNAME_MISMATCH: {
					errorTitleString = FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION;
					errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_INVALID_USER_NAME;
					backState=MENU_EXISTING_USER_NAME;
				} break;

				case ERR_AMTP_INVALID_USERNAME:
				case ERR_AMTP_EXISTING_USERNAME: {
						errorTitleString = FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION;
						errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_EXISTS;
						foreState=MENU_ENTER_USER_NAME;
						backState=MENU_NULL;
				} break;

				case ERR_AMTP_ACCOUNT_NOT_FOUND:
				case ERR_AMTP_ACCOUNT_CREATION_REQUIRED: {
						errorTitleString = FP_STR_CONST_ID_ITEM_LABEL_REGISTRATION;
					errorBodyString = FP_STR_CONST_ID_ITEM_LABEL_ERROR_REGISTRATION_USER_NAME_MISMATCH;
					foreState = MENU_ENTER_USER_NAME;
					backState = MENU_NULL;
				} break;

				case ERR_AMTP_TOURNAMENT_NO_MORE_SEEDS: {
						errorBodyString = FP_STR_CONST_ID_OUT_OF_SEEDS;
						backState = MENU_TOURNAMENT;
				} break;

				case ERR_AMTP_ACCOUNT_ALREADY_EXISTS: {
					ForPrizeTestbed::self->fpa->setUsername(ForPrizeTestbed::self->fpa->getErrorStr());
					ForPrizeTestbed::self->setMenu(MENU_EXISTING_USER_NAME);
				} return true; // return out because we're not going to use the error screen
	

		} 

		ForPrizeTestbed::self->setErrorMenu(
			errorTitleString,
			errorBodyString,
			backState,
			foreState);

		break;
		
	 }
	
	 return true;
}


void ForPrizeTestbed::ForPrizeNetworkAction::_run(ForPrizeTestbed * pUser) {


//	//if(run == true);
//	//	ISHELL_SetTimer(((aMain*)GETAPPINSTANCE())->m_pIShell,5000, ( PFNNOTIFY )_run, pUser);
////#ifdef DEBUG_ON
//	DEBUG(("ForPrizeNetworkAction(%d)",ForPrizeTestbed::self->actionID));
//	char str[10];
////#endif
//		switch (ForPrizeTestbed::self->actionID) {
//			
//		 case LOAD_ACTION_FP_GET_PROMO:
//		 {
//			 //System.out.println("GCMFP.load(" + actionID + ")--sendGetPromoRequest " + fpa.getCurrentPromoID());	
//			 //networkProgress = true;
//			 if( ForPrizeTestbed::self->fpa->requestResponse == EVT_AMTP_GET_PROMOTION_RESPONSE ) 
//			 {
//				 if( !ForPrizeTestbed::self->requestCancelled ) { 
////#ifdef DEBUG_ON
//					    DEBUG(("------------------------------------------------------------------->> MENU PROMO"));
////#endif
//					  ForPrizeTestbed::self->setMenu(MENU_PROMO);	// PROMO MENU
//				 }
//			 }
//			 else if( !ForPrizeTestbed::self->requestCancelled ){	    		 
////#ifdef DEBUG_ON
//					    DEBUG(("------------------------------------------------------------------->> MENU PROMO2"));
////#endif
//				 ForPrizeTestbed::self->handleGeneralError(); 
//			 }
//    		 
//    		 ForPrizeTestbed::self->requestCancelled = false;
//			 ForPrizeTestbed::self->fpa->requestResponse = EVT_AMTP_WAIT;
//    		 return;
//		 }
//		 
//    	 case LOAD_ACTION_FP_REGISTER :{
//    		 //System.out.println("GCMFP.load(" + actionID + ")--registerPlayer");	    		 
//    		 //try{            		 
//    			// if( ForPrizeTestbed::self->fpa->registerPlayer() == PARAM_ERR_NONE ) {
//			 if( ForPrizeTestbed::self->fpa->requestResponse == EVT_AMTP_REGISTER_RESPONSE ) {
//    				 //System.out.println("GCMFP.load(" + actionID + ")--registerPlayer->No Error");
//					 ForPrizeTestbed::self->requestCancelled = false;
//    				 if( ForPrizeTestbed::self->requestCancelled ) {
//    					 ForPrizeTestbed::self->requestCancelled = false;	    					 
//    				 } else if( !ForPrizeTestbed::self->requestCancelled ) {	
//    					 //System.out.println("GCMFP.load(" + actionID + ")--about to show welcome menu");
//    					 //setMenu( MENU_WELCOME );	 
//	    				 // 5001 is T&C
//		    			 if( ForPrizeTestbed::self->fpa->sendGetPromoRequest( 0, 5001 ) == PARAM_ERR_NONE ) {
//		    				 if( !ForPrizeTestbed::self->requestCancelled ) { 
//			    				  ForPrizeTestbed::self->promoInWelcome = true;
//		    					  ForPrizeTestbed::self->setMenu(MENU_PROMO);	// PROMO MENU
//		    					  //System.out.println("---------------------------------------->: promo");
//		    				 }
//		    			 }
//		    			 else if( !ForPrizeTestbed::self->requestCancelled ){	    		 
//		    				 ForPrizeTestbed::self->setMenu( MENU_WELCOME );
//		    				 //handleGeneralError(); 
//		    			 }// else 
//			    		 ForPrizeTestbed::self->requestCancelled = false;
//    				 }
//    				 return;
//    			 } else if( ForPrizeTestbed::self->requestCancelled ) {
//    				 //System.out.println("GCMFP.load(" + actionID + ")--registerPlayer->Request Cancelled");	    				 
//    				 ForPrizeTestbed::self->requestCancelled = false;
//    				 return;
//    			 } else if( !ForPrizeTestbed::self->requestCancelled ){	  
//    				 //System.out.println("GCMFP.load(" + actionID + ")--registerPlayer->Error");
//    				 switch(ForPrizeTestbed::self->fpa->getErrorNum()) {	         					
//	    				 case PARAM_ERR_T4P_EXISTING_USER_NAME :
//	    					 ForPrizeTestbed::self->setMenu(MENU_EXISTING_USER_NAME);
////	    					 fpUserName = fpa._userName;
//	    					 break;
//	    				 case PARAM_ERR_T4P_ACCOUNT_USER_NAME_MISMATCH :
//	    					 ForPrizeTestbed::self->setMenu(MENU_MISMATCH_USER_NAME);
////	    					 fpUserName = fpa._userName;
//	    					 break;
//	    					 
//	    				 case PARAM_ERR_T4P_INVALID_USER_NAME :
//	    					 ForPrizeTestbed::self->setMenu(MENU_INVALID_USER_NAME);
//	    					 //fpa._userName = "";
//	    			//		 fpUserName = fpa._userName;
//	    					 break;
//	    					 
//	    				 case PARAM_ERR_T4P_ACCOUNT_PIN_REQUIRED :
//    						 ForPrizeTestbed::self->setMenu(MENU_REGISTRATION_TEXT_MESSAGE);
//	    					 break;	
//	    					 
////		    				 case PARAM_ERR_T4P_ACCOUNT_PIN_INVALID :            	 		
////			    					 if( PARAM_CARRIER_ID == PARAM_CARRIER_ID_T_MOBILE ) {
////			    						 setMenu(MENU_INVALID_PIN);
////			    						 fpPin = "";
////		    					 }		    					 
////		    					 break;
//	    					 
//	    				 default :
//	    				 	 ForPrizeTestbed::self->handleGeneralError();
//    				 }
//    			 }
//        	 ForPrizeTestbed::self->requestCancelled = false;
//			 ForPrizeTestbed::self->fpa->requestResponse = EVT_AMTP_WAIT;
//        	 return;
//    	 }
//    	 
//    	 case LOAD_ACTION_FP_GET_TOURNAMENTS :{
//    			 if ( ForPrizeTestbed::self->fpa->getTournaments() == PARAM_ERR_NONE ) {	    				 
//    				 if( !ForPrizeTestbed::self->requestCancelled ) {
//    					 /*
//    					 imageWin = fpa.getWinnerImage();
//    					 if (imageWin != null) System.out.println("Got Winner Image: " + imageWin.getWidth() + "x" + imageWin.getHeight());
//    					 textWin = fpa.getWinnerText();
//    					 imageNews = fpa.getNewsImage();
//    					 if (imageNews != null) System.out.println("Got News Image: " + imageNews.getHeight() + "x" + imageNews.getHeight());
//    					 textNews = fpa.getNewsText();
//    					 imagePrize = fpa.getPrizeImage(fpa.getCurrentTournamentType());
//    					 if (imagePrize != null) System.out.println("Got Prize Image: " + imagePrize.getHeight() + "x" + imagePrize.getHeight());
//    					 textPrize = fpa.getPrizeText(fpa.getCurrentTournamentType());
//    					 */
//    					 ForPrizeTestbed::self->setMenu(MENU_WINNER);
//    				 }
//    			 } else if( !ForPrizeTestbed::self->requestCancelled ){
//    				 if (ForPrizeTestbed::self->fpa->getErrorNum() == PARAM_ERR_T4P_ACCOUNT_NOT_FOUND) {
//    					 ForPrizeTestbed::self->doNetworkTransaction(LOAD_ACTION_FP_REGISTER);
//		    		 } else {
//		    			 ForPrizeTestbed::self->handleGeneralError();  
//		    		 }
//    			 }
//    		 ForPrizeTestbed::self->requestCancelled = false;
//    		 return;
//    	 }
//    	 
//    	 case LOAD_ACTION_FP_ENTER_TOURNAMENT :{
//			 if( ForPrizeTestbed::self->fpa->enterTournament( ForPrizeTestbed::self->fpa->getCurrentTournamentType() ) == PARAM_ERR_NONE ) {
//				 if( !ForPrizeTestbed::self->requestCancelled ) { 
//					 
//					 ForPrizeTestbed::self->notifyModule(MODULE_NOTIFY_START_GAME,0);
//					 /*clientTrigger.*/ForPrizeTestbed::self->notifyClient(CLIENT_GAME_START,ForPrizeTestbed::self->fpa->getGameSeed(ForPrizeTestbed::self->fpTournamentParameters));
//					 
////		    					 Make sure to record start time of tournament 
//					 ForPrizeTestbed::self->fpa->gameStarted();
//					 
//				 }
//			 }
//			 else if( !ForPrizeTestbed::self->requestCancelled ){	    				 
//				 ForPrizeTestbed::self->handleGeneralError(); 
//			 }
//    		 ForPrizeTestbed::self->requestCancelled = false;
//    		 break;
//    	 }
//    	 
//    	 case LOAD_ACTION_FP_REPORT_GAME_SCORE :{
//    		 //System.out.println("GCMFP.load(" + actionID + ")--LOAD_ACTION_FP_REPORT_GAME_SCORE");
//			 if( ForPrizeTestbed::self->fpa->reportGameScore(ForPrizeTestbed::self->curScore, NULL) == PARAM_ERR_NONE ) {
//    		 //System.out.println("---------------------------------------------------------------->bug find");
//				 //System.out.println("GCMFP.load(" + actionID + ")--reported game score with no error");
//				 ForPrizeTestbed::self->alreadyEntered = false;
//				 if( !ForPrizeTestbed::self->requestCancelled ) { 
//					 //System.out.println("GCMFP.load(" + actionID + ")--request hasn't been cancelled");
//					 switch( ForPrizeTestbed::self->fpa->getCurrentTournamentType() ) {
//    					 case PARAM_TOURNAMENT_TYPE_H2H :
//    						 ForPrizeTestbed::self->setMenu(MENU_MATCH_RESULTS);
//    						 break;
//    						 
//    					 case PARAM_TOURNAMENT_TYPE_PROGRESSIVE : 
//    						 ForPrizeTestbed::self->setMenu(MENU_RANK_SUMMARY);
//    						 break;    	 		
//					 }   
//				 }
//			 }
//			 else if( !ForPrizeTestbed::self->requestCancelled ){
//				 ForPrizeTestbed::self->handleGeneralError(); 
//			 }
//    		 //fpa.setCurrentTournamentType( (byte) PARAM_TOURNAMENT_TYPE_PRACTICE );
//    		 ForPrizeTestbed::self->requestCancelled = false;
//    		 break;
//    	 }
//    	 
//    	 case LOAD_ACTION_FP_GET_SCORES :{
//			 if( ForPrizeTestbed::self->fpa->getScores((byte)ForPrizeTestbed::self->fpTypeTournament, ForPrizeTestbed::self->fpTypeScore) == PARAM_ERR_NONE ) {
//				 if( !ForPrizeTestbed::self->requestCancelled ) { 
//					 switch( ForPrizeTestbed::self->fpTypeScore ) {
//    					 case PARAM_SCORES_TYPE_MY_CURRENT_RANK:		    						 
//    					 case PARAM_SCORES_TYPE_MY_RECENT_MATCHES:
//    					 case PARAM_SCORES_TYPE_GLOBAL_RANKS:
//    						 ForPrizeTestbed::self->textScore = ForPrizeTestbed::self->fpa->getScoreSummary();
//    						 ForPrizeTestbed::self->setMenu( MENU_SCORES_DISPLAY );
//    						 break;
//    						 
//    					 case PARAM_SCORES_TYPE_MY_TOURNAMENTS:
//
//    						 //System.out.println("GCMFP.load()--About to getTournamentHistoryHeaders");
//							 if( ForPrizeTestbed::self->fpa->getTournamentHistoryHeaders().size() == 0 ) {
//    							 //System.out.println("GCMFP.load()--PARAM_SCORES_TYPE_MY_TOURNAMENTS--Tournamnet history headers NULL");	
//	    						 ForPrizeTestbed::self->textScore = ForPrizeTestbed::self->fpa->getScoreSummary();
//    							 ForPrizeTestbed::self->setMenu( MENU_SCORES_DISPLAY );
//    							 break;
//    						 }
//    						 else {
//    							 //System.out.println("GCMFP.load()--PARAM_SCORES_TYPE_MY_TOURNAMENTS--fpa.getTournamentHistoryHeaders().size()=" + fpa.getTournamentHistoryHeaders().size() );		    							 
//    							 ForPrizeTestbed::self->setMenu( MENU_SCORES_MY_TOURNAMENTS );
//    							 break;
//    						 }
//    						 
//    					 default:
//    						 //System.out.println("GameCanvasMenu.update()--Unknown Score Type");
//							 break;
//					 }
//				 }
//			 }
//			 else if( !ForPrizeTestbed::self->requestCancelled ){	    				 
//    		 //System.out.println("------------------------------------------------------->bug find");
//				 switch(ForPrizeTestbed::self->fpa->getErrorNum()) {	         					
//    				 case PARAM_ERR_T4P_DATABASE_ERROR:
//    				 			ForPrizeTestbed::self->errorBackState = MENU_OFF;
//    				 			ForPrizeTestbed::self->errorForeState = MENU_SCORES;
//									ForPrizeTestbed::self->errorTitleString = "";
//									ForPrizeTestbed::self->errorTitleString += _itoa(ForPrizeTestbed::self->fpa->getErrorNum(),str,10);
//									ForPrizeTestbed::self->errorContentsString = ForPrizeTestbed::self->fpa->getErrorStr();
//									ForPrizeTestbed::self->setMenu(MENU_ERROR_GENERAL);
//    						  break;
//    				 default :
//    				 	 ForPrizeTestbed::self->handleGeneralError();
//				 }
//			 }
//    		 ForPrizeTestbed::self->requestCancelled = false;
//    		 break;
//    	 }
//
//			default:
////#ifdef DEBUG_ON
//				//throw new RuntimeException("Unknown Network State");
////#endif
//				break;
//		}
}

void ForPrizeTestbed::fpProgress( int percentComplete ) {
//#ifdef DEBUG_ON
	DEBUG(("ForPrizeTestbed.fpProgress(%d): Processing",percentComplete));
//#endif
	if (menuState == MENU_LOADING) {
		menuTrigger->setMenuEntry(MENU_LOADING,1,
				MENUENTRY_DYNAMIC_PROGRESS,
				strings->getString(FP_STR_CONST_ID_ITEM_LABEL_PROGRESS),
				percentComplete, // XXX: User Name Max Size
				"",NULL);
	}
	IDISPLAY_Update(((AEEApplet*)GETAPPINSTANCE())->m_pIDisplay);
}	

void ForPrizeTestbed::getScoresRegistrationCheck() {
	if( fpa->getRegistrationState() != 0 ) { 
		doNetworkTransaction( LOAD_ACTION_FP_GET_SCORES ); 
	}
	else {
		doNetworkTransaction( LOAD_ACTION_FP_REGISTER );
		//menuCommand( MENU_ACTION_CHECK_REGISTRATION );
	}
}

void ForPrizeTestbed::notifyClient(int code, Bbyte data){
	if (menuTickOn && !fromMenuTick) {
		eventList.append(code);
		eventList.append(data);
	}else{
		clientTrigger->notifyClient(code, data);
	}
}

void ForPrizeTestbed::menuTick() {
	menuTickOn = true;

	if (!eventList.isEmpty()){
			fromMenuTick = true;
			for (int i = 0; i < eventList.size(); i += 2){
				clientTrigger->notifyClient((int) eventList[i], (Bbyte) eventList[i+1]);
			}
			eventList.removeAll();
			fromMenuTick = false;
	}


	if (menuStateAfterTick != MENU_NULL) {
		fromMenuTick = true;
		setMenu(menuStateAfterTick);
		fromMenuTick = false;
	} 	
	menuStateAfterTick = MENU_NULL;
}

bool ForPrizeTestbed::menuCommandActionFore(){
	switch (menuState) {
	// XXX - FORE COMMAND CONTROL GOES HERE
	

	case MENU_SCORES_MY_TOURNAMENTS:{
			//textScore = *((String*)fpa->getTournamentHistorySummaries()[fpTurnamentHistoryIndex]);
			textScore = fpa->getTournamentHistorySummary(fpTurnamentHistoryIndex);
			return setMenu(MENU_SCORES_DISPLAY);
		}
	//case MENU_WELCOME: return menuCommand(postRegistrationAdvanceGameState);
	case MENU_WINNER: return menuCommand(MENU_NEWS);
	case MENU_SCREEN_GAME_RESULTS: {
			doNetworkTransaction( LOAD_ACTION_FP_REPORT_GAME_SCORE );
			return true;
		} 
	case MENU_NEWS: return menuCommand(MENU_PRIZES);
	case MENU_PRIZES: return menuCommand(PARAM_MENU_ACTION_SWITCH_TO_GAME);
	case MENU_REGISTRATION: return menuCommand(MENU_ACTION_DETERMINE_REGISTRATION_SCREEN);
	case MENU_EXISTING_USER_NAME:
	case MENU_ENTER_USER_NAME: 
			if (fpa->_userName.length() < 3)
				return menuCommand(MENU_INVALID_USER_NAME);
			else
				return menuCommand(MENU_SMS_OPTION);
	case MENU_SMS_OPTION: return menuCommand(MENU_ACTION_REGISTER);
	case MENU_PROMO:
		{
			if (fpa->getCurrentPromoID() != -1)
			{	// there's a next promo id
				doNetworkTransaction( LOAD_ACTION_FP_GET_PROMO );
			}
			else
			{	
				if (promoInReplay)
				{
					promoInReplay = false;
					return menuCommand(MENU_PRIZES);
				} else {
					if (postRegistrationAdvanceGameState != MENU_NULL) {
						return menuCommand(postRegistrationAdvanceGameState);
					} else {
						DEBUG(("POST PROMO ERROR: FAILSAFE CASE TO MAIN MENU!"));
						return menuCommand(MENU_TOURNAMENT);
					}
				}
				/*
				else if (promoInWelcome)
				{
					promoInWelcome = false;
					return menuCommand(postRegistrationAdvanceGameState);
				}
				else
					return menuCommand(MENU_TOURNAMENT);
				*/
			}	
			
			return true;
		}
	
	case MENU_MATCH_RESULTS:
		{
			return menuCommand(MENU_RANK_SUMMARY);		
		}
	
	case MENU_RANK_SUMMARY:
		{
			promoInReplay = true;
			fpa->setPromoID(1001);	// starts at 1001 here
			doNetworkTransaction( LOAD_ACTION_FP_GET_PROMO );
			return true;
		}
	
	case MENU_ERROR_GENERAL: 
		if (errorForeState != MENU_OFF) {
				return menuCommand(errorForeState);
			} else {
				DEBUG(("ERROR HANDLING IS CONFUSED! Defaulting to MENU_TOURNAMENT!"));
				return menuCommand(MENU_TOURNAMENT);
			}
		break;
	default: {
//#ifdef DEBUG_ON
			DEBUG(("ForPrize:menuCommand(MENUENTRY_COMMAND_FORE): In MenuId %d: Unknown", (menuState & MENU_MASK_FLAGS)));	
	//#endif
		} 
	}
	return false;
}

bool ForPrizeTestbed::menuCommandActionBack(){
	switch (menuState) {
			
		//XXX - BACK COMMAND CONTROL GOES HERE
		
		case MENU_LOADING: {
			requestCancelled = true;

			if(!fpa->CancelWebRequests()) break;

			int loadBackState;
			switch (actionID) {
				default:
//#ifdef DEBUG_ON
					DEBUG(("ForPrize:menuCommand(MENUENTRY_COMMAND_BACK): In MENU_LOADING: unknown return target"));
//#endif								
				case LOAD_ACTION_FP_GET_SCORES:
				case LOAD_ACTION_FP_REPORT_GAME_SCORE: 
				case LOAD_ACTION_FP_GET_TOURNAMENTS: {
					loadBackState = MENU_TOURNAMENT;
				} break;
				case LOAD_ACTION_FP_REGISTER: {
					loadBackState = MENU_SMS_OPTION;
				} break;
				case LOAD_ACTION_FP_ENTER_TOURNAMENT: {
					loadBackState = MENU_PRIZES;
				} break;
			}
			
			// This is here so this flag doesn't get fucked up on cancel
			ForPrizeTestbed::self->fpa->_hasNextTournaments = fpTournAvailFlag;
			
			setErrorMenu(FP_STR_CONST_ID_ITEM_LABEL_ERROR_NETWORK,FP_STR_CONST_ID_ITEM_LABEL_ERROR_REQUEST_ABORTED,loadBackState,MENU_ACTION_RETRY_NETWORK);
		} return true; 

		case MENU_SCORES_H2H:
		case MENU_SCORES_PROGRESSIVE:
			return setMenu(MENU_SCORES);

		case MENU_SCORES_MY_TOURNAMENTS:
			if (fpTypeTournament == PARAM_TOURNAMENT_TYPE_H2H)
								return setMenu(MENU_SCORES_H2H);
			else
				return setMenu(MENU_SCORES_PROGRESSIVE);

		case MENU_SCORES_DISPLAY: {
			if (fpTypeScore == PARAM_SCORES_TYPE_MY_TOURNAMENTS) {
				return setMenu(MENU_SCORES_MY_TOURNAMENTS);
			} else {	
				if (fpTypeTournament == PARAM_TOURNAMENT_TYPE_H2H) {
					return setMenu(MENU_SCORES_H2H);
				} else {
					return setMenu(MENU_SCORES_PROGRESSIVE);
				}
			}
		} break;

		case MENU_SCREEN_HELP:
		case MENU_TOURNAMENT: return notifyModule(MODULE_NOTIFY_STOP_MENU,0);

		case MENU_WINNER: return menuCommand(MENU_TOURNAMENT);
		
		case MENU_NEWS: return menuCommand(MENU_WINNER);
		
		case MENU_PRIZES: return menuCommand(MENU_TOURNAMENT);

		case MENU_HELP_TOURNAMENTS:
		case MENU_HELP_LEGAL: return setMenu(MENU_SCREEN_HELP);
		
		case MENU_PROMO:
		{
			promoInReplay = false;
			promoInWelcome = false;
			return menuCommand(MENU_TOURNAMENT);
		}
		
		case MENU_ENTER_USER_NAME: 
		case MENU_EXISTING_USER_NAME:
		case MENU_REGISTRATION: fpa->setUsername("");
		case MENU_RANK_SUMMARY:
		case MENU_MATCH_RESULTS:
		case MENU_SCREEN_GAME_RESULTS:
		case MENU_SCORES: return menuCommand(MENU_TOURNAMENT);
		
		case MENU_SMS_OPTION: return menuCommand(MENU_ENTER_USER_NAME);
		
		case MENU_ERROR_GENERAL: 
			//if (errorForeState == MENU_MISMATCH_USER_NAME) return setMenu(MENU_TOURNAMENT);
			return menuCommand(errorBackState);
		default: {	
//#ifdef DEBUG_ON
			DEBUG(("menuCommand(MENUENTRY_COMMAND_BACK): In MenuId %d: Unknown", (menuState & MENU_MASK_FLAGS)));	
//#endif
		} 
	} 
return false;
}
