/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/


#include "TBAtoms.h"
#include "IOStreamBuf.h"

#if 0
#define DEBUGTEXT(expr) DEBUG(expr)
#else
#define DEBUGTEXT(expr)
#endif

//-----------------------------------------------------------------------------
/*
//void AtomText_Init(AtomTextStruct& text, char* pChars)
//{
//	text._encoding = 1;
//	text._pChars = pChars;
//	text._lenString = STRLEN(pChars);
//}
IOStreamBuf& AtomText_ReadFromStream(AtomTextStruct& text, IOStreamBuf& iosbuf)
{
	DEBUGTEXT(( "AtomText::ReadFromStream()" ));

	if (!iosbuf.IsEmpty()) iosbuf >> text._encoding;
	DEBUGTEXT(( "AtomText::ReadFromStream(): encoding=%d", text._encoding ));

	if (!iosbuf.IsEmpty()) iosbuf >> text._lenString;
	DEBUGTEXT(( "AtomText::ReadFromStream(): lenString=%d", text._lenString ));

	if (text._lenString)
	{
		if (text._pChars)
			MEMFREE(text._pChars);
		char* pChars = (char*)MEMALLOC(text._lenString + 1);
		text._pChars = pChars;

		if (pChars)
		{
			for (int idx=text._lenString-1; idx>=0; idx--, pChars++)
				if (!iosbuf.IsEmpty())
					iosbuf >> pChars;

			*pChars = '\0';
		}
		DEBUGTEXT(( "AtomText::ReadFromStream(): string=%s", text._pChars ));
	}
	return iosbuf;
}
IOStreamBuf& AtomText_WriteToStream(const AtomTextStruct& text, IOStreamBuf& iosbuf)
{
	DEBUGTEXT(( "AtomText::WriteToStream()" ));
	DEBUGTEXT(( "AtomText::WriteToStream(): encoding=%d", text._encoding ));
	DEBUGTEXT(( "AtomText::WriteToStream(): lenString=%d", text._lenString ));
	DEBUGTEXT(( "AtomText::WriteToStream(): string=\"%s\"", text._pChars ));
//	iosbuf << _encoding << _lenString;
	iosbuf << text._encoding;
	iosbuf << text._lenString;
	char* pChars = text._pChars;
	for (int idx=text._lenString-1; idx>=0; idx--)
		iosbuf << (int8)*pChars++;
	return iosbuf;
}
*/
//-----------------------------------------------------------------------------
//	AtomText helper
//-----------------------------------------------------------------------------
AtomText::AtomText()
	: _encoding(1)
	, _lenString(0)
	, _pReadChars(0)
	, _pWriteChars(0)
{}
AtomText::AtomText(const char* chars)
	: _encoding(1)
	, _pReadChars(0)
	, _pWriteChars(chars)
{
	if (chars)
		_lenString = STRLEN(chars);
	else
		_lenString = 0;
}

/*int AtomText::SetText(char* chars)
{
	_encoding = 1;
	_pChars = chars;
	return _lenString = STRLEN(chars);
}*/
//uint16 GetLen() { return 3 + _lenString; }

IOStreamBuf& AtomText::ReadFromStream(IOStreamBuf& iosbuf)
{
	DEBUGTEXT(( "AtomText::ReadFromStream()" ));

	if (!iosbuf.IsEmpty()) iosbuf >> _encoding;
	DEBUGTEXT(( "AtomText::ReadFromStream(): encoding=%d", _encoding ));

	if (!iosbuf.IsEmpty()) iosbuf >> _lenString;
	DEBUGTEXT(( "AtomText::ReadFromStream(): lenString=%d", _lenString ));

	if (_lenString)
	{
		if (_pReadChars)
			MEMFREE(_pReadChars);
		char* pReadChars = (char*)MEMALLOC(_lenString + 1);
		_pReadChars = pReadChars;

		if (pReadChars)
		{
			for (int idx=_lenString-1; idx>=0; idx--, pReadChars++)
				if (!iosbuf.IsEmpty())
					iosbuf >> pReadChars;

			*pReadChars = '\0';
		}
		DEBUGTEXT(( "AtomText::ReadFromStream(): string=%s", _pReadChars ));
	}
	return iosbuf;
}
IOStreamBuf& AtomText::WriteToStream(IOStreamBuf& iosbuf)
{
#ifdef _DEBUG
	DEBUGTEXT(( "AtomText::WriteToStream()" ));
	DEBUGTEXT(( "AtomText::WriteToStream(): encoding=%d", _encoding ));
	DEBUGTEXT(( "AtomText::WriteToStream(): lenString=%d", _lenString ));
	if (_pWriteChars)
		DEBUGTEXT(( "AtomText::WriteToStream(): string=\"%s\"", _pWriteChars ));
	else
		DEBUGTEXT(( "AtomText::WriteToStream(): string=NULL" ));
#endif

	if (_pWriteChars)
	{
	//	iosbuf << _encoding << _lenString;
		iosbuf << _encoding;
		iosbuf << _lenString;
	//	char* pChars = _pChars;
	//	for (int idx=_lenString-1; idx>=0; idx--)
	//		iosbuf << (int8)*pChars++;
		for (int idx=0; idx<_lenString; idx++)
			iosbuf << (int8)_pWriteChars[idx];
	}
	return iosbuf;
}

