/*=============================================================================

  Atlas Mobile Tournament Platform

  Copyright (c) 2003-2004 Atlas Mobile, Inc. All Rights Reserved.

  This software is the confidential and proprietary information of Atlas Mobile
  ("Confidential Information").  You shall not disclose such Confidential
  Information and shall use it only in accordance with the terms of the license
  agreement you entered into with Atlas Mobile.

  ATLAS MOBILE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
  NONINFRINGEMENT. ATLAS MOBILE SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
  LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
  DERIVATIVES.

=============================================================================*/

#ifndef AMTPATOM_H
#define AMTPATOM_H

#include "IOStreamBuf.h"

#define TYPE_BINARY				'bnry'
#define TYPE_STRING				'strg'
#define TYPE_BOOL				'bool'
#define TYPE_INT8				'in08'
#define TYPE_INT16				'in16'
#define TYPE_INT32				'in32'
#define TYPE_INT64				'in64'
#define TYPE_FP32				'fl32'
#define TYPE_FP64				'fl64'
#define TYPE_NULL				'nula'
#define TYPE_LIST				'list'
#define TYPE_NAMED				'namd'
#define TYPE_MAP				'map '
#define TYPE_INDEX				'indx'
#define TYPE_SPARSE				'sprs'
#define TYPE_BITS				'bita'
#define TYPE_MONEY				'buxx'
#define TYPE_PACKAGE			'pack'

#define TYPE_UTF				'utf '

#define TYPE_DATE				'date'

#define TYPE_GAMEID				'gmid'
#define TYPE_PLAY				'play'
#define TYPE_PROFILE			'prfl'
#define TYPE_RESULT				'grsl'
#define TYPE_NEWS				'news'
#define TYPE_PREF				'pref'
//#define TYPE_PROMO			'pomo'
#define TYPE_RANK				'rank'
//#define TYPE_PRNK				'prnk'
//#define TYPE_LRNK				'lrnk'

#define TYPE_SEED				'seed'
#define TYPE_TOURN				'trna'
#define TYPE_TOURNAMENT_DETAIL	'tdet'


#define TYPE_REQ_REGISTER		'regq'
#define TYPE_REQ_AUTHENTICATE	'autq'
#define TYPE_REQ_ENTERTOURNEY	'entq'
#define TYPE_REQ_GETOPTIONS		'gopq'
#define TYPE_REQ_GETSCORES		'gscq'
#define TYPE_REQ_GETTOURNEYS	'gtsq'
#define TYPE_REQ_REPORTSCORE	'rscq'
#define TYPE_REQ_REPORTFORFEIT	'rffq'
#define TYPE_REQ_SETOPTIONS		'sopq'
#define TYPE_REQ_GETPROMOTION	'gtpq'

#define TYPE_RESP_REGISTER		'regr'
#define TYPE_RESP_AUTHENTICATE	'autr'
#define TYPE_RESP_ENTERTOURNEY	'entr'
#define TYPE_RESP_GETOPTIONS	'gopr'
#define TYPE_RESP_GETSCORES		'gscr'
#define TYPE_RESP_GETTOURNEYS	'gtsr'
#define TYPE_RESP_REPORTSCORE	'rscr'
#define TYPE_RESP_REPORTFORFEIT	'rffr'
#define TYPE_RESP_SETOPTIONS	'sopr'
#define TYPE_RESP_GETPROMOTION	'gtpr'

#define ID_NAMED_BOOL			'nabo'
#define ID_NAMED_INT8			'nai3'
#define ID_NAMED_INT16			'nai4'
#define ID_NAMED_INT32			'nai5'
#define ID_NAMED_INT64			'nai6'
#define ID_NAMED_FP32			'naf5'
#define ID_NAMED_FP64			'naf6'


#define NAMED_DOLLARS	0
#define NAMED_CENTS		1
#define NAMED_FORMAT	2
#define NAMED_MSG_ID	3
#define NAMED_PHONE		4
#define NAMED_PREFS		5

#define ID_DOLLARS	0
#define ID_CENTS	1
#define ID_PACKET	2
#define ID_MSG_ID	3
#define ID_PHONE	4
#define ID_PREFS	5

#define ATOM_STRING	0
#define ATOM_PREFS	2

//-----------------------------------------------------------------------------
/*
typedef struct _AtomTextStruct
{
	uint8 _encoding;
	int16 _lenString;
	char* _pChars;

} AtomTextStruct;
//void AtomText_Init(AtomText& text, char* pChars);
IOStreamBuf& AtomText_ReadFromStream(AtomTextStruct& text, IOStreamBuf& iosbuf);
IOStreamBuf& AtomText_WriteToStream(const AtomTextStruct& text, IOStreamBuf& iosbuf);

inline IOStreamBuf& operator>>(IOStreamBuf& iosbuf, AtomTextStruct& data)
{
	DEBUG(( "operator>>(IOStreamBuf&, AtomTextStruct&)" ));
	AtomText_ReadFromStream(data, iosbuf); return iosbuf;
}
inline IOStreamBuf& operator<<(IOStreamBuf& iosbuf, const AtomTextStruct& data)
{
	DEBUG(( "operator<<(IOStreamBuf&, AtomTextStruct&)" ));
	AtomText_WriteToStream(data, iosbuf); return iosbuf;
}
*/

//-----------------------------------------------------------------------------
class AtomText
{
public: //protected:
	uint8 _encoding;
	int16 _lenString;
	char* _pReadChars;
	const char* _pWriteChars;

public:
	AtomText();
	AtomText(const char* chars);

	//int SetText(char* chars);
	//uint16 GetLen() { return 3 + _lenString; }

	IOStreamBuf& ReadFromStream(IOStreamBuf& iosbuf);
	IOStreamBuf& WriteToStream(IOStreamBuf& iosbuf);

};

inline IOStreamBuf& operator>>(IOStreamBuf& iosbuf, AtomText& data)
{
	//DEBUG(( "operator>>(IOStreamBuf&, AtomText&)" ));
	data.ReadFromStream(iosbuf); return iosbuf;
}
inline IOStreamBuf& operator<<(IOStreamBuf& iosbuf, AtomText& data)
{
	//DEBUG(( "operator<<(IOStreamBuf&, AtomText&)" ));
	data.WriteToStream(iosbuf); return iosbuf;
}


//-----------------------------------------------------------------------------
typedef struct _AtomHeader
{
	int32 length;
	int32 type;

} AtomHeader;

//-----------------------------------------------------------------------------
typedef struct _FieldDef
{
	int32 id;
	int16 nBytes;

} FieldDef;

//-----------------------------------------------------------------------------
typedef struct _SequenceDef
{
	int32 id;
	int32* pFieldIDs;

} SequenceDef;

//-----------------------------------------------------------------------------
typedef struct _AtomDef
{
	int32 id;
	int32 type;
	int16 nFields;
	int16 nSubAtoms;
	const int32* seqFieldsTypes;
	const int32* seqSubAtomTypes;

} AtomDef;

//-----------------------------------------------------------------------------
typedef struct _NamedAtomDef
{
	int32 idx;
	int32 id;
	char* szName;
	int32 idAtomType;

} NamedAtomDef;

/*
AtomDef atoms[] =
{
//all atoms have headers. if it doesn't have a header, it's not an atom
//categories: null, primitive, variable count, named

	//Primitives
	{TYPE_NULL,  	TYPE_NULL,		0, 0, NULL, NULL},
	{TYPE_BOOL,  	TYPE_BOOL,		1, 0, _seqBool, NULL},
	{TYPE_INT8,  	TYPE_INT8,		1, 0, _seqInt8, NULL},
	{TYPE_INT16, 	TYPE_INT16,		1, 0, _seqInt16, NULL},
	{TYPE_INT32, 	TYPE_INT32,		1, 0, _seqInt32, NULL},
	{TYPE_INT64, 	TYPE_INT64,		1, 0, _seqInt64, NULL},
	{TYPE_FP32,  	TYPE_FP32,		1, 0, _seqFP32, NULL},
	{TYPE_FP64,  	TYPE_FP64,		1, 0, _seqFP64, NULL},
	{TYPE_BINARY,	TYPE_BINARY,	1, 0, _seqBinary, NULL},
	{TYPE_STRING,	TYPE_STRING,	1, 0, _seqString, NULL},

	//Collections
	{TYPE_LIST,		TYPE_LIST,		1, -1, _seqInt32, NULL},
//	{TYPE_MAP,		TYPE_MAP,		1, -1, _seqInt32, NULL},//special case of LIST where atoms are all NAMED
	{ID_NAMED_BOOL,	ID_NAMED_BOOL,	3, 1, _seqString, _seqBool},
	{ID_NAMED_INT8,	ID_NAMED_INT8,	3, 1, _seqString, _seqInt8},
	{ID_NAMED_INT16,ID_NAMED_INT16,	3, 1, _seqString, _seqInt16},
	{ID_NAMED_INT32,ID_NAMED_INT32,	3, 1, _seqString, _seqInt32},
	{ID_NAMED_INT64,ID_NAMED_INT64,	3, 1, _seqString, _seqInt64},
	{ID_NAMED_FP32,	ID_NAMED_FP32,	3, 1, _seqString, _seqFP32},
	{ID_NAMED_FP64,	ID_NAMED_FP64,	3, 1, _seqString, _seqFP64},

	{TYPE_MONEY,	TYPE_MONEY,		1, 2, _seqInt32, _seqCurrency},

};

NamedAtomDef namedatoms[] =
{
	{ID_DOLLARS,"whole",	ID_NAMED_INT64},
	{ID_CENTS,	"fraction",	ID_NAMED_INT8},
	{ID_PACKET,	"#format",	ID_NAMED_INT16},
	{ID_MSG_ID,	"!!",		ID_ATOM},
	{ID_PACKAGE,"pack",		ID_LISTATOM},
	{ID_PACKAGE,"pack",		ID_LISTATOM},
};
*/


void BinaryAtom_Fn();




#endif //AMTPATOM_H
