#include "aImage.h"
#include "aMain.h"





Image::Image(AEEApplet * main)
{
	myMain = main;
	m_pImage = NULL;
#if 0x2 > 0x1
	m_pBitmap = NULL;
	m_pBitmapInfo = NULL;
#endif
}

Image::~Image(void)
{
}

void Image::draw(int x, int y)
{

#if 0x2 > 0x1
	/*if(m_pBitmap != NULL)
	{
		if(m_pBitmapInfo == NULL)
		{
			m_pBitmapInfo = new AEEBitmapInfo();
			IBITMAP_GetInfo(m_pBitmap, m_pBitmapInfo, sizeof(AEEBitmapInfo));
		}
		IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, m_pBitmapInfo->cx, m_pBitmapInfo->cy, m_pBitmap, 0, 0, AEE_RO_COPY);
	}
	else*/
#endif
	{
		IIMAGE_Draw(m_pImage, x, y);
	}



}

void Image::drawClipped(int x, int y, int ox, int oy, int dx, int dy)
{

#if 0x2 > 0x1
	if(m_pBitmap != NULL)
	{
		IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, dx, dy, m_pBitmap, ox, oy, AEE_RO_TRANSPARENT);
	}
	else
#endif
	{
		IIMAGE_SetOffset(m_pImage, ox, oy);
		IIMAGE_SetDrawSize(m_pImage, dx, dy);
		IIMAGE_Draw(m_pImage, x, y);
		IIMAGE_SetOffset(m_pImage, 0, 0);
		IIMAGE_SetDrawSize(m_pImage, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
	}



}

void Image::release()
{
	if(m_pImage != NULL)
	{

		IIMAGE_Release(m_pImage);










		m_pImage = NULL;
	}
#if 0x2 > 0x1
	if(m_pBitmap != NULL)
	{
		IBITMAP_Release(m_pBitmap);
		m_pBitmap = NULL;
	}
	if(m_pBitmapInfo != NULL)
	{
		delete(m_pBitmapInfo);
		m_pBitmapInfo = NULL;
	}
#endif
}

int Image::getWidth()
{
	int ret = 0;

	AEEImageInfo _ImageInfo;
	if ( m_pImage != NULL ) {
		IIMAGE_GetInfo(m_pImage, &_ImageInfo);
		ret = _ImageInfo.cx;
	}





	return ret;
}

int Image::getHeight()
{
	int ret = 0;

	AEEImageInfo _ImageInfo;
	if ( m_pImage != NULL ) {
		IIMAGE_GetInfo(m_pImage, &_ImageInfo);
		ret = _ImageInfo.cy;
	}





	return ret;
}

void Image::fill()
{
	AEERect r;
  	r.x = 0;
  	r.y = 0;
  	r.dx = _width;
 	r.dy = _height;

#if 0x2 > 0x1
	NativeColor pColor = IBITMAP_RGBToNative(m_pBitmap, MAKE_RGB(255, 0, 255));
	IBITMAP_FillRect(m_pBitmap, &r, pColor, AEE_RO_COPY);
#endif

}

void Image::Draw(Image *dst, int xDst, int yDst) {
	if (!dst) {












#if 0x2 > 0x1
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, _width, _height, (void *)m_pBitmap, 0, 0, _currentRasterOp );
#else
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, _width, _height, (void *)m_pImage, 0, 0, _currentRasterOp );
#endif



	} else {

#if 0x2 > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, _width, _height, m_pBitmap, 0, 0, _currentRasterOp );
#endif

	}
}

void Image::Draw(Image *dst, int xDst, int yDst, int w, int h, int xSrc, int ySrc) {
	if (!dst) {












#if 0x2 > 0x1
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, w, h, (void *)m_pBitmap, xSrc, ySrc, _currentRasterOp );
#else
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, w, h, (void *)m_pImage, xSrc, ySrc, _currentRasterOp );
#endif

	} else {

#if 0x2 > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, w, h, m_pBitmap, xSrc, ySrc, _currentRasterOp );
#endif

	}
}

void Image::DrawFrame(Image *dst, int xDst, int yDst, int frameNum) {
	if (!dst) {












#if 0x2 < 0x1
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, _tileW, _height, (void *)m_pBitmap, frameNum * _tileW, 0, _currentRasterOp );
#else
		IDISPLAY_BitBlt( ((aMain*)myMain)->m_pIDisplay, xDst, yDst, _tileW, _height, (void *)m_pImage, frameNum * _tileW, 0, _currentRasterOp );
#endif


	} else {

#if 0x2 > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, _tileW, _height, m_pBitmap, frameNum * _tileW, 0, _currentRasterOp );
#endif

	}
}

void Image::SetDefaultRasterOp(int rasterOp) {
	_defaultRasterOp = rasterOp;
	
	switch (_defaultRasterOp) {
		case RASTEROP_COPY:
			_currentRasterOp = AEE_RO_COPY;
			break;

		case RASTEROP_TRANSPARENT:
			_currentRasterOp = AEE_RO_TRANSPARENT;
			break;
	}
}















































































































