#ifndef AMAIN_H
#define AMAIN_H

#include "aUtils.h"
#include "aText.h"
#include "bText.h"
#include "aKey.h"
#include "aTextBox.h"
#include "aGame.h"
#include "aSprite.h"
#include "aScore.h"






#include "aSound.h"
#include "BrewString.h"
#include "aeeheap.h"
#include "aHelper.h"


#include "..\Module\Core\ITBClientControls.h"
#include "..\Module\Core\ITBClientEventListener.h"
#include "..\Module\Core\ITBMenuControls.h"
#include "..\Module\Core\ITBMenuEventListener.h"
#include "..\Module\Core\TBC.h"




#include "..\Module\ForPrizes\Verizon\VerizonAdapter.h"
#include "..\Module\ForPrizes\Verizon\TBEvents.h"

#include "FPEventListenerObj.h"


//use our own boolean for inner class stuff, it's smaller this way







// set default (empty) for Twistbox Games




// set defaults for debugging
























// check transition stuff, if no mode is configured use mode blend






//remove the deviceapi completely if not needed: saves some space in the jar file





// which menu is used has to be defined




















































//TODO:






typedef BrewVector<aScore> BScore ;

//#ifndef GAME_STORE_ADDITIONAL_DATA
#ifdef AEE_SIMULATOR
typedef struct tagconfig 
{
#pragma pack(push)
#pragma pack(1)
	byte valid;
	int currentLanguage;



	byte isSoundMuted;







	char ScoreLastName[20];



#pragma pack(pop)
}config;
#else
typedef struct tagconfig 
{
	byte valid;
	int currentLanguage;



	byte isSoundMuted;


	byte isTiltOff;
	char ScoreLastName[20];



}__attribute__ ((packed)) config;
#endif
//#endif


class aMain : public AEEApplet
{
public:
	static bool  HandleEvent(aMain * pMain, AEEEvent eCode, uint16 wParam, uint32 dwParam);
	static void	    freeAppData(aMain * pMain);
	static boolean  InitAppData(IApplet *pIApplet);
	static void mainLoop(aMain * pMain);
public:
	boolean OnAppInitData();
	void OnFreeAppData();
	boolean init();
	bool OnEvent(AEEEvent eCode, uint16 wParam, uint32 dwParam);
	void doInit();
	boolean readConfig();
	void writeConfig();
	void updateLoading(int percent, String txt);
	void startGame();
	void endGame(boolean showScores, int playedScore






	);

	void changeGameState(int state);
	void hideNotify();
	void showNotify();














	void paint();
	void paintCommand();
	void paintGame();
	void paintInit();
	void keyPressed(int keyCode);
	void keyRepeated(int keyCode);
	void keyReleased(int keyCode);
	void processKey();
	void processApplicationState(int state);
	int pauseGame();
	void keyGame(int keyCode);
	void preInit();
	void postInit();
	void nextModeInit();
	void keyInit(int keyCode);

	//adi ------previous game state used for back option from help hiscores etc.
	int BackGameState;
	int PrevMenuItem;
	void setPreviousState();
	//adi ----------------------------------------------------------------------

	//  ****************************************************************
	//  **********  brand methods  *************************************
	//  ****************************************************************
	void nextModeBrand();
	void paintBrand();
	void keyBrand(int keyCode);


//  *****************************************************************
//  **********  score input  ****************************************
//  *****************************************************************
	int getScoreRangePos(char c);
	void paintScoreBackground();
	void preScoreInput();
	void postScoreInput();
	void paintWaitString();
	void paintScoreInput();
	void keyScoreInput(int keyCode);
	void preScore();
	void postScore();
	void paintScore();
	void keyScore(int keyCode);











	void preHelp();
	void postHelp();
	void paintHelp();

	void endHelp();

	void keyHelp(int keyCode);

//  ************************************************************
//  **********  language screen methods  ***********************
//  ************************************************************
	int posLanguage;
	int LanguageStartY;
	int LanguageSepY;
	void preLanguage();
	void postLanguage();
	void keyLanguage(int keyCode);
	void paintLanguage();



















	void preMenu();
	void postMenu();


//  ********************************************************************
//  *********  methods for the classic menu  ***************************
//  ********************************************************************
	void paintClassicMenu(Bbyte pArray);


	void paintMultiMenu(Bbyte pArray, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int animationStatesCount, int menuTextColor, int menuHighlightColor, int itemCount);

	void paintMenuItem(Image* image, int x, int y, int xOffset, int yOffset, int width, int height, String text, int color, int mode);









	void paintHeader(int xPos, int yPos, int width, int height, Image* image, int imageXoffset, int imageYoffset, int imageWidth, int imageHeight, String text, int color, int space);

	void processKeyMenu(int pCode, Bbyte pArray, byte map_DownRight_UpLeft);
	String getMenuItemText(int menuEntry);










// paint the menu button
	void paintMenuButton();


	int arrowPos;



	void paintArrows(IGraphics* g, int arrowNumber, char arrowL, char arrowR,  int arrowStartY, int arrowXoffset, String arrowText, Bint colors,  int textcolor,  boolean in,  byte reCalcArrows,  int menuWidth,  int menuXpos);



// returns 1 if sound is startet
	void playSound(int sound, int loop);
	void stopSound();








private:
	aTextBox _TextBox;


	bText _Text;




	aKey _Key;
	aUtils _Utils;
	aGame _Game;
	aScore _Score;

	boolean m_bLoadText;

	aSound _Sound;









public:
	IGraphics* m_pGraphics;
	aMain* myMain;
	aTextBox* myTextBox;


	bText* myText;





	BScore myModeScores;

	aKey* myKey;
	aUtils* myUtils;
	aGame* myGame;
	aScore* myScores;

	aSound* mySound;











	boolean m_bRun;
	//init vars
	int initPercentage;




	int ScreenWidth;
	int ScreenHeight;

	IHeap* pIHeap;
#if 0x2 > 0x1
	IBitmap* m_pbmScreen;
#endif
	int lastKeyPressed;




	int cycled;					// needed for cycling colors


















































	//game frame timing
	int FrameTime;

	//color rotation
	Bint GameColorRotation;

	//language select vars
	int currentLanguage;
	//help screen vars
	int lastHelpPos;




	//main menu screen items
	static const byte MENU_RESUME=0;
	static const byte MENU_START=1;































	static const byte MENU_SOUND=3;












	static const byte MENU_SCORE=4;

	static const byte MENU_LANGUAGE=5;
	static const byte MENU_QUIT=6;
	static const byte MENU_END_MARK=7; //must always be the last entry!








	//menus available
	static const byte MENU_MAIN=0;
	static const byte MENU_START_GAME=1;

	//menu screen control



	Image* MenuImage;
	int MenuImageX;
	int MenuImageY;
	int currentMenu;
	int currentMenuItem;
	int oldMenuItem;
	int currentMenuStartItem;

	int currentGameMode;
	int currentScoreMode;

	String MenuText;
	int MenuPosition;
	String MenuCommandName;
	String MenuCommandOKName;
	String MenuCommandCancelName;

	//arrows
//	int ArrowStartY;
	String ArrowText;

	//game states
	static const byte INIT=0;
	static const byte BRAND=1;
	static const byte LANGUAGE=2;
	static const byte MENU=3;
	static const byte HELP=4;












	static const byte GAME=5;
	static const byte SCOREINPUT=6;
	static const byte SCORE=7;
	static const byte QUIT=8;







	//game state control
	int m_iGameState;
	byte isInitialised;
	byte isDrawing;
	byte isGamePaused;



	byte isSoundMuted;

	//byte isVibrationOff;
	byte isTiltOff;
	byte isInGame;
	byte isConfigured;
	byte isNewGameState;
	byte isWaiting;
	byte isNewLanguage;



	boolean isPaused;

	//painting control
	boolean doFullPaint;
	byte doFullMenuPaint;
	byte pauseGameNow;





	//store the delight entertainment logo and jingle
	Image*	DelightImage1;
	Image*	DelightImage2;
	long	DelightWait;
	int		DelightJingle;

	//branding stuff
	Image* BrandImage;
	long BrandWait;

	//highscore stuff



//	Font ScoreFont;

	Image* ScoreImage;

	String ScoreTitel;
	StringVector ScoreBuf;
	int ScoreTitelXPos;
	int ScoreTitleYPos;

	int ScoreTitelXPosEnd;

	int ScoreColor;
	int ScoreWidth;
	int ScoreHeight;
	int ScoreScrollPos;
	int ScoreScrollDirection;
	int ScoreCharWidth;
	int ScoreCharHeight;
	int ScoreStartX;
	int ScoreStartY;
	int ScoreWidthY;
	int ScoreEntryLength;
	int ScoreIsMonoSpace;
	int ScoreChars;

	//for score input
	byte ScoreInputInitEnd;
	byte ScoreInputEnd;
	String ScoreInputRange;
	String ScoreInputTitle;
	String ScoreInputGrats;
	String ScoreLastName;
//	Font ScoreInputFont;
	int ScoreLastPosition;

	int ScoreLastMode;

	int ScoreInputTitleXPos;
	int ScoreInputGratsXPos;
	int ScoreInputTitleYPos;
	int ScoreInputGratsYPos;
	int ScorePlayed;
	int ScoreInputPos;
	int ScoreInputCharPos;
	String ScoreInputChars;
	int ScoreInputCharWidth;
	int ScoreInputCharHeight;
	int ScoreInputCharSpace;
	int ScoreInputCharX;
	int ScoreInputCharY;
	int ScoreInputArrowSize;
	int ScoreInputArrowPos;

//#ifdef MENU_MUSIC || SCORE_MUSIC || GAME_SOUND_WIN
	byte restartMusic;
//#endif
	int myCommandPosX;
	int myCommandPosY;

	//general transition stuff





























	// main menu screen items
	Bshort menuEntries;
	// is hand over to Game.initGame as the actual start mode
	int gameStartMode;

	// array for different levels
	Bbyte startEntries;


	// vars and methods needed for the outsliding menu button
	int mySmallFontHeight;
	int mySmallFontSpaceWidth;
	int mySmallFontMenuWidth;
	int mySmallFontMenuOKWidth;
	int mySmallFontMenuCancelWidth;

	long MenuCommandTime;		// stores the time the menu button has been painted completely
	int menuButtonOffset;		// offset for sliding out the menu button; 0 means fully displayed,  - 1 don't draw

	Image* menuButton;			// the menu button image


	int arrowLength;
	int ArrowPos;
	int arrowTextStartX;
	int arrowColor;






	Image* headerImage;












	//  ********************************************************************
	//  *********  methods for the multi item menu  ************************
	//  ********************************************************************

	int availableMenuItems;	// number of available menu items TODO

	Image* menuItemImage;

	Image* menuSelectedItemImage;















	byte updateMenuString;




	int lastLoopedSound;

	int m_iWaitCounter;
	int isParseText;

	byte isEnterGame;
	byte isStartGame;
	byte isReturn;

//	*********************************************************************
//	***********  SOFTKEYS  **********************************************
//	*********************************************************************
	
	// is softkeys processed externally
	byte isSoftKeyExternalSet;// 	= 0; //ADI only used when resume action but if you like to set in game softkey the setsoftkeys() method shouldn't overwite it


	String SoftKeyLeftLabel;
	String SoftKeyRightLabel;

//***
	// softkey dimensions, computed when a button is set in setSoftKey()
	int SoftKeyLeftX;
	int SoftKeyLeftY;
	int SoftKeyLeftW;
	int SoftKeyLeftH;

	int SoftKeyRightX;
	int SoftKeyRightY;
	int SoftKeyRightW;
	int SoftKeyRightH;


	Image* SoftKeyLeftImage;
	Image* SoftKeyRightImage;


	Image* multiButtonImage;
	int leftMultiButtonOffset;
	int rightMultiButtonOffset;













	
//	private static int mySmallFontMenuWidth;
//	private static int mySmallFontMenuOKWidth;
//	private static int mySmallFontMenuCancelWidth;

	long softKeyStartScrollingTime;	// the time when the user pressed a button and thus scrolling of the softkeys was started
	int softKeyScrollingOffset;			// the offset of the softkeys after a certain period of time has passed after 'softKeyStartScrollingTime' was set
 		// 0: no offset, paint the softkeys
 		// -1: softkeys have left the screen, do not paint



	void setSoftKeys();
	void setSoftKey(String commandLabel, int commandType, Image* buttonImage);
	void _setSoftKey(String commandLabel, int commandType

		, Image* buttonImage, int xOffset, int width

	);
	void removeSoftKey(int commandType);

	void paintSoftKey( int softKey

	, int multiButtonOffset

	);
	void showSoftKeys();



	ITBMenuControls* fpMenu;
	FPMenuEventListenerObj* menuObj;

	ITBClientControls* fpClient;
	FPClientEventListenerObj* clientObj;

	
	Bint editKeyMap;

	StringVector editChars;// = new String[8];

	int p4p_seed;

	int 	p4p_menuId,
		p4p_menuBeginScreenY,
		p4p_selectedItem,
		p4p_totalMenuHeight,
		p4p_subItemSelected,
		p4p_pressCount,
		p4p_fontHeight,
		p4p_viewHeight,
		p4p_soundRestart,
		p4p_activeElements,

		p4p_imgSwitchDim,


		p4p_textFontHeight;


		Image* p4p_imgSwitch;

	String p4p_menuName,
		p4p_commandForeText, //for input text implementation
		p4p_commandBackText; //for input text implementation

	StringVector p4p_entryName,
		p4p_entryText;

	Bint p4p_entryType,
		p4p_entryData,
		p4p_itemHeight;

	VoidVector p4p_entryObject;





	bool skipActions,
		 p4p_leftSoft,
		 p4p_rightSoft,
		 p4p_isInForPrizeGame,
		 p4p_paintBackGround,
		 p4p_isInInputMode;

	Bbyte p4p_data;

	int seedCount;

	WStringVector StringVectorTmpInput;
	WStringVector StringVectorTmpStatic;
	WStringVector StringVectorTmpDynamic;


	//PLAY 4 PRIZES Functions 

	Bbyte getSeed();

	bool notifyClient(int code, Bbyte data);

	bool setMenu(int menuId, int menuIndexSelected, int menuSize, String menuName);

	bool setMenuEntry(int menuId, int menuIndex, int entryType, String entryName, int entryData, String entryText, ConvertedBitmapInfo* entryImage);

	bool endSetMenu(int menuId);

	void calculateTotalMenuHeight();

	bool p4p_menuAlling();

	void paint4Prizes();

	void processKey4Prizes(int keyCode, bool isUp, bool isDown);

	//End p4p game and report score. Use insted end() in p4p game mode.
	void endP4PGame(int score);

	//Cancel p4p game. Don't report score. Use insted end() in p4p game mode.
	void cancelP4PGame();

	void p4p_logic();


	//licznik czasu dla przejscia do nastepnej linii
	int editCount;// = 0;
	//wpisany tekst
	String editName;// = "";
	//znak w kursorze
	String editCursor;// = myText->get("smsc");
	//ostatnio wcisniety znak
	int lastKey;// = 0;
	//ostatni indeks znaku dla klawisza
	int lastIndex;// = 0;
	/*czyscimy nazwe po klawiszu*/
	boolean clearName;// = true;
	/*maksymalnie znakw*/
	int textLength;// = 16;

	void editReset();

	String editNext ();

	String editCancel();

	String editGetName();

	void editSetName(String s);

	String editGet();

	String editKey(int key);


	String versionString;

};

#endif
