#ifndef _ASCROLL_H_
#define _ASCROLL_H_

//##include "aMain.h"
#include "BrewString.h"
#include "BrewVector.h"
#include "AEEGraphics.h"
#include "AEEAppGen.h"
#include "PlatformSpecific.h"
#include "aImage.h"

class aScroll
{
private:
	AEEApplet* myMain;

	boolean isFullUpdate;//=false;


	//store tiles x/y position in tileset for quick reference
	Bshort tilePosX;//=null;
	Bshort tilePosY;//=null;
	Bbyte  tilePosI;//=null;
	ImageVector tileImages;//=null;
	//Graphics[] tileGraphs;//=null;

	//store animated tile mapping
	Bshort tileAni;//=null;

	//store max/current number of tiles
	short tileNumber;//=0;

	//store tile x/y sizes
	short tileWidthX;//=0;
	short tileWidthY;//=0;

	//store our tilemap
	Bshort* tileMap;//=null;
	Bshort tileBuf;//=null;
	short   tileBufLen;//=0;

	//store map x/y sizes
	short mapWidthX;//=0;
	short mapWidthY;//=0;

	//store number of tiles per renderscreen
	short screenTileX;//=0;
	short screenTileY;//=0;

	//store Screen x/y start/size
	short screenStartX;//=0;
	short screenStartY;//=0;
	short screenWidth;//=0;
	short screenHeight;//=0;

	//position offsets
	short screenPosX;//=0;
	short screenPosY;//=0;
	short screenOffsetX;//=0;
	short screenOffsetY;//=0;

	//buffer for rotations
	Image*    rotImage;//=null;
	//Graphics rotGraph;//=null;

public:
	aScroll(){};

	void create(AEEApplet* main,int widthX,int widthY,int maxTileSets,int maxTiles,int maxAnimatedTiles);

	void destruct();

	void setFullUpdate();

	int addTileSet(int tileStart,Image* img);

	int delTileSet(Image* img);

	int setMap(Bshort* mapArray,int widthX,int widthY);

	int setScreen(int startX,int startY,int widthX,int widthY);

	int paint(IGraphics* g);
};

#endif //_ASCROLL_H_
