#ifndef _AGAME_H_
#define _AGAME_H_

#include "AEE.h"
#include "AEEGraphics.h"
#include "AEEFile.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"        // AEE Stb Lib Services
#include "aSprite.h"
#include "aScroll.h"
//##include "aKey.h"
#include "aTextBox.h"
#include "aScore.h"
#include "aImage.h"
#include "aHelper.h"


#include "bText.h"





#include "aSound.h"


typedef BrewVector<BshortVector> d3Vector;


typedef struct m_tagconfig1 
{

	byte gameTime[2];
	byte gameCubesToGo[2];
	byte gameInitialCubesNum;
	byte gameRandomCubesNum ;
	byte gameFixedCubesNum ;
	byte gameMaxFixedCubesLenght;

}m_config;

/*typedef struct g_tagconfig
{

	int menuCubeSet;
	int menuLevel;
	int menuDifficulty;	

}g_config;*/

class aGame
{
public:
	aGame();

	void create ( AEEApplet* main,  int x,  int y);
	void freeRes();
	void init();

	//INIT MENU
	void initMenu();

	//INIT SCORES
	void initScores(int number);

	//INIT GAME
	void initGame ( int mode );

	void initLevel(int level);

	int pauseGame ();

	void key(int keyCode);

	void resumeGame();

	void logic();




	boolean paint( boolean doFullPaint);





	int paintMenu(/*IGraphics* g, */boolean doFullPaint, int menuTextStartYPos);


	void checkCheat(int keyCode);
	void initCheatCodes();


	void endGame();

	void paintCommand(IGraphics* g);

	void updateScreenSize(int x, int y);

	int processKey(int keyCode,int state);

	int processApplicationState(int oldState,int newState);

	boolean processPaint(/*IGraphics* graphics,*/ int state);

	void restoreBackground(int x, int y, int width, int height);


	String getMenuItemText(int menuEntry,int state);




	///////////////////Cubis2//////////////////////////////
	short checkCubeChains();
	short checkCubeInsertion(int x, int y, int z, short rightDirection, int type);
	short getCubeType(int x, int y, int z);
	short checkMovePossibility();
	short cubeHandler();
	void setCubeType(int x, int y, int z, int type);
	void setCubeMorphAnim();
	short getCubeColor1(int x, int y, int z);
	short getCubeColor2(int x, int y, int z);
	void clearCube(int x, int y, int z);
	void createCube(int x, int y, int z, int type, int color1, int color2, int action);
	void setCubeColor1(int x, int y, int z, int color1);
	void setCubeColor2(int x, int y, int z, int color1);
	short getCubeNextType(int x, int y, int z);
	void setCubeNextType(int x, int y, int z, int nextType);
	void moveCube(int x,int y, int z, short rightDirection);
	void setCubeAction(int x, int y, int z, int action);
	void setCubeSimpleAnim();
	void copyCubes(int x1, int y1, int z1, int x2, int y2, int z2);
	void insertCube(int x, int y, int z, short rightDirection, int type, int color1, int color2);
	void decreaseCubesToGo(short cubeType);
	void setCubeDisappearAnim();
	short getCubeAction(int x, int y, int z);
	short checkCubeFall();
	void loadSounds();



	void loadMenuGfx();
	void loadGameGfx();

	void loadAllElements();
	void initGameBoard(String layoutFilePrefix, int levelNumber);
	void initHudMainAnim();
	void setMessage(int msgNumber);
	int  checkNextCubeJump(int x,int y, int z, int color);
	void countGameScore();
	void loadNextLevel();
	void nextSelectedCube();
	void setCubisAnim();
	void cubeTeleportHandler();
	void checkCubeSimpleAnim();
	void checkDisappearAnim();
	void checkMorphAnim();
	void checkHudMainAnim();
	void checkHudCubesAnimPaint();
	void checkCubesGfxAnim();
	void checkCubisAnim();
	void setHudCubesAnimPaint(int cubeType, int cubeColor1, int cubeColor2);
	void drawGameBackground(IGraphics* g);
	void drawHudTopLeft(IGraphics* g);
	void drawHudTopRight(IGraphics* g);
	void drawHudBottomRight(IGraphics* g);
	void drawHud(IGraphics* g);
	void drawMessage(IGraphics* g);

	void drawInitCubes(IGraphics* g);

	void drawSelectionPath(IGraphics* g);
	void drawCubes(IGraphics* g);
	void drawSelector(IGraphics* g);
	void drawCubeInsertion(IGraphics* g);
	void drawCubis(IGraphics* g);
	void drawCubeQueue(IGraphics* g);
	void drawCube(IGraphics* g,int x,int y,int z,int type, int posX, int posY, int color1, int color2);
	void checkCubeChain(int x, int y, int z, int color);
	//void addPointsCube(int cubeType, int layerZ, short multiplyMoreThan3, short multiplyCubisChain);
	void scoreAddCube(int cubeType);
	void scorePrepareCube(int cubeType, int layerZ, int chainLenght);
	void scoreFinishCube();
	void scoreFinishCubis();
	void setMenu(Bshort me,int selectedItem);
	void drawMenuBackground(IGraphics* g);
	void drawMenuLogo(IGraphics* g);
	void unloadSounds();
	void scoreAddCubeCracked(int cubeType);
	void drawPartialCubes(IGraphics* g, int startX, int startY, int stopX, int stopY);

	void drawMessageSnail(IGraphics* g);


	void paintHelp(boolean doFullPaint);
	void keyHelp(int keyCode);






	void readData();
	void writeData();
	void setCubeWarpInAnim();
	void srand(int seed);
	int  rand();
	AECHAR  changeTable(String old);
	WString changeToSecondDigitColor(int value);
	void   changeSelectedCubeLeft();
	void   changeSelectedCubeRight();
	void   checkCubeWarpInAnim();

	void checkCubeWarpAnim();

	//////////////////////////////////////////////////////

	AEEApplet* myMain;
	aScore* myScores;


	bText* myText;





	aSound* mySound;

	aTextBox* myTextBox;


	byte isCheating;
	BintVector cheatCodes;

	int lastKeys[11];

	int ScreenWidth;
	int ScreenHeight;

	int MainPercentage;

	int FrameTime;
	int MenuCommandTime;

	byte hasPaintedCommand;

	//	int MaxSounds;

	int GameScore;

	int GameLevel;
	/////////////Cubis2/////////////////////////




	short cubeBoard[7][7][6][5]; 
	int cubeBoardOffsetX;
	int cubeBoardOffsetY;
	//#ifndef LOW_MEMORY

	short initBoardCounter[7][7][3];

	//#endif

	short checkChain;
	short checkFall;
	short insert_Cube;
	short cubeAction;
	short cubeNext;
	short cubeNextAnim;
	short cubeGhostInsertion;
	short cubeGhostFirstInsertion;		//
	short cubisPossible;
	short checkCrack;

	short cubeSimpleAnim;
	short cubeDisappearAnim;
	short cubeMorphAnim;
	short cubeWarpInAnim;

	short cubisAnim;
	int cubisColor;

	Bshort cubeSelectedQueueType;
	Bshort cubeSelectedQueueColor1;
	Bshort cubeSelectedQueueColor2;

	short cubeSelectedType;
	short cubeSelectedColor1;
	short cubeSelectedColor2;
	short cubeSelectedX;
	short cubeSelectedY;

	Bshort cubeRandomType;
	Bshort cubeRandomColor1;
	Bshort cubeRandomColorDouble;
	int cubeRandomColorDoubleNum;

	int 	cubeChainCheckedNumber;

	short cubeChainChecked[7][7][3];
	short cubeChainFirstTwo[2][3];





	int cubeGhostTeleportCounter;
	int cubeGhostMovesCounter;

	short hudCubesAnim;
	short hudMainAnim;

	int hudCubeAnimType;
	int hudCubeAnimColor1;
	int hudCubeAnimColor2;
	int hudCubeAnimFactorX;
	int hudCubeAnimFactorY;

	int hudWatchBlinker;

	int bombEpicentreX;
	int bombEpicentreY;
	int bombEpicentreCounter;



	long gameTime;
	int gameCubesToGo;
	int gameInitialCubesNum;
	int gameRandomCubesNum;
	int gameFixedCubesNum;
	int gameMaxFixedCubesLenght;


	int gameCubeSet;
	int gameLevel;
	int gameDifficulty;

	short gameArcade;
	short gameNormal;

	int gameActualMessage;

	long prevTime;

	int mainFont;
	int digitFont;

	int menuCubeSet;
	int menuLevel;
	int menuDifficulty;

	short menuArcade;
	short menuNormal;



	int scoreLevel;

	int scoreBoard;
	int scoreCubisBonus;
	int scoreTimeBonus;
	int scorePerfectBonus;
	int scoreCubePenalty;
	int scoreStarPenalty;
	int scoreGhostPenalty;

	int tempScoreBoard;
	int tempScoreCube;
	int tempScoreMaxChainLenght;
	int tempScoreCubisNum;


	int recalcuateTimeCounter;


	// the mode with which the game was startet (e.g. easy, medium, hard ...)
	int gameMode;

	// the state ion which the game is (e.g. game shows intro, main game part, video, end credits ...)
	int gameState;

	// if the player can achieve a score - here it is
	int gameScore;


	// if you need to do a full paint sometimes you can trigger it with this
	byte gameDoFullPaint;

	// maybe you need this (if not - remove this and the method 'loadAllElements()' and all calls)
	byte elementsLoaded;

	// if you want scrolling credits...
	int creditsOffset;

	// if you need some paint synchronization
	//	 byte hasBeenPainted;



	ImageVector gfxHud;
	ImageVector gfxMessage;
	int imgMessageLoad;



	aSprite gfxCubis;



	aSprite gfxCubesNormal;
	aSprite gfxCubesCracked;
	aSprite gfxCubesHalfCracked;
	aSprite gfxCubesHalf;

	aSprite gfxCubesLaserShot;

	aSprite gfxCubesOsmosis;
	aSprite gfxCubesStar;
	aSprite gfxCubesWarp;
	aSprite gfxCubesWedge;

	aSprite gfxMessageSnail;					//message snail



	aSprite gfxCubesWarpIn;	
	aSprite gfxCubesDisappear;
	aSprite gfxCubesExplosion;
	aSprite gfxCubesMelt;
	aSprite gfxCubesMorph;
	aSprite gfxCubesStoneMelt;
	aSprite gfxCubesStoneRemoved;

	aSprite gfxCubesLaser;	
	aSprite gfxCubesBomb;





	int gfxOsmosisAnim;
	int gfxLaserAnim;
	int gfxBombAnim;
	int gfxLaserShotAnim;


	//int gfxMenuLogoWidth;
	//int gfxMenuLogoHeight;

	int gfxMenuBackgroundWidth;
	int gfxMenuBackgroundHeight;


	int gfxGameBackgroundWidth;
	int gfxGameBackgroundHeight;























	/*#ifndef LOAD_ALL_GFX_AT_INIT		
	#ifdef PLEASE_WAIT_AT_GAME_INIT

	private static byte repaintPleaseWait;

	#endif
	#endif*/
	int messageAnim;
	Bint gfxMessageWidth;
	Bint gfxMessageHeight;
	boolean textBoxScroll;
	boolean noScore;
	////////////////// IMAGE /////////////////////
	Image* gfxMenuLogo;
	Image* gfxGameBackground;
	Image* gfxCubeSelector;
	Image* gfxCubesStone;
	Image * imagGfx1;
	Image * imagGfx2;
	Image * imagGfx3;
	Image * imagGfx4;
	Image * imagGfx5;
	Image * imagGfx6;
	Image * imagGfx7;
	Image * imagGfx8;
	Image * imagGfx9;
	Image * imagGfx10;
	Image * imagGfx11;
	Image * imagGfx12;
	Image * imagGfx13;
	Image * imagGfx14;
	Image * imagGfx15;
	Image * imagGfx16;
	Image * imagGfx17;
	Image * imagGfx18;
	Image * imagGfx19;
	Image * imagGfx20;








	short helpTextNumber ;
	short helpWait;
	short helpLoaded;

	/*#ifdef HELP_IS_EXTERNAL

	short lastHelpPos;
	byte initHelp;
	#endif*/


	short messageSnailDirection;
	short messageSnailRotation;
	int messageSnailMoveAnim;
	int messageSnailAnimSpeed;
	int messageSnailFrame;
	int messageSnailPosX;
	//private static int messageSnailPosY;

	int _randNum;
	int scoreTotalBoard;							//total board score
	int scoreTotalCubisBonus;				//total cubis bonus
	int scoreTotalTimeBonus;					//total time bonus
	int scoreTotalPerfectBonus;			//total perfect bonus
	int scoreTotalCubePenalty;				//total cube penalty
	int scoreTotalStarPenalty;				//total star cube penalty
	int scoreTotalGhostPenalty;			//total ghost cube penalty

	short cubeWarpAnimIncrease[7][7][6];
	short cubeWarpAnim[7][7][6];
	short cubeWarpSpeed;


	int keyCounterOfFramesPressing;	//how many frames player holds the same button
	int keyLast;					    //what was the last hitted key?
	////////////////////////////////////////////// Sound /////////////////////////////

	int MaxSounds;















	short startCubisSound;
	int cubisSound;



	short startChainSound;
	int chainSound;

































	short startGameOverSound;
	int gameOverSound;








	short startLevelCompleteSound;
	int levelCompleteSound;



	short startLevelStartSound;
	int levelStartSound;























	int msgNr;
	int scHei;

	int LevelTime;


	byte playForPrizes;
	byte cubeHasNeighbour[7][7][3];
	void initP4PGame(int32 p4p_seed,Bbyte p4p_data);

	bool drawP4PMenuBackground();
	void initP4PRandomCubes(int num);
	byte generateNewCube(int x,int y,int z,int color1);
	void loadNextP4PLevel();
	int P4PSeed;



};

#endif _AGAME_H_


