#include "aMain.h"
#include "aScroll.h"








	//transformation constants




void aScroll::create(AEEApplet* main,int widthX,int widthY,int maxTileSets,int maxTiles,int maxAnimatedTiles)
{
	myMain = main;
	int i;

	//all parameter valid?
	if (widthX <= 0 || widthY <= 0 || maxTiles <= 0 || maxTileSets <= 0 || maxAnimatedTiles < 0)
	{



		return;
	}

	//store tile dimensions
	tileWidthX=(short)widthX;
	tileWidthY=(short)widthY;
	
	//allocate all needed buffers
	//tilePosX=new short[maxTiles+1];
	for ( i = 0; i < maxTiles+1; i++ )
		tilePosX.append(0);
	//tilePosY=new short[maxTiles+1];
	for ( i = 0; i < maxTiles+1; i++ )
		tilePosY.append(0);
	//tilePosI=new byte[maxTiles+1];
	for ( i = 0; i < maxTiles+1; i++ )
		tilePosI.append(0);

	//tileAni=new short[maxAnimatedTiles+1];
	for( i = 0; i < maxAnimatedTiles+1; i++ )
		tileAni.append(0);
	tileNumber=-1;
	
	//reset to an illegal value
	for (i=0;i < maxTiles;i++)
		tilePosI[i]=-1;

	//and set all image realated vars
	//tileImages=new Image[maxTileSets];
	for ( i = 0; i < maxTileSets; i++ ) {
		Image * tmp = NULL;
		tileImages.append(tmp);
	}
	//tileGraphs=new Graphics[maxTileSets];
}

void aScroll::destruct() {
	int i;
	tilePosX.remove ( 0, tilePosX.size() );
	tilePosX.destruct();
	tilePosY.remove ( 0, tilePosX.size() );
	tilePosY.destruct ();
	tilePosI.remove ( 0, tilePosI.size() );
	tilePosI.destruct();
	tileImages.remove ( 0, tileImages.size() );
	tileImages.destruct ();
	tileAni.remove ( 0, tileAni.size() );
	tileAni.destruct();
	tileMap=NULL;
	tileBuf.remove ( 0, tileBuf.size());
	tileBuf.destruct();
	if ( rotImage != NULL ) {
		rotImage->release();
		rotImage = NULL;
	}
}

void aScroll::setFullUpdate()
{

	isFullUpdate=true;

}

int aScroll::addTileSet(int tileStart,Image* img)
{
	int i;
	short x,y,n;
	short numx,numy;
















	//search free image slot
	for (i=tileImages.size()-1;i >= 0;i--)
		if (tileImages[i] == NULL)
			break;

	if (i < 0)
	{



		return -1;
	}

	///assign the Image
	tileImages[i]=img;
	
	//if mutable get the graphics object, it may be needed later
	//if (tileImages[i].isMutable() == true)
	//	tileGraphs[i]=tileImages[i].getGraphics();

	//determin number of tiles
	numx=(short)(img->getWidth()/tileWidthX);
	numy=(short)(img->getHeight()/tileWidthY);

	//check it, needed for nokia s40 and maybe others
	if (numx*tileWidthX < img->getWidth())
		numx++;
	if (numy*tileWidthY < img->getHeight())
		numy++;









	
	//first time?
	if (tileNumber == -1)
		tileNumber++;

	//start at what position?
	if (tileStart == 0)
		n=tileNumber;
	else
		n=(short)tileStart;

	//fill in our tiles
	for (y=0;y < numy;y++)
	{
		for (x=0;x < numx;x++)
		{







			tilePosX[n]=(short)(x*tileWidthX);
			tilePosY[n]=(short)(y*tileWidthY);
			tilePosI[n]=(byte)i;
			n++;
		}
	}

	//store number of valid tiles
	tileNumber=n;

	return n-1;
}

int aScroll::delTileSet(Image* img)
{
	int i,n;

	//search image slot
	for (i=tileImages.size()-1;i >= 0;i--)
		if (tileImages[i] == img)
			break;

	if (i < 0)
	{



		return -1;
	}
	
	//invalid all tiles from this tileset
	for (n=tilePosI.size()-1;n >= 0;n--)
		if (tilePosI[n] == i)
			tilePosI[n]=-1;

	//init tileBuf with invalid values to force new rendering
	if (tileBuf.size() != 0)
		for (n=tileBufLen-1;n >= 0;n--)
			tileBuf[n]=-1;

	//remove the image
	//tileImages[i]=null;
	//tileImages.remove(i,1);
	tileImages[i]=NULL;
	//tileGraphs[i]=null;

	return 0;
}

int aScroll::setMap(Bshort* mapArray,int widthX,int widthY)
{
	int i;

	if (tileNumber == 0)
	{



		return -1;
	}

	//check map for valid tiles
	for (i=mapWidthX*mapWidthY-1;i >= 0;i--)
		if ((*tileMap)[i] > tilePosI.size())
			break;
	
	if (i >= 0)
	{



		return -1;
	}

	//store map info
	tileMap=mapArray;
	mapWidthX=(short)widthX;
	mapWidthY=(short)widthY;

	return mapWidthX*mapWidthY;
}

int aScroll::setScreen(int startX,int startY,int widthX,int widthY)
{
	int i;

	if (tileWidthX == 0 || tileWidthY == 0)
	{



		return -1;
	}

	screenStartX=(short)startX;
	screenStartY=(short)startY;
	screenHeight=(short)widthY;
	screenWidth=(short)widthX;

	//calculate max needed xy tiles
	screenTileX=(short)(2+(screenWidth/tileWidthX));
	screenTileY=(short)(2+(screenHeight/tileWidthY));











	//store number of currently needed tiles 
	tileBufLen=(short)(screenTileX*screenTileY);

	//and the needed tile buffer...
	if ( tileBuf.size() < tileBufLen)
		//tileBuf=new short[tileBufLen];
		for ( i = tileBuf.size(); i < tileBufLen; i++ )
			tileBuf.append(0);
	
	//init tileBuf with invalid values to force new rendering
	for (i=tileBufLen-1;i >= 0;i--)
		tileBuf[i]=-1;

	return 0;
}

int aScroll::paint(IGraphics* g)
{
	short t;
	int x,y,n;
	int xpos,ypos;

	//int cx=g.getClipX();
	//int cy=g.getClipY();
	//int cwx=g.getClipWidth();
	//int cwy=g.getClipHeight();


	//Graphics screenGraph=g;










	//generate/update our screenbuffer if needed
	for (n=0,y=0;y+screenPosY < mapWidthY && y < screenTileY;y++)
	{
		for (x=0;x+screenPosX < mapWidthX && x < screenTileX;x++)
		{
			//calc buffer start position for tile
			xpos=x*tileWidthX;
			ypos=y*tileWidthY;

			//get the tile to be drawn
			t=(*tileMap)[((y+screenPosY)*mapWidthX)+x+screenPosX];//((aMain*)myMain)->myGame->scrollMap[((y+screenPosY)*mapWidthX)+x+screenPosX];













































			//check if we really need to update it
			if (isFullUpdate == false && t == tileBuf[(y*screenTileX)+x])
				continue;

			//update tileBuf
			tileBuf[(y*screenTileX)+x]=t;











			//clip exacly one tile
			//screenGraph.setClip(screenStartX+xpos,screenStartY+ypos,tileWidthX,tileWidthY);

			//copy it over
			//screenGraph.drawImage(	tileImages[tilePosI[t]],
			//			screenStartX+xpos-tilePosX[t],
			//			screenStartY+ypos-tilePosY[t],
			//			Graphics.LEFT|Graphics.TOP);

			((aMain*)myMain)->myUtils->drawClippedImage ( tileImages[tilePosI[t]],
						screenStartX+xpos,
						screenStartY+ypos,
						tilePosX[t],tilePosY[t],tileWidthX,tileWidthY);

			//increase number of copied tiles
			n++;
		}
	}













	//restore old clipping
	//g.setClip(cx,cy,cwx,cwy);


	//only do a fullupdate once
	isFullUpdate=false;

	return n;
	
}


