#pragma once

#include "AEE.h"
#include "AEEGraphics.h"
#include "AEEFile.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"        // AEE Stb Lib Service
#include "BrewString.h"
#include "BrewVector.h"

#include "AEEMediaUtil.h"		// Media Interface definitions
#include "AEEMedia.h"
#include "AEEMediaFormats.h"



typedef BrewVector<IMedia*> IMediaVector;


class aSound
{
public:
	//api independent variable declarations


	IMediaVector m_pIMedia;
	IMediaUtil    *pIMediaUtil;		// IMediaUtil interface





	int maxSounds;
	boolean isMuted;
	boolean isStopped;
	AEEApplet* myMain;
	//api declarations
	StringVector sounds;
	boolean isRewinding;
	boolean isRestarting;
	boolean isReplaying;

	void initSound(int maxSounds);
	int addSound(String soundLocation);
	void delSound(int soundID);
	void playSound(int soundID,int loopCount);
	void stopSound();

	void stopSound(int soundID);


public:
	int m_iLoop;
	int soundID;
	aSound(void);
	~aSound(void);
	int create(AEEApplet* main, int maxSounds);
	void freeRes();
	int add(String soundLocation);
	void play(int soundID,int loopCount);
	void stop(int soundID);
	void del(int soundID);
	void setVolume(int v);
	void mute(boolean state);

	static void loop(void* pUser);
	static void replay(void* pUser);	





	static void mediaCBF(void* pUser, AEEMediaCmdNotify* pCmdNotify);


};
