


// **********************************************************************
//  aText Class V1.0 BREW (C) Kolja Hegelich [Charismatix] 2006
//  converted from 
//  aText Class V1.1 MIDP 1.0 (C) Ralf Niebecker & Andrea Middelhove GbR 2004
// ***************************************************************************
// Can be used to generate multilangual Applications.
//
// aText::Constructor(String name):
// Reads the File with the given Name from the JAR File, parses it and stores
// all Entries in a Hashtable for faster access. If none file with the given
// Name can be found it will try to load files by adding a number and the
// suffix .dat to the file. if the name is text it will try to load text0.dat
// to text15.dat, this can be used to store different languages in single
// files.
// The standard Format of all Definitions in the File is Key = Text
// Example: help=this is my help text!\nblah blah blah ...
// Whitespaces before and after the Text are stripped away, you have to escape
// them with \r (carriage return) \n (linefeed) \t (tab) and \s (space) if you
// need to use them in front or at the end of your Text.
// You can define Domains for Texts, which can be switched using the
// aText.setDomain() methode. Use the Key domain in your Textfile to define
// the Domain in which the follwing Text Definitions will be stored in.
// Example:
//
// gameover=Game Over!
// 
// domain=de
// help=dies ist meine hilfe!
// quit=Beenden
//
// domain=en
// help=this is my help!
// quit=Exit
//
// As the Example shows you are allowed to define the same keys in different
// Domains, which is needed for multilanguage support. The gameover key is
// not defined within a domain making it a global define. global defines
// can be overshadowed by domain definitions, aText will try to read the value
// for a Key first out of the current Domain (if any is set) if the key can't
// be found it checks for a global defined key with the same name.
// 
// String aText.getDomain() / void aText.setDomain(String name):
// Get/set current working Domain.
//
// String aText.get(String key):
// Get the Text that is stored for the given Key in the Hashtable.
// If a Domain is active it will try to read the Text from the Domain, if
// not successful it will check for a global defined Key with the same name.
//
// Example (using the Textfile Example above):
// 
// myText aText = new aText("text.txt");
// ...
// //in your options code
// if (german == true)
// 	myText.setDomain("de");
// else
// 	myText.setDomain("en");
// ...
// //in your help screen code
// g.drawString(myText.get("help"),0,0,0);
//
// //in your gameover code
// g.drawString(myText.get("gameover"),0,0,0);
//
// //in your Command code
// exitCommand=new Command(myText.get("quit"),Command.EXIT,1);
// test 
#include "AEEAppGen.h"
#include "AEEStdLib.h"        // AEE Stb Lib Services
#include "aUtils.h"

class aText
{
public:
	aText();
	AEEApplet* myMain;
	String domain;
//	String buf;
	StringVector domains;
	int domainsEntrys;
//	IRamCache* ht;
	StringHashtable ht;
	String noTextFound;

	//check if modified-utf8 syntax is correct
	void checkModifiedUTF( byte* b, int size);
	void initChar( AEEApplet* _pMain, String name);
	void parseCharArray( char* c, int size);
	void parseByteArray( byte* b, int size);
	void initByte( byte* text);
	void parse( String s);
	void setDomain( String d);
	String getDomain();
	StringVector* getDomains();
	int getDomainNumber();
	int check( String key);
	String* get( String key, String* keyval);
	//cleanup all texts currently in memory	
	void cleanup();
};


