#include "aUtils.h"
#include "aMain.h"
#include "BrewString.h"










//#define TRY_LOADING_IMAGE_LOOP
/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/

/*-------------------------------------------------------------------
            Construtor / Destructor
-------------------------------------------------------------------*/
aUtils::aUtils()
{
	trans_xpos = 0;
	trans_ypos = 0;
	myMain = NULL;
	percentLoaded = 0;
	lastColor = 0;
	shadowColor = 0x606060;
	myResourceFile = "";
	lastResourceLen = -1;
//	objects = NULL;
//	resources = NULL;

	m_bIsFontActive = 0;













}

void aUtils::freeRes()
{
#if 0x2 > 0x1
	if(m_pFont != NULL)
	{
		IFONT_Release(m_pFont);
		m_pFont = NULL;
	}
#endif
	resources.removeAll();
	if(m_pResourceFile != NULL)
		IFILE_Release(m_pResourceFile);
	myResourceFile.destruct();
}
/* =========================================================================
                     FUNCTION DEFINITIONS
   ========================================================================= */
void aUtils::create( AEEApplet* main)
{
	myMain = main;


	Image* imgTmp = NULL;
	m_pimFontImage._new(2,imgTmp);









	/*for ( int i = 0; i < 2; i++ ) {
		FontHashtable fontTmp;
		m_htFont.append(&fontTmp);
	}*/
#if 0x2 > 0x1
	IBitmap* bitTmp = NULL;
	m_pFontBitmap._new(2,bitTmp);
#endif
	m_sFontHeight._new(2,0);
	m_sFontSpaceXLeft._new(2,0);
	m_sFontSpaceXRight._new(2,0);
	m_sFontSpaceYUp._new(2,0);
	m_sFontSpaceYDown._new(2,0);
	m_sFontSpaceSize._new(2,0);
	m_bUseFontBackcolor._new(2,0);
	m_clActualFontColor._new(2,0);









	//m_AEEFont = AEE_FONT_NORMAL;

	m_clActualFontColor = 0;


};

void aUtils::setShadowColor( int c)
{
	shadowColor=c;
}

void aUtils::setColorRGB( IGraphics* p_IGraphics, int p_iRed, int p_iGreen, int p_iBlue)
{



	uint8 r, g, b, alpha;
	alpha = 0;
	IGRAPHICS_SetColor(p_IGraphics,p_iRed&0xff,p_iGreen&0xff,p_iBlue&0xff, alpha);
	IGRAPHICS_GetColor(p_IGraphics, &r, &g, &b, &alpha);
	lastColor = (r << 16) + (g << 8) + b;



}

void aUtils::setColor( IGraphics* p_IGraphics, int p_iColor)
{



	uint8 r, g, b, alpha;
	r = p_iColor >> 16;
	g = p_iColor >> 8;
	b = p_iColor;
	alpha = 0;
	IGRAPHICS_SetColor(p_IGraphics, r, g, b, alpha);
	IGRAPHICS_GetColor(p_IGraphics, &r, &g, &b, &alpha);
	lastColor = (r << 16) + (g << 8) + b;
/*
#ifdef AUTILS_USE_GRAPHICAL_FONT
	if (m_bIsFontActive)
		this->setFontColor(lastColor);
#endif
*/



}

int aUtils::getColor()
{
	return lastColor;
}

//get a font by metrix
AEEFont aUtils::getFontFSS( int p_iFace, int p_iStyle, int p_iSize)
{
	switch(p_iSize)
	{
	case 16 : 
#if 0x2 > 0x1
		if(p_iStyle == 2)
			return AEE_FONT_LARGE_ITALIC;
		else
#endif
			return AEE_FONT_LARGE;
		break;
	case 0 : 
#if 0x2 > 0x1
		if(p_iStyle == 2)
			return AEE_FONT_ITALIC;
		else if(p_iStyle == 1)
			return AEE_FONT_BOLD;
		else 
#endif
			return AEE_FONT_NORMAL;
		break;
#if 0x2 > 0x1
	case 8 : 
		return AEE_FONT_USER_1;
		break;
#endif
	}
	return AEE_FONT_NORMAL;
}

//get the last assigned font from the graphics object
AEEFont aUtils::getFont( IGraphics* p_IGraphics)
{
	return m_AEEFont;
}

//assign a font to a graphics object
void aUtils::setFont( IGraphics* p_IGraphics, AEEFont p_AEEFont)
{



	if(m_AEEFont == p_AEEFont)
	{
		m_AEEFont = p_AEEFont;
		return;
	}
	m_AEEFont = p_AEEFont;
	return;
#if 0x2 > 0x1
	IFont* _oldFont;
	if(m_pFont != NULL)
	{
		IFONT_Release(m_pFont);
		m_pFont = NULL;
	}
	switch(p_AEEFont)
	{
	case AEE_FONT_LARGE:
	case AEE_FONT_LARGE_ITALIC:
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FONT_BASIC14 , (void**)( &m_pFont ) ) != SUCCESS)
		{



			return;
		}
		break;
	case AEE_FONT_NORMAL:
	case AEE_FONT_ITALIC:
	case AEE_FONT_BOLD:
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FONT_BASIC10 , (void**)( &m_pFont ) ) != SUCCESS)
		{




			return;
		}
		break;
	case AEE_FONT_USER_1:
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FONT_BASIC6 , (void**)( &m_pFont ) ) != SUCCESS)
		{




			return;
		}
		break;

	}
	_oldFont = IDISPLAY_SetFont(myMain->m_pIDisplay, m_AEEFont, m_pFont);
#endif





}

void aUtils::drawString( IGraphics* p_IGraphics, WString str, int x, int y, int mode)
{



	//Get Font info
	int _iAscent;
	int _iDescent;
	AEEFont _Font;
	int _iBuf;

	if(myMain == NULL)
	{



		return;
	}
	IDISPLAY_GetFontMetrics(myMain->m_pIDisplay, getFont( p_IGraphics), &_iAscent, &_iDescent);

	//calc new x and/or y position if needed
	if((mode != 0)&&(mode !=128))
	{
		//center horizontally
		if ((mode & 1) != 0) 
		{
			// center on screen?
			if ((mode & 5) == 1) 
			{
				x = ((aMain*)myMain)->ScreenWidth / 2;
			}
			int strwidth = 0;

				if (m_bIsFontActive)
					strwidth = paintString( 0, (AECHAR*)str.toCharArray(), 0, 0);
				else

				{
					WString _wsBuf;
					_wsBuf = str;
					strwidth = IDISPLAY_MeasureText(myMain->m_pIDisplay, getFont( p_IGraphics), _wsBuf.toCharArray());
				}
				x = x - strwidth / 2;
		}
		//center vertically
		if ((mode & 2) != 0) 
		{
			// center on screen?
			if ((mode & 6) == 2) 
			{
				y = ((aMain*)myMain)->ScreenHeight / 2;
			}
			int strheight = 0;

			if (m_bIsFontActive)
				strheight = m_sFontHeight[currentFont] + m_sFontSpaceYUp[currentFont] + m_sFontSpaceYDown[currentFont];
			else

			strheight = _iAscent + _iDescent;
			y = y - strheight / 2;
		}
	}

	//paint the shadow
	if(

		m_bIsFontActive == false && 

		(mode&128) != 0)
	{
		int c=getColor();
		setColor( p_IGraphics, shadowColor);
		WString _szBuf = str;
		IDISPLAY_DrawText(myMain->m_pIDisplay, getFont( p_IGraphics), _szBuf.toCharArray(), -1, x-1, y-1, NULL, 0);
		setColor( p_IGraphics, c);
	}


	if (m_bIsFontActive)
	{
		paintString( 1, (AECHAR*)str.toCharArray(), x, y);
	}
	else

	{
		_Font = getFont( p_IGraphics);
		WString _szBuf = str;
		_iBuf = _szBuf.length();
		setFont( ((aMain*)myMain)->m_pGraphics, _Font);
		if(IDISPLAY_DrawText(((aMain*)myMain)->m_pIDisplay, _Font, _szBuf.toCharArray(), _iBuf, x, y, NULL, IDF_TEXT_TRANSPARENT ) == AEE_SUCCESS)
		{
			int a=0;
		}
	}



} 

//wrap drawChars on drawString to simplify things
void aUtils::drawChars( IGraphics* p_IGraphics, AECHAR data[], int offset, int len, int x, int y, int mode)
{
	AECHAR* _szBuf = (AECHAR*)_MALLOC(sizeof(AECHAR)*(len+1));
	int i;
	for(i=0; i<len;i++)
	{
		_szBuf[i] = data[i+offset];
	}
	_szBuf[i]=0;
	drawString( p_IGraphics,_szBuf,x,y,mode);
	_FREE(_szBuf);
	_szBuf = NULL;
}

//wrap drawSubstring on drawString to simplify things
void aUtils::drawSubstring( IGraphics* p_IGraphics, AECHAR* str, int offset, int len, int x, int y, int mode)
{
	drawChars( p_IGraphics,str,offset,len,x,y,mode);
}

void aUtils::drawChar( IGraphics* p_IGraphics, AECHAR c, int x, int y, int mode)
{
	char _cBuf[2];
	_cBuf[1] = '\0';
	WString _szBuf;
	if (

		m_bIsFontActive == false && 

		(mode&128) != 0)
	{
		int cl=getColor();
		setColor( p_IGraphics, shadowColor);
		_cBuf[0] = c;
		_szBuf = _cBuf;
		drawString( p_IGraphics, (AECHAR*)_szBuf.toCharArray(),x-1,y-1,mode);
		setColor( p_IGraphics, cl);
	}
	_cBuf[0] = c;
	_szBuf = _cBuf;
	drawString( p_IGraphics, (AECHAR*)_szBuf.toCharArray(),x,y,0);
}

//there s no charWidth method available in doja
#if 0x2 > 0x1
int aUtils::charWidth( IFont* p_IFont, const AECHAR c)
{
	int pnFits, pnPixels;

		if (m_bIsFontActive)
			return paintChar( 0, c, 0, 0);
		else

		{
			if(p_IFont != NULL)
				IFONT_MeasureText(p_IFont, (const AECHAR*)&c, 1, IFONT_MAXWIDTH, &pnFits, &pnPixels);
		}
	return pnPixels;
}
#else
int aUtils::charWidth( void* p_IFont, const AECHAR c)
{
	int pnFits, pnPixels;

		if (m_bIsFontActive)
			return paintChar( 0, c, 0, 0);
		else

	return 6;
}
#endif
//there s no charWidth method available in doja
#if 0x2 > 0x1
int aUtils::stringWidth( IFont* p_IFont, WString p_pStr)
{



	int pnFits, pnPixels;

	if (m_bIsFontActive)



		return paintString( 0, (AECHAR*)p_pStr.toCharArray(), 0, 0);
	else

	{
		WString _szBuf = p_pStr;
		if(p_IFont != NULL)
			IFONT_MeasureText(p_IFont, _szBuf.toCharArray(), _szBuf.length(), IFONT_MAXWIDTH, &pnFits, &pnPixels);



		return pnPixels;
	}
}
#else
int aUtils::stringWidth( void* p_IFont, WString p_pStr)
{



	int pnFits, pnPixels;

	if (m_bIsFontActive)



		return paintString( 0, (AECHAR*)p_pStr.toCharArray(), 0, 0);
	else

	{
		WString _szBuf = p_pStr;



		return 6*_szBuf.length();
	}
}
#endif
//we do support h and v centering for images
void aUtils::drawImage( IGraphics* p_IGraphics, IImage* p_IImage, int x, int y, int mode)
{



	//Image info
	AEEImageInfo _pImageInfo;
	IIMAGE_GetInfo(p_IImage, &_pImageInfo);

	if (p_IImage == NULL || p_IGraphics == NULL) 
	{






		return;
	}
	//calc new x and/or y position if needed
	if (mode != 0 && mode != 128) 
	{
		//center horizontally
		if ((mode & 1) != 0) 
		{
			// center on screen?
			if ((mode & 5) == 1) 
			{
				x = ((aMain*)myMain)->ScreenWidth / 2;
			}
			
			x = x - _pImageInfo.cx / 2;
		}
		//center vertically
		if ((mode & 2) != 0) 
		{
			// center on screen?
			if ((mode & 6) == 2) 
			{
				y = ((aMain*)myMain)->ScreenHeight / 2;
			}
			y = y - _pImageInfo.cy / 2;
		}
	}
	IIMAGE_Draw(p_IImage, x, y);



}

//we do support h and v centering for images
void aUtils::drawImage(IGraphics* p_pGraphics, Image* p_pImage, int x, int y, int mode)
{




	if (p_pImage == NULL) 
	{



		return;
	}
	//calc new x and/or y position if needed
	if (mode != 0 && mode != 128) 
	{
		//center horizontally
		if ((mode & 1) != 0) 
		{
			// center on screen?
			if ((mode & 5) == 1) 
			{
				x = ((aMain*)myMain)->ScreenWidth / 2;
			}
			
			x = x - getImageWidth(p_pImage) / 2;
		}
		//center vertically
		if ((mode & 2) != 0) 
		{
			// center on screen?
			if ((mode & 6) == 2) 
			{
				y = ((aMain*)myMain)->ScreenHeight / 2;
			}
			y = y - getImageHeight(p_pImage) / 2;
		}
	}
	p_pImage->draw(x,y);



}

#if 0x2 > 0x1
void aUtils::drawImage( IGraphics* p_IGraphics, IBitmap* p_pBitmap, int x, int y, int mode)
{



	//Image info
	AEEBitmapInfo _BitmapInfo;
	IBITMAP_GetInfo(p_pBitmap, &_BitmapInfo, sizeof(AEEBitmapInfo));

	if (p_pBitmap == NULL || p_IGraphics == NULL) 
	{






		return;
	}
	//calc new x and/or y position if needed
	if (mode != 0 && mode != 128) 
	{
		//center horizontally
		if ((mode & 1) != 0) 
		{
			// center on screen?
			if ((mode & 5) == 1) 
			{
				x = ((aMain*)myMain)->ScreenWidth / 2;
			}
			
			x = x - _BitmapInfo.cx / 2;
		}
		//center vertically
		if ((mode & 2) != 0) 
		{
			// center on screen?
			if ((mode & 6) == 2) 
			{
				y = ((aMain*)myMain)->ScreenHeight / 2;
			}
			y = y - _BitmapInfo.cy / 2;
		}
	}
	//IIMAGE_Draw(p_IImage, x, y);
	IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, _BitmapInfo.cx, _BitmapInfo.cy, p_pBitmap, 0, 0, AEE_RO_COPY);



}

void aUtils::drawClippedImage( IGraphics* p_IGraphics, IBitmap* p_pBitmap, int x, int y, int ox, int oy, int dx, int dy)
{




	if (p_pBitmap == NULL || p_IGraphics == NULL) 
	{






		return;
	}
	//IIMAGE_Draw(p_IImage, x, y);
	IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, dx, dy, p_pBitmap, ox, oy, AEE_RO_COPY);



}
#endif

void aUtils::drawClippedBmp( IGraphics* p_IGraphics, void* p_pBitmap, int x, int y, int ox, int oy, int dx, int dy)
{




	if (p_pBitmap == NULL || p_IGraphics == NULL) 
	{






			////DBGPRINTF("drawClippedBmp Bitmap is NULL");
		return;
	}
	IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, dx, dy, p_pBitmap, ox, oy, AEE_RO_TRANSPARENT);
//	IDISPLAY_BitBlt(((aMain*)myMain)->m_pIDisplay, x, y, dx, dy, p_pBitmap, ox, oy, AEE_RO_COPY);



}

void aUtils::drawClippedImage( IGraphics* p_IGraphics, IImage* p_pImage, int x, int y, int ox, int oy, int dx, int dy)
{




	if (p_pImage == NULL || p_IGraphics == NULL) 
	{






		return;
	}
	//check parameters
	if((ox > getImageWidth(p_pImage)) || (oy > getImageHeight(p_pImage)))
	{
		//offsets are crap, try being smart and avoid possible java convert bug, if thats not the problem the drawn image is crap anyway so it doesnt matter
		int orix = x;
		int oriy = y;
		x = ox;
		y = oy;
		ox = ox - orix;
		oy = oy - oriy;

	}
	IIMAGE_SetOffset(p_pImage, ox, oy);
	IIMAGE_SetDrawSize(p_pImage, dx, dy);
	IIMAGE_Draw(p_pImage, x, y);
	IIMAGE_SetOffset(p_pImage, 0, 0);
	IIMAGE_SetDrawSize(p_pImage, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);



}

void aUtils::drawClippedImage(Image* p_pImage, int x, int y, int ox, int oy, int dx, int dy)
{




	if (p_pImage == NULL) 
	{



		return;
	}
	p_pImage->drawClipped(x, y, ox, oy, dx, dy);



}

void aUtils::drawRect( IGraphics* p_IGraphics, int x, int y, int width, int height)
{



	// just draw rect...
	AEERect _rect;
	_rect.x = x;
	_rect.y = y;
	_rect.dx = width;
	_rect.dy = height;
	IGRAPHICS_DrawRect(p_IGraphics, &_rect);



}

void aUtils::fillRect( IGraphics* p_IGraphics, int x, int y, int width, int height)
{



	// just fill rect...
	AEERect _rect;
	uint8 r_old, g_old, b_old, alpha;
	uint8 r_fg, g_fg, b_fg;
	int _iColor;
	boolean _bFM = IGRAPHICS_GetFillMode(p_IGraphics);
	alpha = 0;
	IGRAPHICS_SetFillMode(p_IGraphics, TRUE);
	_rect.x = x;
	_rect.y = y;
	_rect.dx = width;
	_rect.dy = height;
	IGRAPHICS_GetFillColor(p_IGraphics, &r_old, &g_old, &b_old, &alpha);
	_iColor = getColor();
	r_fg = _iColor >> 16;
	g_fg = _iColor >> 8;
	b_fg = _iColor;
	IGRAPHICS_SetFillColor(p_IGraphics, r_fg, g_fg, b_fg, alpha);
	IGRAPHICS_DrawRect(p_IGraphics, &_rect);
	IGRAPHICS_SetFillMode(p_IGraphics, _bFM);
	IGRAPHICS_SetFillColor(p_IGraphics, r_old, g_old, b_old, alpha);



}

void aUtils::fillRoundRect( IGraphics* p_IGraphics, int x, int y, int width, int height, int arcWidth, int arcHeight){



#if 0x2 > 0x1
	// just fill rect...
	AEERect _rect;
	uint8 r_old, g_old, b_old, alpha;
	uint8 r_fg, g_fg, b_fg;
	int _iColor;
	boolean _bFM = IGRAPHICS_GetFillMode(p_IGraphics);
	alpha = 0;
	IGRAPHICS_SetFillMode(p_IGraphics, TRUE);
	_rect.x = x;
	_rect.y = y;
	_rect.dx = width;
	_rect.dy = height;
	IGRAPHICS_GetFillColor(p_IGraphics, &r_old, &g_old, &b_old, &alpha);
	_iColor = getColor();
	r_fg = _iColor >> 16;
	g_fg = _iColor >> 8;
	b_fg = _iColor;
	IGRAPHICS_SetFillColor(p_IGraphics, r_fg, g_fg, b_fg, alpha);
	IGRAPHICS_DrawRoundRectangle(p_IGraphics, &_rect, arcWidth, arcHeight);
	IGRAPHICS_SetFillMode(p_IGraphics, _bFM);
	IGRAPHICS_SetFillColor(p_IGraphics, r_old, g_old, b_old, alpha);
#endif



}

void aUtils::fillArc( IGraphics* p_IGraphics, int x, int y, int width, int height, int startAngle, int arcAngle)
{



	// just fill rect...
	AEEArc _arc;
	uint8 r_old, g_old, b_old, alpha;
	uint8 r_fg, g_fg, b_fg;
	int _iColor;
	boolean _bFM = IGRAPHICS_GetFillMode(p_IGraphics);
	alpha = 0;
	IGRAPHICS_SetFillMode(p_IGraphics, TRUE);

	_arc.cx = x;
	_arc.cy = y+(width/2);
	_arc.r = width/2;
	_arc.startAngle = startAngle;
	_arc.arcAngle = arcAngle;

	IGRAPHICS_GetFillColor(p_IGraphics, &r_old, &g_old, &b_old, &alpha);
	_iColor = getColor();
	r_fg = _iColor >> 16;
	g_fg = _iColor >> 8;
	b_fg = _iColor;
	IGRAPHICS_SetFillColor(p_IGraphics, r_fg, g_fg, b_fg, alpha);
	IGRAPHICS_DrawArc(p_IGraphics, &_arc);
	IGRAPHICS_SetFillMode(p_IGraphics, _bFM);
	IGRAPHICS_SetFillColor(p_IGraphics, r_old, g_old, b_old, alpha);



}
//this function is here to provide downwards compatiblity, it's used in giana sisters
//do not use this method - it will be removed later on!!!
void aUtils::printWithShadow( IGraphics* p_IGraphics, char* txt, int x, int y, int shadowColor)
{
	//store old color
	int oc=getColor();
	//print shadow
	setColorRGB( p_IGraphics, shadowColor,shadowColor,shadowColor);
	drawString( p_IGraphics, txt,0+x-1,0+y-1,0);
	//print text
	setColor( p_IGraphics, oc);
	drawString( p_IGraphics, txt,0+x,0+y,0);
}

// nicer detection of number of images
int aUtils::detectNumImages( char* prefix, int startIndex, char* suffix)
{
	int i = startIndex;
	String name;
	char _cBuf[10];
	boolean _bFound;

	//detect
	for (;;i++) 
	{
		_bFound = 0;
		name = prefix;
		name += _itoa(i, _cBuf, 10);
		name += suffix;
		name += ".png";

		if (checkResource((char*)name.toCharArray()))
		{
			_bFound = 1;
		}
		name = prefix;
		name += _itoa(i, _cBuf, 10);
		name += suffix;
		name += ".jpg";

		if (checkResource((char*)name.toCharArray()))
		{
			_bFound = 1;
		}
		name = prefix;
		name += _itoa(i, _cBuf, 10);
		name += suffix;
		name += ".bmp";

		if (checkResource((char*)name.toCharArray()))
		{
			_bFound = 1;
		}
		if(!_bFound)
			break;
	}
	return i - startIndex;
}

//write data to a recordstore
void aUtils::writeData( char* s, byte d[], int len)
{
	////DBGPRINTF ( "entry:writeData" );
	int i = SUCCESS;
	IDBRecord * _pIDBRecord = NULL;
	_pDB = NULL;
	AEEDBField field;
//	field = ( AEEDBField * ) MALLOC ( 1 );
	field.fType = AEEDB_FT_BINARY;
	field.fName = AEEDBFIELD_TEXT;
	field.pBuffer = d;
	field.wDataLen = len;
	//DBGPRINTF("Size:%d", len);

	ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_DBMGR, (void**)&m_pIDBMgr);

	if ( m_pIDBMgr == NULL ) {
		return;
	}
	////DBGPRINTF ( "createinstance IDBMgr" );
	if((_pDB = IDBMGR_OpenDatabase (m_pIDBMgr, s, TRUE)) == NULL) 
	{
		// Release IDBMgr Interface and return. 
		//DBGPRINTF("CI Database failed!");
		String s;
		if(((aMain*)myMain)->myText->currentTextId == -1)
		{
			while(!((aMain*)myMain)->myText->isParseReady)
			{
				((aMain*)myMain)->myText->setDomainID(0);
			}
		}
		// get the wait message of the new language we are switching to
		s = ((aMain*)myMain)->myText->get("mmf");
		aTextBox _TB;
		_TB.create(myMain);
		_TB.addLine(s);
		prepareTextBox(&_TB, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);

		setColor(((aMain*)myMain)->m_pGraphics, 0x00000000);
		fillRect(((aMain*)myMain)->m_pGraphics, 0, 0, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
		setColor(((aMain*)myMain)->m_pGraphics, 0x00ffffff);
		_TB.paint(((aMain*)myMain)->m_pGraphics, 1, 0);
		IDISPLAY_UpdateEx(((aMain*)myMain)->m_pIDisplay, false);

        IDBMGR_Release (m_pIDBMgr);
		uint32 _uiStartTime = ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell);
		while( (ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell) - _uiStartTime) < 4000)
		{

		}
        return;
    }
	////DBGPRINTF ( "Database is open" );
	IDATABASE_Reset ( _pDB );
	m_pIDBRecord = IDATABASE_GetNextRecord ( _pDB );
	if ( m_pIDBRecord == NULL ) 
	{
		//DBGPRINTF ( "CreateRecord" );
		m_pIDBRecord = IDATABASE_CreateRecord (_pDB, &field, 1);
	} 
	else 
	{
		////DBGPRINTF ( "UpdateRecord" );
		i = IDBRECORD_Update ( m_pIDBRecord, &field, 1 );
		if(i != SUCCESS){
			String s;
			if(((aMain*)myMain)->myText->currentTextId == -1)
			{
				while(!((aMain*)myMain)->myText->isParseReady)
				{
					((aMain*)myMain)->myText->setDomainID(0);
				}
			}
			// get the wait message of the new language we are switching to
			s = ((aMain*)myMain)->myText->get("mmf");
			aTextBox _TB;
			_TB.create(myMain);
			_TB.addLine(s);
			prepareTextBox(&_TB, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);

			setColor(((aMain*)myMain)->m_pGraphics, 0x00000000);
			fillRect(((aMain*)myMain)->m_pGraphics, 0, 0, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
			setColor(((aMain*)myMain)->m_pGraphics, 0x00ffffff);
			_TB.paint(((aMain*)myMain)->m_pGraphics, 1, 0);
			IDISPLAY_UpdateEx(((aMain*)myMain)->m_pIDisplay, false);

			IDBMGR_Release (m_pIDBMgr);
			uint32 _uiStartTime = ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell);
			while( (ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell) - _uiStartTime) < 4000)
			{

			}
		}
	}
	// Release our that did get created.
	if (m_pIDBRecord != NULL) 
	{
		////DBGPRINTF ( "Close with record" );
		IDBRECORD_Release (m_pIDBRecord);
		IDATABASE_Release (_pDB);
        IDBMGR_Release (m_pIDBMgr);        // Release the DB manager
        return;
	}
	else
	{
		String s;
		if(((aMain*)myMain)->myText->currentTextId == -1)
		{
			while(!((aMain*)myMain)->myText->isParseReady)
			{
				((aMain*)myMain)->myText->setDomainID(0);
			}
		}
		// get the wait message of the new language we are switching to
		s = ((aMain*)myMain)->myText->get("mmf");
		aTextBox _TB;
		_TB.create(myMain);
		_TB.addLine(s);
		prepareTextBox(&_TB, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);

		setColor(((aMain*)myMain)->m_pGraphics, 0x00000000);
		fillRect(((aMain*)myMain)->m_pGraphics, 0, 0, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
		setColor(((aMain*)myMain)->m_pGraphics, 0x00ffffff);
		_TB.paint(((aMain*)myMain)->m_pGraphics, 1, 0);
		IDISPLAY_UpdateEx(((aMain*)myMain)->m_pIDisplay, false);

        IDBMGR_Release (m_pIDBMgr);
		uint32 _uiStartTime = ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell);
		while( (ISHELL_GetTimeMS(((aMain*)myMain)->m_pIShell) - _uiStartTime) < 4000)
		{

		}
        return;
		DBGPRINTF("Record failed!");
	}
	////DBGPRINTF ( "go out:writeData" );
}

//read data from a recordstore
byte* aUtils::readData( char* s)
{
	////DBGPRINTF ( "Entry: readData" );
	_pDB = NULL;
	AEEDBFieldType fieldType;
	AEEDBFieldName fieldName;
	uint16 nFieldLen;
	byte *data = NULL;

	ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_DBMGR, (void**)&m_pIDBMgr);

	if ( m_pIDBMgr == NULL ) {
		return (byte*)NULL;
	}
	////DBGPRINTF ( "CreateInstance" );
	if((_pDB = IDBMGR_OpenDatabase (m_pIDBMgr, s, FALSE)) == NULL) {
		
		// Release IDBMgr Interface and return. 
        IDBMGR_Release (m_pIDBMgr);
        return (byte*)NULL;
    }
	////DBGPRINTF ( "Database is open" );

	if ( _pDB != NULL ) {
		// This will reset the record Index of the database to 0.
		IDATABASE_Reset ( _pDB );

		// Get the first record
		m_pIDBRecord = IDATABASE_GetNextRecord ( _pDB );
		if ( m_pIDBRecord != NULL ) {
			fieldType = IDBRECORD_NextField ( m_pIDBRecord, &fieldName, &nFieldLen );
			data = IDBRECORD_GetField (m_pIDBRecord, &fieldName, &fieldType, &nFieldLen);
			IDBRECORD_Release ( m_pIDBRecord );
		}
		IDATABASE_Release ( _pDB );

	}
	IDBMGR_Release ( m_pIDBMgr );
	////DBGPRINTF ( "Go out: read Data" );
	return (data);
}

//prepare a standard textbox depending on the device resolution
//some stuff is hardcoded to save some space :)
void aUtils::prepareTextBox( aTextBox* p_pTextBox, int ScreenWidth, int ScreenHeight)
{
	if (ScreenHeight <= 100 || ScreenWidth <= 100)
		p_pTextBox->prepare( 0,0,ScreenWidth-8,ScreenHeight-1, 0);//aTextBox.SMALL|aTextBox.SYSTEM);
	else if (ScreenHeight <= 120 || ScreenWidth <= 120)
		p_pTextBox->prepare( 8,8,ScreenWidth-8,ScreenHeight-8, 0);//aTextBox.SMALL|aTextBox.SYSTEM);
	else if (ScreenHeight <= 230 || ScreenWidth <= 230)
		p_pTextBox->prepare( 8,8,ScreenWidth-8,ScreenHeight-8, 0);//aTextBox.MEDIUM|aTextBox.SYSTEM);
	else
		p_pTextBox->prepare( 8,8,ScreenWidth-8,ScreenHeight-8, 0);//aTextBox.LARGE|aTextBox.SYSTEM);
}

byte* aUtils::readBytesOverHTTP( char* path)
{
	byte* buf=NULL;
	/*
	HttpConnection http=null;
	DataInputStream in=null;
	boolean dis=false;
	int bytesread=0;
	int actual=0;
	int t=0;

	percentLoaded=0;

#ifdef debug
	myDebug.add(1,"aUtils:readBytesOverHTTP: Path:" + path);
#endif
	for (t=0;t < 3;t++)
	{
		try
		{
			try
			{
				if (in != null)
				{
			 		in.close();
			 		in=null;
			 	}
			} 
			catch (Exception e) {}
	
			try
			{
				if (http != null)
				{
					http.close();
					http=null;
				}
			}
			catch (Exception e) {}

			http=(HttpConnection)Connector.open(path,Connector.READ,true);
			http.setRequestMethod(HttpConnection.GET);

			//open the connection by getting the response code
			if (http.getResponseCode() != HttpConnection.HTTP_OK)
				break;

			in=http.openDataInputStream();
			buf=new byte[(int)http.getLength()];

			for (;bytesread < buf.length;)
			{
				if ((actual=in.read(buf,bytesread,buf.length-bytesread)) == -1)
					break;

				bytesread += actual;
				percentLoaded = bytesread * 100 / buf.length;
#ifdef debug
				myDebug.add(1,"aUtils:readBytesOverHTTP: Bytes read:" + bytesread + " last chunk:" + actual);
#endif
			}
			
			//did we read everyting?
			if (bytesread == buf.length)
				break;
		}
		catch (SecurityException se)
		{
#ifdef debug
			myDebug.add(1,"aUtils:readBytesOverHTTP: SecurityException: " + se.getMessage());
#endif

			//stop trying if disabled
			buf=null;
			dis=true;
			break;
		}
		catch (Exception ex)
		{
#ifdef debug
			myDebug.add(1,"aUtils:readBytesOverHTTP: Exception: " + ex.getMessage());
#endif
			buf=null;
		}
	}

	if (buf == null || bytesread != buf.length)
	{
#ifdef debug
		myDebug.add(1,"aUtils:readBytesOverHTTP: ERROR: download failed or file size mismatch!");
#endif
		buf=null;
	}

	try
	{
		if (in != null)
		{
	 		in.close();
	 		in=null;
	 	}
	} 
	catch (Exception e) {}

	try
	{
		if (http != null)
		{
			http.close();
			http=null;
		}
	}
	catch (Exception e) {}

#ifdef debug
	if (buf != null)
			myDebug.add(1,"aUtils:readBytesOverHTTP: Successful read:" + buf.length);
#endif
	*/
	return buf;
}

void aUtils::setResourceFile( char* name)
{
	//return if nothing is changing
	if (myResourceFile == (AECHAR*)name)
		return;

	if (myResourceFile.length() != 0)
	{
		//return if setting the same resource file again
		if (name != NULL && myResourceFile.equals(name))
			return;


		//clear all settings if setting to null
		if (name == NULL && !resources.isEmpty())
			resources.removeAll();

	}

	//store the name of the resource file
	myResourceFile = name;


	//init a hashtable if first time
/*
	if (resources == NULL)
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_RAMCACHE, (void**)( &resources ) ) != SUCCESS)
		{
			return;
		}
*/
	//now parse the directory of the resource file into our hashtable
	parseResourceFile();

}

char* aUtils::getResourceFile( char* name)
{
	return (char*)myResourceFile.toCharArray();
}

char* aUtils::fetchResource( String name, char* b)
{




	IFile* _pFile = NULL;
	IFileMgr* _pFileMgr = NULL;
	int p,retval;
	FileInfo _FileInfo;

	//try to get the input stream of the resource
	////DBGPRINTF("aUtils::fetchResource: fetchResourceIS");
	if ((b = fetchResourceIS((char*)name.toCharArray(), b)) == NULL)
	{
		//try to read resource from device
#if 0x2 > 0x1
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
#else
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
#endif
		{
			////DBGPRINTF("aUtils::fetchResource: CI FileMgr failed");



			return NULL;
		}
		_pFile = IFILEMGR_OpenFile(_pFileMgr, name.toCharArray(), _OFM_READ);
		if(_pFile)
		{
			IFILE_GetInfo(_pFile, &_FileInfo);
			if(b == NULL)
				b = (char*)_MALLOC(sizeof(char)*_FileInfo.dwSize);
			else
				b = (char*)_REALLOC(b,sizeof(char)*_FileInfo.dwSize);
			lastResourceLen = IFILE_Read(_pFile, b, _FileInfo.dwSize);
			IFILE_Release(_pFile);
			IFILEMGR_Release(_pFileMgr);



			return b;
		}
		else
		{
			////DBGPRINTF("aUtils::fetchResource: Get FileMgr Error");
			retval = IFILEMGR_GetLastError(_pFileMgr);
			switch(retval)
			{
			case EFILEEXISTS: p=0;////DBGPRINTF ("err:0");break;
			case EFILENOEXISTS: p=1;////DBGPRINTF ("err:0");break;
			case EDIRNOTEMPTY: p=2;////DBGPRINTF ("err:0");break;
			case EBADFILENAME: p=3;////DBGPRINTF ("err:0");break;
			case EBADSEEKPOS: p=4;////DBGPRINTF ("err:0");break;
			case EFILEEOF: p=5;////DBGPRINTF ("err:0");break;
			case EFSFULL: p=6;////DBGPRINTF ("err:0");break;
			case EFILEOPEN: p=7;////DBGPRINTF ("err:0");break;
			case EBADPARM: p=8;////DBGPRINTF ("err:0");break;
			}
			IFILEMGR_Release(_pFileMgr);
		}
	}
	/*
	//read a specific number of bytes from the inputstream, or read the whole resource
	if (lastResourceLen > 0)
	{
		//because we know the length we read it directly into an byte array with the corret size for it
		b = new byte[lastResourceLen];
		for (p=0;p < lastResourceLen;p++)
			b[p]=toSignedByte(in.read());
	}
	else
	{
#ifdef debug
		myDebug.add(0,"aUtils::fetchResource(" + name + ") reading from jar");
#endif
		ByteArrayOutputStream out=null;
		
		try
		{
			//if we don't know the exact length of the resource we have to use a bytearray output stream to read it
			out=new ByteArrayOutputStream();

			//read until the end of the resource
			for (;;)
			{
				if ((p=in.read()) < 0)
					break;
				out.write(p);
			}

			//convert to a byte array
			b=out.toByteArray();
#ifdef debug
			myDebug.add(0,"aUtils::fetchResource(" + name + ") read " + b.length + " bytes");
#endif
		}
		catch (Exception ex) {}

		try
		{
			if (out != null)
			{
				out.close();
				out=null;
			}
		}
		catch (Exception ex) {}
	}
*/




	return b;
}


//return an input stream of a resource either from jar or from a resource file within the jar
void aUtils::parseResourceFile()
{
	//InputStream in=null;
	//return if not using a resource file
	if (myResourceFile.length() == 0)
		return;

	String sb;
	char c;
	char _cBuf[2];
	_cBuf[1] = '\0';
	int r;
	int pos=0;
	int start=0;
	int end=0;

	//open our stream
//	IFile* in;
	IFileMgr* _pFileMgr = NULL;
	int p,retval;
	FileInfo _FileInfo;

#if 0x2 > 0x1
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
#else
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
#endif
	{
		////DBGPRINTF("aUtils::parseResource: CI FileMgr failed");
		return ;
	}
	m_pResourceFile = IFILEMGR_OpenFile(_pFileMgr, myResourceFile.toCharArray(), _OFM_READ);
	IFILEMGR_Release(_pFileMgr);
	if(m_pResourceFile == NULL)
	{
		this->myResourceFile = "";
		return;
	}

	//parse directory
	for (;;)
	{
		//reset stringbuffer
		sb.setLength(0);

		//parsed the complete header?
		if (end != 0 && pos >= end)
			break;

		//read a string
		for (;;pos++)
		{
			//end of file or string?
			r = IFILE_Read(m_pResourceFile, &c, 1);
			if ( (r == 0) || c == 0)
				break;
			_cBuf[0] = c;
			sb += _cBuf;
		}
		pos++;

		//end of file?
		if (r == 0)
			break;

		//read size
		byte _byte;
		IFILE_Read(m_pResourceFile, &_byte, 1);
		int _length = ((int)_byte)<<16;
		IFILE_Read(m_pResourceFile, &_byte, 1);
		_length += ((int)_byte)<<8;
		IFILE_Read(m_pResourceFile, &_byte, 1);
		_length += ((int)_byte);
		lastResourceLen=_length;

		//read start pos
		IFILE_Read(m_pResourceFile, &_byte, 1);
		_length = ((int)_byte)<<16;
		IFILE_Read(m_pResourceFile, &_byte, 1);
		_length += ((int)_byte)<<8;
		IFILE_Read(m_pResourceFile, &_byte, 1);
		_length += ((int)_byte);
		start=_length;

		//store data start (header end) position
		if (end == 0)
			end=start;

		//correct position
		pos+=6;

		//add the resource to the hashtable
		char _cBuf2[10];
		String keyval = _itoa(start, _cBuf2, 10);
		keyval += ",";
		keyval += _itoa(lastResourceLen, _cBuf2, 10);
		resources.put(sb, keyval);
	} 
	//close file
	//IFILE_Release(in);
}


IFile* aUtils::getResourceAsStream(String name, IFile* b)
{




	IFileMgr* _pFileMgr = NULL;
	int p,retval;
	FileInfo _FileInfo;

#if 0x2 > 0x1
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
#else
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
#endif
	{
		////DBGPRINTF("aUtils::fetchResource: CI FileMgr failed");



		return NULL;
	}
	b = IFILEMGR_OpenFile(_pFileMgr, name.toCharArray(), _OFM_READ);
	if(b)
	{
		return b;
	}
	else
	{
		return NULL;
	}
}
//check if a resource is available in the resource file or in the jar
boolean aUtils::checkResource( String name)
{
	IFile* _pFile = NULL;
	IFileMgr* _pFileMgr = NULL;
	int p,retval;

	String s;
	//return if precached in resources
	if( (myResourceFile.length() != 0) && (resources.get(name, s) != 0) )
		return true;

#if 0x2 > 0x1
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
#else
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
#endif
	{
		////DBGPRINTF("aUtils::checkResource: CI FileMgr failed");
		return false;
	}
	_pFile = IFILEMGR_OpenFile(_pFileMgr, name.toCharArray(), _OFM_READ);
	if(_pFile)
	{
		IFILE_Release(_pFile);
		IFILEMGR_Release(_pFileMgr);
		return true;
	}
	else
	{
		////DBGPRINTF("aUtils::checkResource: Get FileMgr Error");
		retval = IFILEMGR_GetLastError(_pFileMgr);
		switch(retval)
		{
		case EFILEEXISTS: p=0;////DBGPRINTF ("err:0");break;
		case EFILENOEXISTS: p=1;////DBGPRINTF ("err:0");break;
		case EDIRNOTEMPTY: p=2;////DBGPRINTF ("err:0");break;
		case EBADFILENAME: p=3;////DBGPRINTF ("err:0");break;
		case EBADSEEKPOS: p=4;////DBGPRINTF ("err:0");break;
		case EFILEEOF: p=5;////DBGPRINTF ("err:0");break;
		case EFSFULL: p=6;////DBGPRINTF ("err:0");break;
		case EFILEOPEN: p=7;////DBGPRINTF ("err:0");break;
		case EBADPARM: p=8;////DBGPRINTF ("err:0");break;
		}
		IFILEMGR_Release(_pFileMgr);
		return false;
	}
}

//check if a resource is available in the resource file or in the jar
boolean aUtils::checkInResourceFile(String name)
{
	String s;
	//return if precached in resources
	if( (myResourceFile.length() != 0) && (resources.get(name, s) != 0) )
		return true;
	else
	{
		return false;
	}
}
//return an input stream of a resource either from jar or from a resource file within the jar
char* aUtils::fetchResourceIS(char* name, char* b)
{




















































































































	int start;
	String s,t;
	//IFile* _pFile = NULL;
	IFileMgr* _pFileMgr = NULL;


	//return if not using a resource file
	if (myResourceFile.length() == 0)
	{
		////DBGPRINTF("aUtils::fetchResourceIS: Resource file length is 0");
		return NULL;
	}

	if(m_pResourceFile == NULL)
	{
#if 0x2 > 0x1
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
#else
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
#endif
		{
			////DBGPRINTF("aUtils::fetchResourceIS: CI FileMgr failed");
			return NULL;
		}
	}

	//now try to read it from our resource file
	if(resources.get(name, s) == 0) 
	{
		////DBGPRINTF("aUtils::fetchResourceIS: Resource not found");
		return NULL;
	}


	//now parse the position and length stored in the string, first by finding the comma
	for(int i=0; i < s.length(); i++)
	{
		if(s.charAt(i) == ',')
		{
			t = s.substring(0, i);
			start = ATOI(t.toCharArray());
			t = s.substring(i+1);
			lastResourceLen = ATOI(t.toCharArray());
			////DBGPRINTF("fetchResourceIS: s%d l%d", start, lastResourceLen);
			break;
		}
	}
	//now open the input stream of our resource file
	if(m_pResourceFile == NULL)
	{
		m_pResourceFile = IFILEMGR_OpenFile(_pFileMgr, myResourceFile.toCharArray(), _OFM_READ);
		////DBGPRINTF("fetchResourceIS: File Open", start, lastResourceLen);
	}

	if(_pFileMgr != NULL)
		IFILEMGR_Release(_pFileMgr);

	if (m_pResourceFile != NULL)
	{
		////DBGPRINTF("fetchResourceIS: SEEK");
		int _iBuf = IFILE_Seek(m_pResourceFile, _SEEK_START, start);
		////DBGPRINTF("fetchResourceIS: MALLOC:%d", sizeof(char)*lastResourceLen);
		if(((aMain*)myMain)->pIHeap != NULL)
		{
			if(!IHEAP_CheckAvail(((aMain*)myMain)->pIHeap, sizeof(char)*lastResourceLen))
			{
				//for(;;)
				{
					////DBGPRINTF("fetchResourceIS: MALLOC failed");
					setColor(((aMain*)myMain)->m_pGraphics, 0x000ff00);
					fillRect(((aMain*)myMain)->m_pGraphics, 0, 0, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
					IDISPLAY_UpdateEx(((aMain*)myMain)->m_pIDisplay, false);
				}
			}
		}
		if(b == NULL)
		{
			b = (char*)_MALLOC(sizeof(char)*lastResourceLen);
			//b = (char*)IHEAP_Malloc(((aMain*)myMain)->pIHeap, sizeof(char)*lastResourceLen);
			////DBGPRINTF("fetchResourceIS: MALLOC:%d", sizeof(char)*lastResourceLen);
		}
		else
		{
			b = (char*)_REALLOC(b, sizeof(char)*lastResourceLen);
			//b = (char*)IHEAP_Realloc(((aMain*)myMain)->pIHeap, b, sizeof(char)*lastResourceLen);
			////DBGPRINTF("fetchResourceIS: REALLOC:%d", sizeof(char)*lastResourceLen);
		}
		if(b == NULL)
		{
			//for(;;)
			{
				////DBGPRINTF("fetchResourceIS: MALLOC failed");
				setColor(((aMain*)myMain)->m_pGraphics, 0x000ffff);
				fillRect(((aMain*)myMain)->m_pGraphics, 0, 0, ((aMain*)myMain)->ScreenWidth, ((aMain*)myMain)->ScreenHeight);
				IDISPLAY_UpdateEx(((aMain*)myMain)->m_pIDisplay, false);
			}
		}

		////DBGPRINTF("fetchResourceIS: READ");
		_iBuf = IFILE_Read(m_pResourceFile, b, lastResourceLen);
		if(_iBuf == 0)
		{
			////DBGPRINTF("fetchResourceIS: READ");
			return NULL;
		}
		//IFILE_Release(_pFile);
		return b;
	}
	else
	{
		////DBGPRINTF("aUtils::fetchResourceIS: Resource file is 0");
		return NULL;
	}

	return NULL;
}


void aUtils::waitForImage(void* p_pUser, IImage* p_pImage, AEEImageInfo* p_pImageInfo, int p_Err)
{
	//p_pUser = 1;
}

void aUtils::fetchImages(StringVector* imageNames, ImageVector* images)
{
	int i;

	//fetch all images from the list
	for (i = 0; i < imageNames->size(); i++)
	{
		images->append(fetchImage((*imageNames)[i]));
	}
}

//load an image from the jar, guess the suffix if needed
IImage* aUtils::fetchImage( char* imageName)
{




	byte _ImageReady = 0;

	char _szBuf[256];
	for(int j=0; j < 256; j++)
	{
		_szBuf[j] = '\0';
	}
	IImage* i=NULL;
	IMemAStream* pMStream=NULL;

	if(myMain == NULL)
	{
		////DBGPRINTF("aUtils::fetchImage: myMain is NULL");



		return i;
	}
	//try loading image from resource file
	if(STRLEN(imageName) > 4)
	{
		if(imageName[STRLEN(imageName)-4] == '.')
		{
			STRNCPY(_szBuf, imageName, STRLEN(imageName)-4);
		}
		else
		{
			STRCPY(_szBuf, imageName);
		}
	}
	
	STRCAT(_szBuf, ".png");
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_PNG, (void**)&i);
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
		return i;
	}
	STRCPY(_szBuf, imageName);
	STRCAT(_szBuf, ".jpg");
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_JPEG, (void**)&i);
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
		return i;
	}
	STRCPY(_szBuf, imageName);
	STRCAT(_szBuf, ".bmp");
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		if(ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream) != SUCCESS)
		{
			////DBGPRINTF("aUtils::fetchImage CI MEMASTREAM Error");
			return NULL;
		}
		if(ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_WINBMP, (void**)&i) != SUCCESS)
		{
			////DBGPRINTF("aUtils::fetchImage CI WINBMP Error");
			return NULL;
		}
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
		return i;
	}



	{
		i = ISHELL_LoadImage(myMain->m_pIShell, imageName);
		if(i == NULL)
		{
			STRCPY(_szBuf, imageName);
			STRCAT(_szBuf, ".png");
			i = ISHELL_LoadImage(myMain->m_pIShell, _szBuf);
		}
		if(i == NULL)
		{
			STRCPY(_szBuf, imageName);
			STRCAT(_szBuf, ".jpg");
			i = ISHELL_LoadImage(myMain->m_pIShell, _szBuf);
		}
		if(i == NULL)
		{
			STRCPY(_szBuf, imageName);
			STRCAT(_szBuf, ".bmp");
			i = ISHELL_LoadImage(myMain->m_pIShell, _szBuf);
		}
		if(i == NULL)
		{
			String _szBuf2 = "aUtils::fetchImage: error: ";
			_szBuf2 += _szBuf;
			////DBGPRINTF(_szBuf2.toCharArray());
		}
		ISHELL_SendEvent(((aMain*)myMain)->m_pIShell, 0, EVT_APP_MESSAGE, 0, 0);
	}



	return i;
}

void* aUtils::fetchBmp( char* imageName, AEEImageInfo* p_ImageInfo, boolean* p_bRealloc)
{



	if(myMain == NULL)
	{
		////DBGPRINTF("aUtils::fetchBmp: myMain is NULL");



		return NULL;
	}
	void* Source = NULL;
	byte *sample = NULL;
	void* Dest = NULL;
	char _szBuf[256];



	{
		STRCPY(_szBuf, imageName);
		if(!STRENDS(".bmp", _szBuf))
		{
			STRCAT(_szBuf, ".bmp");
		}
		if(checkResource(_szBuf))
		{
			char* _ResBuf = NULL;
			_ResBuf = fetchResource(_szBuf, _ResBuf);
			if(_ResBuf == NULL)
			{
				////DBGPRINTF("fetchBmp Resource is NULL");
				((aMain*)myMain)->OnFreeAppData();
				return NULL;
			}
			sample = (byte*)_ResBuf;
			Dest = CONVERTBMP(sample,p_ImageInfo, p_bRealloc);
			//IHEAP_Free(((aMain*)myMain)->pIHeap, _ResBuf);
			_FREE(_ResBuf);
			_ResBuf = NULL;
		}
	}



	return Dest;
}
//load an image from the jar, guess the suffix if needed
Image* aUtils::fetchImage(String imageName)
{




	byte _ImageReady = 0;
	String _szBuf;
	IMemAStream* pMStream=NULL;
	int retval = -1;

	if(myMain == NULL)
	{
		////DBGPRINTF("aUtils::fetchImage: myMain is NULL");



		return NULL;
	}
	Image* i= new Image(myMain);
	i->myMain = myMain;
	//try loading image from resource file
	_szBuf = imageName;
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
		if(_szBuf.length() > 4)
		{
			if(_szBuf.substring(_szBuf.length()-4, _szBuf.length()).equals(".png"))
			{
				retval = ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_PNG, (void**)&i->m_pImage);
			}
			if(_szBuf.substring(_szBuf.length()-4, _szBuf.length()).equals(".jpg"))
			{
				retval = ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_JPEG, (void**)&i->m_pImage);
			}
			if(_szBuf.substring(_szBuf.length()-4, _szBuf.length()).equals(".bmp"))
			{
				retval = ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_WINBMP, (void**)&i->m_pImage);
			}
		}
		if(retval != SUCCESS)
		{
			delete(i);
			i=NULL;
			return NULL;
		}
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i->m_pImage, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
#if 0x2 > 0x1
		IBitmap *displayBitmap;

		IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
		if (!displayBitmap) {
			return NULL;
		}	
		AEEImageInfo info;
		IIMAGE_GetInfo(i->m_pImage, &info);
		i->_width = info.cx;
        i->_height = info.cy;
		i->_tileW = i->_width;
		i->_tileH = i->_height;
		i->_endFrame = i->GetTotalFrameCount();
		IBITMAP_CreateCompatibleBitmap(displayBitmap, &i->m_pBitmap, (uint16)i->_width, (uint16)i->_height);
		if(!i->m_pBitmap)
			return NULL;
		IDISPLAY_SetDestination(GETDISPLAY(), i->m_pBitmap);
		NativeColor pColor = IBITMAP_RGBToNative(i->m_pBitmap, MAKE_RGB(255, 0, 255));
		int retint;
		retint = IBITMAP_SetTransparencyColor(i->m_pBitmap, pColor);
		AEERect r;
		r.x = 0;
		r.y = 0;
		r.dx = i->_width;
		r.dy = i->_height;
		IBITMAP_FillRect(i->m_pBitmap, &r, pColor, AEE_RO_COPY);
		IIMAGE_Draw(i->m_pImage, 0, 0);
        IDISPLAY_SetDestination(GETDISPLAY(), NULL);
		i->_currentRasterOp = AEE_RO_COPY;
		IBITMAP_Release(displayBitmap);
		displayBitmap = NULL;
#endif
		return i;
	}
	_szBuf = imageName;
	_szBuf += ".png";
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_PNG, (void**)&i->m_pImage);
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i->m_pImage, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
#if 0x2 > 0x1
		IBitmap *displayBitmap;

		IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
		if (!displayBitmap) {
			return NULL;
		}	
		AEEImageInfo info;
		IIMAGE_GetInfo(i->m_pImage, &info);
		i->_width = info.cx;
        i->_height = info.cy;
		i->_tileW = i->_width;
		i->_tileH = i->_height;
		i->_endFrame = i->GetTotalFrameCount();
		IBITMAP_CreateCompatibleBitmap(displayBitmap, &i->m_pBitmap, (uint16)i->_width, (uint16)i->_height);
		if(!i->m_pBitmap)
			return NULL;
		IDISPLAY_SetDestination(GETDISPLAY(), i->m_pBitmap);
		NativeColor pColor = IBITMAP_RGBToNative(i->m_pBitmap, MAKE_RGB(255, 0, 255));
		int retint;
		retint = IBITMAP_SetTransparencyColor(i->m_pBitmap, pColor);
		AEERect r;
		r.x = 0;
		r.y = 0;
		r.dx = i->_width;
		r.dy = i->_height;
		IBITMAP_FillRect(i->m_pBitmap, &r, pColor, AEE_RO_COPY);
		IIMAGE_Draw(i->m_pImage, 0, 0);
        IDISPLAY_SetDestination(GETDISPLAY(), NULL);
		i->_currentRasterOp = AEE_RO_COPY;
		IBITMAP_Release(displayBitmap);
		displayBitmap = NULL;
#endif
		return i;
	}
	_szBuf = imageName;
	_szBuf += ".jpg";
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
		ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_JPEG, (void**)&i->m_pImage);
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i->m_pImage, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
#if 0x2 > 0x1
		IBitmap *displayBitmap;

		IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
		if (!displayBitmap) {
			return NULL;
		}	
		AEEImageInfo info;
		IIMAGE_GetInfo(i->m_pImage, &info);
		i->_width = info.cx;
        i->_height = info.cy;
		i->_tileW = i->_width;
		i->_tileH = i->_height;
		i->_endFrame = i->GetTotalFrameCount();
		IBITMAP_CreateCompatibleBitmap(displayBitmap, &i->m_pBitmap, (uint16)i->_width, (uint16)i->_height);
		if(!i->m_pBitmap)
			return NULL;
		IDISPLAY_SetDestination(GETDISPLAY(), i->m_pBitmap);
		NativeColor pColor = IBITMAP_RGBToNative(i->m_pBitmap, MAKE_RGB(255, 0, 255));
		int retint;
		retint = IBITMAP_SetTransparencyColor(i->m_pBitmap, pColor);
		AEERect r;
		r.x = 0;
		r.y = 0;
		r.dx = i->_width;
		r.dy = i->_height;
		IBITMAP_FillRect(i->m_pBitmap, &r, pColor, AEE_RO_COPY);
		IIMAGE_Draw(i->m_pImage, 0, 0);
        IDISPLAY_SetDestination(GETDISPLAY(), NULL);
		i->_currentRasterOp = AEE_RO_COPY;
		IBITMAP_Release(displayBitmap);
		displayBitmap = NULL;
#endif
		return i;
	}
	_szBuf = imageName;
	_szBuf += ".bmp";
	if(checkResource(_szBuf))
	{
		char* _ResBuf = NULL;
		_ResBuf = fetchResource(_szBuf, _ResBuf);
		if(ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream) != SUCCESS)
		{
			////DBGPRINTF("aUtils::fetchImage CI MEMASTREAM Error");
			return NULL;
		}
		if(ISHELL_CreateInstance(((aMain*)myMain)->m_pIShell, AEECLSID_WINBMP, (void**)&i->m_pImage) != SUCCESS)
		{
			////DBGPRINTF("aUtils::fetchImage CI WINBMP Error");
			return NULL;
		}
		IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, lastResourceLen, 0, FALSE);
		IIMAGE_SetStream(i->m_pImage, (IAStream*)pMStream);
		IMEMASTREAM_Release(pMStream);
		_FREE(_ResBuf);
		_ResBuf = NULL;
#if 0x2 > 0x1
		IBitmap *displayBitmap;

		IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
		if (!displayBitmap) {
			return NULL;
		}	
		AEEImageInfo info;
		IIMAGE_GetInfo(i->m_pImage, &info);
		i->_width = info.cx;
        i->_height = info.cy;
		i->_tileW = i->_width;
		i->_tileH = i->_height;
		i->_endFrame = i->GetTotalFrameCount();
		IBITMAP_CreateCompatibleBitmap(displayBitmap, &i->m_pBitmap, (uint16)i->_width, (uint16)i->_height);
		if(!i->m_pBitmap)
			return NULL;
		IDISPLAY_SetDestination(GETDISPLAY(), i->m_pBitmap);
		NativeColor pColor = IBITMAP_RGBToNative(i->m_pBitmap, MAKE_RGB(255, 0, 255));
		int retint;
		retint = IBITMAP_SetTransparencyColor(i->m_pBitmap, pColor);
		AEERect r;
		r.x = 0;
		r.y = 0;
		r.dx = i->_width;
		r.dy = i->_height;
		IBITMAP_FillRect(i->m_pBitmap, &r, pColor, AEE_RO_COPY);
		IIMAGE_Draw(i->m_pImage, 0, 0);
        IDISPLAY_SetDestination(GETDISPLAY(), NULL);
		i->_currentRasterOp = AEE_RO_COPY;
		IBITMAP_Release(displayBitmap);
		displayBitmap = NULL;
#endif
		return i;
	}



	{
		i->m_pImage = ISHELL_LoadImage(myMain->m_pIShell, imageName.toCharArray());
		if(i->m_pImage == NULL)
		{
			_szBuf = imageName;
			_szBuf += ".png";
			i->m_pImage = ISHELL_LoadImage(myMain->m_pIShell, _szBuf.toCharArray());
		}
		if(i->m_pImage == NULL)
		{
			_szBuf = imageName;
			_szBuf += ".jpg";
			i->m_pImage = ISHELL_LoadImage(myMain->m_pIShell, _szBuf.toCharArray());
		}
		if(i->m_pImage == NULL)
		{
			_szBuf = imageName;
			_szBuf += ".bmp";
			i->m_pImage = ISHELL_LoadImage(myMain->m_pIShell, _szBuf.toCharArray());
		}
		if(i->m_pImage == NULL)
		{
			String _szBuf2 = "aUtils::fetchImage: error: ";
			_szBuf2 += _szBuf;
			////DBGPRINTF(_szBuf2.toCharArray());
		}
		else
		{
#if 0x2 > 0x1
			IBitmap *displayBitmap;

			IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
			if (!displayBitmap) {
				return NULL;
			}	
			AEEImageInfo info;
			IIMAGE_GetInfo(i->m_pImage, &info);
			i->_width = info.cx;
			i->_height = info.cy;
			i->_tileW = i->_width;
			i->_tileH = i->_height;
			i->_endFrame = i->GetTotalFrameCount();
			IBITMAP_CreateCompatibleBitmap(displayBitmap, &i->m_pBitmap, (uint16)i->_width, (uint16)i->_height);
			if(!i->m_pBitmap)
				return NULL;
			IDISPLAY_SetDestination(GETDISPLAY(), i->m_pBitmap);
			NativeColor pColor = IBITMAP_RGBToNative(i->m_pBitmap, MAKE_RGB(255, 0, 255));
			int retint;
			retint = IBITMAP_SetTransparencyColor(i->m_pBitmap, pColor);
			AEERect r;
			r.x = 0;
			r.y = 0;
			r.dx = i->_width;
			r.dy = i->_height;
			IBITMAP_FillRect(i->m_pBitmap, &r, pColor, AEE_RO_COPY);
			IIMAGE_Draw(i->m_pImage, 0, 0);
			IDISPLAY_SetDestination(GETDISPLAY(), NULL);
			i->_currentRasterOp = AEE_RO_COPY;
			IBITMAP_Release(displayBitmap);
			displayBitmap = NULL;
#endif
			return i;
		}
	}



	delete(i);
	i=NULL;
	return NULL;
















































































}

//helper routine for unsigned byte handling
byte aUtils::InttoSignedByte( int num)
{
	if (num < 128)
		return (byte)num;
	
	return (byte)(-(256-num));
}

//helper routine for unsigned byte handling
byte aUtils::LongtoSignedByte( long num)
{
	if (num < 128)
		return (byte)num;
	
	return (byte)(-(256-num));
}

//load an image into a byte array and change colors in the color table
IImage* aUtils::fetchAndChangeImage( char* imageName, int imageSize, short colorsToChange[])
{
	IImage* i;
	byte* id = NULL;
	//if there is no palette to work with just load the image as usual
	if (colorsToChange == NULL)
		return fetchImage( imageName);

	//read the imagedata into a byte array
//	if ((id=fetchResource(imageName)) == NULL)
//		return NULL;

	i=changeImage( id ,colorsToChange);

	return i;
}

Image* aUtils::fetchAndChangeImage(String imageName, int imageSize, short colorsToChange[])
{
	if (colorsToChange == NULL)
		return fetchImage( imageName);
}

Image* aUtils::fetchAndChangeImage(String imageName, short* colorsToChange) {
	return fetchImage ( imageName );
}

//change the palette of an image that has been loaded into a byte array
IImage* aUtils::changeImage( byte id[], short colorsToChange[])
{
	IImage* i = NULL;
	/*
	int i,c,p,a,l;

	//search for the palette
	for (i=0;i < id.length-4;i++)
		if (id[i] == 'P' && id[i+1] == 'L' && id[i+2] == 'T' && id[i+3] == 'E')
			break;

	//now read the size of the palette chunk, it's before the palette type
	i-=2;
	l=(id[i++]&255)*256+(id[i++]&255);

	//now change the color values
	if (i != id.length)
	{
		a=i;
		i+=4;

		//go thrue every color in the palette
		for (p=i;p < i+l && p < id.length-3;p+=3)
		{
			//compare to every color that should be changed
			for (c=0;c/6 < colorsToChange.length/6;c+=6)
			{
				if (id[p] == toSignedByte(colorsToChange[c]) &&
					id[p+1] == toSignedByte(colorsToChange[c+1]) &&
					id[p+2] == toSignedByte(colorsToChange[c+2]))
				{
					id[p]=toSignedByte(colorsToChange[c+3]);
					id[p+1]=toSignedByte(colorsToChange[c+4]);
					id[p+2]=toSignedByte(colorsToChange[c+5]);
				}
			}
		}

		//calc the new crc32 over the palette
		long crc=crc32(id,a,l+4);

		//and store it
		id[p]=toSignedByte((crc>>24)&0xff);
		id[p+1]=toSignedByte((crc>>16)&0xff);
		id[p+2]=toSignedByte((crc>>8)&0xff);
		id[p+3]=toSignedByte(crc&0xff);
	}

	//return our new image
	return Image.createImage(id,0,id.length);
	*/
	return i;
}

/*** crc32 calculation stuff without a lookup table (slower but less memory is required) ***/
uint64 aUtils::crc32( unsigned short buf[], int offset, int len)
{
 int i,k;
 uint64 crc=0xffffffffL;

 for (i=0;i < len;i++)
 {
  crc^=buf[i+offset]&0xff;

  for (k=0;k < 8;k++)
   crc=(crc&1) != 0 ? 0xedb88320L^(crc>>1) : crc>>1;
 }
 return crc^0xffffffffL;
}


void aUtils::drawLine( IGraphics* g, int x1, int y1, int x2, int y2)
{
	AEELine _Line;
	_Line.sx = x1;
	_Line.sy = y1;
	_Line.ex = x2;
	_Line.ey = y2;
	IGRAPHICS_DrawLine(g, &_Line);
}

char* aUtils::_itoa(int num, char* str, int radix)
{//radix is the base of the number
	int _iBuf;
	char temp[33];
	char *tempStr = str;
	int i = 0;
	MEMSET(temp, 0, sizeof(temp));
	if (num == 0)
	{
		*tempStr++ = '0';
		*tempStr++ = '\0';
	}
	else
	{
		while(num>0)
		{
			_iBuf = num%radix;
			temp[i++] = '0' + (char)_iBuf;
			num = num/radix;
		}
		i--;
		while(i>=0)
		{
			*tempStr++ = temp[i--];
		}
		*tempStr++ = '\0';
	}
	return str;
}

int aUtils::getFontHeight( AEEFont f)
{



	int _iAscent, _iDescent;

	if (m_bIsFontActive)
		return m_sFontHeight[currentFont] + m_sFontSpaceYUp[currentFont] + m_sFontSpaceYDown[currentFont];

	IDISPLAY_GetFontMetrics(((aMain*)myMain)->m_pIDisplay, f, &_iAscent, &_iDescent);




	return _iAscent + _iDescent;
}


//set a background color to fill the background with - before copying a char over it, useful when using reverse fonts
void aUtils::fontUseBackcolor( boolean b)
{
	m_bUseFontBackcolor = b;
}

//change the layout of the font, how much space to use before, after, above and below a character and what is the size of a space character
void aUtils::fontLayout( int spaceLeft, int spaceRight, int spaceUp, int spaceDown, int spaceSize)
{
	m_sFontSpaceXLeft = (byte)spaceLeft;
	m_sFontSpaceXRight = (byte)spaceRight;
	m_sFontSpaceYUp = (byte)spaceUp;
	m_sFontSpaceYDown = (byte)spaceDown;
	m_sFontSpaceSize = (byte)spaceSize;
}

//set to true to activate our graphical font after loading one
void aUtils::fontActive( boolean b)
{
	//only activate if a font has been loaded
	if (m_pimFontImage[currentFont] != NULL )//&& m_phtFontHash != NULL)
		m_bIsFontActive = b;
	else
		m_bIsFontActive = false;
}

void aUtils::setFontColor( uint32 p_Color)
{



	//only change color if color is new

#if 0x2 > 0x1 
	if(p_Color != m_clActualFontColor[currentFont])
	{
		AEEImageInfo _ImageInfo;
		//Get the image size
		IIMAGE_GetInfo(m_pimFontImage[currentFont]->m_pImage, &_ImageInfo);

		if(m_pFontBitmap[currentFont] == NULL)
		{
			//draw the whole image
			IIMAGE_SetOffset(m_pimFontImage[currentFont]->m_pImage, 0, 0);
			IIMAGE_SetDrawSize(m_pimFontImage[currentFont]->m_pImage, _ImageInfo.cx, _ImageInfo.cy);
			//create a bitmap to which is drawn instead of the screen
			if(IBITMAP_CreateCompatibleBitmap(((aMain*)myMain)->m_pbmScreen, &m_pFontBitmap[currentFont], _ImageInfo.cx, _ImageInfo.cy) != SUCCESS)
				////DBGPRINTF("aUtils::setFontColor::CreateCompatibleBitmap failed!")
				;
		}
		if(IDISPLAY_SetDestination(((aMain*)myMain)->m_pIDisplay, m_pFontBitmap[currentFont]) != SUCCESS)
		{
			////DBGPRINTF("aUtils::setFontColor::SetDestination failed!");
		}
		//draw the image
		IIMAGE_Draw(m_pimFontImage[currentFont]->m_pImage, 0, 0);
		//set destination back to screen
		if(IDISPLAY_SetDestination(((aMain*)myMain)->m_pIDisplay, ((aMain*)myMain)->m_pbmScreen) != SUCCESS)
		{
			////DBGPRINTF("aUtils::setFontColor::SetDestination failed!");
		}
		NativeColor _NCSrc, _NCComp, _NCDest;
		if(m_pFontBitmap[currentFont] != NULL)
		{
			//convert destination color to native
			_NCDest = IBITMAP_RGBToNative(m_pFontBitmap[currentFont], p_Color);
			//check all pixels
			for(int j=0; j<_ImageInfo.cy;j++)
			{
				for(int i=0;i <_ImageInfo.cx; i++)
				{
					//save pixel i,j color in _NCSrc
					if(IBITMAP_GetPixel(m_pFontBitmap[currentFont], i, j, &_NCSrc) == SUCCESS)
					{
						//convert white to native
						_NCComp = IBITMAP_RGBToNative(m_pFontBitmap[currentFont], 0xffffff00);
						//if src color is white change it with dest color
						if(_NCSrc ==  _NCComp)
						{
							AEEPoint _Point;
							_Point.x = i;
							_Point.y = j;
							if(IBITMAP_SetPixels(m_pFontBitmap[currentFont], 1, &_Point, _NCDest, AEE_RO_COPY) != SUCCESS)
								////DBGPRINTF("SetPixels failed!")
								;
						}
						//leave the src color
						else
						{
							AEEPoint _Point;
							_Point.x = i;
							_Point.y = j;
							if(IBITMAP_SetPixels(m_pFontBitmap[currentFont], 1, &_Point, _NCSrc, AEE_RO_COPY) != SUCCESS)
								////DBGPRINTF("SetPixels failed!")
								;
						}
					}
					else
						////DBGPRINTF("GetPixel failed!")
						;
				}
			}
		}
		m_clActualFontColor = p_Color;
	}
#endif




}

//paint a single char and give back it's size
int aUtils::paintChar( boolean p_bPaint, AECHAR c, int x, int y)
{



	AECHAR* cLenGet=NULL;
	AECHAR ckeyval[2048];
	int ckeyvallen = 2048;
	ckeyval[0] = '\0';
/*
	if(IRAMCACHE_Find(m_phtFontHash, &c, 1, cLenGet, &ckeyvallen) == EFAILED)
	{
		#ifdef PROFILER
			((aMain*)myMain)->myProfiler->stopMeasurement(_Retval);
		#endif
		return 0;
	}
	else
	{
		IRAMCACHE_Find(m_phtFontHash, &c, 1, ckeyval, &ckeyvallen);
		ckeyval[ckeyvallen] = '\0';
		uint32 d = ATOI(ckeyval);
*/
	uint32 d = 0;
	if(m_htFont[currentFont].get(c, d) == 1)
	{
		int cd = d;
		int cw = (cd >> 24) & 255;
		int cx = (cd >> 12) & 4095;
		int cy = cd & 4095;

		//paint the characters only if graphics object is available
		if ( ((aMain*)myMain)->m_pGraphics != NULL && p_bPaint)
		{
			//set background color if needed
			if (m_bUseFontBackcolor[currentFont])
				fillRect( ((aMain*)myMain)->m_pGraphics, x + m_sFontSpaceXLeft[currentFont], y + m_sFontSpaceYUp[currentFont], cw, m_sFontHeight[currentFont]);

/*			{
				drawClippedImage(m_pimFontImage[currentFont],x + m_sFontSpaceXLeft[currentFont], y + m_sFontSpaceYUp[currentFont], cx, cy, cw, m_sFontHeight[currentFont]);
			}
#else*/
#if 0x2 > 0x1
			if(m_pFontBitmap[currentFont] != NULL)
				IBITMAP_BltIn(((aMain*)myMain)->m_pbmScreen, x + m_sFontSpaceXLeft[currentFont], y + m_sFontSpaceYUp[currentFont], cw, m_sFontHeight[currentFont], m_pFontBitmap[currentFont], cx, cy, AEE_RO_TRANSPARENT);
			else
#endif


			{
				//IIMAGE_SetOffset(m_pimFontImage[currentFont], cx, cy);
				//IIMAGE_SetDrawSize(m_pimFontImage[currentFont], cw, m_sFontHeight[currentFont]);
				//drawImage( ((aMain*)myMain)->m_pGraphics, m_pimFontImage[currentFont], x + m_sFontSpaceXLeft[currentFont], y + m_sFontSpaceYUp[currentFont], 0);		
				drawClippedImage(m_pimFontImage[currentFont],x+m_sFontSpaceXLeft[currentFont], y + m_sFontSpaceYUp[currentFont],cx,cy,cw,m_sFontHeight[currentFont]);
			}






		}



		return cw + m_sFontSpaceXLeft[currentFont] + m_sFontSpaceXRight[currentFont];
	}
	else
	{
		//DBGPRINTF(&c);
	}



	return m_sFontSpaceSize[currentFont];
}

//paint string (only if graphics object is not null) and return length of string in pixel
int aUtils::paintString( boolean p_bPaint, AECHAR* s, int x, int y)
{




	int p = 0;
	int xs = x;

	for (p = 0; p < (int)WSTRLEN(s); p++)
		x += paintChar( p_bPaint, s[p], x, y);




	//return the length of the printed string
	return x - xs;
}

void aUtils::cleanupFont()
{
	

#if 0x2 > 0x1
	for ( int i = 0; i < m_pFontBitmap.size(); i++ ) {
		if(m_pFontBitmap[i] != NULL ) {
			IBITMAP_Release(m_pFontBitmap[i]);
			m_pFontBitmap[i] = NULL;
		}
	}
	m_pFontBitmap.removeAll();
	m_pFontBitmap.destruct();
#endif
	int i = 0;
	for ( i = 0; i < m_pimFontImage.size(); i++ ){
		if(m_pimFontImage[i] != NULL){

			m_pimFontImage[i]->release();
			delete(m_pimFontImage[i]);
			m_pimFontImage[i]=NULL;











		}
	}
	m_pimFontImage.removeAll();
	m_pimFontImage.destruct();




	for ( i = 0; i < 2; i++ ) {
		m_htFont[i].removeAll();
	}
	//m_htFont.removeAll();
	//m_htFont.destruct();
	m_sFontHeight.removeAll();
	m_sFontHeight.destruct();
	m_sFontSpaceXLeft.removeAll();
	m_sFontSpaceXLeft.destruct();
	m_sFontSpaceXRight.removeAll();
	m_sFontSpaceXRight.destruct();
	m_sFontSpaceYUp.removeAll();
	m_sFontSpaceYUp.destruct();
	m_sFontSpaceYDown.removeAll();
	m_sFontSpaceYDown.destruct();
	m_sFontSpaceSize.removeAll();
	m_sFontSpaceSize.destruct();
	m_bUseFontBackcolor.removeAll();
	m_bUseFontBackcolor.destruct();
	m_clActualFontColor.removeAll();
	m_clActualFontColor.destruct();
	currentFont = -1;


































	m_bIsFontActive = false;
	m_bUseFontBackcolor = false;
}
/*
//load a graphical font into memory, every font need to have a config file with the font layout information
int aUtils::loadFont( char* name, int p_ID)
{
#ifdef PROFILER
	ProfilerReturn _Retval = ((aMain*)myMain)->myProfiler->startMeasurement(__FUNCTION__);
#endif

	char* cfg = NULL;
	char _cBuf[81];
	AECHAR* wcfg = NULL;
	AECHAR _wcBuf[81];
	int i, j;

	//load font image
#ifndef USE_RESOURCE_FILE_BMPS
	if ((m_pimFontImage = fetchImage( p_ID)) == NULL)
#else
	if ((m_pimFontImage = fetchBmp(p_ID, &m_FontImageInfo)) == NULL)
#endif
	{
		////DBGPRINTF("Could not load font image!");
		#ifdef PROFILER
			((aMain*)myMain)->myProfiler->stopMeasurement(_Retval);
		#endif
		return -1;
	}

	String _szBuf = name;
	if(_szBuf.substring(_szBuf.length()-4).equals(".dat") != 1)
		_szBuf += ".dat";

	//load font config
	if ((wcfg = (AECHAR*)fetchResource( _szBuf, cfg)) == NULL)
	{
		////DBGPRINTF("aUtils::loadFont(): no config found for font!");
		m_pimFontImage = NULL;
		#ifdef PROFILER
			((aMain*)myMain)->myProfiler->stopMeasurement(_Retval);
		#endif
		return -1;
	}
	//cfg[0] = cfg[1] = cfg[2] = '0';

	//now prepare our hashtable

	//get a stringbuffer to work with
	//char sb[2048];
	AECHAR sb[2048];

	m_sFontHeight = -1;
	m_sFontSpaceXLeft = -1;
	m_sFontSpaceXRight = -1;
	m_sFontSpaceYUp = -1;
	m_sFontSpaceYDown = -1;
	m_sFontSpaceSize = -1;

	int lastPos = 0;
	int a, w, x = 0, y = 0;
	uint32 d;
	for(i=0; i< lastResourceLen; i++)
	{
		sb[i-lastPos] = wcfg[i];
		//Found newline
		//read the first line containing the charset height
		if( (wcfg[i] == '\n') && m_sFontHeight == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontHeight = ATOI(sb);
		}
		//read the next lines containing the charset x left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceXLeft == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontSpaceXLeft = ATOI(sb);
		}
		//read the next lines containing the charset x left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceXRight == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontSpaceXRight = ATOI(sb);
		}
		//read the next lines containing the charset y left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceYUp == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontSpaceYUp = ATOI(sb);
		}
		//read the next lines containing the charset y left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceYDown == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontSpaceYDown = ATOI(sb);
		}
		//read the next line containing the charset space size
		else if( (wcfg[i] == '\n') && m_sFontSpaceSize == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			m_sFontSpaceSize = ATOI(sb);
		}
		//now read the character definition lines
		else if(wcfg[i] == '\n')
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			
			//first read the length of the character, it's seperated by a : from the utf8 values
			for(j=0;j < (int)WSTRLEN(sb);j++)
			{
				if(sb[j] == ':')
				{
					a  = j;
					break;
				}
				else
				{
					_wcBuf[j] = sb[j];
				}
			}
			//read the width of the current char
			_wcBuf[j] = '\0';
			w = ATOI(_wcBuf);
			//is the char fitting?
			AEEImageInfo _ImageInfo;
#ifndef USE_RESOURCE_FILE_BMPS
			IIMAGE_GetInfo(m_pimFontImage, &_ImageInfo);
#else
			_ImageInfo = m_FontImageInfo;
#endif
			if ( (x + w) > _ImageInfo.cx )
			{
				x = 0;
				y += m_sFontHeight;
			}
			//store width, x pos and ypos in one int, width with 8 bit, x and y pos with 12 bit
			d = (w & 255) << 24 | (x & 4095) << 12 | (y & 4095);
	
			//now add every character to our hashtable
			for(a++; a < WSTRLEN(sb)-1; a++)
//			a++;
			{
				//store char with character position information
				int _iBuf = 1;
				char _cBuf[100];
				_itoa(d, _cBuf, 10);
				//char _c = sb[a];
				AECHAR _c = sb[a];
				m_htFont->put(_c, d);
			}

			//finally we have to calc the next char x/y position
			if ( (x += w) > _ImageInfo.cx)
			{
				x = 0;
				y += m_sFontHeight;
			}
		}//end of else
	}//end of for
	_FREE(cfg);
#ifdef PROFILER
	((aMain*)myMain)->myProfiler->stopMeasurement(_Retval);
#endif
	return 0;
}
*/
//load a graphical font into memory, every font need to have a config file with the font layout information
int aUtils::loadFont( char* name)
{




	char* cfg = NULL;
	char _cBuf[81];
	int i, j;


	int f;

	//search for free slot to store the font in
	for (f = 0; f < 2; f++)
		if (m_htFont[f].isEmpty())
			break;

	if (f == 2)
		return -1;

	currentFont = (byte)f;



	//load font image

	if ((m_pimFontImage[currentFont] = fetchImage( String(name))) == NULL)



	{
		////DBGPRINTF("Could not load font image!");



		return -1;
	}












	String _szBuf = name;
	if(_szBuf.substring(_szBuf.length()-4, _szBuf.length()-3).equals(".") == 1)
		_szBuf = _szBuf.substring(0, _szBuf.length()-4);

	if(_szBuf.substring(_szBuf.length()-4).equals(".dat") != 1)
		_szBuf += ".dat";

	//load font config
	if ((cfg = fetchResource( _szBuf, cfg)) == NULL)
	{
		////DBGPRINTF("aUtils::loadFont(): no config found for font!");
		m_pimFontImage = NULL;



		return -1;
	}
	AECHAR* wcfg = (AECHAR*)_MALLOC(sizeof(AECHAR)*lastResourceLen);
	UTF8TOWSTR((const byte*)cfg, lastResourceLen, wcfg, sizeof(AECHAR)*lastResourceLen);
	/*{
		_FREE(cfg);
		cfg = NULL;
		cfg = (char*)_MALLOC(sizeof(char)*lastResourceLen);
		cfg = WSTRTOSTR(wcfg, cfg, sizeof(char)*lastResourceLen);
		_FREE(wcfg);
	}*/
	//cfg[0] = cfg[1] = cfg[2] = '0';
/*
	//get the utf8 data and read it into a string
	final String s = toUTF8String(cfg);
	cfg = null;

	//return if an error happened while converting to utf8
	if (s == null)
	{
		fontImage = null;
		return -1;
	}
*/
	//now prepare our hashtable
/*
	if (m_phtFontHash == NULL)
	{
		if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_RAMCACHE, (void**)( &m_phtFontHash ) ) != SUCCESS)
		{
			////DBGPRINTF("ATEXT_initChar: CI RamCache failed");
			#ifdef PROFILER
				((aMain*)myMain)->myProfiler->stopMeasurement(_Retval);
			#endif
			return -1;
		}
		IRAMCACHE_SetMaxEntries(m_phtFontHash, MAXKEYS);
		IRAMCACHE_SetMaxSize(m_phtFontHash, MAXHTSIZE);
		IRAMCACHE_SetTTL(m_phtFontHash, HTTTL);
	}
	else
		IRAMCACHE_FlushAll(m_phtFontHash);
*/
	//get a stringbuffer to work with
	AECHAR sb[100];

	m_sFontHeight[currentFont] = -1;
	m_sFontSpaceXLeft[currentFont] = -1;
	m_sFontSpaceXRight[currentFont] = -1;
	m_sFontSpaceYUp[currentFont] = -1;
	m_sFontSpaceYDown[currentFont] = -1;
	m_sFontSpaceSize[currentFont] = -1;

	int lastPos = 0;
	int a, w, x = 0, y = 0;
	uint32 d;
	for(i=0; i< lastResourceLen; i++)
	{
		sb[i-lastPos] = wcfg[i];
		//Found newline
		//read the first line containing the charset height
		if( (wcfg[i] == '\n') && m_sFontHeight[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontHeight[currentFont] = ATOI(tmp);
		}
		//read the next lines containing the charset x left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceXLeft[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontSpaceXLeft[currentFont] = ATOI(tmp);
		}
		//read the next lines containing the charset x left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceXRight[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontSpaceXRight[currentFont] = ATOI(tmp);
		}
		//read the next lines containing the charset y left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceYUp[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontSpaceYUp[currentFont] = ATOI(tmp);
		}
		//read the next lines containing the charset y left spacer
		else if( (wcfg[i] == '\n') && m_sFontSpaceYDown[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontSpaceYDown[currentFont] = ATOI(tmp);
		}
		//read the next line containing the charset space size
		else if( (wcfg[i] == '\n') && m_sFontSpaceSize[currentFont] == -1)
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			char tmp[10];
			WSTRTOSTR(sb,tmp,10);
			m_sFontSpaceSize[currentFont] = ATOI(tmp);
		}
		//now read the character definition lines
		else if(wcfg[i] == '\n')
		{
			sb[i-lastPos+1] = '\0';
			lastPos = i+1;
			
			//first read the length of the character, it's seperated by a : from the utf8 values
			for(j=0;j < (int)WSTRLEN(sb);j++)
			{
				if(sb[j] == ':')
				{
					a  = j;
					break;
				}
				else
				{
					_cBuf[j] = (char)sb[j];
				}
			}
			//read the width of the current char
			_cBuf[j] = '\0';
			w = ATOI(_cBuf);
			//is the char fitting?










			if ( (x + w) > m_pimFontImage[currentFont]->getWidth())






			{
				x = 0;
				y += m_sFontHeight[currentFont];
			}
			//store width, x pos and ypos in one int, width with 8 bit, x and y pos with 12 bit
			d = (w & 255) << 24 | (x & 4095) << 12 | (y & 4095);
	
			//now add every character to our hashtable
			for(a++; a < WSTRLEN(sb)-1; a++)
//			a++;
			{
				//store char with character position information
				int _iBuf = 1;
				char _cBuf[100];
				_itoa(d, _cBuf, 10);
				AECHAR _c = sb[a];
				if(_c == '>')
					int a=0;
				m_htFont[currentFont].put(_c, d);
/*
				if(IRAMCACHE_Add(m_phtFontHash, (const char*)&_c, (int)1, (const char*)_cBuf, (int)STRLEN(_cBuf)) != SUCCESS)
				{
					////DBGPRINTF("Could not put font in hastable!");
				}
*/
			}

			//finally we have to calc the next char x/y position




			if ( (x += w) > m_pimFontImage[currentFont]->getWidth())






			{
				x = 0;
				y += m_sFontHeight[currentFont];
			}
		}//end of else
	}//end of for
	_FREE(cfg);
	cfg = NULL;
	_FREE(wcfg);
	wcfg = NULL;






	return currentFont;

}



int aUtils::getImageWidth(IImage* p_pImage)
{
	AEEImageInfo _ImageInfo;
	if(p_pImage != NULL)
	{
		IIMAGE_GetInfo(p_pImage, &_ImageInfo);
		return _ImageInfo.cx;
	}
	else
		return 0;
}

int aUtils::getImageHeight(IImage* p_pImage)
{
	AEEImageInfo _ImageInfo;
	if(p_pImage != NULL)
	{
		IIMAGE_GetInfo(p_pImage, &_ImageInfo);
		return _ImageInfo.cy;
	}
	else
		return 0;
}

int aUtils::getImageWidth(Image* p_pImage)
{
	if(p_pImage != NULL)
	{

		AEEImageInfo _ImageInfo;
		IIMAGE_GetInfo(p_pImage->m_pImage, &_ImageInfo);
		return _ImageInfo.cx;



	}
	else
		return 0;
}

int aUtils::getImageHeight(Image* p_pImage)
{
	if(p_pImage != NULL)
	{

		AEEImageInfo _ImageInfo;
		IIMAGE_GetInfo(p_pImage->m_pImage, &_ImageInfo);
		return _ImageInfo.cy;



	}
	else
		return 0;
}

#if 0x2 > 0x1
IBitmap* aUtils::createImageCompatibleBitmap(IImage* p_pImage, IBitmap* p_pBitmap)
{
	AEEImageInfo _ImageInfo;
	//Get the image size
	IIMAGE_GetInfo(p_pImage, &_ImageInfo);
	//draw the whole image
	IIMAGE_SetOffset(p_pImage, 0, 0);
	IIMAGE_SetDrawSize(p_pImage, _ImageInfo.cx, _ImageInfo.cy);
	//create a bitmap to which is drawn instead of the screen
	if(IBITMAP_CreateCompatibleBitmap(((aMain*)myMain)->m_pbmScreen, &p_pBitmap, _ImageInfo.cx, _ImageInfo.cy) != SUCCESS)
	{
		////DBGPRINTF("aUtils::setFontColor::CreateCompatibleBitmap failed!");
	}
	if(IDISPLAY_SetDestination(((aMain*)myMain)->m_pIDisplay, p_pBitmap) != SUCCESS)
	{
		////DBGPRINTF("aUtils::setFontColor::SetDestination failed!");
	}
	//draw the image
	IIMAGE_Draw(p_pImage, 0, 0);
	//set destination back to screen
	if(IDISPLAY_SetDestination(((aMain*)myMain)->m_pIDisplay, ((aMain*)myMain)->m_pbmScreen) != SUCCESS)
	{
		////DBGPRINTF("aUtils::setFontColor::SetDestination failed!");
	}	
	return p_pBitmap;
}
#endif

void aUtils::setClip ( int _x, int _y, int _width, int _height ) {
	xpos = _x;
	ypos = _y;
	width = _width;
	height = _height;
}

void aUtils::drawImage ( IGraphics* g, Image* i, int x, int y ) {
	if ( xpos == 0 && ypos == 0 && width == ((aMain*)myMain)->ScreenWidth && height == ((aMain*)myMain)->ScreenHeight)
		if ( x < 0 || y < 0 )
			drawClippedImage ( i,((x<0?0:x)+trans_xpos),((y<0?0:y)+trans_ypos),(x>0?0:0-x),(y>0?0:0-y),width,height );
		else
			drawImage(g, i, (x+trans_xpos), (y+trans_ypos), 0 );
	else
		drawClippedImage ( i, ((xpos>=x?xpos:x)+trans_xpos), ((ypos>=y?ypos:y)+trans_ypos), (xpos-x)<0?0:(xpos-x), (ypos-y)<0?0:(ypos-y), (width+xpos-x)>width?width:(width+xpos-x), (height+ypos-y)>height?height:(height+ypos-y) );
}




int aUtils::setFont(int id)
{
	int old_font = -1;
	if (id >= 0 && id < 2){
		old_font = currentFont;
		currentFont = (short)id;
	}
	return old_font;
}

int aUtils::getFont()
{
	return currentFont;
}



char* _itoa(int num, char* str, int radix)
{//radix is the base of the number
	int _iBuf;
	char temp[33];
	char *tempStr = str;
	int i = 0;
	int sign;
	if(num < 0)
		sign = -1;
	else
		sign = 1;
	num = num*sign;
	MEMSET(temp, 0, sizeof(temp));
	
	if (num == 0)
	{
		*tempStr++ = '0';
		*tempStr++ = '\0';
	}
	else
	{
		while(num>0)
		{
			_iBuf = num%radix;
			temp[i++] = '0' + (char)_iBuf;
			num = num/radix;
		}
		i--;
		if(sign == -1)
			*tempStr++ = '-';
		while(i>=0)
		{
			*tempStr++ = temp[i--];
		}
		*tempStr++ = '\0';
	}
	return str;
}

 int _nextInt()
 {
	byte _bRand[4];
	int _iRand;
	GETRAND(_bRand, 4);
	_iRand = _bRand[0]<<12;
	_iRand += _bRand[1]<<8;
	_iRand += _bRand[2]<<4;
	_iRand += _bRand[3];
	return _iRand;
 }

 void _delImg ( Image * img ) {
	 if( img != NULL ) {
		 img->release();
		 delete(img);
		 img=NULL;
	 }
 }

 
