

#pragma once
// ****************************************************************************
//  aUtils Class V1.0 BREW 1.0 (C) Kolja Hegelich & Tiago Teixeira[Charismatix] 2006
//  converted from 
//  aUtils Class V1.0 MIDP 1.0 (C) Ralf Niebecker & Andrea Middelhove GbR 2004
// ****************************************************************************
// A collection of often used Methods.
#include "AEE.h"
#include "AEEGraphics.h"
#if 0x2 > 0x1
#include "AEEFont.h"
#endif
#include "AEEFile.h"
#include "AEEAppGen.h"
#include "AEEDB.h"
#include "AEEStdLib.h"        // AEE Stb Lib Services
#include "aTextBox.h"
#include "BrewHashtable.h"
#include "aImage.h"
//##include "Devices.h"

#ifndef _WIN32
typedef long long int64;
typedef unsigned long long uint64;
#endif _WIN32

//#define DEVICE_DO_NOT_PRECACHE_RESOURCEFILE //for testing ...

class aUtils
{
public:
	aUtils();
	void freeRes();

	//reference to our main object where we get the screenwidth and screenheight values from
	AEEApplet* myMain;
	int percentLoaded; 
	//there is no way in doja to get the last color used in the canvas
	//we have to remember it manually
	int lastColor;
	//standard shadow color, can be changed by using setShadowColor
	int shadowColor;
	//store the resourcefile in use	
	String myResourceFile;
	//this variable holds the length of the last resource we read, or -1 if the length is unknown
	int lastResourceLen;
	//store our objects here
//	IRamCache* objects;
	//only needed if we are working with a resource file
	StringHashtable resources;
#if 0x2 > 0x1
	IFont* m_pFont;
#endif
	AEEFont m_AEEFont;
	IDBMgr* m_pIDBMgr;
	IDatabase* _pDB;
	IDBRecord* m_pIDBRecord;
	// graphical font handling //

	boolean m_bIsFontActive;

#if 0x2 > 0x1
	IBitmapVector m_pFontBitmap;
#endif

	ImageVector m_pimFontImage;





	FontHashtable m_htFont[2];
	Bint m_sFontHeight;
	Bint m_sFontSpaceXLeft;
	Bint m_sFontSpaceXRight;
	Bint m_sFontSpaceYUp;
	Bint m_sFontSpaceYDown;
	Bint m_sFontSpaceSize;
	Bbyte m_bUseFontBackcolor;
	Buint32 m_clActualFontColor;
	IFile* m_pResourceFile;
	short currentFont;

























	void create( AEEApplet* main);
	void setShadowColor( int c);
	void setColorRGB( IGraphics* g, int red, int green, int blue);
	void setColor( IGraphics* g, int color);
	int getColor();
	//get a font by metrix
	AEEFont getFontFSS( int face, int style, int size);
	//get the last assigned font from the graphics object
	AEEFont getFont( IGraphics* g);
	//assign a font to a graphics object
	void setFont( IGraphics* g, AEEFont f);
	void drawString( IGraphics* g, WString str, int x, int y, int mode);
	//wrap drawChars on drawString to simplify things
	void drawChars( IGraphics* g, AECHAR data[], int offset, int len, int x, int y, int mode);
	//wrap drawSubstring on drawString to simplify things
	void drawSubstring( IGraphics* g, AECHAR* str, int offset, int len, int x, int y, int mode);
	//the only mode supported for drawChar is the shadow mode, it doesn't make sense to support h and v centering here
	void drawChar( IGraphics* g, AECHAR c, int x, int y, int mode);
	//there s no charWidth method available in doja
#if 0x2 > 0x1
	int charWidth( IFont* f, const AECHAR c);
#else
	int charWidth( void* f, const AECHAR c);
#endif
	//we do support h and v centering for images 
	void drawImage( IGraphics* g, IImage* i, int x, int y, int mode);
	void drawClippedImage( IGraphics* p_IGraphics, IImage* p_pImage, int x, int y, int ox, int oy, int dx, int dy);
	void drawImage(IGraphics* g, Image* i, int x, int y, int mode);
	void drawClippedImage(Image* i, int x, int y, int ox, int oy, int dx, int dy);
#if 0x2 > 0x1
	void drawImage( IGraphics* p_IGraphics, IBitmap* p_pBitmap, int x, int y, int mode);
	void drawClippedImage( IGraphics* p_IGraphics, IBitmap* p_pBitmap, int x, int y, int ox, int oy, int dx, int dy);
#endif
	void drawClippedBmp( IGraphics* p_IGraphics, void* p_pBitmap, int x, int y, int ox, int oy, int dx, int dy);
	void drawRect( IGraphics* g, int x, int y, int width, int height);
	void fillRect( IGraphics* g, int x, int y, int width, int height);
	void fillRoundRect( IGraphics* p_IGraphics, int x, int y, int width, int height, int arcWidth, int arcHeight);
	void fillArc( IGraphics* p_IGraphics, int x, int y, int width, int height, int startAngle, int arcAngle);
	void printWithShadow( IGraphics* g, char* txt, int x, int y, int shadowColor);
	void hexdump( byte data[]);
	// be compatible to older projects
	//static int detectNumImages(char* name);
	// nicer detection of number of images
	int detectNumImages( char* prefix, int startIndex=0, char* suffix='\0');
	//write data to a recordstore
	void writeData( char* s, byte d[], int len);
	//read data from a recordstore
	byte* readData( char* s);
	//prepare a standard textbox depending on the device resolution
	//some stuff is hardcoded to save some space :)
	void prepareTextBox( aTextBox* p_pTextBox, int ScreenWidth, int ScreenHeight);
	byte* readBytesOverHTTP( char* path);
	void setResourceFile( char* name);
	char* getResourceFile( char* name);

	//return an input stream of a resource either from jar or from a resource file within the jar
	void parseResourceFile();

	//check if a resource is available in the resource file or in the jar
	boolean checkResource( String name);
	boolean checkInResourceFile(String name);
	//return an input stream of a resource either from jar or from a resource file within the jar
	char* fetchResourceIS( char* name, char* b);
	//load any resource with a known length into a byte array (faster and less memory consuming)
	char* fetchResource( String name, char* b);








	void fetchImages(StringVector* imageNames,ImageVector* images);
	//load an image from the jar, guess the suffix if needed
	IImage* fetchImage( char* imageName);
	void* fetchBmp( char* imageName, AEEImageInfo* p_ImageInfo, boolean* p_bRealloc);
	Image* fetchImage(String imageName);
	//helper routine for unsigned byte handling
	byte InttoSignedByte( int num);
	//helper routine for unsigned byte handling
	byte LongtoSignedByte( long num);
	//load an image into a byte array and change colors in the color table
	IImage* fetchAndChangeImage( char* imageName, int imageSize, short colorsToChange[]);
	Image* fetchAndChangeImage(String imageName, int imageSize, short colorsToChange[]);
	Image* fetchAndChangeImage(String imageName, short* colorsToChange);
	//change the palette of an image that has been loaded into a byte array
	IImage* changeImage( byte id[], short colorsToChange[]);
	// crc32 calculation stuff without a lookup table (slower but less memory is required) //
	uint64 crc32( unsigned short buf[], int offset, int len);
	void drawLine( IGraphics* g, int x1, int y1, int x2, int y2);
	int getFontHeight( AEEFont f);
#if 0x2 > 0x1
	int stringWidth( IFont* p_IFont, WString p_pStr);
#else
	int stringWidth( void* p_IFont, WString p_pStr);
#endif
	void waitForImage(void* p_pUser, IImage* p_pImage, AEEImageInfo* p_pImageInfo, int p_Err);


	//set a background color to fill the background with - before copying a char over it, useful when using reverse fonts
	void fontUseBackcolor( boolean b);
	//change the layout of the font, how much space to use before, after, above and below a character and what is the size of a space character
	void fontLayout( int spaceLeft, int spaceRight, int spaceUp, int spaceDown, int spaceSize);
	//set to true to activate our graphical font after loading one
	void fontActive( boolean b);
	//paint a single char and give back it's size
	int paintChar( boolean p_bPaint, AECHAR c, int x, int y);
	//paint string (only if graphics object is not null) and return length of string in pixel
	int paintString( boolean p_bPaint, AECHAR* s, int x, int y);
	void cleanupFont();
	//load a graphical font into memory, every font need to have a config file with the font layout information
	int loadFont( char* name);
//	int loadFont( char* name, int p_ID);
	void setFontColor( uint32 p_Color);

	int setFont(int id);
	int getFont();


	char* _itoa(int num, char* str, int radix);
	int getImageWidth(IImage* p_pImage);
	int getImageHeight(IImage* p_pImage);
	int getImageWidth(Image* p_pImage);
	int getImageHeight(Image* p_pImage);
	IFile* getResourceAsStream(String name, IFile* b);


	//Image clip stuff
	bool isClipped;
	int xpos;
	int ypos;
	int width;
	int height;
	int offsetx;
	int offsety;

	void setClip ( int _x, int _y, int _width, int _height );
	void drawImage(IGraphics* g, Image* i, int x, int y );
	int getClipX(){return xpos;};
	int getClipY(){return ypos;};
	int getClipWidth(){return width;};
	int getClipHeight(){return height;};

	//Image translate stuff
	int trans_xpos;
	int trans_ypos;

	void translate( int _x, int _y ) { trans_xpos+=_x;trans_ypos+=_y; }; 
	int getTranslateX() { return trans_xpos; };
	int getTranslateY() { return trans_ypos; };

#if 0x2 > 0x1
	IBitmap* createImageCompatibleBitmap(IImage* p_pImage, IBitmap* p_pBitmap);
#endif
};
char* _itoa(int num, char* str, int radix);
int _nextInt();
void _delImg( Image * img );


