//take care that it gets included exactly one time
#ifdef _GAME_HEADER_
#exit already included!
#endif
#define cubis2 // vom mir
#define _GAME_HEADER_
#define BREW_DIR_V2 BREW 3.1.5
#define BREW_DIR_V1 BREW v11

#ifdef doja
#define DOJA_COMPACT_DEVICE_CLASS
#define aKey aDevice
#endif

#define MENU_USE_EXTERNAL_GAME_START	APPLICATION_GAME
//#define ATEXTBOX_INNER_SCROLLBAR

/*****************************/
/*** include device header ***/
/*****************************/
#include Devices.h

/****************************/
/*** midlet configuration ***/
/****************************/

//the name to use for the game in the jad and manifest file and the description
//only use alphanumeric characters and spaces, no .,:;!?' etc.
//the name should not consist of more than 14 characters, the description shouldn't be longer than 40 characters
//only the MIDLET_NAME is used in doja
#ifdef cubis2
#define MIDLET_NAME Cubis 2
#define MIDLET_VENDOR Twistbox Games
#define MIDLET_COPYRIGHT -
#define MIDLET_DESCRIPTION Casual Game
#define MIDXLET_CONTENTID l_cmx_cubis2
#endif

#define MIDLET_VERSION 1.0.0

/**************************/
/*** configure features ***/
/**************************/

#ifdef 6280 || 6131 || blackberry
#define GAME_START_SLEEPTIME	1000
#endif

#ifdef doja
#define GAME_NO_HIGHSCORE
#endif

// define this if your game uses vibration, it will turn on the vibra option in the main menu
//#define GAME_USES_VIBRA //vom mir

// activate the code generation for the highscore upload supports scores with up to 2^24 points
// right now not usable for doja
#ifndef doja
//#define GAME_HISCORE_UPLOAD
//#define GAME_HISCORE_CODECHANGE		5, 6, 2, 3, 0, 4, 1		// change this code to what you have been given
//if the hiscore upload url should be read from the jad file uncomment the following define and edit the upload url
//#define GAME_HISCORE_UPLOAD_URL www.gianasisters.de
#endif

//game transition stuff
#ifndef s30 || s40 || s40midp2low || 3650 || 7650 || ngage || sx1 || gx20 || gx30 || x60 || z600 || t610 || e700 || e800 || d410
//#define GAME_USE_TRANSITIONS			//turn transitions on for the game, transitions should only be used for devices with enough heap mem and performance, do not use with nokia s60 midp1 devices...
#define GAME_TRANSITION_MODE_ANY		0	// define for random mode
#define GAME_TRANSITION_MODE_BLEND		1	// if defined use blend over transitions, can be mixed with scroll transitions
#define GAME_TRANSITION_MODE_SCROLL		2	// if defined use scroll over transitions, can be mixed with blend transitions
#endif

//define to remove the brand image screen code completely (might be useful on handsets with very low jar/heap memory)
// #ifdef s30 || s40 || gx10 || gx15 || gx20 || x60 || z600
//#define GAME_NO_BRAND_SCREEN
//#endif

//define this to remove the language selection screen code completely (might be needed on handsets with very low jar/heap memory)
//the standard text handlng (aText) can still be used but only with one language
//#ifdef  s30 || gx10
//#define GAME_NO_LANGUAGE_SELECTION_SCREEN
//#endif

//does the game need repeated key pressed events? (not every device supports this feature, it's better to implement it yourself...)
//#define GAME_PROCESS_KEY_REPEATED_EVENTS

//do we want to enable cheatcodes? if yes the needed code for checking for cheatcodes is added, the codes can be configured in game.java
#ifdef cubis2
#define GAME_USE_CHEATCODES
#endif

//define the frametime to be used within the game, not really a feature but a configuration
#define GAME_SPEED_FAST  //vom mir
#ifdef GAME_SPEED_FAST
	#define GAME_MAX_FRAMETIME 50
#else
#ifdef GAME_SPEED_NORMAL
	#define GAME_MAX_FRAMETIME 70
#else
#ifdef GAME_SPEED_SLOW
	#define GAME_MAX_FRAMETIME 90
#endif
#endif
#endif

/*
#ifdef 7210 || 3220 || s55
	#define GAME_MAX_FRAMETIME 90
#else
	#define GAME_MAX_FRAMETIME 70
#endif
*/

//do we use the new smarter, faster and less heap memory consuming bText() class for multilanguage handling or the good old aText() one, which may be needed in some cases if you do alot of Stuff with texts like Singles 2 is doing
#define GAME_USE_BTEXT_CLASS 

//do we want to use a graphical font within the menu and/or game? if yes we have to define the name of the font to use
// resolution / game (brand) dependend -> font definition moved to cubis2.h
#ifdef cubis2
	#define GAME_USE_GRAPHICAL_FONT "/f0"
	#ifndef ONE_FONT
		#define AUTILS_USE_GRAPHICAL_FONT_COUNT 2
		#define GAME_GRAPHICAL_FONT2 "/f1"
	#endif
#endif

/*****************/
/***menu items ***/
/*****************/

#resource MENU_ITEM_IMAGE 				    "/mi0"
#resource MENU_ITEM_SELECTED_IMAGE		"/mi1"

//if we are working with a reverse font we might want to use backcolor as well
//#define GAME_USE_GRAPHICAL_FONT_WITH_BACKCOLOR

//configure aUtils to enable the graphical font if the font image is available, do not touch this!
#ifdef GAME_USE_GRAPHICAL_FONT
#define AUTILS_USE_GRAPHICAL_FONT
//if using a graphical font the highscore for slow devices is doing the job
#define SLOW_DEVICE
#endif

/****************************/
/*** recordstore settings ***/
/****************************/

#define STORE_CONFIG_NAME "Cfg"	  //name for the game configuration recordstore
#define STORE_SCORES_NAME "HiS"	  //name for the high scores recordstore
//#define SCORE_USE_SINGLE_RECORDSTORE

/**************************/
/*** init mode settings ***/
/**************************/

#resource INIT_IMAGE1 "/de1"		 //the delight logo
#resource INIT_IMAGE2 "/de2"		 //and the smile to be clipped
#resource INIT_JINGLE "/de"		  //play this jingle -> can be removed

#ifdef cubis2
#define INIT_BACK_COLOR 0x00FFFFFF   //background color
#define INIT_TEXT_COLOR 0x00000000   //text color
#endif

#define INIT_WAIT_TIME 1000		  //wait this time in ms after loading is finished if 0 wait for keypress
#ifndef INIT_TEXT_POSITION
#define INIT_TEXT_POSITION -10	   //place the loading text here relative to the display end
#endif
#define INIT_QUIT_TEXT "Stop"		//"Stop" is somehow universal, but should be replace with a proper language define

/*****************************/
/*** brand screen settings ***/
/*****************************/

#ifdef GAME_NO_BRAND_SCREEN
#remove "/bi"							//remove the brand image if we are not using it
#else
#define BRAND_IMAGE "/bi"			 //show this image after the init if it is defined
#endif
#define BRAND_BACK_COLOR 0xffffff	 //use this backcolor
#define BRAND_WAIT_TIME 3000			//wait this time in ms before proceeding if 0 wait for keypress

/****************************/
/*** help screen settings ***/
/****************************/

#ifndef SIMPLIFIED_HELP
   #define HELP_IS_EXTERNAL  				  //if defined the functions paintHelp() and keyHelp() will be called in the game.java
#endif
#define HELP_TEXT_COLOR		0xffffffff	  //text color
#define HELP_BACK_COLOR		0x00000000	  //background color
#define HELP_COPYRIGHT_CHAR	

/********************************/
/*** language screen settings ***/
/********************************/

// this is a little magic (for saving code)
// if you want to use colorcycling for some text use this as the value for the define
// GameColorRotation[cycled]

#define LANG_BACK_COLOR 0x00000000	  // background color
#define LANG_TEXT_COLOR 0xffffffff		// text color, if cycling it's using GAME_COLOR_ROTATION
#define LANG_HIGHLIGHT_COLOR    0x00000000			// highlight color, if cycling it's using GAME_COLOR_ROTATION
#define LANG_NUM_ARROWS 1			   // number of arrows to use for the selector, if 0 use full screen width
#define LANG_SCROLL_IN true			// scroll color direction: in (true) or out (false)
#define LANG_ARROW_LEFT '^'				  //the left arrow ascii character to use
#define LANG_ARROW_RIGHT '~'				 //the right arrow ascii character to use
#define LANG_ARROWS_X_OFFSET	(arrowLength / 2)	// extra space between arrow and text

/**************************/
/*** main menu settings ***/
/**************************/

#ifdef cubis2
#resource MENU_MUSIC "/smm"				//playback this music within menu
#endif cubis2

#ifndef NO_MENU_IMAGE
	#resource MENU_IMAGE "/mbc"			   //background image
#else
	#remove "/mbc"
#endif

#define MENU_DIFFICULT_LEVELS 12		 //number of difficult levels for the game

//#ifdef mobile_pong || mobile_pong_2
//#define MENU_DIFFICULT_LEVELS			1
//#define cubis2_PLAYER_VS_CPU			0
//#define cubis2_CPU_VS_CPU				16
//
//#ifdef PONG_NO_MULTIPLAYER
//
//#ifdef BLUETOOTH
//#define PONG_BT_SERVER					1
//#define PONG_BT_CLIENT					2
//	#ifdef PONG_NO_BT_CLIENT
//		#define MENU_DIFFICULT_LEVELS	3
//	#else
//		#define MENU_DIFFICULT_LEVELS	2
//	#endif
//#endif BLUETOOTH
//
//#else  PONG_NO_MULTIPLAYER
//
//#define cubis2_PLAYER_VS_PLAYER		1
//#define MENU_DIFFICULT_LEVELS			2
//#ifdef BLUETOOTH
//	#define PONG_BT_SERVER				2
//	#define PONG_BT_CLIENT				3
//
//	#ifdef PONG_NO_BT_CLIENT
//		#define MENU_DIFFICULT_LEVELS	3
//	#else
//		#define MENU_DIFFICULT_LEVELS	4
//	#endif
//#endif BLUETOOTH
//
//#endif PONG_NO_MULTIPLAYER
//#endif mobile_pong || mobile_pong_2

// this is a little magic (for saving code)
// if you want to use colorcycling for some text use this as the value for the define
// GameColorRotation[cycled]

#ifdef cubis2
#define MENU_TEXT_COLOR  0xffffffff//0x00ff0000//0x00adad5e	  // text color, if cycling it's using GAME_COLOR_ROTATION
#define MENU_HIGHLIGHT_COLOR      0xffffffff			// highlight color, if cycling it's using GAME_COLOR_ROTATION
#define MENU_BACK_COLOR 0x00000000	  //background color

#define MENU_NUM_ARROWS			0		//number of arrows to use for the selector, if 0 use full screen width
#define MENU_ARROW_LEFT			' '
#define MENU_ARROW_RIGHT		' '
#define MENU_ARROWS_X_OFFSET	10
#define MENU_SCROLL_IN			true	//scroll color in (true) or out (false)
#define GAME_USE_ARROWS_MOVE

#define MENU_TEXT_POSITION 0			//place the menu text here relative to the menu image, if not defined the menu text will be centered between the menu image and the lower end of the screen
//#define MENU_IS_EXTERNAL				// if this define is set the complete menu has to be implemented in 'Game.java'
//#define MENU_PAINT_CLASSIC_EXTERNAL		// if this define is set the painting of the menu has to be implemented in 'Game.java'
#endif cubis2

// menu text alignment (center is default)
//#define MENU_ALIGNMENT_LEFT
//#define MENU_ALIGNMENT_RIGHT

/***********************************/
/*** general appearence settings ***/
/***********************************/

//defines for the menu button in the lower right corner
//#define BUTTON_GAME_PAINT				//no button will be painted ingame if not defined, you have to paint it yourself in that case
//#define BUTTON_PAINT_ALWAYS			//if defined the ingame button will always be painted if BUTTON_GAME_PAINT is defined
#define BUTTON_ARC_STYLE 5			  //defines the arc style to use for the buttons, the higher the rounder but not supported on all devices, use 0 to paint square rectangles
#define BUTTON_BACK_COLOR 0x0064acd9	//button background color
#define BUTTON_TEXT_COLOR 0xffffffff	//button text color
#define BUTTON_PAINT_TIME	0		// the time the button will be painted completely (after pressing a key)

//color rotation used for arrows and other stuff
#define GAME_COLOR_ROTATION 0x00202020, 0x00404040, 0x00606060, 0x00808080, 0x00a0a0a0, 0x00c0c0c0, 0x00e0e0e0, 0x00f0f0f0, 0x00ffffff, 0x00f0f0f0, 0x00e0e0e0, 0x00c0c0c0, 0x00a0a0a0, 0x00808080, 0x00606060, 0x00404040

#ifdef ATEXTBOX_INNER_SCROLLBAR
#define AUTILS_PREPARE_TEXTBOX_SPACE	1
#endif

/**************************************/
/*** score and score input settings ***/
/**************************************/

//on some devices we don't have enough jar mem to use a highscore music or there was a problem with the playback of it in combination with the menu music! this really depends on the music itself
//#ifdef x60 || gx10 || gx20 || gx30 || s40 || s30
#ifdef cubis2
#ifdef PLAY4PRIZES
#remove "/hs"
#else PLAY4PRIZES
#ifdef 7650 || 7210 || 3220
#remove "/hs"
#else
#resource SCORE_MUSIC "/hs"				//playback this music while showing highscores
#endif


#endif PLAY4PRIZES
#endif cubis2

#ifndef NO_MENU_IMAGE
	#define SCORE_IMAGE "/mbc"			//background image, may be the same as MENU_IMAGE in this case it's only loaded once
#else
	#remove "/mbc"
#endif


// #define SCORE_IS_IN_SECONDS	   	//if defined the score will treated as seconds and will be printed in MM:SS style
#define SCORE_ONE_PER_MODE			  //every mode gets it's own highscore if defined
#define SCORE_MARK_LAST_SCORE			//define to display the last played score with a different color
// #define SCORE_INPUT_NO_RANK				//define NOT to display the rank of the score the user played after TEXT_CONST_SGR / 'sgr' (see english.h, t1.dat, ...)
#define SCORE_MARK_COLOR_ADD 0x00f00000 //the standard rotation color will be oreed with this value to build the different color, use 0x00f00000 for red, 0x0000f0000 for green and 0x000000f0 for blue
#define SCORE_NUMBER 10				 //number of scores to manage in your game per mode
#define SCORE_NAME_LENGTH 5			 //score name limitation in characters
#define SCORE_DEFAULT_NAME "TWIST"		//when entering a hiscore name for the first time, use this as default (CHANGE!!!). please change it!!!
#define SCORE_BACK_COLOR 0x00000000		//background color
#define SCORE_TEXT_COLOR  0xffffffff//-1			 //text color, if -1 flash the color using GAME_COLOR_ROTATION
#define SCORE_SHADOW_COLOR 0x00606060   //use this shadow color if it is defined
#define SCORE_INPUT_COLOR 0xffffffff	//use this color for not selected chars in the highscore input screen and the please wait screen
#define SCORE_PAINT_COLOR 0xffffffff
#ifdef SLOW_DEVICE
#define SCORE_SEPERATOR " "			 //dont use a score seperator on slow devices
#else
#define SCORE_SEPERATOR "."			 //use this on on all other devices
#endif
#ifndef SCORE_INPUT_ARROW_X_OFFSET
#define SCORE_INPUT_ARROW_X_OFFSET 0	//the x offset for the arrows on the score input screen
#endif
#ifndef SCORE_INPUT_ARROW_Y_OFFSET
#define SCORE_INPUT_ARROW_Y_OFFSET 0	//the y offset for the arrows on the score input screen
#endif

#define SCORE_HIGHSCORE_NAMES		"Fisch","Eugen","Agnus","Holgi","Benny","Sven","Linda","DLove","Niewi","Marc"

#ifndef doja
// #define AUTILS_USE_NEW_SCORE
#define AUTILS_DEFAULT_SCORE_NAMES 		{"A","B","C","D","E","F","G","H","I","J"}
#define AUTILS_DEFAULT_SCORE_VALUES		{100000,90000,80000,70000,60000,50000,40000,30000,20000,10000};
#endif

/************************/
/***  image features  ***/
/************************/
// #define GAME_USE_PREVIEWS				// the game uses previews (not in the gallery)
// #define GAME_USE_IMAGESERIES				// the game uses images (not especially in the gallery)

// #define GAME_USES_GALLERY						// switch off the gallery
// #define GALLERY_USES_PREVIEWS			// the gallery uses previews

//#define GAME_BACK_IMAGE					"/back"	// if the game uses a tiled background - this is the name of the image

#ifdef GAME_USES_GALLERY
#define GAME_USE_IMAGESERIES				// the game uses images (at least in the gallery)
#define GAME_USE_CENTERED_STRING			// gallery uses centered string
#endif

//#define GAME_USE_IMAGEARRAY				// enables loading of an image array

/****************/
/***  images  ***/
/****************/
// a game might use some images (girls, boys, cars...) and previews of them with following defines their names can be build
// if the game uses the buildin gallery these defines are necessary

#ifdef GAME_USE_IMAGESERIES
// the name of the image is build like this:	GAME_GALLERY_IMAGE_PREFIX + index + GAME_GALLERY_IMAGE_SUFFIX
// where index is calculated within the game; example "/girl" + 3 + "big" => "/girl3big"
#define GAME_IMAGE_PREFIX				"/girl"
#define GAME_IMAGE_SUFFIX				""
#define GAME_IMAGE_START				0
#endif GAME_USE_IMAGESERIES


/******************/
/***  previews  ***/
/******************/
#ifdef GAME_USE_PREVIEWS || GALLERY_USE_PREVIEWS
// same construction like the names for the big images, but only needed for doja like that because
// for midp the previews are combined in one picture (it's smaller this way); example "/previews" +"" => "/previews"
#define GAME_PREVIEWS_PREFIX			"/previews0"
#define GAME_PREVIEWS_SUFFIX			""

#ifdef doja
#define GAME_SINGLE_PREVIEWS			// for doja the previews are always in a single file because there's no clipping
#endif
#endif GAME_USE_PREVIEWS


/*****************/
/***  gallery  ***/
/*****************/
// defines for the (buildin) gallery
#ifndef GAME_NO_GALLERY
//#define GALLERY_IS_EXTERNAL					// if this define is set the complete gallery has to be implemented in 'Game.java'
//#define GALLERY_PAINT_EXTERNAL				// if this define is set the painting of the gallery has to be implemented in 'Game.java'

#define GALLERY_BACKGROUND_COLOR			0	// background color of the gallery

#ifdef GALLERY_USE_PREVIEWS
#define GALLERY_USE_PREVIEWS_DIVIDER		// buildin gallery will paint the black borders around the previews
#define GALLERY_PREVIEWS_BLINK				// buildin gallery will paint a blinking border around the actual preview
#endif GALLERY_USE_PREVIEWS

#define GALLERY_USE_IMAGE_BORDER			// buildin gallery will paint the border around the shown image  (uses define GAME_COLOR_ROTATION)
#define GALLERY_IMAGE_BORDER_THICKNESS		7	// the thickness in pixel of the border around the shown image

#define GALLERY_USE_ARROWS					// buildin gallery will paint the arrows left and right of the image (uses define GAME_COLOR_ROTATION)
#define GALLERY_ARROWS_WIDTH				14	// the size of the arrows left and right of the image (should be even)

#define GALLERY_USE_PREVIEWS_BORDER		// buildin gallery will paint the border around the previews (uses define GAME_COLOR_ROTATION)
#define GALLERY_PREVIEWS_BORDER_THICKNESS	5	// the thickness in pixel of the border around the previews

#define GAME_DETECT_NUM_IMAGES				// this method is always necessary if gallery is used
#endif !GAME_NO_GALLERY


/*****************/
/***  buttons  ***/
/*****************/

// SOFTKEYS
#ifdef doja
	#define SOFTKEY_1 Canvas.SOFT_KEY_1
	#define SOFTKEY_2 Canvas.SOFT_KEY_2
#else  doja

#ifdef USE_COMMANDS
	#define SOFTKEY_1 Command.BACK
	#define SOFTKEY_2 Command.EXIT
#else
	#define SOFTKEY_1	AVK_SOFT1
	#define SOFTKEY_2	AVK_SOFT2
#endif USE_COMMANDS

#endif doja

#ifndef USE_COMMANDS || doja
	
	#define USE_BUTTON_IMAGES
	
	#define MULTI_BUTTON_IMAGE "/bts"
//	#available "/bts"
	
	#ifdef MULTI_BUTTON_IMAGE
		#define MULTI_BUTTON_NUMBER 3
		#define MULTI_BUTTON_OK_INDEX 2
		#define MULTI_BUTTON_CANCEL_INDEX 1
	#endif
	
//#resource MENU_BUTTON_IMAGE				"/mb"
//#available 								"/mb"
//#resource INIT_QUIT_IMAGE				"/xb"
//#available 								"/xb"

#endif

/*************************/
/*** language settings ***/
/*************************/

//because we removed the language selection code for the s30 it can only handle one language
//the help is more comfortable and more informative if we use it together with the aText class instead of using the text defines
/*#ifndef english
#remove "/t1"
#endif
#ifndef german
#remove "/t2"
#endif
#ifndef spanish
#remove "/t3"
#endif
#ifndef french
#remove "/t4"
#endif
#ifndef italian
#remove "/t5"
#endif
#ifndef portuguese
#remove "/t6"
#endif
#ifndef dutch
#remove "/t7"
#endif
#ifndef hungarian
#remove "/t8"
#endif
#ifndef greek
#remove "/t9"
#endif
#ifndef czech
#remove "/t10"
#endif
#ifndef russian
#remove "/t11"
#endif*/

//do we include text via the aText class or using defines (useful for handsets with small heap/jar mem), may cause a problem with strange umlauts?!?
#ifdef  s40 || s30 || x60 || gx10
	#define GAME_USE_TEXT_DEFINES
	//if using text defines include them here and disable the language selection screen and the external help (no fancy helpscreens for small devices)
	//#define GAME_NO_LANGUAGE_SELECTION_SCREEN
	//#undef HELP_IS_EXTERNAL
	#ifdef german
		#include German.h
	#else
		#ifdef english
			#include English.h
		#else
			#stop No Language selected!
		#endif
	#endif

////remove other text files
	#remove "/t1"
	#remove "/t2"
	#remove "/t3"
	#remove "/t4"
	#remove "/t5"
	#remove "/t6"
	#remove "/t7"
	#remove "/t8"
	#remove "/t9"
	#remove "/t10"
	#remove "/t11"
	#remove "/t.cfg"
	
#endif

/**************************/
/*** configure features ***/
/**************************/

// use the inbuild classic menu (like in giana, rainbow islands, moorhuhn, etc)
#ifdef cubis2
//#define MENU_USE_CLASSIC_MAINMENU
	#define MENU_USE_MULTIITEM_MAINMENU
#endif

// use the inbuild classic start menu (also like in giana, rainbow islands, moorhuhn, etc)
#ifdef cubis2
#define MENU_USE_CLASSIC_STARTMENU
#endif

// for positioning the arrows (e.g. in the classic menu)
#define GAME_ARROW_START_POS		0 //7

//#define GAME_STORE_ADDITIONAL_DATA //von mir rauskom.

#define GAME_PAINT_WAIT_BEFORE_GAME

//#ifdef c1200 || v180 || v980 || v360 || e770 || v525 || e1000 || 7210 || x640 || x660 || e310 || e350 || e710 || p400 || e700 || z105 || z500 || d500 || d600 || z110 || s55 || p900 || a1000 || v3x || kg800 || e900 || c450 || x100
//#define PONG_NO_MULTIPLAYER
//#endif

// ************************************************
// *** these are defines for the new main class ***
// ************************************************

// *** this defines are needed for the menu and gamestates, if a define ist set to '-1' that feature is disabled ***

// this are the basic entries, needed in every game
#define APPLICATION_INIT			0
#define APPLICATION_MAINMENU	1
#define APPLICATION_GAME			2
#define APPLICATION_HELP			3
#define APPLICATION_RESUME		4
#define APPLICATION_QUIT			5

// this are additional entries, not everybody will need them (so if you don't - just disable them by setting to '-1')

// most of the times sound is needed
#ifdef DEVICE_HAS_NO_SOUND || soundapi/none || GAME_NO_OPTIONS
#define APPLICATION_SOUND			-1
#else
#define APPLICATION_SOUND			10
#endif

// maybe brandscreen is needed
#ifndef GAME_NO_BRAND_SCREEN
#define APPLICATION_BRAND			11
#else
#define APPLICATION_BRAND			-1
#endif

// maybe language is needed
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
#define APPLICATION_LANGUAGE		12
#else
#define APPLICATION_LANGUAGE		-1
#endif

// sometimes vibration is needed
#ifdef DEVICE_HAS_VIBRA && GAME_USES_VIBRA
#define APPLICATION_VIBRA			15
#else
#define APPLICATION_VIBRA			-1
#endif

// game start submenu, main menu 'APPLICATION_MAINMENU' is 1 (see above)
#ifdef MENU_DIFFICULT_LEVELS
// it's only needed if there's more than one level
//#define APPLICATION_STARTMENU		20
#define APPLICATION_STARTMENU		16
#define APPLICATION_BACK2MAINMENU	127
#else
// setting to '-1' not required here
// be sure to use one score
#undef SCORE_ONE_PER_MODE
#endif MENU_DIFFICULT_LEVELS

// some games use a gallery
#ifdef GAME_USES_GALLERY
//#define APPLICATION_GALLERY			30
#define APPLICATION_GALLERY			17
#else
#define APPLICATION_GALLERY			-1
#endif

// Load ForPrize Definitions if Necessary
//#ifdef PLAY4PRIZES
// WARNING : The Forprize Module requires that gameState 20 through 43 and -50 through -26 not be used!
//#include ForPrizes.h
//#else !PLAY4PRIZES // ForPrizes Replaces Highscore Functionality.  Uses the Same Resources Though, so GAME_NO_HIGHSCORE should _NOT_ be set
//#define APPLICATION_FORPRIZE_MENU_MAIN 	-1
// LOAD Highscore If Necessary


// usually a game uses a highscore
#ifndef GAME_NO_HIGHSCORE
#define APPLICATION_HIGHSCORE		  40
#define APPLICATION_INPUTSCORE		41
// additionally a game might have an upload feature
#ifdef GAME_HISCORE_UPLOAD
#define APPLICATION_SCOREUPLOAD		42
#else
#define APPLICATION_SCOREUPLOAD		-1
#endif GAME_HISCORE_UPLOAD
#else
#define APPLICATION_HIGHSCORE		-1
#define APPLICATION_INPUTSCORE		-1
#define APPLICATION_SCOREUPLOAD		-1
#endif GAME_NO_HIGHSCORE
//#endif PLAY4PRIZES

#define APPLICATION_MAIN_MAX		50

#define APPLICATION_ARCADE 			51
#define APPLICATION_PUZZLE			52

#define APPLICATION_NORMAL			60
#define APPLICATION_MORPH				61
#define APPLICATION_GAMETYPE_BACK 62

#define APPLICATION_GAME2   		70
#define APPLICATION_CUBE_SET		71
#define APPLICATION_LEVEL				72
#define APPLICATION_DIFFICULTY 	73
#define APPLICATION_SETTINGS_BACK 74

#ifndef GAME_NO_OPTIONS
  #define APPLICATION_OPTIONS 80
#else
  #define APPLICATION_OPTIONS -1
#endif
#define APPLICATION_OPTIONS_BACK 81

#define APPLICATION_EXIT 90

#ifndef SIMPLIFIED_HELP
	#define APPLICATION_HELP_ENTRY				100
	#define APPLICATION_HELP_HOWTO				101
	#define APPLICATION_HELP_TYPES				102
	#define APPLICATION_HELP_SCORING			103
	#define APPLICATION_HELP_TIPS					104
	//#define APPLICATION_HELP_TOURNAMENT	105
	//#define APPLICATION_HELP_LEGAL			106
	#define APPLICATION_HELP_CREDITS			107
	#define APPLICATION_HELP_ENTRY_BACK		108
#endif

#ifdef PLAY4PRIZES
	#define APPLICATION_PAUSE_MENU 			110
	#define APPLICATION_PAUSE_FORFEIT 		111
	#define APPLICATION_PAUSE_FORFEIT_YES	112
	#define APPLICATION_PAUSE_FORFEIT_NO	113
	
	#define APPLICATION_P4P_PLAY    48
	#define APPLICATION_P4P_HELP    49
#else
	#define APPLICATION_P4P_PLAY    -1
	#define APPLICATION_P4P_HELP    -1
#endif

// this is the array for the menu entries, it's keeping exactly this order
// there's no need to remove an entry, disabled ones won't appear
// the order and position of :'APPLICATION_RESUME, APPLICATION_GAME' is required (so don't change it!!!)

#ifdef cubis2
//#define SIMPLIFIED_HELP //vom mir
//let's do it in a hard way
#ifdef PLAY4PRIZES && SIMPLIFIED_HELP
	#define MENU_PRIME_ENTRIES		APPLICATION_RESUME, APPLICATION_P4P_PLAY, APPLICATION_P4P_HELP, APPLICATION_ARCADE, APPLICATION_PUZZLE, APPLICATION_HELP, APPLICATION_OPTIONS, APPLICATION_HIGHSCORE, APPLICATION_GALLERY, APPLICATION_EXIT
#else
#ifdef PLAY4PRIZES
	#define MENU_PRIME_ENTRIES		APPLICATION_RESUME, APPLICATION_P4P_PLAY, APPLICATION_ARCADE, APPLICATION_PUZZLE, APPLICATION_HELP_ENTRY, APPLICATION_OPTIONS, APPLICATION_HIGHSCORE, APPLICATION_GALLERY, APPLICATION_EXIT
	//this sub-menu should also contain additional items like: APPLICATION_HELP_TOURNAMENT, APPLICATION_HELP_LEGAL
	#define MENU_HELP_ENTRIES			APPLICATION_HELP_HOWTO,APPLICATION_HELP_TYPES,APPLICATION_HELP_SCORING, APPLICATION_P4P_HELP,APPLICATION_HELP_TIPS,APPLICATION_HELP_CREDITS,APPLICATION_HELP_ENTRY_BACK
#else
#ifdef SIMPLIFIED_HELP
	#define MENU_PRIME_ENTRIES		APPLICATION_RESUME, APPLICATION_ARCADE, APPLICATION_PUZZLE,APPLICATION_HELP, APPLICATION_OPTIONS, APPLICATION_HIGHSCORE, APPLICATION_GALLERY, APPLICATION_EXIT
#else
	#define MENU_PRIME_ENTRIES		APPLICATION_RESUME, APPLICATION_ARCADE, APPLICATION_PUZZLE, APPLICATION_HELP_ENTRY, APPLICATION_OPTIONS, APPLICATION_HIGHSCORE, APPLICATION_GALLERY, APPLICATION_EXIT
	#define MENU_HELP_ENTRIES			APPLICATION_HELP_HOWTO,APPLICATION_HELP_TYPES,APPLICATION_HELP_SCORING,APPLICATION_HELP_TIPS,APPLICATION_HELP_CREDITS,APPLICATION_HELP_ENTRY_BACK
#endif
#endif
#endif

//#define GAME_USES_ONE_LANGUAGE
#define ONE_LANGUAGE

#define MENU_GAMETYPE_ENTRIES APPLICATION_NORMAL,APPLICATION_MORPH,APPLICATION_GAMETYPE_BACK
#define MENU_SETTINGS_ENTRIES APPLICATION_GAME2,APPLICATION_CUBE_SET,APPLICATION_LEVEL,APPLICATION_DIFFICULTY,APPLICATION_SETTINGS_BACK
#ifdef  ONE_LANGUAGE
#define MENU_OPTIONS_ENTRIES  APPLICATION_SOUND,APPLICATION_VIBRA,APPLICATION_OPTIONS_BACK
#else
#define MENU_OPTIONS_ENTRIES  APPLICATION_LANGUAGE,APPLICATION_SOUND,APPLICATION_VIBRA,APPLICATION_OPTIONS_BACK
#endif
#ifndef PLAY4PRIZES
#define MENU_HELP_ENTRIES	 APPLICATION_HELP_HOWTO,APPLICATION_HELP_TYPES,APPLICATION_HELP_SCORING,APPLICATION_HELP_TIPS,APPLICATION_HELP_CREDITS,APPLICATION_HELP_ENTRY_BACK //von mir
#endif

#ifdef APPLICATION_PAUSE_MENU
	#define MENU_PAUSE_ENTRIES 		APPLICATION_RESUME,APPLICATION_SOUND,APPLICATION_VIBRA,APPLICATION_PAUSE_FORFEIT
	#define MENU_FORFEIT_ENTRIES	APPLICATION_PAUSE_FORFEIT_YES,APPLICATION_PAUSE_FORFEIT_NO
#endif	

#endif

#ifdef cubis2
	// use header for the main menu
	#define MENU_USE_HEADER

	#ifdef MENU_USE_HEADER
	
		// use this image...
#ifdef PLAY4PRIZES
		#define MENU_HEADER_IMAGE_FILE			"/mlf"
#else
		#define MENU_HEADER_IMAGE_FILE			"/mln"
#endif

		#define MENU_HEADER_IMAGE_XOFFSET	0
		#define MENU_HEADER_IMAGE_YOFFSET	0
		#define MENU_HEADER_IMAGE_WIDTH		0
		#define MENU_HEADER_IMAGE_HEIGHT	0
		#define MENU_HEADER_SPACER			0
		
		// place it like this
		#define MENU_HEADER_XPOS			0
		#define MENU_HEADER_YPOS			(ScreenHeight/20)
		#define MENU_HEADER_WIDTH			0
		#define MENU_HEADER_HEIGHT		0
		
		// don't use text
		#define MENU_HEADER_TEXT			" "
		#define MENU_HEADER_COLOR			0
		#endif MENU_USE_HEADER
	
		#define MENU_XPOS					0
		
		#ifdef 96x65 || 120x112
			#define MENU_YPOS					(MENU_HEADER_YPOS + PMAIN->headerImage->getHeight() + 15)		// that's tricky ;)
		#else
			#define MENU_YPOS					(MENU_HEADER_YPOS + PMAIN->headerImage->getHeight() + 20)		// that's tricky ;)
		#endif
		
		#ifdef NO_MENU_IMAGE
			#define MENU_WIDTH					ScreenWidth
		#else
			#define MENU_WIDTH					PMAIN->MenuImage->getWidth()
		#endif
		
		#define MENU_HEIGHT					(ScreenHeight - MENU_YPOS - ScreenHeight/20)
		//#define MENU_HEIGHT					ScreenHeight / 2

		#define GAME_MENUITEM_SPACE 3



	
	//#define MENU_LOGO_POSY ((ScreenHeight-Main.MenuImage.getHeight())/2+ScreenHeight/20)
	//#define MENU_LOGO_OFFSETY (ScreenHeight/20)
	//#define GAME_MENUITEM_SPACE 2
	//#define MENU_BOTTOM_OFFSET (ScreenHeight/20)
	
	//#define MENU_XPOS					0
	//#ifdef 96x65 || 120x128
	//#define MENU_YPOS					headerImage.getHeight() + 10		// that's tricky ;)
	//#else
	//#define MENU_YPOS					headerImage.getHeight() + 20		// that's tricky ;)
	//#define MENU_YPOS					  ((Main.MenuImage.getHeight()-ScreenHeight)/2+MENU_LOGO_POSY+Game.gfxMenuLogo.getHeight()+MENU_LOGO_OFFSETY)
	//#endif
	//#define MENU_WIDTH					Main.MenuImage.getWidth()
	//#define MENU_HEIGHT					(ScreenHeight-MENU_LOGO_OFFSETY-Game.gfxMenuLogo.getHeight()-MENU_BOTTOM_OFFSET)
	
//(ScreenHeight/20)
//(MENU_LOGO_POSY+Game.gfxMenuLogoHeight+MENU_LOGO_OFFSETY)
//Main.MenuImage.getHeight()-MENU_YPOS-MENU_BOTTOM_OFFSET
	
//ScreenHeight-MENU_YPOS-MENU_BOTTOM_OFFSET
	
	
	
#endif cubis2

/****************/
/*** includes ***/
/****************/
// this includes must be done at the end of this file because there might be dependencies in the resource files on defines set here

// include our volume settings for the different devices, they depend on the volume of the midi sounds. there is no way to change volumes in doja
#ifndef doja
//#include Volume.h
#endif

// define which resources should be stored together in a resource file depending on the destination plattform
#ifdef doja
#include Resource.DoJa.h
#else
//#include Resource.h
#endif

// include multi-language sourcecode from "MultiLanguage.h"
#ifndef GAME_USE_TEXT_DEFINES
#include MultiLanguage.h
#endif

//include our game specific header
#ifdef cubis2
#include cubis2.h
#endif

/***************************/
/*** extra configuration ***/
/***************************/
// some very important additional configurations. usually no editing needed

#ifdef MENU_USE_CLASSIC_MAINMENU || MENU_USE_CLASSIC_STARTMENU || GAME_USE_CLASSIC_MENU
#define GAME_USE_ARROWS
#endif

#ifdef GAME_USE_GRAPHICAL_FONT
#define BUTTON_TEXT_X_OFFSET 0
#define BUTTON_TEXT_Y_OFFSET 0
#endif GAME_USE_GRAPHICAL_FONT

#ifdef cubis2
//#define GAME_HELP_ABOUT_LINE	\n\nAbout\n\n%bMIDLET_NAME%b\n\nHELP_COPYRIGHT_CHAR 2007\n\nHELP_SPECIAL_VENDOR\n\n\nVMIDLET_VERSION
	//#define GAME_HELP_ABOUT_LINE	\n
	#define MENU_NO_HELP_ABOUT_LINE
#endif



/********************************/
/*** play for prizes settings ***/
/********************************/
#ifdef PLAY4PRIZES
	#define GAME_SWITCH_P4P_GAME_PAINT_BACKGROUND							//game paint background for p4p
	#resource MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE "/mi2"				//selector image used for switch option in p4p menu

	#define MAIN_VALUE_NUM_P4P_MENU_BACK_COLOR    												 0x000000 //backgroud color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR    												 0x000000 //option text color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR    					 0x64acd9 //selected item bacground color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_BORDER_COLOR    		 0xbbe2fb //prograssbar border color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_INLAY_COLOR     		 0x4c8eb8 //prograssbar item background color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_INLAY_FILL_COLOR     0xa1d4f4 //progressbar value color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_SLIDER_FILL_COLOR     					 0xFFFFFF //slider inlay color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_SLIDER_BORDER_COLOR     				 0xFFFFFF //slider border color for for prizes menu
	#define MAIN_VALUE_NUM_P4P_MENU_OPTION_INPUT_TEXT_BACK_COLOR     			 0x97cbed //background for editable item in for prizes menu 

	#define MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET    					  (ScreenHeight/20 + headerImage->getHeight() + 20)	 	//free space above p4p menu
	#define MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET 					 (ScreenHeight/8)    //free space below p4p menu
	#define MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET   					 10    //free space on the left and right side of the p4p menu
	#define MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE  					 4		//free space between options in menu
	#define MAIN_VALUE_DIM_P4P_MENU_OPTION_PROGRESBAR_HEIGHT 16   //pregress bar height
	#define MAIN_VALUE_DIM_P4P_MENU_SLIDER_WIDTH     				 6 		//slider width in for prizes menu
	#define MAIN_VALUE_DIM_P4P_MENU_TEXT_SPACE 							 1		//space between text lines
  #define MAIN_VALUE_NUM_SMS_MAX_LENGTH  									 16		//input field max length
	#define MAIN_VALUE_DIM_P4P_SWITCH_SELECTOR_OFFSETX 			 8    //space between selectat and text in switch selector
	#define MAIN_ARRAY_MISC_SMS_KEY_MAP 										 AVK_0, AVK_1, AVK_2, AVK_3, AVK_4, AVK_5, AVK_6, AVK_7, AVK_8, AVK_9
#endif
