﻿/*** put your game class related stuff into this header file ***/

//be sure to only include this file exactly one time
#ifdef _MYGAME_HEADER_
#exit already included!
#endif
#define _MYGAME_HEADER_

/*** start here with your own settings ***/

#ifdef AKEY_USE_BLACKBERRY_API
// Blackberry API features
#define BLACKBERRY_HI_OPERATION * 3		//how many iterations simulate key press when track wheel (ball) move 3 steps [iterations = iterations BLACKBERRY_HI_OPERATION;]
#define BLACKBERRY_MEDIUM_OPERATION * 2	//how many iterations simulate key press when track wheel (ball) move 2 steps
#define BLACKBERRY_LOW_OPERATION + 1	//how many iterations simulate key press when track wheel (ball) move 1 steps

// #define BLACKBERRY_TRACKWHEEL_ROTATE
#endif

// maybe your game needs speed adjustment for slower devices
//#ifdef x100 || d410 || e310 || e700 || z600 || 3510i || c450 || k10royale || s55 || x60 || t610 || t630 || 96x65
//#define GAME_DEVICE_TOO_SLOW
//#endif

// do you use a tiled image in your game (e.g. background)
//#define GAME_TILED_IMAGE

#define GAME_BACKGROUND_COLOR	0x00000000

#ifdef GAME_USE_GRAPHICAL_FONT
#define HELP_SPECIAL_TAITO		#\n&
#define HELP_SPECIAL_CMX		α\nω
//#ifdef GAME_USE_TEXT_DEFINES
#define HELP_SPECIAL_COPYRIGHT	©
//#else
//#define HELP_SPECIAL_COPYRIGHT	
//#endif
#else
#define HELP_SPECIAL_VAUS		Vaus
#define HELP_SPECIAL_ARK		cubis2
#define HELP_SPECIAL_TAITO		MIDLET_VENDOR
#define HELP_SPECIAL_CMX		Charismatix
#endif

// you can specify when to draw the menu image
//#define MENU_DRAW_IMAGE_LAST

// if your game has got levels define a maximun here
#define GAME_MAX_LEVEL			1

// game states in which the game could be
#define GAMESTATE_INIT_GAME	 0
#define GAMESTATE_INIT_BOARD 1
#define GAMESTATE_IN_GAME		 2
#define GAMESTATE_WON				 3
#define GAMESTATE_LOST			 4
#define GAMESTATE_WON_STATS	 5
#define GAMESTATE_LOST_STATS 6
#define GAMESTATE_PERFECT 	 7

//do not use - for testing purposes
//#ifdef PLEASE_WAIT_AT_GAME_INIT
	//#define GAMESTATE_PLEASE_WAIT 10
//#endif	

#define GAMESTATE_SHOW_CREDITS	100
#ifndef GAME_NO_OPTIONS
//music
//#define IN_GAME_MUSIC 				"/smg.mid"

//#define BOMB_SOUND						"/sbo"
#define   CUBIS_SOUND						"/scu.qcp" //1
#define CHAIN_SOUND						"/sch.qcp"//2
//#define COLLIDE_SOUND					"/sco"
//#define CRACK_SOUND						"/scr"
//#define CRUMBLE_SOUND					"/scm"
//#define DESTROY_SOUND					"/sde"
//#define DROP_SOUND						"/sdr"
//#define CUBE_SHOOT_SOUND			"/scs"
#define GAME_OVER_SOUND				"/sgo.qcp"//3
//#define LASER_SHOOT_SOUND			"/sls"
#define LEVEL_COMPLETE_SOUND	"/slc.qcp"//4
#define LEVEL_START_SOUND			"/slt.qcp"//5
//#define OSMOSIS_SOUND					"/sos"
//#define PERFECT_SOUND					"/spe"
//#define WARP_GENERATE_SOUND		"/swg"
//#define WARP_TELEPORT_SOUND		"/swt"
#endif
#ifdef IN_GAME_MUSIC
	#define IN_GAME_MUSIC_WAIT  	 10
	#define MAX_NUMER_OF_SOUNDS  		1
#else
	#ifdef CUBIS_SOUND || CHAIN_SOUND || GAME_OVER_SOUND || LEVEL_COMPLETE_SOUND || LEVEL_START_SOUND
		#define MAX_NUMER_OF_SOUNDS  5
	#endif
#endif

//vibra
#ifdef DEVICE_HAS_VIBRA && GAME_USES_VIBRA
	#define VIBRATION_TIME 500
#endif

// do you use a graphical font? you can include different fontsizes for the display sizes if you need to
//#ifdef GAME_USE_GRAPHICAL_FONT
//#resource GAME_USE_GRAPHICAL_FONT "/ft.9.png"
//#else
//#remove "/ft.9.png"
//#remove "/ft.9.dat"
//#endif

// replacement for graphical font (if you can't or don't want to use it - maybe for some special devices?)
#define GAME_GRAPHIC_FONT		Main.mySmallFont
#define GAME_FONT_COLOR			0x00FFFFFF


//files
#ifdef PLAY4PRIZES
	#define GFX_MENU_LOGO_FILE  			"/mlf"
	#remove "/mln"
#else
	#define GFX_MENU_LOGO_FILE  			"/mln"
	#remove "/mlf"	
#endif		

#define GFX_MENU_BACKGROUND_FILE  "/mbc"
	
#define GFX_GAME_BACKGROUND_FILE  		"/gbc"
#define GFX_HUD_PREFIX_FILE  					"/gh"
#define GFX_CUBIS_FILE  							"/gpc"
#define GFX_MESSAGE_PREFIX_FILE  			"/gm"
#define GFX_MESSAGE_SNAIL_FILE  			"/gms"
#define GFX_CUBE_SELECTOR_FILE  			"/gse"
#define GFX_CUBES_CRACKED_FILE  			"/gcc"
#define GFX_CUBES_DISAPPEAR_FILE  		"/gcd"
#define GFX_CUBES_EXPLOSION_FILE  		"/gcx"
#define GFX_CUBES_HALF_CRACKED_FILE 	"/gcr"
#define GFX_CUBES_HALF_FILE  					"/gch"
#define GFX_CUBES_LASER_FILE  				"/gcb"
#define GFX_CUBES_LASER_SHOT_FILE  		"/gca"
#define GFX_CUBES_BOMB_FILE  					"/gcu"
#define GFX_CUBES_MELT_FILE  					"/gcp"
#define GFX_CUBES_MORPH_FILE  				"/gcm"
#define GFX_CUBES_NORMAL_FILE  				"/gcn"
#define GFX_CUBES_OSMOSIS_FILE  			"/gco"
#define GFX_CUBES_STAR_FILE  				 	"/gcs"
#define GFX_CUBES_STONE_FILE  			 	"/gct"
#define GFX_CUBES_STONE_MELT_FILE  	 	"/gcl"
#define GFX_CUBES_STONE_REMOVED_FILE  "/gcv"
#define GFX_CUBES_WARP_FILE  					"/gcw"
#define GFX_CUBES_WARPIN_FILE  				"/gci"
#define GFX_CUBES_WEDGE_FILE  				"/gce"

#define LAYOUT_ARCADE_FRESHFUN_FILE  		"/laff"
#define LAYOUT_ARCADE_CUBEOLICIOUS_FILE "/laco"
#define LAYOUT_ARCADE_BETYOUCANT_FILE  	"/laby"
#define LAYOUT_PUZZLE_FRESHFUN_FILE  		"/lpff"
#define LAYOUT_PUZZLE_CUBEOLICIOUS_FILE "/lpco"
#define LAYOUT_PUZZLE_BETYOUCANT_FILE  	"/lpby"

#ifdef PLAY4PRIZES
	#define LAYOUT_FOR_PRIZES_FILE  				"/lfpr"
#endif	

#define LAYOUT_LAY_SUFFIX ".lay"
#define LAYOUT_CFG_SUFFIX ".cfg"

//gfx num
#define GFX_HUD_GFX_NUM  		 5
#define GFX_MESSAGE_GFX_NUM  6
#define MESSAGE_ANIM_NUM_MAX 2

//menu
#define MENU_SPINNER_LEFT  "~"
#define MENU_SPINNER_RIGHT "^"
	
#define GAME_CUBE_SET  			 3

#ifdef ONLY_10_LEVELS
	#define GAME_LEVEL_NUM  		10
#else
	#define GAME_LEVEL_NUM  		50
#endif

#ifdef PLAY4PRIZES
	#define FORPRIZES_LEVEL_NUM 5
#endif
	
#define GAME_DIFFICULTY_NUM  3

#define GAME_DIFFICULTY_TIME_EASY_FACTOR    150
#define GAME_DIFFICULTY_TIME_MEDIUM_FACTOR  100
#define GAME_DIFFICULTY_TIME_HARD_FACTOR     80

#define GAME_TIME_RECALCULATE_PERC  15

#define GAME_KEY_NUMBER_OF_FRAMES_TO_WAIT 3
#ifndef 120_DEVEISES
#define FONT_SECOND_DIGIT_1   	0x2551
#define FONT_SECOND_DIGIT_2 	  0x2502
#define FONT_SECOND_DIGIT_3 	  0x250c
#define FONT_SECOND_DIGIT_4     0x2510
#define FONT_SECOND_DIGIT_5 	  0x2514
#define FONT_SECOND_DIGIT_6 	  0x2518
#define FONT_SECOND_DIGIT_7 	  0x251c
#define FONT_SECOND_DIGIT_8 	  0x2524
#define FONT_SECOND_DIGIT_9 	  0x252c
#define FONT_SECOND_DIGIT_0 	  0x2534
#define FONT_SECOND_DIGIT_DASH  0x253c
#else
#define FONT_SECOND_DIGIT_1     '1'
#define FONT_SECOND_DIGIT_2 	   '2'
#define FONT_SECOND_DIGIT_3 	   '3'
#define FONT_SECOND_DIGIT_4 	   '4'
#define FONT_SECOND_DIGIT_5 	   '5'
#define FONT_SECOND_DIGIT_6 	   '6'
#define FONT_SECOND_DIGIT_7 	   '7'
#define FONT_SECOND_DIGIT_8 	   '8'
#define FONT_SECOND_DIGIT_9 	   '9'
#define FONT_SECOND_DIGIT_0 	   '0'
#define FONT_SECOND_DIGIT_DASH   '-' 
#endif
                               
//board
#define BOARD_CUBE_SIZEX  7
#define BOARD_CUBE_SIZEY  7
#define BOARD_CUBE_SIZEZ  3
#define BOARD_BOMB_SIZEZ  6

//cubes
#define CUBE_INDEX_NUM  			5
#define CUBE_TYPE_INDEX  			0
#define CUBE_NEXT_TYPE_INDEX  1
#define CUBE_COLOR1_INDEX  		2
#define CUBE_COLOR2_INDEX  		3
#define CUBE_ACTION_INDEX  		4
		
#define CUBE_COLOR_NUM  	6
#define CUBE_COLOR_NONE  -1
#define CUBE_COLOR_BLUE  	0
#define CUBE_COLOR_GREEN  1
#define CUBE_COLOR_ORANGE 2
#define CUBE_COLOR_PURPLE 3
#define CUBE_COLOR_RED  	4
#define CUBE_COLOR_YELLOW 5

#define CUBE_TYPE_NUM  	6
#define CUBE_TYPE_NONE -1
	
#define CUBE_TYPE_NORMAL  		0
#define CUBE_TYPE_WEDGE_RIGHT 1
#define CUBE_TYPE_OSMOSIS  		2
#define CUBE_TYPE_LASER  			3
#define CUBE_TYPE_BOMB  			4
#define CUBE_TYPE_DUAL_RIGHT  5
#define CUBE_TYPE_GHOST  			6

#define CUBE_TYPE_WEDGE_LEFT  7
#define CUBE_TYPE_DUAL_LEFT  	8
			
#define CUBE_TYPE_STAR  							10
#define CUBE_TYPE_STONE  							11
#define CUBE_TYPE_CRACKED  						12
#define CUBE_TYPE_DUAL_CRACKED_RIGHT  13
#define CUBE_TYPE_DUAL_CRACKED_LEFT  	14
#define CUBE_TYPE_LASER_SHOT_RIGHT  	15
#define CUBE_TYPE_LASER_SHOT_LEFT  		16
	
#define CUBE_TYPE_DISAPPEAR_COLOR1_ONLY 			 20
#define CUBE_TYPE_DISAPPEAR_COLOR1_WITH_COLOR2 21
#define CUBE_TYPE_DISAPPEAR_COLOR2  		    	 22
#define CUBE_TYPE_STONE_DISAPPEAR  				     23
#define CUBE_TYPE_MELT  									     24
#define CUBE_TYPE_STONE_MELT  							   25
#define CUBE_TYPE_MORPH                        26
#define CUBE_TYPE_EXPLOSION                    27

#define CUBE_TYPE_GHOST_IN   31
#define CUBE_TYPE_GHOST_OUT  32
#define CUBE_TYPE_GHOST_TELEPORTING 33
	
#define CUBE_ACTION_NONE  			-1
#define CUBE_ACTION_MOVEX 			 0
#define CUBE_ACTION_MOVEY  			 1
#define CUBE_ACTION_FINAL_MOVEX  2
#define CUBE_ACTION_FINAL_MOVEY  3
#define CUBE_ACTION_FALL  			 4
#define CUBE_ACTION_LIFT  			 5
#define CUBE_ACTION_WEDGE  			 6
#define CUBE_ACTION_MORPH_LIFT   7
//#define CUBE_ACTION_FINAL_POSX   8
//#define CUBE_ACTION_FINAL_POSY   9

#define CUBE_ACTION_BOMB_LIFT  					10
#define CUBE_ACTION_BOMB_FALL  					11
#define CUBE_ACTION_BOMB_LIFT_DECISION  12
#define CUBE_ACTION_BOMB_FALL_DECISION  13

#define CUBE_GHOST_TELEPORT_MAX  2
#define CUBE_GHOST_MOVES_MAX  	 3	


//messages
#define MESSAGE_NONE  			  -1
#define MESSAGE_INTRO_ARCADE   0
#define MESSAGE_INTRO_PUZZLE   1
#define MESSAGE_WON  					 2
#define MESSAGE_LOST_TIME  		 3
#define MESSAGE_LOST_BLOCKADE  4
#define MESSAGE_STATS_WON			 5
#define MESSAGE_STATS_LOST		 6
#define MESSAGE_PERFECT 			 7
#define MESSAGE_LAST_LEVEL		 8
#ifdef PLAY4PRIZES
#define MESSAGE_P4P_END				 9
#endif

#define MESSAGE_CORNER_TL_INDEX 0
#define MESSAGE_CORNER_TR_INDEX 1
#define MESSAGE_CORNER_BL_INDEX 2
#define MESSAGE_CORNER_BR_INDEX 3
#define MESSAGE_BARH_INDEX			4
#define MESSAGE_BARV_INDEX			5	
		
//points
#define POINTS_CUBE_NORMAL  			    30
#define POINTS_CUBE_STAR  					 700
#define POINTS_CUBE_GHOST  				 	 500
#define POINTS_PENALTY_CUBE_NORMAL   -15
#define POINTS_PENALTY_CUBE_STAR    -350
#define POINTS_PENALTY_CUBE_GHOST   -250
#define POINTS_TIME_TENTH_SEC_BONUS    2

//bonus
//#define BONUS_MORE_THAN_3_MULT 2
//#define BONUS_CUBIS_MULT       2
	
//animations
#define GFX_INIT_ANIM_NUM  6	

#define GFX_CUBIS_ANIM_NUM  6

#define GFX_HUD_CUBES_ANIM_NUM  5

#define GFX_OSMOSIS_ANIM_NUM  			6
#define GFX_LASER_ANIM_NUM  				6
#define GFX_BOMB_ANIM_NUM  					4
#define GFX_LASER_SHOT_ANIM_NUM  		4
#define GFX_CUBE_DISAPPEAR_ANIM_NUM 6
#define GFX_CUBE_MORPH_ANIM_NUM  		6
#define GFX_CUBE_WARPIN_ANIM_NUM 		6

#define GFX_CUBE_WARP_ANIM_NUM  		  4
#define GFX_CUBE_WARP_ANIM_SPEED 		  2
#define GFX_CUBE_WARP_ANIM_RANGE		 16
#define GFX_CUBE_WARP_ANIM_DECISION		5



//anim speed		
#define HUD_MAIN_ANIM_SPEED  				3

#define GFX_CUBIS_ANIM_TIMES  			2
#ifdef LOW_MEM_CUBIS
	#define GFX_CUBIS_ANIM_SPEED  			5
#else
	#define GFX_CUBIS_ANIM_SPEED  			2
#endif	

#define GFX_OSMOSIS_ANIM_SPEED  	2
#define GFX_LASER_ANIM_SPEED  		2
#define GFX_BOMB_ANIM_SPEED  			2
#define GFX_LASER_SHOT_ANIM_SPEED 2	
		
//colors
#define GFX_MESSAGE_SCROLL_COLOR 0x8b8989	
#define MESSAGE_BACKGROUND_COLOR 0
	
//others
#define GFX_WATCH_BLINKING_TIME  15*1000

#define GFX_VISIBLE_SELECTED_NUM  3	

#define MESSAGE_SCROLL_SPEED  1	


//partial paint
#define PARTIAL_NONE 					 	    	0
#define PARTIAL_REDRAW_REGION  	    	1
#define PARTIAL_CUBE_INSERTION  	    2
#define PARTIAL_CUBE_QUEUE  	    		4
#define PARTIAL_SELECTOR						  8
#define PARTIAL_HUD_TOP_LEFT 	       16
#define PARTIAL_HUD_TOP_RIGHT	       32
#define PARTIAL_HUD_BOTTOM_RIGHT   	 64
#define PARTIAL_CUBIS   					 	128
#define PARTIAL_MESSAGE						 	256
#ifndef NO_SNAIL_ANIM
	#define PARTIAL_MESSAGE_SNAIL		 	512
#endif	


#ifdef NO_SNAIL_ANIM
	//#remove "/gms"
#endif

// include sizes, offsets, etc
#ifdef 96x65 || 96x65_low_mem
#include cubis2.96x65.h
#endif 96x65

#ifdef 120x112 || 120x112_low_mem || 120x112_low_mem_gif
#include cubis2.120x112.h
#endif 120x112

#ifdef 176x177 || 176x177_low_mem
#include cubis2.176x177.h
#endif 176x177

#ifdef 240x240
#include cubis2.240x240.h
#endif

#ifdef 352x416
#include cubis2.352x416.h
#endif 352x416

//some additional config
#ifndef PLAY4PRIZES
	#remove "/lfpr.lay"
	#remove "/lfpr.cfg"
#endif

//#include sound.cubis2.h
