##ifndef _AGAME_H_
##define _AGAME_H_

##include "AEE.h"
##include "AEEGraphics.h"
##include "AEEFile.h"
##include "AEEAppGen.h"
##include "AEEStdLib.h"        // AEE Stb Lib Services
##include "aSprite.h"
##include "aScroll.h"
//##include "aKey.h"
##include "aTextBox.h"
##include "aScore.h"
##include "aImage.h"
##include "aHelper.h"
#ifndef GAME_USE_TEXT_DEFINES
#ifdef GAME_USE_BTEXT_CLASS
##include "bText.h"
#else
##include "aText.h"
#endif
#endif
#ifndef soundapi/none
##include "aSound.h"
#endif

typedef BrewVector<BshortVector> d3Vector;


typedef struct m_tagconfig1 
{

	byte gameTime[2];
	byte gameCubesToGo[2];
	byte gameInitialCubesNum;
	byte gameRandomCubesNum ;
	byte gameFixedCubesNum ;
	byte gameMaxFixedCubesLenght;

}m_config;

/*typedef struct g_tagconfig
{

	int menuCubeSet;
	int menuLevel;
	int menuDifficulty;	

}g_config;*/

class aGame
{
public:
	aGame();

	void create ( AEEApplet* main,  int x,  int y);
	void freeRes();
	void init();

	//INIT MENU
	void initMenu();

	//INIT SCORES
	void initScores(int number);

	//INIT GAME
	void initGame ( int mode );

	void initLevel(int level);

	int pauseGame ();

	void key(int keyCode);

	void resumeGame();

	void logic();

#ifdef OLD_MAIN
	boolean paint(IGraphics* graphics,   boolean doFullPaint);
#else
	boolean paint( boolean doFullPaint);
#endif

#ifdef MENU_IS_EXTERNAL || MENU_PAINT_EXTERNAL
	void paintMenu(IGraphics* g, boolean doFullPaint);
#else
	int paintMenu(/*IGraphics* g, */boolean doFullPaint, int menuTextStartYPos);
#endif MENU_IS_EXTERNAL || MENU_PAINT_EXTERNAL
#ifdef GAME_USE_CHEATCODES
	void checkCheat(int keyCode);
	void initCheatCodes();
#endif

	void endGame();

	void paintCommand(IGraphics* g);

	void updateScreenSize(int x, int y);

	int processKey(int keyCode,int state);

	int processApplicationState(int oldState,int newState);

	boolean processPaint(/*IGraphics* graphics,*/ int state);
#ifndef USE_COMMANDS
	void restoreBackground(int x, int y, int width, int height);
#endif

	String getMenuItemText(int menuEntry,int state);

#ifdef MENU_EXTERNAL_PRIME_ENTRIES
	Bshort getMenuEntries();
#endif
	///////////////////Cubis2//////////////////////////////
	short checkCubeChains();
	short checkCubeInsertion(int x, int y, int z, short rightDirection, int type);
	short getCubeType(int x, int y, int z);
	short checkMovePossibility();
	short cubeHandler();
	void setCubeType(int x, int y, int z, int type);
	void setCubeMorphAnim();
	short getCubeColor1(int x, int y, int z);
	short getCubeColor2(int x, int y, int z);
	void clearCube(int x, int y, int z);
	void createCube(int x, int y, int z, int type, int color1, int color2, int action);
	void setCubeColor1(int x, int y, int z, int color1);
	void setCubeColor2(int x, int y, int z, int color1);
	short getCubeNextType(int x, int y, int z);
	void setCubeNextType(int x, int y, int z, int nextType);
	void moveCube(int x,int y, int z, short rightDirection);
	void setCubeAction(int x, int y, int z, int action);
	void setCubeSimpleAnim();
	void copyCubes(int x1, int y1, int z1, int x2, int y2, int z2);
	void insertCube(int x, int y, int z, short rightDirection, int type, int color1, int color2);
	void decreaseCubesToGo(short cubeType);
	void setCubeDisappearAnim();
	short getCubeAction(int x, int y, int z);
	short checkCubeFall();
	void loadSounds();
#ifdef LOAD_ALL_GFX_AT_INIT
	void loadAllGfx();
#else
	void loadMenuGfx();
	void loadGameGfx();
#endif
	void loadAllElements();
	void initGameBoard(String layoutFilePrefix, int levelNumber);
	void initHudMainAnim();
	void setMessage(int msgNumber);
	int  checkNextCubeJump(int x,int y, int z, int color);
	void countGameScore();
	void loadNextLevel();
	void nextSelectedCube();
	void setCubisAnim();
	void cubeTeleportHandler();
	void checkCubeSimpleAnim();
	void checkDisappearAnim();
	void checkMorphAnim();
	void checkHudMainAnim();
	void checkHudCubesAnimPaint();
	void checkCubesGfxAnim();
	void checkCubisAnim();
	void setHudCubesAnimPaint(int cubeType, int cubeColor1, int cubeColor2);
	void drawGameBackground(IGraphics* g);
	void drawHudTopLeft(IGraphics* g);
	void drawHudTopRight(IGraphics* g);
	void drawHudBottomRight(IGraphics* g);
	void drawHud(IGraphics* g);
	void drawMessage(IGraphics* g);
#ifndef LOW_MEMORY
	void drawInitCubes(IGraphics* g);
#endif
	void drawSelectionPath(IGraphics* g);
	void drawCubes(IGraphics* g);
	void drawSelector(IGraphics* g);
	void drawCubeInsertion(IGraphics* g);
	void drawCubis(IGraphics* g);
	void drawCubeQueue(IGraphics* g);
	void drawCube(IGraphics* g,int x,int y,int z,int type, int posX, int posY, int color1, int color2);
	void checkCubeChain(int x, int y, int z, int color);
	//void addPointsCube(int cubeType, int layerZ, short multiplyMoreThan3, short multiplyCubisChain);
	void scoreAddCube(int cubeType);
	void scorePrepareCube(int cubeType, int layerZ, int chainLenght);
	void scoreFinishCube();
	void scoreFinishCubis();
	void setMenu(Bshort me,int selectedItem);
	void drawMenuBackground(IGraphics* g);
	void drawMenuLogo(IGraphics* g);
	void unloadSounds();
	void scoreAddCubeCracked(int cubeType);
	void drawPartialCubes(IGraphics* g, int startX, int startY, int stopX, int stopY);
#ifndef NO_SNAIL_ANIM
	void drawMessageSnail(IGraphics* g);
#endif
#ifdef HELP_IS_EXTERNAL
	void paintHelp(boolean doFullPaint);
	void keyHelp(int keyCode);
#endif
#ifndef NO_PARTIAL_PAINT
	void updatePartialPaint(int newMode);
	void updatePartialRegion(int startX, int startY, int stopX, int stopY);
	void updatePartialSelectionPath();
#endif
	void readData();
	void writeData();
	void setCubeWarpInAnim();
	void srand(int seed);
	int  rand();
	AECHAR  changeTable(String old);
	WString changeToSecondDigitColor(int value);
	void   changeSelectedCubeLeft();
	void   changeSelectedCubeRight();
	void   checkCubeWarpInAnim();
#ifndef LOW_MEM_CUBES	
	void checkCubeWarpAnim();
#endif
	//////////////////////////////////////////////////////

	AEEApplet* myMain;
	aScore* myScores;
#ifndef GAME_USE_TEXT_DEFINES
#ifdef GAME_USE_BTEXT_CLASS
	bText* myText;
#else
	aText* myText;
#endif	
#endif
#ifndef soundapi/none
	aSound* mySound;
#endif
	aTextBox* myTextBox;

#ifdef GAME_USE_CHEATCODES
	_BOOLEAN_ isCheating;
	BintVector cheatCodes;
#endif
	int lastKeys[MAX_KEYS];

	int ScreenWidth;
	int ScreenHeight;

	int MainPercentage;

	int FrameTime;
	int MenuCommandTime;

	_BOOLEAN_ hasPaintedCommand;

	//	int MaxSounds;

	int GameScore;

	int GameLevel;
	/////////////Cubis2/////////////////////////




	short cubeBoard[7][7][6][5]; 
	int cubeBoardOffsetX;
	int cubeBoardOffsetY;
	//#ifndef LOW_MEMORY
#ifndef NO_INTRO_ANIM || LOW_MEM_CUBES
	short initBoardCounter[7][7][3];
#endif
	//#endif

	short checkChain;
	short checkFall;
	short insert_Cube;
	short cubeAction;
	short cubeNext;
	short cubeNextAnim;
	short cubeGhostInsertion;
	short cubeGhostFirstInsertion;		//
	short cubisPossible;
	short checkCrack;

	short cubeSimpleAnim;
	short cubeDisappearAnim;
	short cubeMorphAnim;
	short cubeWarpInAnim;

	short cubisAnim;
	int cubisColor;

	Bshort cubeSelectedQueueType;
	Bshort cubeSelectedQueueColor1;
	Bshort cubeSelectedQueueColor2;

	short cubeSelectedType;
	short cubeSelectedColor1;
	short cubeSelectedColor2;
	short cubeSelectedX;
	short cubeSelectedY;

	Bshort cubeRandomType;
	Bshort cubeRandomColor1;
	Bshort cubeRandomColorDouble;
	int cubeRandomColorDoubleNum;

	int 	cubeChainCheckedNumber;
#ifdef SLOW_DEVEISES
	short cubeChainChecked[7][7][3];
	short cubeChainFirstTwo[2][3];
#else
	d3Vector cubeChainChecked; 
	BshortVector cubeChainFirstTwo; 
#endif

	int cubeGhostTeleportCounter;
	int cubeGhostMovesCounter;

	short hudCubesAnim;
	short hudMainAnim;

	int hudCubeAnimType;
	int hudCubeAnimColor1;
	int hudCubeAnimColor2;
	int hudCubeAnimFactorX;
	int hudCubeAnimFactorY;

	int hudWatchBlinker;

	int bombEpicentreX;
	int bombEpicentreY;
	int bombEpicentreCounter;



	long gameTime;
	int gameCubesToGo;
	int gameInitialCubesNum;
	int gameRandomCubesNum;
	int gameFixedCubesNum;
	int gameMaxFixedCubesLenght;


	int gameCubeSet;
	int gameLevel;
	int gameDifficulty;

	short gameArcade;
	short gameNormal;

	int gameActualMessage;

	long prevTime;

	int mainFont;
	int digitFont;

	int menuCubeSet;
	int menuLevel;
	int menuDifficulty;

	short menuArcade;
	short menuNormal;



	int scoreLevel;

	int scoreBoard;
	int scoreCubisBonus;
	int scoreTimeBonus;
	int scorePerfectBonus;
	int scoreCubePenalty;
	int scoreStarPenalty;
	int scoreGhostPenalty;

	int tempScoreBoard;
	int tempScoreCube;
	int tempScoreMaxChainLenght;
	int tempScoreCubisNum;


	int recalcuateTimeCounter;


	// the mode with which the game was startet (e.g. easy, medium, hard ...)
	int gameMode;

	// the state ion which the game is (e.g. game shows intro, main game part, video, end credits ...)
	int gameState;

	// if the player can achieve a score - here it is
	int gameScore;


	// if you need to do a full paint sometimes you can trigger it with this
	_BOOLEAN_ gameDoFullPaint;

	// maybe you need this (if not - remove this and the method 'loadAllElements()' and all calls)
	_BOOLEAN_ elementsLoaded;

	// if you want scrolling credits...
	int creditsOffset;

	// if you need some paint synchronization
	//	 _BOOLEAN_ hasBeenPainted;



	ImageVector gfxHud;
	ImageVector gfxMessage;
	int imgMessageLoad;
#ifdef LOW_MEM_CUBIS
	Image* gfxCubis;
#else
	aSprite gfxCubis;
#endif


	aSprite gfxCubesNormal;
	aSprite gfxCubesCracked;
	aSprite gfxCubesHalfCracked;
	aSprite gfxCubesHalf;

	aSprite gfxCubesLaserShot;

	aSprite gfxCubesOsmosis;
	aSprite gfxCubesStar;
	aSprite gfxCubesWarp;
	aSprite gfxCubesWedge;
#ifndef NO_SNAIL_ANIM	
	aSprite gfxMessageSnail;					//message snail
#endif

#ifndef LOW_MEM_CUBES
	aSprite gfxCubesWarpIn;	
	aSprite gfxCubesDisappear;
	aSprite gfxCubesExplosion;
	aSprite gfxCubesMelt;
	aSprite gfxCubesMorph;
	aSprite gfxCubesStoneMelt;
	aSprite gfxCubesStoneRemoved;

	aSprite gfxCubesLaser;	
	aSprite gfxCubesBomb;
#else
	Image* gfxCubesLaser;	
	Image* gfxCubesBomb;	
#endif

	int gfxOsmosisAnim;
	int gfxLaserAnim;
	int gfxBombAnim;
	int gfxLaserShotAnim;


	//int gfxMenuLogoWidth;
	//int gfxMenuLogoHeight;
#ifndef NO_MENU_IMAGE
	int gfxMenuBackgroundWidth;
	int gfxMenuBackgroundHeight;
#endif

	int gfxGameBackgroundWidth;
	int gfxGameBackgroundHeight;
#ifndef NO_PARTIAL_PAINT
	//parital paint
	int partialPaintMode;

	int partialPaintRegionStartX;
	int partialPaintRegionStopX;
	int partialPaintRegionStartY;
	int partialPaintRegionStopY;

	int partialCubeSelectedX;
	int partialCubeSelectedY;

	long partialHudTime;

	int partialHudCubesAnim;

	short partialMessageUpdated;

	short partialHudBackground;
	short partialHudTopLeftBackground;
#endif


	/*#ifndef LOAD_ALL_GFX_AT_INIT		
	#ifdef PLEASE_WAIT_AT_GAME_INIT

	private static byte repaintPleaseWait;

	#endif
	#endif*/
	int messageAnim;
	Bint gfxMessageWidth;
	Bint gfxMessageHeight;
	boolean textBoxScroll;
	boolean noScore;
	////////////////// IMAGE /////////////////////
	Image* gfxMenuLogo;
	Image* gfxGameBackground;
	Image* gfxCubeSelector;
	Image* gfxCubesStone;
	Image * imagGfx1;
	Image * imagGfx2;
	Image * imagGfx3;
	Image * imagGfx4;
	Image * imagGfx5;
	Image * imagGfx6;
	Image * imagGfx7;
	Image * imagGfx8;
	Image * imagGfx9;
	Image * imagGfx10;
	Image * imagGfx11;
	Image * imagGfx12;
	Image * imagGfx13;
	Image * imagGfx14;
	Image * imagGfx15;
	Image * imagGfx16;
	Image * imagGfx17;
	Image * imagGfx18;
	Image * imagGfx19;
	Image * imagGfx20;

#ifndef soundapi/none
#ifdef IN_GAME_SOUND
	int inGameSound;
	int startInGameSound;
#endif
#endif
#ifdef HELP_IS_EXTERNAL
	short helpTextNumber ;
	short helpWait;
	short helpLoaded;
#endif
	/*#ifdef HELP_IS_EXTERNAL

	short lastHelpPos;
	_BOOLEAN_ initHelp;
	#endif*/

#ifndef NO_SNAIL_ANIM
	short messageSnailDirection;
	short messageSnailRotation;
	int messageSnailMoveAnim;
	int messageSnailAnimSpeed;
	int messageSnailFrame;
	int messageSnailPosX;
	//private static int messageSnailPosY;
#endif	
	int _randNum;
	int scoreTotalBoard;							//total board score
	int scoreTotalCubisBonus;				//total cubis bonus
	int scoreTotalTimeBonus;					//total time bonus
	int scoreTotalPerfectBonus;			//total perfect bonus
	int scoreTotalCubePenalty;				//total cube penalty
	int scoreTotalStarPenalty;				//total star cube penalty
	int scoreTotalGhostPenalty;			//total ghost cube penalty
#ifndef LOW_MEM_CUBES		
	short cubeWarpAnimIncrease[7][7][6];
	short cubeWarpAnim[7][7][6];
	short cubeWarpSpeed;
#endif	

	int keyCounterOfFramesPressing;	//how many frames player holds the same button
	int keyLast;					    //what was the last hitted key?
	////////////////////////////////////////////// Sound /////////////////////////////

	int MaxSounds;



#ifndef soundapi/none
#ifdef IN_GAME_MUSIC
	int inGameSound;
	int startInGameSound;
#endif

#ifdef BOMB_SOUND
	short startBombSound;
	int bombSound;
#endif

#ifdef CUBIS_SOUND
	short startCubisSound;
	int cubisSound;
#endif

#ifdef CHAIN_SOUND
	short startChainSound;
	int chainSound;
#endif

#ifdef COLLIDE_SOUND
	short startCollideSound;
	int collideSound;
#endif

#ifdef CRACK_SOUND
	short startCrackSound;
	int crackSound;
#endif

#ifdef CRUMBLE_SOUND
	short startCrumbleSound;
	int crumbleSound;
#endif

#ifdef DESTROY_SOUND
	short startDestroySound;
	int destroySound;
#endif

#ifdef DROP_SOUND
	short startDropSound;
	int dropSound;
#endif

#ifdef CUBE_SHOOT_SOUND
	short startCubeShootSound;
	int cubeShootSound;
#endif

#ifdef GAME_OVER_SOUND
	short startGameOverSound;
	int gameOverSound;
#endif

#ifdef LASER_SHOOT_SOUND
	short startLaserShootSound;
	int laserShootSound;
#endif

#ifdef LEVEL_COMPLETE_SOUND
	short startLevelCompleteSound;
	int levelCompleteSound;
#endif

#ifdef LEVEL_START_SOUND
	short startLevelStartSound;
	int levelStartSound;
#endif

#ifdef OSMOSIS_SOUND
	short startOsmosisSound;
	int osmosisSound;
#endif

#ifdef PERFECT_SOUND
	short startPerfectSound;
	int perfectSound;
#endif

#ifdef WARP_GENERATE_SOUND
	short startWarpGenerateSound;
	int warpGenerateSound;
#endif

#ifdef WARP_TELEPORT_SOUND
	short startWarpTeleportSound;
	int warpTeleportSound;
#endif

#endif
	int msgNr;
	int scHei;
#ifdef FRAME_TIME
	int LevelTime;
#endif
#ifdef PLAY4PRIZES
	byte playForPrizes;
	byte cubeHasNeighbour[BOARD_CUBE_SIZEX][BOARD_CUBE_SIZEY][BOARD_CUBE_SIZEZ];
	void initP4PGame(int p4p_seed,Bbyte p4p_data);

	bool drawP4PMenuBackground();
	void initP4PRandomCubes(int num);
	byte generateNewCube(int x,int y,int z,int color1);
	void loadNextP4PLevel();
	int P4PSeed;
#endif


};

##endif _AGAME_H_


