##ifndef PS_H
##define PS_H
##pragma once
typedef unsigned int UINT;
##ifndef WIN32
typedef unsigned long size_t;
##endif
extern void* mem_alloc(size_t len, const char* file, int    line);
extern void mem_free(void*, const char* info, const char* file,	int line);
extern void* mem_realloc(void*  ptr, size_t len, const char* file, int    line);
extern void mem_cleanup(const char* fname);

//#define debug

#ifdef debug
#undef __FILE__
#undef __LINE__
##define _MALLOC(size) mem_alloc(size,__FILE__,__LINE__)
##define _REALLOC(ptr,size) mem_realloc(ptr,size,__FILE__,__LINE__)
##define _FREE(ptr) mem_free(ptr,NULL,__FILE__,__LINE__)
##define _SYSFREE(ptr) if(ptr != NULL){SYSFREE(ptr);};
#else
##define _MALLOC(size) MALLOC(size)
##define _REALLOC(ptr,size) REALLOC(ptr,size)
##define _FREE(ptr) FREEIF(ptr)
##define _SYSFREE(ptr) if(ptr != NULL){SYSFREE(ptr);};
#endif

#define BREW 

#ifdef BREW
##include <aeestdlib.h>

	inline void* operator new(size_t size)
	{
		return _MALLOC(size);
	}

	inline void operator delete(void * ptr)
	{
		_FREE(ptr);
	}

	inline void* operator new[](size_t size)
	{
		return _MALLOC(size);
	}
 
	inline void operator delete[](void * ptr)
	{
		_FREE(ptr);
	}




	
##ifndef STRLOWER

		static bool isLower(char c)
		{
			return c <123 && c >96;
		}

		static char toLower(char c)
		{
			if (!isLower(c) && isUpper(c))
				return c + 32;
			return c;
		}


		static void STRLOWER(char* s)
		{
			while(*s)
			{
				*s = toLower(*s);
				s++;
			}
		}
##endif


##ifndef STRUPPER

		static bool isUpper(char c)
		{
			return (c <91) && (c >64);
		}

		static char toUpper(char c)
		{
			if (!isUpper(c) && isLower(c))
				return c - 32;
			return c;
		}

		static void STRUPPER(char* s)
		{
			while(*s)
			{
				*s = toUpper(*s);
				s++;
			}
		}
##endif

#else
	#include <stdlib.h>
	#define MALLOC malloc
	#define FREE free
	#define STRCMP strcmp
	#define STRNCMP strncmp
	#define STRLEN strlen
	#define STRSTR strstr
	#define STRCPY strcpy
	#define STRNCPY strncpy
	#define STRCAT strcat
	#define STRCHR strchr
	#define STRLOWER strlwr
	#define STRUPPER strupr
	#define MEMCPY memcpy
	#define MEMMOVE memmove
#endif





##endif
