##include "aDebug.h"
##include "aMain.h"

#define PUTILS ((aMain*)myMain)->myUtils

aDebug::aDebug(void)
{
}

aDebug::~aDebug(void)
{
}


//this is only here for compatiblity reasons
aDebug::aDebug(int maxMessages)
{
	if (msgs.size() == 0)
		add(0, "aDebug::Constructor(ADEBUG_MAX_MESSAGES): Debug System V1.2 initialized!");
}

void aDebug::create(AEEApplet* p_pMain)
{
	myMain = p_pMain;
	level = -1;
}

void aDebug::freeRes()
{
	msgs.remove(0, msgs.size());
	msgs.destruct();
}

void aDebug::add(int lvl, String msg)
{
	//return directly if in ignore mode
	if (doIgnore == _TRUE_)
		return;

	//is this the first time adding something to debug we have to allocate our stringarray first
//	if (msgs.size() == 0)
//		msgs = new String[ADEBUG_MAX_MESSAGES];

	//return if message is not important enough
	if (lvl >= 0 && lvl > level)
		return;

	//make room for the new message
//	for (int i = msgs.size() - 2; i >= 0; i--)
//		msgs[i + 1] = msgs[i];

	//and store it
	msgs.append(msg);

	//print the message into the system console
	//////DBGPRINTF(msg.toCharArray());
}

//set the debug level
void aDebug::setLevel(int lvl)
{
	level = lvl;

	if (level < -1)
		level = -1;
}

int aDebug::getLevel()
{
	return level;
}

//move to a a sposition relative to our last one
void aDebug::movePos(int posOffset)
{
	if (posOffset == 0)
		pos=0;
	else
		pos+=posOffset;
	
	if (pos < 0)
		pos=0;

	if (pos >= msgs.size())
		pos=msgs.size()-1;
}

//set ignore mode in which no messages will be added
void aDebug::setIgnore(boolean b)
{
	doIgnore = b;
}

boolean aDebug::getIgnore()
{
	return doIgnore;
}

//paint our current messages in console style
void aDebug::paint(IGraphics* g,int startX,int startY,int endX,int endY)
{
	int c,i,j,w,o,y,l,k;
/*
	final Font of = g.getFont();
	final Font f = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
	final int oc = g.getColor();
	final int fh = f.getHeight();
*/
	AEEFont of = PUTILS->getFont(g);
	AEEFont f = PUTILS->getFontFSS(0, FONT_STYLE_PLAIN, FONT_SIZE_SMALL);
	int oc = PUTILS->getColor();
	int fh = PUTILS->getFontHeight(f);

	//return if no messages have been added
	if (msgs.size() == 0)
		return;

	//work only with a copy of the debug messages while painting
//	String msgs_copy[] = new String[msgs.length];
//	System.arraycopy(msgs, 0, msgs_copy, 0, msgs_copy.length);

	PUTILS->setFont(g, f);
#ifdef ADEBUG_USE_COLOR
	PUTILS->setColor(g, ADEBUG_USE_COLOR);
#endif
	//calc number of useable lines
	y = (endY - startY) / fh;

	//correct the number of lines
	if (startY + y * fh > endY)
		y--;

	//paint debug text
	for (i = pos; i < msgs.size() && y >= 0; i++)
	{
		if (msgs.size() != 0)
		{
			//estimate number of lines needed for this message
#ifdef AUTILS_USE_GRAPHICAL_FONT 
			l = PUTILS->stringWidth(NULL, msgs[i]) / (endX - startX);
#else
			l = PUTILS->stringWidth(PUTILS->m_pFont, msgs[i]) / (endX - startX);
#endif
			k = y - l;

			//linewrap
			for (o = 0, w = 0, j = 0; j < msgs[i].length(); j++)
			{
#ifdef AUTILS_USE_GRAPHICAL_FONT
				c = PUTILS->charWidth(NULL, msgs[i].charAt(j));
#else
				c = PUTILS->charWidth(PUTILS->m_pFont, msgs[i].charAt(j));
#endif
				//print part of line
				if (c+w+startX >= endX)
				{
					//only print if in print area
					if (startY + fh * k >= startY)
						PUTILS->drawString(g, msgs[i].substring(o, j/* - o*/), startX, startY + fh * k, 0);
					k++;

					w = c;
					o = j;
				}
				else
					w += c;
			}

			//print rest of line
			if (o != j)
				PUTILS->drawString(g, msgs[i].substring(o, j/* - o*/), startX, startY + fh * k, 0);

			y -= l + 1;
		}
	}

//	msgs_copy = null;

	//restore old settings
	PUTILS->setFont(g, of);
	PUTILS->setColor(g, oc);
}

