##include "aImage.h"
##include "aMain.h"



#define PMAIN ((aMain*)myMain)

Image::Image(AEEApplet * main)
{
	myMain = main;
	m_pImage = NULL;
##if BREWVERSION > 0x1
	m_pBitmap = NULL;
	m_pBitmapInfo = NULL;
##endif
}

Image::~Image(void)
{
}

void Image::draw(int x, int y)
{
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
	/*if(m_pBitmap != NULL)
	{
		if(m_pBitmapInfo == NULL)
		{
			m_pBitmapInfo = new AEEBitmapInfo();
			IBITMAP_GetInfo(m_pBitmap, m_pBitmapInfo, sizeof(AEEBitmapInfo));
		}
		IDISPLAY_BitBlt(PMAIN->m_pIDisplay, x, y, m_pBitmapInfo->cx, m_pBitmapInfo->cy, m_pBitmap, 0, 0, AEE_RO_COPY);
	}
	else*/
##endif
	{
		IIMAGE_Draw(m_pImage, x, y);
	}
#else
	drawClipped(x, y, 0, 0, m_IInfo.cx, m_IInfo.cy);
#endif
}

void Image::drawClipped(int x, int y, int ox, int oy, int dx, int dy)
{
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
	if(m_pBitmap != NULL)
	{
		IDISPLAY_BitBlt(PMAIN->m_pIDisplay, x, y, dx, dy, m_pBitmap, ox, oy, AEE_RO_TRANSPARENT);
	}
	else
##endif
	{
		IIMAGE_SetOffset(m_pImage, ox, oy);
		IIMAGE_SetDrawSize(m_pImage, dx, dy);
		IIMAGE_Draw(m_pImage, x, y);
		IIMAGE_SetOffset(m_pImage, 0, 0);
		IIMAGE_SetDrawSize(m_pImage, PMAIN->ScreenWidth, PMAIN->ScreenHeight);
	}
#else
	IDISPLAY_BitBlt(PMAIN->m_pIDisplay, x, y, dx, dy, m_pImage, ox, oy, AEE_RO_TRANSPARENT);
#endif
}

void Image::release()
{
	if(m_pImage != NULL)
	{
#ifndef USE_RESOURCE_FILE_BMPS
		IIMAGE_Release(m_pImage);
#else
		if(m_bRealloc)
		{
			_SYSFREE(m_pImage);
		}
		else
		{
			_FREE(m_pImage);
		}
#endif
		m_pImage = NULL;
	}
##if BREWVERSION > 0x1
	if(m_pBitmap != NULL)
	{
		IBITMAP_Release(m_pBitmap);
		m_pBitmap = NULL;
	}
	if(m_pBitmapInfo != NULL)
	{
		delete(m_pBitmapInfo);
		m_pBitmapInfo = NULL;
	}
##endif
}

int Image::getWidth()
{
	int ret = 0;
#ifndef USE_RESOURCE_FILE_BMPS
	AEEImageInfo _ImageInfo;
	if ( m_pImage != NULL ) {
		IIMAGE_GetInfo(m_pImage, &_ImageInfo);
		ret = _ImageInfo.cx;
	}
#else
	if ( m_pImage != NULL ) {
		ret = m_IInfo.cx;
	}
#endif
	return ret;
}

int Image::getHeight()
{
	int ret = 0;
#ifndef USE_RESOURCE_FILE_BMPS
	AEEImageInfo _ImageInfo;
	if ( m_pImage != NULL ) {
		IIMAGE_GetInfo(m_pImage, &_ImageInfo);
		ret = _ImageInfo.cy;
	}
#else
	if ( m_pImage != NULL ) {
		ret = m_IInfo.cy;
	}
#endif
	return ret;
}

void Image::fill()
{
	AEERect r;
  	r.x = 0;
  	r.y = 0;
  	r.dx = _width;
 	r.dy = _height;
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
	NativeColor pColor = IBITMAP_RGBToNative(m_pBitmap, MAKE_RGB(255, 0, 255));
	IBITMAP_FillRect(m_pBitmap, &r, pColor, AEE_RO_COPY);
##endif
#endif
}

void Image::Draw(Image *dst, int xDst, int yDst) {
	if (!dst) {
#ifdef USE_RESOURCE_FILE_BMPS
		//Manually clip as drawing to negative coordinates will cause a nasty crash
		int newWidth = (xDst < 0) ? _width + xDst: _width;
		int newHeight = (yDst < 0) ? _height + yDst: _height;
		int xSrcOffset = (_width - newWidth);
		int ySrcOffset = (_height - newHeight);
		xDst = (xDst < 0) ? 0 : xDst;
		yDst = (yDst < 0) ? 0 : yDst;

		//IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, newWidth, newHeight, (void *)_imageData, xSrcOffset, ySrcOffset, _currentRasterOp );
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _width, _height, (void *)m_pImage, 0, 0, _currentRasterOp );
#else
##if BREWVERSION > 0x1
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _width, _height, (void *)m_pBitmap, 0, 0, _currentRasterOp );
##else
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _width, _height, (void *)m_pImage, 0, 0, _currentRasterOp );
##endif
#endif


	} else {
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, _width, _height, m_pBitmap, 0, 0, _currentRasterOp );
##endif
#endif
	}
}

void Image::Draw(Image *dst, int xDst, int yDst, int w, int h, int xSrc, int ySrc) {
	if (!dst) {
#ifdef USE_RESOURCE_FILE_BMPS
		//Manually clip as drawing to negative coordinates will cause a nasty crash
		int newWidth = (xDst < 0) ? w + xDst: w;
		int newHeight = (yDst < 0) ? w + yDst: w;
		int xSrcOffset = (w - newWidth);
		int ySrcOffset = (h - newHeight);
		xDst = (xDst < 0) ? 0 : xDst;
		yDst = (yDst < 0) ? 0 : yDst;

		//IDISPLAY_BitBlt( _display, xDst, yDst, newWidth, newHeight, (void *)_imageData, xSrc + xSrcOffset, ySrc + ySrcOffset, _currentRasterOp );
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, w, h, (void *)m_pImage, xSrc, ySrc, _currentRasterOp );
#else
##if BREWVERSION > 0x1
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, w, h, (void *)m_pBitmap, xSrc, ySrc, _currentRasterOp );
##else
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, w, h, (void *)m_pImage, xSrc, ySrc, _currentRasterOp );
##endif
#endif
	} else {
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, w, h, m_pBitmap, xSrc, ySrc, _currentRasterOp );
##endif
#endif
	}
}

void Image::DrawFrame(Image *dst, int xDst, int yDst, int frameNum) {
	if (!dst) {
#ifdef USE_RESOURCE_FILE_BMPS
		//Manually clip as drawing to negative coordinates will cause a nasty crash
		int newWidth = (xDst < 0) ? _tileW + xDst: _tileW;
		int newHeight = (yDst < 0) ? _height + yDst: _height;
		int xSrcOffset = (_tileW - newWidth);
		int ySrcOffset = (_height - newHeight);
		xDst = (xDst < 0) ? 0 : xDst;
		yDst = (yDst < 0) ? 0 : yDst;

		//IDISPLAY_BitBlt( _display, xDst, yDst, newWidth, newHeight, (void *)_imageData, frameNum * _tileW + xSrcOffset, ySrcOffset, _currentRasterOp );
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _tileW, _height, (void *)m_pImage, frameNum * _tileW, 0, _currentRasterOp );
#else
##if BREWVERSION < 0x1
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _tileW, _height, (void *)m_pBitmap, frameNum * _tileW, 0, _currentRasterOp );
##else
		IDISPLAY_BitBlt( PMAIN->m_pIDisplay, xDst, yDst, _tileW, _height, (void *)m_pImage, frameNum * _tileW, 0, _currentRasterOp );
##endif
#endif

	} else {
#ifndef USE_RESOURCE_FILE_BMPS
##if BREWVERSION > 0x1
		IBITMAP_BltIn( (IBitmap *)dst->GetImageData(), xDst, yDst, _tileW, _height, m_pBitmap, frameNum * _tileW, 0, _currentRasterOp );
##endif
#endif
	}
}

void Image::SetDefaultRasterOp(int rasterOp) {
	_defaultRasterOp = rasterOp;
	
	switch (_defaultRasterOp) {
		case RASTEROP_COPY:
			_currentRasterOp = AEE_RO_COPY;
			break;

		case RASTEROP_TRANSPARENT:
			_currentRasterOp = AEE_RO_TRANSPARENT;
			break;
	}
}
#ifdef USE_TILT
bool Image::Init(int width, int height) {
	IBitmap *displayBitmap = NULL;
	bool retval = false;

	m_pBitmap = NULL;
	_width = 0;
	_height = 0;
	_tileW = 1;
	_tileH = 1;
	_defaultRasterOp = RASTEROP_COPY;
	_currentRasterOp = AEE_RO_COPY;
	_startFrame = 0;
	_isScreenBuffer = false;
	//_display = GETDISPLAY();


	IDISPLAY_GetDeviceBitmap(GETDISPLAY(), &displayBitmap);
	if (!displayBitmap) {
		return false;
	}

	IBITMAP_CreateCompatibleBitmap(displayBitmap, &m_pBitmap, (uint16)width, (uint16)height);
	if (m_pBitmap) {
		retval = true;
    }

	NativeColor pColor = IBITMAP_RGBToNative(m_pBitmap, MAKE_RGB(255, 0, 255));
	int retint;
	retint = IBITMAP_SetTransparencyColor(m_pBitmap, pColor);

	_width = width;
	_height = height;
	_tileW = _width;
	_tileH = _height;

	AEERect r;
  	r.x = 0;
  	r.y = 0;
  	r.dx = width;
  	r.dy = height;
  	IBITMAP_FillRect(m_pBitmap, &r, pColor, AEE_RO_COPY);


	IBITMAP_Release(displayBitmap);
    displayBitmap = NULL;

	return retval;
}

bool tiltNative(                                                                    // return true if anything was drawn
    M& M,                                                                           // math lib
    int res,                                                                        // supersampling antialiasing resolution: 0 -> none, 1 -> 4x, 2 -> 16x...
    Image *src,                                                               // src image
    Image *dst,                                                               // optional dst image, defaults to screen
    int camx, int camy, int camz,                                                   // cam offset in dst/screen coordinates
    int srcx, int srcy, int srcz,                                                   // src offset in dst/screen coordinates
    int axisx, int axisy, int axisz,                                                // axis offset in dst/screen coordinates
    int axis,                                                                       // rotation axis: 0 -> x, 1 -> y
    int angle,                                                                      // rotation angle in degrees
    int *bound                                                                      // optional rendered rectangle return: { x, y, w, h }
) {
    IDIB            *sIDIB;
    IDIB            *dIDIB;
    IDisplay        *_pIDisplay = NULL;
    int             _bound[4];

    sIDIB = (IDIB *) src->GetImageData();
    if (dst) {
        dIDIB = (IDIB *) dst->GetImageData();
    } else {
        _pIDisplay = ((AEEApplet *) GET_APP_INSTANCE())->m_pIDisplay;
        if (IDISPLAY_GetDeviceBitmap(_pIDisplay, (IBitmap **) &dIDIB) != SUCCESS) {
            return false;
        }
        if (bound == NULL) {
            bound = _bound;
        }
    }
    int depth = dIDIB->nColorScheme;
    unsigned char *s = sIDIB->pBmp;
    int srcw = sIDIB->cx, srch = sIDIB->cy, spitch = sIDIB->nPitch;
    unsigned char *d = dIDIB->pBmp;
    int dstw = dIDIB->cx, dsth = dIDIB->cy, dpitch = dIDIB->nPitch;
    vec campos = M.tofixv(M.vec(camx, camy, camz));
    vec srcpos = M.tofixv(M.vec(srcx, srcy, srcz));
    vec axispos = M.tofixv(M.vec(axisx, axisy, axisz));
    angle = M.tofix(angle);
##ifdef TRANSPARENT
    const int transparent = TRANSPARENT;
##else
    const int transparent = -1;
##endif
    bool drawn = tilt(M, res, depth, s, srcw, srch, spitch, d, dstw, dsth, dpitch, campos, srcpos, axispos, axis, angle, bound, 0x00ff00ff);
    
    if (_pIDisplay) {
        if (drawn) {
            invalidate(_pIDisplay, dIDIB, bound[0], bound[1], bound[2], bound[3]);
        }
        IBITMAP_Release((IBitmap *) dIDIB);
    }
    return drawn;
}

void invalidate(IDisplay *_pIDisplay, IDIB *_pIDIB, int x, int y, int w, int h) {
    IDISPLAY_BitBlt(_pIDisplay, x, y, 1, 1, (IBitmap *) _pIDIB, x, y, AEE_RO_COPY);
    x += w - 1;
    y += h - 1;
    IDISPLAY_BitBlt(_pIDisplay, x, y, 1, 1, (IBitmap *) _pIDIB, x, y, AEE_RO_COPY);
}
#endif USE_TILT