##pragma once
##include "AEEAppGen.h"
##include "BrewString.h"
#ifdef GAME_USES_FASTBITBLT
##include "AEEBitmap.h"
#endif

#ifdef USE_TILT
//##include "M.h"
##include "tilt.h"
#endif

##ifndef GETSHELL
##define GETSHELL()		((AEEApplet*)GETAPPINSTANCE())->m_pIShell
##endif

##ifndef GETDISPLAY
##define GETDISPLAY()	((AEEApplet*)GETAPPINSTANCE())->m_pIDisplay
##endif

typedef enum _RASTEROP {
	RASTEROP_COPY = 0,
	RASTEROP_TRANSPARENT
} RASTEROP;

class Image
{
public:
	Image(AEEApplet * main);
	~Image(void);
	void release();
	void draw(int x, int y);
	void drawClipped(int x, int y, int ox, int oy, int dx, int dy);

	int getWidth();
	int getHeight();

	AEEApplet* myMain;
#ifndef USE_RESOURCE_FILE_BMPS
	IImage* m_pImage;
#else
	void* m_pImage;
	AEEImageInfo m_IInfo;
	boolean m_bRealloc;
#endif
##if BREWVERSION > 0x1
	IBitmap* m_pBitmap;
	AEEBitmapInfo* m_pBitmapInfo;
##endif

	//new Stuff from our office in San Mateo
	int _width, _height;													//Width and height of image
	int _tileW, _tileH;														//Tile width and tile height.   tileW also represents frame width.
	int _defaultRasterOp;													//Raster op to blit with
	int _currentFrame;														//What frame # are we on?
	int _startFrame;														//What frame # are we on?
	int _endFrame;															//What frame # are we on?
	bool _isScreenBuffer;													//Is this a screen buffer?

	AEERasterOp _currentRasterOp;											//Raster op to blit with

	void fill();

	//In the blitting functions below, specify dst as NULL to blit directly to the screen.

	//Regular blitting and tile blitting.
	void Draw(Image *dst, int xDst, int yDst);
	void Draw(Image *dst, int xDst, int yDst, int w, int h, int xSrc, int ySrc);

	void DrawFrame(Image *dst, int xDst, int yDst, int frameNum);


	
	void SetDefaultRasterOp(int rasterOp);

##if BREWVERSION > 0x1
	void *GetImageData()						{ return (void *)m_pBitmap; };
##endif

#ifdef USE_TILT
	bool Init(int width, int height);
#endif

	int GetTotalFrameCount()					{ return (_width / _tileW); };

};

#ifdef USE_TILT
extern bool tiltNative(                                                             // return true if anything was drawn
    M& M,                                                                           // math lib
    int res,                                                                        // supersampling antialiasing resolution: 0 -> none, 1 -> 4x, 2 -> 16x...
    Image *src,                                                               // src image
    Image *dst,                                                               // optional dst image, defaults to screen
    int camx, int camy, int camz,                                                   // cam offset in dst/screen coordinates
    int srcx, int srcy, int srcz,                                                   // src offset in dst/screen coordinates
    int axisx, int axisy, int axisz,                                                // axis offset in dst/screen coordinates
    int axis,                                                                       // rotation axis: 0 -> x, 1 -> y
    int angle,                                                                      // rotation angle in degrees
    int *bound                                                                      // optional rendered rectangle return: { x, y, w, h }
);

static void invalidate(IDisplay *_pIDisplay, IDIB *_pIDIB, int x, int y, int w, int h);
#endif USE_TILT

