##include "aKey.h"





/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/

/*-------------------------------------------------------------------
            Constructor / Destructor
-------------------------------------------------------------------*/
aKey::aKey()
{
	myMain = NULL;
#undef UP
	KeyUp = AVK_UP;
#undef DOWN
	KeyDown = AVK_DOWN;
#undef LEFT
	KeyLeft = AVK_LEFT;
#undef RIGHT
	KeyRight = AVK_RIGHT;
	KeyFire = AVK_SELECT;
	KeyCall = AVK_SEND;
	KeyClear = AVK_CLR;
	KeySoftLeft = AVK_SOFT1;
	KeySoftRight = AVK_SOFT2;
	KeySoftMid = AVK_SOFT3;
	KeyZero = AVK_0;
	KeyOne = AVK_1;
	KeyTwo = AVK_2;    
	KeyThree = AVK_3;  
	KeyFour = AVK_4;   
	KeyFive = AVK_5;   
	KeySix = AVK_6;    
	KeySeven = AVK_7;  
	KeyEight = AVK_8;  
	KeyNine = AVK_9;   
	KeyAsterix = AVK_STAR;
	KeyNumber = AVK_POUND; 
	KeyState = 0;
}
/* =========================================================================
                     FUNCTION DEFINITIONS
   ========================================================================= */
void aKey::create()
{
	myMain = NULL;
	KeyUp = AVK_UP;
	KeyDown = AVK_DOWN;
	KeyLeft = AVK_LEFT;
	KeyRight = AVK_RIGHT;
	KeyFire = AVK_SELECT;
	KeyCall = AVK_SEND;
	KeyClear = AVK_CLR;
	KeySoftLeft = AVK_SOFT1;
	KeySoftRight = AVK_SOFT2;
	KeySoftMid = AVK_SOFT3;
	KeyZero = AVK_0;
	KeyOne = AVK_1;
	KeyTwo = AVK_2;    
	KeyThree = AVK_3;  
	KeyFour = AVK_4;   
	KeyFive = AVK_5;   
	KeySix = AVK_6;    
	KeySeven = AVK_7;  
	KeyEight = AVK_8;  
	KeyNine = AVK_9;   
	KeyAsterix = AVK_STAR;
	KeyNumber = AVK_POUND; 
	KeyState = 0;
}

int aKey::isUp(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;
	return (keyCode == KeyUp || keyCode == KeyTwo);
}

int aKey::isDown(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;
	return (keyCode == KeyDown || keyCode == KeyEight);
}

int aKey::isLeft(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeyLeft || keyCode == KeyFour);
}

int aKey::isRight(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeyRight || keyCode == KeySix);
}

int aKey::isFire(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeyFire || keyCode == KeyFive);
}

int aKey::isCall(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeyCall);
}

int aKey::isClear(uint16 keyCode)
{
		if (keyCode == 0)
			return FALSE;

	return (keyCode == KeyClear);
}

int aKey::isSoftLeft(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeySoftLeft);
}

int aKey::isSoftRight(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeySoftRight);
}

int aKey::isSoftMiddle(uint16 keyCode)
{
	if (keyCode == 0)
		return FALSE;

	return (keyCode == KeySoftMid);
}

int aKey::availableFire()
{
	return (KeyFire != 0);
}

int aKey::availableCall()
{
	return (KeyCall != 0);
}

int aKey::availableClear()
{
	return (KeyClear != 0);
}

int aKey::availableSoftLeft()
{
	return (KeySoftLeft != 0);
}

int aKey::availableSoftRight()
{
	return (KeySoftRight != 0);
}

int aKey::availableSoftMiddle()
{
	return (KeySoftMid != 0);
}

uint16 aKey::getFire()
{
	return KeyFire;
}

uint16 aKey::getSoftLeft()
{
	return KeySoftLeft;
}

uint16 aKey::getSoftRight()
{
	return KeySoftRight;
}

uint16 aKey::getGameAction(uint16 keyCode)
{
	if (isFire( keyCode))
		return KeyFire;

	if (isLeft( keyCode))
		return KeyLeft;

	if (isRight( keyCode))
		return KeyRight;
	
	if (isUp( keyCode))
		return KeyUp;

	if (isDown( keyCode))
		return KeyDown;

	return FALSE;
}


uint16 aKey::updatePressedKey(uint16 keyCode)
{
	//check keys
	if (keyCode >= KeyZero || keyCode <= KeyNine)
		KeyState|=(2<<(keyCode-KeyZero+5));
	else if (keyCode == KeyAsterix)
		KeyState|=KEY_FLAG_ASTERIX;
	else if (keyCode == KeyNumber)
		KeyState|=KEY_FLAG_NUMBER;
	else if (keyCode == KeySoftLeft)
		KeyState|=KEY_FLAG_SOFTLEFT;
	else if (keyCode == KeySoftRight)
		KeyState|=KEY_FLAG_SOFTRIGHT;

	//check logical game keys
	if (isFire( keyCode))
		KeyState|=KEY_FLAG_FIRE;
	else if (isLeft( keyCode))
		KeyState|=KEY_FLAG_LEFT;
	else if (isRight( keyCode))
		KeyState|=KEY_FLAG_RIGHT;
	else if (isUp( keyCode))
		KeyState|=KEY_FLAG_UP;
	else if (isDown( keyCode))
		KeyState|=KEY_FLAG_DOWN;

	return KeyState;
}

uint16 aKey::updateReleasedKey(uint16 keyCode)
{
	//check keys
	if (keyCode >= KeyZero || keyCode <= KeyNine)
		KeyState&=~(2<<(keyCode-KeyZero+5));
	else if (keyCode == KeyAsterix)
		KeyState&=~KEY_FLAG_ASTERIX;
	else if (keyCode == KeyNumber)
		KeyState&=~KEY_FLAG_NUMBER;
	else if (keyCode == KeySoftLeft)
		KeyState&=~KEY_FLAG_SOFTLEFT;
	else if (keyCode == KeySoftRight)
		KeyState&=~KEY_FLAG_SOFTRIGHT;

	//check logical game keys
	if (isFire( keyCode))
		KeyState&=~KEY_FLAG_FIRE;
	else if (isLeft( keyCode))
		KeyState&=~KEY_FLAG_LEFT;
	else if (isRight( keyCode))
		KeyState&=~KEY_FLAG_RIGHT;
	else if (isUp( keyCode))
		KeyState&=~KEY_FLAG_UP;
	else if (isDown( keyCode))
		KeyState&=~KEY_FLAG_DOWN;

	return KeyState;
}
