##ifndef AMAIN_H
##define AMAIN_H

##include "aUtils.h"
##include "aText.h"
##include "bText.h"
##include "aKey.h"
##include "aTextBox.h"
##include "aGame.h"
##include "aSprite.h"
##include "aScore.h"
#ifdef debug
##include "aDebug.h"
#endif
#ifdef PROFILER
##include "aProfiler.h"
#endif
##include "aSound.h"
##include "BrewString.h"
##include "aeeheap.h"
##include "aHelper.h"

#ifdef PLAY4PRIZES
##include "..\Module\Core\ITBClientControls.h"
##include "..\Module\Core\ITBClientEventListener.h"
##include "..\Module\Core\ITBMenuControls.h"
##include "..\Module\Core\ITBMenuEventListener.h"
##include "..\Module\Core\TBC.h"
#ifdef COMPLIANCE
##include "..\Module\Compliance\TBCompliance.h"
##include "..\Module\Compliance\TBEvents.h"
#else
##include "..\Module\ForPrizes\Verizon\VerizonAdapter.h"
##include "..\Module\ForPrizes\Verizon\TBEvents.h"
#endif
##include "FPEventListenerObj.h"
#endif

//use our own boolean for inner class stuff, it's smaller this way
#ifndef _BOOLEAN_
#define _BOOLEAN_ byte
// the (byte) cast is needed if using our own boolean in method signatures
#define _TRUE_ (byte) 1
#define _FALSE_ (byte) 0
#endif

// set default (empty) for MIDLET_VENDOR
#ifndef MIDLET_VENDOR
#define MIDLET_VENDOR -
#endif

// set defaults for debugging
#ifndef DEBUG_LEVEL
#define DEBUG_LEVEL	1
#endif
#ifndef DEBUG_LINES
#define DEBUG_LINES	100
#endif

#ifndef MENU_IS_EXTERNAL
#ifndef MENU_USE_CLASSIC_MAINMENU
#ifndef MENU_USE_MULTIITEM_MAINMENU
#ifndef MENU_USE_ICON_MAINMENU
// if no menu is defined use classic menu
#define MENU_USE_CLASSIC_MAINMENU
#endif
#endif
#endif
#endif

#ifdef MENU_IMAGE
#ifndef MENU_DRAW_IMAGE_FIRST || MENU_DRAW_IMAGE_LAST
#define MENU_DRAW_IMAGE_FIRST
#endif
#endif

// check transition stuff, if no mode is configured use mode blend
#ifdef GAME_USE_TRANSITIONS
#ifndef GAME_TRANSITION_MODE_SCROLL || GAME_TRANSITION_MODE_BLEND
#define GAME_TRANSITION_MODE_BLEND
#endif
#endif GAME_USE_TRANSITIONS

//remove the deviceapi completely if not needed: saves some space in the jar file
#ifdef deviceapi/none
#undef GAME_USES_VIBRA
#undef DEVICE_HAS_VIBRA
#endif

// which menu is used has to be defined
#ifdef GAME_NO_CLASSIC_MENU
#ifndef GAME_USE_MULTI_ITEM_MENU || MENU_IS_EXTERNAL
#stop you need to define which menu to use
#endif
#endif

#ifdef GAME_USE_ARROWS
#ifndef GAME_ARROW_START_POS
#define GAME_ARROW_START_POS 0
#endif
#endif

#ifdef GAME_USE_IMAGESERIES
// image addressing stuff
#ifndef GAME_IMAGE_PREFIX
#ifndef GAME_IMAGE_SUFFIX
#stop you need to define at least GAME_IMAGE_PREFIX or GAME_IMAGE_SUFFIX
#endif
#endif
// define defaults
#ifndef GAME_IMAGE_START
#define GAME_IMAGE_START 0
#endif
#ifndef GAME_IMAGE_PREFIX
#define GAME_IMAGE_PREFIX ""
#endif
#ifndef GAME_IMAGE_SUFFIX
#define GAME_IMAGE_SUFFIX ""
#endif
#endif GAME_USE_IMAGESERIES

#ifdef GAME_USE_PREVIEWS || GALLERY_USE_PREVIEWS
// previews addressing stuff
#ifndef GAME_PREVIEWS_PREFIX
#ifndef GAME_PREVIEWS_SUFFIX
#stop you need to define at least GAME_PREVIEWS_PREFIX or GAME_PREVIEWS_SUFFIX
#endif
#endif
// define defaults
#ifndef GAME_PREVIEWS_PREFIX
#define GAME_PREVIEWS_PREFIX ""
#endif
#ifndef GAME_PREVIEWS_SUFFIX
#define GAME_PREVIEWS_SUFFIX ""
#endif
#endif GAME_USE_PREVIEWS || GALLERY_USE_PREVIEWS

#define PUTILS myUtils
#define PGAME myGame
#define PKEY myKey


//TODO:
#define MAX_LINE 20

#define GAME_NO_KEY_PRESSED 0

#define TB_FRAMEWORK

typedef BrewVector<aScore> BScore ;

//#ifndef GAME_STORE_ADDITIONAL_DATA
##ifdef AEE_SIMULATOR
typedef struct tagconfig 
{
##pragma pack(push)
##pragma pack(1)
	byte valid;
	int currentLanguage;
#ifdef GAME_SET_VOLUME_MED
	byte soundVolume;
#else
	byte isSoundMuted;
#endif
#ifdef GAME_USES_VIBRA
	byte isVibrationOff;
#endif
#ifdef USE_TILT
	byte isTiltOff;
#endif
	char ScoreLastName[20];
#ifdef GAME_USE_GALLERY
	short galleryFlags;
#endif
##pragma pack(pop)
}config;
##else
typedef struct tagconfig 
{
	byte valid;
	int currentLanguage;
#ifdef GAME_SET_VOLUME_MED
	byte soundVolume;
#else
	byte isSoundMuted;
#endif

	byte isTiltOff;
	char ScoreLastName[20];
#ifdef GAME_USE_GALLERY
	short galleryFlags;
#endif
}__attribute__ ((packed)) config;
##endif
//#endif


class aMain : public AEEApplet
{
public:
	static bool  HandleEvent(aMain * pMain, AEEEvent eCode, uint16 wParam, uint32 dwParam);
	static void	    freeAppData(aMain * pMain);
	static boolean  InitAppData(IApplet *pIApplet);
	static void mainLoop(aMain * pMain);
public:
	boolean OnAppInitData();
	void OnFreeAppData();
	boolean init();
	bool OnEvent(AEEEvent eCode, uint16 wParam, uint32 dwParam);
	void doInit();
	boolean readConfig();
	void writeConfig();
	void updateLoading(int percent, String txt);
	void startGame();
	void endGame(boolean showScores, int playedScore
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
	, _BOOLEAN_ resumable
#endif
#ifdef GAME_SET_STATE_AFTER_ENDGAME
	, int newApplicationState
#endif
	);

	void changeGameState(int state);
	void hideNotify();
	void showNotify();
#ifdef GAME_USE_TRANSITIONS
#ifdef GAME_TRANSITION_MODE_SCROLL
	void paintTransScroll(Image* src, int b);
#endif
#ifdef GAME_TRANSITION_MODE_BLEND
	void paintTransBlend(Image* src, int b)
#endif
	static const byte transModeAny=0;
	static const byte transModeBlend=1;
	static const byte transModeScroll=2;
	void initTransition();
	void initTransition(byte transMode);
	void endTransition();
#endif
	void paint();
	void paintCommand();
	void paintGame();
	void paintInit();
	void keyPressed(int keyCode);
	void keyRepeated(int keyCode);
	void keyReleased(int keyCode);
	void processKey();
	void processApplicationState(int state);
	int pauseGame();
	void keyGame(int keyCode);
	void preInit();
	void postInit();
	void nextModeInit();
	void keyInit(int keyCode);

	//adi ------previous game state used for back option from help hiscores etc.
	int BackGameState;
	int PrevMenuItem;
	void setPreviousState();
	//adi ----------------------------------------------------------------------
#ifndef GAME_NO_BRAND_SCREEN
	//  ****************************************************************
	//  **********  brand methods  *************************************
	//  ****************************************************************
	void nextModeBrand();
	void paintBrand();
	void keyBrand(int keyCode);
#endif
#ifndef GAME_NO_HIGHSCORE
//  *****************************************************************
//  **********  score input  ****************************************
//  *****************************************************************
	int getScoreRangePos(char c);
	void paintScoreBackground();
	void preScoreInput();
	void postScoreInput();
	void paintWaitString();
	void paintScoreInput();
	void keyScoreInput(int keyCode);
	void preScore();
	void postScore();
	void paintScore();
	void keyScore(int keyCode);
#ifdef SCORE_IS_EXTERNAL
	void endScore();
#endif SCORE_IS_EXTERNAL
#ifdef GAME_HISCORE_UPLOAD
//  *****************************************************************
//  **********  score uploading  ************************************
//  *****************************************************************
	void keyScoreUpload(int keyCode);
	void paintScoreUpload();
#endif GAME_HISCORE_UPLOAD
#endif !GAME_NO_HIGHSCORE
	void preHelp();
	void postHelp();
	void paintHelp();
#ifdef HELP_IS_EXTERNAL
	void endHelp();
#endif
	void keyHelp(int keyCode);
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
//  ************************************************************
//  **********  language screen methods  ***********************
//  ************************************************************
	int posLanguage;
	int LanguageStartY;
	int LanguageSepY;
	void preLanguage();
	void postLanguage();
	void keyLanguage(int keyCode);
	void paintLanguage();
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN
#ifdef GAME_USE_GALLERY
	void preGallery();
	void postGallery();
	void paintGallery();
#ifdef GALLERY_USE_PREVIEWS
// paint preview pictures TODO borderthickness ist 1 zu wenig wenn paint dividers genutzt wird
	void paintGalleryPreview();
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
// draw black borders around each single preview
	void paintPreviewDivider()
#endif
#endif
	void endGallery();
	void keyGallery(int keyCode);
	void checkGalleryIndex(_BOOLEAN_ reverse);
	void switchGalleryIndex(byte index);
	_BOOLEAN_ isGalleryIndexSet(byte index);
#endif
	void preMenu();
	void postMenu();
#ifndef MENU_IS_EXTERNAL
#ifdef MENU_USE_CLASSIC_MAINMENU || MENU_USE_CLASSIC_STARTMENU || GAME_USE_CLASSIC_MENU
//  ********************************************************************
//  *********  methods for the classic menu  ***************************
//  ********************************************************************
	void paintClassicMenu(Bbyte pArray);
#endif
#ifdef MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
	void paintMultiMenu(Bbyte pArray, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int animationStatesCount, int menuTextColor, int menuHighlightColor, int itemCount);
#ifdef MENU_ITEM_IMAGE
	void paintMenuItem(Image* image, int x, int y, int xOffset, int yOffset, int width, int height, String text, int color, int mode);
#endif MENU_ITEM_IMAGE
#endif MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
	void paintIconMenu(Bbyte pArray, ImageVector pIcons, Bint pOffsets, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int menuTextColor, int menuHighlightColor);
	void paintIconMenu(Bbyte pArray, ImageVector pIcons, Bint pOffsets, ImageVector iconImage, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int menuTextColor, int menuHighlightColor);
	void processKeyIconMenu(int pCode, Bbyte pArray);
#endif MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
#endif !MENU_IS_EXTERNAL
#ifdef MENU_USE_HEADER || GAME_USE_HEADER || MENU_USE_FOOTER || GAME_USE_FOOTER
	void paintHeader(int xPos, int yPos, int width, int height, Image* image, int imageXoffset, int imageYoffset, int imageWidth, int imageHeight, String text, int color, int space);
#endif
	void processKeyMenu(int pCode, Bbyte pArray, _BOOLEAN_ map_DownRight_UpLeft);
	String getMenuItemText(int menuEntry);
#ifdef GAME_USE_CENTERED_STRING
// draws an given string in the center of the screen
// with the given yOffset the string can be positioned more up or down
	void drawCenteredString(String text, int yOffset, _BOOLEAN_ cycleColors, _BOOLEAN_ shadowed);
#endif
#ifdef GAME_TILED_IMAGE || MENU_TILED_IMAGE
// tiles a background image fullscreen; attention set clipping yourself !!!
	void paintTiledImage(Image* image, int xOffset, int yOffset, _BOOLEAN_ centerH, _BOOLEAN_ centerV);
#endif
#ifndef USE_COMMANDS
// paint the menu button
	void paintMenuButton();
#endif
#ifdef GAME_USE_ARROWS
	int arrowPos;
#ifdef MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
	void paintArrows(IGraphics* g, int arrowNumber, char arrowL, char arrowR, int arrowStartY, int arrowXoffset, String arrowText, Bint colors,  int textcolor,  boolean in,  _BOOLEAN_ reCalcArrows,  int menuWidth, int menuXpos,  _BOOLEAN_ centerAllignment=0);
#else
	void paintArrows(IGraphics* g, int arrowNumber, char arrowL, char arrowR,  int arrowStartY, int arrowXoffset, String arrowText, Bint colors,  int textcolor,  boolean in,  _BOOLEAN_ reCalcArrows,  int menuWidth,  int menuXpos);
#endif MENU_ALIGNMENT_LEFT
#endif GAME_USE_ARROWS
#ifndef soundapi/none
// returns _TRUE_ if sound is startet
	void playSound(int sound, int loop);
	void stopSound();
#endif !soundapi/none
#ifdef debug
	void paintInfo();
	void paintDebug();
	void keyDebug(int keyCode);
#endif


private:
	aTextBox _TextBox;
#ifndef GAME_USE_TEXT_DEFINES
#ifdef GAME_USE_BTEXT_CLASS
	bText _Text;
#else
	aText _Text;
#endif
#endif
	aKey _Key;
	aUtils _Utils;
	aGame _Game;
	aScore _Score;

	boolean m_bLoadText;
#ifndef soundapi/none
	aSound _Sound;
#endif
#ifdef debug
	aDebug _Debug;
#endif
#ifdef PROFILER
	aProfiler _Profiler;
	ProfilerReturn _Retval;
#endif

public:
	IGraphics* m_pGraphics;
	aMain* myMain;
	aTextBox* myTextBox;
#ifndef GAME_USE_TEXT_DEFINES
#ifdef GAME_USE_BTEXT_CLASS
	bText* myText;
#else
	aText* myText;
#endif
#endif
#ifdef SCORE_ONE_PER_MODE
	BScore myModeScores;
#endif
	aKey* myKey;
	aUtils* myUtils;
	aGame* myGame;
	aScore* myScores;
#ifndef soundapi/none
	aSound* mySound;
#endif
#ifdef debug
	aDebug* myDebug;
	String initString;
	_BOOLEAN_ doDebug;
	_BOOLEAN_ doInfo;
	int lastKeyProcessed;
	String fpsString;
	int framesPainted;
	long lastPaint;
#endif
	boolean m_bRun;
	//init vars
	int initPercentage;

#ifdef PROFILER
	aProfiler* myProfiler;
#endif	
	int ScreenWidth;
	int ScreenHeight;

	IHeap* pIHeap;
##if BREWVERSION > 0x1
	IBitmap* m_pbmScreen;
##endif
	int lastKeyPressed;

#ifdef GAME_USE_GALLERY || GAME_USE_IMAGESERIES
	int numImages;						// maximum number of images
#endif
	int cycled;					// needed for cycling colors
#ifdef GAME_USE_GALLERY
	//  **********************************************************************
	//  *********  gallery methods and vars  *********************************
	//  **********************************************************************
	int galleryYOffset;			// the offset which is used to place image and previews in the gallery
	int galleryFlags;			// flags to indicate which images are free to be displayed, used bitwise
	int galleryIndex;			// the index of the image to display in the gallery
	Image* galleryImage;			// changes while switching gallery
	int galleryImageHeight;		// the height of the gallery images
	int galleryImageWidth;		// the width of the gallery images
	_BOOLEAN_ drawGalleryImage;	// indicates that the gallery image has to be drawn
#ifdef GALLERY_USE_IMAGE_BORDER
	byte galleryImageBorder;		// thickness of the border
#endif GALLERY_USE_IMAGE_BORDER
#ifdef GAME_USE_PREVIEWS
	int galleryPreviewHeight;	// the height of the preview images
	int galleryPreviewWidth;		// the width of the preview images
#ifdef GALLERY_USE_PREVIEWS_BORDER
	byte galleryPreviewBorder;	// thickness of the border
#endif GALLERY_USE_PREVIEWS_BORDER
#ifdef GAME_SINGLE_PREVIEWS
	ImageVector galleryPreview;
#else
	Image* galleryPreview;
#endif GAME_SINGLE_PREVIEWS
#endif GAME_USE_PREVIEWS
#endif

#ifndef USE_COMMANDS
#ifdef INIT_QUIT_IMAGE
//#ifndef USE_RESOURCE_FILE_BMPS
	Image* initQuitImage;			// quit image to be displayed while loading
/*#else
	void* initQuitImage;
	AEEImageInfo initQuitImageInfo;
	boolean initQuitImageRealloc;
#endif*/
#endif INIT_QUIT_IMAGE
#endif !USE_COMMANDS

#ifdef GAME_BACK_IMAGE
	//a background image may be defined; it will be painted tiled
//#ifndef USE_RESOURCE_FILE_BMPS
	Image* backImage;
/*#else
	void* backImage;
	AEEImageInfo backImageInfo;
	boolean backImageRealloc;
#endif*/
#endif
	//game frame timing
	int FrameTime;

	//color rotation
	Bint GameColorRotation;

	//language select vars
	int currentLanguage;
	//help screen vars
	int lastHelpPos;
#ifndef HELP_IS_EXTERNAL
	_BOOLEAN_ showingHelpWait;
#endif HELP_IS_EXTERNAL

	//main menu screen items
	static const byte MENU_RESUME=0;
	static const byte MENU_START=1;
#ifndef PLAY4PRIZES
	static const byte MENU_HELP=2;
#endif
#ifdef GAME_USE_GALLERY
	static const byte MENU_GALLERY=3;
	static const byte MENU_SOUND=4;
#ifdef GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	static const byte MENU_VIBRA=5;
	static const byte MENU_SCORE=6;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	static const byte MENU_LANGUAGE=7;
	static const byte MENU_QUIT=8;
	static const byte MENU_END_MARK=9; //must always be the last entry!
#else
	static const byte MENU_QUIT=7;
	static const byte MENU_END_MARK=8; //must always be the last entry!
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN
#else GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	static const byte MENU_SCORE=5;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	static const byte MENU_LANGUAGE=6;
	static const byte MENU_QUIT=7;
	static const byte MENU_END_MARK=8; //must always be the last entry!
#else
	static const byte MENU_QUIT=6;
	static const byte MENU_END_MARK=7; //must always be the last entry!
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN
#endif GAME_USES_VIBRA && DEVICE_HAS_VIBRA

#else GAME_USE_GALLERY

	static const byte MENU_SOUND=3;
#ifdef GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	static const byte MENU_VIBRA=4;
	static const byte MENU_SCORE=5;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	static const byte MENU_LANGUAGE=6;
	static const byte MENU_QUIT=7;
	static const byte MENU_END_MARK=8; //must always be the last entry!
#else
	static const byte MENU_QUIT=6;
	static const byte MENU_END_MARK=7; //must always be the last entry!
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN
#else GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	static const byte MENU_SCORE=4;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	static const byte MENU_LANGUAGE=5;
	static const byte MENU_QUIT=6;
	static const byte MENU_END_MARK=7; //must always be the last entry!
#else
	static const byte MENU_QUIT=5;
	static const byte MENU_END_MARK=6; //must always be the last entry!
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN
#endif GAME_USES_VIBRA && DEVICE_HAS_VIBRA

#endif GAME_USE_GALLERY

	//menus available
	static const byte MENU_MAIN=0;
	static const byte MENU_START_GAME=1;

	//menu screen control
#ifdef MENU_MUSIC
	int MenuMusic;
#endif
	Image* MenuImage;
	int MenuImageX;
	int MenuImageY;
	int currentMenu;
	int currentMenuItem;
	int oldMenuItem;
	int currentMenuStartItem;
#ifdef SCORE_ONE_PER_MODE
	int currentGameMode;
	int currentScoreMode;
#endif
	String MenuText;
	int MenuPosition;
	String MenuCommandName;
	String MenuCommandOKName;
	String MenuCommandCancelName;

	//arrows
//	int ArrowStartY;
	String ArrowText;

	//game states
	static const byte INIT=0;
	static const byte BRAND=1;
	static const byte LANGUAGE=2;
	static const byte MENU=3;
	static const byte HELP=4;
#ifdef GAME_USE_GALLERY
	static const byte GALLERY=5;
	static const byte GAME=6;
	static const byte SCOREINPUT=7;
	static const byte SCORE=8;
	static const byte QUIT=9;
#ifndef doja
#ifdef GAME_HISCORE_UPLOAD
	static const byte SCOREUPLOAD=10;
#endif GAME_HISCORE_UPLOAD
#endif !doja
#else GAME_USE_GALLERY
	static const byte GAME=5;
	static const byte SCOREINPUT=6;
	static const byte SCORE=7;
	static const byte QUIT=8;
#ifndef doja
#ifdef GAME_HISCORE_UPLOAD
	static const byte SCOREUPLOAD=9;
#endif GAME_HISCORE_UPLOAD
#endif !doja
#endif GAME_USE_GALLERY

	//game state control
	int m_iGameState;
	_BOOLEAN_ isInitialised;
	_BOOLEAN_ isDrawing;
	_BOOLEAN_ isGamePaused;
#ifdef GAME_SET_VOLUME_MED
	byte soundVolume;
#else
	_BOOLEAN_ isSoundMuted;
#endif GAME_SET_VOLUME_MED
	//_BOOLEAN_ isVibrationOff;
	_BOOLEAN_ isTiltOff;
	_BOOLEAN_ isInGame;
	_BOOLEAN_ isConfigured;
	_BOOLEAN_ isNewGameState;
	_BOOLEAN_ isWaiting;
	_BOOLEAN_ isNewLanguage;
#ifdef gx15 || gx25
	_BOOLEAN_ doStoreConfig;
#endif
	boolean isPaused;

	//painting control
	boolean doFullPaint;
	_BOOLEAN_ doFullMenuPaint;
	_BOOLEAN_ pauseGameNow;
#ifdef debug
	//store last frametime
	long lastFrametime;
#endif

	//store the delight entertainment logo and jingle
	Image*	DelightImage1;
	Image*	DelightImage2;
	long	DelightWait;
	int		DelightJingle;

	//branding stuff
	Image* BrandImage;
	long BrandWait;

	//highscore stuff
#ifdef SCORE_MUSIC
	int ScoreMusic;
#endif
//	Font ScoreFont;
#ifdef SCORE_IMAGE
	Image* ScoreImage;
#endif
	String ScoreTitel;
	StringVector ScoreBuf;
	int ScoreTitelXPos;
	int ScoreTitleYPos;
#ifdef SCORE_ONE_PER_MODE
	int ScoreTitelXPosEnd;
#endif
	int ScoreColor;
	int ScoreWidth;
	int ScoreHeight;
	int ScoreScrollPos;
	int ScoreScrollDirection;
	int ScoreCharWidth;
	int ScoreCharHeight;
	int ScoreStartX;
	int ScoreStartY;
	int ScoreWidthY;
	int ScoreEntryLength;
	int ScoreIsMonoSpace;
	int ScoreChars;

	//for score input
	_BOOLEAN_ ScoreInputInitEnd;
	_BOOLEAN_ ScoreInputEnd;
	String ScoreInputRange;
	String ScoreInputTitle;
	String ScoreInputGrats;
	String ScoreLastName;
//	Font ScoreInputFont;
	int ScoreLastPosition;
#ifdef SCORE_ONE_PER_MODE
	int ScoreLastMode;
#endif
	int ScoreInputTitleXPos;
	int ScoreInputGratsXPos;
	int ScoreInputTitleYPos;
	int ScoreInputGratsYPos;
	int ScorePlayed;
	int ScoreInputPos;
	int ScoreInputCharPos;
	String ScoreInputChars;
	int ScoreInputCharWidth;
	int ScoreInputCharHeight;
	int ScoreInputCharSpace;
	int ScoreInputCharX;
	int ScoreInputCharY;
	int ScoreInputArrowSize;
	int ScoreInputArrowPos;

//#ifdef MENU_MUSIC || SCORE_MUSIC || GAME_SOUND_WIN
	_BOOLEAN_ restartMusic;
//#endif
	int myCommandPosX;
	int myCommandPosY;

	//general transition stuff
#ifdef GAME_USE_TRANSITIONS
	boolean   	isTransition;
	int			currentTransition;
	_BOOLEAN_	isInvertTransition;
	int			transState;
	Bint		lastTransitions;
	Bbyte   	lastTransMode;
	Image*		transImage;
//	Graphics		transGraphics;
#ifdef GAME_TRANSITION_MODE_SCROLL && GAME_TRANSITION_MODE_BLEND
	static const int	transEnd = 8;
#else
	static const int	transEnd = 4;
#endif
#ifdef GAME_TRANSITION_MODE_SCROLL
	int		toggleTransitionMode;
	static const byte transScrollPos[] ={1,2,4,7,11,16,22,29,37,45,53,61,69,77,85,90,94,96,98,99,100};
#endif
#endif GAME_USE_TRANSITIONS
#ifdef GAME_CONDITIONAL_FLUSH_GRAPHICS
	_BOOLEAN_ doFlushGraphics;
#endif
#ifdef GAME_SKIP_NOTIFY
	_BOOLEAN_ skipNotify;
#endif
#ifdef GAME_TILED_IMAGE || MENU_TILED_IMAGE
	// a background image may be defined; it will be painted tiled
	Image* tiledImage;
#endif
	// main menu screen items
	Bshort menuEntries;
	// is hand over to Game.initGame as the actual start mode
	int gameStartMode;
#ifdef MENU_DIFFICULT_LEVELS
	// array for different levels
	Bbyte startEntries;
#endif MENU_DIFFICULT_LEVELS
#ifndef USE_COMMANDS
	// vars and methods needed for the outsliding menu button
	int mySmallFontHeight;
	int mySmallFontSpaceWidth;
	int mySmallFontMenuWidth;
	int mySmallFontMenuOKWidth;
	int mySmallFontMenuCancelWidth;
#ifndef BUTTON_PAINT_ALWAYS
	long MenuCommandTime;		// stores the time the menu button has been painted completely
	int menuButtonOffset;		// offset for sliding out the menu button; 0 means fully displayed,  - 1 don't draw
#endif !BUTTON_PAINT_ALWAYS
	Image* menuButton;			// the menu button image
#endif !USE_COMMANDS
#ifdef GAME_USE_ARROWS
	int arrowLength;
	int ArrowPos;
	int arrowTextStartX;
	int arrowColor;
#endif

#ifdef GAME_USE_TEMP_IMAGE
	Image* tempImage;
#endif
#ifdef MENU_HEADER_IMAGE_FILE
	Image* headerImage;
#endif
#ifdef MENU_FOOTER_IMAGE_FILE
	Image* footerImage;
#endif
#ifndef MENU_IS_EXTERNAL
#ifdef MENU_ANIMATE_TILED_BACK_X
	int menuAnimatedBackXoffset;
#endif
#ifdef MENU_ANIMATE_TILED_BACK_Y
	int menuAnimatedBackYoffset;
#endif
#ifdef MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
	//  ********************************************************************
	//  *********  methods for the multi item menu  ************************
	//  ********************************************************************

	int availableMenuItems;	// number of available menu items TODO
#ifdef MENU_ITEM_IMAGE
	Image* menuItemImage;
#ifdef MENU_ITEM_SELECTED_IMAGE
	Image* menuSelectedItemImage;
#endif
#ifdef MENU_ITEM_ANIMATED
	Bbyte menuItemStates;
	Bbyte menuItemStateIndex;
#endif MENU_ITEM_ANIMATED
#endif MENU_ITEM_IMAGE
#endif MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
//  ********************************************************************
//  *********  methods for the icon menu  ******************************
//  ********************************************************************
	ImageVector icons;
	Bint iconOffsets;
#endif MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
#endif !MENU_IS_EXTERNAL
	_BOOLEAN_ updateMenuString;
#ifdef GAME_USE_TEXT_DEFINES
	StringVector GameModes;
#endif
#ifndef soundapi/none
	int lastLoopedSound;
#endif
	int m_iWaitCounter;
	int isParseText;

	byte isEnterGame;
	byte isStartGame;
	byte isReturn;

//	*********************************************************************
//	***********  SOFTKEYS  **********************************************
//	*********************************************************************
	
	// is softkeys processed externally
	_BOOLEAN_ isSoftKeyExternalSet;// 	= _FALSE_; //ADI only used when resume action but if you like to set in game softkey the setsoftkeys() method shouldn't overwite it

#ifndef USE_COMMANDS
	String SoftKeyLeftLabel;
	String SoftKeyRightLabel;

//***
	// softkey dimensions, computed when a button is set in setSoftKey()
	int SoftKeyLeftX;
	int SoftKeyLeftY;
	int SoftKeyLeftW;
	int SoftKeyLeftH;

	int SoftKeyRightX;
	int SoftKeyRightY;
	int SoftKeyRightW;
	int SoftKeyRightH;

#ifdef USE_BUTTON_IMAGES
	Image* SoftKeyLeftImage;
	Image* SoftKeyRightImage;

#ifdef MULTI_BUTTON_IMAGE
	Image* multiButtonImage;
	int leftMultiButtonOffset;
	int rightMultiButtonOffset;
#else  MULTI_BUTTON_IMAGE
	#ifdef MENU_BUTTON_IMAGE || GAME_BUTTON_IMAGE
		Image* myMenuButtonImage;
	#endif
	#ifdef OK_BUTTON_IMAGE
		Image* myOKButtonImage;
	#endif
	#ifdef CANCEL_BUTTON_IMAGE
		Image* myCancelButtonImage;
	#endif
#endif MULTI_BUTTON_IMAGE
#endif USE_BUTTON_IMAGES

	
//	private static int mySmallFontMenuWidth;
//	private static int mySmallFontMenuOKWidth;
//	private static int mySmallFontMenuCancelWidth;
#ifndef BUTTON_PAINT_ALWAYS
	long softKeyStartScrollingTime;	// the time when the user pressed a button and thus scrolling of the softkeys was started
	int softKeyScrollingOffset;			// the offset of the softkeys after a certain period of time has passed after 'softKeyStartScrollingTime' was set
 		// 0: no offset, paint the softkeys
 		// -1: softkeys have left the screen, do not paint
#endif !BUTTON_PAINT_ALWAYS
#endif !USE_COMMANDS

	void setSoftKeys();
	void setSoftKey(String commandLabel, int commandType, Image* buttonImage);
	void _setSoftKey(String commandLabel, int commandType
#ifdef USE_BUTTON_IMAGES
		, Image* buttonImage, int xOffset, int width
#endif
	);
	void removeSoftKey(int commandType);
#ifndef USE_COMMANDS
	void paintSoftKey( int softKey
#ifdef MULTI_BUTTON_IMAGE
	, int multiButtonOffset
#endif
	);
	void showSoftKeys();
#endif

#ifdef PLAY4PRIZES
	ITBMenuControls* fpMenu;
	FPMenuEventListenerObj* menuObj;

	ITBClientControls* fpClient;
	FPClientEventListenerObj* clientObj;

	
	Bint editKeyMap;

	StringVector editChars;// = new String[8];

	int p4p_seed;

	int 	p4p_menuId,
		p4p_menuBeginScreenY,
		p4p_selectedItem,
		p4p_totalMenuHeight,
		p4p_subItemSelected,
		p4p_pressCount,
		p4p_fontHeight,
		p4p_viewHeight,
		p4p_soundRestart,
		p4p_activeElements,
#ifdef MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE
		p4p_imgSwitchDim,
#endif

		p4p_textFontHeight;

#ifdef MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE
		Image* p4p_imgSwitch;
#endif
	String p4p_menuName,
		p4p_commandForeText, //for input text implementation
		p4p_commandBackText; //for input text implementation

	StringVector p4p_entryName,
		p4p_entryText;

	Bint p4p_entryType,
		p4p_entryData,
		p4p_itemHeight;

	VoidVector p4p_entryObject;





	bool skipActions,
		 p4p_leftSoft,
		 p4p_rightSoft,
		 p4p_isInForPrizeGame,
		 p4p_paintBackGround,
		 p4p_isInInputMode;

	Bbyte p4p_data;

	int seedCount;

	WStringVector StringVectorTmpInput;
	WStringVector StringVectorTmpStatic;
	WStringVector StringVectorTmpDynamic;


	//PLAY 4 PRIZES Functions 

	Bbyte getSeed();

	bool notifyClient(int code, Bbyte data);

	bool setMenu(int menuId, int menuIndexSelected, int menuSize, String menuName);

	bool setMenuEntry(int menuId, int menuIndex, int entryType, String entryName, int entryData, String entryText, ConvertedBitmapInfo* entryImage);

	bool endSetMenu(int menuId);

	void calculateTotalMenuHeight();

	bool p4p_menuAlling();

	void paint4Prizes();

	void processKey4Prizes(int keyCode, bool isUp, bool isDown);

	//End p4p game and report score. Use insted end() in p4p game mode.
	void endP4PGame(int score);

	//Cancel p4p game. Don't report score. Use insted end() in p4p game mode.
	void cancelP4PGame();

	void p4p_logic();


	//licznik czasu dla przejscia do nastepnej linii
	int editCount;// = 0;
	//wpisany tekst
	String editName;// = "";
	//znak w kursorze
	String editCursor;// = myText->get("smsc");
	//ostatnio wcisniety znak
	int lastKey;// = 0;
	//ostatni indeks znaku dla klawisza
	int lastIndex;// = 0;
	/*czyscimy nazwe po klawiszu*/
	boolean clearName;// = true;
	/*maksymalnie znakw*/
	int textLength;// = 16;

	void editReset();

	String editNext ();

	String editCancel();

	String editGetName();

	void editSetName(String s);

	String editGet();

	String editKey(int key);
#endif PLAY4PRIZES

	String versionString;

};

##endif
