// aScore.cpp: implementation of the aScore class.
//
//////////////////////////////////////////////////////////////////////
##include "aScore.h"
##include "aMain.h"


#define PUTILS ((aMain*)myMain)->myUtils

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



aScore::aScore()
{
}

void aScore::aScoreCreate(AEEApplet* main,char* storeName, int maxScores)
{
	myMain = main;
	m_iMaxScores = maxScores;
	myStoreName = ( char * ) _MALLOC ( MAX_LINE );
	STRCPY ( myStoreName, storeName );
	//allocate needed space
//	Names = new String[maxScores];
	Scores = (int*)_MALLOC(sizeof(int)*maxScores);
		
	
	//initialise it
	String _szBuf = "";
	for(int i=0; i<10; i++)
	{
		Names.append(_szBuf);
	}
	/*
	Names[1] = SCORE_DEFAULT_NAME;
	Names[2] = SCORE_DEFAULT_NAME;
	Names[3] = SCORE_DEFAULT_NAME;
	Names[4] = SCORE_DEFAULT_NAME;
	Names[5] = SCORE_DEFAULT_NAME;
	Names[6] = SCORE_DEFAULT_NAME;
	*/
	for (int s=0; s < maxScores; s++)
		Scores[s]=0;
	//read the current stored scores
	read();
	//read the current stored scores
	//read();

}

int aScore::read(void) 
{
	int i = 0, max;
	byte * b;
	OS * is;
	char tmp[100];

	MEMSET ( tmp, '\0', 100 );
	b=PUTILS->readData( myStoreName );
	if ( b != NULL ) 
	{
		max = (int)*b;
		b+=4;
		is = ( OS* )b;
		for ( i = 0; i < max; i++ ) 
		{
			Names[i] = is[i].Name;
			Scores[i] = is[i].Score;
		}
	}

	return i;
}

void aScore::write() {
	
	int max, i;
	byte *tmp, * str, *pbs;
	OS os[SCORE_NUMBER];
	if ( changed == FALSE )
		return;
    

	changed = FALSE;
	for ( max = 0; max < SCORE_NUMBER; max++ ) 
		if ( Names[max] == "" )
			return;

	str = ( byte * ) _MALLOC ( sizeof ( int ) + 1 );
	tmp = ( byte*) &max;
	for ( i = 0; i < sizeof ( int ); i++ ) 
		str[i] = tmp[i];

	for ( i = 0; i < max; i++ ) {
		STRCPY( os[i].Name, Names[i].toCharArray() );
		os[i].Score = Scores[i];		
	}
	tmp = (byte*) _REALLOC ( str, sizeof ( int ) + sizeof ( os ) );
	str = tmp;
	tmp+=4;
	pbs = (byte*)&os;
	for ( i = 0; i < sizeof ( os ); i++ ) {
		tmp[i] = pbs[i];
	}
	
	if ( str != NULL )
		PUTILS->writeData ( myStoreName, str, (i+4) );
	_FREE(str);
}

void aScore::add(String name, int score) {
	int i,j;

	for ( i = 0; i < SCORE_NUMBER; i++ ) {
		if ( Names[i] == "" ) 
			break;

#ifndef ASCORE_DESCENDING_ORDER
		if (Scores[i] < score){
#else
		if (Scores[i] > score){
#endif

			for ( j = SCORE_NUMBER-1; j > i; j-- ){
				Scores[j] = Scores[j-1];
				Names[j] = Names[j-1];
			}
			break;
		}
	}

	//add the score
	if ( i != SCORE_NUMBER ) {
		Scores[i] = score;
		Names[i] = name;
		changed = _TRUE_;
	}
}

int aScore::checkPos(int score){
	int i;
	for ( i = 0; i < SCORE_NUMBER; i++ ) {
		if ( Names[i] == "" )
			break;
#ifndef ASCORE_DESCENDING_ORDER
		if (Scores[i] < score)
#else
		if (Scores[i] > score)
#endif
			return (i+1);
	}
	if ( i != SCORE_NUMBER )
		return (i+1);
	return 0;
}

String aScore::getName(int pos){
	if ( pos < 1 || pos > SCORE_NUMBER ) 
		return "";
	return (Names[pos-1]);
}

int aScore::getScore(int pos) {
	if ( pos < 1 || pos > SCORE_NUMBER )
		return -1;
	return (Scores[pos-1]);
}

void aScore::reset ( void ) {
	int s;
	// cleanup memory
	for ( s = 0; s < SCORE_NUMBER; s++ ) {
		Names[s] = "";
		Scores[s] = -1;
	}
	changed=_TRUE_;
}

int aScore::numScores ( void ) {
	int s;
	for( s = 0; s < SCORE_NUMBER; s++ )
		if ( Names[s] == "" )
			break;
	return s;
}

boolean aScore::isWriting ( void ) {
	return _FALSE_;
}

void aScore::freeRes()
{
	_FREE(myStoreName);
	myStoreName = NULL;
	for(int i=0; i < m_iMaxScores; i++)
	{
		Names[i].destruct();
	}
	Names.remove(0, Names.size());
	Names.destruct();
	_FREE(Scores);
	Scores = NULL;
}

byte* OStobyte ( OS * s, byte * ret,  int elements ){
	/*int i,x;
	char tmp[100];
	byte * str, *pbs, *pbl;
	ret = str = ( byte* ) MALLOC ( sizeof ( OS ) * elements + 4 );
	for ( i = 0; i < elements; i++ ) {
		pbl = (byte*) &s[i].len;
		pbs = (byte*) &s[i].Score;
		str[0] = pbs[0];
		str[1] = pbs[1];
		str[2] = pbs[2];
		str[3] = pbs[3];
		str[4] = pbl[0];
		str[5] = pbl[1];
		str[6] = pbl[2];
		str[7] = pbl[3];
		str+=8;
		/*STRCPY ( tmp, s[i].Names.toCharArray() );
		for ( x = 0; x < ( STRLEN ( tmp )); x++ ) {
			str[0] = tmp[x];
			str++;
		}



		//SPRINTF ( tmp, "%x%x%x%x%x%x%x%x%s", pbs[0], pbs[1], pbs[2], pbs[3], pbl[0], pbl[1], pbl[2], pbl[3], s[i].Name.toCharArray() );
		//STRCAT ( (char*)str,tmp);
	}
	str[1] = '\0';*/	
	return (ret);
}



