##include "aSound.h"
##include "aMain.h"

#define PMAIN ((aMain*)myMain)
#define PUTILS ((aMain*)myMain)->myUtils
#undef PLAYER

aSound::aSound(void)
{
}

aSound::~aSound(void)
{
}


void aSound::initSound(int maxSounds)
{
	for (int s=0;s < maxSounds;s++){
		sounds.append(String(""));
#ifdef GAME_USES_IMEDIA
		IMedia* _pIMedia = NULL;
		m_pIMedia.append(_pIMedia);
#endif
	}
#ifdef debug
//	PMAIN->myDebug.add(0,"aSound::Constructor(): Dummy Sound System V1.2 initialized!");
#endif
}

int aSound::addSound(String soundLocation)
{
	int s;
	//search free slot
	for (s=0;s < maxSounds;s++)
		if (sounds[s].length() == 0)
			break;

	if (s == maxSounds)
	{
#ifdef debug
//		PMAIN->myDebug.add(0,"aSound::add(" + soundLocation + "): max Number of Sounds reached: " + maxSounds);
#endif
		return -1;
	}

	sounds[s]= soundLocation;
	return s;
}

void aSound::delSound(int soundID)
{
	if (sounds[soundID].length() == 0)
		return;

	sounds[soundID]= String("");
#ifdef GAME_USES_IMEDIA
	if(m_pIMedia[soundID] != NULL){
		IMEDIA_Stop(m_pIMedia[soundID]);
		IMEDIA_Release(m_pIMedia[soundID]);
		m_pIMedia[soundID] = NULL;
	}
#endif
	
}

void aSound::playSound(int p_soundID,int loopCount)
{
	if(p_soundID < 0)
		return;

	int retval;
	if(sounds[p_soundID].length() == 0)
		return;
	else
	{
		isStopped = false;

#ifdef GAME_USES_IMEDIA
		//if(p_soundID != soundID)
		{
			if(m_pIMedia[p_soundID] != NULL)
			{
				IMEDIA_Stop(m_pIMedia[p_soundID]);
				IMEDIA_Release(m_pIMedia[p_soundID]);
				m_pIMedia[p_soundID] = NULL;
			}
			if(sounds[p_soundID].length()-4 > 0)
			{

				//if(sounds[p_soundID].substring(sounds[p_soundID].length()-4).equals(".mid"))
				//{
					if(ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_MEDIAMIDI, (void**)&m_pIMedia[p_soundID]) != SUCCESS)
					{
						DBGPRINTF("CI Media failed!");
						return;
					}
				//}
				//else if(sounds[p_soundID].substring(sounds[p_soundID].length()-4).equals(".mp3"))
				//{
				//	if(ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_MEDIAMP3, (void**)&m_pIMedia) != SUCCESS)
				//	{
				//		DBGPRINTF("CI Media failed!");
				//		return;
				//	}
				//}

			}
			else
				return;
			AEEMediaData _Info;
			if(PUTILS->checkInResourceFile(sounds[p_soundID]))
			{
				IMemAStream* pMStream=NULL;
				char* _ResBuf = NULL;
				_ResBuf = PUTILS->fetchResource(sounds[p_soundID], _ResBuf);
				ISHELL_CreateInstance(PMAIN->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
				IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, PUTILS->lastResourceLen, 0, FALSE);
				_Info.clsData = MMD_BUFFER;
				_Info.pData = (void*)_ResBuf;
				_Info.dwSize = sizeof(char) * PUTILS->lastResourceLen;
				retval = IMEDIA_SetMediaData(m_pIMedia[p_soundID], &_Info);
				//retval = IMEDIAUTIL_CreateMedia(pIMediaUtil, &_Info, &m_pIMedia);
				IMEMASTREAM_Release(pMStream);
				_FREE(_ResBuf);
				_ResBuf = NULL;
			}
			else
			{
				_Info.clsData = MMD_FILE_NAME;
				//_Info.pData = (void*)"ti.mid";//(void*)sounds[p_soundID].toCharArray();
				_Info.pData = (void*)sounds[p_soundID].toCharArray();
				_Info.dwSize = 0;
				retval = IMEDIA_SetMediaData(m_pIMedia[p_soundID], &_Info);
				//retval = IMEDIAUTIL_CreateMedia(pIMediaUtil, &_Info, &m_pIMedia);
			}
		}
		//else
		//{
		//	retval = SUCCESS;
		//}
		m_iLoop = loopCount;
		if(retval == SUCCESS)
		{
			soundID = p_soundID;
			if(IMEDIA_RegisterNotify(m_pIMedia[p_soundID], (PFNMEDIANOTIFY)mediaCBF, this) != SUCCESS)
			{
				DBGPRINTF("RN Media failed!");
				return;
			}
			IMEDIA_Play(m_pIMedia[p_soundID]);
		}
		else
		{
			DBGPRINTF("Media play error");
		}		
#else
		
		if(p_soundID != soundID)
		{
			if(m_pSoundPlayer != NULL)
			{
				if(m_pSoundPlayer != NULL)
				{
					ISOUNDPLAYER_RegisterNotify(m_pSoundPlayer, NULL, NULL);
					ISOUNDPLAYER_Release(m_pSoundPlayer);
					m_pSoundPlayer = NULL;
				}
			}
			if(ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_SOUNDPLAYER, (void**)&m_pSoundPlayer) != SUCCESS)
			{
				//DBGPRINTF("CI SoundPlayer failed!");
				return;
			}
			AEESoundPlayerInfo _Info;
			if(PUTILS->checkInResourceFile(sounds[p_soundID]))
			{
				IMemAStream* pMStream=NULL;
				char* _ResBuf = NULL;
				_ResBuf = PUTILS->fetchResource(sounds[p_soundID], _ResBuf);
				ISHELL_CreateInstance(PMAIN->m_pIShell, AEECLSID_MEMASTREAM, (void**)&pMStream);
				IMEMASTREAM_Set(pMStream, (byte*)_ResBuf, PUTILS->lastResourceLen, 0, FALSE);
				_Info.eInput = SDT_BUFFER;
				_Info.pData = (void*)_ResBuf;
				_Info.dwSize = sizeof(char) * PUTILS->lastResourceLen;
				retval = ISOUNDPLAYER_SetInfo(m_pSoundPlayer, &_Info);
				//if(retval != AEE_SUCCESS)
					//DBGPRINTF("Sound SetInfo failed!");
				IMEMASTREAM_Release(pMStream);
				_FREE(_ResBuf);
				_ResBuf = NULL;
			}
			else
			{
				_Info.eInput = SDT_FILE;
				_Info.pData = (void*)sounds[p_soundID].toCharArray();
				_Info.dwSize = sizeof(char) * sounds[p_soundID].length();
				retval = ISOUNDPLAYER_SetInfo(m_pSoundPlayer, &_Info);
				if(retval != AEE_SUCCESS)
				{
					if(!isReplaying)
					{
						DBGPRINTF("Timing replay");
						soundID = p_soundID;
						ISHELL_SetTimer( PMAIN->m_pIShell, 100, ( PFNNOTIFY )replay, this );
						isReplaying = true;
					}
					return;
				}
			}
		}
		else
		{
			retval = AEE_SUCCESS;
		}
		m_iLoop = loopCount;
		ISOUNDPLAYER_RegisterNotify(m_pSoundPlayer, (PFNSOUNDPLAYERSTATUS)soundCBF, this);
		if(retval == AEE_SUCCESS)
			ISOUNDPLAYER_Play(m_pSoundPlayer);
		else
		{
			switch(retval)
			{
			case EITEMBUSY: 
				if(!isReplaying)
				{
					ISHELL_SetTimer( PMAIN->m_pIShell, 100, ( PFNNOTIFY )replay, this );
					isReplaying = true;
				}
				break;
			case EBADPARM: retval = 2;break;
			case EUNSUPPORTED: retval = 3;break;
			}
		}
#endif
	}
}

void aSound::stopSound()
{
	
#ifdef GAME_USES_IMEDIA
	for ( int i = 0; i < m_pIMedia.size(); i++ ) {
		if(m_pIMedia[i] != NULL)
		{
			IMEDIA_Stop(m_pIMedia[i]);
			IMEDIA_Release(m_pIMedia[i]);
			m_pIMedia[i] = NULL;
		}
	}
#else
	if(m_pSoundPlayer != NULL)
	{
		isStopped = true;
		ISOUNDPLAYER_Stop(m_pSoundPlayer);
	}
#endif
}

#ifdef GAME_USES_IMEDIA
void aSound::stopSound(int soundID)
{
	if(m_pIMedia[soundID] != NULL)
	{
		IMEDIA_Stop(m_pIMedia[soundID]);
		IMEDIA_Release(m_pIMedia[soundID]);
		m_pIMedia[soundID] = NULL;
	}
}
#endif

/***
 *** public methods
 ***/
int aSound::create(AEEApplet* main, int maxSounds)
{
	myMain = main;
	isRestarting = false;
	soundID = -1;
	
#ifdef GAME_USES_IMEDIA
	for(int i = 0; i < m_pIMedia.size();i++) {
		if( m_pIMedia[i] != NULL ) {
			IMEDIA_Stop(m_pIMedia[i]);
			IMEDIA_Release(m_pIMedia[i]);
			m_pIMedia[i] = NULL;
		}
	}
	m_pIMedia.removeAll();

	if (maxSounds <= 0)
		return -1;
	else
	{
		//call our init
		initSound(maxSounds);
		//store max number of sounds to handle
		this->maxSounds=maxSounds;
		//ISOUNDPLAYER_RegisterNotify(m_pSoundPlayer, (PFNSOUNDPLAYERSTATUS)soundCBF, this);
		return maxSounds;
	}
	
#else
	
	m_pSound = NULL;
	if(ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_SOUND, (void**)&m_pSound) != SUCCESS)
	{
		//DBGPRINTF("CI Sound failed!");
		return -1;
	}
	else
	{
		ISOUND_RegisterNotify(m_pSound, (PFNSOUNDSTATUS)ISoundCBF, this);
		ISOUND_GetVolume(m_pSound);
	}
	if(ISHELL_CreateInstance(myMain->m_pIShell, AEECLSID_SOUNDPLAYER, (void**)&m_pSoundPlayer) != SUCCESS)
	{
		//DBGPRINTF("CI SoundPlayer failed!");
		return -1;
	}
	else
	{
		if (maxSounds <= 0)
			return -1;
		else
		{
			//call our init
			initSound(maxSounds);

			//store max number of sounds to handle
			this->maxSounds=maxSounds;
			ISOUNDPLAYER_RegisterNotify(m_pSoundPlayer, (PFNSOUNDPLAYERSTATUS)soundCBF, this);
			return maxSounds;
		}
	}
#endif
	return -1;
}

void aSound::freeRes()
{
	
#ifdef GAME_USES_IMEDIA
	for(int i = 0; i < m_pIMedia.size(); i++) {
		if( m_pIMedia[i] != NULL ) {
			IMEDIA_Stop(m_pIMedia[i]);
			IMEDIA_Release(m_pIMedia[i]);
			m_pIMedia[i] = NULL;
		}
	}
	m_pIMedia.removeAll();
	m_pIMedia.destruct();

#else
	
	if(m_pSoundPlayer != NULL)
	{
		ISOUNDPLAYER_RegisterNotify(m_pSoundPlayer, NULL, NULL);
		ISOUNDPLAYER_Release(m_pSoundPlayer);
	}
	if(m_pSound)
	{
		ISOUND_Release(m_pSound);
	}
#endif
	sounds.remove(0, sounds.size());
	sounds.destruct();
}

int aSound::add(String soundLocation)
{
#ifdef debug
	if (maxSounds == 0)
	{

//		myDebug.add(0,"aSound::add(" + soundLocation + "): not initialized!?");
		return -1;
	}

//	if (soundLocation == NULL)
	{
//		myDebug.add(0,"aSound::add(null): illegal soundLocation!");
//		return -1;
	}

//	myDebug.add(2,"aSound::add(" + soundLocation + ")");
#endif
	return addSound(soundLocation);
}

void aSound::play(int p_soundID,int loopCount)
{
	if (isMuted != _TRUE_)
	{
		playSound(p_soundID,loopCount);
		this->soundID = p_soundID;
		mute(false);
	}
}

void aSound::stop(int soundID)
{
#ifdef debug
	if (maxSounds == 0)
	{
//		myDebug.add(0,"aSound::stop(" + soundID + "): not initialized!?");
		return;
	}

//	myDebug.add(2,"aSound::stop()");
#endif
#ifdef GAME_USES_IMEDIA
	stopSound(soundID);
#else
	stopSound();
#endif
	m_iLoop=0;
}

void aSound::del(int soundID)
{
#ifdef debug
	if (maxSounds == 0)
	{
//		myDebug.add(0,"aSound::del(" + soundID + "): not initialized!?");
		return;
	}
#endif
	if (soundID < 0)
	{
#ifdef debug
//		myDebug.add(2,"aSound::del(" + soundID + "): deleting all stored Sounds!");
#endif
		for (int s=0;s < maxSounds;s++)
			delSound(s);
	}
	else
	{
#ifdef debug
		if (soundID >= maxSounds)
		{
	//		myDebug.add(0,"aSound::del(" + soundID + "): illegal soundID!");
			return;
		}

	//	myDebug.add(2,"aSound::del(" + soundID + ")");
#endif
		delSound(soundID);
	}
}

void aSound::setVolume(int v)
{
	
#ifdef GAME_USES_IMEDIA
	for( int i = 0; i < m_pIMedia.size(); i++ ) {
		if(m_pIMedia[i] != NULL)
			IMEDIA_SetVolume(m_pIMedia[i], v);
	}
#else
		
	if(m_pSound != NULL)
		ISOUND_SetVolume(m_pSound, v);
#endif
}

void aSound::mute(boolean state)
{
	if (state == _TRUE_)
	{

#ifdef GAME_USES_IMEDIA
		for(int i = 0; i < m_pIMedia.size(); i++ ) {
			if(m_pIMedia[i] != NULL)
				IMEDIA_SetVolume(m_pIMedia[i], 0);
		}
#else
			
		if(m_pSound != NULL)
			ISOUND_SetVolume(m_pSound, 0);
#endif
	}
	if (state == _FALSE_)
	{

#ifdef GAME_USES_IMEDIA
		for(int i = 0; i < m_pIMedia.size(); i++ ) {
			if(m_pIMedia[i] != NULL)
				IMEDIA_SetVolume(m_pIMedia[i], AEE_MAX_VOLUME);
		}
#else
			
		if(m_pSound != NULL)
			ISOUND_SetVolume(m_pSound, AEE_MAX_VOLUME);
#endif
	}
	isMuted=state;
}

void aSound::loop(void* pUser)
{
	if(((aSound*)pUser)->m_iLoop == 1)
	{
		int _iBuf = ((aSound*)pUser)->soundID;
	    ((aSound*)pUser)->soundID = -1;
		((aSound*)pUser)->play(_iBuf, ((aSound*)pUser)->m_iLoop);
	}
	else
	{
		//((aSound*)pUser)->stopSound();
		((aSound*)pUser)->soundID = -1;
	}
	((aSound*)pUser)->isRestarting = false;
}

void aSound::replay(void* pUser)
{
	((aSound*)pUser)->stopSound();
	((aSound*)pUser)->play(((aSound*)pUser)->soundID, ((aSound*)pUser)->m_iLoop);
	((aSound*)pUser)->isReplaying = false;
}

#ifndef GAME_USES_IMEDIA
void aSound::soundCBF(void* pUser, AEESoundPlayerCmd eCBType, AEESoundPlayerStatus eSPStatus, uint32 dwParam)
{
	int a;
	String _szBuf;
	switch(eCBType)
	{
	case AEE_SOUNDPLAYER_STATUS_CB: 
		switch(eSPStatus)
		{
		case AEE_SOUNDPLAYER_SUCCESS: a=11;break;
		}
		break;
	case AEE_SOUNDPLAYER_PLAY_CB: 
		switch(eSPStatus)
		{
		case AEE_SOUNDPLAYER_SUCCESS: 
			//DBGPRINTF("SPP success");a=21;
			break;
		case AEE_SOUNDPLAYER_REWIND : 
			//DBGPRINTF("SPP rewind");a=22;
			break;
		case AEE_SOUNDPLAYER_FFORWARD : 
			//DBGPRINTF("SPP fforward");a=23;
			break;
		case AEE_SOUNDPLAYER_PAUSE : 
			//DBGPRINTF("SPP pause");a=24;
			break;
		case AEE_SOUNDPLAYER_RESUME : 
			//DBGPRINTF("SPP resume");a=25;
			break;
		case AEE_SOUNDPLAYER_TEMPO : 
			//DBGPRINTF("SPP tempo");a=26;
			break;
		case AEE_SOUNDPLAYER_TUNE : 
			//DBGPRINTF("SPP tune");a=27;
			break;
		case AEE_SOUNDPLAYER_AUDIO_SPEC : 
			//DBGPRINTF("SPP audio_spec");a=28;
			break;
		case AEE_SOUNDPLAYER_TICK_UPDATE : 
			//DBGPRINTF("SPP Tick");
			/*
			if(ISOUNDPLAYER_GetInfo(((aSound*)pUser)->m_pSoundPlayer, NULL) != EITEMBUSY)
			{
				DBGPRINTF("SPP Tick, restarting");
				ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 10, ( PFNNOTIFY )loop, pUser );
				((aSound*)pUser)->isRestarting = true;
			}
			*/
			a=29;break;
		case AEE_SOUNDPLAYER_DATA_ACCESS_DELAY : 
			//DBGPRINTF("SPP data_access_delay");a=211;
			break;
		case AEE_SOUNDPLAYER_ABORTED : 
			//DBGPRINTF("SPP aborted");a=212;
			/*
			if(!((aSound*)pUser)->isRestarting)
			{
				((aSound*)pUser)->stopSound();
				ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 100, ( PFNNOTIFY )loop, pUser );
				((aSound*)pUser)->isRestarting = true;
			}
			*/
			break;
		case AEE_SOUNDPLAYER_DONE : 
			if(!((aSound*)pUser)->isRestarting)
			{
				if(!((aSound*)pUser)->isStopped)
				{
					ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 10, ( PFNNOTIFY )loop, pUser );
					((aSound*)pUser)->isRestarting = true;
				}
				else
					((aSound*)pUser)->isStopped = false;
			}
			//DBGPRINTF("SPP done");
			break;
		case AEE_SOUNDPLAYER_FAILURE : 
			//DBGPRINTF("SPP failure");a=214;
			if(!((aSound*)pUser)->isRestarting)
			{
				((aSound*)pUser)->stopSound();
				ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 100, ( PFNNOTIFY )loop, pUser );
				((aSound*)pUser)->isRestarting = true;
			}
			break;
		}
		;break;
	case AEE_SOUNDPLAYER_TIME_CB: a=3;break;
	case AEE_SOUNDPLAYER_SOUND_CB: a=4;break;
	case AEE_SOUNDPLAYER_VOLUME_CB: a=5;break;
	}

}
void aSound::ISoundCBF(void* pUser, AEESoundCmd eCBType, AEESoundStatus eSPStatus, uint32 dwParam)
{
	int a;
	AEESoundCmdData* _scd = (AEESoundCmdData*)dwParam;
	switch(eCBType)
	{
	case AEE_SOUND_STATUS_CB: 
		switch(eSPStatus)
		{
		case AEE_SOUND_UNKNOWN : a=11;break;
		case AEE_SOUND_SUCCESS : a=12;break;
		case AEE_SOUND_PLAY_DONE : a=13;break;
		case AEE_SOUND_FAILURE : a=14;break;
		case AEE_SOUND_LAST : a=15;break;
		}
		break;
	case AEE_SOUND_VOLUME_CB: 
		if(_scd != NULL)
		{
			//DBGPRINTF("Volume: %d", _scd->wVolume);
			((aSound*)pUser)->setVolume(_scd->wVolume);
		}
		switch(eSPStatus)
		{
		case AEE_SOUND_UNKNOWN : a=21;break;
		case AEE_SOUND_SUCCESS : a=22;break;
		case AEE_SOUND_PLAY_DONE : a=23;break;
		case AEE_SOUND_FAILURE : a=24;break;
		case AEE_SOUND_LAST : a=25;break;
		}
		break;
	}
}

#else !GAME_USES_IMEDIA
void aSound::mediaCBF(void* pUser, AEEMediaCmdNotify* pCmdNotify)
{
	int a;
	String _szBuf;
	switch(pCmdNotify->nCmd)
	{
	case MM_CMD_SETMEDIAPARM: 
		switch(pCmdNotify->nStatus)
		{
		case MM_STATUS_DONE: a=11;break;
		case MM_STATUS_ABORT: a=12;break;
		}
		break;
	case MM_CMD_PLAY: 
		switch(pCmdNotify->nStatus)
		{
		case MM_STATUS_START: DBGPRINTF("MCP start");a=21;break;
		case MM_STATUS_SEEK : DBGPRINTF("MCP seek");a=22;break;
		case MM_STATUS_SEEK_FAIL : DBGPRINTF("MCP seek fail");a=23;break;
		case MM_STATUS_PAUSE : DBGPRINTF("MCP pause");a=24;break;
		case MM_STATUS_RESUME : DBGPRINTF("MCP resume");a=25;break;
		case MM_STATUS_PAUSE_FAIL : DBGPRINTF("MCP pause fail");a=26;break;
		case MM_STATUS_RESUME_FAIL : DBGPRINTF("MCP resume fail");a=27;break;
		case MM_STATUS_MEDIA_SPEC : DBGPRINTF("MCP media_spec");a=28;break;
		case MM_STATUS_TICK_UPDATE : a=29;break;
		case MM_STATUS_DATA_IO_DELAY : DBGPRINTF("MCP data_access_delay");a=211;break;
		case MM_STATUS_ABORT : DBGPRINTF("MCP aborted");a=212;
			if(!((aSound*)pUser)->isRestarting)
			{
				ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 10, ( PFNNOTIFY )loop, pUser );
				((aSound*)pUser)->isRestarting = true;
			}
			break;
		case MM_STATUS_DONE : 
			if(!((aSound*)pUser)->isRestarting)
			{
				ISHELL_SetTimer( ((aMain*)((aSound*)pUser)->myMain)->m_pIShell, 10, ( PFNNOTIFY )loop, pUser );
				((aSound*)pUser)->isRestarting = true;
			}
			DBGPRINTF("MCP done");
			break;
		case MM_STATUS_REPEAT : DBGPRINTF("MCP repeat");a=214;break;
		case MM_STATUS_FRAME : DBGPRINTF("MCP frame");a=215;break;
		}
		;break;
	case MM_CMD_GETMEDIAPARM: 
		switch(pCmdNotify->nStatus)
		{
		case MM_STATUS_DONE: a=31;break;
		case MM_STATUS_ABORT: a=32;break;
		}
		break;
	}
}
#endif !GAME_USES_IMEDIA