##pragma once

##include "AEE.h"
##include "AEEGraphics.h"
##include "AEEFile.h"
##include "AEEAppGen.h"
##include "AEEStdLib.h"        // AEE Stb Lib Service
##include "BrewString.h"
##include "BrewVector.h"
#ifdef GAME_USES_IMEDIA
##include "AEEMediaUtil.h"		// Media Interface definitions
##include "AEEMedia.h"
##include "AEEMediaFormats.h"
#endif

#ifdef GAME_USES_IMEDIA
typedef BrewVector<IMedia*> IMediaVector;
#endif

class aSound
{
public:
	//api independent variable declarations

#ifdef GAME_USES_IMEDIA
	IMediaVector m_pIMedia;
	IMediaUtil    *pIMediaUtil;		// IMediaUtil interface
#else
	
	ISoundPlayer* m_pSoundPlayer;
	ISound* m_pSound;
#endif
	int maxSounds;
	boolean isMuted;
	boolean isStopped;
	AEEApplet* myMain;
	//api declarations
	StringVector sounds;
	boolean isRewinding;
	boolean isRestarting;
	boolean isReplaying;

	void initSound(int maxSounds);
	int addSound(String soundLocation);
	void delSound(int soundID);
	void playSound(int soundID,int loopCount);
	void stopSound();
#ifdef GAME_USES_IMEDIA
	void stopSound(int soundID);
#endif

public:
	int m_iLoop;
	int soundID;
	aSound(void);
	~aSound(void);
	int create(AEEApplet* main, int maxSounds);
	void freeRes();
	int add(String soundLocation);
	void play(int soundID,int loopCount);
	void stop(int soundID);
	void del(int soundID);
	void setVolume(int v);
	void mute(boolean state);

	static void loop(void* pUser);
	static void replay(void* pUser);	

#ifndef GAME_USES_IMEDIA
	static void soundCBF(void* pUser, AEESoundPlayerCmd eCBType, AEESoundPlayerStatus eSPStatus, uint32 dwParam);
	static void ISoundCBF(void* pUser, AEESoundCmd eCBType, AEESoundStatus eSPStatus, uint32 dwParam);
#else !GAME_USES_IMEDIA
	static void mediaCBF(void* pUser, AEEMediaCmdNotify* pCmdNotify);
#endif !GAME_USES_IMEDIA

};