##include "aMain.h"
#define PMAIN ((aMain*)myMain)
#define PUTILS ((aMain*)myMain)->myUtils
#define PPROFILER ((aMain*)myMain)->myProfiler

/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/
/*-------------------------------------------------------------------
            Constructor / Destructor
-------------------------------------------------------------------*/
aSprite::aSprite()
{

}
/* =========================================================================
                     FUNCTION DEFINITIONS
   ========================================================================= */
void aSprite::prevFrame()
{
	if (frameSequence->size() != 0 && --currentSequence < 0)
		currentSequence=(byte)(currentSequenceLength - 1);
}

void aSprite::nextFrame()
{
	if (frameSequence->size() != 0 && ++currentSequence >= currentSequenceLength)
		currentSequence=0;
}

int aSprite::getRawFrameCount()
{
	return maxFrames;
}


Bbyte aSprite::getFrameSequence()
{
	return frameSequence;
}

int aSprite::getFrameSequenceLength()
{
	return currentSequenceLength;
}

void aSprite::cleanup()
{
	spriteImage = NULL;

#ifdef bscroll
	myScroll = NULL;
#endif

	frameSequence = NULL;
	maxFrames=0;
	currentSequence=0;
	currentSequenceLength=0;
	spriteOffsetX=0;
	spriteOffsetY=0;
	spritePosX=0;
	spritePosY=0;
	spriteColX=0;
	spriteColY=0;

#ifdef ASPRITE_USE_LINKED_SPRITES
	//free up attached sprite list
	if (linkedSprites != NULL)
	{
		linkedSprites.removeAllElements();
		linkedSprites = NULL;
	}
#endif
	frameSequenceDef.remove(0, frameSequenceDef.size());
	frameSequenceDef.destruct();
	imagePosX.remove(0, imagePosX.size());
	imagePosX.destruct();
	imagePosY.remove(0, imagePosY.size());
	imagePosY.destruct();
}

void aSprite::setImageSS(IImage* img, int startX, int startY, int widthX, int widthY, int num)
{
	int x,y,n;
	AEEImageInfo _ImageInfo;
	//are all parameter valid?
	if (startX < 0 || startY < 0 || num < 0 || widthX <= 0 || widthY <= 0 || img == NULL)
	{
		return;
	}
	//cleanup();
	IIMAGE_GetInfo(img, &_ImageInfo);

	//assign the Image
	spriteImage=img;
	//store tile dimensions
	spriteWidthX=(short)widthX;
	spriteWidthY=(short)widthY;

	//detect how many sprites can be cutted out
	if (num == 0)
	{
		for (y=startY;y < _ImageInfo.cy;y+=widthY)
		{
			//start at x position 0 in a new line
			if (y == startY)
				x=startX;
			else
				x=0;

			//count frames in that line
			for (;x+widthX <= _ImageInfo.cx;x+=widthX)
				num++;
		}
	}

	//store number of frames in the set
	maxFrames=(short)num;

	//set the default framesequence
	frameSequence = &frameSequenceDef;

	//set the length of our default framesequence
	currentSequenceLength=maxFrames;

	for (n=0,y=startY;y < _ImageInfo.cy && n < num;y+=widthY)
	{
		//start at x position 0 in a new line
		if (y == startY)
			x=startX;
		else
			x=0;

		//count frames in that line
		for (;x+widthX <= _ImageInfo.cx && n < num;x+=widthX)
		{
			imagePosX.append((short)x);
			imagePosY.append((short)y);
			frameSequenceDef.append((byte)n++);
		}
	}

	//set default collision rectangle
	spriteColWidthX=spriteWidthX;
	spriteColWidthY=spriteWidthY;
}

#ifdef USE_RESOURCE_FILE_BMPS
void aSprite::setImageSS(void* img, AEEImageInfo* p_pImageInfo, int startX, int startY, int widthX, int widthY, int num)
{
	int x,y,n;
	//are all parameter valid?
	if (startX < 0 || startY < 0 || num < 0 || widthX <= 0 || widthY <= 0 || p_pImageInfo == NULL || img == NULL)
	{
		return;
	}
	//cleanup();

	//assign the Image
	spriteImage=img;
	//store tile dimensions
	spriteWidthX=(short)widthX;
	spriteWidthY=(short)widthY;

	//detect how many sprites can be cutted out
	if (num == 0)
	{
		for (y=startY;y < p_pImageInfo->cy;y+=widthY)
		{
			//start at x position 0 in a new line
			if (y == startY)
				x=startX;
			else
				x=0;

			//count frames in that line
			for (;x+widthX <= p_pImageInfo->cx;x+=widthX)
				num++;
		}
	}

	//store number of frames in the set
	maxFrames=(short)num;

	//set the default framesequence
	frameSequence = &frameSequenceDef;

	//set the length of our default framesequence
	currentSequenceLength=maxFrames;

	for (n=0,y=startY;y < p_pImageInfo->cy && n < num;y+=widthY)
	{
		//start at x position 0 in a new line
		if (y == startY)
			x=startX;
		else
			x=0;

		//count frames in that line
		for (;x+widthX <= p_pImageInfo->cx && n < num;x+=widthX)
		{
			imagePosX.append((short)x);
			imagePosY.append((short)y);
			frameSequenceDef.append((byte)n++);
		}
	}

	//set default collision rectangle
	spriteColWidthX=spriteWidthX;
	spriteColWidthY=spriteWidthY;
}
#endif

void aSprite::setImageSS(Image* img, int startX, int startY, int widthX, int widthY, int num){
#ifndef USE_RESOURCE_FILE_BMPS
	setImageSS ( img->m_pImage,startX, startY,widthX,widthY, num );
#else
	setImageSS ( img->m_pImage, &img->m_IInfo, startX, startY, widthX, widthY, num );
#endif
}


void aSprite::setImage(IImage* img, int widthX, int widthY)
{
	setImageSS( img,0,0,widthX,widthY,0);
}

void aSprite::setImage(Image* img, int widthX, int widthY)
{
#ifndef USE_RESOURCE_FILE_BMPS
	setImageSS( img->m_pImage,0,0,widthX,widthY,0);
#else 
	setImageSS(img->m_pImage,&img->m_IInfo,0,0,widthX,widthY,0);
#endif
}

void aSprite::create( IImage* img, int widthX, int widthY)
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());
	setImageSS( img,0,0,widthX,widthY,0);
}
#ifdef USE_RESOURCE_FILE_BMPS
void aSprite::create(void* img, AEEImageInfo* p_pImageInfo, int widthX, int widthY)
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());
	setImageSS(img, p_pImageInfo,0,0,widthX,widthY,0);
}
#endif

void aSprite::create( Image* img, int widthX, int widthY)
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());
	setImageSS( img,0,0,widthX,widthY,0);
}


void aSprite::createSS( IImage* img, int startX, int startY, int widthX, int widthY, int num)
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());
	setImageSS( img, startX, startY, widthX, widthY, num);
}

void aSprite::createSS( Image* img, int startX, int startY, int widthX, int widthY, int num)
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());
	setImageSS( img, startX, startY, widthX, widthY, num);
}

void aSprite::createNONE()
{
	imagePosX.remove(0,imagePosX.size());
	imagePosY.remove(0,imagePosY.size());
	frameSequenceDef.remove(0,frameSequenceDef.size());

	cleanup();
}

void aSprite::setFrameSequenceInt( Bint sequence, int size)
{
	int i;
	if (sequence.size() == 0)
	{
		frameSequence= &frameSequenceDef;
		currentSequenceLength=maxFrames;
	}
	else
	{
		//copy over the new sequence
		for (i=0;i < sequence.size();i++)
		{
			if(i < frameSequence->size())
			{
				(*frameSequence)[i]=(byte)sequence[i];
			}
			else
			{
				frameSequence->append((byte)sequence[i]);
			}
		}

		//set sequence length
		currentSequenceLength=(short)sequence.size();
	}
	currentSequence=0;
}

void aSprite::setFrame( int sequenceIndex)
{
	if (sequenceIndex >= currentSequenceLength)
	{
		return;
	}
	currentSequence=(byte)sequenceIndex;
}

int aSprite::getFrame()
{
	return currentSequence;
}

void aSprite::setPosition( int x, int y)
{
	spritePosX=(short)x;
	spritePosY=(short)y;
}

int aSprite::getX()
{
	return spritePosX;
}

int aSprite::getY()
{
	return spritePosY;
}

void aSprite::defineReferencePixel( int x, int y)
{
	spriteOffsetX=(short)x;
	spriteOffsetY=(short)y;
}

int aSprite::getRefPixelX()
{
	return spriteOffsetX;
}

int aSprite::getRefPixelY()
{
	return spriteOffsetY;
}

void aSprite::defineCollisionRectangle( int x, int y, int widthx, int widthy)
{
	spriteColX=(short)x;
	spriteColY=(short)y;
	spriteColWidthX=(short)widthx;
	spriteColWidthY=(short)widthy;
}

boolean aSprite::collidesWith( aSprite s)
{
	//x/y coords of first sprite
	int sx1 = spritePosX + spriteColX;
	int sy1 = spritePosY + spriteColY;
	int ex1 = sx1 + spriteColWidthX;
	int ey1 = sy1 + spriteColWidthY;

	//x/y coords of second sprite
	int sx2 = s.spritePosX + s.spriteColX;
	int sy2 = s.spritePosY + s.spriteColY;
	int ex2 = sx2 + s.spriteColWidthX;
	int ey2 = sy2 + s.spriteColWidthY;

	//do the detection
	return (((sx2 >= sx1 && sx2 < ex1) || (ex2 >= sx1 && ex2 < ex1) || (sx2 < sx1 && ex2 >= ex1)) &&
			((sy2 >= sy1 && sy2 < ey1) || (ey2 >= sy1 && ey2 < ey1) || (sy2 < sy1 && ey2 >= ey1)));
}

void aSprite::paint()
{
#ifdef PROFILER
	ProfilerReturn _Retval = PPROFILER->startMeasurement(__FUNCTION__);
#endif

	int s,xpos,ypos;

	if (spriteImage == NULL)
	{
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

		return;
	}

#ifndef ASPRITE_DO_NOT_RESTORE_CLIPPING
	/*
	final int cx=g.getClipX();
	final int cy=g.getClipY();
	final int cwx=g.getClipWidth();
	final int cwy=g.getClipHeight();
	*/
#endif

	s = (*frameSequence)[currentSequence];

	if (s >= maxFrames)
	{
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif
		return;
	}

	xpos = spritePosX - spriteOffsetX;
	ypos = spritePosY - spriteOffsetY;

#ifdef bscroll
	//get relative coordinates
	if (myScroll != null)
	{
		//is it in the render area of the scrollengine?
		if (xpos > myScroll.screenX+myScroll.screenWidthX || 
			ypos > myScroll.screenY+myScroll.screenWidthY || 
			xpos+spriteWidthX < myScroll.screenX ||
			ypos+spriteWidthY < myScroll.screenY)
			return;

		xpos+=myScroll.screenStartX - myScroll.screenX;
		ypos+=myScroll.screenStartY - myScroll.screenY;

		//set scrollarea clipping
		g.clipRect(myScroll.screenStartX,myScroll.screenStartY,myScroll.screenWidthX,myScroll.screenWidthY);
	}
#endif
#ifndef USE_RESOURCE_FILE_BMPS
	IIMAGE_SetOffset(spriteImage, imagePosX[s], imagePosY[s]);
	IIMAGE_SetDrawSize(spriteImage, spriteWidthX, spriteWidthY);
	PUTILS->drawImage( PMAIN->m_pGraphics, spriteImage,xpos, ypos,0);
#else
	PUTILS->drawClippedBmp(PMAIN->m_pGraphics, spriteImage, xpos, ypos, imagePosX[s], imagePosY[s], spriteWidthX, spriteWidthY);
#endif

#ifndef ASPRITE_DO_NOT_RESTORE_CLIPPING
	//restore old clipping
//	g.setClip(cx,cy,cwx,cwy);
#endif

#ifdef ASPRITE_USE_LINKED_SPRITES

	//paint all sprites that have been linked to this one
	if (linkedSprites != null)
	{
		aSprite spr;
		final int l=linkedSprites.size();

		//paint all linked sprites
		for (int i=0;i < l;i++)
			if ((spr=(aSprite)linkedSprites.elementAt(i)) != null)
				spr.paint(g,this);
	}

#endif
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif
}
