##include "aMain.h"

#define PMAIN ((aMain*)myMain)
#define PPROFILER ((aMain*)myMain)->myProfiler
#define PDEBUG ((aMain*)myMain)->myDebug
#define MAXKEYVALLEN 2048
#define MAXKEYLEN 81

/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/
/*-------------------------------------------------------------------
            Constructor / Destructor
-------------------------------------------------------------------*/
aText::aText()
{
	myMain = NULL;
	domain = "";
	domainsEntrys = 0;
//	ht = NULL;
	noTextFound = "Text is missing!";
}
/* =========================================================================
                     FUNCTION DEFINITIONS
   ========================================================================= */
//check if modified-utf8 syntax is correct
void aText::checkModifiedUTF( byte* b, int size)
{
	//patch the correct length
	b[0]=(byte)(((size-2)>>8)&0xff);
	b[1]=(byte)((size-2)&0xff);
	b[2]=' ';
}

void aText::initChar( AEEApplet* _pMain, String name)
{
	////DBGPRINTF ("begin initChar");
	int i,retval;
	char* _b=NULL;
	String s,n;
	myMain = _pMain;
/*
	if(ISHELL_CreateInstance( myMain->m_pIShell, AEECLSID_RAMCACHE, (void**)( &ht ) ) != SUCCESS)
	{
#ifdef debug
		PMAIN->m_pDebug->add(1,"ATEXT_initChar: CI RamCache failed");
#endif
		return;
	}
	retval = IRAMCACHE_SetMaxEntries(ht, MAXKEYS);
	retval = IRAMCACHE_SetMaxSize(ht, MAXHTSIZE);
	retval = IRAMCACHE_SetTTL(ht, HTTTL);
*/
	if (name.length() == 0)
	{
		retval=-1;
	}

	if(name.endsWith(".dat") == _FALSE_)
	{
		s = name + ".dat";
	}
	else
	{
		s = name;
	}
	////DBGPRINTF ("front fetchResource");
	if ((_b=PUTILS->fetchResource( s, _b)) == NULL)
	{
		////DBGPRINTF ("true pfad");
		boolean f=FALSE;

		//check for files
		char _cBuf[10];
		for (i=1;i < 6;i++)
		{

			n = name + PUTILS->_itoa(i, _cBuf, 10) + ".dat";

			////DBGPRINTF ("front fetchResource2");
			////DBGPRINTF ( n.toCharArray());
			if ((_b=PUTILS->fetchResource( n,_b)) != NULL)
			{
				////DBGPRINTF ("true pfad2");
				parseCharArray( _b, PUTILS->lastResourceLen);
				////DBGPRINTF ("end recourcelen");
				////DBGPRINTF (_b);
				f=TRUE;
				_FREE(_b);
				_b=NULL;
			}
		}
		_FREE(_b);
		_b = NULL;
		if (f == FALSE)
			retval=-1;
	}
	else
	{
		////DBGPRINTF ("else pfad");
		parseCharArray( _b, PUTILS->lastResourceLen);
	}
	////DBGPRINTF ("end fetchResource");
	//autoselect first element
	if(domains.size() > 0)
	{
		if (domains[0].length() != 0)
			setDomain( domains[0]);
	}
	_b=NULL;
	////DBGPRINTF ("end initChar");
}

void aText::parseCharArray( char* c, int size)
{
	int i,lastPos;
	char _cBuf[MAXKEYVALLEN];
	String _szBuf;
	lastPos = 0;
	for(i=0; i< size; i++)
	{
		_cBuf[i-lastPos] = c[i];
		//Found newline
		if(c[i] == '\n')
		{
			_cBuf[i-lastPos+1] = '\0';
			_szBuf = _cBuf;
			parse( _szBuf);
			lastPos = i+1;
		}
	}
}
void aText::parseByteArray( byte* b, int size)
{
	/*
	if (b == NULL)
		return;

	//check if length field is missing
	checkModifiedUTF(b, size);

	ByteArrayInputStream bais=new ByteArrayInputStream(b);
	DataInputStream is=new DataInputStream(bais);

	if ((s=is.readUTF()) != null)
		parse(s);

	is.close();
	is=null;

	bais.close();
	bais=null;

	s=null;
	*/
}

void aText::initByte( byte* text)
{
	//parseByteArray(text);
}

void aText::parse( String s)
{
	UINT i;
	int j,varlen,vallen;
	String key = "";
	String keyval = "";
	String var = "";
	String val = "";
	String buf = "";
	String dom = "domain";
	char* read=NULL;
	

	for (i=0;i < s.length();)
	{
		//read varname
		var = "";
		for (;i < s.length() && s.charAt(i) != '=';i++)
		{
			j = i;
		}
		var = s.substring(0,i);
		varlen = var.length();
		i++;
		
		//read value
		for (;i < s.length() && s.charAt(i) != '\n' && s.charAt(i) != '\r';i++)
		{
		}
		val = s.substring(j+2,i);
		vallen = val.length();

		//step over cr and lf
		for (;i < s.length() && (s.charAt(i) == '\n' || s.charAt(i) == '\r');i++) {}

		if (var.equals(dom) == _TRUE_)
		{
			domains.append(val);
			domain = domains[domainsEntrys];//memerr
			domainsEntrys++;
			continue;
		}
		//compile domain.varname key if domain is set
		if(domain.length() > 1)
		{
			buf = domain + "." + var;
		}
		else
			buf = var;
		//add to the hashtable
		key = buf;
		keyval = val;
/*
		retval = IRAMCACHE_Add(ht, (const char*)key.toCharArray(), (int)key.length(), (const char*)keyval.toCharArray(), (int)keyval.length());
		switch(retval)
		{
		case SUCCESS: a=0;break;
		case EFAILED: a=1;break;
		case ENOMEMORY: a=2;break;
		}
*/
		ht.put(buf, val);
	}
}

void aText::setDomain( String d)
{
	if (d.length() != 0)
		domain = d;
	else
		domain = "";
}

String aText::getDomain()
{
	return domain;
}

StringVector* aText::getDomains()
{
	return &domains;
}

int aText::getDomainNumber()
{
	return domainsEntrys;
}

int aText::check( String key)
{
	String keyval;
	get( key, &keyval);
	if (keyval.equals(noTextFound) != 0)
		return TRUE;
	return FALSE;
}

String* aText::get( String key, String* keyval)
{
#ifdef PROFILER
	ProfilerReturn _Retval = PPROFILER->startMeasurement(__FUNCTION__);
#endif
	char* cLenGet=NULL;
	String ckey;// = "";
	String buf;// = "";
	int ckeyvallen = MAXKEYVALLEN;
	int ckeylen = 0;
	//is a domain set?
	if(domain.length() == 0)
	{
#ifdef debug
		PDEBUG->add(1,"ATEXT_get: domain is NULL");
#endif
		return NULL;
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif
	}
	if (domain.length() > 1)
	{
		buf += domain;
		//_FREE(&domain);von mir
		buf += ".";
		buf += key;
		ckey = buf;
		ckeylen = ckey.length();
		//if(IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, cLenGet, &ckeyvallen) == EFAILED)
		if(ht.get(ckey, *keyval) == 0)
		{
			//check for global definition
			ckey = key;
			ckeylen = ckey.length();
			//if(IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, cLenGet, &ckeyvallen) == EFAILED)
			if(ht.get(ckey, *keyval) == 0)
			{
				*keyval = noTextFound;
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

				return keyval;
			}
			else
			{
				/*
				IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, ckeyval, &ckeyvallen);
				ckeyval[ckeyvallen] = '\0';
				*keyval = ckeyval;
				*/
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

				return keyval;
			}
		}
		else
		{
			/*
			IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, ckeyval, &ckeyvallen);
			ckeyval[ckeyvallen] = '\0';
			*keyval = ckeyval;//memerr
			*/
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

			return keyval;
		}
	}
	else
	{
		//check for global definition
		key = ckey;
		ckeylen = ckey.length();
		//if(IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, cLenGet, &ckeyvallen) == EFAILED)
		if(ht.get(ckey, *keyval) == 0)
		{
			*keyval = noTextFound;
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

			return keyval;
		}
		else
		{
			/*
			IRAMCACHE_Find(ht, ckey.toCharArray(), ckeylen, ckeyval, &ckeyvallen);
			ckeyval[ckeyvallen] = '\0';
			*keyval = ckeyval;
			*/
#ifdef PROFILER
	PPROFILER->stopMeasurement(_Retval);
#endif

			return keyval;
		}
	}
}

//cleanup all texts currently in memeory	
void aText::cleanup()
{
	/*
	if(ht != NULL)
	{
		IRAMCACHE_FlushAll(ht);
		IRAMCACHE_Release(ht);
		ht = NULL;
	}
	*/
	ht.removeAll();
	domainsEntrys = 0;
	domains.remove(0, domains.size());
	domains.destruct();
	domain.destruct();
	noTextFound.destruct();
}
