##include "aTextBox.h"
##include "aMain.h"
//##include "Devices.h"

#define PMAIN ((aMain*)myMain)
#define PUTILS ((aMain*)myMain)->myUtils
#define PDEBUG ((aMain*)myMain)->myDebug
#define NUM_LINES_ALLOC 25
#define TEXTBOX_UNDERLINED 0
#define MAXSTRINGLEN 1024
#define TEXTBOX_PLAIN AEE_FONT_NORMAL
#define TEXTBOX_BOLD AEE_FONT_BOLD

/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/
/* =========================================================================
                     CONSTRUCTOR / DESTRUCTOR
   ========================================================================= */
aTextBox::aTextBox()
{
	//font symetrics
	fontSize = 0;
	fontFace = 0;
	fontHeight = 0;

	//positions
	textPos = 0;
	numLines = 0;
	showLines = 0;

	//screen dimensiones
	startX = 0;
	startY = 0;
	endX = 0;
	endY = 0;
	offsetY = 0;

	//can be mixed
	 PLAIN = TEXTBOX_PLAIN;
	UNDERLINED = TEXTBOX_UNDERLINED;
	 BOLD = TEXTBOX_BOLD;
	 ITALIC = TEXTBOX_ITALIC;

	//use one of
##if BREWVERSION > 0x1
	 MEDIUM = AEECLSID_FONT_BASIC12;
	 SMALL = AEECLSID_FONT_BASIC10;
	 LARGE = AEECLSID_FONT_BASIC14;
##else
	 MEDIUM = 0;
	 SMALL = 1;
	 LARGE = 2;
##endif
	//use one of
	SYSTEM = AEE_FONT_NORMAL;
	MONOSPACE = AEE_FONT_NORMAL;
	PROPORTIONAL = AEE_FONT_NORMAL;

	//add to last text
	APPEND = 128;

	//word wrap
	DONOTWRAP =  256;
	paintOffsetX = 0;
	paintOffsetY = 0;
};
/* =========================================================================
                     FUNCTION DEFINITIONS
   ========================================================================= */
const aTextBox&	aTextBox::operator=( const aTextBox &p_TB )
{
	//reference to our main object where we get the screenwidth and screenheight values from
	myMain = p_TB.myMain;
	//storage the text/lines
	myText = p_TB.myText;
	myLines = p_TB.myLines;

	//font symetrics
	fontSize = p_TB.fontSize;
	fontFace = p_TB.fontFace;
	fontHeight = p_TB.fontHeight;

	//positions
	textPos = p_TB.textPos;
	numLines = p_TB.numLines;
	showLines = p_TB.showLines;

	//screen dimensiones
	startX = p_TB.startX;
	startY = p_TB.startY;
	endX = p_TB.endX;
	endY = p_TB.endY;
	offsetY = p_TB.offsetY;

	//can be mixed
	PLAIN = p_TB.PLAIN;
	UNDERLINED = p_TB.UNDERLINED;
	BOLD = p_TB.BOLD;
	ITALIC = p_TB.ITALIC;

	//use one of
	MEDIUM = p_TB.MEDIUM;
	SMALL = p_TB.SMALL;
	LARGE = p_TB.LARGE;

	//use one of
	SYSTEM = p_TB.SYSTEM;
	MONOSPACE = p_TB.MONOSPACE;
	PROPORTIONAL = p_TB.PROPORTIONAL;

	//add to last text
	APPEND = p_TB.APPEND;

	//word wrap
	DONOTWRAP = p_TB.DONOTWRAP;
	paintOffsetX = p_TB.paintOffsetX;
	paintOffsetY = p_TB.paintOffsetY;
	return *this;
}

void aTextBox::create( AEEApplet* main)
{
	myMain = main;
	SMALL = FONT_SIZE_SMALL;
	MEDIUM = FONT_SIZE_MEDIUM;
	LARGE = FONT_SIZE_LARGE;
	BOLD = FONT_STYLE_BOLD;
	ITALIC = FONT_STYLE_ITALIC;
	//font symetrics
	fontSize = 0;
	fontFace = 0;
	fontHeight = 0;

	//positions
	textPos = 0;
	numLines = 0;
	showLines = 0;

	//screen dimensiones
	startX = 0;
	startY = 0;
	endX = 0;
	endY = 0;
	offsetY = 0;

	//can be mixed
	 PLAIN = 0;//TEXTBOX_PLAIN;
	UNDERLINED = 1;//TEXTBOX_UNDERLINED;
	 BOLD = 2;//TEXTBOX_BOLD;
	 ITALIC = 3;//TEXTBOX_ITALIC;

##if BREWVERSION > 0x1
	 MEDIUM = AEECLSID_FONT_BASIC12;
	 SMALL = AEECLSID_FONT_BASIC10;
	 LARGE = AEECLSID_FONT_BASIC14;
##else
	 MEDIUM = 0;
	 SMALL = 1;
	 LARGE = 2;
##endif

	//use one of
	SYSTEM = AEE_FONT_NORMAL;
	MONOSPACE = AEE_FONT_NORMAL;
	PROPORTIONAL = AEE_FONT_NORMAL;

	//add to last text
	APPEND = 128;

	//word wrap
	DONOTWRAP =  256;
	paintOffsetX = 0;
	paintOffsetY = 0;
}

void aTextBox::add( WString msg, int mode)
{
	if (msg.length() == 0)
		return;

	aEntry _entry;
	_entry.text = msg;
	_entry.mode = (mode&(BOLD|ITALIC|UNDERLINED|APPEND));
	_entry.len = 0;
	_entry.line = 0;
	myText.append(_entry);
}

void aTextBox::addLine( WString msg)
{
	UINT i;
	boolean nl=0;
	int m=PLAIN;
	int o=PLAIN;
//	char c,d = '\0';
	WString sb = "";
	int sblen = 0;

	if (msg.length() == 0)
		return;

	for (i=0;i < msg.length();i++)
	{
		//c = msg[i];
//		if( (i+1) < msg.length() )
//			d = msg[i+1];

//		if ((msg.charAt(i) == '\\') && (msg.charAt(i+1) == 'n'))
		if(msg.charAt(i) == '\n')
		{
			nl=1;
			//i++;
		}

		else if (msg.charAt(i) == '%')
		{
			//new mode?
//			c = msg[++i];
			switch (msg.charAt(++i))
			{
				case '%' :
					sb += "%";
					break;

				case 'b' :
					m^=BOLD;
					break;

				case 'i' :
					m^=ITALIC;
					break;

				case 'u' :
					m^=UNDERLINED;
					break;
				
				default :
					sb += "%";
					sb += msg.substring(i,i+1);
					break;
			}
		}
		else
		{
			sb += msg.substring(i,i+1);
		}
		//changed?
		if (m != o || nl == 1)
		{
			if (sb.length() > 0)
			{
				//add string buffer with old mode
				add( sb,o);
				sb = "";
				//set append mode
				m|=APPEND;
			}
			o=m;
		}
		
		if (nl == 1)
		{
			add( "\n", 0);
			nl=0;
		}
	}

	//add rest
	if (sb.length() > 0)
		add( sb,m);
}

void aTextBox::clear()
{
	paintOffsetX=0;
	paintOffsetY=0;
	myText.remove(0, myText.size());
	myLines.remove(0, myLines.size());
	create( myMain);
}

void aTextBox::freeRes()
{
	myText.remove(0, myText.size());
	myText.destruct();
	myLines.remove(0, myLines.size());
	myLines.destruct();
	test.destruct();
}

void aTextBox::prepare( int sX, int sY, int eX, int eY, int mode)
{
	int b,bl,c,l,s,m,e,n,p;
	UINT i,j;
	//Get Font info
	AEEFont f;
	UINT x=eX-sX;
	int y=eY-sY;
	//word wrap is by default on
	boolean ww=1;
	//store our current message
	WString msg;
//	char _szDebug[1024];

	//supress word wrap?		
	if ((mode&DONOTWRAP) != 0)
		ww=0;

	//store dimensions		
	startX=sX;
	startY=sY;
	endX=eX;
	endY=eY;

	//reset current textposition
	textPos=0;

	//extract face
	fontFace=(mode&(SYSTEM|MONOSPACE|PROPORTIONAL));

	//check if face is valid
	if (fontFace != SYSTEM && fontFace != MONOSPACE && fontFace != PROPORTIONAL)
		fontFace=SYSTEM;

	//extract style
	fontSize=(mode&(SMALL|MEDIUM|LARGE));

	//check if style is valid
	if (fontSize != SMALL && fontSize != MEDIUM && fontSize != LARGE)
		fontSize=MEDIUM;

	//get font
	f= PUTILS->getFontFSS( fontFace,PLAIN,fontSize);
	p=PLAIN;
	
	//get font height
//	IDISPLAY_SetFont(myMain->m_pIDisplay, f, _IFont);
#ifdef AUTILS_USE_GRAPHICAL_FONT
	fontHeight = PUTILS->getFontHeight(PUTILS->getFont(PMAIN->m_pGraphics));
#else
	{
		if(PUTILS->m_pFont != NULL)
		{
			IFONT_GetInfo(PUTILS->m_pFont, &_FontInfo, sizeof(AEEFontInfo));
			fontHeight = _FontInfo.nAscent + _FontInfo.nDescent;
		}
	}	
#endif
	//calc number of lines that can be displayed
	if(fontHeight != 0)
		showLines = y / fontHeight;
	else
	{
#ifdef debug
		PDEBUG->add(1,"fontHeight is 0, prevent division by 0 and return!");
#endif
		return;
	}

	//center the text vertically
	offsetY=(endY-startY-showLines*fontHeight)/2;
	
	//clear last rendering
	myLines.remove(0, myLines.size());

	//render text
	for (n=-1,l=0,i=0;i < myText.size();i++)
	{
		//get the text
		msg = myText[i].text;
		m=myText[i].mode;
		j=0;

		//linefeed?
		if (msg.equals("\n"))
		{
			l=0;
			n++;
			m&=~APPEND;
			continue;
		}
		
		//should we append the message?			
		if ((m&APPEND) == 0)
		{
			l=0;
			n++;
		}
		else
			m&=~APPEND;

		//get the font if needed
		if (p != m)
		{
			f= PUTILS->getFontFSS( fontFace, m, fontSize);
			p=m;
		}

		//reset entry length
		e=0;

		//add one line
		for (b=0,bl=0,s=0,j=0;j < msg.length();j++)
		{
			//remember last blank pos for word wrap
			if (ww == 1 && msg.charAt(j) == 32)
			{
				b=j;
				bl=e;
			}

			//get the character width
			if (msg.charAt(j) != '\n')
			{
//				IDISPLAY_SetFont(myMain->m_pIDisplay, f, _IFont);
#ifdef AUTILS_USE_GRAPHICAL_FONT
				c= PUTILS->charWidth( NULL, msg.charAt(j));
#else
				if(PUTILS->m_pFont != NULL)
					c= PUTILS->charWidth( PUTILS->m_pFont, msg.charAt(j));
				else
					c = 0;
#endif
			}
			else
				c=0;

			//reached the end of line?
			if ((UINT)(l+c) > x)
			{
				//do the word wrap
				if (ww == 1 && b > s) //changed: b >= s
				{
					j=b;
					e=bl;
				}

				//generate a new entry
				aEntry _myEntry;
				_myEntry.text = msg.substring(s, j);
				_myEntry.mode=m;
				_myEntry.len=e;
				_myEntry.line=n++;

				//add it to the vectorlist
				myLines.append(_myEntry);
				//reset vars
				e=0;
				s=j;
				l=0;

				//ignore blank at beginning of a new line
				if (msg.charAt(j) == 32)
				{
					s++;
					continue;
				}
			}
			l+=c;
			e+=c;
		}

		//add the rest of the message
		if((UINT)s < j)
		{
			aEntry _myEntry;
			_myEntry.text = msg.substring(s, j);
			_myEntry.mode=m;
			_myEntry.len=e;
			_myEntry.line=n;

			//add it to the vectorlist
			myLines.append(_myEntry);
		}
	}
	numLines=n+1;

	//now trimm start and end of lines
	aEntry _myEntry;
	for (n=0,j=0;j < myLines.size();j++)
	{
		if (myLines[j].line != n)
		{
			//trim end of last line
			if (j > 0)
			{
				_myEntry=myLines[j-1];
				_myEntry.text.trim();
			}

			//trim beginning of new line
			_myEntry=myLines[j];
			n=_myEntry.line;
			_myEntry.text.trim();
		}
	}
}

void aTextBox::movePos( int posOffset)
{
	if (posOffset == 0)
		textPos=0;
	else
		textPos+=posOffset;

	if (textPos > numLines-showLines)
		textPos=numLines-showLines;

	if (textPos < 0)
		textPos=0;
}

void aTextBox::setHome()
{
	textPos=0;
}

void aTextBox::setEnd()
{
	textPos=numLines-showLines;

	if (textPos < 0)
		textPos=0;
}

void aTextBox::pageDown()
{
	movePos( showLines);
}

void aTextBox::pageUp()
{
	movePos( -showLines);
}

boolean aTextBox::isHome()
{
	if (textPos == 0)
		return 1;
	
	return 0;
}

boolean aTextBox::isEnd()
{
	if (textPos+showLines >= numLines)
		return 1;

	return 0;
}

int aTextBox::getPos()
{
	return textPos;
}

int aTextBox::getLines()
{
	return showLines;
}

int aTextBox::getTotalLines()
{
	return numLines;
}

void aTextBox::setPaintOffsetX( int offx)
{
	paintOffsetX=offx;
}

void aTextBox::setPaintOffsetY( int offy)
{
	paintOffsetY=offy;
}

void aTextBox::paint( IGraphics* p_IGraphics, boolean center, boolean scrollbar)
{
	UINT i,a;
	int y,x,l,fh;
	int m=-1;
	int s=0;
	int h;
	int b;

	aEntry _myEntry;

	//store old font
	AEEFont f = PUTILS->getFont( p_IGraphics);

	//search starting position
	for (i=0;i < myLines.size();i++)
	{
		if (myLines[i].line >= textPos)
			break;
	}
	//not found?
	if (i == myLines.size())
		return;

	//check if number of lines to print is less than lines that fit into box
	if (numLines < showLines)
		s=((showLines-numLines)*fontHeight)/(numLines+1);

	fh=fontHeight+s;
	
	//print it
	for (l=-1,y=textPos,x=0;i < myLines.size();i++)
	{
		_myEntry=myLines[i];

		//starting a new line?
		if (l != _myEntry.line)
		{
			if (_myEntry.line-y >= showLines)
				break;

			l=_myEntry.line;

			//centerprint?
			if (center == 1)
			{
				x=_myEntry.len;

				//calc complete line size
				for (a=i+1;a < myLines.size();a++)
				{
					if (myLines[a].line == l)
						x+=myLines[a].len;
				}
				//calc center offset for that line
				x=(endX-startX-x)/2;

//center fix for moorhuhn
if (scrollbar == 1 && showLines >= numLines)
x += 3;
			}
			else 
				x=0;
		}

		//only get a new font if needed
		if (_myEntry.mode != m)
		{
			m=_myEntry.mode;
			PUTILS->setFont( p_IGraphics, PUTILS->getFontFSS( fontFace,m,fontSize));
		}

		//ignore linefeeds
		if (_myEntry.text.length() == 1 && _myEntry.text.equals("\n"))
			continue;

		//print it
		PUTILS->drawString( p_IGraphics, _myEntry.text,FONT_X_OFFSET+paintOffsetX+startX+x,FONT_Y_OFFSET+paintOffsetY+startY+offsetY+(_myEntry.line-y)*fh+s,0);

		//add stringlen to xlen
		x+=_myEntry.len;
	}

	//restore old font
	PUTILS->setFont( p_IGraphics, f);
//	g.setFont(f);
	
	//paint scrollbar?
	if (scrollbar == 1 && showLines < numLines)
	{
		//paint frame
		PUTILS->drawRect( p_IGraphics, endX+1,startY,5,endY-startY);
		
		//calc bar
		h =((endY-startY-2)*showLines)/numLines;
		b =((endY-startY-2)*textPos)/numLines;

		//correct the bar length
		if (h+startY+2+b >= endY-1)
			h=endY-1-startY-2-b;

		//paint bar
		PUTILS->fillRect( p_IGraphics, endX+3,startY+2+b,2,h);
	}
}

WStringVector aTextBox::getTextLines(){
	WStringVector ret;// = new String[numLines];
	ret._new(numLines,WString(""));
	for (int i = 0 ; i < myLines.size(); i++){
		ret[((aEntry)myLines[i]).line] = ((aEntry)myLines[i]).text;
	}
	return ret;
}

