##include "aMain.h"

#define PMAIN ((aMain*)myMain)
#define PUTILS ((aMain*)myMain)->myUtils
//up to how many languages do we support?
#define TEXT_MAX_LANGUAGES 15


bText::bText(void)
{
}

bText::~bText(void)
{
}

//check if modified-utf8 syntax is correct
void bText::checkModifiedUTF(byte* b, int size)
{
#ifdef debug
	//myUtils.hexdump(b);
#endif

#ifdef debug
//	PMAIN->m_pDebug->add(1,"bText::checkModifiedUTF(): patching length:" + (b.length-2));
#endif
	//patch the correct length
	b[0]=(byte)(((size-2)>>8)&0xff);
	b[1]=(byte)((size-2)&0xff);
	b[2]=' ';
}

void bText::autodetectDomain()
{
	/*
	String l=System.getProperty("microedition.locale");

	if (l == null)
		return;

	int pos;

	if ((pos=l.indexOf('-')) != -1)
		localLanguage=l.substring(0,pos);
		*/
}

void bText::create(AEEApplet* _pMain, String name)
{
	myMain = _pMain;
	m_cBuf = NULL;
	currentTextId=-1;
	l=c=0;
	//support up to TEXT_MAX_LANGUAGES languages
	for(int i=0; i < TEXT_MAX_LANGUAGES; i++)
	{
		languageMapping.append(0);
		waitMessage.append(String(""));
	}
	noTextFound="Text is missing!";

	int i;
	char* b = NULL;
	String n;

	if (name.length() == 0)
		return;

	//store the filename
	filename=name;

	//now check for the locale
	autodetectDomain();

	//init domain mapping array, only needed if a config is available
	for (i=0;i < languageMapping.size();i++)
		languageMapping[i]=-1;

	//try to read a config file for the languages
	if ((b = PUTILS->fetchResource(name + ".cfg", b)) != NULL)
	{
		AECHAR* wcfg = (AECHAR*)_MALLOC(sizeof(AECHAR)*PUTILS->lastResourceLen);
		UTF8TOWSTR((const byte*)b, PUTILS->lastResourceLen, wcfg, sizeof(AECHAR)*PUTILS->lastResourceLen);
		/*{
			_FREE(b);
			b = NULL;
			b = (char*)_MALLOC(sizeof(char)*PUTILS->lastResourceLen);
			b = WSTRTOSTR(wcfg, b, sizeof(char)*PUTILS->lastResourceLen);
			_FREE(wcfg);
		}*/
#ifdef debug
//		PMAIN->m_pDebug->add(1,"bText::Constructor(): Parsing Configfile:" + name + ".cfg");
#endif
		//parse config file
		parseCharArray(wcfg, WSTRLEN(wcfg), true);
		_FREE(wcfg);
		wcfg = NULL;
		_FREE(b);
		b = NULL;
	}
	
	//if there is only one language available we automatically load it into memory
	//if (getDomainNumber() == 1){
		lastPos=0;
	//	setDomainID(0);
	//}
}

int bText::parseCharArray( AECHAR* c, int size, boolean p_parseConfig, int pos)
{
	int i;
	if(m_cBuf == NULL)
		m_cBuf = (AECHAR*)_MALLOC(sizeof(AECHAR)*size);
	else
		m_cBuf = (AECHAR*)_REALLOC(m_cBuf, sizeof(AECHAR)*size);

	WString _szBuf;
	for(i=pos; i< size; i++)
	{
		m_cBuf[i-lastPos] = c[i];
		//Found newline
		if(c[i] == '\n')
		{
			m_cBuf[i-lastPos+1] = '\0';
			_szBuf = m_cBuf;
			if(p_parseConfig)
				parseConfig(_szBuf);
			else
				parse( _szBuf);
			lastPos = i+1;
		}
	}
	if(		isParseReady 
		||	p_parseConfig)
	{
		_FREE(m_cBuf);
		m_cBuf = NULL;
	}
	return i;
}

void bText::parseByteArray(byte* b, boolean parseConfig)
{
	/*
	if (b == null)
		return;

	//check if length field is missing
	checkModifiedUTF(b);

	ByteArrayInputStream bais=new ByteArrayInputStream(b);
	DataInputStream is=new DataInputStream(bais);
	String s;

	try
	{
		if ((s=is.readUTF()) != null)
		{
			if (parseConfig == false)
				parse(s);
			else
				parseConfig(s);
		}
	}
	catch (Exception ex)
	{
#ifdef debug
		myDebug.add(0,"bText::parseByteArray(): Exception caught:" + ex.getMessage());
#endif
	}

	try
	{
		is.close();
		is=null;
	}
	catch (Exception ex) {}

	try
	{
		bais.close();
		bais=null;
	}
	catch (Exception ex) {}

	s=null;
	*/
}

void bText::parseConfig(WString s)
{
	//there is only one name in every line within the config file
	int i,f,start, wait_start;
	WString var;
	WString e;
	WString w;
	WString loc;

	for (i=0;i < s.length();l++)
	{
		//reset wait message and locale
		w = "";
		f=0;

		//reset string
		var.setLength(0);

		//read entry
		start = i;
		for (;i < s.length() && s.charAt(i) != '\n' && s.charAt(i) != ',';i++)
		{
			if (s.charAt(i) == '\r')
			{
				var += s.substring(start, i);
				start = i + 1;
			}
		}
		var += s.substring(start, i);


		//get the string and trim it
		e = var.trim();

		//read a wait message?
		if (s.charAt(i++) == ',')
		{
			wait_start = i;

			//reset string
			var.setLength(0);

			//read wait message
			for (;i < s.length() && s.charAt(i) != '\n' && s.charAt(i) != ',';i++)
			{
				if (s.charAt(i) == '\r')
				{
					var += s.substring(start, i);
					start = i + 1;
				}
			}
			var += s.substring(start, i);

			//get the string and trim it
			w = s.substring(wait_start, i);
			w = w.trim();
		}

		//read a locale?
		if (s.charAt(i++) == ',')
		{
			//reset string
			var.setLength(0);

			//read wait message
			for (;i < s.length() && s.charAt(i) != '\n';i++)
			{
				if (s.charAt(i) == '\r')
				{
					var += s.substring(start, i);
					start = i + 1;
				}
			}
			var += s.substring(start, i);

			//get the string, trim it and check if this is our locale language
			if (localLanguage.length() != 0 && localLanguage.equals(var.trim()) == 0)
				f++;
		}

		//step over cr and lf
		for (;i < s.length() && (s.charAt(i) == '\n' || s.charAt(i) == '\r');i++) {}

//System.out.println("var:" + var.toString().trim());

		//so did we read a string? > check now if the config file is also available in the jar file, if yes add it to the domains list
		String _szBuf;
		char _cBuf[10];
		_szBuf = filename;
		_szBuf += _itoa( (l + 1), _cBuf, 10);
		_szBuf += ".dat";
		if (e.length() > 0 && PUTILS->checkResource(_szBuf))
		{
			//add config name
			domains.append(e);

			//store filenumber of config
			languageMapping[c]=l + 1;
			waitMessage[c++]=w;

			//did we found the local language?
			if (f != 0)
				localLanguageIndex=l;
#ifdef debug
//			PMAIN->m_pDebug->add(1,"bText::parseConfig(): added Language:" + e + " with Waitmessage:" + w + " and filename:" + filename + (l + 1) + ".dat");
#endif
		}
	}
}

void bText::parse(WString s)
{
	int i, j, start;

	WString var;
	WString val;
	WString buf;

	for (i=0;i < s.length();)
	{
#ifdef APPLICATION_INIT
		if(PMAIN->m_iGameState != APPLICATION_INIT)
#else
		if(PMAIN->m_iGameState != INIT)
#endif
			PMAIN->paintWaitString();
		//read varname
		start = i;
		for (;i < s.length() && s.charAt(i) != '=';i++) {}
		var = s.substring(start, i);
		i++;

		//read value
		start = i;
		for (;i < s.length() && s.charAt(i) != '\n' && s.charAt(i) != '\r';i++) {}
		val = s.substring(start, i);

		//step over cr and lf
		for (;i < s.length() && (s.charAt(i) == '\n' || s.charAt(i) == '\r');i++) {}

		//remove whitespaces
		var=var.trim();
		val=val.trim();

		//parse value for escaped chars
		start = 0;
		for(j=0;j < val.length();j++)
		{
			if (val.charAt(j) == '\\')
			{
				switch (val.charAt(++j))
				{
					case 'n' :
						buf += val.substring(start, j-1);
						start = j+1;
						buf += String("\n");
						break;
						
					case 'r' :
						buf += val.substring(start, j-1);
						start = j+1;
						buf += String("\r");
						break;
					case 's' :
						buf += val.substring(start, j-1);
						start = j+1;
						buf += String(" ");
						break;
					case 't' :
						buf += val.substring(start, j-1);
						start = j+1;
						buf += String("\t");
						break;

					case '\\' :
						buf += val.substring(start, j-1);
						start = j+1;
						buf += String("\\");
						break;
					
					default :
						buf += val.substring(start, j+1);
						start = j+1;
						break;
				}
			}
		}
		buf += val.substring(start, j);

		if(var.length() == 0 || buf.length() == 0)
		{

//			PMAIN->m_pDebug->add(0,"bText:parse(): Variable or Value empty: Var:" + a + " Val: " + b + " -> stopped!");

			return;
		}

//		PMAIN->m_pDebug->add(2,"bText:parse(): adding:'" + a + "' = '" + b + "'");

		//add to the hashtable
		ht.put(var,buf);
	}
}

void bText::setDomain(String s)
{
	int d;

	for (d=0;d < domains.size();d++)
		if (((String)domains[d]).equals(s) != false)
			break;

	if (d != domains.size())
		setDomainID(d);
}

void bText::setDomainID(int id)
{
	char* b=NULL;
	isParseReady = false;

	//ignore if trying to set an illegal textid
	if (id < 0 || id >= domains.size())
	{
		isParseReady = true;
		return;
	}

	//ignore if selecting the actual active language
	if (currentTextId == id && lastPosition == 0)
	{
		isParseReady = true;
		return;
	}

	//is the new config valid?
	if (languageMapping[id] < 0)
	{
		isParseReady = true;
		return;
	}

#ifdef debug
//	myDebug.add(1,"bText::setDomain(" + (String)domains.elementAt(id) + ")");
#endif

	//fetch new textfile
	char _cBuf[10];
	String _szBuf = filename;
	_szBuf += _itoa(languageMapping[id], _cBuf, 10);
	_szBuf += ".dat";
	if ((b = PUTILS->fetchResource(_szBuf, b)) != NULL)
	{
		AECHAR* wcfg = (AECHAR*)_MALLOC(sizeof(AECHAR)*PUTILS->lastResourceLen);
		UTF8TOWSTR((const byte*)b, PUTILS->lastResourceLen, wcfg, sizeof(AECHAR)*PUTILS->lastResourceLen);
		/*{
			_FREE(b);
			b = NULL;
			b = (char*)_MALLOC(sizeof(char)*PUTILS->lastResourceLen);
			b = WSTRTOSTR(wcfg, b, sizeof(char)*PUTILS->lastResourceLen);
			_FREE(wcfg);
		}*/
		//remove old texts
		if ( cleanit == true )
			cleanup();

		//store new id
		currentTextId=id;

#ifdef LONG_TEXT_FILE
		if ( lastPosition < (WSTRLEN(wcfg) - 511) ) 
		{
			DBGPRINTF("load Text:%d", lastPosition);
			lastPosition = parseCharArray(wcfg, lastPosition + (WSTRLEN(wcfg)/(((float)WSTRLEN(wcfg))/512)), false, lastPosition);
			cleanit = false;
		}
		else {
#endif
		//parse new textfile
		isParseReady = true;
		parseCharArray(wcfg, WSTRLEN(wcfg), false, lastPosition);
		lastPosition = 0;
		lastPos = 0;
		cleanit = true;
#ifdef LONG_TEXT_FILE
		}
#endif
		_FREE(wcfg);
		wcfg = NULL;
		_FREE(b);
		b = NULL;
	}
}

WString bText::getDomain()
{
	if (currentTextId >= 0)
		return (WString)domains[currentTextId];
	else
		return "";
}

WStringVector* bText::getDomains()
{
	return &domains;
}

int bText::getDomainNumber()
{
	return domains.size();
}

boolean bText::check(String key, WString* keyval)
{
	get(key, keyval);
	if (keyval->equals(noTextFound))
		return false;
	return true;
}

String bText::getWaitMessage(int languageId)
{
	return waitMessage[languageId];
}

WString* bText::get(String key, WString* keyval)
{
	if ((ht.get(key, *keyval)) == 0)
	{
#ifdef debug
//		myDebug.add(0,"bText:get(): unknown Key:'" + key + "'");
#endif
		*keyval = noTextFound;
	}
	return keyval;
}

WString bText::get(String key)
{
	WString keyval;
	if ((ht.get(key, keyval)) == 0)
	{
#ifdef debug
//		myDebug.add(0,"bText:get(): unknown Key:'" + key + "'");
#endif
		keyval = noTextFound;
	}
	return keyval;
}

//cleanup all texts currently in memeory	
void bText::cleanup()
{
	ht.removeAll();
	currentTextId=-1;
}

void bText::freeRes()
{
	filename.destruct();	
	domains.remove(0, domains.size());
	domains.destruct();
	languageMapping.remove(0, languageMapping.size());
	languageMapping.destruct();
	waitMessage.remove(0, waitMessage.size());
	waitMessage.destruct();
	localLanguage.destruct();
	ht.removeAll();
	noTextFound.destruct();
}