/*===========================================================================
   In the applet source file (like this one), include AEEAppGen.h.

   Mandatory Sections in Applet Source (this file):
   -----------------------------------------------
   Following Mandatory Sections are required for each applet source file. 
   (Search for "Mandatory" to identify these sections)

   Includes:     
      Copy this section as-is from the sample applet. It contains:
      AEEAppGen.h: For AEEApplet declaration

   Type Declarations:
		A data structure is usually defined to hold the app specific data. In this structure,
		the first element must be of type AEEApplet.  Note that this simple example does 
      not require any additional data, so this step has been removed.

   Functions: (For more details, see corresponding function description in this applet)

      App_HandleEvent(): This function is the Event Handler for the applet.
                         Copy the function outline from the sample applet and add app
                         specific code.

      AEEClsCreateInstance(): This function is called to create an instance of the applet.
                              It is called by AEEModGen when applet is being created.

   
   Important Notes:
   ---------------
   1. DO NOT use any "static data" in the applet. Always use the functions exported by
	   AEEStdlib or by IHeap services to dynamically allocate data and make it a member of 
		the applet structure. 
   2. DO NOT include and link "standard C library". Use AEE Memory Services (in AEEHeap.h) and Standard Library macros(in AEEStdLib.h).
      For example, use MALLOC() to allocate memory, WSTRCPY() to make a copy of Unicode (wide) string.
   3. BREW is Unicode(wide string) compliant ONLY (no ISOLATIN1/ANSI) except for file names which are ISOLATIN1/ANSI.
      ALWAYS USE AECHAR instead of "char". Use string services provided in AEEStdLib.h for string manipulation.
   4. It is always a good idea to DEFINE RESOURCES using BREW ResourceEditor. Make Strings, Bitmaps, Dialogs, etc. 
      as resources. ResourceEditor saves resources as .bri file, generates resource header file 
      and compiles .bri into a .bar binary file, which can be used by the applet.

   Miscellanoeus Notes:
   -------------------
   1. Make sure that the class ID used for the app is the same as that defined corresponding in .MIF file
   2. Always make sure that compiled resource (.bar) file and corresponding
      resource header (a) reside in app directory and (b) are included in the applet code.
      Define a constant APP_RES_FILE containing the name of the compiled resource file (with .bar extension).
===========================================================================*/


/*===============================================================================
INCLUDES AND VARIABLE DEFINITIONS
=============================================================================== */
##include "aMain.h"
##include "aeeheap.h"

#ifdef PLAY4PRIZES
##include "FPSeedGenerator.h"
##include "..\Module\Core\TBC.h"
#endif

//include needed headers for this class
#include Game.h

////////////////////////////////////////////////////////
##ifdef AEE_SIMULATOR
##if BREWVERSION > 0x1
##include "c:\program files\BREW_DIR_V2\sdk\src\AEEModGen.c"
##include "c:\program files\BREW_DIR_V2\sdk\src\AEEAppGen.c"
##else
##include "c:\programme\BREW_DIR_V1\src\AEEModGen.c"
##include "c:\programme\BREW_DIR_V1\src\AEEAppGen.c"
##endif
##endif
/////////////////////////////////////////////////////////
//binary masks for the binary key states
#define KEY_FLAG_UP			1
#define AKEY_FLAG_UP		1
#define KEY_FLAG_DOWN		2
#define AKEY_FLAG_DOWN		2
#define KEY_FLAG_LEFT		2<<2
#define KEY_FLAG_RIGHT		2<<3
#define KEY_FLAG_FIRE		2<<4
#define KEY_FLAG_ZERO		2<<5
#define KEY_FLAG_ONE		2<<6
#define KEY_FLAG_TWO		2<<7
#define KEY_FLAG_THREE		2<<8
#define KEY_FLAG_FOUR		2<<9
#define KEY_FLAG_FIVE		2<<10
#define KEY_FLAG_SIX		2<<11
#define KEY_FLAG_SEVEN		2<<12
#define KEY_FLAG_EIGHT		2<<13
#define KEY_FLAG_NINE		2<<14
#define KEY_FLAG_ASTERIX	2<<15
#define AKEY_FLAG_ASTERISK  2<<15
#define KEY_FLAG_NUMBER		2<<16
#define AKEY_FLAG_NUMBER    2<<16
#define KEY_FLAG_SOFTLEFT	2<<17
#define KEY_FLAG_SOFTRIGHT	2<<18

// 0 is just fine here as code for 'no key pressed'
/////////////////////////////////////////////////////////

/*
#define MAXKEYS 1024
#define MAXHTSIZE 40960
#define HTTTL 36000000
#define MAXKEYLEN 81
#define MAXKEYVALLEN 2048
#define MAX_LINE 20
#define NUM_GAME_COLOR_ROTATION 16
#define NOTEXTFOUND "Text is missing!"

//main menu screen items
#define MENU_RESUME 0
#define MENU_START 1
#define MENU_HELP 2
#define MENU_SOUND 3
#define MENU_SCORE 4
#define MENU_GALLERY 5
#define MENU_LANGUAGE 6
#define MENU_QUIT 7
#define MENU_END_MARK 8 //must always be the last entry!

//menus available
#define MENU_MAIN 0
#define MENU_START_GAME 1
*/
extern void print_table(IFile* fd);
extern void free_all();
#define BUTTON_TEXT_X_OFFSET 0
#define BUTTON_TEXT_Y_OFFSET 0
/*
#define ARROW_RIGHT '>'
#define HELP_BACK_COLOR 0xffffffff
#define MENU_DIFFICULT_LEVELS 2
#define MAIN_PERCENTAGE 70
#define LANG_BACK_COLOR 0xffff
#define ARROW_LEFT '<'
#define BRAND_BACK_COLOR 0xffff
*/
/*===============================================================================
FUNCTION DEFINITIONS
=============================================================================== */
/*===========================================================================

FUNCTION: AEEClsCreateInstance

DESCRIPTION
	This function is invoked while the app is being loaded. All Modules must provide this 
	function. Ensure to retain the same name and parameters for this function.
	In here, the module must verify the ClassID and then invoke the AEEApplet_New() function
	that has been provided in AEEAppGen.c. 

   After invoking AEEApplet_New(), this function can do app specific initialization. In this
   example, a generic structure is provided so that app developers need not change app specific
   initialization section every time except for a call to InitAppData(). This is done as follows:
   InitAppData() is called to initialize AppletData instance. It is app developers 
   responsibility to fill-in app data initialization code of InitAppData(). App developer
   is also responsible to release memory allocated for data contained in AppletData -- this can be
   done in FreeAppData().

PROTOTYPE:
	int AEEAppCreateInstance(AEECLSID clsID, IShell* pIShell, IModule* pIModule,IApplet** ppApplet)

PARAMETERS:
	clsID: [in]: Specifies the ClassID of the applet which is being loaded

	pIShell: [in]: Contains pointer to the IShell interface. 

	pIModule: pin]: Contains pointer to the IModule interface to the current module to which
	this app belongs

	ppApplet: [out]: On return, *ppApplet must point to a valid AEEApplet structure. Allocation
	of memory for this structure and initializing the base data members is done by AEEApplet_New().

DEPENDENCIES
  none

RETURN VALUE
  SUCCESS: If the app needs to be loaded and if AEEApplet_New() invocation was successful
  EFAILED: If the app does not need to be loaded or if errors occurred in AEEApplet_New().
  If this function returns FALSE, the app will not be loaded.

SIDE EFFECTS
  none
===========================================================================*/
extern "C" void __cxa_pure_virtual () {}
int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * pMod,void ** ppObj)
{
	////DBGPRINTF ( "entr:AEECreateInstanse" );
	if(!AEEApplet_New( sizeof(aMain),                  // Size of our private class
					 ClsId,                              // Our class ID
					 pIShell,                            // Shell interface
					 pMod,                               // Module instance
					 (IApplet**)ppObj,                   // Return object
					 (AEEHANDLER)aMain::HandleEvent, // Our event handler
					 (PFNFREEAPPDATA)aMain::freeAppData))                              // No special "cleanup" function
	  return(EFAILED);


	if (!aMain::InitAppData((IApplet*) *ppObj))
	{
	  return EFAILED;
	}
	return( SUCCESS );
}

boolean aMain::InitAppData(IApplet* pIApplet)
{
	////DBGPRINTF ( "entr:InitAppData" );
	aMain* pMain = (aMain*)pIApplet;
	return pMain->OnAppInitData();
}

void aMain::freeAppData(aMain *pMain)
{
	pMain->OnFreeAppData();
};
/*===========================================================================

FUNCTION HandleEvent
  
DESCRIPTION
   This is the EventHandler for this app. All events to this app are handled in this
   function. All APPs must supply an Event Handler.  

   Note - The switch statement in the routine is to demonstrate how event handlers are 
   generally structured.  However, realizing the simplicity of the example, the code could
   have been reduced as follows:

   if(eCode == EVT_APP_START){
      IDISPLAY_DrawText();
      IDISPLAY_Update();
      return(TRUE);
   }
   return(FALSE);

   However, while doing so would have demonstrated how BREW apps can be written in about 8
   lines of code (including the app creation function), it might have confused those who wanted 
   a bit more practical example.

   Also note that the use of "szText" below is provided only for demonstration purposes.  As 
   indicated in the documentation, a more practical approach is to load text resources
   from the applicaton's resource file.

   Finally, note that the ONLY event that an applet must process is EVT_APP_START.  Failure
   to return TRUE from this event will indicate that the app cannot be started and BREW
   will close the applet.
    
PROTOTYPE:
   boolean BrewCMX_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
      
PARAMETERS:
   pi: Pointer to the AEEApplet structure. This structure contains information specific
   to this applet. It was initialized during the AppCreateInstance() function.
        
   ecode: Specifies the Event sent to this applet
          
   wParam, dwParam: Event specific data.
            
DEPENDENCIES
   none
              
RETURN VALUE
   TRUE: If the app has processed the event
   FALSE: If the app did not process the event
                
SIDE EFFECTS
   none
===========================================================================*/
bool aMain::HandleEvent(aMain* p_pMain, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
	return p_pMain->OnEvent(eCode, wParam, dwParam);
}

boolean aMain::OnAppInitData()
{
	myMain = this;
	FrameTime = 80;
	int _iGameColorRotation[] = {GAME_COLOR_ROTATION};
	for(int i=0; i<(sizeof(_iGameColorRotation)/sizeof(int));i++)
	{
		GameColorRotation.append(_iGameColorRotation[i]);
	}
	LanguageSepY=-1;
	lastHelpPos=-1;
#ifdef MENU_MUSIC
	MenuMusic=-1;
#endif
	currentMenu=MENU_MAIN;
	currentMenuItem=MENU_START;
	m_iGameState = INIT;
#ifdef GAME_SET_VOLUME_MED
	soundVolume = GAME_SET_VOLUME_MED;
#endif
	isNewGameState = _TRUE_;
	isPaused=true;
	doFullPaint=true;
	doFullMenuPaint=_TRUE_;
	DelightJingle = -1;
#ifdef SCORE_MUSIC
	ScoreMusic=-1;
#endif
	ScoreScrollPos=-1;
	ScoreLastName=SCORE_DEFAULT_NAME;
	ScoreLastPosition=-1;
#ifdef SCORE_ONE_PER_MODE
	ScoreLastMode=-1;
#endif

	lastKeyPressed = GAME_NO_KEY_PRESSED;
#ifdef GAME_CONDITIONAL_FLUSH_GRAPHICS
	doFlushGraphics = GAME_CONDITIONAL_FLUSH_GRAPHICS;
#endif
#ifdef GAME_SKIP_NOTIFY
	skipNotify = _FALSE_;
#endif
	currentMenuItem = 2;		// set to 'GAME' as default
#ifdef GAME_USE_ARROWS
	arrowPos = GAME_ARROW_START_POS;
#endif GAME_USE_ARROWS
	BackGameState = -1;
	PrevMenuItem = -1;

	return TRUE;
}

void aMain::OnFreeAppData()
{
	//writeConfig();
	IFile* _pFile;
	IFileMgr* _pFileMgr;

//free game stuff
	myGame->freeRes();

	//if (mySlyder != NULL)
	//{
	//	delete mySlyder;
	//	mySlyder = NULL;
	//}

	//if (amtpGraphics != NULL)
	//{
	//	delete amtpGraphics;
	//	amtpGraphics = NULL;
//	}	

//free utils stuff
	myUtils->freeRes();
#ifdef AUTILS_USE_GRAPHICAL_FONT
	myUtils->cleanupFont();
#endif
#ifndef soundapi/none
//free sound stuff
	mySound->freeRes();
#endif
#ifdef PROFILER
	if(ISHELL_CreateInstance( m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
	{
#ifdef debug
		myDebug->add(0, "aMain::OnFreeAppData:CI FileMgr failed!");
#endif
	}
	else
	{
		_pFile = IFILEMGR_OpenFile(_pFileMgr, "Profiler.log", _OFM_READWRITE);
		if(_pFile == NULL)
		{
			_pFile = IFILEMGR_OpenFile(_pFileMgr, "Profiler.log", _OFM_CREATE);
		}
		if(_pFile != NULL)
		{
			IFILE_Truncate(_pFile, 0);
			myProfiler->print(_pFile);
			IFILE_Release(_pFile);
		}
		IFILEMGR_Release(_pFileMgr);
	}
	myProfiler->clear();
#endif
//free textbox stuff
	myTextBox->freeRes();
//free text stuff
#ifdef GAME_USE_BTEXT_CLASS
	myText->freeRes();
#else
	myText->cleanup();
#endif
//free score stuff
#ifdef SCORE_ONE_PER_MODE
	for ( int i = 0; i < myModeScores.size(); i++) {
		myModeScores[i].freeRes();
	}
	myModeScores.removeAll();
	myModeScores.destruct();
#endif

	myScores->freeRes();

//free main stuff
	if(pIHeap != NULL)
	{
		IHEAP_Release(pIHeap);
		pIHeap = NULL;
	}
	if(m_pGraphics != NULL)
	{
		IGRAPHICS_Release(m_pGraphics);
		m_pGraphics = NULL;
	}

##if BREWVERSION > 0x1
	if(m_pbmScreen != NULL)
	{
		IBITMAP_Release(m_pbmScreen);
		m_pbmScreen = NULL;
	}
##endif
#ifdef GAME_USE_GALLERY
	if(galleryImage != NULL)
	{
		galleryImage->release();
		delete(galleryImage);
		galleryImage = NULL;
	}
#ifdef GAME_USE_PREVIEWS
#ifdef GAME_SINGLE_PREVIEWS
	for(int i=0; i < galleryPreview.size(); i++)
	{
		if(galleryPreview[i] != NULL)
		{
			galleryPreview[i]->release();
			delete(galleryPreview[i]);
			galleryPreview[i] = NULL;
		}
	}
	galleryPreview.removeAll();
	galleryPreview.destruct();
#else
	if(galleryPreview != NULL)
	{
		galleryPreview->release();
		delete(galleryPreview);
		galleryPreview = NULL);
	}
#endif GAME_SINGLE_PREVIEWS
#endif GAME_USE_PREVIEWS
#endif
#ifndef USE_COMMANDS
#ifdef INIT_QUIT_IMAGE
	if(initQuitImage != NULL)
	{
		initQuitImage->release();
		delete(initQuitImage);
		initQuitImage = NULL;
	}
#endif INIT_QUIT_IMAGE
#endif !USE_COMMANDS
#ifdef GAME_BACK_IMAGE
	if(backImage != NULL)
	{
		backImage->release();
		delete(backImage);
		backImage = NULL;
	}
#endif
	//color rotation
	GameColorRotation.removeAll();
	GameColorRotation.destruct();
	if(MenuImage != NULL)
	{
		MenuImage->release();
		delete(MenuImage);
		MenuImage = NULL;
	}
	MenuText.destruct();
	MenuCommandName.destruct();
	MenuCommandOKName.destruct();
	MenuCommandCancelName.destruct();
	ArrowText.destruct();
	//store the delight entertainment logo and jingle
	if(DelightImage1 != NULL)
	{
		DelightImage1->release();
		delete(DelightImage1);
		DelightImage1 = NULL;
	}
	if(DelightImage2 != NULL)
	{
		DelightImage2->release();
		delete(DelightImage2);
		DelightImage2 = NULL;
	}
	//branding stuff
	if(BrandImage != NULL)
	{
		BrandImage->release();
		delete(BrandImage);
		BrandImage = NULL;
	}
#ifndef SCORE_IS_EXTERNAL
#ifdef SCORE_IMAGE
	if(ScoreImage != NULL)
	{
		ScoreImage->release();
		delete(ScoreImage);
		ScoreImage = NULL;
	}
#endif
	for( int i=0; i < ScoreBuf.size(); i++)
	{
		ScoreBuf[i].destruct();
	}
	ScoreBuf.removeAll();
	ScoreBuf.destruct();
	ScoreInputRange.destruct();
	ScoreInputTitle.destruct();
	ScoreInputGrats.destruct();
	ScoreLastName.destruct();
	ScoreInputChars.destruct();
	ScoreTitel.destruct();
#endif SCORE_IS_EXTERNAL
#ifdef GAME_USE_TRANSITIONS
	lastTransitions.removeAll();
	lastTransitions.destruct();
	lastTransMode.removeAll();
	lastTransMode.destruct();
	if(transImage != NULL)
	{
		transImage->release();
		delete(transImage);
		transImage = NULL;
	}
#endif GAME_USE_TRANSITIONS
#ifdef GAME_TILED_IMAGE || MENU_TILED_IMAGE
	if(tiledImage != NULL)
	{
		tiledImage->release();
		delete(tiledImage);
		tiledImage = NULL;
	}
#endif
	menuEntries.removeAll();
	menuEntries.destruct();
#ifdef MENU_DIFFICULT_LEVELS
	startEntries.removeAll();
	startEntries.destruct();
#endif MENU_DIFFICULT_LEVELS
#ifndef USE_COMMANDS
	if(menuButton != NULL)
	{
		menuButton->release();
		delete(menuButton);
		menuButton = NULL;
	}
#endif !USE_COMMANDS
#ifdef GAME_USE_TEMP_IMAGE
	if(tempImage != NULL)
	{
		tempImage->release();
		delete(tempImage);
		tempImage = NULL;
	}
#endif
#ifdef MENU_HEADER_IMAGE_FILE
	if(headerImage != NULL)
	{
		headerImage->release();
		delete(headerImage);
		headerImage = NULL;
	}
#endif
#ifdef MENU_FOOTER_IMAGE_FILE
	if(footerImage != NULL)
	{
		footerImage->release();
		delete(footerImage);
		footerImage = NULL;
	}
#endif
#ifndef MENU_IS_EXTERNAL
#ifdef MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_ITEM_IMAGE
	if(menuItemImage != NULL)
	{
		menuItemImage->release();
		delete(menuItemImage);
		menuItemImage = NULL;
	}
#ifdef MENU_ITEM_SELECTED_IMAGE
	if(menuSelectedItemImage != NULL)
	{
		menuSelectedItemImage->release();
		delete(menuSelectedItemImage);
		menuSelectedItemImage = NULL;
	}
#endif
#ifdef MENU_ITEM_ANIMATED
	menuItemStates.removeAll();
	menuItemStates.destruct();
	menuItemStateIndex.removeAll();
	menuItemStateIndex.destruct();
#endif MENU_ITEM_ANIMATED
#endif MENU_ITEM_IMAGE
#endif MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
	for(int i=0; i<icons.size(); i++)
	{
		if(icons[i] != NULL)
		{
			icons[i]->release();
			delete(icons[i]);
			icons[i] = NULL;
		}
	}
	icons.removeAll();
	icons.destruct();
	iconOffsets.removeAll();
	iconOffsets.destruct();
#endif MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
#endif !MENU_IS_EXTERNAL
#ifdef GAME_USE_TEXT_DEFINES
	GameModes.removeAll();
	GameModes.destruct();
#endif

	//free_all();
#ifdef debug
	myDebug->freeRes();
	initString.destruct();
	fpsString.destruct();

##if BREWVERSION > 0x1
	if(ISHELL_CreateInstance( m_pIShell, AEECLSID_FILEMGR_312, (void**)( &_pFileMgr ) ) != SUCCESS)
##else
	if(ISHELL_CreateInstance( m_pIShell, AEECLSID_FILEMGR, (void**)( &_pFileMgr ) ) != SUCCESS)
##endif
	{
		myDebug->add(0, "aMain::OnFreeAppData:CI FileMgr failed!");
	}
	else
	{
		_pFile = IFILEMGR_OpenFile(_pFileMgr, "MemStats.log", _OFM_READWRITE);
		if(_pFile == NULL)
		{
			_pFile = IFILEMGR_OpenFile(_pFileMgr, "MemStats.log", _OFM_CREATE);
		}
		if(_pFile != NULL)
		{
			IFILE_Truncate(_pFile, 0);
			print_table(_pFile);
			IFILE_Release(_pFile);
		}
		IFILEMGR_Release(_pFileMgr);
	}
	mem_cleanup("test");
#endif

#ifndef USE_COMMANDS
	SoftKeyLeftLabel.destruct();
	SoftKeyRightLabel.destruct();
#endif

#ifdef PLAY4PRIZES
	TBEvents::Release();
	editKeyMap._delete();
	for(int i = 0; i < editChars.size(); i++)
		editChars[i].destruct();
	editChars._delete();
	p4p_menuName.destruct();
	p4p_commandForeText.destruct();
	p4p_commandBackText.destruct();
	for(int i = 0; i < p4p_entryName.size();i++)
		p4p_entryName[i].destruct();
	p4p_entryName._delete();
	for( int i = 0; i < p4p_entryText.size(); i++)
		p4p_entryText[i].destruct();
	p4p_entryText._delete();
	p4p_entryType._delete();
	p4p_entryData._delete();
	p4p_itemHeight._delete();
	p4p_entryObject._delete();
	p4p_data._delete();
	for(int i = 0; i < StringVectorTmpInput.size();i++)
		StringVectorTmpInput[i].destruct();
	StringVectorTmpInput._delete();
	for(int i =0; i <StringVectorTmpStatic.size(); i++)
		StringVectorTmpStatic[i].destruct();
	StringVectorTmpStatic._delete();
	for(int i = 0; i < StringVectorTmpDynamic.size(); i++)
		StringVectorTmpDynamic[i].destruct();
	StringVectorTmpDynamic._delete();
	editName.destruct();
	editCursor.destruct();
	if(menuObj)
		delete(menuObj);
	if(clientObj)
		delete(clientObj);
#endif PLAY4PRIZES
	versionString.destruct();
}

boolean aMain::init()
{
	AEEDeviceInfo   di;
    m_bLoadText = false;
	if(ISHELL_CreateInstance(this->m_pIShell, AEECLSID_HEAP, (void **)&pIHeap) != SUCCESS)
		return FALSE;
	//Init Interface instances
	if(ISHELL_CreateInstance( m_pIShell, AEECLSID_GRAPHICS, (void**)( &m_pGraphics ) ) != SUCCESS)
	{
		return(FALSE);
	}
	////DBGPRINTF ("end createinstance");
	// Get screen pixel count 
	ISHELL_GetDeviceInfo(m_pIShell, &di);
	ScreenWidth = di.cxScreen;
	ScreenHeight = di.cyScreen;

	myKey = &_Key;
	myText = &_Text;
	myTextBox = &_TextBox;
	myUtils = &_Utils;
	myGame = &_Game;
	myScores = &_Score;
#ifndef soundapi/none
	mySound = &_Sound;
#endif
#ifdef PROFILER
	myProfiler = &_Profiler;
#endif
##if BREWVERSION > 0x1
	IDISPLAY_GetDeviceBitmap(m_pIDisplay, &m_pbmScreen);
##endif

	//now create required objects
	////DBGPRINTF ("begincreate class pKey");
	myKey->create();
	////DBGPRINTF ("begincreate class pUtils");
	myUtils->create( (AEEApplet*)this);
#ifdef debug
	myDebug = &_Debug;
	myDebug->create( (AEEApplet*)this);
	myDebug->setLevel(0);
#endif
#ifdef PROFILER
	myProfiler->create( (AEEApplet*)this);
	myProfiler->setLevel(20);
#endif
#ifdef GAME_RESOURCE_FILE
	//init resource file if we are working with one
	myUtils->setResourceFile("dat.bin");
	myUtils->setFont(m_pGraphics, AEE_FONT_NORMAL);

#endif
	if(DelightImage1 == NULL)
		DelightImage1 = myUtils->fetchImage ( String(INIT_IMAGE1) );
	if(DelightImage2 == NULL)
		DelightImage2 = myUtils->fetchImage ( String(INIT_IMAGE2) );

//get x resolution
#ifdef DEVICE_X_RESOLUTION
		ScreenWidth=DEVICE_X_RESOLUTION;
#endif

//get y resolution
#ifdef DEVICE_Y_RESOLUTION
		ScreenHeight=DEVICE_Y_RESOLUTION;
#endif

	//amtpGraphics = new AMTPGraphics();
	
	//GETGRAPHICS()->Init("amtpgame.bar", AMTP_PALETTE);
	//GETGRAPHICS()->LoadFont(AMTPGraphics::AMTP_FONT_SMALL, "amtpgame.bar", AMTP_FONT_SMALL_HDR, AMTP_FONT_SMALL_IMG);
	//GETGRAPHICS()->LoadFont(AMTPGraphics::AMTP_FONT_MEDIUM, "amtpgame.bar", AMTP_FONT_MEDIUM_HDR, AMTP_FONT_MEDIUM_IMG);
	//GETGRAPHICS()->LoadFont(AMTPGraphics::AMTP_FONT_LARGE, "amtpgame.bar", AMTP_FONT_LARGE_HDR, AMTP_FONT_LARGE_IMG);


	
	//mySlyder = new SlyderGame(this->m_pIShell, m_pIDisplay, myGame);
	
	myGame->create( (AEEApplet*)this, ScreenWidth, ScreenHeight);
	// hand the resolution over to the game class
	myGame->updateScreenSize(ScreenWidth, ScreenHeight);

	//mySlyder->Init();


	//paint is now possible
	isPaused=false;
	pauseGameNow = _FALSE_;

	////DBGPRINTF ("begincreate class pTextBox");
	myTextBox->create( (AEEApplet*)this);
	//do the whole initialisation
	doInit();

	myCommandPosX=ScreenWidth;
	myCommandPosY=ScreenHeight;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	int LanguageSepY = -1;
#endif
#ifdef GAME_USE_ARROWS
#ifndef GAME_ARROW_START_POS
#define GAME_ARROW_START_POS 0
#endif
	ArrowPos = GAME_ARROW_START_POS;
#endif
	updateMenuString = _TRUE_;
#ifdef GAME_USE_TEXT_DEFINES
	String _GameModes[] = {TEXT_CONST_MODES};
	for(int i=0; i < (sizeof(_GameModes)/sizeof(String)); i++)
	{
		GameModes.append(_GameModes[i]);
	}
#endif
#ifdef PLAY4PRIZES
	TBEvents::fpInit(this,LOCALE_DEFAULT);
	menuObj = new FPMenuEventListenerObj(this);
	TBEvents::registerEventHandler((ITBMenuEventListener*)menuObj);
	clientObj = new FPClientEventListenerObj(this);
	TBEvents::registerEventHandler((ITBClientEventListener*)clientObj);
	TBEvents::registerEventHandler(new FPSeedGenerator(this));
	fpMenu = TBEvents::getMenuControls();
	fpClient = TBEvents::getClientControls();
#endif
	return TRUE;
}

void aMain::mainLoop(aMain * pMain)
{
#ifdef debug
	if(pMain->pIHeap != NULL)
	{
		uint32 mem = IHEAP_GetMemStats(pMain->pIHeap);
		AEEDeviceInfo di;
		di.wStructSize = sizeof(AEEDeviceInfo);
		ISHELL_GetDeviceInfo(pMain->m_pIShell, &di);
		uint32 memFree = di.dwRAM - mem;
		////DBGPRINTF("Heap Gre %d", mem);
		////DBGPRINTF("Verfgbarer Speicher %d", di.dwRAM);
		////DBGPRINTF("Freier Speicher %d", memFree);
	}
#endif
	if(pMain->m_bRun)
	{
#ifdef PROFILER
		pMain->_Retval = pMain->m_pProfiler->startMeasurement(__FUNCTION__);
#endif
		uint32 _uiStartTime = ISHELL_GetTimeMS(m_pIShell);
		pMain->processKey();
#ifdef PLAY4PRIZES
		if(pMain->m_iGameState == APPLICATION_P4P_PLAY)
			pMain->p4p_logic();
  #ifdef MENU_MUSIC
    #ifdef soundapi/none
		//delay to play sound because sometimes it will switch to game after exit p4p ui system
		else{
			if(pMain->p4p_soundRestart > 0){
				pMain->p4p_soundRestart--;
				if(pMain->p4p_soundRestart == 0){
					if(pMain->isSoundMuted == FALSE) pMain->restartMusic = _TRUE_;
				}
			}
		}
    #endif
  #endif
#endif
		//than do some logic stuff
		if (pMain->m_iGameState == APPLICATION_GAME && pMain->isGamePaused == _FALSE_)
		{
			pMain->myGame->logic();
		}
		pMain->paint();
		int _iTimeDiff = pMain->FrameTime - (ISHELL_GetTimeMS(m_pIShell) - _uiStartTime);
		DBGPRINTF("FT: %d", _iTimeDiff);
/*#ifndef KYOCERA_KX1
		if( _iTimeDiff > 0 )
		{
			ISHELL_SetTimer(pMain->m_pIShell, _iTimeDiff, ( PFNNOTIFY )mainLoop, pMain );
			//DBGPRINTF("Set Timer: %d", _iTimeDiff);
		}
		else
		{
			ISHELL_SetTimer(pMain->m_pIShell, 10, ( PFNNOTIFY )mainLoop, pMain );
		}*/
//#else
		ISHELL_SetTimer(pMain->m_pIShell, 70, ( PFNNOTIFY )mainLoop, pMain );
		//DBGPRINTF("Set Timer: 50");
//#endif
		
#ifdef debug
		pMain->lastFrametime = (ISHELL_GetTimeMS(m_pIShell) - _uiStartTime);
#endif
#ifdef PROFILER
		pMain->m_pProfiler->stopMeasurement(pMain->_Retval);
#endif
		if(!pMain->m_bLoadText)
			pMain->m_bLoadText = true;
#ifdef PLAY4PRIZES
		pMain->fpMenu->menuTick();
#endif
	}
	else
	{
#ifndef soundapi/none
//		pMain->mySound->mute(_TRUE_);
		pMain->mySound->stop(0);
		//pMain->m_bSoundStarted = _FALSE_;
#endif
#ifdef PLAY4PRIZES
		pMain->fpClient->notifyModule(MODULE_NOTIFY_DESTROYED, 0);
#endif
		//pMain->writeConfig();
		ISHELL_CloseApplet(pMain->m_pIShell, FALSE);
	}
}

bool aMain::OnEvent(AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
	
	switch (eCode)
	{
	case EVT_APP_START:
		//init the application
		if(init())
		{
			//start the main loop
			mainLoop(this);
			return(TRUE);
		}
		else
			return FALSE;
	case EVT_APP_STOP:
		//OnFreeAppData();
		return(TRUE);
		break;

	case EVT_AMTP_WEB_RESPONSE:
		//GetResponse();
		TBEvents::GetResponse();
	return TRUE;

	//case EVT_APP_MESSAGE_EX:
	case EVT_APP_MESSAGE:
		if (myKey != NULL){
		myKey->KeyState=0;
		PGAME->keyCounterOfFramesPressing = 0;
	  PGAME->keyLast = 0;
	}
		DBGPRINTF("EVT_APP_MESSAGE");
		return FALSE;
		break;
	case EVT_APP_SUSPEND:
		if (myKey != NULL){
		myKey->KeyState=0;
		PGAME->keyCounterOfFramesPressing = 0;
	  PGAME->keyLast = 0;
	}
		hideNotify();
		DBGPRINTF ( "Suspend" );
		return TRUE;
		break;
	case EVT_APP_RESUME:
		if (myKey != NULL){
		myKey->KeyState=0;
		PGAME->keyCounterOfFramesPressing = 0;
	  PGAME->keyLast = 0;
	}
		//DBGPRINTF ( "Resume" );
		showNotify();
		return (TRUE);
		break;
	case EVT_BUSY:
		
		return FALSE;
	case EVT_KEY_PRESS:  // Handle necessary key events
/*
		if((wParam == AVK_VOLUME_UP) || (wParam == AVK_VOLUME_DOWN) || (wParam == AVK_VOICE_MEMO) || (wParam == AVK_SPEAKER) )
		{
			ISHELL_Notify(m_pIShell, clsID, dwParam, NULL);
			return(FALSE);
		}
*/
		keyPressed( wParam);
		return(TRUE);
		break;
	case EVT_KEY_RELEASE:  // Handle necessary key events
/*
		if((wParam == AVK_VOLUME_UP) || (wParam == AVK_VOLUME_DOWN) || (wParam == AVK_VOICE_MEMO) || (wParam == AVK_SPEAKER) )
		{
			ISHELL_Notify(m_pIShell, clsID, dwParam, NULL);
			return(FALSE);
		}
*/
		keyReleased( wParam);
		return(TRUE);
		break;
	case EVT_FLIP:
		/*
		if(wParam)
			showNotify();
		else
			hideNotify();
		*/
		m_bRun = _FALSE_;
		break;
	case EVT_KEYGUARD:
		if(wParam ==true)
			m_bRun = _FALSE_;
		break;
	  default:
		 break;
	}
	return(TRUE);
}

// process the keyCodes, gets called from the main thread between every paint
void aMain::processKey() 
{
	int ret;
	int processStateByKey = -1;
#ifdef debug
	// something went wrong
	if (m_iGameState < 0)
		myDebug->add(0, "Main::processKey(): unknown GameState:");
#endif

	/* return if:
			 -  nothing happened (lastKeyPressed == 0 (or ' - 23' for doja))
			 -  we are currently drawing
			 -  game is paused */
	if (lastKeyPressed == GAME_NO_KEY_PRESSED || isDrawing == _TRUE_ || isPaused)  // TODO check this: isInitialised == _FALSE_ ||
		return;

	// just store the keycode to process
	int keyCode = lastKeyPressed;

#ifdef debug
	// for displaying keys if in debug mode
	lastKeyProcessed = lastKeyPressed;
#endif

	// reset the last key pressed
	lastKeyPressed = GAME_NO_KEY_PRESSED;

	// block paints / repaints while processing keys
	isPaused = true;

#ifdef debug
	// check debug keys if in debug mode
	keyDebug(keyCode);
#endif

#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// set menu command time, needed for sliding the button out of the screen if not already set
	if ((
		m_iGameState == APPLICATION_GAME ||
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
// 			m_iGameState == APPLICATION_LANGUAGE ||	// within language screen menu button does not need to slide out (i think)
#endif
#ifdef GAME_USE_GALLERY
		m_iGameState == APPLICATION_GALLERY ||
#endif
#ifndef GAME_NO_HIGHSCORE
		m_iGameState == APPLICATION_HIGHSCORE ||
#endif
		m_iGameState == APPLICATION_HELP) && MenuCommandTime == 0) 
	{
			MenuCommandTime = ISHELL_GetTimeMS(m_pIShell);
	}
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS

	switch (m_iGameState) 
	{
		case APPLICATION_INIT :
			keyInit(keyCode);
			break;
#ifndef GAME_NO_BRAND_SCREEN
		case APPLICATION_BRAND :
			keyBrand(keyCode);
			break;
#endif
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
		case APPLICATION_LANGUAGE :
			keyLanguage(keyCode);
			break;
#endif
		case APPLICATION_MAINMENU :
			{
#ifdef MENU_IS_EXTERNAL
			myGame->keyMenu(m_iGameState, keyCode);
#else
#ifdef MENU_USE_CLASSIC_MAINMENU
			processKeyMenu(keyCode, menuEntries, _TRUE_);
#endif
#ifdef MENU_USE_MULTIITEM_MAINMENU
			processKeyMenu(keyCode, menuEntries, _FALSE_);
#endif
#ifdef MENU_USE_ICON_MAINMENU
			processKeyIconMenu(keyCode, menuEntries);
#endif
			// display the new menu string  TODO
// 				MenuText = getMenuItemText(menuEntries[currentMenuItem]);
#endif MENU_IS_EXTERNAL
			}
			break;

#ifdef MENU_DIFFICULT_LEVELS
		case APPLICATION_STARTMENU :
#ifdef MENU_USE_CLASSIC_STARTMENU
			processKeyMenu(keyCode, startEntries, _TRUE_);
#endif
#ifdef MENU_USE_MULTIITEM_STARTMENU
			//processKeyMenu(keyCode, startEntries, _FALSE_);
			ret = myGame->levelSelectPress(keyCode);

			if (ret == 1)
			{	
				processApplicationState(APPLICATION_BACK2MAINMENU);
 				currentMenuItem = 2;
			}
			else if (ret == 2)
			{
				processApplicationState(APPLICATION_GAME);
				gameStartMode = currentMenuItem - 1;
			}

#endif
#ifdef MENU_USE_ICON_STARTMENU
// TODO?				processKeyIconMenu(keyCode, startEntries);
#endif
			// display the new menu string  TODO
//				MenuText = getMenuItemText(startEntries[currentMenuItem]);
#endif MENU_DIFFICULT_LEVELS
			
			break;

		case APPLICATION_HELP :
			keyHelp(keyCode);
			break;
#ifdef GAME_USE_GALLERY
		case APPLICATION_GALLERY :
			keyGallery(keyCode);
			break;
#endif
		case APPLICATION_GAME :
			keyGame(keyCode);
			break;
#ifndef GAME_NO_HIGHSCORE
		case APPLICATION_INPUTSCORE :
			keyScoreInput(keyCode);
			break;
		case APPLICATION_HIGHSCORE :
			keyScore(keyCode);
			break;
#ifdef GAME_HISCORE_UPLOAD
		case APPLICATION_SCOREUPLOAD :
			keyScoreUpload(keyCode);
			break;
#endif GAME_HISCORE_UPLOAD
#endif !GAME_NO_HIGHSCORE
		case APPLICATION_QUIT :
			m_bRun = _FALSE_;
			return;
#ifdef PLAY4PRIZES
		case APPLICATION_P4P_PLAY:
		case APPLICATION_P4P_HELP:
			processKey4Prizes(keyCode, false, false);
			break;
#endif
		default :
			// main does not know what to do - let game do it
			// IMPORTANT: do debug error handling in Game.processKey(keyCode)
			processStateByKey = myGame->processKey(keyCode, m_iGameState);
	}

	if (processStateByKey > -1) 
	{
		// do the desired action
		processApplicationState(processStateByKey);
	}
	isPaused = false;
	if(m_iGameState != APPLICATION_GAME
#ifdef PLAY4PRIZES
		&& m_iGameState != APPLICATION_P4P_PLAY
#endif
		){
			myKey->KeyState = 0;
	}
}

void aMain::doInit()
{
	//only initialise once
	if (isInitialised == _TRUE_)
		return;

	int i;

#ifdef GAME_USE_GALLERY
	// initialize flags for gallery
	galleryFlags = 0;
#endif

#ifndef soundapi/none
		lastLoopedSound = -2;
#endif

/*		mySmallFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_PLAIN,Font.SIZE_SMALL);

	//get our standard font depending on the screensize
	if (ScreenHeight <= 120 || ScreenWidth <= 120)
	{
#ifndef panasonic && x60
		myFont = aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_PLAIN,Font.SIZE_SMALL);
		ScoreFont = aUtils.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL);
		ScoreInputFont = aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_MEDIUM);
#else
		myFont=aUtils.getFont(Font.FACE_PROPORTIONAL,Font.STYLE_PLAIN,Font.SIZE_SMALL);
		ScoreFont=aUtils.getFont(Font.FACE_PROPORTIONAL,Font.STYLE_PLAIN,Font.SIZE_SMALL);
		ScoreInputFont=aUtils.getFont(Font.FACE_PROPORTIONAL,Font.STYLE_BOLD,Font.SIZE_MEDIUM);
#endif
	}
#ifndef gx10 || s30 || c450 || x60
	else
	{
		if (ScreenHeight <= 230 || ScreenWidth <= 230)
		{
#ifdef p900
			myFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_LARGE);
			ScoreFont=aUtils.getFont(Font.FACE_MONOSPACE,Font.STYLE_BOLD,Font.SIZE_LARGE);
			ScoreInputFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_LARGE);
#else
			myFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_MEDIUM);
			ScoreFont=aUtils.getFont(Font.FACE_MONOSPACE,Font.STYLE_BOLD,Font.SIZE_MEDIUM);
			ScoreInputFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_LARGE);
#endif
		}
#ifndef s40
		else
		{
			myFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_LARGE);
			ScoreFont=aUtils.getFont(Font.FACE_MONOSPACE,Font.STYLE_BOLD,Font.SIZE_LARGE);
			ScoreInputFont=aUtils.getFont(Font.FACE_SYSTEM,Font.STYLE_BOLD,Font.SIZE_LARGE);
		}
#endif s40
	}
#endif gx10 || s30
*/
#ifdef GAME_USE_TRANSITIONS
	//init transition stuff
	for (i=0;i < transEnd / 2;i++)
	{
		lastTransitions.append(-1);
	}

	for (i=0;i < transEnd;i++)
	{
		if ((_nextInt() & 1) != 0)
			lastTransMode.append(_TRUE_);
		else
			lastTransMode.append(_FALSE_);
	}
#endif
	//update loading screen
	updateLoading(0,"[init Menu]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

	// for displaying the quit while initialising the game (doja / midp1)
	MenuCommandName=INIT_QUIT_TEXT;
#ifndef USE_COMMANDS
#ifdef INIT_QUIT_IMAGE
	// for displaying the quit while initialising the game (midp2)
	if(initQuitImage == NULL)
		initQuitImage = PUTILS->fetchImage(String(INIT_QUIT_IMAGE));
#endif INIT_QUIT_IMAGE
#endif USE_COMMANDS

#ifdef USE_COMMANDS
	//add and remove commands
		//handleCommands(APPLICATION_INIT);
#endif USE_COMMANDS

#ifndef doja || FULLCANVAS
	//command stuff
//		setCommandListener(this);
#endif

	//update loading screen
	updateLoading(5,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
	//read config if available
	isConfigured=readConfig();
#ifdef debug
	if (isConfigured == _TRUE_)
		myDebug->add(0,"Main::doInit(): Config read successful!");
#endif
	//update loading screen
	updateLoading(10,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifndef soundapi/none
	//init sound
	if(mySound != NULL)
		mySound->create(this, 3 + myGame->MaxSounds);

#ifdef GAME_SET_VOLUME
	//set a standard volume
	mySound->setVolume(GAME_SET_VOLUME);
#endif
#ifdef GAME_SET_VOLUME_MED
	//set medium volume if volume is changeable in the menu
	mySound->setVolume(GAME_SET_VOLUME_MED);
#endif
	//if mute is configured mute the sound
#ifdef GAME_SET_VOLUME_MED
	if (isConfigured == _TRUE_) 
	{
		mySound->setVolume(soundVolume);
		if ( soundVolume == 0) 
		{
			mySound->mute(true);
		}
	} 
	else 
	{
		soundVolume = GAME_SET_VOLUME_MED;
	}
#else
	if (isConfigured == _TRUE_ && isSoundMuted == _TRUE_) 
	{
		mySound->mute(true);
	}
#endif
	//update loading screen
	updateLoading(15,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifdef INIT_JINGLE
	//only load jingle if not muted
#ifdef GAME_SET_VOLUME_MED
	if (isConfigured == _FALSE_ || (isConfigured == _TRUE_ && soundVolume > 0))
	{
#else
	if (isConfigured == _FALSE_ || (isConfigured == _TRUE_ && isSoundMuted == _FALSE_))
	{
#endif GAME_SET_VOLUME_MED
		//only load and play the jingle if it is defined
		DelightJingle = mySound->add(INIT_JINGLE);

		//play the jingle
		mySound->play(DelightJingle,1);
	}
#endif INIT_JINGLE
#endif soundapi/none

	//update loading screen
	updateLoading((myGame->MainPercentage * 20) / 100,"[init Device]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifndef deviceapi/none
	//needed for vibration and light
/*
	myDevice=new aDevice(myDisplay);
#ifdef GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	//if mute is configured mute the sound
	if (isConfigured == _TRUE_ && isVibrationOff == _TRUE_)
#endif
		myDevice.setStill(true);

	//turn on the light if supported
	myDevice.setLight(true);
	*/
#endif !deviceapi/none
	//update loading screen
	updateLoading((myGame->MainPercentage * 25) / 100,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifdef debug
#ifndef doja
	//aDebug.add(1,"Main::doInit(): ScreenWidth:" + ScreenWidth + " ScreenHeight:" + ScreenHeight + " isDoubleBuffered:" + isDoubleBuffered());
#endif
#endif
	//update loading screen
	updateLoading((myGame->MainPercentage * 30) / 100,"[reading Scores]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

#ifdef MENU_DIFFICULT_LEVELS
		// generate array for different levels
		//startEntries = new byte[MENU_DIFFICULT_LEVELS + 3];
		for (i = 0; i < (MENU_DIFFICULT_LEVELS + 3); i++) 
		{
			startEntries.append((byte) (i - 1));
		}
		startEntries[0] = -1;							// first entry is ' - 1' per definition (needed for correct function of some methods)
		startEntries[startEntries.size() - 2] = APPLICATION_BACK2MAINMENU;	// used for returning to previous menu
		startEntries[startEntries.size() - 1] = -1;		// last entry is ' - 1' per definition (needed for correct function of some methods)
#endif MENU_DIFFICULT_LEVELS

	//needed for HighScore handling
#ifdef SCORE_ONE_PER_MODE
	//myModeScores=new aScore[MENU_DIFFICULT_LEVELS];
		for ( int i = 0; i < MENU_DIFFICULT_LEVELS; i++ ) {
			aScore score;
			char str[10];
			String szBuf = STORE_SCORES_NAME;
			szBuf += _itoa ( i, str, 10 );
			score.aScoreCreate ( (AEEApplet*)this, (char*)szBuf.toCharArray(), SCORE_NUMBER);
			myModeScores.append(score);
		}
	myScores=&myModeScores[0];
#else
	myScores->aScoreCreate(this, STORE_SCORES_NAME,SCORE_NUMBER);
#endif
	//update loading screen
	updateLoading((myGame->MainPercentage * 40) / 100,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

#ifdef SCORE_ONE_PER_MODE
	for (i=0;i < MENU_DIFFICULT_LEVELS;i++)
	{
		//init Scores if first time
		if (myModeScores[i].numScores() == 0)
		{
			//update loading screen
			updateLoading((myGame->MainPercentage * 50) / 100,"[init Scores]");
			//request a repaint
			paintInit();
			IDISPLAY_UpdateEx(m_pIDisplay, false);
			myScores=&myModeScores[i];
			myGame->initScores(SCORE_NUMBER
#ifdef SCORE_INIT_USE_MODE
				,i
#endif
				);
		}
	}
#else
	//init Scores if first time
	if (myScores->numScores() == 0)
	{
		//update loading screen
		updateLoading((myGame->MainPercentage * 50) / 100,"");
		//request a repaint
		paintInit();
		IDISPLAY_UpdateEx(m_pIDisplay, false);
		PGAME->initScores(SCORE_NUMBER);
	}
#endif

#ifdef GAME_USE_GRAPHICAL_FONT
	updateLoading((myGame->MainPercentage * 55) / 100,"[loading Font]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

	//load and activate the graphical font
	PUTILS->loadFont(GAME_USE_GRAPHICAL_FONT);
	PUTILS->fontActive(true);

#ifdef GAME_USE_GRAPHICAL_FONT_WITH_BACKCOLOR
	PUTILS->fontUseBackcolor(true);
#endif
#endif

#ifndef USE_COMMANDS
	mySmallFontSpaceWidth = PUTILS->charWidth(NULL,' ');
	mySmallFontHeight = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
#endif

	//update loading screen
	updateLoading((myGame->MainPercentage * 60) / 100,"[loading Language]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifndef GAME_USE_TEXT_DEFINES

	//get our Text
#ifdef GAME_USE_BTEXT_CLASS
	myText->create(this, "/t");
#else
	myText->initChar(this, "/t");
#endif
  isParseText=1;
	myText->cleanit = true;
	myText->lastPos = 0;
	//update loading screen
	updateLoading((myGame->MainPercentage * 70) / 100,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#endif
	//update loading screen
	updateLoading((myGame->MainPercentage * 80) / 100,"[loading Images]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

#ifdef MENU_IMAGE
	//load menu background image
	if(MenuImage == NULL)
	{
		MenuImage=PUTILS->fetchImage(String(MENU_IMAGE));
##if BREWVERSION > 0x1
		//MenuImage->m_pBitmap = PUTILS->createImageCompatibleBitmap(MenuImage->m_pImage, MenuImage->m_pBitmap);
##endif
	}
#ifndef SCORE_IS_EXTERNAL
	String _szBuf1;
	String _szBuf2;
#ifdef SCORE_IMAGE
	//use same image for highscore?
	_szBuf1 = MENU_IMAGE;
	_szBuf2 = SCORE_IMAGE;
	if (_szBuf1.equals(_szBuf2) == true)
	{
		ScoreImage=MenuImage;
	}
#endif
#endif
#endif
	//update loading screen
	updateLoading((myGame->MainPercentage * 85) / 100,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifdef PLAY4PRIZES
	p4p_pressCount = 0;
	skipActions = false,
	 p4p_leftSoft = false;
	 p4p_rightSoft = false;
	 p4p_isInForPrizeGame = false;
	 p4p_isInInputMode = false;
	 seedCount = 2;
  #ifdef MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE
	lastIndex = 0;
	editText = "";
	clearName = true;
	textLength = MAIN_VALUE_NUM_SMS_MAX_LENGTH;
  #else
    editCount = 0;
	editName = "";
	editCursor = TEXT_CONST_SMS_CURSOR;
	lastKey = 0;
	lastIndex = 0;
	clearName = true;
	textLength = MAIN_VALUE_NUM_SMS_MAX_LENGTH;
	int _editKeyMap[] ={MAIN_ARRAY_MISC_SMS_KEY_MAP	};
	for(int i = 0; i < (sizeof(_editKeyMap)/sizeof(int)); i++)
		editKeyMap.append(_editKeyMap[i]);
	#endif
#endif
#ifdef BRAND_IMAGE
	//load brand logo image
	if(BrandImage == NULL)
		BrandImage=PUTILS->fetchImage(String(BRAND_IMAGE));
#ifndef SCORE_IS_EXTERNAL
#ifdef SCORE_IMAGE
	//use same image for highscore?
	_szBuf1 = BRAND_IMAGE;
	_szBuf2 = SCORE_IMAGE;
	if (_szBuf1.equals(_szBuf2) == true)
	{
		ScoreImage=BrandImage;
	}
#endif
#endif
#endif
	//update loading screen
	updateLoading(myGame->MainPercentage,"");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);
#ifndef SCORE_IS_EXTERNAL
#ifdef SCORE_IMAGE
	//load score image
	if (ScoreImage == NULL)
	{
		ScoreImage=PUTILS->fetchImage(String(SCORE_IMAGE));
	}
#endif
#endif

#ifndef soundapi/none
#ifdef MENU_MUSIC || SCORE_MUSIC
	//update loading screen
	updateLoading((myGame->MainPercentage * 90) / 100,"[loading Music]");
	//request a repaint
	paintInit();
	IDISPLAY_UpdateEx(m_pIDisplay, false);

#ifdef MENU_MUSIC
	MenuMusic=mySound->add(MENU_MUSIC);
#endif

#ifdef SCORE_MUSIC
	ScoreMusic=mySound->add(SCORE_MUSIC);
#endif
#endif
#endif soundapi/none

#ifdef GAME_USE_GALLERY || GAME_USE_IMAGESERIES
	// detect number of images
	numImages = PUTILS->detectNumImages(GAME_IMAGE_PREFIX, GAME_IMAGE_START, GAME_IMAGE_SUFFIX);
#endif GAME_USE_GALLERY

	//do the game initialisation
	myGame->init();

#ifdef GAME_USE_GALLERY
	// set initial values for gallery
	galleryIndex = -1;
	cycled = 0;
#endif GAME_USE_GALLERY

#ifndef USE_COMMANDS
#ifdef GAME_BUTTON_IMAGE
	// if an image is used as the menubutton we need some infos
	if(menuButton == NULL)
		menuButton = PUTILS->fetchImage(String(GAME_BUTTON_IMAGE));
#endif GAME_BUTTON_IMAGE
#endif USE_COMMANDS

	//set a timer
	if (INIT_WAIT_TIME > 0)
	{
		DelightWait = ISHELL_GetTimeMS(m_pIShell);
	}

#ifndef soundapi/none
#ifdef MENU_MUSIC || SCORE_MUSIC
		// to be shure menu sound will be started
		restartMusic = _TRUE_;
#endif
#endif

	isInitialised=_TRUE_;
	m_bRun = true;
}

void aMain::processApplicationState(int state) 
{
#ifdef debug
	myDebug->add(1, "Main::processApplicationState");
#endif

	isEnterGame = _FALSE_;	// enter the game (resume)
	isStartGame = _FALSE_;	// (re)start the game
	isReturn	= _FALSE_;	// do not set the new game state
	_BOOLEAN_ doStart = _FALSE_;

	if (m_iGameState == state
#ifdef PLAY4PRIZES
		|| (m_iGameState == APPLICATION_P4P_PLAY && state == APPLICATION_MAINMENU )
#endif
		) {
		// stop
		return;
	}

	if ((BackGameState != m_iGameState) && (state != APPLICATION_SOUND) && (state != APPLICATION_VIBRA)) {
		BackGameState = m_iGameState;
		oldMenuItem = currentMenuItem;
	}

	if (m_iGameState > APPLICATION_MAIN_MAX && state == APPLICATION_MAINMENU) 
	{
		currentMenuItem = oldMenuItem;
	}
	else if (m_iGameState > APPLICATION_RESUME && state == APPLICATION_MAINMENU && isInGame == _FALSE_) {
		// there is no "resume" menu entry
		currentMenuItem = 2;
	}
#ifdef PLAY4PRIZES
	if(state == APPLICATION_P4P_PLAY){
		fpClient->notifyModule(MODULE_NOTIFY_START_MAIN, 0);
		//GameState = APPLICATION_P4P_PLAY;
#ifndef soundapi/none
		//stop music
		stopSound();
#endif soundapi/none
		return;
	}
	if(state == APPLICATION_P4P_HELP){
		fpClient->notifyModule(MODULE_NOTIFY_START_HELP, 0);
		//GameState = APPLICATION_P4P_PLAY;

#ifndef soundapi/none
		// stop music
		stopSound();
#endif soundapi/none

		return;
	}
#endif
//#ifdef MENU_DIFFICULT_LEVELS
	if (state == APPLICATION_GAME && m_iGameState == APPLICATION_MAINMENU) 
	{
#ifdef PLAY4PRIZES
			isEnterGame = _TRUE_;
			isStartGame = _TRUE_;
#else
	#ifdef MENU_DIFFICULT_LEVELS
			state = APPLICATION_STARTMENU;
			currentMenuItem = 1;
	#else !MENU_DIFFICULT_LEVELS
			isEnterGame = _TRUE_;
			isStartGame = _TRUE_;
	#endif MENU_DIFFICULT_LEVELS

#endif

		// we're in the submenue for starting the game now...
		//m_iGameState = APPLICATION_STARTMENU;
		//currentMenuItem = 1;
		// return without setting the gamestate

		//myGame->StopSplash(false, false);
		//myGame->buildLevelSelect();

	//	return;
	} 
#ifdef MENU_DIFFICULT_LEVELS
	else if (m_iGameState == APPLICATION_STARTMENU) 
	{
		if (state == APPLICATION_BACK2MAINMENU) 
		{
			state = APPLICATION_MAINMENU;
 			currentMenuItem = 2;
		} 
		else 
		{
			state = APPLICATION_GAME;
			gameStartMode = currentMenuItem - 1;
		}
	}
#endif MENU_DIFFICULT_LEVELS

#ifndef soundapi/none
	// turn sound on / off or set soundVolume
	if (state == APPLICATION_SOUND) 
	{
#ifdef GAME_SET_VOLUME_MED
#ifdef MENU_MUSIC
		// per default restart menu music (we ARE in the main menu)
		restartMusic = _TRUE_;
#endif
		switch (soundVolume) 
		{
			case 0:
				soundVolume = GAME_SET_VOLUME_LOW;
				break;
			case GAME_SET_VOLUME_LOW:
				soundVolume = GAME_SET_VOLUME_MED;
				break;
			case GAME_SET_VOLUME_MED:
				soundVolume = GAME_SET_VOLUME_HIGH;
				break;
			case GAME_SET_VOLUME_HIGH:
				soundVolume = 0;
#ifdef MENU_MUSIC
				// don't restart menu music (we ARE in the main menu)
				restartMusic = _FALSE_;
#endif
				break;
			default:
				soundVolume = GAME_SET_VOLUME_MED;
		}
		// set the desired volume
		mySound->setVolume(soundVolume);

		if (soundVolume > 0) 
		{
			mySound->mute(false);
		} else {
			mySound->mute(true);
		}
#else GAME_SET_VOLUME_MED
		if (isSoundMuted == _TRUE_) 
		{
			isSoundMuted = _FALSE_;
			mySound->mute(false);
#ifdef GAME_SET_VOLUME
			mySound->setVolume(GAME_SET_VOLUME);
#endif
#ifdef MENU_MUSIC
			restartMusic = _TRUE_;
#endif
		} 
		else 
		{
#ifdef GAME_SET_VOLUME
			mySound->setVolume(0);
#endif
			isSoundMuted = _TRUE_;
			mySound->mute(true);
#ifdef MENU_MUSIC
			stopSound();
#endif
		}
#endif GAME_SET_VOLUME_MED
		// save new preferences
		writeConfig();

#ifndef GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL
		// read the new changed menu string
		MenuText = getMenuItemText(menuEntries[currentMenuItem]);
#endif !GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL

		// done here
		return;
	}
#endif soundapi/none

#ifndef deviceapi/none
#ifdef GAME_USES_VIBRA && DEVICE_HAS_VIBRA
	// turn vibration on / off
	if (state == APPLICATION_VIBRA) {
		if (isVibrationOff == _TRUE_) {
			isVibrationOff = _FALSE_;
			myDevice.setStill(false);
		} else {
			isVibrationOff = _TRUE_;
			myDevice.setStill(true);
		}
		// save new preferences
		writeConfig();

#ifndef GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL
		// read the new changed menu string
// 			updateMenuString();
#endif !GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL

		// done here
		return;
	}
#endif GAME_USES_VIBRA && DEVICE_HAS_VIBRA
#endif deviceapi/none

#ifdef USE_TILT
//	if (state == APPLICATION_TILT) {
//		if (isTiltOff == _TRUE_) {
//			isTiltOff = _FALSE_;
//		} else {
//			isTiltOff = _TRUE_;
//		}
//		// save new preferences
//		writeConfig();

#ifndef GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL
		// read the new changed menu string
// 			updateMenuString();
#endif !GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL

		// done here
//		return;
//	}
#endif

#ifdef GAME_USE_TRANSITIONS
	// with transitions it looks nicer
	if (state != APPLICATION_QUIT && state != APPLICATION_GAME
#ifndef GAME_NO_HIGHSCORE
		 && state != APPLICATION_INPUTSCORE
#endif GAME_NO_HIGHSCORE
	) {
#ifndef GAME_NO_BRAND_SCREEN
		if (state == APPLICATION_BRAND && m_iGameState == APPLICATION_INIT)
			initTransition(GAME_TRANSITION_MODE_BLEND);
		else if (state == APPLICATION_MAINMENU && m_iGameState == APPLICATION_BRAND)
			initTransition(GAME_TRANSITION_MODE_SCROLL);
		else
#endif GAME_NO_BRAND_SCREEN
			initTransition(GAME_TRANSITION_MODE_ANY);
	}
#endif GAME_USE_TRANSITIONS

#ifndef USE_COMMANDS
	// language may have changed calculate width
	mySmallFontMenuWidth = PUTILS->stringWidth(NULL, MenuCommandName);
#endif

	// ... but not to the same state
	if (m_iGameState == state)
		return;

	//  ***  the following code WILL switch the GameState...  ***

#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// reset menu command time
	MenuCommandTime = 0;
	// if used, menubutton must be drawn completely now for several gamestates
	menuButtonOffset = 0;
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS

	// we are setting a new gamestate
	isNewGameState = _TRUE_;

	// usually the menu button is needed
	MenuCommandName = TEXT_CONST_MENU;

// TODO nicer (wrong place here?)
#ifdef USE_COMMANDS
	// add and remove commands
// 		handleCommands(state);
#endif USE_COMMANDS

#ifndef FULLCANVAS
#ifndef USE_COMMANDS
	// do we have to use commands because the right softkey keycode is unknown?
// 		if (aKey.availableSoftRight() == false)
// 			handleCommands(state);
#endif
#endif

	// quit the game
	if (state == APPLICATION_QUIT) {
#ifndef soundapi/none
		// stop music
		stopSound();
#endif
		// stop directly if transitions are not supported
#ifdef GAME_USE_TRANSITIONS
		if (transImage == NULL)
			m_bRun = _FALSE_;
			return;
		else
			initTransition(GAME_TRANSITION_MODE_BLEND);  // TODO mu ordentlich
#endif
	}

	// be sure that the menu gets fully repainted
	else if (state == APPLICATION_MAINMENU) 
	{
		preMenu();
	}

	// resume the paused game
	else if (state == APPLICATION_RESUME) 
	{
#ifdef SCORE_ONE_PER_MODE
		myScores = &myModeScores[currentGameMode];
#endif
		// add menu command / label
#ifdef USE_COMMANDS //|| doja
#ifndef FULLCANVAS
		//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif
		// tell game to resume
		myGame->resumeGame();
#ifdef PLAY4PRIZES
		if (p4p_isInForPrizeGame){
			fpClient->notifyModule(MODULE_NOTIFY_RESUMED, 0);
			//fpClient.resumeGame();
		}
#endif
#ifdef GAME_USE_TRANSITIONS
		initTransition(GAME_TRANSITION_MODE_ANY);
#endif
		// TODO correct placement here?
		isGamePaused = _FALSE_;

		// we want to "start" the game now
		state = APPLICATION_GAME;
	}

#ifndef GAME_NO_HIGHSCORE
	// force full rebuild of scores
	else if (state == APPLICATION_HIGHSCORE)
	{
#ifdef SCORE_ONE_PER_MODE
		currentScoreMode = currentGameMode;
		myScores = &myModeScores[currentScoreMode];
#endif
#ifdef SCORE_MUSIC || MENU_MUSIC
		// only start score music if not coming from score input mode
		if (m_iGameState != APPLICATION_INPUTSCORE
#ifndef doja
#ifdef GAME_HISCORE_UPLOAD
			 && m_iGameState != APPLICATION_SCOREUPLOAD
#endif GAME_HISCORE_UPLOAD
#endif !doja
		)
#ifndef SCORE_MUSIC
			if (m_iGameState != APPLICATION_MAINMENU)
#endif !SCORE_MUSIC
				restartMusic = _TRUE_;
#endif SCORE_MUSIC || MENU_MUSIC
		ScoreBuf.removeAll();
		//ScoreBuf.destruct();

		preScore();
	}
	// switch to input score screen
	else if (state == APPLICATION_INPUTSCORE) 
	{
		preScoreInput();
	}
#endif GAME_NO_HIGHSCORE

#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	// switch to the language selection
	else if (state == APPLICATION_LANGUAGE) 
	{
		// TODO this is a hotfix: language - file is not reachable - why?
		if (myText->getDomain().length() == 0) 
		{
			MenuCommandName = "ok";
#ifndef USE_COMMANDS
			// calculate width
			mySmallFontMenuWidth = PUTILS->stringWidth(NULL, MenuCommandName);
#endif
		}
		preLanguage();
	}
#endif !GAME_NO_LANGUAGE_SELECTION_SCREEN

#ifdef GAME_USE_GALLERY
	else if (state == APPLICATION_GALLERY) 
	{
		preGallery();
	}
#endif
	else if (state == APPLICATION_HELP) 
	{
// TODO
	} 
	else if (state == APPLICATION_GAME) 
	{
// TODO nicht doppelt abfragen
		doStart = _TRUE_;
	}

#ifndef GAME_NO_BRAND_SCREEN
	else if (state == APPLICATION_BRAND) 
	{
	}
#endif
#ifdef GAME_HISCORE_UPLOAD
	else if (state == APPLICATION_SCOREUPLOAD) 
	{
	}
#endif
	// Main does not know what to do - ask Game ;)
	else 
	{
		// IMPORTANT: do debug error handling in Game.processApplicationState(state)
		if (m_iGameState == APPLICATION_MAINMENU)
			oldMenuItem = currentMenuItem;
		if ((state = myGame->processApplicationState(m_iGameState, state)) == APPLICATION_GAME) 
		{
			doStart = _TRUE_;
		}
#ifdef MARTIN
		// coming from a menu in game, set the state back to game
		if((state = myGame->processApplicationState(m_iGameState, state)) == APPLICATION_RESUME) 
		{
			state = APPLICATION_GAME;
		}
#endif MARTIN
	}
	//adi------------- remember previous state
		//skip for sound and vibra
	if ((BackGameState != m_iGameState) && (state != APPLICATION_SOUND) && (state != APPLICATION_VIBRA)) {
		BackGameState = m_iGameState;
		oldMenuItem = currentMenuItem;
	//			System.out.println("PAMIETAM"+ BackGameState);
	}
	//adi--------

	// set the state
	m_iGameState = state;

	// force a full paint after gamestate switching
#ifdef MARTIN
	if(state != APPLICATION_GAME)
#endif MARTIN
	doFullPaint = true;


	// switch to the game
	if (state == APPLICATION_GAME) 
	{
		postMenu();

		FrameTime = myGame->FrameTime;
// TODO weg hier!!!
#ifndef soundapi/none
#ifdef SCORE_MUSIC || MENU_MUSIC
		// stop menu music
		stopSound();
#endif
#endif
		if (doStart == _TRUE_) 
		{
			startGame();
		}
	} 
	else 
	{
		// set default frametime except for gamestate 'GAME'
#ifdef GAME_TEST_FRAMETIME
		FrameTime = GAME_TEST_FRAMETIME;
#else
		FrameTime = 80;// =  100;
#endif
	}
}

boolean aMain::readConfig() 
{
#ifndef MEINS
	char str[10];
	config * sconf = NULL;
	sconf = ( config * )PUTILS->readData ( STORE_CONFIG_NAME );
	if ( sconf == NULL )
		return _FALSE_;
	_itoa ( sconf->valid, str, 10 );
	//the config is only valid if the first byte is not 0
	if ( sconf->valid != 0 ) 
	{
		//read config values
		currentLanguage = sconf->currentLanguage;
		_itoa ( currentLanguage, str, 10 );
#ifdef GAME_SET_VOLUME_MED
		soundVolume = sconf->soundVolume;
#else
		isSoundMuted = sconf->isSoundMuted;
#endif
#ifdef GAME_USES_VIBRA
		isVibrationOff = sconf->isVibrationOff;
#endif
#ifdef USE_TILT
		isTiltOff = sconf->isTiltOff;
#endif

#ifndef USE_TILT
		//isTiltOff = _TRUE_;
#endif
		ScoreLastName = sconf->ScoreLastName;
#ifdef GAME_USE_GALLERY
		galleryFlags = sconf->galleryFlags;
#endif
#ifdef GAME_STORE_ADDITIONAL_DATA
		PGAME->readData(sconf);
#endif GAME_STORE_ADDITIONAL_DATA
 FREE(sconf);
 sconf=NULL;
		return _TRUE_;
	}
#endif MEINS
 FREE(sconf);
 sconf=NULL;
	return _FALSE_;
}

void aMain::writeConfig() 
{
#ifndef MEINS
	config sconf;
	sconf.valid = 1;
	sconf.currentLanguage = currentLanguage;
#ifdef GAME_SET_VOLUME_MED
	sconf.soundVolume = soundVolume;
#else
	sconf.isSoundMuted = isSoundMuted;
#endif
#ifdef GAME_USES_VIBRA
	sconf.isVibrationOff = isVibrationOff;
#endif
#ifdef USE_TILT
	sconf.isTiltOff = isTiltOff;
#endif
	STRCPY ( sconf.ScoreLastName, ScoreLastName.toCharArray() );
#ifdef GAME_USE_GALLERY
	sconf.galleryFlags = galleryFlags;
#endif
#ifdef GAME_STORE_ADDITIONAL_DATA
			PGAME->writeData(&sconf);
#endif GAME_STORE_ADDITIONAL_DATA
	
	byte * baos;
	baos = ( byte* ) &sconf;

	PUTILS->writeData ( STORE_CONFIG_NAME, baos, ( sizeof ( sconf ) ) ); 
#endif MEINS
}

//updating loading percentage display
void aMain::updateLoading(int percent, String txt)
{
	//ignore if less than current percentage
	if (percent <= initPercentage)
		return;

	//store data
	if (percent > 100)
		initPercentage=100;
	else
		initPercentage=percent;

#ifdef debug
	if (txt.length() != 0)
		initString=txt;
#endif
	
}

void aMain::startGame()
{
#ifdef NOKIA_6236I
#ifdef MENU_MUSIC
	if(mySound != NULL)
	{
		if(mySound->m_pSoundPlayer != NULL)
		{
			ISOUNDPLAYER_Stop(mySound->m_pSoundPlayer);
			ISOUNDPLAYER_RegisterNotify(mySound->m_pSoundPlayer, NULL, NULL);
			ISOUNDPLAYER_Release(mySound->m_pSoundPlayer);
			mySound->m_pSoundPlayer = NULL;
		}
		mySound->m_iLoop = 0;
		mySound->soundID = -1;
	}
#endif
#endif
#ifdef SCORE_ONE_PER_MODE
	myScores=&myModeScores[gameStartMode];
#endif
	//init a new game
#ifdef PLAY4PRIZES
	if(p4p_isInForPrizeGame)
		PGAME->initP4PGame(p4p_seed, p4p_data);
	else
#endif
	PGAME->initGame(gameStartMode);

	//set ingame to true and pause to false
	isGamePaused=_FALSE_;
	isInGame=_TRUE_;
#ifdef MENU_MUSIC
	stopSound();
	stopSound();
#endif
}

// pauses the game
int aMain::pauseGame()
{
#ifdef PLAY4PRIZES
	if (p4p_isInForPrizeGame){
		fpClient->notifyModule(MODULE_NOTIFY_PAUSED, 0);
		//fpClient.pauseGame();
	}
#endif
	// if game is not paused pause it now
	if (isGamePaused == _FALSE_) 
	{
		isGamePaused = _TRUE_;

		// fix an error appearing on s60 and whatever else - only pause game after painting is done
		if (isDrawing == _TRUE_) 
		{
			pauseGameNow = _TRUE_;
		} 
		else 
		{
			int state = myGame->pauseGame();
			if (state != -1) {
				processApplicationState(state);
				return state;
			}
		}
	}

	// set menu to resume
	currentMenuItem = 1;
	// switch over to main menu (might be called more than one time - who cares?!)
	processApplicationState(APPLICATION_MAINMENU);

	return -1;
}

void aMain::endGame(boolean showScores, int playedScore
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
	, _BOOLEAN_ resumable
#endif
#ifdef GAME_SET_STATE_AFTER_ENDGAME
	, int newApplicationState
#endif
	)
{
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
		if (resumable == _FALSE_) 
		{
#endif
			isInGame = _FALSE_;
			currentMenuItem = 2;
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
		} 
		else 
		{
			currentMenuItem = 1;
		}
#endif

	if (showScores)
	{
		if (myScores->checkPos(playedScore) == 0){
			processApplicationState(APPLICATION_HIGHSCORE);
			//adi--- always back to mainmenu from here
			BackGameState = APPLICATION_MAINMENU;
			//adi--------
		} else {
				// reset score input vars
				ScoreInputPos = 0;
				ScoreInputRange = "";
				ScoreInputEnd = _FALSE_;
				ScoreInputInitEnd = _FALSE_;

				// store score infos
				ScorePlayed = playedScore;

				// change gamestate
				processApplicationState(APPLICATION_INPUTSCORE);
				//adi---				//adi--- always back to mainmenu from here
				BackGameState = APPLICATION_MAINMENU;
				//adi--------
			}
	}
	else
	{
			preMenu();
#ifdef GAME_SET_STATE_AFTER_ENDGAME
	        processApplicationState(newApplicationState);
#else
			processApplicationState(APPLICATION_MAINMENU);
#endif
	}
}

void aMain::keyGame(int keyCode)
{
	// use right softkey to go back to menu if nokia device
	if (PKEY->isSoftRight(keyCode) || PKEY->isClear(keyCode)) 
	{
		stopSound();
		pauseGame();
		return;
	}
	// let the game process the keys
	PGAME->key(keyCode);
}

void aMain::preInit() 
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif
}

void aMain::postInit() 
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
}

void aMain::changeGameState(int state)
{
	/*
	//switching to the same mode?
	if (m_iGameState == state)
		return;

#ifdef GAME_USE_TRANSITIONS
	if (state != SCOREINPUT && state != GAME)
	{
#ifndef GAME_NO_BRAND_SCREEN
		if (state == BRAND && m_iGameState == INIT)
			initTransition(transModeBlend);
		else if (state == MENU && m_iGameState == BRAND)
			initTransition(transModeScroll);
		else
#endif
		if (state == QUIT)
			initTransition(transModeBlend);
		else
			initTransition();
	}
#endif GAME_USE_TRANSITIONS

	//setting a new gamestate
	isNewGameState=_TRUE_;

#ifdef debug
	//aDebug.add(1,"Main::changeGameState(" + state +")");
#endif
	if (state == GAME || state == SCORE || state == HELP || state == LANGUAGE
#ifdef GAME_USE_GALLERY
		|| state == GALLERY
#endif GAME_USE_GALLERY
	) {
#ifndef GAME_USE_TEXT_DEFINES
		if (state == LANGUAGE && myText->getDomain().length() == 0) 
		{
			MenuCommandName = "ok";
		} 
		else 
		{
			MenuCommandName = myText->get("m");
		}
#else
		MenuCommandName = TEXT_CONST_MENU;
#endif GAME_USE_TEXT_DEFINES
#ifndef USE_COMMANDS
#ifdef GAME_BUTTON_IMAGE
		// menubutton must be drawn completely
		menuButtonPos = -1;
#endif GAME_BUTTON_IMAGE
#endif USE_COMMANDS
	}

	//language may have changed...
	if (state == GAME)
	{
#ifndef soundapi/none
#ifdef SCORE_MUSIC || MENU_MUSIC
		//stop menu music
		if (mySound != NULL)
			mySound->stop(0);
#endif
#endif
#ifndef USE_COMMANDS
		//TODO?
		//mySmallFontMenuWidth = aUtils.stringWidth(mySmallFont, MenuCommandName);
		//myCommandPosX = ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth;
		//myCommandPosY = ScreenHeight - mySmallFontHeight;
		//
#endif
	}

	//language may have changed...
	else if (state == SCOREINPUT)
	{
#ifndef GAME_USE_TEXT_DEFINES
		MenuCommandOKName=myText->get("mok");
		MenuCommandCancelName=myText->get("mca");
#else
		MenuCommandOKName=TEXT_CONST_MOK;
		MenuCommandCancelName=TEXT_CONST_MCA;
#endif GAME_USE_TEXT_DEFINES
#ifndef USE_COMMANDS
//TODO?
//		mySmallFontMenuOKWidth = aUtils.stringWidth(mySmallFont, MenuCommandOKName);
//		mySmallFontMenuCancelWidth = aUtils.stringWidth(mySmallFont, MenuCommandCancelName);
//		
#endif USE_COMMANDS
	}

#ifdef SCORE_ONE_PER_MODE
	else if (state == SCORE)
	{
		currentScoreMode=currentGameMode;
		myScores=myModeScores[currentScoreMode];
	}
#endif SCORE_ONE_PER_MODE

#ifdef GAME_USE_GALLERY
	else if (state == GALLERY)
	{
		// by default don't use the galleryYOffset => previews won't be used
		galleryYOffset = 0;

		int prevHeight, imHeight;
		prevHeight = imHeight = galleryImageHeight = 0;
#ifdef GALLERY_USES_PREVIEWS
		galleryPreviewHeight = 0;
		// get galleryPreviews if not already TODO cache previews if possible/necessary
		if (galleryPreview.size() == 0) 
		{
#ifdef GAME_SINGLE_PREVIEWS
			// initialize array
			galleryPreview = new Image[numImages];
			for(int i=0; i<numImages;i++)
			{
#ifndef USE_RESOURCE_FILE_BMPS
				IImage* _pImage;
				galleryPreview.append(_pImage);
#else
				void* _pImage;
				AEEImageInfo _IInfo;
				boolean _bRealloc;
				galleryPreview.append(_pImage);
				galleryPreviewInfo.append(_IInfo);
				galleryPreviewRealloc.append(_brealloc);
#endif
			}
			// try to get all images
			char _cBuf[10];
			String _szBuf = GAME_PREVIEWS_PREFIX;
			for(int i = GAME_IMAGE_START; i < (GAME_IMAGE_START + numImages); i++) 
			{
				_szBuf += _itoa(i, _cBuf, 10);
				_szBuf += GAME_PREVIEWS_SUFFIX;
				if(galleryPreview[i - GAME_IMAGE_START] == NULL)
					galleryPreview[i - GAME_IMAGE_START] = PUTILS->fetchImage((char*)_szBuf.toCharArray());
			}
			// did we get them? (only first image checked)
			if (galleryPreview[0] != NULL) 
			{
				// note size
#ifndef USE_RESOURCE_FILE_BMPS
				galleryPreviewHeight = PUTILS->getImageHeight(galleryPreview[0]);
				galleryPreviewWidth = PUTILS->getImageWidth(galleryPreview[0]);
#else
				galleryPreviewHeight = galleryPreviewInfo[0].cy;
				galleryPreviewWidth = galleryPreviewInfo[0].cx;
#endif
			}
#else  GAME_SINGLE_PREVIEWS
			// try to get image
			String _szBuf = GAME_PREVIEWS_PREFIX;
			_szBuf += GAME_PREVIEWS_SUFFIX;
			if(galleryPreview == NULL)
				galleryPreview = PUTILS->fetchImage((char*)_szBuf.toCharArray());
			// did we get it?
			if (galleryPreview != NULL) 
			{
				// note size
#ifndef USE_RESOURCE_FILE_BMPS
				galleryPreviewHeight = PUTILS->getImageHeight(galleryPreview);
				galleryPreviewWidth = PUTILS->getImageWidth(galleryPreview) / numImages;
#else
				galleryPreviewHeight = galleryPreviewInfo.cy;
				galleryPreviewWidth = galleryPreviewInfo.cx / numImages;
#endif
			}
#endif GAME_SINGLE_PREVIEWS
		}
		// do we have the height?
		if (galleryPreviewHeight > 0) 
		{
#ifdef GALLERY_USES_PREVIEWS_BORDER
			// calculate thickness once
			if (galleryPreviewBorder <= 0) 
			{
#ifdef GALLERY_PREVIEWS_BORDER_THICKNESS
				// get thickness of the border
				galleryPreviewBorder = GALLERY_PREVIEWS_BORDER_THICKNESS;
				// is the thickness of the border defined larger than the amount of usable colors?
				if (galleryPreviewBorder > GameColorRotation.size()) 
				{
					// if so get amount of colors
					galleryPreviewBorder = (byte) GameColorRotation.size();
				}
#else  GALLERY_PREVIEWS_BORDER_THICKNESS
				// thickness of the border is GameColorRotation.size() / 3
				galleryPreviewBorder = (byte) (GameColorRotation.size() / 3);
#endif GALLERY_PREVIEWS_BORDER_THICKNESS
				// not enough space for previews AND border?
				if ((galleryPreviewBorder * 2) > (ScreenWidth - galleryPreviewWidth * numImages)) {
					galleryPreviewBorder = (byte) ((ScreenWidth - 2 - galleryPreviewWidth * numImages) / 2);
				}
			}
			// double the thickness of the border because of 2 borders (left and right)
			prevHeight = galleryImageBorder * 2;
#endif GALLERY_USES_PREVIEWS_BORDER
			// add height of the preview image
			prevHeight += galleryPreviewHeight;
		}
#endif GALLERY_USES_PREVIEWS

		// get a gallery image if not already
		if (galleryImage == NULL) 
		{
			char _cBuf[10];
			String _szBuf = GAME_IMAGE_PREFIX;
			_szBuf += _itoa(GAME_IMAGE_START, _cBuf, 10);
			_szBuf += GAME_IMAGE_SUFFIX;
			galleryImage = PUTILS->fetchImage(_szBuf);
		}
		// did we get it?
		if (galleryImage != NULL) 
		{
			// note size
			galleryImageHeight = PUTILS->getImageHeight(galleryImage);
			galleryImage->release();
			// (and) forget it
			delete(galleryImage);
			galleryImage = NULL;
		}

		// do we have the height?
		if (galleryImageHeight > 0) 
		{
#ifdef GALLERY_USES_IMAGE_BORDER
			// calculate thickness once
			if (galleryImageBorder <= 0) {
#ifdef GALLERY_IMAGE_BORDER_THICKNESS
				// get thickness of the border
				galleryImageBorder = GALLERY_IMAGE_BORDER_THICKNESS;
				// is the borderthickness defined larger than the amount of usable colors?
				if (galleryImageBorder > GameColorRotation.size()) 
				{
					// if so get amount of colors
					galleryImageBorder = (byte) GameColorRotation.size();
				}
#else  GALLERY_IMAGE_BORDER_THICKNESS
				// thickness of the border is GameColorRotation.size() / 2
				galleryImageBorder = (byte) (GameColorRotation.size() / 2);
#endif GALLERY_IMAGE_BORDER_THICKNESS
				// not enough space for image AND border?
				if ((galleryImageBorder * 2) > (ScreenWidth - galleryImageWidth)) 
				{
					galleryImageBorder = (byte) ((ScreenWidth - galleryImageWidth - 2) / 2);
				}
				// not enough space for image AND border?
				if ((galleryImageBorder * 2) > (ScreenHeight - galleryImageHeight)) 
				{
					galleryImageBorder = (byte) ((ScreenHeight - galleryImageHeight - 2) / 2);
				}
			}
			// double the thickness of the border because of 2 borders (left and right)
			imHeight = galleryImageBorder * 2;
#endif GALLERY_USES_IMAGE_BORDER
			// add height of the preview image
			imHeight += galleryImageHeight;
		}

		// could we determine the necessary values?
		if ((imHeight + prevHeight != 0) && (ScreenHeight - imHeight - prevHeight > 0)) 
		{
			// yes, so calculate offset for the gallery (top-down: offset | image | approx. 2*offset | previews | offset)
			galleryYOffset =
				(ScreenHeight - galleryImageHeight
#ifdef GAME_USES_PREVIEWS
				- galleryPreviewHeight
#endif GAME_USES_PREVIEWS
				) / 7 * 2;	// <- nice positions...
#ifdef debug
		} 
		else if (imHeight + prevHeight == 0) 
		{
			PDEBUG->add(1,"Main::changeGameState(GALLERY)  NO preview- and imageheight could be determined!");
		} 
		else 
		{
			//PDEBUG->add(1,"Main::changeGameState(GALLERY)  too little space to show previews (height needed: " + (imHeight + prevHeight) + "  is: " + ScreenHeight + ")");
#endif debug
		}
	}
#endif GAME_USE_GALLERY

#ifdef USE_COMMANDS
	//add and remove commands
	handleCommands(state);
#endif USE_COMMANDS

#ifndef FULLCANVAS
#ifndef USE_COMMANDS
	//do we have to use commands because the right softkey keycode is unknown?
	if (myKey->availableSoftRight() == false)
	{
		handleCommands(state);
	}
#endif
#endif
	//be sure that the menu gets fully repainted
	if (state == MENU)
	{
#ifdef MENU_MUSIC
#ifndef SCORE_MUSIC
		//restart menu music when comming back from the game or going into menu after startup
		if (m_iGameState == GAME || (m_iGameState < MENU && MenuPosition == 0))
			restartMusic=_TRUE_;
#else
		if (m_iGameState == GAME || (m_iGameState < MENU && MenuPosition == 0) || m_iGameState == SCORE || m_iGameState == SCOREINPUT)
			restartMusic=_TRUE_;
#endif
#else
#ifdef SCORE_MUSIC
		//comming back from hiscore to main menu, the hiscore has to be stopped beacuse there is no menu music to play!
		mySound->stop(0);
#endif
#endif
		doFullMenuPaint=_TRUE_;
	}

	//force full rebuild of scores
	else if (state == SCORE)
	{
#ifdef SCORE_MUSIC || MENU_MUSIC
		//only start score music if not coming from score input mode
		if (m_iGameState != SCOREINPUT
#ifndef doja
#ifdef GAME_HISCORE_UPLOAD
			 && m_iGameState != SCOREUPLOAD
#endif GAME_HISCORE_UPLOAD
#endif !doja
		)
#ifndef SCORE_MUSIC
			if (m_iGameState != MENU)
#endif
				restartMusic=_TRUE_;
#endif
		ScoreBuf.remove(0, ScoreBuf.size());
		ScoreBuf.destruct();

	}

#ifdef SCORE_MUSIC || MENU_MUSIC
	if (state == SCOREINPUT)
		restartMusic=_TRUE_;
#endif

	//set the state
	m_iGameState=state;

	//force a full paint after gamestate switching
	doFullPaint=true;

	//set frametime depending on the gamestate
	if (m_iGameState == GAME)
	{
		FrameTime=PGAME->FrameTime;
	}
	else
		FrameTime=80;//=100;
		*/
}

void aMain::hideNotify()
{
	DBGPRINTF ( "hideNotify augerufen" );
	ISHELL_CancelTimer(m_pIShell, NULL, this);
#ifdef GAME_SKIP_NOTIFY
		if (skipNotify == _TRUE_)
			return;
#endif
	int state = -1;
	//request a full paint
	doFullPaint=true;

#ifdef debug
	PDEBUG->add(1,"Main::hideNotify()");
#endif
	if (m_iGameState == APPLICATION_GAME && isGamePaused == _FALSE_)
	{
		state = pauseGame();
	}

	//reset key flags
	if (myKey != NULL)
		myKey->KeyState=0;

#ifndef soundapi/none
	//stop music
	if (mySound != NULL)
	{
		restartMusic = _FALSE_;
//		mySound->mute(_TRUE_);
		mySound->stop(0);
	}
#endif
	if (state != -1)
	{
		processApplicationState(state);
	}
	DBGPRINTF ( "hideNotify augerufen ende" );
}

void aMain::showNotify()
{
	
	DBGPRINTF ( "showNotify augerufen" );
	mainLoop(this);
#ifdef GAME_SKIP_NOTIFY
	if (skipNotify == _TRUE_) 
	{
		skipNotify = _FALSE_;
		return;
	}
#endif
	int state = -1;

#ifdef debug
	PDEBUG->add(1,"Main::showNotify()");
#endif
	//request a full paint
	doFullPaint=true;
#ifdef PLAY4PRIZES
	p4p_paintBackGround = true;
#endif
#ifdef GAME_USE_TRANSITIONS
	isTransition=false;
#endif

	//it happened while playing?
	if (m_iGameState == APPLICATION_GAME)
	{
		//if game is not paused pause it now
		state = pauseGame();
	}

#ifdef SCORE_MUSIC || MENU_MUSIC
	//restart the last music here
#ifndef soundapi/none
	if(mySound != NULL)
	{
		if(!isSoundMuted)
		{
			mySound->mute(_FALSE_);
		}
	}
	restartMusic=_TRUE_;
#endif
#endif
	//reset key flags
	if (myKey != NULL)
		myKey->KeyState=0;

	if (state != -1)
	{
		processApplicationState(state);
	}
}

#ifdef GAME_USE_TRANSITIONS
#ifdef GAME_TRANSITION_MODE_SCROLL
void aMain::paintTransScroll(Image* src, int b)
{
	int x=0;
	int y=0;

	int ViewImageW = PUTILS->getImageWidth(src);
	int ViewImageH = PUTILS->getImageHeight(src);

	if (transState == 0)
		toggleTransitionMode^=1;

	if (isInvertTransition == _FALSE_ || toggleTransitionMode == 0)
	{
		if ((b&1) == 0)
				x=(ViewImageW*transScrollPos[transState])/100-ViewImageW;
		else
				x=ViewImageW-(ViewImageW*transScrollPos[transState])/100;
	}

	if (isInvertTransition == _FALSE_ || toggleTransitionMode != 0)
	{
		if ((b&2) == 0)
				y=(ViewImageH*transScrollPos[transState])/100-ViewImageH;
		else
				y=ViewImageH-(ViewImageH*transScrollPos[transState])/100;
	}

//  g.setClip(0,0,ViewImageW,ViewImageH);
//	g.drawImage(src,x,y,0);
	PUTILS->drawClippedImage(m_pGraphics, src, x, y, 0, 0, ViewImageW,ViewImageH);

	if (++transState > 20)
		isTransition=false;
}
#endif
#ifdef GAME_TRANSITION_MODE_BLEND
#define GAME_BLEND_TRANSITION_STEPS 15
void aMain::paintTransBlend(Image* src, int b)
{
	int i,j,w,f=0;
	int xo,yo,dx,dy;

	if (b < 2)
		w=ScreenHeight;
	else
		w=ScreenWidth;

	for (i=0;i < w;i+=GAME_BLEND_TRANSITION_STEPS)
	{
		//stop at end
		if ((j=transState-i/GAME_BLEND_TRANSITION_STEPS) <= 0)
			break;

		if (j > GAME_BLEND_TRANSITION_STEPS+1)
		{
			f++;
			continue;
		}
		//paint the start in one piece
		if (f != 0)
		{
			f++;

			if (b == 0)
			{
				xo = 0;
				yo = 0;
				dx = ScreenWidth;
				dy = j*f;
//				g.setClip(0,0,ScreenWidth,j*f);
			}
			else if (b == 1)
			{
				xo = 0;
				yo = ScreenHeight-i-GAME_BLEND_TRANSITION_STEPS;
				dx = ScreenWidth;
				dy = ScreenHeight;
//				g.setClip(0,ScreenHeight-i-GAME_BLEND_TRANSITION_STEPS,ScreenWidth,ScreenHeight);
			}
			else if (b == 2)
			{
				xo = 0;
				yo = 0;
				dx = j*f;
				dy = ScreenHeight;
//				g.setClip(0,0,j*f,ScreenHeight);
			}
			else
			{
				xo = ScreenWidth-i-GAME_BLEND_TRANSITION_STEPS;
				yo = 0;
				dx = ScreenWidth;
				dy = ScreenHeight;
//				g.setClip(ScreenWidth-i-GAME_BLEND_TRANSITION_STEPS,0,ScreenWidth,ScreenHeight);
			}
			PUTILS->drawClippedImage(m_pGraphics, src, 0, 0, xo, yo, dx, dy);
			f=0;
			continue;
		}

		if (b == 0)
		{
			xo = 0;
			yo = i;
			dx = ScreenWidth;
			dy = j;
//			g.setClip(0,i,ScreenWidth,j);
		}
		else if (b == 1)
		{
			xo = 0;
			yo = ScreenHeight-i-GAME_BLEND_TRANSITION_STEPS;
			dx = ScreenWidth;
			dy = j;
//			g.setClip(0,ScreenHeight-i-GAME_BLEND_TRANSITION_STEPS,ScreenWidth,j);
		}
		else if (b == 2)
		{
			xo = i;
			yo = 0;
			dx = j;
			dy = ScreenHeight;
//			g.setClip(i,0,j,ScreenHeight);
		}
		else
		{
			xo = ScreenWidth-i-GAME_BLEND_TRANSITION_STEPS;
			yo = 0;
			dx = j;
			dy = ScreenHeight;
//			g.setClip(ScreenWidth-i-GAME_BLEND_TRANSITION_STEPS,0,j,ScreenHeight);
		}
		PUTILS->drawClippedImage(m_pGraphics, src, 0, 0, xo, yo, dx, dy);
//		g.drawImage(src,0,0,0);
	}

	if (++transState > GAME_BLEND_TRANSITION_STEPS+w/GAME_BLEND_TRANSITION_STEPS)
			isTransition=false;
}
#endif GAME_TRANSITION_MODE_BLEND

void aMain::initTransition()
{
	initTransition(transModeAny);
}

void aMain::initTransition(byte transMode)
{
	int i;
	isTransition=true;
	transState=0;

#ifdef GAME_TRANSITION_MODE_SCROLL && GAME_TRANSITION_MODE_BLEND
	if (transMode == GAME_TRANSITION_MODE_ANY)
	{
#endif
		//get next transition
		for (;;)
		{
			currentTransition=(_nextInt()&255)%transEnd;

			for (i=0;i < lastTransitions.size();i++)
				if (currentTransition == lastTransitions[i])
					break;

			if (i == lastTransitions.size())
				break;
		}
#ifdef GAME_TRANSITION_MODE_SCROLL && GAME_TRANSITION_MODE_BLEND
	}
	else
	{
		currentTransition=(_nextInt()&3);
		if (transMode == transModeScroll)
			currentTransition+=4;
	}
#endif
	//store last transitions to be sure not to use the same twice
	for (i=0;i < lastTransitions.size()-1;i++)
		lastTransitions[i]=lastTransitions[i+1];
	lastTransitions[i]=currentTransition;

	//switch the invert effect of that transition
	isInvertTransition=lastTransMode[currentTransition];
	if (isInvertTransition == _TRUE_)
		lastTransMode[currentTransition]=_FALSE_;
	else
		lastTransMode[currentTransition]=_TRUE_;
}

void aMain::endTransition()
{
	isTransition=false;
}
#endif GAME_USE_TRANSITIONS

void aMain::paint()
{

	if(myText->getDomainNumber()==1){
	if ( !myText->isParseReady){
	myText->setDomain((String)(*(myText->getDomains()))[currentLanguage]);
	}else{
		if(isParseText){
			String _editChars[] = {MAIN_ARRAY_MISC_SMS_KEY_MAP_STRING};
			for(int i = 0; i < (sizeof(_editChars)/sizeof(String));i++)
				editChars.append(_editChars[i]);
			writeConfig();
			isParseText=0;
	}
	}
    }
	//return if we are still drawing or paused
	if (isDrawing == _TRUE_ || isPaused)
		return;

	isDrawing=_TRUE_;

#ifdef GAME_USE_TRANSITIONS
	/*TODO:
	if (transImage == NULL)
	{
		transImage=Image.createImage(ScreenWidth,ScreenHeight);
		transGraphics=transImage.getGraphics();
	}
	*/
#endif
#ifdef debug
	//remember start time
	long stime = ISHELL_GetTimeMS(m_pIShell);
#endif
	//working graphics object
#ifdef GAME_USE_TRANSITIONS
	/*TODO:
	if (transGraphics != NULL && isTransition)
		myGraphics=transGraphics;
	else
	{
	*/
#endif
#ifdef GAME_USE_TRANSITIONS
	//TODO:}
#endif
	//set our font
//	if (myFont != NULL)
//		aUtils.setFont(myGraphics,myFont);

#ifndef doja
	//reset any clippings
	//myGraphics.setClip(0,0,ScreenWidth,ScreenHeight);
#endif

	IGraphics* myGraphics = m_pGraphics;
	if (m_iGameState == -1) 
	{
		// something went wrong
#ifdef debug
		PUTILS->setColor(myGraphics, 0x0);
		PUTILS->fillRect(myGraphics, 0, 0, ScreenWidth, ScreenHeight);
		PUTILS->setColor(myGraphics, 0xff0000);
		String s = "Warning: Unknown GameState";
		PUTILS->drawString(myGraphics, s, (ScreenWidth - PUTILS->stringWidth(NULL, s)) / 2,
			(ScreenHeight - PUTILS->getFontHeight(PUTILS->getFont(myGraphics))) / 2, 0);
#endif
	} 
	else if (m_iGameState == APPLICATION_INIT) 
	{
		paintInit();
#ifndef GAME_NO_BRAND_SCREEN
	} 
	else if (m_iGameState == APPLICATION_BRAND) 
	{
		if (myText->isParseReady)
		paintBrand();
#endif
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	} 
	else if (m_iGameState == APPLICATION_LANGUAGE) 
	{
		paintLanguage();
#endif
	} 
	else if ((m_iGameState == APPLICATION_MAINMENU)
#ifdef MENU_DIFFICULT_LEVELS
	|| (m_iGameState == APPLICATION_STARTMENU)
#endif
	) 
	{
		if (m_iGameState == APPLICATION_MAINMENU) 
		{
// THIS USED TO BE IN paintMenu()
// TODO this is ralfs solution  - > test which one works
#ifndef soundapi/none
#ifdef MENU_MUSIC
			// restart menu music here
#ifdef GAME_SET_VOLUME_MED
			if (restartMusic == _TRUE_ && soundVolume > 0) 
			{
#else
			if (restartMusic == _TRUE_ && isSoundMuted == _FALSE_) 
			{
#endif
				restartMusic = _FALSE_;
				stopSound();
				playSound(MenuMusic, 1);

				// needed for sharp gx10 / 20, they are not repainting the background correctly after a showNotify!?
				doFullPaint = true;
			}
#else
#endif
#endif soundapi/none
		}
#ifdef MENU_IS_EXTERNAL
		myGame->paintMenu(doFullPaint);
#else

#ifdef GAME_SCREENHEIGHT
//TODO?		myGraphics.setClip(0, 0, ScreenWidth, GAME_SCREENHEIGHT);
#else
//TODO?		myGraphics.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif GAME_SCREENHEIGHT

#ifdef MENU_BACK_COLOR
#ifndef MENU_IMAGE
		// fill background
		PUTILS->setColor(myGraphics, MENU_BACK_COLOR);
#ifdef GAME_SCREENHEIGHT
		PUTILS->fillRect(myGraphics, 0, 0, ScreenWidth, GAME_SCREENHEIGHT);
#else
		PUTILS->fillRect(myGraphics, 0, 0, ScreenWidth, ScreenHeight);
#endif GAME_SCREENHEIGHT
#endif
#endif

#ifdef MENU_TILED_IMAGE && MENU_DRAW_TILED_IMAGE
		// background image?
		if (tiledImage != NULL) 
		{
#ifdef MENU_ANIMATE_TILED_BACK_X
			menuAnimatedBackXoffset += MENU_ANIMATE_TILED_BACK_X;
			if (menuAnimatedBackXoffset > 0) 
			{
				menuAnimatedBackXoffset -= PUTILS->getImageWidth(tiledImage);
			}
#else  MENU_ANIMATE_TILED_BACK_X
#define menuAnimatedBackXoffset 0
#endif MENU_ANIMATE_TILED_BACK_X
#ifdef MENU_ANIMATE_TILED_BACK_Y
			menuAnimatedBackYoffset += MENU_ANIMATE_TILED_BACK_Y;
			if (menuAnimatedBackYoffset > 0) 
			{
				menuAnimatedBackYoffset -= PUTILS->getIMageHeight(tiledImage);
			}
#else  MENU_ANIMATE_TILED_BACK_Y
#define menuAnimatedBackYoffset 0
#endif MENU_ANIMATE_TILED_BACK_Y
			paintTiledImage(tiledImage, menuAnimatedBackXoffset, menuAnimatedBackYoffset, _FALSE_, _FALSE_);
#ifndef MENU_ANIMATE_TILED_BACK_X
#undef menuAnimatedBackXoffset
#endif
#ifndef MENU_ANIMATE_TILED_BACK_Y
#undef menuAnimatedBackYoffset
#endif
		}
#endif MENU_TILED_IMAGE && MENU_DRAW_TILED_IMAGE

#ifdef MENU_IMAGE
	if (MenuImage != NULL) 
	{
		MenuImageX = (ScreenWidth - PUTILS->getImageWidth(MenuImage)) / 2;
		MenuImageY = (ScreenHeight - (PUTILS->getImageHeight(MenuImage))) / 2;
		PUTILS->drawImage(myGraphics, MenuImage, MenuImageX, MenuImageY, 0);
//		DBGPRINTF("Drawing Menu image");
	}
	else
	{
		//DBGPRINTF("Error Menu image");
	}
#endif MENU_IMAGE

#ifdef MENU_USE_HEADER
		// paint the menu header
#ifdef MENU_HEADER_IMAGE_FILE
		paintHeader(
			MENU_HEADER_XPOS, MENU_HEADER_YPOS, MENU_HEADER_WIDTH, MENU_HEADER_HEIGHT,
			headerImage, MENU_HEADER_IMAGE_XOFFSET, MENU_HEADER_IMAGE_YOFFSET, MENU_HEADER_IMAGE_WIDTH, MENU_HEADER_IMAGE_HEIGHT,
			MENU_HEADER_TEXT, MENU_HEADER_COLOR, MENU_HEADER_SPACER);
#else
		paintHeader(
			MENU_HEADER_XPOS, MENU_HEADER_YPOS, MENU_HEADER_WIDTH, MENU_HEADER_HEIGHT,
			NULL, MENU_HEADER_IMAGE_XOFFSET, MENU_HEADER_IMAGE_YOFFSET, MENU_HEADER_IMAGE_WIDTH, MENU_HEADER_IMAGE_HEIGHT,
			MENU_HEADER_TEXT, MENU_HEADER_COLOR, MENU_HEADER_SPACER);
#endif
#endif MENU_USE_HEADER
#ifdef MENU_USE_FOOTER
		// paint the menu footer
#ifdef MENU_FOOTER_IMAGE_FILE
		paintHeader(
			MENU_FOOTER_XPOS, MENU_FOOTER_YPOS, MENU_FOOTER_WIDTH, MENU_FOOTER_HEIGHT,
			footerImage, MENU_FOOTER_IMAGE_XOFFSET, MENU_FOOTER_IMAGE_YOFFSET, MENU_FOOTER_IMAGE_WIDTH, MENU_FOOTER_IMAGE_HEIGHT,
			MENU_FOOTER_TEXT, MENU_FOOTER_COLOR, MENU_FOOTER_SPACER);
#else
		paintHeader(
			MENU_FOOTER_XPOS, MENU_FOOTER_YPOS, MENU_FOOTER_WIDTH, MENU_FOOTER_HEIGHT,
			NULL, MENU_FOOTER_IMAGE_XOFFSET, MENU_FOOTER_IMAGE_YOFFSET, MENU_FOOTER_IMAGE_WIDTH, MENU_FOOTER_IMAGE_HEIGHT,
			MENU_FOOTER_TEXT, MENU_FOOTER_COLOR, MENU_FOOTER_SPACER);
#endif
#endif MENU_USE_FOOTER
#ifdef MENU_DIFFICULT_LEVELS
		if (m_iGameState == APPLICATION_STARTMENU) 
		{
#ifdef MENU_USE_CLASSIC_STARTMENU
		paintClassicMenu(startEntries);
#endif
#ifdef MENU_USE_MULTIITEM_STARTMENU
#ifndef MENU_ITEM_ANIMATION_STATES_COUNT
#define MENU_ITEM_ANIMATION_STATES_COUNT 1
#endif MENU_ITEM_ANIMATION_STATES_COUNT
		paintMultiMenu(startEntries,
				MENU_XPOS, MENU_YPOS, MENU_WIDTH, MENU_HEIGHT, MENU_ITEM_ANIMATION_STATES_COUNT,
				MENU_TEXT_COLOR, MENU_HIGHLIGHT_COLOR, MENU_DIFFICULT_LEVELS + 1);
#endif
#ifdef MENU_USE_ICON_STARTMENU
		paintIconMenu(startEntries);
#endif
		} 
		else
#endif MENU_DIFFICULT_LEVELS
		// paint the menu
#ifdef MENU_USE_CLASSIC_MAINMENU
		paintClassicMenu(menuEntries);
#endif
#ifdef MENU_USE_MULTIITEM_MAINMENU
#ifndef MENU_ITEM_ANIMATION_STATES_COUNT
#define MENU_ITEM_ANIMATION_STATES_COUNT 1
#endif MENU_ITEM_ANIMATION_STATES_COUNT
		paintMultiMenu(menuEntries,
			MENU_XPOS, MENU_YPOS, MENU_WIDTH, MENU_HEIGHT, MENU_ITEM_ANIMATION_STATES_COUNT,
			MENU_TEXT_COLOR, MENU_HIGHLIGHT_COLOR, availableMenuItems);
#endif MENU_USE_MULTIITEM_MAINMENU
#ifdef MENU_USE_ICON_MAINMENU
		paintIconMenu(menuEntries, icons, iconOffsets,
				10, 20, menuHeight, menuWidth, 0x005A5B00, MENU_ICON_HIGHLIGHT);
#endif
#endif MENU_IS_EXTERNAL

	} 
	else if (m_iGameState == APPLICATION_HELP) 
	{
// #ifdef HELP_IS_EXTERNAL
// 				Game.paintHelp(myGraphics, doFullPaint);
// #else
		paintHelp();
// #endif HELP_IS_EXTERNAL
#ifdef GAME_USE_GALLERY
	} 
	else if (m_iGameState == APPLICATION_GALLERY) 
	{
// #ifdef GALLERY_IS_EXTERNAL
// 				Game.paintGallery(myGraphics, doFullPaint);
// #else
		paintGallery();
// #endif GALLERY_IS_EXTERNAL
#endif GAME_USE_GALLERY
	} 
	else if (m_iGameState == APPLICATION_GAME) 
	{
		if (isGamePaused == _FALSE_)
		{
			paintGame();
		}
#ifndef GAME_NO_HIGHSCORE
	} 
	else if (m_iGameState == APPLICATION_INPUTSCORE) 
	{
		paintScoreInput();
	} 
	else if (m_iGameState == APPLICATION_HIGHSCORE) 
	{
		paintScore();
#ifdef GAME_HISCORE_UPLOAD
	} 
	else if (m_iGameState == APPLICATION_SCOREUPLOAD) 
	{
		paintScoreUpload();
#endif GAME_HISCORE_UPLOAD
#endif !GAME_NO_HIGHSCORE
	} 
	else if (m_iGameState == APPLICATION_QUIT) 
	{
		if (doFullPaint) 
		{
			PUTILS->setColor(myGraphics, 0x0);
			PUTILS->fillRect(myGraphics, 0, 0, ScreenWidth, ScreenHeight);
		}
#ifdef GAME_USE_TRANSITIONS
		if (isTransition == false)
#endif
			m_bRun = false;
		return;
	}
#ifdef PLAY4PRIZES
	else if(m_iGameState == APPLICATION_P4P_PLAY || m_iGameState == APPLICATION_P4P_HELP){
		paint4Prizes();
	}
#endif
	else 
	{
		// main does not know what to do - let game do it
		// IMPORTANT: do debug error handling in Game.processPaint(keyCode)
#ifndef USE_COMMANDS
		if (
#endif
#ifdef OLD_GAME
		myGame->processPaint(PMAIN->m_pGraphics,m_iGameState)
#else
		myGame->processPaint(m_iGameState)
#endif
#ifndef USE_COMMANDS
		)
		{
			paintMenuButton();
		}
#else
		;
#endif
	}

#ifndef GAMECANVAS
#ifdef debug
	lastFrametime = ISHELL_GetTimeMS(m_pIShell) - stime;
#endif
#endif

#ifdef GAME_USE_TRANSITIONS
	if (transGraphics != NULL && isTransition)
	{
#ifdef GAME_TRANSITION_MODE_SCROLL && GAME_TRANSITION_MODE_BLEND
		if (currentTransition < 4)
			paintTransBlend(myGraphics, transImage, currentTransition);
		else
			paintTransScroll(myGraphics, transImage, currentTransition - 4);
#else
#ifdef GAME_TRANSITION_MODE_BLEND
		paintTransBlend(myGraphics, transImage, currentTransition);
#endif
#ifdef GAME_TRANSITION_MODE_SCROLL
		paintTransScroll(myGraphics, transImage, currentTransition);
#endif
#endif GAME_TRANSITION_MODE_SCROLL && GAME_TRANSITION_MODE_BLEND
	}
#endif GAME_USE_TRANSITIONS

#ifdef debug
	framesPainted++;

	// print the info text?
	if (doInfo == _TRUE_)
		paintInfo();

	// print the debug text?
	if (doDebug == _TRUE_)
	{
		// always paint fullscreen if debugging!
		doFullPaint = true;
		paintDebug();
	}
#endif

//	DBGPRINTF("Before Update");
	IDISPLAY_UpdateEx(m_pIDisplay, true);
//	DBGPRINTF("After Update");
	isDrawing=_FALSE_;
	//doFullPaint = false;
}

void aMain::paintCommand()
{
#ifndef USE_COMMANDS
	/*
#ifdef BUTTON_GAME_PAINT
	if (m_iGameState == GAME || m_iGameState == SCORE|| m_iGameState == HELP || m_iGameState == LANGUAGE
#ifdef GAME_USE_GALLERY
		|| m_iGameState == GALLERY
#endif GAME_USE_GALLERY
	) {
		aUtils.setFont(g,mySmallFont);
		aUtils.setColor(g,BUTTON_BACK_COLOR);
		g.fillRoundRect(myCommandPosX,myCommandPosY,mySmallFontMenuWidth + mySmallFontSpaceWidth, mySmallFontHeight, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);
		aUtils.setColor(g,BUTTON_TEXT_COLOR);
		aUtils.drawString(g, MenuCommandName, BUTTON_TEXT_X_OFFSET + ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth / 2,BUTTON_TEXT_Y_OFFSET + ScreenHeight - mySmallFontHeight, 0);
	}
#endif
	if (m_iGameState == SCOREINPUT)
	{
		int w;

		//get width for both buttons
		if (mySmallFontMenuCancelWidth > mySmallFontMenuOKWidth)
			w=mySmallFontMenuCancelWidth+mySmallFontSpaceWidth;
		else
			w=mySmallFontMenuOKWidth+mySmallFontSpaceWidth;

		aUtils.setFont(g,mySmallFont);

		//right button
		aUtils.setColor(g,BUTTON_BACK_COLOR);
		g.fillRoundRect(ScreenWidth-w,ScreenHeight - mySmallFontHeight, w, mySmallFontHeight, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);
		aUtils.setColor(g,BUTTON_TEXT_COLOR);
		aUtils.drawString(g,MenuCommandCancelName,BUTTON_TEXT_X_OFFSET+ScreenWidth-w+(w-mySmallFontMenuCancelWidth)/2,BUTTON_TEXT_Y_OFFSET+ScreenHeight-mySmallFontHeight,0);
		//left button
		aUtils.setColor(g,BUTTON_BACK_COLOR);
		g.fillRoundRect(0,ScreenHeight-mySmallFontHeight,w,mySmallFontHeight,BUTTON_ARC_STYLE,BUTTON_ARC_STYLE);
		aUtils.setColor(g,BUTTON_TEXT_COLOR);
		aUtils.drawString(g,MenuCommandOKName,BUTTON_TEXT_X_OFFSET+(w-mySmallFontMenuOKWidth)/2,BUTTON_TEXT_Y_OFFSET+ScreenHeight-mySmallFontHeight,0);
	}
	*/
#endif
}

void aMain::paintGame()
{
#ifndef USE_COMMANDS
		boolean paintButton  =
#endif USE_COMMANDS
#ifdef OLD_GAME
			myGame->paint(PMAIN->m_pGraphics,doFullPaint);
#else
			myGame->paint(doFullPaint);
#endif
	//still in mode game?
	if (m_iGameState == APPLICATION_GAME)
	{
		doFullPaint=false;
		FrameTime = PGAME->FrameTime;
	}

#ifndef USE_COMMANDS
#ifndef BUTTON_PAINT_ALWAYS
		// call paintMenuButton to draw (and fade out) the menubutton
		if (paintButton) 
		{
			// if sliding out the button restore background first
			if ((menuButtonOffset > 0) && (MenuCommandTime != 0)) 
			{
				myGame->restoreBackground(
#ifdef GAME_BUTTON_IMAGE
					ScreenWidth - PUTILS->getImageWidth(menuButton),
					ScreenHeight - PUTILS->getImageWidth(menuButton),
					PUTILS->getImageWidth(menuButton),
					PUTILS->getImageWidth(menuButton));
#else  GAME_BUTTON_IMAGE
					ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth,
					ScreenHeight - mySmallFontHeight,
					mySmallFontMenuWidth + mySmallFontSpaceWidth,
					mySmallFontHeight);
#endif GAME_BUTTON_IMAGE
			}
#endif BUTTON_PAINT_ALWAYS
			// paint the button
			paintMenuButton();
#ifndef BUTTON_PAINT_ALWAYS
		}
#endif BUTTON_PAINT_ALWAYS
#endif USE_COMMANDS
		if (pauseGameNow == _TRUE_) 
		{
			// tell Game to pause
			int state = myGame->pauseGame();
			// but only once, so reset variable
			pauseGameNow = _FALSE_;

			if (state != -1)
				processApplicationState(state);
		}
}

void aMain::paintInit()
{
	
	
	// while initializing (doInit()) process keys here, because we're not threaded yet (see method: run())
	processKey();

//	final Font f=aUtils.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
//	aUtils.setFont(g,f);
	PUTILS->setColor(m_pGraphics,INIT_BACK_COLOR);

	//get x resolution
#ifdef DEVICE_X_RESOLUTION
	int width=DEVICE_X_RESOLUTION;
#else
	int width = ScreenWidth;
#endif

	//get y resolution
#ifdef DEVICE_Y_RESOLUTION
	int height=DEVICE_Y_RESOLUTION;
#else
	int height=ScreenHeight;
#endif

	//change to the next mode?
	if (DelightWait != 0 && DelightWait + INIT_WAIT_TIME < ISHELL_GetTimeMS(m_pIShell) && (myText->isParseReady || isConfigured != 1))
	{
		//update loading screen
		updateLoading(100,"");
		//request a repaint
		IDISPLAY_UpdateEx(m_pIDisplay, false);
		nextModeInit();
		return;
	}
	else if(!myText->isParseReady && m_bLoadText)
	{
		//select the domain saved in our config
		if (isConfigured == _TRUE_ && currentLanguage < myText->getDomainNumber())
		{
			myText->setDomain((*(myText->getDomains()))[currentLanguage]);
		}
	}

	//clear background
	PUTILS->fillRect(m_pGraphics, 0,0,width,height);

	//print logo
	if (DelightImage1 != NULL)
	{
		PUTILS->drawImage(m_pGraphics,DelightImage1,0,(height - (PUTILS->getImageHeight(DelightImage1) + PUTILS->getImageHeight(DelightImage2) + 3)) / 2,HCENTER);
	}

	//paint loading bar
	if (DelightImage2 != NULL && initPercentage != 0)
	{
		//calc smile length, x and y position
		int a=(PUTILS->getImageWidth(DelightImage2) - (PUTILS->getImageWidth(DelightImage2)*initPercentage) / 100) / 2;
		int y=(height - (PUTILS->getImageHeight(DelightImage1) + PUTILS->getImageHeight(DelightImage2) + 3)) / 2 + PUTILS->getImageHeight(DelightImage1) + 3;
		int x=(width - PUTILS->getImageWidth(DelightImage2)) / 2;
		PUTILS->drawImage(m_pGraphics,DelightImage2,x,y,0);
		//now cut away image parts
		if (initPercentage < 100)
		{
			PUTILS->setColor(m_pGraphics,INIT_BACK_COLOR);
			PUTILS->fillRect(m_pGraphics, x,y,a,PUTILS->getImageHeight(DelightImage2));
			PUTILS->setColor(m_pGraphics,INIT_BACK_COLOR);
			PUTILS->fillRect(m_pGraphics, x+PUTILS->getImageWidth(DelightImage2)-a,y,a,PUTILS->getImageHeight(DelightImage2));
		}
	}

#ifndef USE_COMMANDS
#ifdef INIT_QUIT_IMAGE
	PUTILS->drawImage(m_pGraphics,initQuitImage,ScreenWidth - PUTILS->getImageWidth(initQuitImage),ScreenHeight - PUTILS->getImageHeight(initQuitImage),0);
#endif INIT_QUIT_IMAGE
#endif USE_COMMANDS

#ifdef debug
	//print loading text
	if (initString.length() != 0)
	{
		//aUtils.setColor(g,INIT_TEXT_COLOR);
##if BREWVERSION > 0x1
		PUTILS->setFontColor(INIT_TEXT_COLOR);
##endif
		PUTILS->drawString(m_pGraphics,initString,0,height - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) + (INIT_TEXT_POSITION), HCENTER);
		String s="[Debug]";
##if BREWVERSION > 0x1
		PUTILS->drawString(m_pGraphics,s,width - PUTILS->stringWidth(PUTILS->m_pFont, s), 0, 0);
##else
		PUTILS->drawString(m_pGraphics,s,width - PUTILS->stringWidth(NULL, s), 0, 0);
##endif
	}
#endif
}

//we only store the last pressed key here and do the actions in the main thread
void aMain::keyPressed(int keyCode)
{
	if (myKey != NULL)
		myKey->updatePressedKey(keyCode);

	if (keyCode != 0)
		lastKeyPressed=keyCode;
}


#ifdef GAME_PROCESS_KEY_REPEATED_EVENTS
//we only store the last pressed key here and do the actions in the main thread
void aMain::keyRepeated(int keyCode)
{
	if (keyCode != 0)
		lastKeyPressed=keyCode;
}
#endif

void aMain::keyReleased(int keyCode)
{
	if (myKey != NULL)
		myKey->updateReleasedKey(keyCode);
}

void aMain::nextModeInit()
{
#ifndef GAME_NO_BRAND_SCREEN
	// switch to main menu or language select menu
	if (BrandImage != NULL)
	{
		// reset brand wait time
		if (BRAND_WAIT_TIME > 0)
			BrandWait = 0;

		processApplicationState(APPLICATION_BRAND);
	}
	else
#ifdef GAME_NO_LANGUAGE_SELECTION_SCREEN
		processApplicationState(APPLICATION_MAINMENU);
#else
	{
#endif
#endif GAME_NO_BRAND_SCREEN


#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
		// skip language selection if already configured or only one language available
		if (myText->getDomainNumber() <= 1 || (isConfigured == _TRUE_ && currentLanguage < myText->getDomainNumber()))
			processApplicationState(APPLICATION_MAINMENU);
		else
		{
#ifdef GAME_USE_BTEXT_CLASS
			currentLanguage = myText->localLanguageIndex;
#else
			currentLanguage = 0;
#endif
			processApplicationState(APPLICATION_LANGUAGE);
			//adi -------
#ifdef EXTERNAL_INTRO
			BackGameState = APPLICATION_INTRO;
#else
		  	BackGameState = APPLICATION_MAINMENU;
#endif
  			oldMenuItem = 2;
			//	  		System.out.println("PAMIETAM"+ BackGameState);
			//adi--------
		}
#endif

#ifndef GAME_NO_BRAND_SCREEN || GAME_NO_LANGUAGE_SELECTION_SCREEN
	}
#endif

#ifdef GAME_NO_BRAND_SCREEN && GAME_NO_LANGUAGE_SELECTION_SCREEN
	processApplicationState(APPLICATION_MAINMENU);
#endif
	// remove loading screen resources
	if( DelightImage1 != NULL ) {
		DelightImage1->release();
		delete(DelightImage1);
		DelightImage1 = NULL;
	}
	if(DelightImage2 != NULL){
		DelightImage2->release();
		delete(DelightImage2);
		DelightImage2 = NULL;
	}

#ifndef soundapi/none
	if (DelightJingle >= 0)
		mySound->del(DelightJingle);
#endif
}

void aMain::keyInit(int keyCode)
{
	// quit game if cancel is pressed while loading
	if (PKEY->isSoftRight(keyCode) || PKEY->isClear(keyCode)) 
	{
#ifndef soundapi/none
		// stop music
		stopSound();
#endif soundapi/none
		m_bRun = _FALSE_;
		return;
	} 
	/*
	else
	// any key ends the loading screen after we are initialised
	if (isInitialised == _TRUE_)
		nextModeInit();
		*/
}

#ifndef GAME_NO_BRAND_SCREEN
//  ****************************************************************
//  **********  brand methods  *************************************
//  ****************************************************************
void aMain::nextModeBrand()
{
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	// skip language selection if already configured or only one language available
	if (myText->getDomainNumber() <= 1 || (isConfigured == _TRUE_ && currentLanguage < myText->getDomainNumber()))
#endif
		processApplicationState(APPLICATION_MAINMENU);
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
	else
	{
		// switch to language select if more than 1 language is available
#ifdef GAME_USE_BTEXT_CLASS
		currentLanguage = myText->localLanguageIndex;
#else
		currentLanguage = 0;
#endif
		processApplicationState(APPLICATION_LANGUAGE);
		//adi -------
#ifdef EXTERNAL_INTRO
		BackGameState = APPLICATION_INTRO;
#else
		BackGameState = APPLICATION_MAINMENU;
#endif
		oldMenuItem = 2; // new game

		// System.out.println("PAMIETAM"+ BackGameState);
		//adi -------
	}
#endif
	BrandImage->release();
	delete(BrandImage);
	BrandImage = NULL;
}

void aMain::paintBrand()
{
	// store brand wait time after the transition has ended
	if (BRAND_WAIT_TIME > 0 && BrandWait == 0
#ifdef GAME_USE_TRANSITIONS
		&& isTransition == false
#endif GAME_USE_TRANSITIONS
		)
			BrandWait = ISHELL_GetTimeMS(m_pIShell);

	// change to the next mode?
	if (BrandImage == NULL || (
#ifdef GAME_USE_TRANSITIONS
		isTransition == false &&
#endif GAME_USE_TRANSITIONS
		BrandWait != 0 && BrandWait + BRAND_WAIT_TIME < ISHELL_GetTimeMS(m_pIShell)))
			nextModeBrand();
	else
	{
		// paint background
		if (doFullPaint)
		{
			doFullPaint = false;

			// paint background
			PUTILS->setColor(m_pGraphics, BRAND_BACK_COLOR);
			PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
		}

		// print logo
		PUTILS->drawImage(m_pGraphics, BrandImage, 0, 0, HCENTER|VCENTER);
	}
}

void aMain::keyBrand(int keyCode)
{
	if(myKey->isClear(keyCode))
	{
#ifndef soundapi/none
		//stop music
		mySound->stop(0);
#endif
		m_bRun=_FALSE_;
	}
	else if(myKey->isCall(keyCode))
	{
		return;
	}
	else
	{
		nextModeBrand();
	}
}
#endif

#ifndef GAME_NO_HIGHSCORE
//  *****************************************************************
//  **********  score input  ****************************************
//  *****************************************************************
int aMain::getScoreRangePos(char c)
{
	for (int i = 0; i < ScoreInputRange.length(); i++)
		if (ScoreInputRange.charAt(i) == c)
			return i;

	return 0;
}

void aMain::paintScoreBackground()
{
#ifdef MENU_TILED_IMAGE && SCORE_DRAW_TILED_IMAGE
	// background image?
	if (tiledImage != NULL)
	{
		paintTiledImage(tiledImage, 0, 0, _FALSE_, _FALSE_);
	}
#else
	// clear background
	PUTILS->setColor(m_pGraphics, SCORE_BACK_COLOR);
	PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
#endif MENU_TILED_IMAGE && SCORE_DRAW_TILED_IMAGE
//#ifndef SCORE_IS_EXTERNAL
#ifdef SCORE_IMAGE
	// paint background
	if (ScoreImage != NULL)
		PUTILS->drawImage(m_pGraphics, ScoreImage, 0, 0, HCENTER|VCENTER);
#endif
//#endif
}

// prepare everything needed for score input here
void aMain::preScoreInput() 
{
#ifdef debug
	myDebug->add(1, "Main::preScoreInput()");
#endif
	// add ok and cancel command / label if going into score input
	MenuCommandOKName = TEXT_CONST_MOK;
	MenuCommandCancelName = TEXT_CONST_MCA;

#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//setSoftKey(MenuCommandOKName, SOFT_KEY_1);
	//setSoftKey(MenuCommandCancelName, SOFT_KEY_2);
#endif FULLCANVAS
#endif USE_COMMANDS

#ifndef USE_COMMANDS
	mySmallFontMenuOKWidth = PUTILS->stringWidth(NULL, MenuCommandOKName);
	mySmallFontMenuCancelWidth = PUTILS->stringWidth(NULL, MenuCommandCancelName);
#endif !USE_COMMANDS

#ifdef SCORE_MUSIC || MENU_MUSIC
	restartMusic = _TRUE_;
#endif
}

// clean up everything needed for score input here
void aMain::postScoreInput()
{
	// add ok and cancel command / label if going into score input
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_1);
	//removeSoftKey(SOFT_KEY_2);
#endif FULLCANVAS
#endif USE_COMMANDS
}

void aMain::paintWaitString()
{
	if(PUTILS->m_bIsFontActive)
	{

#ifndef GAME_USE_TEXT_DEFINES
		String s;
#ifdef GAME_USE_BTEXT_CLASS
		// get the wait message of the new language we are switching to
		if ((s = myText->getWaitMessage(currentLanguage)).length() == 0)
			s = "...";
#else
		s = myText->get("w");
#endif

#else
		String s = TEXT_CONST_WAIT;

#endif GAME_USE_TEXT_DEFINES
		m_iWaitCounter++;
		m_iWaitCounter = (m_iWaitCounter%3);
		int _length = PUTILS->stringWidth(NULL, s);
		s.partialString(s.length()-m_iWaitCounter);
		// use a smaller font...
		PUTILS->setFont(m_pGraphics, PUTILS->getFont(m_pGraphics));
		PUTILS->setColor(m_pGraphics, 0x00000000);
		PUTILS->fillRect(m_pGraphics, 0,0, ScreenWidth, ScreenHeight);
		PUTILS->drawString(m_pGraphics, s, (ScreenWidth - _length)/2,(ScreenHeight-20 - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)))/2,0);//VCENTER|SHADOW);//HCENTER|
		IDISPLAY_UpdateEx(m_pIDisplay, false);
		PUTILS->setColor(m_pGraphics, 0x00000000);
		PUTILS->fillRect(m_pGraphics, 0,0, ScreenWidth, ScreenHeight);
	}
}

void aMain::paintScoreInput()
{
	// set our highscore input font
	//PUTILS->setFont(m_pGraphics, ScoreInputFont);
	int i, j;
	// do some calculations one time
	if (ScoreInputRange.length() == 0)
	{
		ScoreInputRange = TEXT_CONST_SCH;
		ScoreInputTitle = TEXT_CONST_STI;
#ifdef SCORE_INPUT_NO_RANK
		ScoreInputGrats = TEXT_CONST_SGR;
#else  SCORE_INPUT_NO_RANK
		char _cBuf[10];
		ScoreInputGrats = TEXT_CONST_SGR;
		ScoreInputGrats += " ";
		ScoreInputGrats += _itoa(myScores->checkPos(ScorePlayed), _cBuf, 10);
#endif SCORE_INPUT_NO_RANK

#ifdef debug
		//myDebug.add(1, "Main::paintScoreInput(): CharRange:'" + ScoreInputRange + "'");
#endif
		// copy the last name over to our input char array
		//for (i = 0; i < ScoreInputChars.length() && i < ScoreLastName.length(); i++)
		//	ScoreInputChars[i] = ScoreLastName.charAt(i);
		ScoreInputChars = ScoreLastName;

		// clear rest
		//for (; i < ScoreInputChars.length(); i++)
		//	ScoreInputChars[i] = ScoreInputRange.charAt(0);
		//ScoreInputChars = "";


		// get highest char width
		for (ScoreInputCharWidth = 0, i = 0; i < ScoreInputRange.length(); i++)
			if ((j = PUTILS->charWidth(NULL, ScoreInputRange.charAt(i))) > ScoreInputCharWidth)
				ScoreInputCharWidth = j;

		// make it even
		if ((ScoreInputCharWidth&1) != 0)
			ScoreInputCharWidth++;

		// get font y metrix
		ScoreInputCharHeight = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
		// get the smaller one for the arrow width
		ScoreInputArrowSize = ScoreInputCharWidth;
		// make it even
		ScoreInputArrowSize &= ~1;
		// calc space between chars
		ScoreInputCharSpace = ScreenWidth - ScoreInputCharWidth * ScoreInputChars.length() - 2 * ScoreInputCharWidth;

		if (ScoreInputCharSpace > 0)
		{
			ScoreInputCharSpace /= (ScoreInputChars.length() - 1);
			if  (ScoreInputCharSpace > ScoreInputCharWidth)
				ScoreInputCharSpace = ScoreInputCharWidth;
		}
		else
			ScoreInputCharSpace = 0;

		// calc x pos
		ScoreInputCharX = (ScreenWidth - ScoreInputCharWidth * ScoreInputChars.length() - ScoreInputCharSpace * (ScoreInputChars.length() - 1)) / 2;
		ScoreInputTitleXPos = (ScreenWidth - PUTILS->stringWidth(NULL, ScoreInputTitle)) / 2;
		ScoreInputGratsXPos = (ScreenWidth - PUTILS->stringWidth(NULL, ScoreInputGrats)) / 2;

		ScoreInputCharY = (ScreenHeight * 2) / 3;
		ScoreInputTitleYPos = (ScoreInputCharY - 2 * ScoreInputCharHeight) / 2;
		ScoreInputGratsYPos = (ScoreInputCharY - ScoreInputTitleYPos - ScoreInputCharHeight) / 2 + ScoreInputTitleYPos;
	}

	// initiate score input end
	if (ScoreInputInitEnd == _TRUE_)
	{
		ScoreInputInitEnd = _FALSE_;
		ScoreInputEnd = _TRUE_;

		// paint background
		paintScoreBackground();

		// display waiting text  TODO could be better than '...'
		PUTILS->setColor(m_pGraphics, SCORE_INPUT_COLOR);
		paintWaitString();

		return;
	}

	// end scoreinput
	if (ScoreInputEnd == _TRUE_)
	{
		ScoreInputEnd = _FALSE_;

		// store position of last added score
		ScoreLastPosition = myScores->checkPos(ScorePlayed) - 1;
#ifdef SCORE_ONE_PER_MODE
		ScoreLastMode = currentScoreMode;
#endif
		// store name
		ScoreLastName = ScoreInputChars;
		writeConfig();

		// add additional infos?
		myScores->add(ScoreLastName.trim(), ScorePlayed);

		// write the scores
		myScores->write();
#ifndef doja
#ifdef GAME_HISCORE_UPLOAD
		// switch over to score state
		processApplicationState(APPLICATION_SCOREUPLOAD);
		//adi--- back to main menu always here
		BackGameState = APPLICATION_MAINMENU;
		oldMenuItem = 2; // new game
		//adi -------
#else GAME_HISCORE_UPLOAD
		// switch over to score state
		processApplicationState(APPLICATION_HIGHSCORE);
		//adi--- back to main menu always here
		BackGameState = APPLICATION_MAINMENU;
		oldMenuItem = 2; // new game
		//adi -------
#endif GAME_HISCORE_UPLOAD
#else !doja
		// switch over to score state
		processApplicationState(APPLICATION_HIGHSCORE);
		//adi--- back to main menu always here
		BackGameState = APPLICATION_MAINMENU;
		oldMenuItem = 2; // new game
		//adi -------
#endif !doja
		return;
	}

	// only paint what is needed
	if (doFullPaint)
	{
#ifndef soundapi/none
#ifdef SCORE_MUSIC || MENU_MUSIC
		// restart music here
		if (restartMusic == _TRUE_)
		{
			restartMusic = _FALSE_;
#ifdef SCORE_MUSIC
			stopSound();
			playSound(ScoreMusic, 1);
#else
#ifdef MENU_MUSIC
			stopSound();
			playSound(MenuMusic, 1);
#endif
#endif
		}
#endif
#endif soundapi/none
		doFullPaint = false;
#ifndef doja
		//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
	}
#ifndef doja
	else
	{
/*		g.setClip(ScoreInputCharX - ScoreInputCharWidth,
			ScoreInputCharY - ScoreInputCharHeight,
			ScoreInputCharWidth * (ScoreInputChars.length + 2) + (ScoreInputChars.length - 1) * ScoreInputCharSpace,
			3 * PUTILS->getFontHeight(ScoreInputFont));
*/
	}
#endif
	paintScoreBackground();

	// set color
	PUTILS->setColor(m_pGraphics, SCORE_INPUT_COLOR);

	// paint all the chars
	for (i = 0; i < ScoreInputChars.length(); i++)
	{
		// center the char
		j = 1 + (ScoreInputCharWidth - (PUTILS->charWidth(NULL, ScoreInputChars.charAt(i)))) / 2;

		PUTILS->setColor(m_pGraphics, SCORE_INPUT_COLOR);
		PUTILS->drawChar(m_pGraphics, ScoreInputChars.charAt(i), ScoreInputCharX + i * ScoreInputCharWidth + i * ScoreInputCharSpace + j,
			ScoreInputCharY, SHADOW);
	}

	// rotate the color
	if (++ScoreColor >= GameColorRotation.size())
		ScoreColor = 0;

	// use smaller font for title
	//PUTILS->setFont(g, myFont);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(SCORE_INPUT_COLOR);
##endif
	PUTILS->drawString(m_pGraphics, ScoreInputTitle, ScoreInputTitleXPos, ScoreInputTitleYPos, SHADOW);
	PUTILS->drawString(m_pGraphics, ScoreInputGrats, ScoreInputGratsXPos, ScoreInputGratsYPos, SHADOW);

	// set rotating color and score font
	//PUTILS->setFont(m_pGraphics, ScoreInputFont);
	PUTILS->setColor(m_pGraphics, GameColorRotation[ScoreColor]);

	// move the arrows
	if (ScoreInputArrowPos++ >= ScoreInputArrowSize / 4 + 2)
		ScoreInputArrowPos = 2;

	// center the char
	j = 1 + (ScoreInputCharWidth - (PUTILS->charWidth(NULL, ScoreInputChars.charAt(ScoreInputPos)))) / 2;

	// shortcut
	int x = ScoreInputCharX + ScoreInputPos * ScoreInputCharWidth + ScoreInputPos * ScoreInputCharSpace;

	// draw arrows above / below the char
	for (int z = -1; z < 2; z++)
	{
		// draw arrows up
		PUTILS->drawLine(m_pGraphics, SCORE_INPUT_ARROW_X_OFFSET + x + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY - ScoreInputArrowPos,
			SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize / 2 + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY - ScoreInputArrowPos - ScoreInputArrowSize / 2);
		PUTILS->drawLine(m_pGraphics, SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize / 2 + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY - ScoreInputArrowPos - ScoreInputArrowSize / 2,
			SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY - ScoreInputArrowPos);

		// draw arrows down
		PUTILS->drawLine(m_pGraphics, SCORE_INPUT_ARROW_X_OFFSET + x + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY + ScoreInputArrowPos + ScoreInputCharHeight,
			SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize / 2 + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY + ScoreInputArrowPos + ScoreInputCharHeight + ScoreInputArrowSize / 2);
		PUTILS->drawLine(m_pGraphics, SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize / 2 + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY + ScoreInputArrowPos + ScoreInputCharHeight + ScoreInputArrowSize / 2,
			SCORE_INPUT_ARROW_X_OFFSET + x + ScoreInputArrowSize + z,
			SCORE_INPUT_ARROW_Y_OFFSET + ScoreInputCharY + ScoreInputArrowPos + ScoreInputCharHeight);
	}

	// draw the char
##if BREWVERSION > 0x1
	PUTILS->setFontColor(GameColorRotation[ScoreColor]);
##endif
	PUTILS->drawChar(m_pGraphics, ScoreInputChars.charAt(ScoreInputPos), x + j, ScoreInputCharY, SHADOW);

#ifndef USE_COMMANDS
	// paint ok / cancel
	int w;

	// get width for both buttons
	if (mySmallFontMenuCancelWidth > mySmallFontMenuOKWidth)
		w = mySmallFontMenuCancelWidth + mySmallFontSpaceWidth;
	else
		w = mySmallFontMenuOKWidth + mySmallFontSpaceWidth;

//	PUTILS->setFont(g, mySmallFont);
	mySmallFontHeight = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));

	// right button
	PUTILS->setColor(m_pGraphics, BUTTON_BACK_COLOR);
	PUTILS->fillRect(m_pGraphics, ScreenWidth - w, ScreenHeight - mySmallFontHeight, w, mySmallFontHeight);//, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(BUTTON_TEXT_COLOR);
##endif
	PUTILS->drawString(m_pGraphics, MenuCommandCancelName,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_X_OFFSET +
#endif
		ScreenWidth - w + (w - mySmallFontMenuCancelWidth) / 2,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_Y_OFFSET +
#endif
		ScreenHeight - mySmallFontHeight, 0);
#ifndef 9500 || 9300
	// left button
	PUTILS->setColor(m_pGraphics, BUTTON_BACK_COLOR);
	PUTILS->fillRect(m_pGraphics, 0, ScreenHeight - mySmallFontHeight, w, mySmallFontHeight);//, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);
	PUTILS->setColor(m_pGraphics, BUTTON_TEXT_COLOR);
	PUTILS->drawString(m_pGraphics, MenuCommandOKName,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_X_OFFSET +
#endif
		(w - mySmallFontMenuOKWidth) / 2,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_Y_OFFSET +
#endif
		ScreenHeight - mySmallFontHeight, 0);
#else
	// draw the left softkey in the top right corner of the communicator
	PUTILS->setColor(m_pGraphics, BUTTON_BACK_COLOR);
	PUTILS->fillRect(ScreenWidth - w, 0, w, mySmallFontHeight);//, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);
	PUTILS->setColor(m_pGraphics, BUTTON_TEXT_COLOR);
	PUTILS->drawString(m_pGraphics, MenuCommandOKName,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_X_OFFSET +
#endif
		ScreenWidth - w + (w - mySmallFontMenuCancelWidth) / 2,
#ifndef GAME_USE_GRAPHICAL_FONT
		BUTTON_TEXT_Y_OFFSET, 0);
#else
		0, 0);
#endif
#endif
#endif !USE_COMMANDS
}

void aMain::keyScoreInput(int keyCode)
{
// #ifndef USE_COMMANDS
	// use right softkey to go back to menu
	if (PKEY->isSoftRight(keyCode) || PKEY->isClear(keyCode))
	{
		processApplicationState(APPLICATION_MAINMENU);
		return;
	}
	else
// #endif
	if (PKEY->isLeft(keyCode))
	{
		if (ScoreInputPos > 0)
			ScoreInputPos--;

		// get new char postion
		ScoreInputCharPos = getScoreRangePos(ScoreInputChars.charAt(ScoreInputPos));
	}
	else if (PKEY->isRight(keyCode))
	{
		if (++ScoreInputPos >= SCORE_NAME_LENGTH)
			ScoreInputPos = SCORE_NAME_LENGTH - 1;

		// get new char postion
		ScoreInputCharPos = getScoreRangePos(ScoreInputChars.charAt(ScoreInputPos));
	}
	else if (PKEY->isDown(keyCode))
	{
		if (ScoreInputCharPos > 0)
			ScoreInputCharPos--;
		else
			ScoreInputCharPos = ScoreInputRange.length() - 1;

		//ScoreInputChars[ScoreInputPos] = ScoreInputRange.charAt(ScoreInputCharPos);
		ScoreInputChars.setCharAt(ScoreInputRange.charAt(ScoreInputCharPos), ScoreInputPos);
	}
	else if (PKEY->isUp(keyCode))
	{
		if (++ScoreInputCharPos >= ScoreInputRange.length())
			ScoreInputCharPos = 0;

//		ScoreInputChars[ScoreInputPos] = ScoreInputRange.charAt(ScoreInputCharPos);
		ScoreInputChars.setCharAt(ScoreInputRange.charAt(ScoreInputCharPos), ScoreInputPos);
	}
	else if (PKEY->isSoftLeft(keyCode) || PKEY->isFire(keyCode))
		ScoreInputInitEnd = _TRUE_;
}

//  *****************************************************************
//  **********  highscore  ******************************************
//  *****************************************************************

void aMain::preScore()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif
}

void aMain::postScore()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
}

void aMain::paintScore()
{
	doFullPaint = true;

#ifdef SCORE_IS_EXTERNAL

	// let game paint the help
	myGame->paintScore(doFullPaint);
	// ok was painted once completely
	doFullPaint = false;

#else SCORE_IS_EXTERNAL
	int c, i, j, y;

	// set our highscore font
//	PUTILS->setFont(m_pGraphics, ScoreFont);

	// prepare the scores for printing if needed
	if (ScoreBuf.size() == 0)
	{
		int n = 0;

		// check if really monospace font
		ScoreIsMonoSpace = PUTILS->charWidth(NULL, 'W') - PUTILS->charWidth(NULL, '.');
		ScoreScrollDirection = 0;

		// some working buffers
		String name;
		String score;

		// get needed buffer and init them
//		ScoreBuf = new StringBuffer[myScores.numScores()];
//		for (i = 0; i < ScoreBuf.length(); i++)
//			ScoreBuf[i] =  new StringBuffer(20);

		String _szBuf="";
		for(i = 0; i < myScores->numScores(); i++)
		{
			ScoreBuf.append(_szBuf);
		}
		// process every score
		for (i = 1; i <= myScores->numScores(); i++)
		{
			// prepare name
			name.setLength(0);
			name += myScores->getName(i);

			// correct name length
			for (j = name.length();j < SCORE_NAME_LENGTH;j++)
			{
				name += SCORE_SEPERATOR;
			}
			name.setLength(SCORE_NAME_LENGTH);

			// prepare score
			score.setLength(0);

			char _cBuf[10];
#ifdef SCORE_IS_IN_SECONDS
			c = myScores->getScore(i) / 60;
			j = myScores->getScore(i) - (c * 60);

			if (c > 99)
			{
				c = 99;
				j = 59;
			}

			if (c < 10)
				score += "0";

			score += _itoa(c, _cBuf,10);
			score += ":";

			if (j < 10)
				score += "0";

			score += _itoa(j, _cBuf, 10);
#else
			score += _itoa(myScores->getScore(i), _cBuf, 10);
#endif
			// check score length
			if (i == 1)
			{
				ScoreChars = score.length();
#ifdef SLOW_DEVICE
				n = 0;
#else
				if (ScoreIsMonoSpace == 0)
					n = ScreenWidth / PUTILS->charWidth(NULL, 'W') - ScoreChars - SCORE_NAME_LENGTH;
				else
					n = ScreenWidth / (PUTILS->charWidth(NULL, 'W') - 1) - ScoreChars - SCORE_NAME_LENGTH;

				n--;		// = 2;
				if (n < 0)
					n = 0;
#endif
			}
			else
			{
				String _szBuf;
				for (j = score.length();j < ScoreChars;j++)
				{
					_szBuf = SCORE_SEPERATOR;
					_szBuf += score;
					score = _szBuf;
					//score.insert(0, SCORE_SEPERATOR);
				}
			}

			// generate final score
			ScoreBuf[i-1] = name;

			for (j = 0;j < n;j++)
			{
				ScoreBuf[i-1] += SCORE_SEPERATOR;
			}
			ScoreBuf[i-1] += score;
		}
		// store some needed vars
#ifdef SCORE_ONE_PER_MODE
#ifndef GAME_USE_TEXT_DEFINES
		char _cBuf[10];
		_szBuf = "mmo";
		_szBuf += _itoa(currentScoreMode, _cBuf, 10);
		ScoreTitel = myText->get(_szBuf);
#else
		ScoreTitel = GameModes[currentScoreMode];
#endif
#else
		ScoreTitel = TEXT_CONST_MSC;
#endif
		ScoreTitelXPos = (ScreenWidth - PUTILS->stringWidth(NULL, ScoreTitel)) / 2;
#ifdef SCORE_ONE_PER_MODE
		ScoreTitelXPosEnd = ScoreTitelXPos + PUTILS->stringWidth(NULL, ScoreTitel);
#endif
		ScoreCharHeight = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));

		// only change charwidth if not monospace font
		if (ScoreIsMonoSpace == 0)
			ScoreCharWidth = PUTILS->charWidth(NULL, 'W');
		else
			ScoreCharWidth = PUTILS->charWidth(NULL, 'W') - 1;

		ScoreHeight = ScoreBuf.size() * ScoreCharHeight;
#ifdef SLOW_DEVICE
		ScoreWidth = ScreenWidth - 14;
#else
		ScoreWidth = ScoreCharWidth * ScoreBuf.size();
#endif
		ScoreStartX = (ScreenWidth - ScoreWidth) / 2;
		ScoreEntryLength = ScoreBuf[0].length();

		ScoreStartY = 3 * ScoreCharHeight;
		ScoreWidthY = ScreenHeight - ScoreStartY - ScoreCharHeight;

		// stretch space between scores when scrolling
		ScoreCharHeight += (ScoreCharHeight / 2);
		ScoreHeight = ScoreBuf.size() * ScoreCharHeight;

		// now check if in limits if yes stretch
		if (ScoreHeight < ScoreWidthY)
		{
			// stretch space between scores if screenarea is bigger than needed
			ScoreCharHeight += (ScoreWidthY - ScoreHeight - 1) / ScoreBuf.size();
			ScoreHeight = ScoreBuf.size() * ScoreCharHeight;
		}

		// scroll scores the whole distance at start
		ScoreScrollPos = ScoreWidthY;
#ifdef debug
		if (ScoreIsMonoSpace != 0)
		{
		//	myDebug->add(1, "Main::paintScore(): Font is not MonoSpace! Diff:" + ScoreIsMonoSpace);
		}
#endif
		ScoreTitleYPos = (ScoreStartY - ScoreCharHeight) / 2;

		// fix for s30
		if (ScoreTitleYPos <= 0)
			ScoreTitleYPos = 1;
	}

	// only paint what is needed
	if ((doFullPaint == true)
#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// while sliding out the menubutton a full repaint is required...
	|| ((menuButtonOffset > 0) && (MenuCommandTime != 0))
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS
	) {
#ifndef soundapi/none
#ifdef SCORE_MUSIC || MENU_MUSIC
		// restart music here
		if (restartMusic == _TRUE_)
		{
			restartMusic = _FALSE_;
#ifdef SCORE_MUSIC
			stopSound();
			playSound(ScoreMusic, 1);
#else
#ifdef MENU_MUSIC
			stopSound();
			playSound(MenuMusic, 1);
#endif
#endif
		}
#endif
#endif soundapi/none

		doFullPaint = false;
#ifndef doja
		//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
		// paint background
		paintScoreBackground();

		// set score clipping
#ifndef doja
		//g.setClip(0, ScoreStartY - 1, ScreenWidth, ScoreWidthY + 1);
#endif
	}
	else	// clip one y more for background reconstruction because of samsung e700
	{
		// set score clipping
#ifndef doja
		//g.setClip(0, ScoreStartY - 1, ScreenWidth, ScoreWidthY + 1);
#endif
		paintScoreBackground();
	}

	// rotate the color
	if (++ScoreColor >= GameColorRotation.size())
		ScoreColor = 0;

	// scroll the scores
	if (ScoreScrollDirection == 0)
	{
		if (ScoreWidthY - ScoreHeight > 0)
		{
			if (--ScoreScrollPos <= 0)
				ScoreScrollDirection ^= 1;
		}
		else
			if (--ScoreScrollPos < ScoreWidthY - ScoreHeight)
				ScoreScrollDirection ^= 1;
	}
	else 	// only scroll if highscore list is longer than display area
		if (ScoreWidthY - ScoreHeight < 0)
			if (++ScoreScrollPos >= 0)
				ScoreScrollDirection ^= 1;

#ifdef SLOW_DEVICE
	String s;
	int m = 0;

	// print the scores
	for (c = ScoreColor, i = 0; i < ScoreBuf.size(); i++)
	{
		// calc y print position
		y = ScoreScrollPos + ScoreStartY + i * ScoreCharHeight;

		// only print if text is in the clipping area
		if (ScoreStartY > y + ScoreCharHeight || ScoreStartY + ScoreWidthY < y)
			continue;

		// get the string
		s = ScoreBuf[i];

		// scroll color depending on the scroll direction
		if (ScoreScrollDirection == 0)
		{
			if (--c < 0)
				c = GameColorRotation.size() - 1;
		}
		else
			if (++c >= GameColorRotation.size())
				c = 0;

		// skip spaces before score
		for (j = ScoreEntryLength - ScoreChars;j < ScoreChars;j++)
			if (s.charAt(j) != ' ')
				break;

#ifdef SCORE_MARK_LAST_SCORE
		// change the color of the last added entry
		if (i == ScoreLastPosition
#ifdef SCORE_ONE_PER_MODE
			 && ScoreLastMode == currentScoreMode
#endif
			)
			PUTILS->setColor(m_pGraphics, GameColorRotation[c] | SCORE_MARK_COLOR_ADD);
		else
#endif
			PUTILS->setColor(m_pGraphics, GameColorRotation[c]);

// add a shadow depending on the speed of the device
#ifdef NOT_THAT_SLOW_DEVICE
#define _WITH_SHADOW_ SHADOW
#else
#define _WITH_SHADOW_ 0
#endif
		// print shadow for names and scores
		WString _wszBuf = s;
		PUTILS->drawSubstring(m_pGraphics, (AECHAR*)_wszBuf.toCharArray(), 0, SCORE_NAME_LENGTH, ScoreStartX, y, _WITH_SHADOW_);
		PUTILS->drawSubstring(m_pGraphics, (AECHAR*)_wszBuf.toCharArray(), j, (s.length() - j), ScoreStartX + ScoreWidth - PUTILS->stringWidth(NULL, s.substring(j, j + (s.length() - j))), y, _WITH_SHADOW_);
#undef _WITH_SHADOW_
	}

#else SLOW_DEVICE
	// print the scores
	int o = 0;
	char b;
	for (c = ScoreColor, i = 0; i < ScoreBuf.size(); i++)
	{
		// calc y print position
		y = ScoreScrollPos + ScoreStartY + i * ScoreCharHeight;

		// only print if text is in the clipping area
		if (ScoreStartY > y + ScoreCharHeight || ScoreStartY + ScoreWidthY < y)
			continue;

#ifdef SCORE_SHADOW_COLOR
		// print text shadow only if monospace font
		if (ScoreIsMonoSpace == 0)
		{
			PUTILS->setColor(m_pGraphics, SCORE_SHADOW_COLOR);
			PUTILS->drawString(m_pGraphics, ScoreBuf[i], ScoreStartX - 1, y - 1, 0);
		}
#endif
		// print every char with a different color
		if ((i & 1) == 0)
		{
			c = ScoreColor;

			// scroll color to left for every even line
			for (j = 0; j < ScoreEntryLength; j++)
			{
				b = ScoreBuf[i].charAt(j);

				// center the char if no monospacefont is supported
				if (ScoreIsMonoSpace != 0)
					o = (ScoreCharWidth - PUTILS->charWidth(NULL, b)) / 2;

#ifdef SCORE_MARK_LAST_SCORE
				// change the color of the last added entry
				if (i == ScoreLastPosition
#ifdef SCORE_ONE_PER_MODE
					 && ScoreLastMode == currentScoreMode
#endif
					)
					PUTILS->setColor(m_pGraphics, GameColorRotation[c]|SCORE_MARK_COLOR_ADD);
				else
#endif
					PUTILS->setColor(m_pGraphics, GameColorRotation[c]);

// System.out.println("DrawChar:" + b);

				PUTILS->drawChar(m_pGraphics, b, ScoreStartX + j * ScoreCharWidth + o, y, 0);

				if (++c >= GameColorRotation.size())
					c = 0;
			}
		}
		else
		{
			// set score color to the opposite of the left scroller
			c = (ScoreColor + GameColorRotation.size() / 2 ) % GameColorRotation.size();

			// scroll color to right for every odd line
			for (j = 0;j < ScoreEntryLength;j++)
			{
				b = ScoreBuf[i].charAt(j);

				// center the char if no monospacefont is supported
				if (ScoreIsMonoSpace != 0)
					o = (ScoreCharWidth - PUTILS->charWidth(NULL, b)) / 2;

#ifdef SCORE_MARK_LAST_SCORE
				// change the color of the last added entry
				if (i == ScoreLastPosition
#ifdef SCORE_ONE_PER_MODE
					 && ScoreLastMode == currentScoreMode
#endif
					)
					PUTILS->setColor(m_pGraphics, GameColorRotation[c] | SCORE_MARK_COLOR_ADD);
				else
#endif
					PUTILS->setColor(m_pGraphics, GameColorRotation[c]);

				PUTILS->drawChar(m_pGraphics, b, ScoreStartX + j * ScoreCharWidth + o, ScoreScrollPos + ScoreStartY + i * ScoreCharHeight, 0);

				if (--c < 0)
					c = GameColorRotation.size() - 1;
			}
		}
	}
#endif SLOW_DEVICE
	// reset clip area
#ifndef doja
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif

#ifdef doja
#ifndef SCORE_IMAGE
	// restore background because we cannot clip in doja we have to paint over the start and the end of the scores to get the scoll in / out effect
	// we can't do that if a score image is involved
	PUTILS->setColor(m_pGraphics, SCORE_BACK_COLOR);
	PUTILS->fillRect(m_pGraphics, 0, ScoreStartY - 1 - ScoreCharHeight, ScreenWidth, ScoreCharHeight);
	PUTILS->fillRect(m_pGraphics, 0, ScoreStartY - 1 + ScoreWidthY + 1, ScreenWidth, ScoreCharHeight);
#endif
#endif

	// print headline depending on the device screen resolution
	if (ScreenHeight < 100)
		i = 0;
	else
		i = 1;

#ifdef SCORE_ONE_PER_MODE
	// move the side arrows
	if (ScoreInputArrowPos++ >= PUTILS->charWidth(NULL, '>'))
		ScoreInputArrowPos = 0;

#ifndef doja
	// reconstruct animation background
	//g.setClip(0, i * ScoreCharHeight, ScreenWidth, ScoreCharHeight);
	//paintScoreBackground();
#endif
#endif
#ifndef doja
	// reset clipping area
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
	if (SCORE_TEXT_COLOR == -1)
		PUTILS->setColor(m_pGraphics, GameColorRotation[ScoreColor]);
	else
		PUTILS->setColor(m_pGraphics, SCORE_TEXT_COLOR);

	// print the headline
	PUTILS->drawString(m_pGraphics, ScoreTitel, ScoreTitelXPos, ScoreTitleYPos, SHADOW);

#ifdef SCORE_ONE_PER_MODE
	if (currentScoreMode > 0)
		PUTILS->drawChar(m_pGraphics, '<', ScoreTitelXPos - PUTILS->charWidth(NULL, '<') - 3 - ScoreInputArrowPos, ScoreTitleYPos, SHADOW);

	if (currentScoreMode < MENU_DIFFICULT_LEVELS - 1)
		PUTILS->drawChar(m_pGraphics, '>', ScoreTitelXPosEnd + 3 + ScoreInputArrowPos, ScoreTitleYPos, SHADOW);
#endif

#ifndef USE_COMMANDS
	// call paintMenuButton to draw (and fade out) the menubutton
	paintMenuButton();
#endif USE_COMMANDS
#endif SCORE_IS_EXTERNAL
}

void aMain::keyScore(int keyCode)
{
#ifdef SCORE_IS_EXTERNAL
	myGame->keyScore(keyCode);
#else  SCORE_IS_EXTERNAL
	if (PKEY->isSoftLeft(keyCode) || PKEY->isSoftRight(keyCode) || PKEY->isFire(keyCode) || PKEY->isClear(keyCode))
	{
		processApplicationState(APPLICATION_MAINMENU);

		// force new rendering of highscores next time
		ScoreBuf.removeAll();
		return;
	}
#ifdef SCORE_ONE_PER_MODE
	else if (PKEY->isLeft(keyCode))
	{
		if (currentScoreMode > 0)
		{
			doFullPaint = true;
			myScores = &myModeScores[--currentScoreMode];
			ScoreBuf.removeAll();
		}
	}
	else if (PKEY->isRight(keyCode))
	{
		if (currentScoreMode + 1 < MENU_DIFFICULT_LEVELS)
		{
			doFullPaint = true;
			myScores = &myModeScores[++currentScoreMode];
			ScoreBuf.removeAll();
		}
	}
#endif
#endif SCORE_IS_EXTERNAL
}


#ifdef GAME_HISCORE_UPLOAD
//  *****************************************************************
//  **********  score uploading  ************************************
//  *****************************************************************
void aMain::keyScoreUpload(int keyCode)
{
	if (aKey.isUp(keyCode))
		myTextBox.movePos( - 1);
	else if (aKey.isDown(keyCode))
		myTextBox.movePos(1);
	else if (aKey.isLeft(keyCode))
		myTextBox.pageUp();
	else if (aKey.isRight(keyCode))
		myTextBox.pageDown();
	else
	{
		myTextBox.clear();
		Main.processApplicationState(APPLICATION_HIGHSCORE);
	}
}

//TODO? static byte[] CodeChange = {GAME_HISCORE_CODECHANGE};

void aMain::paintScoreUpload()
{
	// need to prepare the textbox?
	if (isNewGameState == _TRUE_)
	{
		isNewGameState = _FALSE_;

		lastHelpPos = -1;

		// clear old text, add new and use a font depending on the screensize
		myTextBox.clear();

		//final String url = myInit.getAppProperty("CMX - HiScore - URL");
		final String url = "GAME_HISCORE_UPLOAD_URL";
		// if no url can be retrieved from the jad file we cancel this mode and go over to displaying the hiscore
		if (url == null)
		{
			myTextBox.clear();
			Main.processApplicationState(APPLICATION_HIGHSCORE);
			return;
		}

		myTextBox.addLine(TEXT_CONST_SU1 + url + TEXT_CONST_SU2);

		// we need CodeChange.length bytes for the code generation
		final byte[] b = new byte[CodeChange.length];

		// store played score in 3 bytes
		b[0] = (byte)((ScorePlayed)		& 0xff);
		b[1] = (byte)((ScorePlayed>>8)	& 0xff);
		b[2] = (byte)((ScorePlayed>>16)	& 0xff);

		// make it unique by adding 2 random bytes
		int r = (myRandom.nextInt()&0xffff);
		b[3] = (byte)((r)		&0xff);
		b[4] = (byte)((r>>8)	&0xff);

		// calc the needed crc and add the first 2 bytes of it
		final long crc = PUTILS->crc32(b, 0, 5);
		b[5] = (byte)((crc)		&0xff);
		b[6] = (byte)((crc>>8)	&0xff);

		int i;
		final StringBuffer sb = new StringBuffer();
// System.out.println(((ScorePlayed)&0xff)  + " : " + ((ScorePlayed>>8)&0xff));
// System.out.println("ByteArray:" + (b[0]&0xff) + " : " + (b[1]&0xff) + " : "  + (b[2]&0xff) + " : "  + (b[3]&0xff) + " : "  + (b[4]&0xff) + " : "  + (b[5]&0xff) + " : "  + (b[6]&0xff));

		for (i = 0; i < CodeChange.length; i++)
		{
			if (b[CodeChange[i]] >= 0 && b[CodeChange[i]] < 16)
				sb.append('0');
			sb.append(Integer.toHexString(((int)b[CodeChange[i]])&0xff));
		}

		// get the final string
		String s = sb.toString();

		// transpose all numbers
		for (i = 0; i < CodeChange.length * 2; i++)
			s = s.replace((char)('0' + i), (char)('g' + i));

		// add the final code to the textbox
		myTextBox.addLine("%b" + s.toUpperCase());

// System.out.println("Code:" + s.toUpperCase() + " Original:" + ScorePlayed + ", " + r);
// System.out.println("uncryptScore():" + uncryptScore(s.toUpperCase()));

		// prepare the textbox device dependent
		PUTILS->prepareTextBox(myTextBox, ScreenWidth, ScreenHeight);
	}

	// only paint if something changed or a fullpaint is requested
	if (doFullPaint || lastHelpPos != myTextBox.getPos())
	{
		// store last help text position
		lastHelpPos = myTextBox.getPos();
		doFullPaint = false;

		// paint it
		PUTILS->setColor(g, HELP_BACK_COLOR);
		PUTILS->fillRect(g, 0, 0, ScreenWidth, ScreenHeight);
		PUTILS->setColor(g, HELP_TEXT_COLOR);
		myTextBox.paint(g, true, true);
	}
}
#endif GAME_HISCORE_UPLOAD
#endif !GAME_NO_HIGHSCORE

//  *******************************************************************
//  **********  help methods  *****************************************
//  *******************************************************************
void aMain::preHelp()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif
}

void aMain::postHelp()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
}

void aMain::paintHelp()
{
#ifdef debug
	//System.out.println("Main::paintHelp");
#endif
#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// while sliding out the menubutton a full repaint is required...
	if ((menuButtonOffset > 0) && (MenuCommandTime != 0)) 
	{
		doFullPaint = true;
	}
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS

#ifdef HELP_IS_EXTERNAL

	// let game paint the help
	PGAME->paintHelp(doFullPaint);
	// ok was painted once completely
	doFullPaint = false;

#else HELP_IS_EXTERNAL
	// need to prepare the textbox?
	if (isNewGameState == _TRUE_)
	{
		// show waiting screen for slow devices
		if (showingHelpWait == _FALSE_)
		{
			showingHelpWait = _TRUE_;
			PUTILS->setColor(m_pGraphics, HELP_BACK_COLOR);
			PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
##if BREWVERSION > 0x1
			PUTILS->setFontColor(HELP_TEXT_COLOR);
##endif
#ifndef GAME_USE_TEXT_DEFINES
			String s;
#ifdef GAME_USE_BTEXT_CLASS
			// get the wait message of the new language we are switching to
			if ((s = myText->getWaitMessage(currentLanguage)).length() == 0)
				s = "...";
#else
					s = myText->get("w");
#endif

#else
					String s = TEXT_CONST_WAIT;

#endif GAME_USE_TEXT_DEFINES
			// use a smaller font...
			int _length = PUTILS->stringWidth(NULL, s);
			PUTILS->setFont(m_pGraphics, PUTILS->getFont(m_pGraphics));
			PUTILS->drawString(m_pGraphics, s, (ScreenWidth - _length)/2,(ScreenHeight - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)))/2,0);//VCENTER|SHADOW);//HCENTER|
			IDISPLAY_UpdateEx(m_pIDisplay, false);
			return;
		}
		showingHelpWait = _FALSE_;

		lastHelpPos = -1;
		isNewGameState = _FALSE_;

		// clear old text, add new and use a font depending on the screensize
		myTextBox->clear();
		myTextBox->addLine(TEXT_CONST_HELP);
		myTextBox->addLine(myText->get("li"));

		// the precompiler will parse in the needed infos
		//myTextBox->addLine("GAME_HELP_ABOUT_LINE");

		// prepare the textbox device dependent
		PUTILS->prepareTextBox(myTextBox, ScreenWidth, ScreenHeight);
		restartMusic = _TRUE_;
	}

#ifndef USE_COMMANDS
#ifdef GAME_BUTTON_IMAGE
	// while sliding out the menubutton a full repaint is required...
	if ((doFullPaint == true) || (lastHelpPos != myTextBox->getPos())
#ifndef BUTTON_PAINT_ALWAYS
		|| ((menuButtonOffset > 0) && (menuButtonOffset < PUTILS->getImageHeight(menuButton)))
#endif !BUTTON_PAINT_ALWAYS
	){
#ifndef doja
		// ... but only the place behind the button image needs to be repainted (whatever this might be)
		if ((doFullPaint == false) && (lastHelpPos == myTextBox->getPos())) 
		{
			/*
			g.setClip(
#ifdef GAME_BUTTON_IMAGE
				ScreenWidth - menuButton.getWidth(),
				ScreenHeight - menuButton.getHeight(),
				menuButton.getWidth(),
				menuButton.getHeight());
#else  GAME_BUTTON_IMAGE
				ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth,
				ScreenHeight - mySmallFontHeight,
				mySmallFontMenuWidth + mySmallFontSpaceWidth,
				mySmallFontHeight);
#endif GAME_BUTTON_IMAGE
				*/
		}
#endif doja
#else GAME_BUTTON_IMAGE
	// only paint if something changed or a fullpaint is requested
	if (doFullPaint || lastHelpPos != myTextBox->getPos()) 
	{
#endif GAME_BUTTON_IMAGE
#else !USE_COMMANDS
	// only paint if something changed or a fullpaint is requested
	if (doFullPaint || lastHelpPos != myTextBox->getPos()) 
	{
#endif !USE_COMMANDS



		// store last help text position
		lastHelpPos = myTextBox->getPos();
		doFullPaint = false;

		// paint it
		PUTILS->setColor(m_pGraphics, HELP_BACK_COLOR);
		PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
		PUTILS->setColor(m_pGraphics, HELP_TEXT_COLOR);
		myTextBox->paint(m_pGraphics, true, true);
	}
#endif HELP_IS_EXTERNAL

#ifndef USE_COMMANDS
	// call paintMenuButton to draw (and fade out) the menubutton
	paintMenuButton();
#endif USE_COMMANDS
}

#ifdef HELP_IS_EXTERNAL
void aMain::endHelp()
{
	processApplicationState(APPLICATION_MAINMENU);
}
#endif HELP_IS_EXTERNAL

void aMain::keyHelp(int keyCode)
{
#ifdef HELP_IS_EXTERNAL
	PGAME->keyHelp(keyCode);
#else HELP_IS_EXTERNAL
	if (PKEY->isUp(keyCode))
		myTextBox->movePos( - 1);
	else if (PKEY->isDown(keyCode))
		myTextBox->movePos(1);
	else if (PKEY->isLeft(keyCode))
		myTextBox->pageUp();
	else if (PKEY->isRight(keyCode))
		myTextBox->pageDown();
	else if (PKEY->isCall(keyCode))
	{
		return;
	}
	else
	{
		myTextBox->clear();
		processApplicationState(APPLICATION_MAINMENU);
		// finished with the help, so get out
		return;
	}
#endif HELP_IS_EXTERNAL
}

#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
//  ************************************************************
//  **********  language screen methods  ***********************
//  ************************************************************
void aMain::preLanguage()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif
#ifdef GAME_USE_ARROWS
#ifdef LANG_ARROW_LEFT && LANG_ARROW_RIGHT
	if(PUTILS->charWidth(NULL, LANG_ARROW_LEFT) > PUTILS->charWidth(NULL, LANG_ARROW_RIGHT))
		arrowLength = PUTILS->charWidth(NULL, LANG_ARROW_LEFT);
	else
		arrowLength = PUTILS->charWidth(NULL, LANG_ARROW_RIGHT);
#endif
#endif
}

void aMain::postLanguage()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
#ifdef PLAY4PRIZES
	editChars.removeAll();
	String _editChars[] = {MAIN_ARRAY_MISC_SMS_KEY_MAP_STRING};
	for(int i = 0; i < (sizeof(_editChars)/sizeof(String)); i++)
		editChars.append(_editChars[i]);

#endif
}

void aMain::keyLanguage(int keyCode)
{
	if (PKEY->isUp(keyCode))
	{
		if (currentLanguage > 0)
			currentLanguage--;
	}
	else if (PKEY->isDown(keyCode))
	{
		if (++currentLanguage >= myText->getDomainNumber())
			currentLanguage = myText->getDomainNumber() - 1;
	}
	else if (PKEY->isSoftLeft(keyCode) || PKEY->isFire(keyCode) || PKEY->isSoftRight(keyCode))
	{
		// only switch language if really neccessary
		if (isConfigured == _FALSE_ || myText->getDomain().length() == 0 ||
			!myText->getDomain().equals((String)(*(myText->getDomains()))[currentLanguage]))
		{
#ifdef PLAY4PRIZES
	editChars.removeAll();
	String _editChars[] = {MAIN_ARRAY_MISC_SMS_KEY_MAP_STRING};
	for(int i = 0; i < (sizeof(_editChars)/sizeof(String)); i++)
		editChars.append(_editChars[i]);

#endif
			isNewLanguage = _TRUE_;
			isWaiting = _TRUE_;
			IDISPLAY_UpdateEx(m_pIDisplay, false);
			// try to force the paint
		}
		else 
		{
			// leave selection screen
			// return to the menu
			//adi------------- back to previous game state and menu item
			if (BackGameState >= APPLICATION_MAIN_MAX) {
				processApplicationState(BackGameState);
			    currentMenuItem = oldMenuItem;
			} else {
				processApplicationState(APPLICATION_MAINMENU);
			}
			//adi -------
			return;
		}
	}
	else if ( myKey->isClear(keyCode)) 
	{
		//processApplicationState(APPLICATION_MAINMENU);
		// return to the menu
		//adi------------- back to previous game state and menu item
		if (BackGameState >= APPLICATION_MAIN_MAX) {
			processApplicationState(BackGameState);
		    currentMenuItem = oldMenuItem;
		} else {
			processApplicationState(APPLICATION_MAINMENU);
		}
		//adi -------
		return;
	}
}

void aMain::paintLanguage()
{
	doFullPaint = true;
	// added waiting screen for sharp gx15 because it needs too much time for accessing the recordstore
	if (isWaiting == _TRUE_)
	{
		isWaiting = _FALSE_;
		PUTILS->setColor(m_pGraphics, LANG_BACK_COLOR);
		PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
##if BREWVERSION > 0x1
		PUTILS->setFontColor(LANG_TEXT_COLOR);
##endif

#ifndef GAME_USE_BTEXT_CLASS
		// we have to switch the language before painting the waitmessage if using aText (else it will display the wait message in a wrong language)
		myText->setDomain((String)(*(myText->getDomains()))[currentLanguage]);
#endif

		// get the wait message of the new language we are switching to
#ifdef GAME_USE_BTEXT_CLASS
		String s = myText->getWaitMessage(currentLanguage);
		if (s.length() == 0)
			s = "...";
#else
		String s = myText->get("w");
#endif

		PUTILS->drawString(m_pGraphics, s, 0, 0, HCENTER | VCENTER);
		return;
	}

	// did we set a new language?
	if (isNewLanguage == _TRUE_)
	{
#ifdef MENU_MUSIC
//		mySound->mute(_TRUE_);
		stopSound();
		restartMusic = _TRUE_;
#endif
#ifdef GAME_USE_BTEXT_CLASS
		// we have to switch the language after painting the wait message if using bText (else it will display the wait message in a wrong language)
		myText->setDomain((String)(*(myText->getDomains()))[currentLanguage]);
#endif
		if ( myText->isParseReady == true ) 
		{
			isNewLanguage = _FALSE_;
#ifndef GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL
// 			MenuText = getMenuItemText(menuEntries[currentMenuItem]);
#endif !GAME_NO_CLASSIC_MENU || MENU_IS_EXTERNAL
		processApplicationState(APPLICATION_MAINMENU);
		writeConfig();
#ifdef MENU_MUSIC
		// restart music here
		if (restartMusic == _TRUE_)
		{
			restartMusic = _FALSE_;
			stopSound();
//			mySound->mute(_FALSE_);
			playSound(MenuMusic, 1);
		}
#endif
		}
		return;
	}

	// only paint what is needed
	if ((doFullPaint == true) || (currentLanguage != posLanguage)
#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// while sliding out the menubutton a full repaint is required...
	|| ((menuButtonOffset > 0) && (MenuCommandTime != 0))
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS
	) {
		String s;
//		final Font f = PUTILS->getFont(g);
		int h = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
		int l = myText->getDomainNumber();
		WStringVector* v = myText->getDomains();

		posLanguage = currentLanguage;
		doFullPaint = false;

		// calc screenlayout only one time
		if (LanguageSepY < 0)
		{
			LanguageSepY = (ScreenHeight - (h * l)) / (l - 1);

			if (LanguageSepY > h)
				LanguageSepY = h;
			else if (LanguageSepY < 0)
				LanguageSepY = 0;
		}

		LanguageStartY = (ScreenHeight - (h * l) - ((l - 1) * LanguageSepY)) / 2;

		if (LanguageStartY < 0)
			LanguageStartY = 0;

		PUTILS->setColor(m_pGraphics, LANG_BACK_COLOR);
		PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
##if BREWVERSION > 0x1
		PUTILS->setFontColor(LANG_TEXT_COLOR);
##endif

		for (int i = 0; i < l; i++) 
		{
			s = (String) (*v)[i];

			// this call is needed because of the need to recalculate arrow positions (last parameter is _TRUE_)
			if (i == currentLanguage) 
			{
#ifdef GAME_USE_ARROWS
#ifdef MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
     paintArrows(m_pGraphics, LANG_NUM_ARROWS, LANG_ARROW_LEFT, LANG_ARROW_RIGHT, LanguageStartY + i * (h + LanguageSepY), LANG_ARROWS_X_OFFSET, s, GameColorRotation, LANG_TEXT_COLOR, LANG_SCROLL_IN, _TRUE_, ScreenWidth, 0, _TRUE_);
#else
     paintArrows(m_pGraphics, LANG_NUM_ARROWS, LANG_ARROW_LEFT, LANG_ARROW_RIGHT, LanguageStartY + i * (h + LanguageSepY), LANG_ARROWS_X_OFFSET, s, GameColorRotation, LANG_TEXT_COLOR, LANG_SCROLL_IN, _TRUE_, ScreenWidth, 0);
#endif MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
#endif GAME_USE_ARROWS
				MenuText = s;
			}
##if BREWVERSION > 0x1
			PUTILS->setFontColor(LANG_TEXT_COLOR);
##endif
			PUTILS->drawString(m_pGraphics, s, 0, LanguageStartY + i * (h + LanguageSepY), HCENTER | SHADOW);
		}

		LanguageStartY += (currentLanguage * (h + LanguageSepY));
	}

	// cycle color
	cycled++;
	// don't exceed array
	cycled %= GameColorRotation.size();

##if BREWVERSION > 0x1
	PUTILS->setFontColor(LANG_HIGHLIGHT_COLOR);
##endif

	// do the printing
	PUTILS->drawString(m_pGraphics, MenuText, 0, LanguageStartY, HCENTER | SHADOW);
#ifdef GAME_USE_ARROWS
	paintArrows(m_pGraphics,LANG_NUM_ARROWS, LANG_ARROW_LEFT, LANG_ARROW_RIGHT, LanguageStartY, LANG_ARROWS_X_OFFSET, MenuText, GameColorRotation, LANG_TEXT_COLOR, LANG_SCROLL_IN, _FALSE_, ScreenWidth, 0);
#endif
#ifndef USE_COMMANDS
	// call paintMenuButton to draw (and fade out) the menubutton
	paintMenuButton();
#endif USE_COMMANDS
}
#endif GAME_NO_LANGUAGE_SELECTION_SCREEN

#ifdef GAME_USE_GALLERY
void aMain::preGallery()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
#ifdef MARTIN
	MenuCommandCancelName = TEXT_CONST_MCA;

	if(PGAME->m_bool_game_runs == _TRUE_)
	{
		//setSoftKey(MenuCommandCancelName, SOFT_KEY_1);
	}
#endif MARTIN
	//setSoftKey(MenuCommandName, SOFT_KEY_2);
#endif
#endif

// TODO OPTIMIZE
	// by default don't use the galleryYOffset  = > previews won't be used
	galleryYOffset = 0;

	int prevHeight, imHeight;
	prevHeight = imHeight = galleryImageHeight = 0;
#ifdef GALLERY_USE_PREVIEWS
	galleryPreviewHeight = 0;
	// get galleryPreviews if not already TODO cache previews if possible / necessary
	if (galleryPreview == NULL) 
	{
#ifdef GAME_SINGLE_PREVIEWS
		// initialize array
		Image* _Image=NULL;
		for(int i=0; i < numImages; i++)
		{
			//galleryPreview = new Image[numImages];
			galleryPreview.append(_Image);
		}
		// try to get all images
		char _cBuf[10];
		String _szBuf = GAME_PREVIEWS_PREFIX
		for(int i = GAME_IMAGE_START; i < (GAME_IMAGE_START + numImages); i++) 
		{
			_szBuf += _itoa(i, _cBuf, 10);
			_szBuf += GAME_PREVIEWS_SUFFIX;
			if(galleryPreview[i - GAME_IMAGE_START] == NULL)
				galleryPreview[i - GAME_IMAGE_START] = aUtils.fetchImage(_szBuf);
		}
		// did we get them? (only first image checked)
		if (galleryPreview[0] != NULL) 
		{
			// note size
			galleryPreviewHeight = PUTILS->getImageHeight(galleryPreview[0]);
			galleryPreviewWidth = PUTILS->getImageWidth(galleryPreview[0]);
		}
#else  GAME_SINGLE_PREVIEWS
		// try to get image
		String _szBuf = GAME_PREVIEWS_PREFIX;
		_szBuf += GAME_PREVIEWS_SUFFIX;
		if(galleryPreview == NULL)
			galleryPreview = aUtils.fetchImage(_szBuf);
		// did we get it?
		if (galleryPreview != NULL)
		{
			// note size
			galleryPreviewHeight = PUTILS->getImageHeight)galleryPreview);
			galleryPreviewWidth = PUTILS->getImageWidth(galleryPreview) / numImages;
		}
#endif GAME_SINGLE_PREVIEWS
	}
	// do we have the height?
	if (galleryPreviewHeight > 0) 
	{
#ifdef GALLERY_USE_PREVIEWS_BORDER
		// calculate thickness once
		if (galleryPreviewBorder <= 0) 
		{
#ifdef GALLERY_PREVIEWS_BORDER_THICKNESS
			// get thickness of the border
			galleryPreviewBorder = GALLERY_PREVIEWS_BORDER_THICKNESS;
			// is the thickness of the border defined larger than the amount of usable colors?
			if (galleryPreviewBorder > GameColorRotation.size())
			{
				// if so get amount of colors
				galleryPreviewBorder = (byte) GameColorRotation.size();
			}
#else  GALLERY_PREVIEWS_BORDER_THICKNESS
			// thickness of the border is GameColorRotation.size() / 3
			galleryPreviewBorder = (byte) (GameColorRotation.size() / 3);
#endif GALLERY_PREVIEWS_BORDER_THICKNESS
			// not enough space for previews AND border?
			if ((galleryPreviewBorder * 2) > (ScreenWidth - galleryPreviewWidth * numImages)) 
			{
				galleryPreviewBorder = (byte) ((ScreenWidth - 2 - galleryPreviewWidth * numImages) / 2);
			}
		}
		// double the thickness of the border because of 2 borders (left and right)
		prevHeight = galleryImageBorder * 2;
#endif GALLERY_USE_PREVIEWS_BORDER
		// add height of the preview image
		prevHeight += galleryPreviewHeight;
	}
#endif GALLERY_USE_PREVIEWS

	// get a gallery image if not already
	char _cBuf[10];
	String _szBuf = GAME_IMAGE_PREFIX;
	_szBuf += _itoa(GAME_IMAGE_START, _cBuf, 10);
	_szBuf += GAME_IMAGE_SUFFIX;
	if (galleryImage == NULL) 
	{
		galleryImage = PUTILS->fetchImage(_szBuf);
	}
	// did we get it?
	if (galleryImage != NULL) 
	{
		// note size
		galleryImageHeight = PUTILS->getImageHeight(galleryImage);
		galleryImage->release();
		delete(galleryImage);
		// (and) forget it
		galleryImage = NULL;
	}

	// do we have the height?
	if (galleryImageHeight > 0) 
	{
#ifdef GALLERY_USE_IMAGE_BORDER
		// calculate thickness once
		if (galleryImageBorder <= 0) 
		{
#ifdef GALLERY_IMAGE_BORDER_THICKNESS
			// get thickness of the border
			galleryImageBorder = GALLERY_IMAGE_BORDER_THICKNESS;
			// is the borderthickness defined larger than the amount of usable colors?
			if (galleryImageBorder > GameColorRotation.size()) 
			{
				// if so get amount of colors
				galleryImageBorder = (byte) GameColorRotation.size();
			}
#else  GALLERY_IMAGE_BORDER_THICKNESS
			// thickness of the border is GameColorRotation.size() / 2
			galleryImageBorder = (byte) (GameColorRotation.size() / 2);
#endif GALLERY_IMAGE_BORDER_THICKNESS
			// not enough space for image AND border?
			if ((galleryImageBorder * 2) > (ScreenWidth - galleryImageWidth)) 
			{
				galleryImageBorder = (byte) ((ScreenWidth - galleryImageWidth - 2) / 2);
			}
			// not enough space for image AND border?
			if ((galleryImageBorder * 2) > (ScreenHeight - galleryImageHeight)) 
			{
				galleryImageBorder = (byte) ((ScreenHeight - galleryImageHeight - 2) / 2);
			}
		}
		// double the thickness of the border because of 2 borders (left and right)
		imHeight = galleryImageBorder * 2;
#endif GALLERY_USE_IMAGE_BORDER
		// add height of the preview image
		imHeight += galleryImageHeight;
	}

	// could we determine the necessary values?
	if ((imHeight + prevHeight != 0) && (ScreenHeight - imHeight - prevHeight > 0)) 
	{
		// yes, so calculate offset for the gallery (top - down: offset | image | approx. 2 * offset | previews | offset)
		galleryYOffset  =
			(ScreenHeight - galleryImageHeight
#ifdef GAME_USE_PREVIEWS
			 -  galleryPreviewHeight
#endif GAME_USE_PREVIEWS
			) / 7 * 2;	// < -  nice positions...
#ifdef debug
	} 
	else if (imHeight + prevHeight == 0) 
	{
		myDebug->add(1, "Main::preGallery()  NO preview -  and imageheight could be determined!");
	} 
	else 
	{
		//myDebug->add(1, "Main::preGallery()  too little space to show previews (height needed: " + (imHeight + prevHeight) + "  is: " + ScreenHeight + ")");
#endif debug
	}
#ifdef MENU_MUSIC
	playSound(MenuMusic, 1);
#endif
}

void aMain::postGallery()
{
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
#ifdef MARTIN
	//removeSoftKey(SOFT_KEY_1);
#endif MARTIN
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
}

 /**
 * TODO  remember last shown / won image
 * gets called when GAME_USE_GALLERY is defined in the game.h and "Gallery" was chosen in the
 * menu. should be used to integrate a gallery into the game
 */
void aMain::paintGallery()
{
#ifdef MARTIN
	boolean _bpaintMenuButton = true;
#endif MARTIN
#ifdef GALLERY_IS_EXTERNAL
#ifdef MARTIN
	_bpaintMenuButton =
#endif MARTIN
		PGAME->paintGallery(doFullPaint);
#else GALLERY_IS_EXTERNAL

	int i;
	// prepare gallery if not already
	if (galleryFlags != 0 && (galleryImage == NULL || galleryIndex < 0 || galleryIndex > numImages)) 
	{
		// try to get same image as last time gallery was visited
// 			galleryIndex--;
		checkGalleryIndex(_FALSE_);
	}

#ifndef doja
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// while sliding out the menubutton a full repaint is required...
	if ((doFullPaint == true) || ((menuButtonOffset > 0) && (MenuCommandTime != 0))) 
	{
#ifndef doja
		// ... but only the place behind the button image needs to be repainted (whatever this might be)
		if ((doFullPaint == false) && (drawGalleryImage == _FALSE_)) 
		{
		//	g.setClip(menuButtonX, menuButtonY, menuButtonW, menuButton.getHeight());
		}
#endif doja
#else  !USE_COMMANDS || BUTTON_PAINT_ALWAYS
	if (doFullPaint == true) {
#endif !USE_COMMANDS || BUTTON_PAINT_ALWAYS

		// mark for initial drawing
		drawGalleryImage = _TRUE_;
		PUTILS->setColor(m_pGraphics, GALLERY_BACKGROUND_COLOR);
		PUTILS->fillRect(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
#ifdef MENU_TILED_IMAGE && GALLERY_DRAW_TILED_IMAGE
				paintTiledImage(tiledImage, 0, 0, _FALSE_, _FALSE_);
#endif
#ifdef GALLERY_USE_PREVIEWS
		// if enough space draw previews also
		if (galleryYOffset > 0) 
		{
			paintGalleryPreview();
#ifdef doja || USE_COMMANDS
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
			// draw black borders around each single preview
			paintPreviewDivider();
#endif GALLERY_USE_PREVIEWS_DIVIDER
#else doja || USE_COMMANDS
#ifdef GAME_BUTTON_IMAGE
			//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
			// draw black borders around each single preview
			paintPreviewDivider();
#endif GALLERY_USE_PREVIEWS_DIVIDER
//TODO				// repaint only where the button slides out needed
//				if ((doFullPaint == false) && (drawGalleryImage == _FALSE_)) {
//					g.setClip(menuButtonX, menuButtonY, menuButtonW, menuButton.getHeight());
//				}
#else GAME_BUTTON_IMAGE
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
			// draw black borders around each single preview
			paintPreviewDivider();
#endif GALLERY_USE_PREVIEWS_DIVIDER
#endif GAME_BUTTON_IMAGE
#endif doja || USE_COMMANDS
		}
#endif GALLERY_USE_PREVIEWS
		// if no pic is free just draw string
		if (galleryFlags == 0) 
		{
						drawCenteredString(TEXT_CONST_NOP, 0, _TRUE_, _FALSE_);
		}
	}
// TODO OPTIMIZE REPAINT
	if (galleryFlags == 0) 
	{
#ifndef doja
		// reset clipping
	   //	g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif doja
		// if no pic is free just animate string
				drawCenteredString(TEXT_CONST_NOP, 0, _TRUE_, _FALSE_);
	} else {
		// if image is not there don't try to draw it
		if (galleryImage == NULL) 
		{
			drawGalleryImage = _FALSE_;
		}

		// if a key is pressed (or initial drawing (see above)) draw image
		if (drawGalleryImage == _TRUE_) 
		{
#ifdef GALLERY_USE_PREVIEWS
			if (galleryYOffset > 0)
				PUTILS->drawImage(m_pGraphics, galleryImage, (ScreenWidth - galleryImageWidth) / 2, galleryYOffset + 1, 0);
			else
#endif GALLERY_USE_PREVIEWS
				PUTILS->drawImage(m_pGraphics, galleryImage, (ScreenWidth - galleryImageWidth) / 2, (ScreenHeight - galleryImageHeight) / 2, 0);

#ifdef GALLERY_USE_IMAGE_BORDER || GALLERY_USE_ARROWS || GALLERY_USE_PREVIEWS_BORDER
			int xOffset = 0;
			int yOffset = 0;
			byte colorlength = (byte) GameColorRotation.size();
#endif GALLERY_USE_IMAGE_BORDER || GALLERY_USE_ARROWS || GALLERY_USE_PREVIEWS_BORDER

			// draw border around image
			for (i = 0; i < galleryImageBorder; i++) 
			{
				xOffset = galleryImageWidth + (2 * i);
				yOffset = galleryImageHeight + (2 * i);
				PUTILS->setColor(m_pGraphics, GameColorRotation[i]);
#ifdef GALLERY_USE_PREVIEWS
				if (galleryYOffset > 0)
					PUTILS->drawRect(m_pGraphics, (ScreenWidth - xOffset) / 2, galleryYOffset - i, xOffset, yOffset);
				else
#endif GALLERY_USE_PREVIEWS
					PUTILS->drawRect(m_pGraphics, (ScreenWidth - xOffset) / 2, (ScreenHeight - yOffset) / 2, xOffset, yOffset);
			}

#ifdef GALLERY_USE_ARROWS
			// draw Arrows
			byte arrowWidth;
			_BOOLEAN_ onePicFree = _FALSE_;
			_BOOLEAN_ drawArrows = _FALSE_;

			// get arrow size
#ifdef GALLERY_ARROWS_WIDTH
			arrowWidth = GALLERY_ARROWS_WIDTH;
			if ((arrowWidth / 2) > colorlength) 
			{
				arrowWidth = colorlength;
			}
			// make it even
			arrowWidth = (byte) (arrowWidth & 0xFE);	// (11111110)
#else  GALLERY_ARROWS_WIDTH
			arrowWidth = (byte) colorlength;
#endif GALLERY_ARROWS_WIDTH

			// test each bit
			for (i = 0; i < numImages; i++) 
			{
				if ((galleryFlags & (2 << i)) != 0) 
				{
					if (onePicFree == _TRUE_) {
						// more than one pic is free  - > draw arrows
						drawArrows = _TRUE_;
						break;
					}
					// yep - one pic is free
					onePicFree = _TRUE_;
				}
			}

			if (drawArrows == _TRUE_) 
			{
				yOffset = ScreenHeight / 2;
#ifdef GALLERY_USE_PREVIEWS
				if (galleryYOffset > 0) 
				{
					yOffset = galleryYOffset + galleryImageHeight / 2;
				}
#endif GALLERY_USE_PREVIEWS
#ifdef GALLERY_USE_IMAGE_BORDER
				// double the thickness of the border because of 2 borders (left and right)
				xOffset = galleryImageBorder * 2;
#endif GALLERY_USE_IMAGE_BORDER
				// add width of the preview image
				xOffset += galleryImageWidth;
				// get free space in pixel, we need the half of it (free space on one side of the gallery image)
				xOffset = (ScreenWidth - xOffset) / 2;
				// enough space to draw arrows?
				if (arrowWidth < xOffset) {
					// half of free space (on one side) is the center of the arrow
					xOffset  /= 2;
				} else {
					// NOT enough space (don't draw arrows)
					arrowWidth = 0;
				}
				// draw the arrows?
				if (arrowWidth > 0) {
					// half of the size of the arrow is needed (kind of radius)
					arrowWidth  /= 2;
					// draw every line
					for (i = 0; i < arrowWidth; i++) 
					{
						// set color
						PUTILS->setColor(m_pGraphics, GameColorRotation[i]);
						// left arrow  <|
						// top line
						PUTILS->drawLine(m_pGraphics, xOffset - 1 - i, yOffset, xOffset + i, yOffset - 1 - (i * 2));
						// bottom line
						PUTILS->drawLine(m_pGraphics, xOffset - 1 - i, yOffset, xOffset + i, yOffset + 1 + (i * 2));
						// vertical line
						PUTILS->drawLine(m_pGraphics, xOffset + i, yOffset - (i * 2), xOffset + i, yOffset + (i * 2));
						// right arrow  |>
						// top line
						PUTILS->drawLine(m_pGraphics, (ScreenWidth - xOffset) + i, yOffset, (ScreenWidth - xOffset) - 1 - i, yOffset - 1 - (i * 2));
						// bottom line
						PUTILS->drawLine(m_pGraphics, (ScreenWidth - xOffset) + i, yOffset, (ScreenWidth - xOffset) - 1 - i, yOffset + 1 + (i * 2));
						// vertical line
						PUTILS->drawLine(m_pGraphics, (ScreenWidth - xOffset) - 1 - i, yOffset - (i * 2), (ScreenWidth - xOffset) - 1 - i, yOffset + (i * 2));
					}
				}
			}
#endif GALLERY_USE_ARROWS

#ifndef doja
			// reset clipping
		   	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif doja

#ifdef GALLERY_USE_PREVIEWS
// we do NOT need an offset if we draw no dividers
#define GALLERY_PREVIEWS_BORDER_SIZE_OFFSET  -
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
			// draw black borders around each single preview if enough space
			if (galleryYOffset > 0) 
			{
				paintPreviewDivider();
			}
#else  GALLERY_USE_PREVIEWS_DIVIDER
#ifdef GALLERY_PREVIEWS_BLINK
			// if enough space, blinking active preview and NO divider between previews draw previews again
			if (galleryYOffset > 0) 
			{
				paintGalleryPreview();
			}
// we need an offset if we draw no dividers
#define GALLERY_PREVIEWS_BORDER_SIZE_OFFSET - 1
#endif GALLERY_PREVIEWS_BLINK
#endif GALLERY_USE_PREVIEWS_DIVIDER
#endif GALLERY_USE_PREVIEWS

#ifndef USE_COMMANDS
#ifdef GAME_BUTTON_IMAGE
			// as long as the menu button slides out the repaint ist needed
			if ((menuButtonOffset == 0) || (menuButtonOffset >= PUTILS->getImageHeight(menuButton)))
#endif GAME_BUTTON_IMAGE
#endif USE_COMMANDS
				// all done
				drawGalleryImage = _FALSE_;
		}

#ifdef GALLERY_USE_PREVIEWS && GALLERY_PREVIEWS_BLINK
		// let actual preview have a animated extra border
		if (galleryYOffset > 0) 
		{
			if (++cycled >= GameColorRotation.size()) 
			{
				cycled = 0;
			}
			PUTILS->setColor(m_pGraphics, GameColorRotation[cycled]);
			PUTILS->drawRect(m_pGraphics, (ScreenWidth / 2 - galleryPreviewWidth * (numImages / 2)) + galleryIndex * galleryPreviewWidth,
				ScreenHeight - galleryPreviewHeight - galleryYOffset,
				galleryPreviewWidth GALLERY_PREVIEWS_BORDER_SIZE_OFFSET,
				galleryPreviewHeight GALLERY_PREVIEWS_BORDER_SIZE_OFFSET);
		}
#endif GALLERY_USE_PREVIEWS && GALLERY_PREVIEWS_BLINK
	}

#endif GALLERY_IS_EXTERNAL
	// still in mode gallery?
	if (m_iGameState == APPLICATION_GALLERY)
		doFullPaint = false;

#ifndef USE_COMMANDS
	// call paintMenuButton to draw (and fade out) the menubutton
#ifdef MARTIN
	if (_bpaintMenuButton)
#endif MARTIN
	{
			paintMenuButton();
	}
#endif USE_COMMANDS

	FrameTime = PGAME->FrameTime;
#undef GALLERY_PREVIEWS_BORDER_SIZE_OFFSET
}

#ifdef GALLERY_USE_PREVIEWS
// paint preview pictures TODO borderthickness ist 1 zu wenig wenn paint dividers genutzt wird
void aMain::paintGalleryPreview()
{
#ifdef GALLERY_IS_EXTERNAL
	PGAME->paintGalleryPreview();
#else GALLERY_IS_EXTERNAL
	int i;
#ifdef GAME_SINGLE_PREVIEWS
	int xOffset = ScreenWidth / 2 - galleryPreviewWidth * (numImages / 2);
	int yOffset = ScreenHeight - galleryPreviewHeight - galleryYOffset;
	for (i = 0; i < numImages; i++) 
	{
		PUTILS->drawImage(m_pGraphics, galleryPreview[i], xOffset + galleryPreviewWidth * i, yOffset, 0);
	}
#else GAME_SINGLE_PREVIEWS
	PUTILS->drawImage(m_pGraphics, galleryPreview, ScreenWidth / 2 - galleryPreviewWidth * (numImages / 2), ScreenHeight - galleryPreviewHeight - galleryYOffset, 0);
#endif GAME_SINGLE_PREVIEWS

#ifdef GALLERY_USE_PREVIEWS_BORDER
// we need an offset depending on if we draw dividers or not
#ifdef GALLERY_USE_PREVIEWS_DIVIDER
#define GALLERY_PREVIEWS_BORDER_SIZE_OFFSET 2
#else
#define GALLERY_PREVIEWS_BORDER_SIZE_OFFSET 1
#endif GALLERY_USE_PREVIEWS_DIVIDER
	// draw border...
	for (i = 0; i < galleryPreviewBorder; i++) 
	{
		PUTILS->setColor(m_pGraphics, GameColorRotation[i]);
		PUTILS->drawRect(m_pGraphics, ((ScreenWidth - galleryPreviewWidth * numImages - 2 * i) / 2) - 1,
			ScreenHeight - galleryPreviewHeight - galleryYOffset - i - 1,
			(galleryPreviewWidth * numImages) + (2 * i) + GALLERY_PREVIEWS_BORDER_SIZE_OFFSET,
			galleryPreviewHeight + (2 * i) + GALLERY_PREVIEWS_BORDER_SIZE_OFFSET);
	}
#undef GALLERY_PREVIEWS_BORDER_SIZE_OFFSET
#endif GALLERY_USE_PREVIEWS_BORDER
#endif GALLERY_IS_EXTERNAL
}

#ifdef GALLERY_USE_PREVIEWS_DIVIDER
// draw black borders around each single preview
void aMain::paintPreviewDivider()
{
	PUTILS->setColor(m_pGraphics, GALLERY_BACKGROUND_COLOR);
	for (int i = 0; i < numImages; i++) 
	{
		PUTILS->drawRect(m_pGraphics, (ScreenWidth / 2 - galleryPreviewWidth * (numImages / 2)) + (i * galleryPreviewWidth),
			ScreenHeight - galleryPreviewHeight - galleryYOffset, galleryPreviewWidth, galleryPreviewHeight);
	}
}
#endif GALLERY_USE_PREVIEWS_DIVIDER
#endif GALLERY_USE_PREVIEWS

void aMain::endGallery()
{
	processApplicationState(APPLICATION_MAINMENU);
}

// keyhandling within the gallery
void aMain::keyGallery(int keyCode)
{
#ifdef GALLERY_IS_EXTERNAL
// 		if (aKey.isSoftRight(keyCode))
// 			Main.processApplicationState(APPLICATION_MAINMENU);
// 		else
		PGAME->keyGallery(keyCode);
#else GALLERY_IS_EXTERNAL
	if (PKEY->isFire(keyCode) || PKEY->isSoftRight(keyCode) || PKEY->isClear(keyCode)) {
		// remove gallery image to save space
		if(galleryImage != NULL)
		{
			galleryImage->release();
			delete(galleryImage);
		}
		galleryImage = NULL;

#ifdef GALLERY_USE_PREVIEWS
#ifdef GAME_SINGLE_PREVIEWS
		// work all previews
		for(int i = GAME_IMAGE_START; i < (GAME_IMAGE_START + numImages); i++) 
		{
			// 'remove' previews
			if(galleryPreview[i - GAME_IMAGE_START] != NULL)
			{
				galleryPreview[i - GAME_IMAGE_START]->release();
				delete(galleryPreview[i - GAME_IMAGE_START]);
			}
			galleryPreview[i - GAME_IMAGE_START] = NULL;
		}
		// 'destroy' array
		galleryPreview.remove(0, galleryPreview.size());
		galleryPreview.destruct();
#else GAME_SINGLE_PREVIEWS
		if (galleryPreview != NULL) 
		{
			galleryPreview->release();
			delete(galleryPreview);
		}
		galleryPreview = NULL;
#endif GAME_SINGLE_PREVIEWS
#endif GALLERY_USE_PREVIEWS
		endGallery();
	} 
	else if (galleryFlags != 0) 
	{
		if (PKEY->isLeft(keyCode) || ((PKEY->KeyState & KEY_FLAG_FOUR) != 0)) 
		{
			checkGalleryIndex(_TRUE_);
		} 
		else if (PKEY->isRight(keyCode) || ((PKEY->KeyState & KEY_FLAG_SIX) != 0)) 
		{
			checkGalleryIndex(_FALSE_);
		}
	}
#endif GALLERY_IS_EXTERNAL
}

// checks for the next free picture in gallery
void aMain::checkGalleryIndex(_BOOLEAN_ reverse)
{
#ifdef debug
	//myDebug.add(1, "Main::checkGalleryIndex(" + reverse + ")");
#endif
	int i;
	int oldIndex = galleryIndex;

	// check all bits
	for (i = 0; i < 32; i++) 
	{
		// backwards
		if (reverse == _TRUE_) 
		{
			if (--galleryIndex < 0) 
			{
				galleryIndex = (numImages - 1);
			}
		}
		// forwards
		else 
		{
			if (++galleryIndex > (numImages - 1)) 
			{
				galleryIndex = 0;
			}
		}

		// check for the next available image
		if ((galleryFlags & (2 << galleryIndex)) != 0) 
		{
			// clean up
			if (galleryImage != NULL) 
			{
				galleryImage->release();
				delete(galleryImage);
				galleryImage = NULL;
			}
			char _cBuf[10];
			String _szBuf = GAME_IMAGE_PREFIX;
			_szBuf += _itoa((GAME_IMAGE_START + galleryIndex), _cBuf, 10);
			_szBuf += GAME_IMAGE_SUFFIX;
			if(galleryImage == NULL)
				galleryImage = PUTILS->fetchImage(_szBuf);

			// we got a new picture or the old one, but NOT no picture
			if (galleryImage != NULL) 
			{
				break;
			}
		}
	}

	// did we found a new one?
	if (galleryIndex != oldIndex) 
	{
		// a new paint is needed
		drawGalleryImage = _TRUE_;
	}

	// if we found no image this is a big error (handset defective, coder insane or whatever)
	// to prevent the application from crashing we don't show any picture
	if (galleryImage == NULL) 
	{
		galleryFlags = 0;
	} 
	else 
	{
		// note size
		galleryImageHeight = PUTILS->getImageHeight(galleryImage);
		galleryImageWidth = PUTILS->getImageWidth(galleryImage);
	}
}

// switches the galleryimage according to the given index to 'available'
void aMain::switchGalleryIndex(byte index)
{
#ifdef debug
	//myDebug.add(1, "Main::switchGalleryIndex(" + index + ")");
	//myDebug.add(1, "galleryFlags: " + galleryFlags);
#endif
	galleryFlags |= (2 << index);
#ifdef debug
	//myDebug.add(1, "galleryFlags: " + galleryFlags);
#endif
}

// is the gallery index set before with a switchGalleryIndex ?
_BOOLEAN_ aMain::isGalleryIndexSet(byte index)
{
	if ((galleryFlags & (2 << index)) != 0)
		return _TRUE_;
	else
		return _FALSE_;
}
#endif GAME_USE_GALLERY

void aMain::preMenu()
{
#ifdef debug
	myDebug->add(1, "Main::preMenu()");
#endif

	int i;
// TODO weg hier!!!
#ifdef USE_COMMANDS || doja
#ifndef FULLCANVAS
	//removeSoftKey(SOFT_KEY_2);
#endif
#endif
#ifdef GAME_USE_ARROWS
#ifdef MENU_ARROW_LEFT && MENU_ARROW_RIGHT
	if(PUTILS->charWidth(NULL, MENU_ARROW_LEFT) > PUTILS->charWidth(NULL, MENU_ARROW_RIGHT))
		arrowLength = PUTILS->charWidth(NULL, MENU_ARROW_LEFT);
	else
		arrowLength = PUTILS->charWidth(NULL, MENU_ARROW_RIGHT);
#endif
#endif
#ifdef MENU_MUSIC
#ifndef SCORE_MUSIC
		// restart menu music when coming back from the game or going into menu after startup
		if (m_iGameState == APPLICATION_GAME || (m_iGameState < APPLICATION_MAINMENU && MenuPosition == 0))
			restartMusic = _TRUE_;
#else
		if (m_iGameState == APPLICATION_GAME || (m_iGameState < APPLICATION_MAINMENU && MenuPosition == 0) || m_iGameState == APPLICATION_HIGHSCORE || m_iGameState == APPLICATION_INPUTSCORE)
			restartMusic = _TRUE_;
#endif
#else
#ifdef SCORE_MUSIC
		// coming back from hiscore to main menu, the hiscore has to be stopped because there is no menu music to play!
		stopSound();
#endif
#endif

#ifdef MENU_TILED_IMAGE
	// load tiled background image
	if (tiledImage == NULL)
		tiledImage = PUTILS->fetchImage(MENU_TILED_IMAGE);
#endif

	// build menu array
#ifdef MENU_EXTERNAL_PRIME_ENTRIES
		menuEntries = myGame->getMenuEntries();
#else
	short _menuEntries[] = { - 1, MENU_PRIME_ENTRIES,  - 1};
	menuEntries.removeAll();
	for(int i=0; i < (sizeof(_menuEntries)/sizeof(short));i++)
	{
		menuEntries.append(_menuEntries[i]);
	}
#endif
	//delete[](_menuEntries);
	
#ifdef MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_ITEM_IMAGE
	// load item image
	if (menuItemImage == NULL)
		menuItemImage = PUTILS->fetchImage(String(MENU_ITEM_IMAGE));

#ifdef MENU_ITEM_SELECTED_IMAGE
	// load image for selected item
	if (menuSelectedItemImage == NULL)
		menuSelectedItemImage = PUTILS->fetchImage(String(MENU_ITEM_SELECTED_IMAGE));
#endif
	// iconOffsets = new int[] {MENU_ITEM_ANIMATION_OFFSETS};
#endif

	// determine how many menu items we have
	availableMenuItems = 0;
	for (i = 0; i < menuEntries.size(); i++) 
	{
		// get next available menu item (' - 1' is not defined, so step over it)
		if ((menuEntries[i] < 0)
		// step over resume game if no game is in progress
		|| (menuEntries[i] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
		// step over language select menu if only one language is available
		|| (menuEntries[i] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
		) {
			continue;
		}
		availableMenuItems++;
	}

#ifdef MENU_ITEM_ANIMATED
	byte lastRandom =  - 23;

	menuItemStates = new byte[] { MENU_ITEM_ANIMATION_STATES_ORDER };
	menuItemStateIndex = new byte[availableMenuItems];
	for (i = 0; i < menuItemStateIndex.length;) {
		menuItemStateIndex[i] = (byte) (((myRandom.nextInt() % menuItemStates.length) + menuItemStates.length) / 2);
		if (lastRandom != menuItemStateIndex[i]) {
			lastRandom = menuItemStateIndex[i];
			i++;
		}
	}
#endif MENU_ITEM_ANIMATED
#endif MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU

#ifdef MENU_HEADER_IMAGE_FILE
	// get header image
	if (headerImage == NULL)
		headerImage = PUTILS->fetchImage(String(MENU_HEADER_IMAGE_FILE));
#endif
#ifdef MENU_FOOTER_IMAGE_FILE
	// get footer image
	if (footerImage == NULL)
		footerImage = PUTILS->fetchImage(String(MENU_FOOTER_IMAGE_FILE));
#endif
	PGAME->initMenu();
	doFullMenuPaint = _TRUE_;
}

void aMain::postMenu()
{
#ifdef MENU_TILED_IMAGE
	// drop background image
	if (tiledImage != NULL)
	{
		tiledImage->release();
		delete(tiledImage);
	}
	tiledImage = NULL;
#endif MENU_TILED_IMAGE
#ifdef GAME_USE_MULTI_ITEM_MENU && MENU_ITEM_IMAGE
	// drop item image
	if (menuItemImage != NULL)
	{
		menuItemImage->release();
		delete(menuImage);
	}
	menuItemImage = NULL;
#ifdef MENU_ITEM_SELECTED_IMAGE
	// load image for selected item
	if (menuSelectedItemImage != NULL)
	{
		menuSelectedItemImage->release();
		delete(menuSelectedItemImage);
	}
	menuSelectedItemImage = NULL;
#endif
	menuItemStates.remove(0, menuItemStates.size());
	menuItemStates.destruct();
	menuItemStateIndex.remove(0, menuItemStateIndex.size());
	menuItemStateIndex.destruct();
#endif GAME_USE_MULTI_ITEM_MENU && MENU_ITEM_IMAGE
}

#ifndef MENU_IS_EXTERNAL
#ifdef MENU_USE_CLASSIC_MAINMENU || MENU_USE_CLASSIC_STARTMENU || GAME_USE_CLASSIC_MENU
//  ********************************************************************
//  *********  methods for the classic menu  ***************************
//  ********************************************************************
void aMain::paintClassicMenu(Bbyte pArray)
{
#ifdef MENU_PAINT_CLASSIC_EXTERNAL
	PGAME->paintMenu(doFullPaint);
#else  MENU_PAINT_CLASSIC_EXTERNAL

	int y;

	// do a fullpaint?
	if (doFullMenuPaint == _TRUE_ || doFullPaint || MenuText=="")
	{
		// prepare background?
		if (isNewGameState == _TRUE_)
		{
			isNewGameState = _FALSE_;

#ifdef MENU_IMAGE
			if (MenuImage != NULL)
			{
				MenuImageX = (ScreenWidth - PUTILS->getImageWidth(MenuImage)) / 2;
				MenuImageY = (ScreenHeight - (PUTILS->getImageHeight(MenuImage))) / 2;
			}
#endif
		}

		// reset vars, doFullPaint is used later on
		doFullPaint = true;
		doFullMenuPaint = _FALSE_;

		// calc menu select start position one time
		if (MenuPosition == 0)
		{
#ifndef MENU_TEXT_AT_BOTTOM
#ifdef MENU_IMAGE
			// calc menu text position
			if (MenuImage != NULL)
			{
#ifdef MENU_TEXT_POSITION
				// use the menu text position as offset to the end of the image
				MenuPosition = (ScreenHeight - PUTILS->getImageHeight(MenuImage)) / 2 + PUTILS->getImageHeight(MenuImage) + (MENU_TEXT_POSITION) - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
#else  MENU_TEXT_POSITION
				// middle the menu text between the menu image and the end of the screen
				MenuPosition = (ScreenHeight - PUTILS->getImageHeight(MenuImage)) / 2 + PUTILS->getImageHeight(MenuImage);
				MenuPosition += (ScreenHeight - MenuPosition - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics))) / 2;
#endif MENU_TEXT_POSITION

				// do not print the menu text outside the screen
				if (MenuPosition + PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) > ScreenHeight)
					MenuPosition = ScreenHeight - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
			}
			else
#endif MENU_IMAGE
#endif !MENU_TEXT_AT_BOTTOM

#ifdef MENU_TEXT_POSITION
				MenuPosition=ScreenHeight - (MENU_TEXT_POSITION) - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
#else
				MenuPosition=ScreenHeight - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));
#endif MENU_TEXT_POSITION
		}
	}

	if (updateMenuString == _TRUE_)
	{
		updateMenuString = _FALSE_;

		// get menu text in current language
		MenuText = getMenuItemText(pArray[currentMenuItem]);

#ifdef MENU_IMAGE && MENU_DRAW_IMAGE_FIRST
		// menu image?
		if (MenuImage != NULL)
			PUTILS->drawImage(m_pGraphics, MenuImage, MenuImageX, MenuImageY, 0);
#endif MENU_IMAGE && MENU_DRAW_IMAGE_FIRST

		y = PGAME->paintMenu( true, MenuPosition);

		PUTILS->drawString(m_pGraphics, MenuText, 0, MenuPosition, HCENTER |SHADOW);
	}
	else {
		y = PGAME->paintMenu(doFullPaint, MenuPosition);
	}
#ifdef MENU_IMAGE && MENU_DRAW_IMAGE_LAST
		// menu image?
		if (MenuImage != NULL)
			PUTILS->drawImage(m_pGraphics, MenuImage, MenuImageX, MenuImageY, 0);
#endif MENU_IMAGE && MENU_DRAW_IMAGE_LAST

	// if the game is setting a y position for the menu text than use it
	if (y != 0)
		MenuPosition = y;

#ifndef doja
	// reset any clippings
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
	// has to be done here
	doFullPaint = false;

	// cycle color
	cycled++;
	// don't exceed array
	cycled %= GameColorRotation.size();

##if BREWVERSION > 0x1
	PUTILS->setFontColor(MENU_HIGHLIGHT_COLOR);
##endif

	// do the printing
	PUTILS->drawString(m_pGraphics, MenuText, 0, MenuPosition, HCENTER | SHADOW);
#ifdef GAME_USE_ARROWS
		paintArrows(m_pGraphics,MENU_NUM_ARROWS, MENU_ARROW_LEFT, MENU_ARROW_RIGHT, MenuPosition, MENU_ARROWS_X_OFFSET, MenuText, GameColorRotation, MENU_TEXT_COLOR, MENU_SCROLL_IN, _TRUE_, ScreenWidth, 0);
#endif
#endif MENU_PAINT_CLASSIC_EXTERNAL
}
#endif MENU_USE_CLASSIC_MAINMENU || MENU_USE_CLASSIC_STARTMENU || GAME_USE_CLASSIC_MENU

#ifdef MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
void aMain::paintMultiMenu(Bbyte pArray, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int animationStatesCount, int menuTextColor, int menuHighlightColor, int itemCount)
{
	int i, j, menuItems, menuItemHeight, textColor;
#ifdef MENU_ITEM_IMAGE
	Image* itemImage;
#endif

	if (menuHeight == 0) 
	{
		i = ScreenHeight - menuYpos;
	} 
	else 
	{
		i = menuHeight;
	}

#ifdef MENU_ITEM_IMAGE
	if (menuItemImage != NULL) 
	{
		menuItemHeight = PUTILS->getImageHeight(menuItemImage) / animationStatesCount;
#ifdef MENU_ITEM_SELECTED_IMAGE
		int tmpHeight = PUTILS->getImageHeight(menuSelectedItemImage) / animationStatesCount;
		if (tmpHeight > menuItemHeight)
			menuItemHeight = tmpHeight;
#endif
	} else
#endif MENU_ITEM_IMAGE
		menuItemHeight = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));

	// determine how many menu items have to be displayed at the same time ...
	int displayableMenuItems = itemCount;

#ifdef GAME_MENUITEM_SPACE
	int itemSpace = GAME_MENUITEM_SPACE;

	// calculate how many menu items can be displayed with the given space between them
	while (((displayableMenuItems * menuItemHeight) + ((displayableMenuItems - 1) * GAME_MENUITEM_SPACE)) > i) 
	{
		displayableMenuItems--;
	}
#else
	// calculate how many menu items can be displayed
	while (displayableMenuItems * menuItemHeight > i) 
	{
		displayableMenuItems--;
	}

	// and the space between them
	int itemSpace = (i - displayableMenuItems * menuItemHeight) / (availableMenuItems - 1);
#endif GAME_MENUITEM_SPACE

	// center all displayable items
	menuHeight = displayableMenuItems * menuItemHeight + (displayableMenuItems - 1) * itemSpace;
	menuYpos += (i - menuHeight) / 2;

	menuItems = i = j = 0;

	// determine which menu items are to displayed (regarding free space on the screen, '0' = all items can be displayed)
	if (displayableMenuItems == 1) 
	{
		// only current item can be displayed
		menuItems = currentMenuItem;
	} 
	else if (displayableMenuItems != availableMenuItems) 
	{
		// get first menu item to be displayed (it's not simply the second or third,
		// there might be undefined menu items which have to be left out)

		// get number of menu items which exist after current
		for (i = currentMenuItem + 1; i < pArray.size(); i++) 
		{
			// get next available menu item (' - 1' is not defined, so step over it)
			if ((pArray[i] < 0)
				// step over resume game if no game is in progress
				|| (pArray[i] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
				// step over language select menu if only one language is available
				|| (pArray[i] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
				) {
					continue;
			}
			j++;
		}
		// if there are not enough items to be displayed underneath the current we have to paint it lower
		if (j < (displayableMenuItems - (displayableMenuItems / 2))) 
		{
			// calculate offset (for lower painting)
			j = (displayableMenuItems / 2) - j;
		} 
		else 
		{
			// everything is fine - just paint as it is...
			j = 0;
		}

		// place in the center if possible
		j += (displayableMenuItems - (displayableMenuItems / 2) - 1);
		// get menu item which has to be displayed first
		for (i = currentMenuItem; i >= 0; i--) 
		{
			// get next available menu item (' - 1' is not defined, so step over it)
			if ((pArray[i] < 0)
				// step over resume game if no game is in progress
				|| (pArray[i] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
				// step over language select menu if only one language is available
				|| (pArray[i] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
				) {
					continue;
			}
			if (j == 0) 
			{
				menuItems = i - 1;
				break;
			}
			j--;
		}
	}
#ifdef MENU_ITEM_IMAGE
	int yOffset = 0;
#endif
#ifdef OLD_GAME
	PGAME->paintMenu(m_pGraphics, doFullPaint, menuYpos);
#else
	myGame->paintMenu(doFullPaint, menuYpos);
#endif

	for (i = 0; i < displayableMenuItems; i++) 
	{
		// get next menu item (' - 1' is not defined, so step over it)
		for (;(pArray[++menuItems] < 0)
			// step over resume game if no game is in progress
			|| (pArray[menuItems] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
			// step over language select menu if only one language is available
			|| (pArray[menuItems] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
			;) {}
#ifdef MENU_ITEM_ANIMATED
		if (menuItemStates.size() != 0) 
		{
			// calculate index for item state for each item separately
			menuItemStateIndex[i]++;
			if ((menuItemStateIndex[i] / 2) >= menuItemStates.size()) 
			{
				menuItemStateIndex[i] = 0;
			}
			yOffset = menuItemStates[(menuItemStateIndex[i] / 2)] * menuItemHeight;
		}
#endif MENU_ITEM_ANIMATED

#ifdef MENU_ITEM_IMAGE
		itemImage = menuItemImage;
#endif
		if (menuItems == currentMenuItem) 
		{
			textColor = menuHighlightColor;
#ifdef MENU_ITEM_SELECTED_IMAGE
			itemImage = menuSelectedItemImage;
#endif
		}
		else 
		{
			textColor = menuTextColor;
		}
#ifdef MENU_ITEM_IMAGE
		if (itemImage != NULL) 
		{
// TODO xOffset, yOffset + width bestimmen
			paintMenuItem(itemImage,
				menuXpos + (menuWidth - itemImage->getWidth()) / 2,
				menuYpos + i * (itemSpace + menuItemHeight),
				0, yOffset, 0, menuItemHeight,
				getMenuItemText(pArray[menuItems]), textColor,SHADOW | HCENTER_X);
		} 
		else 
		{
#endif MENU_ITEM_IMAGE
			// set font, color
//			PUTILS->setFont(m_pGraphics, myFont);
##if BREWVERSION > 0x1
			PUTILS->setFontColor(textColor);
##endif
			// print the item text
#ifdef MENU_ALIGNMENT_LEFT
			myUtils->drawString(m_pGraphics,
				getMenuItemText(pArray[menuItems]),
				menuXpos,
				menuYpos + i * (itemSpace + menuItemHeight),
				0);
#else
#ifdef MENU_ALIGNMENT_RIGHT
			myUtils->drawString(m_pGraphics,
				getMenuItemText(pArray[menuItems]),
				menuXpos + menuWidth - myUtils->stringWidth(NULL, getMenuItemText(pArray[menuItems])),
				menuYpos + i * (itemSpace + menuItemHeight),
				0);
#else
			myUtils->drawString(m_pGraphics,
				getMenuItemText(pArray[menuItems]),
				menuXpos + (menuWidth / 2),
				menuYpos + i * (itemSpace + menuItemHeight),
				HCENTER_X);
#endif MENU_ALIGNMENT_RIGHT
#endif MENU_ALIGNMENT_LEFT
#ifdef MENU_ITEM_IMAGE
		}
#endif MENU_ITEM_IMAGE


#ifdef MENU_USE_SEPARATOR
		if (pArray[menuItems] == APPLICATION_SEPARATOR)
		{
			myUtils->setColor(m_pGraphics, MENU_SEPARATOR_COLOR);
			myUtils->drawRect(m_pGraphics, menuXpos + 8, menuYpos + i * (itemSpace + menuItemHeight) + menuItemHeight / 2, menuWidth - 16, 1);
			myUtils->setColor(m_pGraphics, MENU_SEPARATOR_BACK_COLOR);
			myUtils->drawRect(m_pGraphics, menuXpos + 9, menuYpos + i * (itemSpace + menuItemHeight) + menuItemHeight / 2 + 1, menuWidth - 16, 1);
		}
#endif

#ifdef MENU_USE_MARK_ICONS
#ifndef MENU_MARK_ICON_POS_X
#define MENU_MARK_ICON_POS_X 3
#endif
#ifndef MENU_MARK_ICON_POS_Y
#define MENU_MARK_ICON_POS_Y 0
#endif

		int cx = myUtils->getClipX();
		int cy = myUtils->getClipY();
		if (markEntries[ menuItems ] > -1 && markImage != NULL)
		{
			 int optionWidth = myUtils->stringWidth(NULL, getMenuItemText(pArray[menuItems])) / 2;
				myUtils->setClip(menuXpos + menuWidth - markImage->getWidth()/ MENU_MARK_COUNT - MENU_MARK_ICON_POS_X, menuYpos + i * (itemSpace + menuItemHeight) + (itemSpace + menuItemHeight - markImage->getHeight()) / 2 - MENU_MARK_ICON_POS_Y, markImage->getWidth() / MENU_MARK_COUNT, markImage->getHeight() );
				myUtils->drawImage(m_pGraphics, markImage, menuXpos + menuWidth - markImage->getWidth()/ MENU_MARK_COUNT - markEntries[ menuItems ] * markImage->getWidth() / MENU_MARK_COUNT  - MENU_MARK_ICON_POS_X,  menuYpos + i * (itemSpace + menuItemHeight) + (itemSpace + menuItemHeight - markImage->getHeight()) / 2 - MENU_MARK_ICON_POS_Y);
				myUtils->setClip(cx, cy, ScreenWidth, ScreenHeight); //restore cliping region
		}
#endif

#ifdef GAME_USE_ARROWS
		if (menuItems == currentMenuItem)
		{
#ifdef MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
			paintArrows(m_pGraphics, MENU_NUM_ARROWS, MENU_ARROW_LEFT, MENU_ARROW_RIGHT, menuYpos
			+ i * (itemSpace + menuItemHeight), MENU_ARROWS_X_OFFSET, getMenuItemText(pArray[menuItems]), GameColorRotation, MENU_TEXT_COLOR, MENU_SCROLL_IN, _TRUE_, menuWidth, menuXpos, _FALSE_);
#else
			paintArrows(m_pGraphics, MENU_NUM_ARROWS, MENU_ARROW_LEFT, MENU_ARROW_RIGHT, menuYpos
			+ i * (itemSpace + menuItemHeight), MENU_ARROWS_X_OFFSET, getMenuItemText(pArray[menuItems]), GameColorRotation, MENU_TEXT_COLOR, MENU_SCROLL_IN, _TRUE_, menuWidth, menuXpos);
#endif
		}
#endif
	}

// #ifndef doja
// 		// reset any clippings
// 		g.setClip(0, 0, ScreenWidth, ScreenHeight);
// #endif

#ifndef MENU_ANIMATE_TILED_BACK_X || MENU_ANIMATE_TILED_BACK_Y
	// has to be done here
	if (updateMenuString == _TRUE_) {
		// used here as a flag if fullpaint is required
		updateMenuString = _FALSE_;
	} else {
		// fullpaint only needed after menuchanging (happens in processKeyMenu)
 		doFullPaint = false;
 	}
#endif
}

#ifdef MENU_ITEM_IMAGE
// 	Graphics g					Graphics to paint on
// 	Image image					image which contains the desired item image
// 	int x, int y				x and y position where the item has to be drawn
// 	int xOffset, int yOffset	offsets to use within the source image
// 	int width, int height		width and height of the item image
// 	String text					text to print for this item (maybe upon the image)
// 	Font font					Font to use
// 	int color					color for the text
// 	int mode					printing mode for the text
void aMain::paintMenuItem(Image* image, int x, int y, int xOffset, int yOffset, int width, int height, String text, int color, int mode)
{
	// get width and height if not set
	if (width <= 0) {
		width = PUTILS->getImageWidth(image);
	}
	if (height <= 0) {
		height = PUTILS->getImageHeight(image);
	}
#ifndef doja
	// set clipping
	//g.setClip(x, y, width, height);
#endif
	// draw the image
	PUTILS->drawImage(m_pGraphics, image, x - xOffset, y - yOffset, 0);

	// set font, color
	//PUTILS->setFont(g, font);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(color);
##endif
// TODO free positioning of text
	// gain is to center horizontally and / or vertically
	if ((mode & HCENTER) != 0) {
		x += (width / 2);
	}
//		if ((mode & VCENTER) != 0) {
		y += (height / 2);
//		}

	// print the item text
	PUTILS->drawString(m_pGraphics, text, x, y, mode | VCENTER);

#ifndef doja
	// reset clipping
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
}
#endif MENU_ITEM_IMAGE
#endif MENU_USE_MULTIITEM_MAINMENU || MENU_USE_MULTIITEM_STARTMENU || GAME_USE_MULTIITEM_MENU
#ifdef MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
//  ********************************************************************
//  *********  methods for the icon menu  ******************************
//  ********************************************************************
// 	Graphics g						Graphics to paint on
// 	byte[] pArray					array with the menu entries
// 	byte[] pIcons					array with the icons for the menu entries
// 	byte[] pOffsets					array with the offsets for the icons
// 	int menuXpos, int menuYpos		x and y position of the menu (maybe it's not simply centered)
// 	int menuWidth, int menuHeight	width and height to be used by the menu
// 	int menuTextColor				colour to use for the menuitem text
// 	int menuHighlightColor			colour to use for the actual selected menuitem text
void aMain::paintIconMenu(Bbyte pArray, ImageVector pIcons, Bint pOffsets, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int menuTextColor, int menuHighlightColor)
{

	int x, y, w, h;
	byte row = 0;
	byte column = 0;

	String text = getMenuItemText(pArray[currentMenuItem]);
	if (text.length() != 0 && !(String("").equals(text))) 
	{
		menuHeight -= PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) + MENU_ICON_MENU_TEXT_SPACE;
	}

	int columnWidth = menuWidth / MENU_ICON_IN_ROW;
	int rowHeight =0;
	if(1 < (pArray.size() - 2) % MENU_ICON_IN_ROW)
		rowHeight = menuHeight / ((pArray.size() - 2) / MENU_ICON_IN_ROW + 1);
	else
		rowHeight = menuHeight / ((pArray.size() - 2) / MENU_ICON_IN_ROW + (pArray.size() - 2) % MENU_ICON_IN_ROW);

	//g.setClip(0, 0, ScreenWidth, ScreenHeight);

	for (int i = 1; i < pArray.size() - 1; i++) 
	{
		// get next menu item (' - 1' is not defined, so step over it)
		if (!((pArray[i] < 0)
			// step over resume game if no game is in progress
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[i] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
			// step over language select menu if only one language is available
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[i] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
			)) {
				w = pOffsets[(i - 1) * 4 + 2];
				h = pOffsets[(i - 1) * 4 + 3];
				x = menuXpos + ((columnWidth - w) / 2) + (column * columnWidth);
				y = menuYpos + ((rowHeight - h) / 2) + (row * rowHeight);

				if (i == currentMenuItem) 
				{
					// highlight actual item
					PUTILS->setColor(m_pGraphics, menuHighlightColor);
					PUTILS->fillArc(m_pGraphics, x - 5, y + h * 2 / 3, w + 10, h / 2, 0, 360);
				}
#ifndef doja
				// set clipping
				//g.setClip(x, y, w, h);
#endif
				// draw the image
				PUTILS->drawImage(m_pGraphics, pIcons[i], x - (pOffsets[(i - 1) * 4]), y - (pOffsets[(i - 1) * 4 + 1]), 0);
#ifndef doja
				// reset any clippings
				//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
		}
		// column done?
		if (++column == MENU_ICON_IN_ROW) 
		{
			column = 0;
			row++;
		}
#ifdef MENU_ITEM_ANIMATED
		// calculate index for item state for each item separately
		// TODO selected offset anioffset
// 			paintMenuItem(g, menuItemImage,
// 				menuXpos + (menuWidth - menuItemImage.getWidth()) / 2, menuYpos + i * (itemSpace + menuItemHeight), 0, 29, 0, menuItemStates[(menuItemStateIndex[i] / 2)] * menuItemHeight,
// 				getMenuItemText(menuEntries[menuItems]), myFont, textColor, aUtils.SHADOW | aUtils.HCENTER_X | aUtils.VCENTER_Y);
#endif MENU_ITEM_ANIMATED
	}
	// print the actual item text
	// set font, color
//	PUTILS->setFont(g, myFont);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(menuTextColor);
##endif
	PUTILS->drawString(m_pGraphics, getMenuItemText(pArray[currentMenuItem]),
		menuXpos + (menuWidth / 2), menuYpos + menuHeight ,
		SHADOW | HCENTER_X | VCENTER_Y);
	// has to be done here
	doFullPaint = false;
}

void aMain::paintIconMenu(Bbyte pArray, ImageVector pIcons, Bint pOffsets, ImageVector iconImage, int menuXpos, int menuYpos, int menuWidth, int menuHeight, int menuTextColor, int menuHighlightColor)
{

	int x, y, w, h;
	byte row = 0;
	byte column = 0;
	int galleryHeight = 0;
	byte start = 0, end = 0;
	int ydiff = 0;

#ifndef GAME_USE_TEMP_IMAGE
	Image* tempImage;
#endif
#ifdef debug
	//System.out.println("currentMenuItem: "+currentMenuItem);
#endif
	String text = getMenuItemText(pArray[currentMenuItem]);
	if (text.length() != 0 && !(String("").equals(text))) 
	{
		menuHeight -= PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) + MENU_ICON_MENU_TEXT_SPACE;
	}
#ifdef debug
//System.out.println("__FILE__:__LINE__");
#endif
	int columnWidth = menuWidth / MENU_ICON_IN_ROW;
	int rowHeight =  0; 

	// max number of rows displayble
	int max_num_rows = 0;
	// count maximum number of rows that can be displayed
#ifdef MARTIN
	// mostly it depends on the height of the iconImage
	// only 2 rows are allowed to be painted
	for(; galleryHeight < menuHeight - (PUTILS->getImageHeight(iconImage[0])) && max_num_rows < 2; )
#else
	for(; galleryHeight < menuHeight - (PUTILS->getImageHeight(iconImage[0]) + MENU_ICON_SPACE_Y); )
#endif MARTIN
	{
		galleryHeight += PUTILS->getImageHeight(iconImage[0])
#ifndef MARTIN
		+ MENU_ICON_SPACE_Y
#endif MARTIN
		;
		max_num_rows++;
	}

#ifdef MARTIN
	// Space between Cards
	ydiff = ( menuHeight - galleryHeight ) / max_num_rows + 1;
#else
	rowHeight = galleryHeight / max_num_rows;
	ydiff = ( menuHeight - galleryHeight ) / 2;
#endif MARTIN

#ifdef debug
#ifdef MARTIN
//System.out.println("y diff: "+ydiff);
//System.out.println("menu Height: "+menuHeight);
#endif MARTIN
//System.out.println("gallery Height: "+galleryHeight);
//System.out.println("max number of displayble rows: "+max_num_rows);
#endif
	// start position which icon should be painted
	if(currentMenuItem <= max_num_rows  * MENU_ICON_IN_ROW)
	{
		start = 1;
		end = (byte)(max_num_rows * MENU_ICON_IN_ROW );
	}
	else
	{
		start = (byte)(((max_num_rows - 1) * MENU_ICON_IN_ROW) + 1);
		end = (byte)(pArray.size() - 1);
	}

#ifdef debug
#ifdef MARTIN
//System.out.println("max num of rows: "+max_num_rows);
#endif MARTIN
//System.out.println("start at: "+start);
//System.out.println("end at: "+end);
#endif
	for (byte i = start; i <= end; i++) 
	{
		// get next menu item (' - 1' is not defined, so step over it)
		if (!((pArray[i] < 0)
			// step over resume game if no game is in progress
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[i] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
			// step over language select menu if only one language is available
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[i] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
			)) {
				w = pOffsets[(i - 1) * 4 + 2];
				h = pOffsets[(i - 1) * 4 + 3];
				x = menuXpos + ((columnWidth - w) / 2) + (column * columnWidth);
#ifdef MARTIN
				y = menuYpos + ((row + 1) * ydiff) + (row * PUTILS->getImageHeight(iconImage[0]));
#else
				y = menuYpos + ((rowHeight - h) / 2) + (row * rowHeight) + ydiff;
#endif MARTIN

				// DEVELOPER
				tempImage = pIcons[i];
//#ifdef debug
//System.out.println("__FILE__:__LINE__");
//#endif
				if (i == currentMenuItem)
				{
					//g.setClip(0,0,ScreenWidth,ScreenHeight);
					// - tempImage.getWidth()/(pIcons.length-2))/2, - tempImage.getHeight()
					PUTILS->drawImage(m_pGraphics, iconImage[1], x - (PUTILS->getImageWidth(iconImage[0]) - GAME_ICON_WIDTH_GALLERY)/2  , y - (PUTILS->getImageHeight(iconImage[0]) - GAME_ICON_HEIGHT_GALLERY)/2 , 0);
				}
				else
				{
					// draw the image
					//g.setClip(0,0,ScreenWidth,ScreenHeight);
					// - tempImage.getWidth()/(pIcons.length-2))/2, - tempImage.getHeight())/2
					PUTILS->drawImage(m_pGraphics, iconImage[0], x - (PUTILS->getImageWidth(iconImage[0]) - GAME_ICON_WIDTH_GALLERY)/2, y - (PUTILS->getImageHeight(iconImage[0]) - GAME_ICON_HEIGHT_GALLERY)/2 , 0);
				}
//#ifdef debug
//System.out.println("__FILE__:__LINE__");
//#endif
#ifndef doja
				// set clipping
				//g.setClip(x, y, w, h);
#endif
				PUTILS->drawClippedImage(tempImage, x, y, (pOffsets[(i - 1) * 4]), (pOffsets[(i - 1) * 4 + 1]), w, h);
				// DEVELOPER
//#ifdef debug
//System.out.println("__FILE__:__LINE__");
//#endif
#ifndef doja
				// reset any clippings
				//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
				if(isGalleryIndexSet((byte)(i-1)) == _FALSE_)
					PGAME->fillTransBG(x , y ,w,h,LANG_BACK_COLOR,GAME_TRANSPARENT_LINE_STEP,_FALSE_);


		}
		// column done?
		if (++column == MENU_ICON_IN_ROW) 
		{
			column = 0;
			row = (row < max_num_rows ? ++row : 0);

		}
#ifdef MENU_ITEM_ANIMATED
		// calculate index for item state for each item separately
		// TODO selected offset anioffset
// 			paintMenuItem(g, menuItemImage,
// 				menuXpos + (menuWidth - menuItemImage.getWidth()) / 2, menuYpos + i * (itemSpace + menuItemHeight), 0, 29, 0, menuItemStates[(menuItemStateIndex[i] / 2)] * menuItemHeight,
// 				getMenuItemText(menuEntries[menuItems]), myFont, textColor, aUtils.SHADOW | aUtils.HCENTER_X | aUtils.VCENTER_Y);
#endif MENU_ITEM_ANIMATED
	}
	// print the actual item text
	// set font, color
	//PUTILS->setFont(g, myFont);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(menuTextColor);
##endif
	PUTILS->drawString(m_pGraphics, getMenuItemText(pArray[currentMenuItem]),
#ifdef MARTIN
		menuXpos + (menuWidth / 2), //menuYpos + menuHeight + ydiff/2 -
		ScreenHeight - PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)),
		SHADOW | HCENTER_X);
#else
		menuXpos + (menuWidth / 2), PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) ,
		SHADOW | HCENTER_X | VCENTER_Y);
#endif MARTIN
	// has to be done here
	doFullPaint = false;
}

void aMain::processKeyIconMenu(int pCode, Bbyte pArray)
{
	int nextItem = currentMenuItem;

	if (PKEY->isDown(pCode)) 
	{
		for (;;) 
		{
			// bottom reached
			if (nextItem + MENU_ICON_IN_ROW >= pArray.size() - 1) 
			{
				return;
			} 
			else 
			{
				nextItem += MENU_ICON_IN_ROW;
				if ((pArray[nextItem] < 0)
					// step over resume game in main menu if no game is in progress
					|| (m_iGameState == APPLICATION_MAINMENU && pArray[nextItem] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
					// step over language select in main menu if only one language is available
					|| (m_iGameState == APPLICATION_MAINMENU && pArray[nextItem] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
				) {
					continue;
				} else {
					break;
				}
			}
		}
	} else if (PKEY->isUp(pCode)) {
		for (;;) {
			// top reached
			if (nextItem - MENU_ICON_IN_ROW < 1) {
				return;
			} else {
				nextItem -= MENU_ICON_IN_ROW;
				if ((pArray[nextItem] < 0)
					// step over resume game in main menu if no game is in progress
					|| (m_iGameState == APPLICATION_MAINMENU && pArray[nextItem] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
					// step over language select in main menu if only one language is available
					|| (m_iGameState == APPLICATION_MAINMENU && pArray[nextItem] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
				) {
					continue;
				} else {
					break;
				}
			}
		}
	} else if (PKEY->isRight(pCode) || PKEY->isLeft(pCode) || PKEY->isSoftLeft(pCode) ||PKEY->isFire(pCode) ||PKEY->isClear(pCode)) {
		// do the selected action and return
		processKeyMenu(pCode, pArray, _TRUE_);
		return;
	}
	currentMenuItem = nextItem;
}
#endif MENU_USE_ICON_MAINMENU || MENU_USE_ICON_STARTMENU || GAME_USE_ICON_MENU
#endif MENU_IS_EXTERNAL

#ifdef MENU_USE_HEADER || GAME_USE_HEADER || MENU_USE_FOOTER || GAME_USE_FOOTER
// 	Graphics g							Graphics to paint on
// 	int xPos, int yPos					x and y position where to paint the header
// 	int width, int height				width and height of the space used for the header
// 	Image image							the image containing the header
// 	int imageXoffset, int imageYoffset	offsets for the header image
// 	int imageWidth, int imageHeight		width and height of header image
// 	String text							text to print as a header
// 	int color							color to use for printing
void aMain::paintHeader(int xPos, int yPos, int width, int height, Image* image, int imageXoffset, int imageYoffset, int imageWidth, int imageHeight, String text, int color, int space)
{
	PUTILS->setColor(m_pGraphics, color);

	if (image != NULL)
	{
		// prepare defaults
		if (imageWidth == 0) 
		{
			imageWidth = PUTILS->getImageWidth(image);
		}
		if (imageHeight == 0) {
			imageHeight = PUTILS->getImageHeight(image);
		}
		if (height == 0) {
			height = imageHeight;
		}

		if (text.length() != 0)
		{
			if (width == 0) {
				width = imageWidth + space + PUTILS->stringWidth(NULL, text);
				xPos += (ScreenWidth - width) / 2;
			}
			// paint image and text within given position
#ifndef doja
			//g.setClip(xPos, yPos, imageWidth, imageHeight);
#endif
			PUTILS->drawImage(m_pGraphics, image, xPos - imageXoffset, yPos - imageYoffset, 0);
#ifndef doja
			//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
			PUTILS->drawString(m_pGraphics, text, xPos + width - PUTILS->stringWidth(NULL, text), yPos + imageHeight / 2, SHADOW | VCENTER_Y);
		} else {
			if (width == 0) {
				width = ScreenWidth;
			}
#ifndef doja
			//g.setClip(xPos + ((width - imageWidth) / 2), yPos + ((height - imageHeight) / 2), imageWidth, imageHeight);
#endif
			// paint image centered on given position
			PUTILS->drawImage(m_pGraphics, image, xPos + width / 2, yPos + height / 2, HCENTER_X | VCENTER_Y);
#ifndef doja
			//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
		}
	} else if (text.length() != 0) {
		// paint text centered on given position
		PUTILS->drawString(m_pGraphics, text, xPos, yPos, SHADOW | HCENTER_X | VCENTER_Y);
	}
}
#endif MENU_USE_HEADER || GAME_USE_HEADER

//  ********************************************************************
//  *********  utility method for processing keys in menues  ***********
//  ********************************************************************

void aMain::processKeyMenu(int pCode, Bbyte pArray, _BOOLEAN_ map_DownRight_UpLeft)
{
	updateMenuString = _TRUE_;
	if (PKEY->isDown(pCode) || (map_DownRight_UpLeft == _TRUE_ && PKEY->isRight(pCode))) {
		// select next menu item (' - 1' is not defined, so step over it)
		for (;(pArray[++currentMenuItem] < 0)
			// step over resume game in main menu if no game is in progress
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[currentMenuItem] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
			// step over language select in main menu if only one language is available
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[currentMenuItem] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
			;) {
				// end of array reached?
				if (currentMenuItem == pArray.size() - 1) {
					currentMenuItem = 0;
				}
		}
	} else if (PKEY->isUp(pCode) || (map_DownRight_UpLeft == _TRUE_ && PKEY->isLeft(pCode))) {
		// select next menu item (' - 1' is not defined, so step over it)
		for (;(pArray[--currentMenuItem] < 0)
			// step over resume game in main menu if no game is in progress
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[currentMenuItem] == APPLICATION_RESUME && isInGame == _FALSE_)
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
			// step over language select in main menu if only one language is available
			|| (m_iGameState == APPLICATION_MAINMENU && pArray[currentMenuItem] == APPLICATION_LANGUAGE && myText->getDomainNumber() <= 1)
#endif
			;) {
				// beginning of array reached?
				if (currentMenuItem == 0) {
					currentMenuItem = pArray.size() - 1;
				}
		}
	} 
	else if (PKEY->isSoftLeft(pCode) || PKEY->isFire(pCode)) 
	{
		// do the selected action and return
		processApplicationState(pArray[currentMenuItem]);
		return;
	}
	else if(PKEY->isClear(pCode))
	{
		m_bRun = false;
	}
}

String aMain::getMenuItemText(int menuEntry)
{
	if (m_iGameState == APPLICATION_MAINMENU) 
	{
		if( (menuEntry == -1) || (menuEntry == 255)){
#ifdef debug
			/*
			aUtils.setColor(myGraphics, 0, 0, 0);
			aUtils.fillRect(myGraphics, 0, 0, ScreenWidth, ScreenHeight);
			aUtils.setColor(myGraphics, 255, 0, 0);
			final String s = "Warning: Unknown m_iGameState";
			aUtils.drawString(myGraphics, s, (ScreenWidth - aUtils.stringWidth(aUtils.getFont(myGraphics), s)) / 2,
				(ScreenHeight - aUtils.getFontHeight(aUtils.getFont(myGraphics))) / 2, 0);
				*/
#endif
			return "n/a";
		}
#ifdef PLAY4PRIZES
		else if (menuEntry == APPLICATION_P4P_PLAY) {
			return TEXT_CONST_P4P_PLAY;
		}
		else if (menuEntry == APPLICATION_P4P_HELP) {
			return TEXT_CONST_P4P_HELP;
		}
#endif
		else if (menuEntry == APPLICATION_RESUME) 
		{
			if (isInGame == _TRUE_) {
				return TEXT_CONST_MRE;
			}
			currentMenuItem = 2;
			return "";
		} else if (menuEntry == APPLICATION_GAME) {
			return TEXT_CONST_MST;
		} else if (menuEntry == APPLICATION_HELP) {
			return TEXT_CONST_MHE;
#ifdef GAME_USE_GALLERY
		} else if (menuEntry == APPLICATION_GALLERY) {
			return TEXT_CONST_MGA;
#endif

		} 
#ifdef USE_TILT
		else if (menuEntry == APPLICATION_TILT) {
			String itemText = TEXT_CONST_TIL;
			itemText += " ";
			return itemText += (isTiltOff == _TRUE_ ? TEXT_CONST_OFF : TEXT_CONST_ON);
		}
#endif
		else if (menuEntry == APPLICATION_SOUND) {
			String itemText = TEXT_CONST_MSO;
			itemText += " ";
#ifdef GAME_SET_VOLUME_MED
			switch (soundVolume) {
				case 0:
					itemText += (TEXT_CONST_OFF);
					break;
				case GAME_SET_VOLUME_LOW:
					itemText += (TEXT_CONST_SLO);
					break;
				case GAME_SET_VOLUME_MED:
					itemText += (TEXT_CONST_SME);
					break;
				case GAME_SET_VOLUME_HIGH:
					itemText += (TEXT_CONST_SHI);
			}
			return itemText;
#else  GAME_SET_VOLUME_MED
			return itemText += (isSoundMuted == _TRUE_ ? TEXT_CONST_OFF : TEXT_CONST_ON);
#endif GAME_SET_VOLUME_MED
#ifdef GAME_USES_VIBRA && DEVICE_HAS_VIBRA
		} else if (menuEntry == APPLICATION_VIBRA) {
			return  TEXT_CONST_MVI + " " + (isVibrationOff == _TRUE_ ? TEXT_CONST_OFF : TEXT_CONST_ON);
#endif GAME_USES_VIBRA && DEVICE_HAS_VIBRA
		} else if (menuEntry == APPLICATION_HIGHSCORE) {
			return TEXT_CONST_MSC;
#ifndef GAME_NO_LANGUAGE_SELECTION_SCREEN
		} else if (menuEntry == APPLICATION_LANGUAGE) {
			return myText->get("mla");
#endif !GAME_NO_LANGUAGE_SELECTION_SCREEN
		} else if (menuEntry == APPLICATION_QUIT) {
			return TEXT_CONST_MQU;
		} else {
			// IMPORTANT: do debug error handling in Game.getMenuItemText(menuEntry, GameState)
			return PGAME->getMenuItemText(menuEntry, m_iGameState);
		}
#ifdef MENU_DIFFICULT_LEVELS
	} else if (m_iGameState == APPLICATION_STARTMENU) {
		if (menuEntry < APPLICATION_BACK2MAINMENU) {
#ifndef GAME_USE_TEXT_DEFINES
			String string = "mmo";
			char str[10];
			string += _itoa ( menuEntry,str,10 );
			return myText->get(string);
#else
			return GameModes[menuEntry];
#endif
		} else {
			return TEXT_CONST_MBA;
		}
#endif MENU_DIFFICULT_LEVELS
	} else {
		// IMPORTANT: do debug error handling in Game.getMenuItemText(menuEntry, m_iGameState)
		return PGAME->getMenuItemText(menuEntry, m_iGameState);
	}
}

#ifdef GAME_USE_CENTERED_STRING
// draws an given string in the center of the screen
// with the given yOffset the string can be positioned more up or down
void aMain::drawCenteredString(String text, int yOffset, _BOOLEAN_ cycleColors, _BOOLEAN_ shadowed)
{
#ifndef doja
	//g.setClip(0, 0, ScreenWidth, ScreenHeight);
#endif
	if ((cycleColors == _TRUE_) && ++cycled >= GameColorRotation.size()) {
		cycled = 0;
	}
	int mode = HCENTER_X;
//	PUTILS->setFont(g, myFont);
##if BREWVERSION > 0x1
	PUTILS->setFontColor(GameColorRotation[cycled]);
##endif
	if (cycleColors == _FALSE_) 
	{
		mode |= SHADOW;
	}
	// calculate centered y - position regarding the textheight (not accurate right now) and the offset for printing the text
	//PUTILS->drawString(m_pGraphics, text, 0, (ScreenHeight / 2) - (PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)) / 2) + yOffset, mode);
	myUtils->drawString(m_pGraphics, text, (ScreenWidth / 2) - (myUtils->stringWidth(NULL, text)/2), (ScreenHeight / 2) - (myUtils->getFontHeight(myUtils->getFont(m_pGraphics)) / 2),0);
}
#endif GAME_USE_CENTERED_STRING

#ifdef GAME_TILED_IMAGE || MENU_TILED_IMAGE
// tiles a background image fullscreen; attention set clipping yourself !!!
void aMain::paintTiledImage(Image* image, int xOffset, int yOffset, _BOOLEAN_ centerH, _BOOLEAN_ centerV)
{
#ifdef debug
	//myDebug.add(2, "Main::paintTiledImage(" + image + ", " + xOffset + ", " + yOffset + ")");
#endif
	// note dimension
	int width = PUTILS->getImageWidth(image);
	int height = PUTILS->getImageHeight(image);

	// center horizontally?
	if (centerH == _TRUE_) {
		// note remaining pixel
		int remainW = ScreenWidth % width;
		// center it if necessary
		if (remainW != 0) {
			xOffset += (remainW - width) / 2;
		}
	}

	// center vertically?
	if (centerV == _TRUE_) {
		// note remaining pixel
		int remainH = ScreenHeight % height;
		// center it if necessary
		if (remainH != 0) {
			yOffset += (remainH - height) / 2;
		}
	}
	/*TODO:
	// use clipping
	int clipX1 = g.getClipX();
	int clipY1 = g.getClipY();
	int clipX2 = clipX1 + g.getClipWidth();
	int clipY2 = clipY1 + g.getClipHeight();

	// set new offsets to start painting where needed
	if ((clipX1 > 0) && (clipX1 > xOffset)) {
		xOffset += ((clipX1 - xOffset) / width * width);
	}
	if ((clipY1 > 0) && (clipY1 > yOffset)) {
		yOffset += ((clipY1 - yOffset) / height * height);
	}

	// draw it!
	int x;
	int y;
	for (x = xOffset; ((x < clipX2) && (x < ScreenWidth)); x += width) 
	{
		for (y = yOffset; ((y < clipY2) && (y < ScreenHeight)); y += height) 
		{
			aUtils.drawImage(g, image, x, y, 0);
		}
	}
	*/
}
#endif GAME_TILED_IMAGE || MENU_TILED_IMAGE

#ifndef USE_COMMANDS
// paint the menu button
void aMain::paintMenuButton()
{
#ifndef BUTTON_PAINT_ALWAYS
	//  don't draw menu button if it's offscreen
	if (menuButtonOffset < 0)
		return;
#endif
	// use clipping
/*TODO?
	int clipX = g.getClipX();
	int clipY = g.getClipY();
	int clipW = g.getClipWidth();
	int clipH = g.getClipHeight();

	// reset any clipping
	g.setClip(0, 0, ScreenWidth, ScreenHeight);
*/
#ifndef BUTTON_PAINT_ALWAYS
	if (MenuCommandTime != 0) {
		// offset gets higher by 1 pixel each drawing
		// menuButtonOffset++;
		// offset is calculated timebased
		long t = ISHELL_GetTimeMS(m_pIShell) - MenuCommandTime;

		// calculate offset
		if (t > BUTTON_PAINT_TIME)
			menuButtonOffset = (int) ((ISHELL_GetTimeMS(m_pIShell) - MenuCommandTime - BUTTON_PAINT_TIME) / 125);

		if (menuButtonOffset >=
#ifdef GAME_BUTTON_IMAGE
			PUTILS->getImageHeight(menuButton))
#else  GAME_BUTTON_IMAGE
			mySmallFontHeight)
#endif GAME_BUTTON_IMAGE
		{
			// slided out of screen - done here
			menuButtonOffset = -1;
			// reset menu command time
			MenuCommandTime = 0;
			return;
		}
	}
#endif !BUTTON_PAINT_ALWAYS

#ifdef GAME_BUTTON_IMAGE
		PUTILS->drawImage(m_pGraphics, menuButton, ScreenWidth - PUTILS->getImageWidth(menuButton), ScreenHeight - PUTILS->getImageHeight(menuButton)
#ifndef BUTTON_PAINT_ALWAYS
			 +  menuButtonOffset
#endif !BUTTON_PAINT_ALWAYS
			, 0);
#else  GAME_BUTTON_IMAGE
//		aUtils.setFont(g, mySmallFont);
		PUTILS->setColor(m_pGraphics, BUTTON_BACK_COLOR);

		PUTILS->fillRect(m_pGraphics, ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth,
			ScreenHeight - mySmallFontHeight
#ifndef BUTTON_PAINT_ALWAYS
			 +  menuButtonOffset
#endif !BUTTON_PAINT_ALWAYS
			, mySmallFontMenuWidth + mySmallFontSpaceWidth,
			mySmallFontHeight);/*,
			BUTTON_ARC_STYLE,
			BUTTON_ARC_STYLE);
*/
##if BREWVERSION > 0x1
		PUTILS->setFontColor(BUTTON_TEXT_COLOR);
##endif

		PUTILS->drawString(m_pGraphics,
			MenuCommandName,
#ifndef GAME_USE_GRAPHICAL_FONT
			BUTTON_TEXT_X_OFFSET +
#endif
			ScreenWidth - mySmallFontMenuWidth - mySmallFontSpaceWidth / 2,
#ifndef GAME_USE_GRAPHICAL_FONT
			BUTTON_TEXT_Y_OFFSET +
#endif
			ScreenHeight - mySmallFontHeight
#ifndef BUTTON_PAINT_ALWAYS
			 +  menuButtonOffset
#endif !BUTTON_PAINT_ALWAYS
			, 0);
#endif GAME_BUTTON_IMAGE

	// restore old clipping
	//g.setClip(clipX, clipY, clipW, clipH);
}
#endif USE_COMMANDS

#ifdef GAME_USE_ARROWS
#ifdef MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
void aMain::paintArrows(IGraphics* g, int arrowNumber, char arrowL, char arrowR, int arrowStartY, int arrowXoffset, String arrowText, Bint colors,  int textcolor,  boolean in,  _BOOLEAN_ reCalcArrows,  int menuWidth, int menuXpos,  _BOOLEAN_ centerAllignment) {
#else
void aMain::paintArrows(IGraphics* g, int arrowNumber, char arrowL, char arrowR,  int arrowStartY, int arrowXoffset, String arrowText, Bint colors,  int textcolor,  boolean in,  _BOOLEAN_ reCalcArrows,  int menuWidth,  int menuXpos) {
#endif
	int xL, xR, cL, cR;

	if (arrowLength == 0) {
		// calc arrow size
		arrowLength = _MAX(myUtils->charWidth(NULL, arrowL), myUtils->charWidth(NULL, arrowR));
	}
	if (reCalcArrows == _TRUE_) {
		// calc x position of actual text
#ifdef MENU_ALIGNMENT_LEFT || MENU_ALIGNMENT_RIGHT
		if (centerAllignment == _TRUE_)
			arrowTextStartX = (menuWidth - myUtils->stringWidth(NULL, arrowText)) / 2 + menuXpos;
		else
#endif
#ifdef MENU_ALIGNMENT_LEFT
		arrowTextStartX = menuXpos;
#else
#ifdef MENU_ALIGNMENT_RIGHT
		arrowTextStartX = menuWidth - myUtils->stringWidth(NULL, arrowText) + menuXpos;
#else
		arrowTextStartX = (menuWidth - myUtils->stringWidth(NULL, arrowText)) / 2 + menuXpos;
#endif
#endif MENU_ALIGNMENT_LEFT

	}

	// calc number of needed arrows
	if (arrowNumber == 0) {
		arrowNumber = arrowTextStartX / arrowLength + 1;
}

	// cycle colors
	arrowColor++;
	arrowColor %= colors.size();

	// animate the arrows in or out
	if (in) {
#ifdef GAME_USE_ARROWS_MOVE
		if (++arrowPos >= arrowLength)
			arrowPos = 0;
#endif GAME_USE_ARROWS_MOVE

		// swap chars if scrolling in
		char tmp = arrowL;
		arrowL = arrowR;
		arrowR = tmp;
#ifdef GAME_USE_ARROWS_MOVE
	} else {
		if (--arrowPos < 0)
			arrowPos = arrowLength - 1;
#endif GAME_USE_ARROWS_MOVE
		}

	// prepare colors to use
	int up = arrowColor;
	int down = arrowColor + arrowNumber;
	for (;down >= colors.size();) {
		down -= colors.size();
		}

	// calc start x postion for left and right arrow printing, this offset is needed for both
	int xPos = arrowTextStartX - arrowXoffset - arrowLength + arrowPos;

	// and print them (as many as wanted)
	for (int i = 0; i < arrowNumber; i++) {
		// cycle colors
		up++;
		up %= colors.size();
		if (--down < 0)
			down = colors.size() - 1;

		// which direction?
		if (in) {
			cR = up;
			cL = down;
		} else {
			cL = up;
			cR = down;
		}

/*			this ist the old calculating (not optimized)
		// calc start x postion for the left arrow printing
		xL = arrowTextStartX - arrowLength - (arrowLength / 2) + (i * arrowLength) + arrowPos - (arrowNumber * arrowLength);
		// calc start x postion for the right arrow printing
		xR = ScreenWidth - arrowTextStartX + arrowLength + (arrowLength / 2) + (i * arrowLength) - arrowPos;			*/

		// calc start x postion for the left arrow printing
		xL = xPos + (i + 1 - arrowNumber) * arrowLength;
		// calc start x postion for the right arrow printing
		xR = ScreenWidth + ((i - 1) * arrowLength) - xPos;

		// draw left arrows
		myUtils->setColor(g, colors[cL]);
		myUtils->drawChar(g, arrowL, xL, arrowStartY, 0);

		// draw right arrows
		myUtils->setColor(g, colors[cR]);
		myUtils->drawChar(g, arrowR, xR, arrowStartY, 0);
	}
}
#endif GAME_USE_ARROWS

#ifndef soundapi/none
// returns _TRUE_ if sound is startet
void aMain::playSound(int sound, int loop)
{
	if (((loop == 0) && (lastLoopedSound == sound)) || (mySound == NULL)) 
	{
		return;
	}

#ifdef GAME_SET_VOLUME_MED
	if (soundVolume > 0) {
#else
	if (isSoundMuted == _FALSE_) {
#endif

#ifdef GAME_SET_VOLUME || GAME_SET_VOLUME_MED
#ifdef 6600 || 6630 || 6680 || 6230i || s40midp2hires
		if (lastLoopedSound == -2) 
		{
#ifdef GAME_SET_VOLUME
			// reset the volume
			mySound->setVolume(GAME_SET_VOLUME);
#endif GAME_SET_VOLUME
#ifdef GAME_SET_VOLUME_MED
			// reset the volume
			mySound->setVolume(soundVolume);
#endif GAME_SET_VOLUME_MED
		}
#endif 6600 || 6630 || 6680 || 6230i || s40midp2hires
#endif GAME_SET_VOLUME || GAME_SET_VOLUME_MED

		// set last loop sound always - below might follow a correction
		lastLoopedSound = sound;
//		mySound->mute(_FALSE_);
		mySound->play(sound, loop);
	}

	if ((loop != 0) && (lastLoopedSound > -1)) {
		// if not looping, don't store a loop sound
		lastLoopedSound = -1;
	}
}

void aMain::stopSound()
{
	// clear loop sound
	lastLoopedSound = -2;

	if (mySound != NULL) {
#ifdef GAME_SET_VOLUME || GAME_SET_VOLUME_MED
#ifdef 6600 || 6630 || 6680 || 6230i || s40midp2hires
		// set a zero volume, this will avoid playing the last midi sound while receiving a call, do this before stopping current music
		mySound->setVolume(0);
#endif
#endif GAME_SET_VOLUME || GAME_SET_VOLUME_MED
//		mySound->mute(_TRUE_);
		mySound->stop(0);
	}
}
#endif !soundapi/none

#ifdef debug
// ************************************************************************
// ******* debug methods **************************************************
// ************************************************************************
#ifndef DEBUG_PAINT_INFO_DEFAULT
#define DEBUG_PAINT_INFO_DEFAULT -
#endif

void aMain::paintInfo()
{
	int y = PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics));

##if BREWVERSION > 0x1
	PUTILS->setFontColor(0x00ffff);
##endif

	PUTILS->drawString(m_pGraphics, fpsString, 0, 0 * y, 0);
	//PUTILS->drawString(m_pGraphics, "Mem:" + (long) myRuntime.freeMemory() + " / " + (long) myRuntime.totalMemory(), 0, 1 * y, 0);
	char _cBuf[10];
	String _szBuf = "lastKey:";
	_szBuf += _itoa(lastKeyProcessed, _cBuf, 10);
	PUTILS->drawString(m_pGraphics,  _szBuf , 0, 2 * y, 0);
	_szBuf = "X:";
	_szBuf += _itoa(ScreenWidth, _cBuf, 10);
	_szBuf += " Y:";
	_szBuf += _itoa(ScreenHeight, _cBuf, 10);
	PUTILS->drawString(m_pGraphics,  _szBuf, 0, 3 * y, 0);

	doFullPaint = true;
	if (ISHELL_GetTimeMS(m_pIShell) - lastPaint >= 1000) 
	{
		fpsString = "Fps:";
		fpsString += _itoa(framesPainted, _cBuf, 10);
		framesPainted = 0;
		lastPaint = ISHELL_GetTimeMS(m_pIShell);
	}
}

void aMain::paintDebug()
{
	PUTILS->setColor(m_pGraphics, 0xffff00);

	// start under the info text if needed
	if (doInfo == _FALSE_)
		myDebug->paint(m_pGraphics, 0, 0, ScreenWidth, ScreenHeight);
	else
		myDebug->paint(m_pGraphics, 0, 4 * PUTILS->getFontHeight(PUTILS->getFont(m_pGraphics)), ScreenWidth, ScreenHeight);
}

void aMain::keyDebug(int keyCode)
{
	if ((PKEY->KeyState & AKEY_FLAG_ASTERISK) != 0)
	{
		doInfo ^= 1;
	}
	else if ((PKEY->KeyState & AKEY_FLAG_NUMBER) != 0)
	{
		doDebug ^= 1;
	}
	else if (PKEY->isUp(keyCode))
	{
		if (doDebug == _TRUE_)
			myDebug->movePos(1);
	}
	else if (PKEY->isDown(keyCode))
	{
		if (doDebug == _TRUE_)
			myDebug->movePos( - 1);
	}
	else if (PKEY->isLeft(keyCode))
	{
		if (doDebug == _TRUE_)
		{
			int l = myDebug->getLevel();
			if (l >= 0)
			{
				myDebug->setLevel(--l);
				//myDebug->add(0, "Debug Level changed to:" + l);
			}
		}
	}
	else if (PKEY->isRight(keyCode))
	{
		if (doDebug == _TRUE_)
		{
			int l = myDebug->getLevel();
			if (l < 2)
			{
				myDebug->setLevel(++l);
				//myDebug.add(0, "Debug Level changed to:" + l);
			}
		}
	}
}
#endif

void aMain::setPreviousState() {
	processApplicationState(BackGameState);
	currentMenuItem = oldMenuItem;
//			System.out.println("Set Prev state:" + BackGameState);
}

#ifdef SCORE_IS_EXTERNAL
void aMain::endScore() {
	//adi-------- back to previous menu item
	processApplicationState(BackGameState);
//		processApplicationState(APPLICATION_MAINMENU);
	//adi -------
}
#endif SCORE_IS_EXTERNAL

void aMain::setSoftKeys()
{

	// add new softkeys
	if (m_iGameState == APPLICATION_RESUME
		|| m_iGameState == APPLICATION_HIGHSCORE
		|| m_iGameState == APPLICATION_GALLERY
		|| m_iGameState == APPLICATION_HELP
//			|| GameState == APPLICATION_LANGUAGE
		|| m_iGameState == APPLICATION_GAME
	) {
		if (isSoftKeyExternalSet == _FALSE_) {
#ifndef USE_BUTTON_IMAGES
			_setSoftKey(MenuCommandName, AVK_SOFT2);
#else  !USE_BUTTON_IMAGES
#ifdef MENU_BUTTON_IMAGE
			_setSoftKey(MenuCommandName, AVK_SOFT2, myMenuButtonImage, 0, myMenuButtonImage->getWidth());
#else  MENU_BUTTON_IMAGE
	#ifdef MULTI_BUTTON_IMAGE
			_setSoftKey(MenuCommandName, AVK_SOFT2, multiButtonImage, 0, multiButtonImage->getWidth() / MULTI_BUTTON_NUMBER);
	#else  MULTI_BUTTON_IMAGE
			_setSoftKey(MenuCommandName, AVK_SOFT2, NULL, 0, 0);
	#endif MULTI_BUTTON_IMAGE
#endif MENU_BUTTON_IMAGE
#endif !USE_BUTTON_IMAGES
		}
	}
	else if ((m_iGameState == APPLICATION_LANGUAGE)
#ifndef MAIN_USE_ATEXT_INPUT_FOR_SCORE_INPUT || GAME_NO_HIGHSCORE
		|| (m_iGameState == APPLICATION_INPUTSCORE)
#endif
	) {
#ifndef USE_BUTTON_IMAGES
		_setSoftKey(MenuCommandOKName, AVK_SOFT2);
#else  !USE_BUTTON_IMAGES
#ifdef OK_BUTTON_IMAGE
		_setSoftKey(MenuCommandOKName, AVK_SOFT2, myOKButtonImage, 0, myOKButtonImage->getWidth());
#else  OK_BUTTON_IMAGE
	#ifdef MULTI_BUTTON_IMAGE
		_setSoftKey(MenuCommandOKName, AVK_SOFT2, multiButtonImage, multiButtonImage->getWidth() * MULTI_BUTTON_OK_INDEX / MULTI_BUTTON_NUMBER, multiButtonImage->getWidth() / MULTI_BUTTON_NUMBER);
	#else  MULTI_BUTTON_IMAGE
		_setSoftKey(MenuCommandOKName, AVK_SOFT2, NULL, 0, 0);
	#endif MULTI_BUTTON_IMAGE
#endif OK_BUTTON_IMAGE
#endif !USE_BUTTON_IMAGES
	}

#ifndef MAIN_USE_ATEXT_INPUT_FOR_SCORE_INPUT || GAME_NO_HIGHSCORE
	if (m_iGameState == APPLICATION_INPUTSCORE) {
#ifndef USE_BUTTON_IMAGES
		_setSoftKey(MenuCommandCancelName, AVK_SOFT1);
#else  !USE_BUTTON_IMAGES
#ifdef CANCEL_BUTTON_IMAGE
		_setSoftKey(MenuCommandCancelName, AVK_SOFT1, myCancelButtonImage, 0, myCancelButtonImage->getWidth());
#else  CANCEL_BUTTON_IMAGE
	#ifdef MULTI_BUTTON_IMAGE
		_setSoftKey(MenuCommandCancelName, AVK_SOFT1, multiButtonImage, multiButtonImage->getWidth() * MULTI_BUTTON_CANCEL_INDEX / MULTI_BUTTON_NUMBER, multiButtonImage->getWidth() / MULTI_BUTTON_NUMBER);
	#else  MULTI_BUTTON_IMAGE
		_setSoftKey(MenuCommandCancelName, AVK_SOFT1, NULL, 0, 0);
	#endif MULTI_BUTTON_IMAGE
#endif CANCEL_BUTTON_IMAGE
#endif !USE_BUTTON_IMAGES
	}
#endif MAIN_USE_ATEXT_INPUT_FOR_SCORE_INPUT
}

void aMain::setSoftKey(String commandLabel, int commandType, Image* buttonImage)
{
	if (commandType == AVK_SOFT2) {
		isSoftKeyExternalSet = _TRUE_;
	}

#ifdef USE_BUTTON_IMAGES
	int width = 0;

	if (buttonImage != NULL) {
		width = buttonImage->getWidth();
	}
	_setSoftKey(commandLabel, commandType, buttonImage, 0, width);
#else
	_setSoftKey(commandLabel, commandType);
#endif
}

void aMain::_setSoftKey(String commandLabel, int commandType
#ifdef USE_BUTTON_IMAGES
		, Image* buttonImage, int xOffset, int width
#endif
	) {
#ifdef USE_COMMANDS
//#ifdef doja
	setSoftLabel(commandType, commandLabel);
/*#else  doja
	/*Command newCommand = new Command(commandLabel,
	#ifdef FIX_SWITCH_COMMANDS_ALWAYS_USE_ITEM
	// some devices have a bug in the commands implementation, we have to use Command.ITEM
		Command.ITEM
	#else
		commandType
	#endif
	, 1);

	if (SOFTKEY_1 == commandType) {
		if (softKey1 != null)
			myMain.removeCommand(softKey1);
		softKey1 = newCommand;
	} else {
		if (softKey2 != null)
			myMain.removeCommand(softKey2);
		softKey2 = newCommand;
	}

	#ifdef e310
	// fix for this buggy device: add and remove empty command for displaying the given command correctly
	Command empty = new Command(" ", commandType, 1);
	myMain.addCommand(empty);
	myMain.removeCommand(empty);
	#endif e310
	myMain.addCommand(newCommand);
#endif doja*/

#else USE_COMMANDS

	int softKeyLabelWidth = 0;

	// set the left softkey and compute its dimensions
	if (commandType == AVK_SOFT1) {
		// ################### LEFT SOFT KEY ##############
		SoftKeyLeftLabel = commandLabel;
#ifdef USE_BUTTON_IMAGES
		SoftKeyLeftImage = buttonImage;
		// if there is no image assigned to the softkey
		if (SoftKeyLeftImage == NULL)
		{
#endif USE_BUTTON_IMAGES
			// if there is no label assigned to the softkey
			if (SoftKeyLeftLabel.length() == 0)
			{
				// ERROR: stop
				return;
			}
			softKeyLabelWidth = myUtils->stringWidth(NULL,SoftKeyLeftLabel);
#ifdef MAIN_BUTTON_WIDTH
			// width of the softkey is fix
			SoftKeyLeftW = MAIN_BUTTON_WIDTH;
#else
			// if there are two soft key labels
			if (SoftKeyRightLabel.length() != 0)
			{
				// use the max. width for both buttons
				SoftKeyLeftW = _MAX(/*aUtils.stringWidth(mySmallFont,SoftKeyLeftLabel)*/ softKeyLabelWidth + mySmallFontSpaceWidth, SoftKeyRightW);
	#ifdef USE_BUTTON_IMAGES
				// if there is no image assigned to the other button
				if (SoftKeyRightImage == NULL)
				{
	#endif USE_BUTTON_IMAGES
					// update location and width of the other button to assure symmetry
					SoftKeyRightW = SoftKeyLeftW;
					SoftKeyRightX = ScreenWidth-SoftKeyRightW;
					SoftKeyRightY = ScreenHeight-SoftKeyRightH;
	#ifdef USE_BUTTON_IMAGES
				}
	#endif USE_BUTTON_IMAGES
			}
			else
			{
				// otherwise use the label width + some space
				SoftKeyLeftW = softKeyLabelWidth + mySmallFontSpaceWidth;
			}
#endif !MAIN_BUTTON_WIDTH
#ifdef MAIN_BUTTON_HEIGHT
			// height of the softkey is fixed
			SoftKeyLeftH = MAIN_BUTTON_HEIGHT;
#else
			// height is equal to the font height used to paint the label
			SoftKeyLeftH = mySmallFontHeight;
#endif !MAIN_BUTTON_HEIGHT
#ifdef USE_BUTTON_IMAGES
		}
		else
		{
			if (width != 0) {
				// use the given width for button width
				SoftKeyLeftW = width;
			} else {
				// use the image dimensions for button width
				SoftKeyLeftW = SoftKeyLeftImage->getWidth();
			}
			// use the image dimensions for button height
			SoftKeyLeftH = SoftKeyLeftImage->getHeight();
	#ifdef MULTI_BUTTON_IMAGE
			// store offset
			leftMultiButtonOffset = xOffset;
	#endif MULTI_BUTTON_IMAGE
		}
#endif USE_BUTTON_IMAGES
#ifdef 9500 || 9300
		// on 9500 and 9300, the "left" soft button is painted in the upper right corner
		SoftKeyLeftX = ScreenWidth - SoftKeyLeftW;
		SoftKeyLeftY = 0;
#else
		// the left soft button is painted in the lower left corner
		SoftKeyLeftX = 0;
		SoftKeyLeftY = ScreenHeight - SoftKeyLeftH;
#endif
	} else if (commandType == AVK_SOFT2) {
		// ################### RIGHT SOFT KEY ##############
		// for comments see above (commandType == SOFTKEY_1) !!!
		SoftKeyRightLabel = commandLabel;
#ifdef USE_BUTTON_IMAGES
		SoftKeyRightImage = buttonImage;
		if (SoftKeyRightImage == NULL)
		{
#endif USE_BUTTON_IMAGES
			if (SoftKeyRightLabel.length() == 0)
			{
				return;
			}
			softKeyLabelWidth = myUtils->stringWidth(NULL, SoftKeyRightLabel);
#ifdef MAIN_BUTTON_WIDTH
			SoftKeyRightW = MAIN_BUTTON_WIDTH;
#else MAIN_BUTTON_WIDTH
			if (SoftKeyLeftLabel.length()!=0) {
				SoftKeyRightW = _MAX(/*aUtils.stringWidth(mySmallFont,SoftKeyRightLabel)*/ softKeyLabelWidth + mySmallFontSpaceWidth, SoftKeyLeftW);
	#ifdef USE_BUTTON_IMAGES
				if (SoftKeyLeftImage == NULL) {
	#endif USE_BUTTON_IMAGES
					SoftKeyLeftW = SoftKeyRightW;
	#ifdef 9500 || 9300
					SoftKeyLeftX = ScreenWidth - SoftKeyLeftW;
					SoftKeyLeftY = 0;
	#else
					SoftKeyLeftX = 0;
					SoftKeyLeftY = ScreenHeight - SoftKeyLeftH;
	#endif
	#ifdef USE_BUTTON_IMAGES
				}
	#endif USE_BUTTON_IMAGES
			} else {
				SoftKeyRightW = softKeyLabelWidth + mySmallFontSpaceWidth;
			}
#endif !MAIN_BUTTON_WIDTH
#ifdef MAIN_BUTTON_HEIGHT
			SoftKeyRightH = MAIN_BUTTON_HEIGHT;
#else
			SoftKeyRightH = mySmallFontHeight;
#endif !MAIN_BUTTON_HEIGHT
#ifdef USE_BUTTON_IMAGES
			} else {
				if (width != 0) {
					// use the given width for button width
					SoftKeyRightW = width;
				} else {
					// use the image dimensions for button width
					SoftKeyRightW = SoftKeyRightImage->getWidth();
				}
				// use the image dimensions for button height
				SoftKeyRightH = SoftKeyRightImage->getHeight();
	#ifdef MULTI_BUTTON_IMAGE
				// store offset
				rightMultiButtonOffset = xOffset;
	#endif MULTI_BUTTON_IMAGE
		}
#endif USE_BUTTON_IMAGES
		SoftKeyRightX = ScreenWidth - SoftKeyRightW;
		SoftKeyRightY = ScreenHeight - SoftKeyRightH;
	}

#ifndef USE_COMMANDS || BUTTON_PAINT_ALWAYS
	// resetting the scrolling parameters here makes sure that scrolling
	// is properly reset for custom buttons and standard buttons likewise
	softKeyStartScrollingTime = 0;
	softKeyScrollingOffset = 0;
#endif !(USE_COMMANDS || BUTTON_PAINT_ALWAYS)
	return;
#endif USE_COMMANDS
}

void aMain::removeSoftKey(int commandType) {
#ifdef USE_COMMANDS
#ifdef doja
	setSoftLabel(commandType, "");
#else  doja
	if (SOFTKEY_1 == commandType) {
		if (softKey1 != NULL)
			removeCommand(softKey1);
	} else {
		if (softKey2 != NULL)
			removeCommand(softKey2);
	}
#endif doja

#else USE_COMMANDS

	if (commandType == AVK_SOFT1) {
		SoftKeyLeftLabel = "";
#ifdef USE_BUTTON_IMAGES
		_delImg(SoftKeyLeftImage);
#endif
	} else if (commandType == AVK_SOFT2) {
		SoftKeyRightLabel = "";
#ifdef USE_BUTTON_IMAGES
		_delImg(SoftKeyRightImage);
#endif
	}

#endif USE_COMMANDS
}

#ifndef USE_COMMANDS
void aMain::paintSoftKey( int softKey
#ifdef MULTI_BUTTON_IMAGE
	, int multiButtonOffset
#endif
	) {

	//System.out.println("paintSoftKey: " + __LINE__);
	IGraphics* g = m_pGraphics;
	// button position and dimensions
	int buttonX = 0;
	int buttonY = 0;
	int buttonW = -1;
	int buttonH = -1;

	// the label of the button
	String softKeyLabel = "";

	// the width of the label
	int softKeyLabelWidth = -1;

#ifdef USE_BUTTON_IMAGES
	Image* softKeyImage = NULL;
#endif
	if (softKey == AVK_SOFT1)
	{
		buttonX = SoftKeyLeftX;
		buttonY = SoftKeyLeftY;
		buttonW = SoftKeyLeftW;
		buttonH = SoftKeyLeftH;
		softKeyLabel = SoftKeyLeftLabel;
#ifdef USE_BUTTON_IMAGES
		softKeyImage = SoftKeyLeftImage;
#endif
	}
	else
	{
		buttonX = SoftKeyRightX;
		buttonY = SoftKeyRightY;
		buttonW = SoftKeyRightW;
		buttonH = SoftKeyRightH;
		softKeyLabel = SoftKeyRightLabel;
#ifdef USE_BUTTON_IMAGES
		softKeyImage = SoftKeyRightImage;
#endif
	}

	//System.out.println("paintSoftKey: " + __LINE__);
	// if the softkey does not exist
	if (softKeyLabel.length() == 0
#ifdef USE_BUTTON_IMAGES
		 && softKeyImage == NULL
#endif
		) {
		return;
	}

	//System.out.println("paintSoftKey: " + __LINE__);


#ifndef BUTTON_PAINT_ALWAYS
	// do not paint the button if it has left the screen
	if (softKeyScrollingOffset < 0) {
		return;
	}

	//System.out.println("paintSoftKey: " + __LINE__);


	// if the button is currently scrolling off the screen
	if (softKeyStartScrollingTime != 0) {
		long t = ISHELL_GetTimeMS(m_pIShell) - softKeyStartScrollingTime;

		// if the button has to be scrolled out of the screen
		if (t > BUTTON_PAINT_TIME) {
			// calculate current offset depending on the time passed since scrolling has started
			softKeyScrollingOffset = (int) ((ISHELL_GetTimeMS(m_pIShell) - softKeyStartScrollingTime - BUTTON_PAINT_TIME) / 125);
		}

		// if the button has left the screen
		// !!!
		// assuming there is only the right button in the current game state,
		// doing this check (and the involved reset of 'softKeyScrollingOffset') before checking
		// the presence of a button may result in the button not being repainted immediately after a key has been pressed
		// (because the height of the left button (initially 0!) may be smaller than 'softKeyScrollingOffset')
		// !!!
		if (softKeyScrollingOffset >= _MAX(SoftKeyLeftH, SoftKeyRightH))//(softKey == SOFTKEY_1 ? SoftKeyLeftH : SoftKeyRightH))
		{
			// make sure the button is not painted again
			softKeyScrollingOffset = -1;
			// make sure the player has to press a button to start scrolling next time a button is painted
			softKeyStartScrollingTime = 0;

			return;
		}
	}
#endif !BUTTON_PAINT_ALWAYS
	// label width
	if (softKeyLabel.length()!=0)
	{
		softKeyLabelWidth = myUtils->stringWidth(NULL, softKeyLabel);
	}


	// store current clip
	int clipX = myUtils->getClipX();
	int clipY = myUtils->getClipY();
	int clipW = myUtils->getClipWidth();
	int clipH = myUtils->getClipHeight();

	// set clip
	myUtils->setClip(buttonX, buttonY
#ifndef BUTTON_PAINT_ALWAYS
		+ softKeyScrollingOffset
#endif
		, buttonW, buttonH
#ifndef BUTTON_PAINT_ALWAYS
		- softKeyScrollingOffset
#endif
	);

#ifdef USE_BUTTON_IMAGES
	if (softKeyImage!=NULL)
	{
		myUtils->drawImage(g,
			softKeyImage, buttonX
#ifdef MULTI_BUTTON_IMAGE
			- multiButtonOffset
#endif
			, buttonY
#ifndef BUTTON_PAINT_ALWAYS
			+ softKeyScrollingOffset
#endif
			, 0);
	} else {
#endif USE_BUTTON_IMAGES
		// set background color
		myUtils->setColor(g,BUTTON_BACK_COLOR);

		// paint button
		myUtils->fillRoundRect(g, buttonX, buttonY
#ifndef BUTTON_PAINT_ALWAYS
			+ softKeyScrollingOffset
#endif
			, buttonW, buttonH
#ifndef BUTTON_PAINT_ALWAYS
			- softKeyScrollingOffset
#endif
			, BUTTON_ARC_STYLE, BUTTON_ARC_STYLE);

		// set text color
		myUtils->setColor(g, BUTTON_TEXT_COLOR);

		// set small font
		//myUtils->setFont(g,mySmallFont);

		// paint label
		
		//System.out.println("Draw string: " + softKeyLabel + " line: " + __LINE__);
		
		myUtils->drawString(g, softKeyLabel,
#ifndef GAME_USE_GRAPHICAL_FONT
			BUTTON_TEXT_X_OFFSET +
#endif
			buttonX + (buttonW-softKeyLabelWidth) / 2,
#ifndef GAME_USE_GRAPHICAL_FONT
			BUTTON_TEXT_Y_OFFSET +
#endif
#ifndef BUTTON_PAINT_ALWAYS
			softKeyScrollingOffset +
#endif
			buttonY + (buttonH-mySmallFontHeight) / 2, 0);
#ifdef USE_BUTTON_IMAGES
	}
#endif USE_BUTTON_IMAGES
	// restore previous clip
	myUtils->setClip(clipX, clipY, clipW, clipH);
}

void aMain::showSoftKeys() {
#ifndef BUTTON_PAINT_ALWAYS
	// resetting the scrolling parameters here makes sure that scrolling
	// is properly reset for custom buttons and standard buttons likewise
	softKeyStartScrollingTime = 0;
	softKeyScrollingOffset = 0;
#endif BUTTON_PAINT_ALWAYS
}
#endif !USE_COMMANDS

#ifdef PLAY4PRIZES
Bbyte aMain::getSeed(){
 #ifdef MAIN_MISC_P4P_SWITCH_GAME_GENERATE_SEED
	return myGame->getSeed();
 #else
	Bbyte ret;
	if(seedCount > 0){
		ret.append((byte)0xAA);
		ret.append((byte)0xBB);
		ret.append((byte)0xCC);
		ret.append((byte)0xDD);
	}
	return ret;
 #endif
}

bool aMain::notifyClient(int code, Bbyte data){
	switch (code){
	case CLIENT_START_MENU:
		if(m_iGameState != APPLICATION_HELP_ENTRY)
			m_iGameState = APPLICATION_P4P_PLAY;
		else
			m_iGameState = APPLICATION_P4P_HELP;
		p4p_soundRestart = 0;
		return true;
	case CLIENT_END_MENU:
		//fixed game menu mig
		//GameState = APPLICATION_INIT;
		//processApplicationState(APPLICATION_MAINMENU);
		if(m_iGameState == APPLICATION_P4P_HELP)
			m_iGameState = APPLICATION_HELP_ENTRY;
		else
			m_iGameState = APPLICATION_MAINMENU;

   		removeSoftKey(SOFTKEY_1);
  		removeSoftKey(SOFTKEY_2);
#ifndef GAME_USES_SOFTKEYS  // (define for sprint (marc))
#ifdef GAME_SET_ALTERNATIVE_SOFTKEYS
		if (myGame->setSoftKeys(APPLICATION_MAINMENU))
#endif
			// set the softkeys
			setSoftKeys(); //set if we don't set it in Game.processApplicationState()
			
			
#endif GAME_USES_SOFTKEYS

		doFullPaint = true;
#ifndef soundapi/none
		// stop sound
		//stopSound();
#endif !soundapi/none

#ifdef MENU_MUSIC
#ifndef soundapi/none
		p4p_soundRestart = 20;
		restartMusic = _FALSE_;
#endif
#endif

#ifdef MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE
		if(p4p_imgSwitch != NULL){
			p4p_imgSwitch->release();
			delete(p4p_imgSwitch);
			p4p_imgSwitch =NULL;
		}
#endif
		return true;
		case CLIENT_GAME_START:
			p4p_data = data;
			p4p_seed = data[0];
			p4p_seed = ((data[0] << 24) & 0xff000000) | ((data[0] << 16) & 0x0ff0000) | ((data[0] << 8) & 0x0ff00) | (data[0] & 0x0ff);
			m_iGameState = APPLICATION_MAINMENU;
			p4p_isInForPrizeGame = true;
			processApplicationState(APPLICATION_GAME);
			p4p_soundRestart = 0;
			return true;
	}

	return false;
}

bool aMain::setMenu(int menuId, int menuIndexSelected, int menuSize, String menuName){

	//setSkipActions(true);
	p4p_activeElements = 0;
	p4p_fontHeight = myUtils->getFontHeight(myUtils->getFont(m_pGraphics)) + MAIN_VALUE_DIM_P4P_MENU_TEXT_SPACE;
	p4p_viewHeight = ScreenHeight - MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET - MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
	- p4p_fontHeight - MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET;
#endif
	;



	removeSoftKey(AVK_SOFT1);
	removeSoftKey(AVK_SOFT2);

	p4p_leftSoft  = false;
	p4p_rightSoft = false;

	p4p_menuId = menuId;
	p4p_selectedItem = menuIndexSelected % menuSize;
	p4p_menuName = menuName;
	p4p_subItemSelected = 0;

	p4p_entryName._new(menuSize,String(""));
	p4p_entryText._new(menuSize,String(""));

	p4p_entryType._new(menuSize,0);
	p4p_entryData._new(menuSize,0);
	p4p_itemHeight._new(menuSize,0);

	void* tmp = NULL;
	p4p_entryObject._new(menuSize,tmp);

	skipActions = true;

	p4p_paintBackGround = true;

	return true;
}

bool aMain::setMenuEntry(int menuId, int menuIndex, int entryType, String entryName, int entryData, String entryText, ConvertedBitmapInfo* entryImage){

	WStringVector s;
	int count = 0;
	int offset = 0;
	if (menuId == p4p_menuId){
		if (menuIndex != -1){
			p4p_entryName[menuIndex] = entryName;
			p4p_entryData[menuIndex] = entryData;
			p4p_entryText[menuIndex] = entryText;
			p4p_entryObject[menuIndex] = entryImage;
			p4p_entryType[menuIndex] = entryType;

			switch (entryType){
			case MENUENTRY_COMMAND:
				p4p_itemHeight[menuIndex] = p4p_fontHeight + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				break;
			case MENUENTRY_INPUT_TEXT:
				p4p_itemHeight[menuIndex] = p4p_fontHeight + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				if (entryName.length() != 0) p4p_itemHeight[menuIndex] += p4p_fontHeight;
				p4p_activeElements++;
				break;
			case MENUENTRY_INPUT_SWITCH:
#ifdef MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE
				//load switch image
				if (p4p_imgSwitch == NULL){
					//p4p_imgSwitch = myUtils->fetchImage(MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE);
					p4p_imgSwitch=((aMain*)myMain)->myUtils->fetchImage(String(MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE));
					p4p_imgSwitchDim = p4p_imgSwitch->getWidth();
				}
#endif
				
				while ( 0 < (offset = entryText.indexOf(",", offset) + 1)) count++;
				count++;

				s._new(count, WString(""));
				offset = 0;
				count = 0;

				while (count < s.size() - 1){
					s[count] = entryText.substring(offset, entryText.indexOf(",", offset));
					offset = entryText.indexOf(",", offset);
					count++;
					offset++;
				}
				s[count] = entryText.substring(offset, entryText.length() );

				p4p_itemHeight[menuIndex] = p4p_fontHeight * s.size() + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				if (entryName.length() != 0) p4p_itemHeight[menuIndex] += p4p_fontHeight;
				StringVectorTmpInput.removeAll();
				StringVectorTmpInput = s;
				p4p_entryObject[menuIndex] = (void*)&StringVectorTmpInput;
				p4p_activeElements++;
				break;
			case MENUENTRY_DYNAMIC_PROGRESS:
				p4p_itemHeight[menuIndex] = MAIN_VALUE_DIM_P4P_MENU_OPTION_PROGRESBAR_HEIGHT + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				if (entryName.length() != 0) p4p_itemHeight[menuIndex] += p4p_fontHeight;
				break;
			case MENUENTRY_STATIC_TEXT:
				myTextBox->clear();
				if (entryName.length() != 0) myTextBox->addLine(entryName);
				if (entryText.length() != 0) myTextBox->addLine(entryText);
				//myTextBox.prepare(32, 64 , ScreenWidth - 32, ScreenHeight - 64, aTextBox.MEDIUM | aTextBox.SYSTEM);

				myUtils->prepareTextBox(myTextBox, ScreenWidth - 2 * 32, p4p_viewHeight);

				//p4p_textFont = myTextBox.textFont;
				p4p_textFontHeight = myTextBox->fontHeight;

				s = myTextBox->getTextLines();
				StringVectorTmpStatic.removeAll();
				StringVectorTmpStatic = s;
				p4p_entryObject[menuIndex] = (void*)&StringVectorTmpStatic;
				p4p_itemHeight[menuIndex] = s.size() * p4p_textFontHeight + 2 * 4;
				break;
			case MENUENTRY_DYNAMIC_TEXT:
				myTextBox->clear();
				if (entryName.length() != 0) myTextBox->addLine(entryName);
				if (entryText.length() != 0) myTextBox->addLine(entryText);
				//myTextBox.prepare(32, 64 , ScreenWidth - 32, ScreenHeight - 64, aTextBox.MEDIUM | aTextBox.SYSTEM);

				myUtils->prepareTextBox(myTextBox, ScreenWidth - 2 * 32, p4p_viewHeight);

				//p4p_textFont = myTextBox.textFont;
				p4p_textFontHeight = myTextBox->fontHeight;

				s = myTextBox->getTextLines();
				StringVectorTmpDynamic.removeAll();
				StringVectorTmpDynamic = s;
				p4p_entryObject[menuIndex] = (void*)&StringVectorTmpDynamic;
				p4p_itemHeight[menuIndex] = s.size() * p4p_textFontHeight + 2 * 4;
				break;
			case MENUENTRY_DYNAMIC_IMAGE:
				p4p_itemHeight[menuIndex] = entryImage->bitmapInfo.cy + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				if (p4p_entryName[menuIndex].length() != 0) p4p_itemHeight[menuIndex] += p4p_fontHeight;
					break;
			default:
				p4p_itemHeight[menuIndex] = p4p_fontHeight + 2 * MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
				return false;
			}
		} else {

			if (entryType == MENUENTRY_COMMAND_BACK){
				 setSoftKey(entryName, AVK_SOFT1, NULL);
				 p4p_leftSoft = true;
				 p4p_commandBackText = entryName;
			}else if (entryType == MENUENTRY_COMMAND_FORE){
				 setSoftKey(entryName, AVK_SOFT2, NULL);
				 p4p_rightSoft = true;
				 p4p_commandForeText = entryName;
			}
#ifndef USE_COMMANDS
			showSoftKeys();
#endif
		}

	}

	if (!skipActions){
		calculateTotalMenuHeight();
		p4p_menuAlling();
	}

	return true;
}

bool aMain::endSetMenu(int menuId){

	skipActions = false;


	calculateTotalMenuHeight();
	if (p4p_totalMenuHeight <= p4p_viewHeight)
	p4p_menuBeginScreenY =
		((MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
	 + p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
	 + ScreenHeight
	 - MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET
	 - p4p_totalMenuHeight
	) >> 1)	;
	else p4p_menuBeginScreenY = MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
	+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET;
#endif
	;
	p4p_menuAlling();
	//auto select edit mode
	if (p4p_activeElements == 1 && p4p_entryType[p4p_selectedItem] == MENUENTRY_INPUT_TEXT && p4p_totalMenuHeight <= p4p_viewHeight)
	{
		p4p_isInInputMode = true;
		textLength = p4p_entryData[p4p_selectedItem];
		editSetName(p4p_entryText[p4p_selectedItem]);
		
		//removeSoftKey(SOFTKEY_1);
  	//removeSoftKey(SOFTKEY_2);
		setSoftKey(TEXT_CONST_P4P_CLR, SOFTKEY_1, NULL);
		//setSoftKey(TEXT_CONST_P4P_END, SOFTKEY_2, null);

		//p4p_menuPaint = false;
	}

	//setSkipActions(false);

	return true;
}

void aMain::calculateTotalMenuHeight(){

	p4p_totalMenuHeight = 0;
	for (int i = 0; i < p4p_entryType.size(); i++){
			p4p_totalMenuHeight += p4p_itemHeight[i];
	}

}

bool aMain::p4p_menuAlling(){

	int startPos = p4p_menuBeginScreenY;

	if (p4p_totalMenuHeight > p4p_viewHeight){
		int posY = p4p_menuBeginScreenY;
		for (int i = 0; i < p4p_entryData.size(); i++){
			if (i == p4p_selectedItem) break;
			posY += p4p_itemHeight[i];
		}

		int p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];

		if (p4p_entryTypeValue == MENUENTRY_STATIC_TEXT ||
				p4p_entryTypeValue == MENUENTRY_DYNAMIC_TEXT
		) posY += p4p_subItemSelected * p4p_textFontHeight;
		if (posY < MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
			+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
		) {
			p4p_menuBeginScreenY += MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET - posY
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
				+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
			;
		}else{

			int p4p_itemHeightValue = (p4p_entryTypeValue != MENUENTRY_STATIC_TEXT && p4p_entryTypeValue != MENUENTRY_DYNAMIC_TEXT)?p4p_itemHeight[p4p_selectedItem]:(p4p_textFontHeight + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE);

			if (posY + p4p_itemHeightValue > ScreenHeight - MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET){
				p4p_menuBeginScreenY -= posY + p4p_itemHeightValue - ScreenHeight + MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET;
			}
		}

	}

	return (p4p_menuBeginScreenY == startPos);

}

void aMain::paint4Prizes(){
	IGraphics* g = m_pGraphics;
	int i = 0;
	WStringVector s;
	int ppY;
	int j;
	if (!skipActions && p4p_menuName.length() != 0){

		if (!p4p_isInInputMode || p4p_paintBackGround){
		//Draw background for p4p menu. If Game return true Main will repaint background by own.
			p4p_paintBackGround = false;
#ifndef GAME_SWITCH_P4P_GAME_PAINT_BACKGROUND
				myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_BACK_COLOR);
				myUtils->fillRect(g, 0, 0, ScreenWidth, ScreenHeight);
#else
				myGame->drawP4PMenuBackground();
#endif
		}

		//Draw menu name
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
	  aUtils.setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
		myUtils->drawString(g, p4p_menuName, 0, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET , HCENTER);
		myUtils->drawLine(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET + p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET / 2, ScreenWidth - MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET + p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET / 2);
#endif


		//Set clip region. Skip frame.
		myUtils->setClip(MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
		+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
		, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_viewHeight);

		int posY = p4p_menuBeginScreenY;



		for (; i < p4p_entryType.size(); i++){

			//g.setFont(myFont);

			//Skip some items if needed.
			if ((posY + p4p_itemHeight[i] < MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
					+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
			)|| (p4p_isInInputMode && p4p_entryType[i] != MENUENTRY_INPUT_TEXT)) {
				//posY += p4p_itemHeight[i];
				//continue;
			}
			
			//if (posY > ScreenHeight - MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET || p4p_isInInputMode && p4p_entryType[i] != MENUENTRY_INPUT_TEXT) break;


			//Paint every item.
			switch (p4p_entryType[i])
			{
					case MENUENTRY_COMMAND:
						//Draw selector.
						if (i == p4p_selectedItem){

#ifdef GAME_SWITCH_P4P_GAME_PAINT_SELECTOR
							myGame->drawP4PSelector(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i] , false);
#else
							myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
							myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i]);
#endif
						}
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
						myUtils->drawString(g, p4p_entryName[i], 0, posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE, HCENTER);
						break;
					case MENUENTRY_INPUT_TEXT:
						ppY = posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
						//Draw selector.
						if (i == p4p_selectedItem){
#ifdef GAME_SWITCH_P4P_GAME_PAINT_SELECTOR
							myGame->drawP4PSelector(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i], false);
#else
							myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
							myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i]);
#endif
						}
						if (p4p_entryName[i].length() != 0){
							 myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
							 myUtils->drawString(g, p4p_entryName[i], 0, ppY , HCENTER);
							 ppY += p4p_fontHeight;
						}
#ifdef GAME_SWITCH_P4P_GAME_PAINT_SELECTOR
						myGame->drawP4PSelector(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_fontHeight, true);
#else
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_INPUT_TEXT_BACK_COLOR);
						myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_fontHeight);
#endif

						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
						if (p4p_isInInputMode){
							myUtils->drawString(g, editGet(), 0, ppY , HCENTER);
							editNext();
						}
						else
							myUtils->drawString(g, p4p_entryText[i], 0, ppY , HCENTER);

						break;
					case MENUENTRY_INPUT_SWITCH:
						ppY = posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
						if (p4p_entryName[i].length() != 0){
							myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
							myUtils->drawString(g, p4p_entryName[i], 0, ppY , HCENTER);
							ppY += p4p_fontHeight;
						}
						s = *(WStringVector*)(p4p_entryObject[i]);
						for (j = 0; j < s.size(); j++){
								//Draw selector.
							if (j == p4p_subItemSelected && i == p4p_selectedItem){
#ifdef GAME_SWITCH_P4P_GAME_PAINT_SELECTOR
								myGame->drawP4PSelector(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_fontHeight, false);
#else
								myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
								myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_fontHeight);
#endif
							}
							myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
							myUtils->drawString(g, s[j], 0, ppY , HCENTER);
							if (p4p_entryData[i] == j) {
								myUtils->setColor(g, 0x000000);
							 	int width = myUtils->stringWidth(NULL, s[j]);
							 	int posX = (ScreenWidth - width) / 2;
#ifdef MAIN_MISC_P4P_SWICH_SELECTOR_IMAGE
								myUtils->drawImage(g, p4p_imgSwitch, posX - MAIN_VALUE_DIM_P4P_SWITCH_SELECTOR_OFFSETX - p4p_imgSwitchDim, ((p4p_fontHeight - p4p_imgSwitchDim) / 2 + ppY)-1);
								myUtils->drawImage(g, p4p_imgSwitch, posX + width + MAIN_VALUE_DIM_P4P_SWITCH_SELECTOR_OFFSETX, ((p4p_fontHeight - p4p_imgSwitchDim) / 2 + ppY)-1);
#else
							 	myUtils->fillArc(g,posX - MAIN_VALUE_DIM_P4P_SWITCH_SELECTOR_OFFSETX, ppY, p4p_fontHeight - 1, p4p_fontHeight - 1, 0, 360);
							 	myUtils->fillArc(g,posX + width + MAIN_VALUE_DIM_P4P_SWITCH_SELECTOR_OFFSETX, ppY, p4p_fontHeight - 1, p4p_fontHeight - 1, 0, 360);
#endif
							 }
							 ppY += p4p_fontHeight;
						}

						break;
					case MENUENTRY_DYNAMIC_PROGRESS:
						ppY = posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
						//Draw selector.
						//if (i == p4p_selectedItem){
						//	aUtils.setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
						//	aUtils.drawRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i]);
						//}
						if (p4p_entryName[i].length() != 0){
							 myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
							 myUtils->drawString(g, p4p_entryName[i], 0, ppY , HCENTER);
							 ppY += p4p_fontHeight;
						}
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_INLAY_COLOR);
						myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET + 2, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET - 4, MAIN_VALUE_DIM_P4P_MENU_OPTION_PROGRESBAR_HEIGHT);
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_INLAY_FILL_COLOR);
						myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET + 2, ppY, (ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET - 4) * p4p_entryData[i] / 100 , MAIN_VALUE_DIM_P4P_MENU_OPTION_PROGRESBAR_HEIGHT);
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_PROGRESBAR_BORDER_COLOR);
						myUtils->drawRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET + 2, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET - 4, MAIN_VALUE_DIM_P4P_MENU_OPTION_PROGRESBAR_HEIGHT);
						break;
					case MENUENTRY_DYNAMIC_TEXT:
					case MENUENTRY_STATIC_TEXT:

						//if (p4p_textFont != null) g.setFont(p4p_textFont);
						ppY = posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE;
						s = *(WStringVector*)(p4p_entryObject[i]);

						j = 0;
						while (ppY + p4p_textFontHeight < MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
							+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
						) {
							ppY += p4p_textFontHeight;
							j++;
						}

						for (/*int j = 0*/; j < s.size(); j++){
							if (ppY > ScreenHeight - MAIN_VALUE_DIM_P4P_MENU_BOTTOM_OFFSET) break;
							//Draw selector.
							//if (j == p4p_subItemSelected && i == p4p_selectedItem){

							//  aUtils.setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
							//	aUtils.drawRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, ppY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_textFontHeight);
							//}
							if (s[j].length() != 0){
								 myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
					  			 myUtils->drawString(g, s[j], 0, ppY , HCENTER);
						    }
							ppY += p4p_textFontHeight;
						}
						break;
					case MENUENTRY_DYNAMIC_IMAGE:

						//Draw selector.
						//if (i == p4p_selectedItem){
						//	aUtils.setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
						//	aUtils.drawRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i]);
						//}
						int ppYtmp;
						ppY = posY + 4;
						if (p4p_entryName[i].length() != 0){
							 myUtils->setColor(g, 0x000000);
							 myUtils->drawString(g, p4p_entryName[i], 0, ppY , 1);
							 ppY += p4p_fontHeight;
						}
					    //myUtils->drawImage(g, (Image*)p4p_entryObject[i], 0, ppY,1);
						if(ppY > MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET)
							ppYtmp = ppY;
						else
							ppYtmp = MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET;
						AEERect rect;
						rect.x = 0;
						rect.y = ppYtmp;
						rect.dx = ScreenWidth;
						rect.dy = ((ConvertedBitmapInfo*)p4p_entryObject[i])->bitmapInfo.cy;
						IDISPLAY_SetClipRect(GETDISPLAY(), &rect);
						IDISPLAY_BitBlt(
							GETDISPLAY(), 
							(ScreenWidth-((ConvertedBitmapInfo*)p4p_entryObject[i])->bitmapInfo.cx)>>1, ppY,
							((ConvertedBitmapInfo*)p4p_entryObject[i])->bitmapInfo.cx, 
							((ConvertedBitmapInfo*)p4p_entryObject[i])->bitmapInfo.cy, 
							((ConvertedBitmapInfo*)p4p_entryObject[i])->bitmap,
							0, 0, AEE_RO_TRANSPARENT);
						rect.x = 0;
						rect.y = 0;
						rect.dx = ScreenWidth;
						rect.dy = ScreenHeight;
						IDISPLAY_SetClipRect(GETDISPLAY(), &rect);
						break;
					default:
						//Draw selector.
						if (i == p4p_selectedItem){
							myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_SELECTED_ITEM_BACK_COLOR);
							myUtils->fillRect(g, MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, posY, ScreenWidth - 2 * MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET, p4p_itemHeight[i]);
						}
						myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_TEXT_COLOR);
						myUtils->drawString(g, TEXT_CONST_P4P_UNSUPORTED, 0, posY + MAIN_VALUE_DIM_P4P_MENU_OPTIONS_SPACE, HCENTER);
						break;
			}
			posY += p4p_itemHeight[i];
		}

		myUtils->setClip(0, 0, ScreenWidth, ScreenHeight);

		//Draw slidder.
		if (p4p_totalMenuHeight > p4p_viewHeight)
		{
			myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_SLIDER_FILL_COLOR);
			myUtils->drawRect(g, ScreenWidth - MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET + 1, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
			+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
			, MAIN_VALUE_DIM_P4P_MENU_SLIDER_WIDTH, p4p_viewHeight);
			int sliderHeight = (p4p_viewHeight) * (p4p_viewHeight) / p4p_totalMenuHeight - 3;
			int sliderPosY = (- p4p_menuBeginScreenY + MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
			+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
			) * p4p_viewHeight / p4p_totalMenuHeight + 2;
			myUtils->setColor(g, MAIN_VALUE_NUM_P4P_MENU_OPTION_SLIDER_BORDER_COLOR);
			myUtils->fillRect(g, ScreenWidth - MAIN_VALUE_DIM_P4P_MANU_SIDE_OFFSET + 3, MAIN_VALUE_DIM_P4P_MENU_TOP_OFFSET
#ifdef MAIN_VALUE_SWITCH_P4P_MENU_DISPLY_TITLE
			+ p4p_fontHeight + MAIN_VALUE_DIM_P4P_MENU_TITLE_OFFSET
#endif
			 + sliderPosY, MAIN_VALUE_DIM_P4P_MENU_SLIDER_WIDTH - 4, sliderHeight);
		}

		//Draw soft keys.
		paintSoftKey(AVK_SOFT1,0);
		paintSoftKey(AVK_SOFT2,0);

	}

}

void aMain::processKey4Prizes(int keyCode, bool isUp, bool isDown){

	if (!skipActions && p4p_menuName.length() != 0){

		//in edit text mode
		if (p4p_isInInputMode){
			if (myKey->isSoftRight(keyCode) || (keyCode == AVK_SELECT) || ((myKey->isClear(keyCode) || myKey->isSoftLeft(keyCode)) && 
					
#ifdef MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE
				editText.length() == 1
#else
				editGetName().length() == 0
#endif							
					
			)){
				p4p_isInInputMode = false;
	   			removeSoftKey(SOFTKEY_1);
				removeSoftKey(SOFTKEY_2);
				if (p4p_leftSoft) setSoftKey(p4p_commandBackText, SOFTKEY_1, NULL);
				if (p4p_rightSoft) setSoftKey(p4p_commandForeText, SOFTKEY_2, NULL);
				clearName = true;
				String temp = editGetName();
				fpMenu->menuInput(p4p_menuId, p4p_selectedItem, MENUENTRY_INPUT_TEXT, 0, temp);
				p4p_entryText[p4p_selectedItem] = temp;
				//TODO inform P4P module about changes
				if (p4p_activeElements == 1 && p4p_entryType[p4p_selectedItem] == MENUENTRY_INPUT_TEXT && p4p_totalMenuHeight <= p4p_viewHeight)
				{
					/*if (
#ifdef MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE
						editText.length() == 1
#else
						editGetName().length() == 0
#endif					
					)		
							{
										fpMenu->menuCommand(MENUENTRY_COMMAND_BACK);
							}*/
					if (
//#ifndef MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE						
//					((myKey->KeyState & (KEY_FLAG_FIRE | KEY_FLAG_FIVE)) == KEY_FLAG_FIRE) || 
//#else
					myKey->isFire(keyCode) ||
//#endif						
					myKey->isSoftRight(keyCode)) fpMenu->menuCommand(MENUENTRY_COMMAND_FORE);

				}

			}else{
				if( keyCode >= AVK_0 && keyCode <= AVK_9 || myKey->isClear(keyCode) || myKey->isSoftLeft(keyCode) )
					editKey(keyCode);
			}
		} else {
			//command's actions
			if (keyCode != 0){
				if ((myKey->isSoftLeft(keyCode) || myKey->isClear(keyCode)) && p4p_leftSoft){
					fpMenu->menuCommand(MENUENTRY_COMMAND_BACK);
				}
				if (myKey->isSoftRight(keyCode) && p4p_rightSoft){
					fpMenu->menuCommand(MENUENTRY_COMMAND_FORE);
				}
				if (myKey->isFire(keyCode)){
					if (p4p_entryType[p4p_selectedItem] == MENUENTRY_COMMAND)
						fpMenu->menuCommand(p4p_entryData[p4p_selectedItem]);
					else if (p4p_entryType[p4p_selectedItem] == MENUENTRY_INPUT_SWITCH){
						fpMenu->menuInput(p4p_menuId, p4p_selectedItem, MENUENTRY_INPUT_SWITCH, p4p_subItemSelected, "");
						p4p_entryData[p4p_selectedItem] = p4p_subItemSelected;
						//TODO inform p4p module about changes
						if (p4p_activeElements == 1 && p4p_totalMenuHeight <= p4p_viewHeight){
										fpMenu->menuCommand(MENUENTRY_COMMAND_FORE);
									}
					}
					else if (p4p_entryType[p4p_selectedItem] == MENUENTRY_INPUT_TEXT){
						if (!p4p_isInInputMode) p4p_isInInputMode = true;
					   	removeSoftKey(AVK_SOFT1);
  						removeSoftKey(AVK_SOFT2);
			 			setSoftKey(TEXT_CONST_P4P_CLR, AVK_SOFT1, NULL);
			 			setSoftKey(TEXT_CONST_P4P_END, AVK_SOFT2, NULL);
			 			textLength = p4p_entryData[p4p_selectedItem];
			 			editSetName(p4p_entryText[p4p_selectedItem]);
					}
					else if (p4p_rightSoft){
						fpMenu->menuCommand(MENUENTRY_COMMAND_FORE);
					}
				}
			}

			//scroll up
			if ((myKey->isDown(keyCode) || isDown)){
				
				bool loop = true;
				while(loop){	

					int p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];
						
						
					if (( p4p_entryTypeValue == MENUENTRY_STATIC_TEXT ||
						p4p_entryTypeValue == MENUENTRY_INPUT_SWITCH ||
						p4p_entryTypeValue == MENUENTRY_DYNAMIC_TEXT) && p4p_subItemSelected < ((StringVector*)p4p_entryObject[p4p_selectedItem])->size() - 1){
						p4p_subItemSelected++;
					}else{
						if (p4p_selectedItem < p4p_entryType.size() - 1){
							 p4p_selectedItem++;
							 p4p_subItemSelected = 0;
						}else loop = false;
					}
						
					p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];
					if (!p4p_menuAlling() || p4p_entryTypeValue == MENUENTRY_COMMAND || p4p_entryTypeValue == MENUENTRY_INPUT_SWITCH || p4p_entryTypeValue == MENUENTRY_INPUT_TEXT /*|| p4p_totalMenuHeight <= p4p_viewHeight*/) loop = false;
						
						
				}
					
			}
			//scroll down
			if ((myKey->isUp(keyCode) || isUp)){
					
				bool loop = true;
				while(loop){	

					int p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];

					if ((p4p_entryTypeValue == MENUENTRY_STATIC_TEXT ||
						p4p_entryTypeValue == MENUENTRY_INPUT_SWITCH ||
						p4p_entryTypeValue == MENUENTRY_DYNAMIC_TEXT) && p4p_subItemSelected > 0){
						p4p_subItemSelected--;
					} else {
						if (p4p_selectedItem > 0){
							 p4p_selectedItem--;
							 p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];
			 				 if (p4p_entryTypeValue == MENUENTRY_STATIC_TEXT ||
			 					 p4p_entryTypeValue == MENUENTRY_INPUT_SWITCH ||
			 					 p4p_entryTypeValue == MENUENTRY_DYNAMIC_TEXT
			 				 ){
								 p4p_subItemSelected = ((StringVector*)p4p_entryObject[p4p_selectedItem])->size() - 1;
							 } else {
								 p4p_subItemSelected = 0;
							 }
						} else loop = false;
					}
						
					p4p_entryTypeValue = p4p_entryType[p4p_selectedItem];
					if (!p4p_menuAlling() || p4p_entryTypeValue == MENUENTRY_COMMAND || p4p_entryTypeValue == MENUENTRY_INPUT_SWITCH || p4p_entryTypeValue == MENUENTRY_INPUT_TEXT /*|| p4p_totalMenuHeight <= p4p_viewHeight*/) loop = false;
				}							
					
			}
		}
			//p4p_menuAlling();
	}
}

void aMain::endP4PGame(int score){
	m_iGameState = APPLICATION_GAME;
	endGame(false, 0
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
		, _FALSE_
#endif
#ifdef GAME_SET_STATE_AFTER_ENDGAME
		, APPLICATION_P4P_PLAY
		, 0
#endif
	);
	myGame->gameScore += myGame->scoreLevel;
	fpClient->notifyModule(MODULE_NOTIFY_END_GAME, myGame->gameScore);
	//fpClient.endGame(score);
	p4p_isInForPrizeGame = false;
	/*if (p4p_isInForPrizeGame)*/ m_iGameState = APPLICATION_P4P_PLAY;
}

void aMain::cancelP4PGame(){
	m_iGameState = APPLICATION_GAME;
	endGame(false, 0
#ifdef GAME_RESUMABLE_AFTER_ENDGAME
		, _FALSE_
#endif
#ifdef GAME_SET_STATE_AFTER_ENDGAME
		, APPLICATION_P4P_PLAY
		, 0
#endif
	);
	myGame->gameScore += myGame->scoreLevel;
	fpClient->notifyModule(MODULE_NOTIFY_END_GAME, myGame->gameScore);
	p4p_isInForPrizeGame = false;
	myGame->playForPrizes = 0;
	/*if (p4p_isInForPrizeGame)*/ m_iGameState = APPLICATION_P4P_PLAY;

}

void aMain::p4p_logic(){

	if (!skipActions && p4p_menuName.length() != 0){
		if ((myKey->KeyState & (KEY_FLAG_UP | KEY_FLAG_DOWN)) > 0)
			p4p_pressCount++;
		else p4p_pressCount = 0;

		if (p4p_pressCount > 3){

			if ((myKey->KeyState & KEY_FLAG_UP) == KEY_FLAG_UP)
			{
				processKey4Prizes(0, true, false);
			}
			if ((myKey->KeyState & KEY_FLAG_DOWN) == KEY_FLAG_DOWN)
				processKey4Prizes(0, false, true);
		}
	}
}

#ifdef MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE
void aMain::editReset()
{
	lastIndex = 0;
}

String aMain::editNext ()
{
	return editText;
}

String aMain::editCancel()
{
	if (editText.length() > 1) {
		editText = editText.substring(0, editText.length() - 1);
		int i = 0;
		while(i < editChars.length() - 1 && editChars.charAt(i) != editText.charAt(editText.length() - 1))
		{
		    i++;
		}
		lastIndex = i;
	}
	return editText;
}

String aMain::editGetName()
{
	return editText;
}

void aMain::editSetName(String s)
{
	editText = s;
	if (editText.length() == 0){
		lastIndex = 0;
		editText += editChars.charAt(lastIndex);
	}else{
		int i = 0;
		while(i < editChars.length() - 1 && editChars.charAt(i) != editText.charAt(editText.length() - 1))
		{
		    i++;
		}
		lastIndex = i;
	}
	
}

String aMain::editGet()
{
	return editText;
}

String aMain::editKey (int key)
{
	if (myKey->isUp(key)){
		lastIndex = (lastIndex + 1) % editChars.length();
		editText = editText.substring(0, editText.length() - 1) + editChars.charAt(lastIndex);
	}else
	if (myKey->isDown(key)){
		lastIndex = (lastIndex - 1) % editChars.length();
		if (lastIndex < 0) lastIndex += editChars.length();
		editText = editText.substring(0, editText.length() - 1) + editChars.charAt(lastIndex);
	}else 
	if (myKey->isRight(key)){
		if (editText.length() < textLength){
			lastIndex = 0;
			editText += editChars.charAt(lastIndex);
		}
	}else
	{
		editCancel();
	}
	
	return editText;
}
#else MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE
void aMain::editReset()
{
	editCount = 0;
	editName = "";
	editCursor = TEXT_CONST_SMS_CURSOR;
	lastKey = 0;
	lastIndex = 0;
}

String aMain::editNext ()
{
	if (editCount == 0)
	{
		if (!editCursor.equals(TEXT_CONST_SMS_CURSOR) && editName.length() < textLength - 1)
		{
		   editName += editCursor;
		   editCursor = TEXT_CONST_SMS_CURSOR;
		   lastIndex = 0;
		   lastKey = -1;
		}
	}else editCount--;
	return editName + editCursor;
}

String aMain::editCancel()
{
	if (!editCursor.equals(TEXT_CONST_SMS_CURSOR)) editCursor = TEXT_CONST_SMS_CURSOR;
	else
	{
		String s = "";
		char str[2] = { '\0', '\0' };
		int len = (editName.length() - 1);
		for (int i = 0; i < len; i++){
			str[0] = editName.charAt(i);
			s += str;
		}
		editName = s;
	}
	lastIndex = 0;
	lastKey = -1;
	return editName + editCursor;
}

String aMain::editGetName()
{
	if (!editCursor.equals(TEXT_CONST_SMS_CURSOR)) editName += editCursor;
	return editName;
}

void aMain::editSetName(String s)
{
	if (s.length() < textLength) editCursor = TEXT_CONST_SMS_CURSOR;
	else editCursor = "";
	editName = s;
}

String aMain::editGet()
{
	return editName + editCursor;
}

String aMain::editKey(int key)
{
	if (clearName)
	{
		editName = "";
		editCursor = TEXT_CONST_SMS_CURSOR;
		clearName = false;
	}


	int ret = 0;
	for (;ret < editKeyMap.size(); ret++)
		if (key == editKeyMap[ret]) break;

	if (ret == editKeyMap.size())
	{
		editCancel();
		return editName + editCursor;
	}

	if (lastKey == key)
	{
		lastIndex += 1;
		char str[2] = { '\0', '\0' };
		str[0] = editChars[ret].charAt(lastIndex % editChars[ret].length());
		editCursor = str;
		editCount = 15;
		lastKey = key;
	}else
	{
		lastIndex = 0;

		if (!editCursor.equals(TEXT_CONST_SMS_CURSOR) && editName.length() < textLength - 1) editName += editCursor;
		char str[2] = { '\0', '\0' };
		str[0] = editChars[ret].charAt(lastIndex % editChars[ret].length());
		editCursor = str;
		editCount = 15;
		lastKey = key;
	}
	
	return editName + editCursor;
}
#endif MAIN_SWITCH_MACRO_SMS_NO_KEYPAD_AVALAIBLE

#endif PLAY4PRIZES
